#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 2824
#define SYMBOL_COUNT 147
#define ALIAS_COUNT 2
#define TOKEN_COUNT 92
#define EXTERNAL_TOKEN_COUNT 12
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_heredoc_start = 1,
  sym__simple_heredoc_body = 2,
  sym__heredoc_body_beginning = 3,
  sym__heredoc_body_middle = 4,
  sym__heredoc_body_end = 5,
  sym_file_descriptor = 6,
  sym__empty_value = 7,
  sym__concat = 8,
  sym_variable_name = 9,
  anon_sym_for = 10,
  anon_sym_in = 11,
  anon_sym_LPAREN_LPAREN = 12,
  anon_sym_RPAREN_RPAREN = 13,
  anon_sym_SEMI = 14,
  anon_sym_while = 15,
  anon_sym_do = 16,
  anon_sym_done = 17,
  anon_sym_if = 18,
  anon_sym_then = 19,
  anon_sym_fi = 20,
  anon_sym_elif = 21,
  anon_sym_else = 22,
  anon_sym_case = 23,
  anon_sym_esac = 24,
  anon_sym_PIPE = 25,
  anon_sym_RPAREN = 26,
  anon_sym_SEMI_SEMI = 27,
  anon_sym_function = 28,
  anon_sym_LPAREN = 29,
  anon_sym_LBRACE = 30,
  anon_sym_RBRACE = 31,
  anon_sym_PIPE_AMP = 32,
  anon_sym_AMP_AMP = 33,
  anon_sym_PIPE_PIPE = 34,
  anon_sym_BANG = 35,
  anon_sym_LBRACK = 36,
  anon_sym_RBRACK = 37,
  anon_sym_LBRACK_LBRACK = 38,
  anon_sym_RBRACK_RBRACK = 39,
  anon_sym_declare = 40,
  anon_sym_typeset = 41,
  anon_sym_export = 42,
  anon_sym_readonly = 43,
  anon_sym_local = 44,
  anon_sym_unset = 45,
  anon_sym_unsetenv = 46,
  anon_sym_EQ_TILDE = 47,
  anon_sym_EQ_EQ = 48,
  anon_sym_EQ = 49,
  anon_sym_PLUS_EQ = 50,
  anon_sym_LT = 51,
  anon_sym_GT = 52,
  anon_sym_GT_GT = 53,
  anon_sym_AMP_GT = 54,
  anon_sym_AMP_GT_GT = 55,
  anon_sym_LT_AMP = 56,
  anon_sym_GT_AMP = 57,
  anon_sym_LT_LT = 58,
  anon_sym_LT_LT_DASH = 59,
  anon_sym_LT_LT_LT = 60,
  anon_sym_BANG_EQ = 61,
  sym__special_characters = 62,
  anon_sym_DQUOTE = 63,
  anon_sym_DOLLAR = 64,
  sym__string_content = 65,
  sym_raw_string = 66,
  anon_sym_POUND = 67,
  anon_sym_DOLLAR_LBRACE = 68,
  anon_sym_SLASH = 69,
  anon_sym_COLON = 70,
  anon_sym_COLON_QMARK = 71,
  anon_sym_COLON_DASH = 72,
  anon_sym_PERCENT = 73,
  anon_sym_DASH = 74,
  anon_sym_DOLLAR_LPAREN = 75,
  anon_sym_BQUOTE = 76,
  anon_sym_LT_LPAREN = 77,
  anon_sym_GT_LPAREN = 78,
  sym_comment = 79,
  aux_sym_SLASH_BSLASHw_PLUS_SLASH = 80,
  anon_sym_STAR = 81,
  anon_sym_AT = 82,
  anon_sym_QMARK = 83,
  anon_sym_0 = 84,
  anon_sym__ = 85,
  sym_word = 86,
  sym_test_operator = 87,
  sym_regex = 88,
  sym_regex_without_right_brace = 89,
  anon_sym_LF = 90,
  anon_sym_AMP = 91,
  sym_program = 92,
  sym__terminated_statement = 93,
  sym_for_statement = 94,
  sym_c_style_for_statement = 95,
  sym_while_statement = 96,
  sym_do_group = 97,
  sym_if_statement = 98,
  sym_elif_clause = 99,
  sym_else_clause = 100,
  sym_case_statement = 101,
  sym_case_item = 102,
  sym_last_case_item = 103,
  sym_function_definition = 104,
  sym_compound_statement = 105,
  sym_subshell = 106,
  sym_pipeline = 107,
  sym_list = 108,
  sym_negated_command = 109,
  sym_test_command = 110,
  sym_declaration_command = 111,
  sym_unset_command = 112,
  sym_command = 113,
  sym_command_name = 114,
  sym_variable_assignment = 115,
  sym_subscript = 116,
  sym_file_redirect = 117,
  sym_heredoc_redirect = 118,
  sym_heredoc_body = 119,
  sym_herestring_redirect = 120,
  sym__expression = 121,
  sym_binary_expression = 122,
  sym_unary_expression = 123,
  sym_parenthesized_expression = 124,
  sym_concatenation = 125,
  sym_string = 126,
  sym_array = 127,
  sym_simple_expansion = 128,
  sym_string_expansion = 129,
  sym_expansion = 130,
  sym_command_substitution = 131,
  sym_process_substitution = 132,
  aux_sym__statements_repeat1 = 133,
  aux_sym_for_statement_repeat1 = 134,
  aux_sym_while_statement_repeat1 = 135,
  aux_sym_if_statement_repeat1 = 136,
  aux_sym_case_statement_repeat1 = 137,
  aux_sym_case_item_repeat1 = 138,
  aux_sym_declaration_command_repeat1 = 139,
  aux_sym_unset_command_repeat1 = 140,
  aux_sym_command_repeat1 = 141,
  aux_sym_command_repeat2 = 142,
  aux_sym_heredoc_body_repeat1 = 143,
  aux_sym_concatenation_repeat1 = 144,
  aux_sym_string_repeat1 = 145,
  aux_sym_expansion_repeat1 = 146,
  alias_sym_special_variable_name = 147,
  alias_sym_word = 148,
};

static const char *ts_symbol_names[] = {
  [sym_heredoc_start] = "heredoc_start",
  [sym__simple_heredoc_body] = "_simple_heredoc_body",
  [sym__heredoc_body_beginning] = "_heredoc_body_beginning",
  [sym__heredoc_body_middle] = "_heredoc_body_middle",
  [sym__heredoc_body_end] = "_heredoc_body_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_LPAREN_LPAREN] = "((",
  [anon_sym_RPAREN_RPAREN] = "))",
  [anon_sym_SEMI] = ";",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_unset] = "unset",
  [anon_sym_unsetenv] = "unsetenv",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_BANG_EQ] = "!=",
  [sym__special_characters] = "_special_characters",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DOLLAR] = "$",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DASH] = "-",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = "variable_name",
  [anon_sym_STAR] = "special_variable_name",
  [anon_sym_AT] = "special_variable_name",
  [anon_sym_QMARK] = "special_variable_name",
  [anon_sym_0] = "special_variable_name",
  [anon_sym__] = "special_variable_name",
  [sym_word] = "word",
  [sym_test_operator] = "test_operator",
  [sym_regex] = "regex",
  [sym_regex_without_right_brace] = "regex",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_for_statement] = "for_statement",
  [sym_c_style_for_statement] = "c_style_for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_negated_command] = "negated_command",
  [sym_test_command] = "test_command",
  [sym_declaration_command] = "declaration_command",
  [sym_unset_command] = "unset_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc_body] = "heredoc_body",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_string_expansion] = "string_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_while_statement_repeat1] = "while_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_unset_command_repeat1] = "unset_command_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_special_variable_name] = "special_variable_name",
  [alias_sym_word] = "word",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_heredoc_body] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsetenv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym__special_characters] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_test_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_without_right_brace] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_c_style_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_command] = {
    .visible = true,
    .named = true,
  },
  [sym_test_command] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_string_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_word] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[8][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_word,
  },
  [2] = {
    [1] = alias_sym_word,
  },
  [3] = {
    [1] = alias_sym_special_variable_name,
  },
  [4] = {
    [2] = alias_sym_word,
  },
  [5] = {
    [2] = alias_sym_special_variable_name,
  },
  [6] = {
    [3] = alias_sym_word,
  },
  [7] = {
    [4] = alias_sym_word,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '*')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(23);
      if (lookahead == '/')
        ADVANCE(24);
      if (lookahead == '0')
        ADVANCE(25);
      if (lookahead == ':')
        ADVANCE(26);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(37);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '?')
        ADVANCE(44);
      if (lookahead == '@')
        ADVANCE(45);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(48);
      if (lookahead == ']')
        ADVANCE(49);
      if (lookahead == '_')
        ADVANCE(51);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == 'e')
        ADVANCE(53);
      if (lookahead == 'i')
        ADVANCE(57);
      if (lookahead == '{')
        ADVANCE(59);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      ADVANCE(5);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 4:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '{')
        ADVANCE(10);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(13);
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(15);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 16:
      if (lookahead == '\'')
        ADVANCE(17);
      if (lookahead != 0)
        ADVANCE(16);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(22);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(27);
      if (lookahead == '?')
        ADVANCE(28);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(30);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(32);
      if (lookahead == '(')
        ADVANCE(33);
      if (lookahead == '<')
        ADVANCE(34);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(35);
      if (lookahead == '<')
        ADVANCE(36);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(38);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == '~')
        ADVANCE(39);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(5);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(41);
      if (lookahead == '(')
        ADVANCE(42);
      if (lookahead == '>')
        ADVANCE(43);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 48:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(50);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 's')
        ADVANCE(54);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'a')
        ADVANCE(55);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'n')
        ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(61);
      if (lookahead == '|')
        ADVANCE(62);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 64:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(66);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(68);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(64);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(65);
      END_STATE();
    case 66:
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(32);
      if (lookahead == '(')
        ADVANCE(33);
      END_STATE();
    case 68:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(64);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym__special_characters);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      END_STATE();
    case 70:
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '+')
        ADVANCE(71);
      if (lookahead == '=')
        ADVANCE(73);
      if (lookahead == '[')
        ADVANCE(74);
      if (lookahead == '\\')
        SKIP(75);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(70);
      END_STATE();
    case 71:
      if (lookahead == '=')
        ADVANCE(72);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 75:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(70);
      END_STATE();
    case 76:
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '(')
        ADVANCE(77);
      if (lookahead == '\\')
        SKIP(79);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 77:
      if (lookahead == '(')
        ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LPAREN_LPAREN);
      END_STATE();
    case 79:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(76);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 81:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(66);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(82);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(81);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 82:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(81);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 83:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(66);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(84);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(83);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 84:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(83);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 85:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(86);
      if (lookahead == '-')
        ADVANCE(88);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(92);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(85);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 86:
      if (lookahead == ')')
        ADVANCE(87);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_RPAREN_RPAREN);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '`' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(89);
      END_STATE();
    case 90:
      if (lookahead == '(')
        ADVANCE(33);
      END_STATE();
    case 91:
      if (lookahead == '(')
        ADVANCE(42);
      END_STATE();
    case 92:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(85);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 93:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(94);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(95);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(96);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(13);
      END_STATE();
    case 95:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(93);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 97:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(98);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(99);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(97);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(38);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == '~')
        ADVANCE(39);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(5);
      END_STATE();
    case 99:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(97);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 100:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(101);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\\')
        ADVANCE(105);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(106);
      if (lookahead != 0)
        ADVANCE(102);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(102);
      if (lookahead == '\\')
        ADVANCE(104);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(101);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(102);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(102);
      if (lookahead == '\\')
        ADVANCE(103);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(102);
      if (lookahead != 0)
        ADVANCE(102);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(102);
      if (lookahead == '\\')
        ADVANCE(104);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(101);
      if (lookahead != 0)
        ADVANCE(101);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(106);
      if (lookahead == '\\')
        ADVANCE(103);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(106);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(102);
      if (lookahead != 0)
        ADVANCE(102);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(101);
      if (lookahead == '\\')
        ADVANCE(105);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(106);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(102);
      END_STATE();
    case 107:
      if (lookahead == '!')
        ADVANCE(108);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(109);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(110);
      if (lookahead == '-')
        ADVANCE(111);
      if (lookahead == '0')
        ADVANCE(112);
      if (lookahead == '?')
        ADVANCE(113);
      if (lookahead == '@')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(115);
      if (lookahead == '_')
        ADVANCE(116);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(107);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 115:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(107);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 117:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(98);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(118);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(117);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 118:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(117);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 119:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(119);
      END_STATE();
    case 120:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(119);
      END_STATE();
    case 121:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(94);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '\\')
        SKIP(122);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(121);
      END_STATE();
    case 122:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(121);
      END_STATE();
    case 123:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(124);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 124:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 125:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(98);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(126);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(125);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 126:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(125);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 127:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(128);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(127);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 128:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(127);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 129:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(130);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(88);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(131);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(129);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 131:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(129);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 132:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(130);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '\\')
        SKIP(133);
      if (lookahead == 'i')
        ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      END_STATE();
    case 133:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      END_STATE();
    case 134:
      if (lookahead == 'n')
        ADVANCE(135);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 136:
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(137);
      if (lookahead == '{')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      END_STATE();
    case 137:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      END_STATE();
    case 138:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(94);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(138);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(96);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 139:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(138);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 140:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(98);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(141);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(140);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 141:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(140);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 142:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(143);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(142);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 143:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(142);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 144:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(94);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '\\')
        SKIP(145);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(144);
      END_STATE();
    case 145:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(144);
      END_STATE();
    case 146:
      if (lookahead == 's')
        ADVANCE(147);
      END_STATE();
    case 147:
      if (lookahead == 'a')
        ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == 'c')
        ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 150:
      if (lookahead == '!')
        ADVANCE(151);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(153);
      if (lookahead == '-')
        ADVANCE(154);
      if (lookahead == '<')
        ADVANCE(156);
      if (lookahead == '=')
        ADVANCE(157);
      if (lookahead == '>')
        ADVANCE(160);
      if (lookahead == '\\')
        SKIP(161);
      if (lookahead == ']')
        ADVANCE(162);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(150);
      END_STATE();
    case 151:
      if (lookahead == '=')
        ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 153:
      if (lookahead == '&')
        ADVANCE(13);
      END_STATE();
    case 154:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(158);
      if (lookahead == '~')
        ADVANCE(159);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 161:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(150);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 163:
      if (lookahead == '|')
        ADVANCE(62);
      END_STATE();
    case 164:
      if (lookahead == '!')
        ADVANCE(151);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(153);
      if (lookahead == '-')
        ADVANCE(154);
      if (lookahead == '<')
        ADVANCE(156);
      if (lookahead == '=')
        ADVANCE(157);
      if (lookahead == '>')
        ADVANCE(160);
      if (lookahead == '\\')
        SKIP(165);
      if (lookahead == ']')
        ADVANCE(166);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(164);
      END_STATE();
    case 165:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(164);
      END_STATE();
    case 166:
      if (lookahead == ']')
        ADVANCE(50);
      END_STATE();
    case 167:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(109);
      if (lookahead == '*')
        ADVANCE(110);
      if (lookahead == '-')
        ADVANCE(111);
      if (lookahead == '0')
        ADVANCE(168);
      if (lookahead == '?')
        ADVANCE(113);
      if (lookahead == '@')
        ADVANCE(114);
      if (lookahead == '\\')
        ADVANCE(170);
      if (lookahead == '_')
        ADVANCE(172);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(171);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(169);
      if (lookahead != 0 &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(102);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(169);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(171);
      if (lookahead == '\\')
        ADVANCE(103);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(171);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(102);
      if (lookahead != 0)
        ADVANCE(102);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(110);
      if (lookahead == '-')
        ADVANCE(111);
      if (lookahead == '0')
        ADVANCE(168);
      if (lookahead == '?')
        ADVANCE(113);
      if (lookahead == '@')
        ADVANCE(114);
      if (lookahead == '\\')
        ADVANCE(170);
      if (lookahead == '_')
        ADVANCE(172);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(171);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(169);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(102);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(169);
      END_STATE();
    case 173:
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(109);
      if (lookahead == '*')
        ADVANCE(110);
      if (lookahead == '-')
        ADVANCE(111);
      if (lookahead == '0')
        ADVANCE(112);
      if (lookahead == '?')
        ADVANCE(113);
      if (lookahead == '@')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(174);
      if (lookahead == '_')
        ADVANCE(116);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(80);
      END_STATE();
    case 174:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      END_STATE();
    case 175:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(23);
      if (lookahead == '/')
        ADVANCE(24);
      if (lookahead == ':')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(177);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 177:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 178:
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(179);
      if (lookahead == '\\')
        SKIP(180);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(10);
      END_STATE();
    case 180:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      END_STATE();
    case 181:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(182);
      if (lookahead == '$')
        ADVANCE(184);
      if (lookahead == '\'')
        ADVANCE(189);
      if (lookahead == '<')
        ADVANCE(192);
      if (lookahead == '>')
        ADVANCE(194);
      if (lookahead == '[')
        ADVANCE(196);
      if (lookahead == '\\')
        ADVANCE(197);
      if (lookahead == ']')
        ADVANCE(196);
      if (lookahead == '`')
        ADVANCE(203);
      if (lookahead == '{')
        ADVANCE(196);
      if (lookahead == '}')
        ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(181);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(187);
      if (lookahead != 0)
        ADVANCE(200);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(183);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(182);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(185);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead == '{')
        ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(187);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\'')
        ADVANCE(190);
      if (lookahead == '\\')
        ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(16);
      if (lookahead != 0)
        ADVANCE(189);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_raw_string);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\n')
        ADVANCE(16);
      if (lookahead == '\'')
        ADVANCE(190);
      if (lookahead == '\\')
        ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(189);
      if (lookahead != 0)
        ADVANCE(189);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '(')
        ADVANCE(193);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '(')
        ADVANCE(195);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '[')
        ADVANCE(196);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead == ']')
        ADVANCE(196);
      if (lookahead == '{')
        ADVANCE(196);
      if (lookahead == '}')
        ADVANCE(196);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(201);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(200);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(199);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(187);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(200);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(200);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(199);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(200);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\"')
        ADVANCE(202);
      if (lookahead == '#')
        ADVANCE(182);
      if (lookahead == '$')
        ADVANCE(184);
      if (lookahead == '\'')
        ADVANCE(189);
      if (lookahead == '<')
        ADVANCE(192);
      if (lookahead == '>')
        ADVANCE(194);
      if (lookahead == '[')
        ADVANCE(196);
      if (lookahead == '\\')
        ADVANCE(197);
      if (lookahead == ']')
        ADVANCE(196);
      if (lookahead == '`')
        ADVANCE(203);
      if (lookahead == '{')
        ADVANCE(196);
      if (lookahead == '}')
        ADVANCE(196);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(200);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 204:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(207);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(32);
      if (lookahead == '<')
        ADVANCE(34);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(41);
      if (lookahead == '>')
        ADVANCE(43);
      END_STATE();
    case 207:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(204);
      END_STATE();
    case 208:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(209);
      if (lookahead == ']')
        ADVANCE(162);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(208);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 209:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(208);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 210:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(211);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 211:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 212:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(151);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(94);
      if (lookahead == '-')
        ADVANCE(154);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(156);
      if (lookahead == '=')
        ADVANCE(157);
      if (lookahead == '>')
        ADVANCE(160);
      if (lookahead == '\\')
        SKIP(213);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      END_STATE();
    case 213:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      END_STATE();
    case 214:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(66);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(215);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 215:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 216:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(217);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(218);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(32);
      END_STATE();
    case 218:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      END_STATE();
    case 219:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(66);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(220);
      if (lookahead == '<')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(221);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      if (lookahead != 0 &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 220:
      if (lookahead == ';')
        ADVANCE(30);
      END_STATE();
    case 221:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 222:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(223);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(222);
      END_STATE();
    case 223:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(222);
      END_STATE();
    case 224:
      if (lookahead == '!')
        ADVANCE(151);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(153);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '-')
        ADVANCE(154);
      if (lookahead == '<')
        ADVANCE(156);
      if (lookahead == '=')
        ADVANCE(157);
      if (lookahead == '>')
        ADVANCE(160);
      if (lookahead == '\\')
        SKIP(225);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(224);
      END_STATE();
    case 225:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(224);
      END_STATE();
    case 226:
      if (lookahead == '!')
        ADVANCE(227);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(182);
      if (lookahead == '$')
        ADVANCE(184);
      if (lookahead == '\'')
        ADVANCE(189);
      if (lookahead == '(')
        ADVANCE(228);
      if (lookahead == '-')
        ADVANCE(229);
      if (lookahead == '<')
        ADVANCE(192);
      if (lookahead == '>')
        ADVANCE(194);
      if (lookahead == '[')
        ADVANCE(196);
      if (lookahead == '\\')
        ADVANCE(231);
      if (lookahead == ']')
        ADVANCE(196);
      if (lookahead == '`')
        ADVANCE(203);
      if (lookahead == '{')
        ADVANCE(196);
      if (lookahead == '}')
        ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(187);
      if (lookahead != 0)
        ADVANCE(200);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(199);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(200);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(187);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(199);
      if (('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('[' <= lookahead && lookahead <= ']') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(187);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(230);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(200);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(230);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '\\')
        ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(232);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(200);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_regex);
      if (lookahead == '!')
        ADVANCE(227);
      if (lookahead == '\"')
        ADVANCE(202);
      if (lookahead == '#')
        ADVANCE(182);
      if (lookahead == '$')
        ADVANCE(184);
      if (lookahead == '\'')
        ADVANCE(189);
      if (lookahead == '(')
        ADVANCE(228);
      if (lookahead == '-')
        ADVANCE(229);
      if (lookahead == '<')
        ADVANCE(192);
      if (lookahead == '>')
        ADVANCE(194);
      if (lookahead == '[')
        ADVANCE(196);
      if (lookahead == '\\')
        ADVANCE(231);
      if (lookahead == ']')
        ADVANCE(196);
      if (lookahead == '`')
        ADVANCE(203);
      if (lookahead == '{')
        ADVANCE(196);
      if (lookahead == '}')
        ADVANCE(196);
      if (('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '|')
        ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '$'))
        ADVANCE(200);
      END_STATE();
    case 233:
      if (lookahead == '!')
        ADVANCE(151);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(153);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '-')
        ADVANCE(154);
      if (lookahead == '<')
        ADVANCE(156);
      if (lookahead == '=')
        ADVANCE(157);
      if (lookahead == '>')
        ADVANCE(160);
      if (lookahead == '\\')
        SKIP(234);
      if (lookahead == ']')
        ADVANCE(166);
      if (lookahead == '|')
        ADVANCE(235);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      END_STATE();
    case 234:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(62);
      END_STATE();
    case 236:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(237);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(236);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 237:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(236);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 238:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(23);
      if (lookahead == ':')
        ADVANCE(26);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(239);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(238);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 239:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(238);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 240:
      if (lookahead == '#')
        ADVANCE(241);
      if (lookahead == '\\')
        ADVANCE(243);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '}')
        ADVANCE(245);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(242);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '}')
        ADVANCE(241);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(242);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '}')
        ADVANCE(241);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(241);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(244);
      if (lookahead == '}')
        ADVANCE(245);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(246);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(245);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(244);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '}')
        ADVANCE(245);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n')
        ADVANCE(245);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\\')
        ADVANCE(244);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '}')
        ADVANCE(245);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_regex_without_right_brace);
      if (lookahead == '\"')
        ADVANCE(245);
      if (lookahead == '#')
        ADVANCE(241);
      if (lookahead == '\\')
        ADVANCE(243);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '}')
        ADVANCE(245);
      END_STATE();
    case 247:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(248);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      END_STATE();
    case 248:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      END_STATE();
    case 249:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(250);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      END_STATE();
    case 250:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      END_STATE();
    case 251:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(151);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(94);
      if (lookahead == '-')
        ADVANCE(154);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(156);
      if (lookahead == '=')
        ADVANCE(157);
      if (lookahead == '>')
        ADVANCE(160);
      if (lookahead == '\\')
        SKIP(252);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      END_STATE();
    case 252:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      END_STATE();
    case 253:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(130);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(254);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(253);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 254:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(253);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 255:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(256);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == 'e')
        ADVANCE(53);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 256:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 257:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(217);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(258);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      END_STATE();
    case 258:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      END_STATE();
    case 259:
      if (lookahead == '!')
        ADVANCE(151);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(153);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '-')
        ADVANCE(154);
      if (lookahead == '<')
        ADVANCE(156);
      if (lookahead == '=')
        ADVANCE(157);
      if (lookahead == '>')
        ADVANCE(160);
      if (lookahead == '\\')
        SKIP(260);
      if (lookahead == ']')
        ADVANCE(166);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(259);
      END_STATE();
    case 260:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(259);
      END_STATE();
    case 261:
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == ';')
        ADVANCE(262);
      if (lookahead == '\\')
        ADVANCE(263);
      if (lookahead == '{')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 263:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 264:
      if (lookahead == '!')
        ADVANCE(151);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(153);
      if (lookahead == ')')
        ADVANCE(86);
      if (lookahead == '-')
        ADVANCE(154);
      if (lookahead == '<')
        ADVANCE(156);
      if (lookahead == '=')
        ADVANCE(157);
      if (lookahead == '>')
        ADVANCE(160);
      if (lookahead == '\\')
        SKIP(265);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      END_STATE();
    case 265:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      END_STATE();
    case 266:
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == '\\')
        SKIP(267);
      if (lookahead == '|')
        ADVANCE(268);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      END_STATE();
    case 267:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 269:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(94);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '\\')
        SKIP(270);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(269);
      END_STATE();
    case 270:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(269);
      END_STATE();
    case 271:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(66);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(220);
      if (lookahead == '<')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(272);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == 'e')
        ADVANCE(53);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(271);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 272:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(271);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 273:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(94);
      if (lookahead == ')')
        ADVANCE(19);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '\\')
        SKIP(274);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(273);
      END_STATE();
    case 274:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(273);
      END_STATE();
    case 275:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(94);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '\\')
        SKIP(276);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(275);
      END_STATE();
    case 276:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(275);
      END_STATE();
    case 277:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(94);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(91);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(278);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == 'e')
        ADVANCE(279);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(277);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(96);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 278:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(277);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 's')
        ADVANCE(280);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'a')
        ADVANCE(281);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 283:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(98);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(284);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == 'e')
        ADVANCE(53);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(283);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 284:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(283);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 285:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(98);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(286);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == 'e')
        ADVANCE(53);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(285);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 286:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(285);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 287:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(69);
      if (lookahead == '\\')
        ADVANCE(288);
      if (lookahead == ']')
        ADVANCE(69);
      if (lookahead == '`')
        ADVANCE(52);
      if (lookahead == 'e')
        ADVANCE(53);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '}')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(287);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 288:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(287);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 289:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(205);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(290);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(289);
      END_STATE();
    case 290:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(289);
      END_STATE();
    case 291:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(65);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(217);
      if (lookahead == '>')
        ADVANCE(206);
      if (lookahead == '\\')
        SKIP(292);
      if (lookahead == 'e')
        ADVANCE(146);
      if (lookahead == '|')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      END_STATE();
    case 292:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'c')
        ADVANCE(1);
      if (lookahead == 'd')
        ADVANCE(5);
      if (lookahead == 'e')
        ADVANCE(15);
      if (lookahead == 'f')
        ADVANCE(26);
      if (lookahead == 'i')
        ADVANCE(37);
      if (lookahead == 'l')
        ADVANCE(39);
      if (lookahead == 'r')
        ADVANCE(44);
      if (lookahead == 't')
        ADVANCE(52);
      if (lookahead == 'u')
        ADVANCE(62);
      if (lookahead == 'w')
        ADVANCE(70);
      END_STATE();
    case 1:
      if (lookahead == 'a')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 's')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'e')
        ADVANCE(4);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 5:
      if (lookahead == 'e')
        ADVANCE(6);
      if (lookahead == 'o')
        ADVANCE(12);
      END_STATE();
    case 6:
      if (lookahead == 'c')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'l')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 'a')
        ADVANCE(9);
      END_STATE();
    case 9:
      if (lookahead == 'r')
        ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == 'e')
        ADVANCE(11);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n')
        ADVANCE(13);
      END_STATE();
    case 13:
      if (lookahead == 'e')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 15:
      if (lookahead == 'l')
        ADVANCE(16);
      if (lookahead == 'x')
        ADVANCE(21);
      END_STATE();
    case 16:
      if (lookahead == 'i')
        ADVANCE(17);
      if (lookahead == 's')
        ADVANCE(19);
      END_STATE();
    case 17:
      if (lookahead == 'f')
        ADVANCE(18);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 19:
      if (lookahead == 'e')
        ADVANCE(20);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 21:
      if (lookahead == 'p')
        ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == 'o')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 'r')
        ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == 't')
        ADVANCE(25);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 26:
      if (lookahead == 'i')
        ADVANCE(27);
      if (lookahead == 'o')
        ADVANCE(28);
      if (lookahead == 'u')
        ADVANCE(30);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 28:
      if (lookahead == 'r')
        ADVANCE(29);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 30:
      if (lookahead == 'n')
        ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'c')
        ADVANCE(32);
      END_STATE();
    case 32:
      if (lookahead == 't')
        ADVANCE(33);
      END_STATE();
    case 33:
      if (lookahead == 'i')
        ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == 'o')
        ADVANCE(35);
      END_STATE();
    case 35:
      if (lookahead == 'n')
        ADVANCE(36);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 37:
      if (lookahead == 'f')
        ADVANCE(38);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 39:
      if (lookahead == 'o')
        ADVANCE(40);
      END_STATE();
    case 40:
      if (lookahead == 'c')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == 'a')
        ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == 'l')
        ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 44:
      if (lookahead == 'e')
        ADVANCE(45);
      END_STATE();
    case 45:
      if (lookahead == 'a')
        ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == 'd')
        ADVANCE(47);
      END_STATE();
    case 47:
      if (lookahead == 'o')
        ADVANCE(48);
      END_STATE();
    case 48:
      if (lookahead == 'n')
        ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 'l')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 'y')
        ADVANCE(51);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 52:
      if (lookahead == 'h')
        ADVANCE(53);
      if (lookahead == 'y')
        ADVANCE(56);
      END_STATE();
    case 53:
      if (lookahead == 'e')
        ADVANCE(54);
      END_STATE();
    case 54:
      if (lookahead == 'n')
        ADVANCE(55);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 56:
      if (lookahead == 'p')
        ADVANCE(57);
      END_STATE();
    case 57:
      if (lookahead == 'e')
        ADVANCE(58);
      END_STATE();
    case 58:
      if (lookahead == 's')
        ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 'e')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 't')
        ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_typeset);
      END_STATE();
    case 62:
      if (lookahead == 'n')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == 's')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'e')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 't')
        ADVANCE(66);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == 'e')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'n')
        ADVANCE(68);
      END_STATE();
    case 68:
      if (lookahead == 'v')
        ADVANCE(69);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      END_STATE();
    case 70:
      if (lookahead == 'h')
        ADVANCE(71);
      END_STATE();
    case 71:
      if (lookahead == 'i')
        ADVANCE(72);
      END_STATE();
    case 72:
      if (lookahead == 'l')
        ADVANCE(73);
      END_STATE();
    case 73:
      if (lookahead == 'e')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 64, .external_lex_state = 2},
  [2] = {.lex_state = 64},
  [3] = {.lex_state = 70},
  [4] = {.lex_state = 76},
  [5] = {.lex_state = 64, .external_lex_state = 2},
  [6] = {.lex_state = 64, .external_lex_state = 2},
  [7] = {.lex_state = 81},
  [8] = {.lex_state = 81},
  [9] = {.lex_state = 64, .external_lex_state = 2},
  [10] = {.lex_state = 83, .external_lex_state = 2},
  [11] = {.lex_state = 85},
  [12] = {.lex_state = 85},
  [13] = {.lex_state = 93, .external_lex_state = 3},
  [14] = {.lex_state = 93, .external_lex_state = 4},
  [15] = {.lex_state = 81},
  [16] = {.lex_state = 97, .external_lex_state = 5},
  [17] = {.lex_state = 100},
  [18] = {.lex_state = 107},
  [19] = {.lex_state = 97, .external_lex_state = 5},
  [20] = {.lex_state = 107, .external_lex_state = 6},
  [21] = {.lex_state = 64, .external_lex_state = 2},
  [22] = {.lex_state = 64, .external_lex_state = 2},
  [23] = {.lex_state = 64, .external_lex_state = 2},
  [24] = {.lex_state = 117, .external_lex_state = 5},
  [25] = {.lex_state = 119},
  [26] = {.lex_state = 121, .external_lex_state = 4},
  [27] = {.lex_state = 97, .external_lex_state = 7},
  [28] = {.lex_state = 123, .external_lex_state = 8},
  [29] = {.lex_state = 70},
  [30] = {.lex_state = 125, .external_lex_state = 7},
  [31] = {.lex_state = 64, .external_lex_state = 2},
  [32] = {.lex_state = 81, .external_lex_state = 2},
  [33] = {.lex_state = 81},
  [34] = {.lex_state = 81},
  [35] = {.lex_state = 127, .external_lex_state = 9},
  [36] = {.lex_state = 129, .external_lex_state = 4},
  [37] = {.lex_state = 132, .external_lex_state = 4},
  [38] = {.lex_state = 70},
  [39] = {.lex_state = 64, .external_lex_state = 2},
  [40] = {.lex_state = 81},
  [41] = {.lex_state = 83, .external_lex_state = 2},
  [42] = {.lex_state = 85},
  [43] = {.lex_state = 85},
  [44] = {.lex_state = 93, .external_lex_state = 3},
  [45] = {.lex_state = 93, .external_lex_state = 4},
  [46] = {.lex_state = 97, .external_lex_state = 5},
  [47] = {.lex_state = 97, .external_lex_state = 5},
  [48] = {.lex_state = 117, .external_lex_state = 5},
  [49] = {.lex_state = 81},
  [50] = {.lex_state = 93, .external_lex_state = 4},
  [51] = {.lex_state = 97, .external_lex_state = 7},
  [52] = {.lex_state = 123, .external_lex_state = 8},
  [53] = {.lex_state = 70},
  [54] = {.lex_state = 81, .external_lex_state = 2},
  [55] = {.lex_state = 81},
  [56] = {.lex_state = 132, .external_lex_state = 10},
  [57] = {.lex_state = 100},
  [58] = {.lex_state = 107},
  [59] = {.lex_state = 132, .external_lex_state = 10},
  [60] = {.lex_state = 107, .external_lex_state = 6},
  [61] = {.lex_state = 64, .external_lex_state = 2},
  [62] = {.lex_state = 64, .external_lex_state = 2},
  [63] = {.lex_state = 64, .external_lex_state = 2},
  [64] = {.lex_state = 132, .external_lex_state = 4},
  [65] = {.lex_state = 136},
  [66] = {.lex_state = 70},
  [67] = {.lex_state = 64, .external_lex_state = 2},
  [68] = {.lex_state = 81},
  [69] = {.lex_state = 83, .external_lex_state = 2},
  [70] = {.lex_state = 85},
  [71] = {.lex_state = 85},
  [72] = {.lex_state = 138, .external_lex_state = 3},
  [73] = {.lex_state = 138, .external_lex_state = 4},
  [74] = {.lex_state = 125, .external_lex_state = 5},
  [75] = {.lex_state = 125, .external_lex_state = 5},
  [76] = {.lex_state = 140, .external_lex_state = 5},
  [77] = {.lex_state = 138, .external_lex_state = 4},
  [78] = {.lex_state = 125, .external_lex_state = 7},
  [79] = {.lex_state = 142, .external_lex_state = 8},
  [80] = {.lex_state = 70},
  [81] = {.lex_state = 64, .external_lex_state = 2},
  [82] = {.lex_state = 81, .external_lex_state = 2},
  [83] = {.lex_state = 70},
  [84] = {.lex_state = 144, .external_lex_state = 4},
  [85] = {.lex_state = 70},
  [86] = {.lex_state = 85},
  [87] = {.lex_state = 85},
  [88] = {.lex_state = 150, .external_lex_state = 11},
  [89] = {.lex_state = 100},
  [90] = {.lex_state = 107},
  [91] = {.lex_state = 150, .external_lex_state = 11},
  [92] = {.lex_state = 107, .external_lex_state = 6},
  [93] = {.lex_state = 64, .external_lex_state = 2},
  [94] = {.lex_state = 64, .external_lex_state = 2},
  [95] = {.lex_state = 64, .external_lex_state = 2},
  [96] = {.lex_state = 150, .external_lex_state = 12},
  [97] = {.lex_state = 85},
  [98] = {.lex_state = 85},
  [99] = {.lex_state = 164, .external_lex_state = 13},
  [100] = {.lex_state = 100},
  [101] = {.lex_state = 107},
  [102] = {.lex_state = 164, .external_lex_state = 13},
  [103] = {.lex_state = 107, .external_lex_state = 6},
  [104] = {.lex_state = 64, .external_lex_state = 2},
  [105] = {.lex_state = 64, .external_lex_state = 2},
  [106] = {.lex_state = 64, .external_lex_state = 2},
  [107] = {.lex_state = 164},
  [108] = {.lex_state = 70},
  [109] = {.lex_state = 93, .external_lex_state = 14},
  [110] = {.lex_state = 100},
  [111] = {.lex_state = 107},
  [112] = {.lex_state = 93, .external_lex_state = 14},
  [113] = {.lex_state = 107, .external_lex_state = 6},
  [114] = {.lex_state = 64, .external_lex_state = 2},
  [115] = {.lex_state = 64, .external_lex_state = 2},
  [116] = {.lex_state = 64, .external_lex_state = 2},
  [117] = {.lex_state = 70},
  [118] = {.lex_state = 93, .external_lex_state = 3},
  [119] = {.lex_state = 93, .external_lex_state = 10},
  [120] = {.lex_state = 100},
  [121] = {.lex_state = 107},
  [122] = {.lex_state = 93, .external_lex_state = 10},
  [123] = {.lex_state = 107, .external_lex_state = 6},
  [124] = {.lex_state = 64, .external_lex_state = 2},
  [125] = {.lex_state = 64, .external_lex_state = 2},
  [126] = {.lex_state = 64, .external_lex_state = 2},
  [127] = {.lex_state = 93, .external_lex_state = 4},
  [128] = {.lex_state = 81, .external_lex_state = 15},
  [129] = {.lex_state = 100},
  [130] = {.lex_state = 107},
  [131] = {.lex_state = 81, .external_lex_state = 15},
  [132] = {.lex_state = 107, .external_lex_state = 6},
  [133] = {.lex_state = 64, .external_lex_state = 2},
  [134] = {.lex_state = 64, .external_lex_state = 2},
  [135] = {.lex_state = 64, .external_lex_state = 2},
  [136] = {.lex_state = 81, .external_lex_state = 2},
  [137] = {.lex_state = 81},
  [138] = {.lex_state = 97, .external_lex_state = 5},
  [139] = {.lex_state = 125, .external_lex_state = 5},
  [140] = {.lex_state = 167},
  [141] = {.lex_state = 100, .external_lex_state = 13},
  [142] = {.lex_state = 107, .external_lex_state = 6},
  [143] = {.lex_state = 64, .external_lex_state = 2},
  [144] = {.lex_state = 64, .external_lex_state = 2},
  [145] = {.lex_state = 100},
  [146] = {.lex_state = 125, .external_lex_state = 5},
  [147] = {.lex_state = 125, .external_lex_state = 5},
  [148] = {.lex_state = 125, .external_lex_state = 5},
  [149] = {.lex_state = 70},
  [150] = {.lex_state = 173, .external_lex_state = 6},
  [151] = {.lex_state = 175, .external_lex_state = 16},
  [152] = {.lex_state = 175, .external_lex_state = 16},
  [153] = {.lex_state = 138, .external_lex_state = 4},
  [154] = {.lex_state = 142, .external_lex_state = 8},
  [155] = {.lex_state = 64, .external_lex_state = 2},
  [156] = {.lex_state = 64, .external_lex_state = 2},
  [157] = {.lex_state = 81},
  [158] = {.lex_state = 83, .external_lex_state = 2},
  [159] = {.lex_state = 85},
  [160] = {.lex_state = 85},
  [161] = {.lex_state = 93, .external_lex_state = 3},
  [162] = {.lex_state = 93, .external_lex_state = 4},
  [163] = {.lex_state = 117, .external_lex_state = 5},
  [164] = {.lex_state = 93, .external_lex_state = 4},
  [165] = {.lex_state = 97, .external_lex_state = 7},
  [166] = {.lex_state = 123, .external_lex_state = 8},
  [167] = {.lex_state = 64, .external_lex_state = 2},
  [168] = {.lex_state = 81, .external_lex_state = 2},
  [169] = {.lex_state = 138, .external_lex_state = 4},
  [170] = {.lex_state = 142, .external_lex_state = 8},
  [171] = {.lex_state = 64, .external_lex_state = 2},
  [172] = {.lex_state = 83},
  [173] = {.lex_state = 64, .external_lex_state = 2},
  [174] = {.lex_state = 64, .external_lex_state = 2},
  [175] = {.lex_state = 64, .external_lex_state = 2},
  [176] = {.lex_state = 144, .external_lex_state = 4},
  [177] = {.lex_state = 178, .external_lex_state = 17},
  [178] = {.lex_state = 64},
  [179] = {.lex_state = 181},
  [180] = {.lex_state = 81},
  [181] = {.lex_state = 64, .external_lex_state = 18},
  [182] = {.lex_state = 81},
  [183] = {.lex_state = 97, .external_lex_state = 5},
  [184] = {.lex_state = 97, .external_lex_state = 5},
  [185] = {.lex_state = 144, .external_lex_state = 4},
  [186] = {.lex_state = 204, .external_lex_state = 7},
  [187] = {.lex_state = 97, .external_lex_state = 7},
  [188] = {.lex_state = 121, .external_lex_state = 4},
  [189] = {.lex_state = 123, .external_lex_state = 8},
  [190] = {.lex_state = 64, .external_lex_state = 2},
  [191] = {.lex_state = 97, .external_lex_state = 7},
  [192] = {.lex_state = 81, .external_lex_state = 2},
  [193] = {.lex_state = 81, .external_lex_state = 15},
  [194] = {.lex_state = 81, .external_lex_state = 15},
  [195] = {.lex_state = 81, .external_lex_state = 2},
  [196] = {.lex_state = 208, .external_lex_state = 11},
  [197] = {.lex_state = 208, .external_lex_state = 11},
  [198] = {.lex_state = 208, .external_lex_state = 11},
  [199] = {.lex_state = 142, .external_lex_state = 8},
  [200] = {.lex_state = 210},
  [201] = {.lex_state = 123, .external_lex_state = 19},
  [202] = {.lex_state = 100},
  [203] = {.lex_state = 107},
  [204] = {.lex_state = 123, .external_lex_state = 19},
  [205] = {.lex_state = 107, .external_lex_state = 6},
  [206] = {.lex_state = 64, .external_lex_state = 2},
  [207] = {.lex_state = 64, .external_lex_state = 2},
  [208] = {.lex_state = 64, .external_lex_state = 2},
  [209] = {.lex_state = 129, .external_lex_state = 4},
  [210] = {.lex_state = 85},
  [211] = {.lex_state = 85},
  [212] = {.lex_state = 212, .external_lex_state = 10},
  [213] = {.lex_state = 100},
  [214] = {.lex_state = 107},
  [215] = {.lex_state = 212, .external_lex_state = 10},
  [216] = {.lex_state = 107, .external_lex_state = 6},
  [217] = {.lex_state = 64, .external_lex_state = 2},
  [218] = {.lex_state = 64, .external_lex_state = 2},
  [219] = {.lex_state = 64, .external_lex_state = 2},
  [220] = {.lex_state = 212, .external_lex_state = 4},
  [221] = {.lex_state = 81},
  [222] = {.lex_state = 81},
  [223] = {.lex_state = 127, .external_lex_state = 9},
  [224] = {.lex_state = 81},
  [225] = {.lex_state = 136},
  [226] = {.lex_state = 150, .external_lex_state = 12},
  [227] = {.lex_state = 164},
  [228] = {.lex_state = 70},
  [229] = {.lex_state = 93, .external_lex_state = 14},
  [230] = {.lex_state = 93, .external_lex_state = 14},
  [231] = {.lex_state = 70},
  [232] = {.lex_state = 93, .external_lex_state = 3},
  [233] = {.lex_state = 93, .external_lex_state = 10},
  [234] = {.lex_state = 93, .external_lex_state = 10},
  [235] = {.lex_state = 93, .external_lex_state = 4},
  [236] = {.lex_state = 97, .external_lex_state = 5},
  [237] = {.lex_state = 83},
  [238] = {.lex_state = 64, .external_lex_state = 2},
  [239] = {.lex_state = 204, .external_lex_state = 7},
  [240] = {.lex_state = 81},
  [241] = {.lex_state = 64, .external_lex_state = 2},
  [242] = {.lex_state = 64, .external_lex_state = 2},
  [243] = {.lex_state = 64},
  [244] = {.lex_state = 181},
  [245] = {.lex_state = 81},
  [246] = {.lex_state = 81},
  [247] = {.lex_state = 97, .external_lex_state = 5},
  [248] = {.lex_state = 97, .external_lex_state = 5},
  [249] = {.lex_state = 204, .external_lex_state = 7},
  [250] = {.lex_state = 97, .external_lex_state = 7},
  [251] = {.lex_state = 97, .external_lex_state = 7},
  [252] = {.lex_state = 64, .external_lex_state = 2},
  [253] = {.lex_state = 81},
  [254] = {.lex_state = 129, .external_lex_state = 4},
  [255] = {.lex_state = 132},
  [256] = {.lex_state = 132, .external_lex_state = 10},
  [257] = {.lex_state = 132, .external_lex_state = 10},
  [258] = {.lex_state = 167},
  [259] = {.lex_state = 100},
  [260] = {.lex_state = 132, .external_lex_state = 10},
  [261] = {.lex_state = 132, .external_lex_state = 10},
  [262] = {.lex_state = 132, .external_lex_state = 10},
  [263] = {.lex_state = 129, .external_lex_state = 4},
  [264] = {.lex_state = 132},
  [265] = {.lex_state = 70},
  [266] = {.lex_state = 173, .external_lex_state = 6},
  [267] = {.lex_state = 175, .external_lex_state = 16},
  [268] = {.lex_state = 175, .external_lex_state = 16},
  [269] = {.lex_state = 138, .external_lex_state = 4},
  [270] = {.lex_state = 142, .external_lex_state = 8},
  [271] = {.lex_state = 64, .external_lex_state = 2},
  [272] = {.lex_state = 93, .external_lex_state = 4},
  [273] = {.lex_state = 123, .external_lex_state = 8},
  [274] = {.lex_state = 64, .external_lex_state = 2},
  [275] = {.lex_state = 138, .external_lex_state = 4},
  [276] = {.lex_state = 142, .external_lex_state = 8},
  [277] = {.lex_state = 64, .external_lex_state = 2},
  [278] = {.lex_state = 83},
  [279] = {.lex_state = 214, .external_lex_state = 20},
  [280] = {.lex_state = 216, .external_lex_state = 21},
  [281] = {.lex_state = 127, .external_lex_state = 9},
  [282] = {.lex_state = 81},
  [283] = {.lex_state = 136},
  [284] = {.lex_state = 150, .external_lex_state = 12},
  [285] = {.lex_state = 164},
  [286] = {.lex_state = 70},
  [287] = {.lex_state = 138, .external_lex_state = 14},
  [288] = {.lex_state = 138, .external_lex_state = 14},
  [289] = {.lex_state = 70},
  [290] = {.lex_state = 138, .external_lex_state = 3},
  [291] = {.lex_state = 138, .external_lex_state = 10},
  [292] = {.lex_state = 138, .external_lex_state = 10},
  [293] = {.lex_state = 138, .external_lex_state = 4},
  [294] = {.lex_state = 125, .external_lex_state = 5},
  [295] = {.lex_state = 83},
  [296] = {.lex_state = 219, .external_lex_state = 2},
  [297] = {.lex_state = 64, .external_lex_state = 2},
  [298] = {.lex_state = 144, .external_lex_state = 4},
  [299] = {.lex_state = 64, .external_lex_state = 2},
  [300] = {.lex_state = 64},
  [301] = {.lex_state = 181},
  [302] = {.lex_state = 81},
  [303] = {.lex_state = 81},
  [304] = {.lex_state = 125, .external_lex_state = 5},
  [305] = {.lex_state = 125, .external_lex_state = 5},
  [306] = {.lex_state = 222, .external_lex_state = 7},
  [307] = {.lex_state = 125, .external_lex_state = 7},
  [308] = {.lex_state = 138, .external_lex_state = 4},
  [309] = {.lex_state = 142, .external_lex_state = 8},
  [310] = {.lex_state = 125, .external_lex_state = 7},
  [311] = {.lex_state = 127, .external_lex_state = 9},
  [312] = {.lex_state = 85},
  [313] = {.lex_state = 224, .external_lex_state = 13},
  [314] = {.lex_state = 224, .external_lex_state = 13},
  [315] = {.lex_state = 224},
  [316] = {.lex_state = 150, .external_lex_state = 12},
  [317] = {.lex_state = 81},
  [318] = {.lex_state = 150, .external_lex_state = 11},
  [319] = {.lex_state = 150, .external_lex_state = 11},
  [320] = {.lex_state = 167},
  [321] = {.lex_state = 100},
  [322] = {.lex_state = 150, .external_lex_state = 11},
  [323] = {.lex_state = 150, .external_lex_state = 11},
  [324] = {.lex_state = 150, .external_lex_state = 11},
  [325] = {.lex_state = 70},
  [326] = {.lex_state = 173, .external_lex_state = 6},
  [327] = {.lex_state = 175, .external_lex_state = 16},
  [328] = {.lex_state = 175, .external_lex_state = 16},
  [329] = {.lex_state = 138, .external_lex_state = 4},
  [330] = {.lex_state = 142, .external_lex_state = 8},
  [331] = {.lex_state = 64, .external_lex_state = 2},
  [332] = {.lex_state = 93, .external_lex_state = 4},
  [333] = {.lex_state = 123, .external_lex_state = 8},
  [334] = {.lex_state = 64, .external_lex_state = 2},
  [335] = {.lex_state = 138, .external_lex_state = 4},
  [336] = {.lex_state = 142, .external_lex_state = 8},
  [337] = {.lex_state = 64, .external_lex_state = 2},
  [338] = {.lex_state = 85},
  [339] = {.lex_state = 204, .external_lex_state = 21},
  [340] = {.lex_state = 226},
  [341] = {.lex_state = 224},
  [342] = {.lex_state = 164},
  [343] = {.lex_state = 81},
  [344] = {.lex_state = 164, .external_lex_state = 13},
  [345] = {.lex_state = 233, .external_lex_state = 13},
  [346] = {.lex_state = 167},
  [347] = {.lex_state = 100},
  [348] = {.lex_state = 233, .external_lex_state = 13},
  [349] = {.lex_state = 233, .external_lex_state = 13},
  [350] = {.lex_state = 233, .external_lex_state = 13},
  [351] = {.lex_state = 70},
  [352] = {.lex_state = 173, .external_lex_state = 6},
  [353] = {.lex_state = 175, .external_lex_state = 16},
  [354] = {.lex_state = 175, .external_lex_state = 16},
  [355] = {.lex_state = 138, .external_lex_state = 4},
  [356] = {.lex_state = 142, .external_lex_state = 8},
  [357] = {.lex_state = 64, .external_lex_state = 2},
  [358] = {.lex_state = 93, .external_lex_state = 4},
  [359] = {.lex_state = 123, .external_lex_state = 8},
  [360] = {.lex_state = 64, .external_lex_state = 2},
  [361] = {.lex_state = 138, .external_lex_state = 4},
  [362] = {.lex_state = 142, .external_lex_state = 8},
  [363] = {.lex_state = 64, .external_lex_state = 2},
  [364] = {.lex_state = 85},
  [365] = {.lex_state = 226},
  [366] = {.lex_state = 127, .external_lex_state = 9},
  [367] = {.lex_state = 81},
  [368] = {.lex_state = 93, .external_lex_state = 14},
  [369] = {.lex_state = 138, .external_lex_state = 14},
  [370] = {.lex_state = 167},
  [371] = {.lex_state = 100},
  [372] = {.lex_state = 138, .external_lex_state = 14},
  [373] = {.lex_state = 138, .external_lex_state = 14},
  [374] = {.lex_state = 138, .external_lex_state = 14},
  [375] = {.lex_state = 70},
  [376] = {.lex_state = 173, .external_lex_state = 6},
  [377] = {.lex_state = 175, .external_lex_state = 16},
  [378] = {.lex_state = 175, .external_lex_state = 16},
  [379] = {.lex_state = 138, .external_lex_state = 4},
  [380] = {.lex_state = 142, .external_lex_state = 8},
  [381] = {.lex_state = 64, .external_lex_state = 2},
  [382] = {.lex_state = 93, .external_lex_state = 4},
  [383] = {.lex_state = 123, .external_lex_state = 8},
  [384] = {.lex_state = 64, .external_lex_state = 2},
  [385] = {.lex_state = 138, .external_lex_state = 4},
  [386] = {.lex_state = 142, .external_lex_state = 8},
  [387] = {.lex_state = 64, .external_lex_state = 2},
  [388] = {.lex_state = 93, .external_lex_state = 3},
  [389] = {.lex_state = 81},
  [390] = {.lex_state = 93, .external_lex_state = 10},
  [391] = {.lex_state = 138, .external_lex_state = 10},
  [392] = {.lex_state = 167},
  [393] = {.lex_state = 100},
  [394] = {.lex_state = 138, .external_lex_state = 10},
  [395] = {.lex_state = 138, .external_lex_state = 10},
  [396] = {.lex_state = 138, .external_lex_state = 10},
  [397] = {.lex_state = 70},
  [398] = {.lex_state = 173, .external_lex_state = 6},
  [399] = {.lex_state = 175, .external_lex_state = 16},
  [400] = {.lex_state = 175, .external_lex_state = 16},
  [401] = {.lex_state = 138, .external_lex_state = 4},
  [402] = {.lex_state = 142, .external_lex_state = 8},
  [403] = {.lex_state = 64, .external_lex_state = 2},
  [404] = {.lex_state = 93, .external_lex_state = 4},
  [405] = {.lex_state = 123, .external_lex_state = 8},
  [406] = {.lex_state = 64, .external_lex_state = 2},
  [407] = {.lex_state = 138, .external_lex_state = 4},
  [408] = {.lex_state = 142, .external_lex_state = 8},
  [409] = {.lex_state = 64, .external_lex_state = 2},
  [410] = {.lex_state = 93, .external_lex_state = 4},
  [411] = {.lex_state = 81},
  [412] = {.lex_state = 81, .external_lex_state = 15},
  [413] = {.lex_state = 81, .external_lex_state = 15},
  [414] = {.lex_state = 167},
  [415] = {.lex_state = 100},
  [416] = {.lex_state = 81, .external_lex_state = 15},
  [417] = {.lex_state = 81, .external_lex_state = 15},
  [418] = {.lex_state = 81, .external_lex_state = 15},
  [419] = {.lex_state = 70},
  [420] = {.lex_state = 173, .external_lex_state = 6},
  [421] = {.lex_state = 175, .external_lex_state = 16},
  [422] = {.lex_state = 175, .external_lex_state = 16},
  [423] = {.lex_state = 138, .external_lex_state = 4},
  [424] = {.lex_state = 142, .external_lex_state = 8},
  [425] = {.lex_state = 64, .external_lex_state = 2},
  [426] = {.lex_state = 93, .external_lex_state = 4},
  [427] = {.lex_state = 123, .external_lex_state = 8},
  [428] = {.lex_state = 64, .external_lex_state = 2},
  [429] = {.lex_state = 138, .external_lex_state = 4},
  [430] = {.lex_state = 142, .external_lex_state = 8},
  [431] = {.lex_state = 64, .external_lex_state = 2},
  [432] = {.lex_state = 125, .external_lex_state = 5},
  [433] = {.lex_state = 97, .external_lex_state = 5},
  [434] = {.lex_state = 125, .external_lex_state = 5},
  [435] = {.lex_state = 100, .external_lex_state = 13},
  [436] = {.lex_state = 100, .external_lex_state = 13},
  [437] = {.lex_state = 100, .external_lex_state = 13},
  [438] = {.lex_state = 100},
  [439] = {.lex_state = 70},
  [440] = {.lex_state = 173, .external_lex_state = 6},
  [441] = {.lex_state = 175, .external_lex_state = 16},
  [442] = {.lex_state = 175, .external_lex_state = 16},
  [443] = {.lex_state = 138, .external_lex_state = 4},
  [444] = {.lex_state = 142, .external_lex_state = 8},
  [445] = {.lex_state = 64, .external_lex_state = 2},
  [446] = {.lex_state = 93, .external_lex_state = 4},
  [447] = {.lex_state = 123, .external_lex_state = 8},
  [448] = {.lex_state = 64, .external_lex_state = 2},
  [449] = {.lex_state = 167},
  [450] = {.lex_state = 100},
  [451] = {.lex_state = 81},
  [452] = {.lex_state = 236, .external_lex_state = 16},
  [453] = {.lex_state = 70},
  [454] = {.lex_state = 175, .external_lex_state = 16},
  [455] = {.lex_state = 175, .external_lex_state = 16},
  [456] = {.lex_state = 125, .external_lex_state = 5},
  [457] = {.lex_state = 238, .external_lex_state = 22},
  [458] = {.lex_state = 100},
  [459] = {.lex_state = 107},
  [460] = {.lex_state = 238, .external_lex_state = 22},
  [461] = {.lex_state = 107, .external_lex_state = 6},
  [462] = {.lex_state = 240},
  [463] = {.lex_state = 64, .external_lex_state = 2},
  [464] = {.lex_state = 64, .external_lex_state = 2},
  [465] = {.lex_state = 64, .external_lex_state = 2},
  [466] = {.lex_state = 238, .external_lex_state = 16},
  [467] = {.lex_state = 125, .external_lex_state = 5},
  [468] = {.lex_state = 240},
  [469] = {.lex_state = 238, .external_lex_state = 16},
  [470] = {.lex_state = 219, .external_lex_state = 2},
  [471] = {.lex_state = 125, .external_lex_state = 5},
  [472] = {.lex_state = 138, .external_lex_state = 4},
  [473] = {.lex_state = 142, .external_lex_state = 8},
  [474] = {.lex_state = 81},
  [475] = {.lex_state = 136},
  [476] = {.lex_state = 150, .external_lex_state = 12},
  [477] = {.lex_state = 164},
  [478] = {.lex_state = 93, .external_lex_state = 3},
  [479] = {.lex_state = 93, .external_lex_state = 4},
  [480] = {.lex_state = 83},
  [481] = {.lex_state = 64, .external_lex_state = 2},
  [482] = {.lex_state = 64, .external_lex_state = 2},
  [483] = {.lex_state = 64, .external_lex_state = 2},
  [484] = {.lex_state = 64},
  [485] = {.lex_state = 81},
  [486] = {.lex_state = 81},
  [487] = {.lex_state = 247, .external_lex_state = 7},
  [488] = {.lex_state = 97, .external_lex_state = 7},
  [489] = {.lex_state = 93, .external_lex_state = 4},
  [490] = {.lex_state = 123, .external_lex_state = 8},
  [491] = {.lex_state = 97, .external_lex_state = 7},
  [492] = {.lex_state = 219, .external_lex_state = 2},
  [493] = {.lex_state = 125, .external_lex_state = 5},
  [494] = {.lex_state = 138, .external_lex_state = 4},
  [495] = {.lex_state = 142, .external_lex_state = 8},
  [496] = {.lex_state = 136},
  [497] = {.lex_state = 144, .external_lex_state = 4},
  [498] = {.lex_state = 142, .external_lex_state = 8},
  [499] = {.lex_state = 121, .external_lex_state = 4},
  [500] = {.lex_state = 123, .external_lex_state = 8},
  [501] = {.lex_state = 144, .external_lex_state = 4},
  [502] = {.lex_state = 107},
  [503] = {.lex_state = 107, .external_lex_state = 6},
  [504] = {.lex_state = 178, .external_lex_state = 17},
  [505] = {.lex_state = 81},
  [506] = {.lex_state = 97, .external_lex_state = 5},
  [507] = {.lex_state = 97, .external_lex_state = 5},
  [508] = {.lex_state = 125, .external_lex_state = 7},
  [509] = {.lex_state = 204, .external_lex_state = 5},
  [510] = {.lex_state = 204, .external_lex_state = 5},
  [511] = {.lex_state = 249, .external_lex_state = 7},
  [512] = {.lex_state = 249, .external_lex_state = 7},
  [513] = {.lex_state = 204, .external_lex_state = 5},
  [514] = {.lex_state = 204, .external_lex_state = 5},
  [515] = {.lex_state = 249, .external_lex_state = 7},
  [516] = {.lex_state = 144, .external_lex_state = 4},
  [517] = {.lex_state = 204, .external_lex_state = 7},
  [518] = {.lex_state = 204, .external_lex_state = 7},
  [519] = {.lex_state = 97, .external_lex_state = 7},
  [520] = {.lex_state = 64, .external_lex_state = 2},
  [521] = {.lex_state = 93, .external_lex_state = 4},
  [522] = {.lex_state = 123, .external_lex_state = 8},
  [523] = {.lex_state = 97, .external_lex_state = 7},
  [524] = {.lex_state = 208, .external_lex_state = 12},
  [525] = {.lex_state = 70, .external_lex_state = 13},
  [526] = {.lex_state = 208, .external_lex_state = 11},
  [527] = {.lex_state = 208, .external_lex_state = 12},
  [528] = {.lex_state = 70, .external_lex_state = 13},
  [529] = {.lex_state = 150, .external_lex_state = 12},
  [530] = {.lex_state = 142, .external_lex_state = 8},
  [531] = {.lex_state = 210, .external_lex_state = 13},
  [532] = {.lex_state = 100},
  [533] = {.lex_state = 107},
  [534] = {.lex_state = 210, .external_lex_state = 13},
  [535] = {.lex_state = 107, .external_lex_state = 6},
  [536] = {.lex_state = 64, .external_lex_state = 2},
  [537] = {.lex_state = 64, .external_lex_state = 2},
  [538] = {.lex_state = 64, .external_lex_state = 2},
  [539] = {.lex_state = 210},
  [540] = {.lex_state = 81},
  [541] = {.lex_state = 123, .external_lex_state = 19},
  [542] = {.lex_state = 142, .external_lex_state = 19},
  [543] = {.lex_state = 167},
  [544] = {.lex_state = 100},
  [545] = {.lex_state = 142, .external_lex_state = 19},
  [546] = {.lex_state = 142, .external_lex_state = 19},
  [547] = {.lex_state = 142, .external_lex_state = 19},
  [548] = {.lex_state = 70},
  [549] = {.lex_state = 173, .external_lex_state = 6},
  [550] = {.lex_state = 175, .external_lex_state = 16},
  [551] = {.lex_state = 175, .external_lex_state = 16},
  [552] = {.lex_state = 138, .external_lex_state = 4},
  [553] = {.lex_state = 142, .external_lex_state = 8},
  [554] = {.lex_state = 64, .external_lex_state = 2},
  [555] = {.lex_state = 93, .external_lex_state = 4},
  [556] = {.lex_state = 123, .external_lex_state = 8},
  [557] = {.lex_state = 64, .external_lex_state = 2},
  [558] = {.lex_state = 138, .external_lex_state = 4},
  [559] = {.lex_state = 142, .external_lex_state = 8},
  [560] = {.lex_state = 64, .external_lex_state = 2},
  [561] = {.lex_state = 85},
  [562] = {.lex_state = 212, .external_lex_state = 4},
  [563] = {.lex_state = 224},
  [564] = {.lex_state = 212, .external_lex_state = 4},
  [565] = {.lex_state = 81},
  [566] = {.lex_state = 212, .external_lex_state = 10},
  [567] = {.lex_state = 251, .external_lex_state = 10},
  [568] = {.lex_state = 167},
  [569] = {.lex_state = 100},
  [570] = {.lex_state = 251, .external_lex_state = 10},
  [571] = {.lex_state = 251, .external_lex_state = 10},
  [572] = {.lex_state = 251, .external_lex_state = 10},
  [573] = {.lex_state = 70},
  [574] = {.lex_state = 173, .external_lex_state = 6},
  [575] = {.lex_state = 175, .external_lex_state = 16},
  [576] = {.lex_state = 175, .external_lex_state = 16},
  [577] = {.lex_state = 138, .external_lex_state = 4},
  [578] = {.lex_state = 142, .external_lex_state = 8},
  [579] = {.lex_state = 64, .external_lex_state = 2},
  [580] = {.lex_state = 93, .external_lex_state = 4},
  [581] = {.lex_state = 123, .external_lex_state = 8},
  [582] = {.lex_state = 64, .external_lex_state = 2},
  [583] = {.lex_state = 138, .external_lex_state = 4},
  [584] = {.lex_state = 142, .external_lex_state = 8},
  [585] = {.lex_state = 64, .external_lex_state = 2},
  [586] = {.lex_state = 129, .external_lex_state = 4},
  [587] = {.lex_state = 85},
  [588] = {.lex_state = 226},
  [589] = {.lex_state = 253, .external_lex_state = 10},
  [590] = {.lex_state = 100},
  [591] = {.lex_state = 107},
  [592] = {.lex_state = 253, .external_lex_state = 10},
  [593] = {.lex_state = 107, .external_lex_state = 6},
  [594] = {.lex_state = 64, .external_lex_state = 2},
  [595] = {.lex_state = 64, .external_lex_state = 2},
  [596] = {.lex_state = 64, .external_lex_state = 2},
  [597] = {.lex_state = 253, .external_lex_state = 4},
  [598] = {.lex_state = 64, .external_lex_state = 2},
  [599] = {.lex_state = 144, .external_lex_state = 4},
  [600] = {.lex_state = 123, .external_lex_state = 19},
  [601] = {.lex_state = 123, .external_lex_state = 19},
  [602] = {.lex_state = 204, .external_lex_state = 7},
  [603] = {.lex_state = 83},
  [604] = {.lex_state = 123, .external_lex_state = 21},
  [605] = {.lex_state = 204, .external_lex_state = 21},
  [606] = {.lex_state = 127, .external_lex_state = 9},
  [607] = {.lex_state = 93, .external_lex_state = 14},
  [608] = {.lex_state = 93, .external_lex_state = 3},
  [609] = {.lex_state = 93, .external_lex_state = 10},
  [610] = {.lex_state = 93, .external_lex_state = 4},
  [611] = {.lex_state = 97, .external_lex_state = 5},
  [612] = {.lex_state = 136},
  [613] = {.lex_state = 249, .external_lex_state = 7},
  [614] = {.lex_state = 64, .external_lex_state = 2},
  [615] = {.lex_state = 144, .external_lex_state = 4},
  [616] = {.lex_state = 204, .external_lex_state = 7},
  [617] = {.lex_state = 93, .external_lex_state = 4},
  [618] = {.lex_state = 123, .external_lex_state = 8},
  [619] = {.lex_state = 81},
  [620] = {.lex_state = 97, .external_lex_state = 5},
  [621] = {.lex_state = 97, .external_lex_state = 5},
  [622] = {.lex_state = 204, .external_lex_state = 5},
  [623] = {.lex_state = 204, .external_lex_state = 5},
  [624] = {.lex_state = 204, .external_lex_state = 5},
  [625] = {.lex_state = 204, .external_lex_state = 5},
  [626] = {.lex_state = 204, .external_lex_state = 7},
  [627] = {.lex_state = 204, .external_lex_state = 7},
  [628] = {.lex_state = 97, .external_lex_state = 7},
  [629] = {.lex_state = 97, .external_lex_state = 7},
  [630] = {.lex_state = 144, .external_lex_state = 4},
  [631] = {.lex_state = 64, .external_lex_state = 2},
  [632] = {.lex_state = 64, .external_lex_state = 2},
  [633] = {.lex_state = 81},
  [634] = {.lex_state = 64, .external_lex_state = 2},
  [635] = {.lex_state = 81},
  [636] = {.lex_state = 132, .external_lex_state = 10},
  [637] = {.lex_state = 255},
  [638] = {.lex_state = 129, .external_lex_state = 4},
  [639] = {.lex_state = 132, .external_lex_state = 10},
  [640] = {.lex_state = 132, .external_lex_state = 10},
  [641] = {.lex_state = 167},
  [642] = {.lex_state = 255},
  [643] = {.lex_state = 129, .external_lex_state = 4},
  [644] = {.lex_state = 236, .external_lex_state = 16},
  [645] = {.lex_state = 70},
  [646] = {.lex_state = 175, .external_lex_state = 16},
  [647] = {.lex_state = 175, .external_lex_state = 16},
  [648] = {.lex_state = 132, .external_lex_state = 10},
  [649] = {.lex_state = 240},
  [650] = {.lex_state = 238, .external_lex_state = 16},
  [651] = {.lex_state = 132, .external_lex_state = 10},
  [652] = {.lex_state = 240},
  [653] = {.lex_state = 238, .external_lex_state = 16},
  [654] = {.lex_state = 219, .external_lex_state = 2},
  [655] = {.lex_state = 132, .external_lex_state = 10},
  [656] = {.lex_state = 138, .external_lex_state = 4},
  [657] = {.lex_state = 142, .external_lex_state = 8},
  [658] = {.lex_state = 64, .external_lex_state = 2},
  [659] = {.lex_state = 93, .external_lex_state = 4},
  [660] = {.lex_state = 123, .external_lex_state = 8},
  [661] = {.lex_state = 219, .external_lex_state = 2},
  [662] = {.lex_state = 132, .external_lex_state = 10},
  [663] = {.lex_state = 138, .external_lex_state = 4},
  [664] = {.lex_state = 142, .external_lex_state = 8},
  [665] = {.lex_state = 136},
  [666] = {.lex_state = 257, .external_lex_state = 21},
  [667] = {.lex_state = 93, .external_lex_state = 4},
  [668] = {.lex_state = 123, .external_lex_state = 8},
  [669] = {.lex_state = 214, .external_lex_state = 20},
  [670] = {.lex_state = 64},
  [671] = {.lex_state = 81},
  [672] = {.lex_state = 144, .external_lex_state = 4},
  [673] = {.lex_state = 142, .external_lex_state = 19},
  [674] = {.lex_state = 142, .external_lex_state = 19},
  [675] = {.lex_state = 222, .external_lex_state = 7},
  [676] = {.lex_state = 83},
  [677] = {.lex_state = 142, .external_lex_state = 21},
  [678] = {.lex_state = 222, .external_lex_state = 21},
  [679] = {.lex_state = 127, .external_lex_state = 9},
  [680] = {.lex_state = 138, .external_lex_state = 14},
  [681] = {.lex_state = 138, .external_lex_state = 3},
  [682] = {.lex_state = 138, .external_lex_state = 10},
  [683] = {.lex_state = 138, .external_lex_state = 4},
  [684] = {.lex_state = 125, .external_lex_state = 5},
  [685] = {.lex_state = 136},
  [686] = {.lex_state = 144, .external_lex_state = 4},
  [687] = {.lex_state = 138, .external_lex_state = 4},
  [688] = {.lex_state = 142, .external_lex_state = 8},
  [689] = {.lex_state = 81},
  [690] = {.lex_state = 125, .external_lex_state = 5},
  [691] = {.lex_state = 125, .external_lex_state = 5},
  [692] = {.lex_state = 222, .external_lex_state = 5},
  [693] = {.lex_state = 222, .external_lex_state = 5},
  [694] = {.lex_state = 222, .external_lex_state = 5},
  [695] = {.lex_state = 222, .external_lex_state = 5},
  [696] = {.lex_state = 222, .external_lex_state = 7},
  [697] = {.lex_state = 222, .external_lex_state = 7},
  [698] = {.lex_state = 125, .external_lex_state = 7},
  [699] = {.lex_state = 219, .external_lex_state = 2},
  [700] = {.lex_state = 125, .external_lex_state = 7},
  [701] = {.lex_state = 81, .external_lex_state = 2},
  [702] = {.lex_state = 210},
  [703] = {.lex_state = 81, .external_lex_state = 15},
  [704] = {.lex_state = 81, .external_lex_state = 15},
  [705] = {.lex_state = 224},
  [706] = {.lex_state = 224, .external_lex_state = 13},
  [707] = {.lex_state = 150, .external_lex_state = 12},
  [708] = {.lex_state = 85},
  [709] = {.lex_state = 226},
  [710] = {.lex_state = 150, .external_lex_state = 11},
  [711] = {.lex_state = 150, .external_lex_state = 11},
  [712] = {.lex_state = 150, .external_lex_state = 11},
  [713] = {.lex_state = 167},
  [714] = {.lex_state = 236, .external_lex_state = 16},
  [715] = {.lex_state = 70},
  [716] = {.lex_state = 175, .external_lex_state = 16},
  [717] = {.lex_state = 175, .external_lex_state = 16},
  [718] = {.lex_state = 150, .external_lex_state = 11},
  [719] = {.lex_state = 240},
  [720] = {.lex_state = 238, .external_lex_state = 16},
  [721] = {.lex_state = 150, .external_lex_state = 11},
  [722] = {.lex_state = 240},
  [723] = {.lex_state = 238, .external_lex_state = 16},
  [724] = {.lex_state = 219, .external_lex_state = 2},
  [725] = {.lex_state = 150, .external_lex_state = 11},
  [726] = {.lex_state = 138, .external_lex_state = 4},
  [727] = {.lex_state = 142, .external_lex_state = 8},
  [728] = {.lex_state = 64, .external_lex_state = 2},
  [729] = {.lex_state = 93, .external_lex_state = 4},
  [730] = {.lex_state = 123, .external_lex_state = 8},
  [731] = {.lex_state = 219, .external_lex_state = 2},
  [732] = {.lex_state = 150, .external_lex_state = 11},
  [733] = {.lex_state = 138, .external_lex_state = 4},
  [734] = {.lex_state = 142, .external_lex_state = 8},
  [735] = {.lex_state = 150, .external_lex_state = 12},
  [736] = {.lex_state = 64},
  [737] = {.lex_state = 81},
  [738] = {.lex_state = 64, .external_lex_state = 18},
  [739] = {.lex_state = 81},
  [740] = {.lex_state = 204, .external_lex_state = 21},
  [741] = {.lex_state = 150, .external_lex_state = 12},
  [742] = {.lex_state = 259},
  [743] = {.lex_state = 233, .external_lex_state = 13},
  [744] = {.lex_state = 164, .external_lex_state = 13},
  [745] = {.lex_state = 233, .external_lex_state = 13},
  [746] = {.lex_state = 167},
  [747] = {.lex_state = 236, .external_lex_state = 16},
  [748] = {.lex_state = 70},
  [749] = {.lex_state = 175, .external_lex_state = 16},
  [750] = {.lex_state = 175, .external_lex_state = 16},
  [751] = {.lex_state = 233, .external_lex_state = 13},
  [752] = {.lex_state = 240},
  [753] = {.lex_state = 238, .external_lex_state = 16},
  [754] = {.lex_state = 233, .external_lex_state = 13},
  [755] = {.lex_state = 240},
  [756] = {.lex_state = 238, .external_lex_state = 16},
  [757] = {.lex_state = 219, .external_lex_state = 2},
  [758] = {.lex_state = 233, .external_lex_state = 13},
  [759] = {.lex_state = 138, .external_lex_state = 4},
  [760] = {.lex_state = 142, .external_lex_state = 8},
  [761] = {.lex_state = 64, .external_lex_state = 2},
  [762] = {.lex_state = 93, .external_lex_state = 4},
  [763] = {.lex_state = 123, .external_lex_state = 8},
  [764] = {.lex_state = 219, .external_lex_state = 2},
  [765] = {.lex_state = 233, .external_lex_state = 13},
  [766] = {.lex_state = 138, .external_lex_state = 4},
  [767] = {.lex_state = 142, .external_lex_state = 8},
  [768] = {.lex_state = 259},
  [769] = {.lex_state = 259},
  [770] = {.lex_state = 138, .external_lex_state = 3},
  [771] = {.lex_state = 210},
  [772] = {.lex_state = 93, .external_lex_state = 14},
  [773] = {.lex_state = 93, .external_lex_state = 14},
  [774] = {.lex_state = 138, .external_lex_state = 14},
  [775] = {.lex_state = 93, .external_lex_state = 14},
  [776] = {.lex_state = 138, .external_lex_state = 14},
  [777] = {.lex_state = 167},
  [778] = {.lex_state = 236, .external_lex_state = 16},
  [779] = {.lex_state = 70},
  [780] = {.lex_state = 175, .external_lex_state = 16},
  [781] = {.lex_state = 175, .external_lex_state = 16},
  [782] = {.lex_state = 138, .external_lex_state = 14},
  [783] = {.lex_state = 240},
  [784] = {.lex_state = 238, .external_lex_state = 16},
  [785] = {.lex_state = 138, .external_lex_state = 14},
  [786] = {.lex_state = 240},
  [787] = {.lex_state = 238, .external_lex_state = 16},
  [788] = {.lex_state = 219, .external_lex_state = 2},
  [789] = {.lex_state = 138, .external_lex_state = 14},
  [790] = {.lex_state = 138, .external_lex_state = 4},
  [791] = {.lex_state = 142, .external_lex_state = 8},
  [792] = {.lex_state = 64, .external_lex_state = 2},
  [793] = {.lex_state = 93, .external_lex_state = 4},
  [794] = {.lex_state = 123, .external_lex_state = 8},
  [795] = {.lex_state = 219, .external_lex_state = 2},
  [796] = {.lex_state = 138, .external_lex_state = 14},
  [797] = {.lex_state = 138, .external_lex_state = 4},
  [798] = {.lex_state = 142, .external_lex_state = 8},
  [799] = {.lex_state = 138, .external_lex_state = 10},
  [800] = {.lex_state = 93, .external_lex_state = 10},
  [801] = {.lex_state = 138, .external_lex_state = 10},
  [802] = {.lex_state = 167},
  [803] = {.lex_state = 236, .external_lex_state = 16},
  [804] = {.lex_state = 70},
  [805] = {.lex_state = 175, .external_lex_state = 16},
  [806] = {.lex_state = 175, .external_lex_state = 16},
  [807] = {.lex_state = 138, .external_lex_state = 10},
  [808] = {.lex_state = 240},
  [809] = {.lex_state = 238, .external_lex_state = 16},
  [810] = {.lex_state = 138, .external_lex_state = 10},
  [811] = {.lex_state = 240},
  [812] = {.lex_state = 238, .external_lex_state = 16},
  [813] = {.lex_state = 219, .external_lex_state = 2},
  [814] = {.lex_state = 138, .external_lex_state = 10},
  [815] = {.lex_state = 138, .external_lex_state = 4},
  [816] = {.lex_state = 142, .external_lex_state = 8},
  [817] = {.lex_state = 64, .external_lex_state = 2},
  [818] = {.lex_state = 93, .external_lex_state = 4},
  [819] = {.lex_state = 123, .external_lex_state = 8},
  [820] = {.lex_state = 219, .external_lex_state = 2},
  [821] = {.lex_state = 138, .external_lex_state = 10},
  [822] = {.lex_state = 138, .external_lex_state = 4},
  [823] = {.lex_state = 142, .external_lex_state = 8},
  [824] = {.lex_state = 81, .external_lex_state = 15},
  [825] = {.lex_state = 81, .external_lex_state = 15},
  [826] = {.lex_state = 81, .external_lex_state = 15},
  [827] = {.lex_state = 167},
  [828] = {.lex_state = 236, .external_lex_state = 16},
  [829] = {.lex_state = 70},
  [830] = {.lex_state = 175, .external_lex_state = 16},
  [831] = {.lex_state = 175, .external_lex_state = 16},
  [832] = {.lex_state = 81, .external_lex_state = 15},
  [833] = {.lex_state = 240},
  [834] = {.lex_state = 238, .external_lex_state = 16},
  [835] = {.lex_state = 81, .external_lex_state = 15},
  [836] = {.lex_state = 240},
  [837] = {.lex_state = 238, .external_lex_state = 16},
  [838] = {.lex_state = 219, .external_lex_state = 2},
  [839] = {.lex_state = 81, .external_lex_state = 15},
  [840] = {.lex_state = 138, .external_lex_state = 4},
  [841] = {.lex_state = 142, .external_lex_state = 8},
  [842] = {.lex_state = 64, .external_lex_state = 2},
  [843] = {.lex_state = 93, .external_lex_state = 4},
  [844] = {.lex_state = 123, .external_lex_state = 8},
  [845] = {.lex_state = 219, .external_lex_state = 2},
  [846] = {.lex_state = 81, .external_lex_state = 15},
  [847] = {.lex_state = 138, .external_lex_state = 4},
  [848] = {.lex_state = 142, .external_lex_state = 8},
  [849] = {.lex_state = 100},
  [850] = {.lex_state = 236, .external_lex_state = 16},
  [851] = {.lex_state = 70},
  [852] = {.lex_state = 175, .external_lex_state = 16},
  [853] = {.lex_state = 175, .external_lex_state = 16},
  [854] = {.lex_state = 100, .external_lex_state = 13},
  [855] = {.lex_state = 240},
  [856] = {.lex_state = 238, .external_lex_state = 16},
  [857] = {.lex_state = 100, .external_lex_state = 13},
  [858] = {.lex_state = 240},
  [859] = {.lex_state = 238, .external_lex_state = 16},
  [860] = {.lex_state = 219, .external_lex_state = 2},
  [861] = {.lex_state = 100, .external_lex_state = 13},
  [862] = {.lex_state = 138, .external_lex_state = 4},
  [863] = {.lex_state = 142, .external_lex_state = 8},
  [864] = {.lex_state = 64, .external_lex_state = 2},
  [865] = {.lex_state = 93, .external_lex_state = 4},
  [866] = {.lex_state = 123, .external_lex_state = 8},
  [867] = {.lex_state = 125, .external_lex_state = 5},
  [868] = {.lex_state = 167},
  [869] = {.lex_state = 208, .external_lex_state = 11},
  [870] = {.lex_state = 208, .external_lex_state = 11},
  [871] = {.lex_state = 208, .external_lex_state = 11},
  [872] = {.lex_state = 125, .external_lex_state = 5},
  [873] = {.lex_state = 214, .external_lex_state = 22},
  [874] = {.lex_state = 100},
  [875] = {.lex_state = 107},
  [876] = {.lex_state = 214, .external_lex_state = 22},
  [877] = {.lex_state = 107, .external_lex_state = 6},
  [878] = {.lex_state = 64, .external_lex_state = 2},
  [879] = {.lex_state = 64, .external_lex_state = 2},
  [880] = {.lex_state = 64, .external_lex_state = 2},
  [881] = {.lex_state = 214, .external_lex_state = 16},
  [882] = {.lex_state = 236, .external_lex_state = 16},
  [883] = {.lex_state = 125, .external_lex_state = 5},
  [884] = {.lex_state = 240},
  [885] = {.lex_state = 238, .external_lex_state = 16},
  [886] = {.lex_state = 240},
  [887] = {.lex_state = 238, .external_lex_state = 16},
  [888] = {.lex_state = 81},
  [889] = {.lex_state = 238, .external_lex_state = 22},
  [890] = {.lex_state = 238, .external_lex_state = 22},
  [891] = {.lex_state = 167},
  [892] = {.lex_state = 100},
  [893] = {.lex_state = 238, .external_lex_state = 22},
  [894] = {.lex_state = 238, .external_lex_state = 22},
  [895] = {.lex_state = 238, .external_lex_state = 22},
  [896] = {.lex_state = 70},
  [897] = {.lex_state = 173, .external_lex_state = 6},
  [898] = {.lex_state = 175, .external_lex_state = 16},
  [899] = {.lex_state = 175, .external_lex_state = 16},
  [900] = {.lex_state = 238, .external_lex_state = 16},
  [901] = {.lex_state = 138, .external_lex_state = 4},
  [902] = {.lex_state = 142, .external_lex_state = 8},
  [903] = {.lex_state = 64, .external_lex_state = 2},
  [904] = {.lex_state = 93, .external_lex_state = 4},
  [905] = {.lex_state = 123, .external_lex_state = 8},
  [906] = {.lex_state = 64, .external_lex_state = 2},
  [907] = {.lex_state = 138, .external_lex_state = 4},
  [908] = {.lex_state = 142, .external_lex_state = 8},
  [909] = {.lex_state = 64, .external_lex_state = 2},
  [910] = {.lex_state = 125, .external_lex_state = 5},
  [911] = {.lex_state = 238, .external_lex_state = 16},
  [912] = {.lex_state = 238, .external_lex_state = 16},
  [913] = {.lex_state = 125, .external_lex_state = 5},
  [914] = {.lex_state = 219, .external_lex_state = 2},
  [915] = {.lex_state = 247, .external_lex_state = 7},
  [916] = {.lex_state = 83},
  [917] = {.lex_state = 123, .external_lex_state = 21},
  [918] = {.lex_state = 247, .external_lex_state = 21},
  [919] = {.lex_state = 136},
  [920] = {.lex_state = 123, .external_lex_state = 8},
  [921] = {.lex_state = 93, .external_lex_state = 4},
  [922] = {.lex_state = 123, .external_lex_state = 8},
  [923] = {.lex_state = 81},
  [924] = {.lex_state = 247, .external_lex_state = 5},
  [925] = {.lex_state = 247, .external_lex_state = 5},
  [926] = {.lex_state = 247, .external_lex_state = 5},
  [927] = {.lex_state = 247, .external_lex_state = 5},
  [928] = {.lex_state = 247, .external_lex_state = 7},
  [929] = {.lex_state = 247, .external_lex_state = 7},
  [930] = {.lex_state = 64, .external_lex_state = 2},
  [931] = {.lex_state = 97, .external_lex_state = 7},
  [932] = {.lex_state = 125, .external_lex_state = 5},
  [933] = {.lex_state = 219, .external_lex_state = 2},
  [934] = {.lex_state = 216, .external_lex_state = 21},
  [935] = {.lex_state = 178, .external_lex_state = 17},
  [936] = {.lex_state = 178, .external_lex_state = 17},
  [937] = {.lex_state = 70},
  [938] = {.lex_state = 173, .external_lex_state = 6},
  [939] = {.lex_state = 175, .external_lex_state = 16},
  [940] = {.lex_state = 175, .external_lex_state = 16},
  [941] = {.lex_state = 144, .external_lex_state = 4},
  [942] = {.lex_state = 178, .external_lex_state = 17},
  [943] = {.lex_state = 204, .external_lex_state = 5},
  [944] = {.lex_state = 204, .external_lex_state = 5},
  [945] = {.lex_state = 249, .external_lex_state = 7},
  [946] = {.lex_state = 204, .external_lex_state = 5},
  [947] = {.lex_state = 144, .external_lex_state = 4},
  [948] = {.lex_state = 219, .external_lex_state = 2},
  [949] = {.lex_state = 204, .external_lex_state = 7},
  [950] = {.lex_state = 70, .external_lex_state = 13},
  [951] = {.lex_state = 70},
  [952] = {.lex_state = 208, .external_lex_state = 11},
  [953] = {.lex_state = 70, .external_lex_state = 13},
  [954] = {.lex_state = 70},
  [955] = {.lex_state = 81},
  [956] = {.lex_state = 210, .external_lex_state = 13},
  [957] = {.lex_state = 210, .external_lex_state = 13},
  [958] = {.lex_state = 167},
  [959] = {.lex_state = 100},
  [960] = {.lex_state = 210, .external_lex_state = 13},
  [961] = {.lex_state = 210, .external_lex_state = 13},
  [962] = {.lex_state = 210, .external_lex_state = 13},
  [963] = {.lex_state = 70},
  [964] = {.lex_state = 173, .external_lex_state = 6},
  [965] = {.lex_state = 175, .external_lex_state = 16},
  [966] = {.lex_state = 175, .external_lex_state = 16},
  [967] = {.lex_state = 138, .external_lex_state = 4},
  [968] = {.lex_state = 142, .external_lex_state = 8},
  [969] = {.lex_state = 64, .external_lex_state = 2},
  [970] = {.lex_state = 93, .external_lex_state = 4},
  [971] = {.lex_state = 123, .external_lex_state = 8},
  [972] = {.lex_state = 64, .external_lex_state = 2},
  [973] = {.lex_state = 138, .external_lex_state = 4},
  [974] = {.lex_state = 142, .external_lex_state = 8},
  [975] = {.lex_state = 64, .external_lex_state = 2},
  [976] = {.lex_state = 142, .external_lex_state = 8},
  [977] = {.lex_state = 210},
  [978] = {.lex_state = 142, .external_lex_state = 19},
  [979] = {.lex_state = 123, .external_lex_state = 19},
  [980] = {.lex_state = 142, .external_lex_state = 19},
  [981] = {.lex_state = 167},
  [982] = {.lex_state = 236, .external_lex_state = 16},
  [983] = {.lex_state = 70},
  [984] = {.lex_state = 175, .external_lex_state = 16},
  [985] = {.lex_state = 175, .external_lex_state = 16},
  [986] = {.lex_state = 142, .external_lex_state = 19},
  [987] = {.lex_state = 240},
  [988] = {.lex_state = 238, .external_lex_state = 16},
  [989] = {.lex_state = 142, .external_lex_state = 19},
  [990] = {.lex_state = 240},
  [991] = {.lex_state = 238, .external_lex_state = 16},
  [992] = {.lex_state = 219, .external_lex_state = 2},
  [993] = {.lex_state = 142, .external_lex_state = 19},
  [994] = {.lex_state = 138, .external_lex_state = 4},
  [995] = {.lex_state = 142, .external_lex_state = 8},
  [996] = {.lex_state = 64, .external_lex_state = 2},
  [997] = {.lex_state = 93, .external_lex_state = 4},
  [998] = {.lex_state = 123, .external_lex_state = 8},
  [999] = {.lex_state = 219, .external_lex_state = 2},
  [1000] = {.lex_state = 142, .external_lex_state = 19},
  [1001] = {.lex_state = 138, .external_lex_state = 4},
  [1002] = {.lex_state = 142, .external_lex_state = 8},
  [1003] = {.lex_state = 261},
  [1004] = {.lex_state = 85},
  [1005] = {.lex_state = 85},
  [1006] = {.lex_state = 264, .external_lex_state = 13},
  [1007] = {.lex_state = 100},
  [1008] = {.lex_state = 107},
  [1009] = {.lex_state = 264, .external_lex_state = 13},
  [1010] = {.lex_state = 107, .external_lex_state = 6},
  [1011] = {.lex_state = 64, .external_lex_state = 2},
  [1012] = {.lex_state = 64, .external_lex_state = 2},
  [1013] = {.lex_state = 64, .external_lex_state = 2},
  [1014] = {.lex_state = 264},
  [1015] = {.lex_state = 85},
  [1016] = {.lex_state = 212, .external_lex_state = 4},
  [1017] = {.lex_state = 251, .external_lex_state = 10},
  [1018] = {.lex_state = 212, .external_lex_state = 10},
  [1019] = {.lex_state = 251, .external_lex_state = 10},
  [1020] = {.lex_state = 167},
  [1021] = {.lex_state = 236, .external_lex_state = 16},
  [1022] = {.lex_state = 70},
  [1023] = {.lex_state = 175, .external_lex_state = 16},
  [1024] = {.lex_state = 175, .external_lex_state = 16},
  [1025] = {.lex_state = 251, .external_lex_state = 10},
  [1026] = {.lex_state = 240},
  [1027] = {.lex_state = 238, .external_lex_state = 16},
  [1028] = {.lex_state = 251, .external_lex_state = 10},
  [1029] = {.lex_state = 240},
  [1030] = {.lex_state = 238, .external_lex_state = 16},
  [1031] = {.lex_state = 219, .external_lex_state = 2},
  [1032] = {.lex_state = 251, .external_lex_state = 10},
  [1033] = {.lex_state = 138, .external_lex_state = 4},
  [1034] = {.lex_state = 142, .external_lex_state = 8},
  [1035] = {.lex_state = 64, .external_lex_state = 2},
  [1036] = {.lex_state = 93, .external_lex_state = 4},
  [1037] = {.lex_state = 123, .external_lex_state = 8},
  [1038] = {.lex_state = 219, .external_lex_state = 2},
  [1039] = {.lex_state = 251, .external_lex_state = 10},
  [1040] = {.lex_state = 138, .external_lex_state = 4},
  [1041] = {.lex_state = 142, .external_lex_state = 8},
  [1042] = {.lex_state = 212, .external_lex_state = 4},
  [1043] = {.lex_state = 212, .external_lex_state = 4},
  [1044] = {.lex_state = 212, .external_lex_state = 4},
  [1045] = {.lex_state = 81},
  [1046] = {.lex_state = 253, .external_lex_state = 10},
  [1047] = {.lex_state = 253, .external_lex_state = 10},
  [1048] = {.lex_state = 167},
  [1049] = {.lex_state = 100},
  [1050] = {.lex_state = 253, .external_lex_state = 10},
  [1051] = {.lex_state = 253, .external_lex_state = 10},
  [1052] = {.lex_state = 253, .external_lex_state = 10},
  [1053] = {.lex_state = 70},
  [1054] = {.lex_state = 173, .external_lex_state = 6},
  [1055] = {.lex_state = 175, .external_lex_state = 16},
  [1056] = {.lex_state = 175, .external_lex_state = 16},
  [1057] = {.lex_state = 138, .external_lex_state = 4},
  [1058] = {.lex_state = 142, .external_lex_state = 8},
  [1059] = {.lex_state = 64, .external_lex_state = 2},
  [1060] = {.lex_state = 93, .external_lex_state = 4},
  [1061] = {.lex_state = 123, .external_lex_state = 8},
  [1062] = {.lex_state = 64, .external_lex_state = 2},
  [1063] = {.lex_state = 138, .external_lex_state = 4},
  [1064] = {.lex_state = 142, .external_lex_state = 8},
  [1065] = {.lex_state = 64, .external_lex_state = 2},
  [1066] = {.lex_state = 81},
  [1067] = {.lex_state = 253, .external_lex_state = 4},
  [1068] = {.lex_state = 144, .external_lex_state = 4},
  [1069] = {.lex_state = 64, .external_lex_state = 2},
  [1070] = {.lex_state = 123, .external_lex_state = 19},
  [1071] = {.lex_state = 204, .external_lex_state = 7},
  [1072] = {.lex_state = 136},
  [1073] = {.lex_state = 64},
  [1074] = {.lex_state = 81},
  [1075] = {.lex_state = 64},
  [1076] = {.lex_state = 81},
  [1077] = {.lex_state = 81},
  [1078] = {.lex_state = 204, .external_lex_state = 21},
  [1079] = {.lex_state = 93, .external_lex_state = 14},
  [1080] = {.lex_state = 93, .external_lex_state = 14},
  [1081] = {.lex_state = 93, .external_lex_state = 14},
  [1082] = {.lex_state = 93, .external_lex_state = 10},
  [1083] = {.lex_state = 123, .external_lex_state = 21},
  [1084] = {.lex_state = 249, .external_lex_state = 7},
  [1085] = {.lex_state = 64, .external_lex_state = 2},
  [1086] = {.lex_state = 144, .external_lex_state = 4},
  [1087] = {.lex_state = 204, .external_lex_state = 5},
  [1088] = {.lex_state = 204, .external_lex_state = 5},
  [1089] = {.lex_state = 204, .external_lex_state = 5},
  [1090] = {.lex_state = 204, .external_lex_state = 7},
  [1091] = {.lex_state = 81},
  [1092] = {.lex_state = 64, .external_lex_state = 2},
  [1093] = {.lex_state = 144, .external_lex_state = 4},
  [1094] = {.lex_state = 81},
  [1095] = {.lex_state = 64, .external_lex_state = 2},
  [1096] = {.lex_state = 81},
  [1097] = {.lex_state = 81},
  [1098] = {.lex_state = 144, .external_lex_state = 4},
  [1099] = {.lex_state = 266, .external_lex_state = 13},
  [1100] = {.lex_state = 266, .external_lex_state = 13},
  [1101] = {.lex_state = 269},
  [1102] = {.lex_state = 266},
  [1103] = {.lex_state = 81},
  [1104] = {.lex_state = 255},
  [1105] = {.lex_state = 132, .external_lex_state = 10},
  [1106] = {.lex_state = 144, .external_lex_state = 4},
  [1107] = {.lex_state = 269},
  [1108] = {.lex_state = 81},
  [1109] = {.lex_state = 255},
  [1110] = {.lex_state = 132, .external_lex_state = 10},
  [1111] = {.lex_state = 214, .external_lex_state = 22},
  [1112] = {.lex_state = 214, .external_lex_state = 22},
  [1113] = {.lex_state = 214, .external_lex_state = 16},
  [1114] = {.lex_state = 236, .external_lex_state = 16},
  [1115] = {.lex_state = 132, .external_lex_state = 10},
  [1116] = {.lex_state = 240},
  [1117] = {.lex_state = 238, .external_lex_state = 16},
  [1118] = {.lex_state = 240},
  [1119] = {.lex_state = 238, .external_lex_state = 16},
  [1120] = {.lex_state = 238, .external_lex_state = 16},
  [1121] = {.lex_state = 132, .external_lex_state = 10},
  [1122] = {.lex_state = 238, .external_lex_state = 16},
  [1123] = {.lex_state = 132, .external_lex_state = 10},
  [1124] = {.lex_state = 219, .external_lex_state = 2},
  [1125] = {.lex_state = 64, .external_lex_state = 2},
  [1126] = {.lex_state = 132, .external_lex_state = 10},
  [1127] = {.lex_state = 219, .external_lex_state = 2},
  [1128] = {.lex_state = 216, .external_lex_state = 21},
  [1129] = {.lex_state = 214, .external_lex_state = 20},
  [1130] = {.lex_state = 257, .external_lex_state = 21},
  [1131] = {.lex_state = 214, .external_lex_state = 20},
  [1132] = {.lex_state = 81},
  [1133] = {.lex_state = 121, .external_lex_state = 10},
  [1134] = {.lex_state = 121, .external_lex_state = 10},
  [1135] = {.lex_state = 144, .external_lex_state = 4},
  [1136] = {.lex_state = 142, .external_lex_state = 19},
  [1137] = {.lex_state = 222, .external_lex_state = 7},
  [1138] = {.lex_state = 136},
  [1139] = {.lex_state = 64},
  [1140] = {.lex_state = 81},
  [1141] = {.lex_state = 64},
  [1142] = {.lex_state = 81},
  [1143] = {.lex_state = 81},
  [1144] = {.lex_state = 222, .external_lex_state = 21},
  [1145] = {.lex_state = 138, .external_lex_state = 14},
  [1146] = {.lex_state = 138, .external_lex_state = 14},
  [1147] = {.lex_state = 138, .external_lex_state = 14},
  [1148] = {.lex_state = 138, .external_lex_state = 10},
  [1149] = {.lex_state = 142, .external_lex_state = 21},
  [1150] = {.lex_state = 222, .external_lex_state = 5},
  [1151] = {.lex_state = 222, .external_lex_state = 5},
  [1152] = {.lex_state = 222, .external_lex_state = 5},
  [1153] = {.lex_state = 144, .external_lex_state = 4},
  [1154] = {.lex_state = 222, .external_lex_state = 7},
  [1155] = {.lex_state = 81, .external_lex_state = 2},
  [1156] = {.lex_state = 210},
  [1157] = {.lex_state = 224, .external_lex_state = 13},
  [1158] = {.lex_state = 150, .external_lex_state = 11},
  [1159] = {.lex_state = 150, .external_lex_state = 11},
  [1160] = {.lex_state = 214, .external_lex_state = 22},
  [1161] = {.lex_state = 214, .external_lex_state = 22},
  [1162] = {.lex_state = 214, .external_lex_state = 16},
  [1163] = {.lex_state = 236, .external_lex_state = 16},
  [1164] = {.lex_state = 150, .external_lex_state = 11},
  [1165] = {.lex_state = 240},
  [1166] = {.lex_state = 238, .external_lex_state = 16},
  [1167] = {.lex_state = 240},
  [1168] = {.lex_state = 238, .external_lex_state = 16},
  [1169] = {.lex_state = 238, .external_lex_state = 16},
  [1170] = {.lex_state = 150, .external_lex_state = 11},
  [1171] = {.lex_state = 238, .external_lex_state = 16},
  [1172] = {.lex_state = 150, .external_lex_state = 11},
  [1173] = {.lex_state = 219, .external_lex_state = 2},
  [1174] = {.lex_state = 64, .external_lex_state = 2},
  [1175] = {.lex_state = 150, .external_lex_state = 11},
  [1176] = {.lex_state = 219, .external_lex_state = 2},
  [1177] = {.lex_state = 81},
  [1178] = {.lex_state = 204, .external_lex_state = 23},
  [1179] = {.lex_state = 100},
  [1180] = {.lex_state = 107},
  [1181] = {.lex_state = 204, .external_lex_state = 23},
  [1182] = {.lex_state = 107, .external_lex_state = 6},
  [1183] = {.lex_state = 64, .external_lex_state = 2},
  [1184] = {.lex_state = 64, .external_lex_state = 2},
  [1185] = {.lex_state = 64, .external_lex_state = 2},
  [1186] = {.lex_state = 249, .external_lex_state = 21},
  [1187] = {.lex_state = 249, .external_lex_state = 21},
  [1188] = {.lex_state = 204, .external_lex_state = 23},
  [1189] = {.lex_state = 204, .external_lex_state = 23},
  [1190] = {.lex_state = 249, .external_lex_state = 21},
  [1191] = {.lex_state = 204, .external_lex_state = 21},
  [1192] = {.lex_state = 233, .external_lex_state = 13},
  [1193] = {.lex_state = 233, .external_lex_state = 13},
  [1194] = {.lex_state = 214, .external_lex_state = 22},
  [1195] = {.lex_state = 214, .external_lex_state = 22},
  [1196] = {.lex_state = 214, .external_lex_state = 16},
  [1197] = {.lex_state = 236, .external_lex_state = 16},
  [1198] = {.lex_state = 233, .external_lex_state = 13},
  [1199] = {.lex_state = 240},
  [1200] = {.lex_state = 238, .external_lex_state = 16},
  [1201] = {.lex_state = 240},
  [1202] = {.lex_state = 238, .external_lex_state = 16},
  [1203] = {.lex_state = 238, .external_lex_state = 16},
  [1204] = {.lex_state = 233, .external_lex_state = 13},
  [1205] = {.lex_state = 238, .external_lex_state = 16},
  [1206] = {.lex_state = 233, .external_lex_state = 13},
  [1207] = {.lex_state = 219, .external_lex_state = 2},
  [1208] = {.lex_state = 64, .external_lex_state = 2},
  [1209] = {.lex_state = 233, .external_lex_state = 13},
  [1210] = {.lex_state = 219, .external_lex_state = 2},
  [1211] = {.lex_state = 138, .external_lex_state = 3},
  [1212] = {.lex_state = 210},
  [1213] = {.lex_state = 138, .external_lex_state = 14},
  [1214] = {.lex_state = 138, .external_lex_state = 14},
  [1215] = {.lex_state = 214, .external_lex_state = 22},
  [1216] = {.lex_state = 214, .external_lex_state = 22},
  [1217] = {.lex_state = 214, .external_lex_state = 16},
  [1218] = {.lex_state = 236, .external_lex_state = 16},
  [1219] = {.lex_state = 138, .external_lex_state = 14},
  [1220] = {.lex_state = 240},
  [1221] = {.lex_state = 238, .external_lex_state = 16},
  [1222] = {.lex_state = 240},
  [1223] = {.lex_state = 238, .external_lex_state = 16},
  [1224] = {.lex_state = 238, .external_lex_state = 16},
  [1225] = {.lex_state = 138, .external_lex_state = 14},
  [1226] = {.lex_state = 238, .external_lex_state = 16},
  [1227] = {.lex_state = 138, .external_lex_state = 14},
  [1228] = {.lex_state = 219, .external_lex_state = 2},
  [1229] = {.lex_state = 64, .external_lex_state = 2},
  [1230] = {.lex_state = 138, .external_lex_state = 14},
  [1231] = {.lex_state = 219, .external_lex_state = 2},
  [1232] = {.lex_state = 138, .external_lex_state = 10},
  [1233] = {.lex_state = 138, .external_lex_state = 10},
  [1234] = {.lex_state = 214, .external_lex_state = 22},
  [1235] = {.lex_state = 214, .external_lex_state = 22},
  [1236] = {.lex_state = 214, .external_lex_state = 16},
  [1237] = {.lex_state = 236, .external_lex_state = 16},
  [1238] = {.lex_state = 138, .external_lex_state = 10},
  [1239] = {.lex_state = 240},
  [1240] = {.lex_state = 238, .external_lex_state = 16},
  [1241] = {.lex_state = 240},
  [1242] = {.lex_state = 238, .external_lex_state = 16},
  [1243] = {.lex_state = 238, .external_lex_state = 16},
  [1244] = {.lex_state = 138, .external_lex_state = 10},
  [1245] = {.lex_state = 238, .external_lex_state = 16},
  [1246] = {.lex_state = 138, .external_lex_state = 10},
  [1247] = {.lex_state = 219, .external_lex_state = 2},
  [1248] = {.lex_state = 64, .external_lex_state = 2},
  [1249] = {.lex_state = 138, .external_lex_state = 10},
  [1250] = {.lex_state = 219, .external_lex_state = 2},
  [1251] = {.lex_state = 81, .external_lex_state = 15},
  [1252] = {.lex_state = 81, .external_lex_state = 15},
  [1253] = {.lex_state = 214, .external_lex_state = 22},
  [1254] = {.lex_state = 214, .external_lex_state = 22},
  [1255] = {.lex_state = 214, .external_lex_state = 16},
  [1256] = {.lex_state = 236, .external_lex_state = 16},
  [1257] = {.lex_state = 81, .external_lex_state = 15},
  [1258] = {.lex_state = 240},
  [1259] = {.lex_state = 238, .external_lex_state = 16},
  [1260] = {.lex_state = 240},
  [1261] = {.lex_state = 238, .external_lex_state = 16},
  [1262] = {.lex_state = 238, .external_lex_state = 16},
  [1263] = {.lex_state = 81, .external_lex_state = 15},
  [1264] = {.lex_state = 238, .external_lex_state = 16},
  [1265] = {.lex_state = 81, .external_lex_state = 15},
  [1266] = {.lex_state = 219, .external_lex_state = 2},
  [1267] = {.lex_state = 64, .external_lex_state = 2},
  [1268] = {.lex_state = 81, .external_lex_state = 15},
  [1269] = {.lex_state = 219, .external_lex_state = 2},
  [1270] = {.lex_state = 100, .external_lex_state = 13},
  [1271] = {.lex_state = 214, .external_lex_state = 22},
  [1272] = {.lex_state = 214, .external_lex_state = 22},
  [1273] = {.lex_state = 214, .external_lex_state = 16},
  [1274] = {.lex_state = 236, .external_lex_state = 16},
  [1275] = {.lex_state = 100, .external_lex_state = 13},
  [1276] = {.lex_state = 240},
  [1277] = {.lex_state = 238, .external_lex_state = 16},
  [1278] = {.lex_state = 240},
  [1279] = {.lex_state = 238, .external_lex_state = 16},
  [1280] = {.lex_state = 238, .external_lex_state = 16},
  [1281] = {.lex_state = 100, .external_lex_state = 13},
  [1282] = {.lex_state = 238, .external_lex_state = 16},
  [1283] = {.lex_state = 100, .external_lex_state = 13},
  [1284] = {.lex_state = 219, .external_lex_state = 2},
  [1285] = {.lex_state = 64, .external_lex_state = 2},
  [1286] = {.lex_state = 208, .external_lex_state = 12},
  [1287] = {.lex_state = 175, .external_lex_state = 22},
  [1288] = {.lex_state = 208, .external_lex_state = 12},
  [1289] = {.lex_state = 175, .external_lex_state = 22},
  [1290] = {.lex_state = 150, .external_lex_state = 12},
  [1291] = {.lex_state = 81},
  [1292] = {.lex_state = 125, .external_lex_state = 5},
  [1293] = {.lex_state = 214, .external_lex_state = 22},
  [1294] = {.lex_state = 214, .external_lex_state = 22},
  [1295] = {.lex_state = 167},
  [1296] = {.lex_state = 100},
  [1297] = {.lex_state = 214, .external_lex_state = 22},
  [1298] = {.lex_state = 214, .external_lex_state = 22},
  [1299] = {.lex_state = 214, .external_lex_state = 22},
  [1300] = {.lex_state = 125, .external_lex_state = 5},
  [1301] = {.lex_state = 70},
  [1302] = {.lex_state = 173, .external_lex_state = 6},
  [1303] = {.lex_state = 175, .external_lex_state = 16},
  [1304] = {.lex_state = 175, .external_lex_state = 16},
  [1305] = {.lex_state = 138, .external_lex_state = 4},
  [1306] = {.lex_state = 142, .external_lex_state = 8},
  [1307] = {.lex_state = 64, .external_lex_state = 2},
  [1308] = {.lex_state = 93, .external_lex_state = 4},
  [1309] = {.lex_state = 123, .external_lex_state = 8},
  [1310] = {.lex_state = 64, .external_lex_state = 2},
  [1311] = {.lex_state = 138, .external_lex_state = 4},
  [1312] = {.lex_state = 142, .external_lex_state = 8},
  [1313] = {.lex_state = 64, .external_lex_state = 2},
  [1314] = {.lex_state = 214, .external_lex_state = 22},
  [1315] = {.lex_state = 214, .external_lex_state = 22},
  [1316] = {.lex_state = 214, .external_lex_state = 16},
  [1317] = {.lex_state = 238, .external_lex_state = 16},
  [1318] = {.lex_state = 125, .external_lex_state = 5},
  [1319] = {.lex_state = 238, .external_lex_state = 16},
  [1320] = {.lex_state = 238, .external_lex_state = 22},
  [1321] = {.lex_state = 238, .external_lex_state = 22},
  [1322] = {.lex_state = 238, .external_lex_state = 22},
  [1323] = {.lex_state = 167},
  [1324] = {.lex_state = 236, .external_lex_state = 16},
  [1325] = {.lex_state = 70},
  [1326] = {.lex_state = 175, .external_lex_state = 16},
  [1327] = {.lex_state = 175, .external_lex_state = 16},
  [1328] = {.lex_state = 238, .external_lex_state = 22},
  [1329] = {.lex_state = 240},
  [1330] = {.lex_state = 238, .external_lex_state = 16},
  [1331] = {.lex_state = 238, .external_lex_state = 22},
  [1332] = {.lex_state = 240},
  [1333] = {.lex_state = 238, .external_lex_state = 16},
  [1334] = {.lex_state = 125, .external_lex_state = 5},
  [1335] = {.lex_state = 238, .external_lex_state = 16},
  [1336] = {.lex_state = 219, .external_lex_state = 2},
  [1337] = {.lex_state = 238, .external_lex_state = 22},
  [1338] = {.lex_state = 138, .external_lex_state = 4},
  [1339] = {.lex_state = 142, .external_lex_state = 8},
  [1340] = {.lex_state = 64, .external_lex_state = 2},
  [1341] = {.lex_state = 93, .external_lex_state = 4},
  [1342] = {.lex_state = 123, .external_lex_state = 8},
  [1343] = {.lex_state = 219, .external_lex_state = 2},
  [1344] = {.lex_state = 238, .external_lex_state = 22},
  [1345] = {.lex_state = 138, .external_lex_state = 4},
  [1346] = {.lex_state = 142, .external_lex_state = 8},
  [1347] = {.lex_state = 238, .external_lex_state = 16},
  [1348] = {.lex_state = 125, .external_lex_state = 5},
  [1349] = {.lex_state = 247, .external_lex_state = 7},
  [1350] = {.lex_state = 136},
  [1351] = {.lex_state = 64},
  [1352] = {.lex_state = 81},
  [1353] = {.lex_state = 64},
  [1354] = {.lex_state = 81},
  [1355] = {.lex_state = 81},
  [1356] = {.lex_state = 247, .external_lex_state = 21},
  [1357] = {.lex_state = 123, .external_lex_state = 21},
  [1358] = {.lex_state = 247, .external_lex_state = 5},
  [1359] = {.lex_state = 247, .external_lex_state = 5},
  [1360] = {.lex_state = 247, .external_lex_state = 5},
  [1361] = {.lex_state = 247, .external_lex_state = 7},
  [1362] = {.lex_state = 125, .external_lex_state = 5},
  [1363] = {.lex_state = 144, .external_lex_state = 4},
  [1364] = {.lex_state = 236, .external_lex_state = 16},
  [1365] = {.lex_state = 70},
  [1366] = {.lex_state = 175, .external_lex_state = 16},
  [1367] = {.lex_state = 175, .external_lex_state = 16},
  [1368] = {.lex_state = 178, .external_lex_state = 17},
  [1369] = {.lex_state = 240},
  [1370] = {.lex_state = 238, .external_lex_state = 16},
  [1371] = {.lex_state = 178, .external_lex_state = 17},
  [1372] = {.lex_state = 240},
  [1373] = {.lex_state = 238, .external_lex_state = 16},
  [1374] = {.lex_state = 204, .external_lex_state = 5},
  [1375] = {.lex_state = 144, .external_lex_state = 4},
  [1376] = {.lex_state = 70},
  [1377] = {.lex_state = 70},
  [1378] = {.lex_state = 210, .external_lex_state = 13},
  [1379] = {.lex_state = 210, .external_lex_state = 13},
  [1380] = {.lex_state = 210, .external_lex_state = 13},
  [1381] = {.lex_state = 167},
  [1382] = {.lex_state = 236, .external_lex_state = 16},
  [1383] = {.lex_state = 70},
  [1384] = {.lex_state = 175, .external_lex_state = 16},
  [1385] = {.lex_state = 175, .external_lex_state = 16},
  [1386] = {.lex_state = 210, .external_lex_state = 13},
  [1387] = {.lex_state = 240},
  [1388] = {.lex_state = 238, .external_lex_state = 16},
  [1389] = {.lex_state = 210, .external_lex_state = 13},
  [1390] = {.lex_state = 240},
  [1391] = {.lex_state = 238, .external_lex_state = 16},
  [1392] = {.lex_state = 219, .external_lex_state = 2},
  [1393] = {.lex_state = 210, .external_lex_state = 13},
  [1394] = {.lex_state = 138, .external_lex_state = 4},
  [1395] = {.lex_state = 142, .external_lex_state = 8},
  [1396] = {.lex_state = 64, .external_lex_state = 2},
  [1397] = {.lex_state = 93, .external_lex_state = 4},
  [1398] = {.lex_state = 123, .external_lex_state = 8},
  [1399] = {.lex_state = 219, .external_lex_state = 2},
  [1400] = {.lex_state = 210, .external_lex_state = 13},
  [1401] = {.lex_state = 138, .external_lex_state = 4},
  [1402] = {.lex_state = 142, .external_lex_state = 8},
  [1403] = {.lex_state = 142, .external_lex_state = 19},
  [1404] = {.lex_state = 142, .external_lex_state = 19},
  [1405] = {.lex_state = 214, .external_lex_state = 22},
  [1406] = {.lex_state = 214, .external_lex_state = 22},
  [1407] = {.lex_state = 214, .external_lex_state = 16},
  [1408] = {.lex_state = 236, .external_lex_state = 16},
  [1409] = {.lex_state = 142, .external_lex_state = 19},
  [1410] = {.lex_state = 240},
  [1411] = {.lex_state = 238, .external_lex_state = 16},
  [1412] = {.lex_state = 240},
  [1413] = {.lex_state = 238, .external_lex_state = 16},
  [1414] = {.lex_state = 238, .external_lex_state = 16},
  [1415] = {.lex_state = 142, .external_lex_state = 19},
  [1416] = {.lex_state = 238, .external_lex_state = 16},
  [1417] = {.lex_state = 142, .external_lex_state = 19},
  [1418] = {.lex_state = 219, .external_lex_state = 2},
  [1419] = {.lex_state = 64, .external_lex_state = 2},
  [1420] = {.lex_state = 142, .external_lex_state = 19},
  [1421] = {.lex_state = 219, .external_lex_state = 2},
  [1422] = {.lex_state = 261},
  [1423] = {.lex_state = 214, .external_lex_state = 20},
  [1424] = {.lex_state = 144, .external_lex_state = 4},
  [1425] = {.lex_state = 224},
  [1426] = {.lex_state = 264},
  [1427] = {.lex_state = 81},
  [1428] = {.lex_state = 264, .external_lex_state = 13},
  [1429] = {.lex_state = 264, .external_lex_state = 13},
  [1430] = {.lex_state = 167},
  [1431] = {.lex_state = 100},
  [1432] = {.lex_state = 264, .external_lex_state = 13},
  [1433] = {.lex_state = 264, .external_lex_state = 13},
  [1434] = {.lex_state = 264, .external_lex_state = 13},
  [1435] = {.lex_state = 70},
  [1436] = {.lex_state = 173, .external_lex_state = 6},
  [1437] = {.lex_state = 175, .external_lex_state = 16},
  [1438] = {.lex_state = 175, .external_lex_state = 16},
  [1439] = {.lex_state = 138, .external_lex_state = 4},
  [1440] = {.lex_state = 142, .external_lex_state = 8},
  [1441] = {.lex_state = 64, .external_lex_state = 2},
  [1442] = {.lex_state = 93, .external_lex_state = 4},
  [1443] = {.lex_state = 123, .external_lex_state = 8},
  [1444] = {.lex_state = 64, .external_lex_state = 2},
  [1445] = {.lex_state = 138, .external_lex_state = 4},
  [1446] = {.lex_state = 142, .external_lex_state = 8},
  [1447] = {.lex_state = 64, .external_lex_state = 2},
  [1448] = {.lex_state = 261},
  [1449] = {.lex_state = 85},
  [1450] = {.lex_state = 226},
  [1451] = {.lex_state = 264},
  [1452] = {.lex_state = 251, .external_lex_state = 10},
  [1453] = {.lex_state = 251, .external_lex_state = 10},
  [1454] = {.lex_state = 214, .external_lex_state = 22},
  [1455] = {.lex_state = 214, .external_lex_state = 22},
  [1456] = {.lex_state = 214, .external_lex_state = 16},
  [1457] = {.lex_state = 236, .external_lex_state = 16},
  [1458] = {.lex_state = 251, .external_lex_state = 10},
  [1459] = {.lex_state = 240},
  [1460] = {.lex_state = 238, .external_lex_state = 16},
  [1461] = {.lex_state = 240},
  [1462] = {.lex_state = 238, .external_lex_state = 16},
  [1463] = {.lex_state = 238, .external_lex_state = 16},
  [1464] = {.lex_state = 251, .external_lex_state = 10},
  [1465] = {.lex_state = 238, .external_lex_state = 16},
  [1466] = {.lex_state = 251, .external_lex_state = 10},
  [1467] = {.lex_state = 219, .external_lex_state = 2},
  [1468] = {.lex_state = 64, .external_lex_state = 2},
  [1469] = {.lex_state = 251, .external_lex_state = 10},
  [1470] = {.lex_state = 219, .external_lex_state = 2},
  [1471] = {.lex_state = 85},
  [1472] = {.lex_state = 253, .external_lex_state = 10},
  [1473] = {.lex_state = 253, .external_lex_state = 10},
  [1474] = {.lex_state = 253, .external_lex_state = 10},
  [1475] = {.lex_state = 167},
  [1476] = {.lex_state = 236, .external_lex_state = 16},
  [1477] = {.lex_state = 70},
  [1478] = {.lex_state = 175, .external_lex_state = 16},
  [1479] = {.lex_state = 175, .external_lex_state = 16},
  [1480] = {.lex_state = 253, .external_lex_state = 10},
  [1481] = {.lex_state = 240},
  [1482] = {.lex_state = 238, .external_lex_state = 16},
  [1483] = {.lex_state = 253, .external_lex_state = 10},
  [1484] = {.lex_state = 240},
  [1485] = {.lex_state = 238, .external_lex_state = 16},
  [1486] = {.lex_state = 219, .external_lex_state = 2},
  [1487] = {.lex_state = 253, .external_lex_state = 10},
  [1488] = {.lex_state = 138, .external_lex_state = 4},
  [1489] = {.lex_state = 142, .external_lex_state = 8},
  [1490] = {.lex_state = 64, .external_lex_state = 2},
  [1491] = {.lex_state = 93, .external_lex_state = 4},
  [1492] = {.lex_state = 123, .external_lex_state = 8},
  [1493] = {.lex_state = 219, .external_lex_state = 2},
  [1494] = {.lex_state = 253, .external_lex_state = 10},
  [1495] = {.lex_state = 138, .external_lex_state = 4},
  [1496] = {.lex_state = 142, .external_lex_state = 8},
  [1497] = {.lex_state = 144, .external_lex_state = 4},
  [1498] = {.lex_state = 144, .external_lex_state = 4},
  [1499] = {.lex_state = 123, .external_lex_state = 19},
  [1500] = {.lex_state = 123, .external_lex_state = 21},
  [1501] = {.lex_state = 81},
  [1502] = {.lex_state = 121, .external_lex_state = 10},
  [1503] = {.lex_state = 121, .external_lex_state = 10},
  [1504] = {.lex_state = 81},
  [1505] = {.lex_state = 204, .external_lex_state = 23},
  [1506] = {.lex_state = 204, .external_lex_state = 23},
  [1507] = {.lex_state = 204, .external_lex_state = 23},
  [1508] = {.lex_state = 204, .external_lex_state = 23},
  [1509] = {.lex_state = 204, .external_lex_state = 21},
  [1510] = {.lex_state = 204, .external_lex_state = 5},
  [1511] = {.lex_state = 64, .external_lex_state = 2},
  [1512] = {.lex_state = 64, .external_lex_state = 2},
  [1513] = {.lex_state = 144, .external_lex_state = 4},
  [1514] = {.lex_state = 81},
  [1515] = {.lex_state = 81},
  [1516] = {.lex_state = 271, .external_lex_state = 2},
  [1517] = {.lex_state = 266},
  [1518] = {.lex_state = 266, .external_lex_state = 13},
  [1519] = {.lex_state = 271, .external_lex_state = 2},
  [1520] = {.lex_state = 266},
  [1521] = {.lex_state = 144, .external_lex_state = 4},
  [1522] = {.lex_state = 269},
  [1523] = {.lex_state = 81},
  [1524] = {.lex_state = 81},
  [1525] = {.lex_state = 144, .external_lex_state = 4},
  [1526] = {.lex_state = 269},
  [1527] = {.lex_state = 81},
  [1528] = {.lex_state = 132, .external_lex_state = 10},
  [1529] = {.lex_state = 132, .external_lex_state = 10},
  [1530] = {.lex_state = 214, .external_lex_state = 22},
  [1531] = {.lex_state = 214, .external_lex_state = 22},
  [1532] = {.lex_state = 214, .external_lex_state = 16},
  [1533] = {.lex_state = 238, .external_lex_state = 16},
  [1534] = {.lex_state = 132, .external_lex_state = 10},
  [1535] = {.lex_state = 238, .external_lex_state = 16},
  [1536] = {.lex_state = 132, .external_lex_state = 10},
  [1537] = {.lex_state = 238, .external_lex_state = 16},
  [1538] = {.lex_state = 238, .external_lex_state = 16},
  [1539] = {.lex_state = 132, .external_lex_state = 10},
  [1540] = {.lex_state = 132, .external_lex_state = 10},
  [1541] = {.lex_state = 144, .external_lex_state = 4},
  [1542] = {.lex_state = 121, .external_lex_state = 10},
  [1543] = {.lex_state = 121, .external_lex_state = 10},
  [1544] = {.lex_state = 144, .external_lex_state = 4},
  [1545] = {.lex_state = 121, .external_lex_state = 10},
  [1546] = {.lex_state = 142, .external_lex_state = 19},
  [1547] = {.lex_state = 142, .external_lex_state = 21},
  [1548] = {.lex_state = 81},
  [1549] = {.lex_state = 273, .external_lex_state = 10},
  [1550] = {.lex_state = 273, .external_lex_state = 10},
  [1551] = {.lex_state = 81},
  [1552] = {.lex_state = 222, .external_lex_state = 23},
  [1553] = {.lex_state = 222, .external_lex_state = 23},
  [1554] = {.lex_state = 222, .external_lex_state = 23},
  [1555] = {.lex_state = 222, .external_lex_state = 23},
  [1556] = {.lex_state = 222, .external_lex_state = 21},
  [1557] = {.lex_state = 222, .external_lex_state = 5},
  [1558] = {.lex_state = 81, .external_lex_state = 2},
  [1559] = {.lex_state = 150, .external_lex_state = 11},
  [1560] = {.lex_state = 150, .external_lex_state = 11},
  [1561] = {.lex_state = 214, .external_lex_state = 22},
  [1562] = {.lex_state = 214, .external_lex_state = 22},
  [1563] = {.lex_state = 214, .external_lex_state = 16},
  [1564] = {.lex_state = 238, .external_lex_state = 16},
  [1565] = {.lex_state = 150, .external_lex_state = 11},
  [1566] = {.lex_state = 238, .external_lex_state = 16},
  [1567] = {.lex_state = 150, .external_lex_state = 11},
  [1568] = {.lex_state = 238, .external_lex_state = 16},
  [1569] = {.lex_state = 238, .external_lex_state = 16},
  [1570] = {.lex_state = 150, .external_lex_state = 11},
  [1571] = {.lex_state = 150, .external_lex_state = 11},
  [1572] = {.lex_state = 204, .external_lex_state = 23},
  [1573] = {.lex_state = 204, .external_lex_state = 23},
  [1574] = {.lex_state = 249, .external_lex_state = 21},
  [1575] = {.lex_state = 81},
  [1576] = {.lex_state = 204, .external_lex_state = 23},
  [1577] = {.lex_state = 249, .external_lex_state = 23},
  [1578] = {.lex_state = 167},
  [1579] = {.lex_state = 100},
  [1580] = {.lex_state = 249, .external_lex_state = 23},
  [1581] = {.lex_state = 249, .external_lex_state = 23},
  [1582] = {.lex_state = 249, .external_lex_state = 23},
  [1583] = {.lex_state = 70},
  [1584] = {.lex_state = 173, .external_lex_state = 6},
  [1585] = {.lex_state = 175, .external_lex_state = 16},
  [1586] = {.lex_state = 175, .external_lex_state = 16},
  [1587] = {.lex_state = 138, .external_lex_state = 4},
  [1588] = {.lex_state = 142, .external_lex_state = 8},
  [1589] = {.lex_state = 64, .external_lex_state = 2},
  [1590] = {.lex_state = 93, .external_lex_state = 4},
  [1591] = {.lex_state = 123, .external_lex_state = 8},
  [1592] = {.lex_state = 64, .external_lex_state = 2},
  [1593] = {.lex_state = 138, .external_lex_state = 4},
  [1594] = {.lex_state = 142, .external_lex_state = 8},
  [1595] = {.lex_state = 64, .external_lex_state = 2},
  [1596] = {.lex_state = 233, .external_lex_state = 13},
  [1597] = {.lex_state = 233, .external_lex_state = 13},
  [1598] = {.lex_state = 214, .external_lex_state = 22},
  [1599] = {.lex_state = 214, .external_lex_state = 22},
  [1600] = {.lex_state = 214, .external_lex_state = 16},
  [1601] = {.lex_state = 238, .external_lex_state = 16},
  [1602] = {.lex_state = 233, .external_lex_state = 13},
  [1603] = {.lex_state = 238, .external_lex_state = 16},
  [1604] = {.lex_state = 233, .external_lex_state = 13},
  [1605] = {.lex_state = 238, .external_lex_state = 16},
  [1606] = {.lex_state = 238, .external_lex_state = 16},
  [1607] = {.lex_state = 233, .external_lex_state = 13},
  [1608] = {.lex_state = 233, .external_lex_state = 13},
  [1609] = {.lex_state = 138, .external_lex_state = 3},
  [1610] = {.lex_state = 138, .external_lex_state = 14},
  [1611] = {.lex_state = 138, .external_lex_state = 14},
  [1612] = {.lex_state = 214, .external_lex_state = 22},
  [1613] = {.lex_state = 214, .external_lex_state = 22},
  [1614] = {.lex_state = 214, .external_lex_state = 16},
  [1615] = {.lex_state = 238, .external_lex_state = 16},
  [1616] = {.lex_state = 138, .external_lex_state = 14},
  [1617] = {.lex_state = 238, .external_lex_state = 16},
  [1618] = {.lex_state = 138, .external_lex_state = 14},
  [1619] = {.lex_state = 238, .external_lex_state = 16},
  [1620] = {.lex_state = 238, .external_lex_state = 16},
  [1621] = {.lex_state = 138, .external_lex_state = 14},
  [1622] = {.lex_state = 138, .external_lex_state = 14},
  [1623] = {.lex_state = 138, .external_lex_state = 10},
  [1624] = {.lex_state = 138, .external_lex_state = 10},
  [1625] = {.lex_state = 214, .external_lex_state = 22},
  [1626] = {.lex_state = 214, .external_lex_state = 22},
  [1627] = {.lex_state = 214, .external_lex_state = 16},
  [1628] = {.lex_state = 238, .external_lex_state = 16},
  [1629] = {.lex_state = 138, .external_lex_state = 10},
  [1630] = {.lex_state = 238, .external_lex_state = 16},
  [1631] = {.lex_state = 138, .external_lex_state = 10},
  [1632] = {.lex_state = 238, .external_lex_state = 16},
  [1633] = {.lex_state = 238, .external_lex_state = 16},
  [1634] = {.lex_state = 138, .external_lex_state = 10},
  [1635] = {.lex_state = 138, .external_lex_state = 10},
  [1636] = {.lex_state = 81, .external_lex_state = 15},
  [1637] = {.lex_state = 81, .external_lex_state = 15},
  [1638] = {.lex_state = 214, .external_lex_state = 22},
  [1639] = {.lex_state = 214, .external_lex_state = 22},
  [1640] = {.lex_state = 214, .external_lex_state = 16},
  [1641] = {.lex_state = 238, .external_lex_state = 16},
  [1642] = {.lex_state = 81, .external_lex_state = 15},
  [1643] = {.lex_state = 238, .external_lex_state = 16},
  [1644] = {.lex_state = 81, .external_lex_state = 15},
  [1645] = {.lex_state = 238, .external_lex_state = 16},
  [1646] = {.lex_state = 238, .external_lex_state = 16},
  [1647] = {.lex_state = 81, .external_lex_state = 15},
  [1648] = {.lex_state = 81, .external_lex_state = 15},
  [1649] = {.lex_state = 100, .external_lex_state = 13},
  [1650] = {.lex_state = 100, .external_lex_state = 13},
  [1651] = {.lex_state = 214, .external_lex_state = 22},
  [1652] = {.lex_state = 214, .external_lex_state = 22},
  [1653] = {.lex_state = 214, .external_lex_state = 16},
  [1654] = {.lex_state = 238, .external_lex_state = 16},
  [1655] = {.lex_state = 100, .external_lex_state = 13},
  [1656] = {.lex_state = 238, .external_lex_state = 16},
  [1657] = {.lex_state = 100, .external_lex_state = 13},
  [1658] = {.lex_state = 238, .external_lex_state = 16},
  [1659] = {.lex_state = 238, .external_lex_state = 16},
  [1660] = {.lex_state = 100, .external_lex_state = 13},
  [1661] = {.lex_state = 175, .external_lex_state = 22},
  [1662] = {.lex_state = 175, .external_lex_state = 16},
  [1663] = {.lex_state = 175, .external_lex_state = 22},
  [1664] = {.lex_state = 175, .external_lex_state = 16},
  [1665] = {.lex_state = 214, .external_lex_state = 22},
  [1666] = {.lex_state = 214, .external_lex_state = 22},
  [1667] = {.lex_state = 214, .external_lex_state = 22},
  [1668] = {.lex_state = 167},
  [1669] = {.lex_state = 236, .external_lex_state = 16},
  [1670] = {.lex_state = 70},
  [1671] = {.lex_state = 175, .external_lex_state = 16},
  [1672] = {.lex_state = 175, .external_lex_state = 16},
  [1673] = {.lex_state = 214, .external_lex_state = 22},
  [1674] = {.lex_state = 240},
  [1675] = {.lex_state = 238, .external_lex_state = 16},
  [1676] = {.lex_state = 214, .external_lex_state = 22},
  [1677] = {.lex_state = 240},
  [1678] = {.lex_state = 238, .external_lex_state = 16},
  [1679] = {.lex_state = 219, .external_lex_state = 2},
  [1680] = {.lex_state = 214, .external_lex_state = 22},
  [1681] = {.lex_state = 138, .external_lex_state = 4},
  [1682] = {.lex_state = 142, .external_lex_state = 8},
  [1683] = {.lex_state = 64, .external_lex_state = 2},
  [1684] = {.lex_state = 93, .external_lex_state = 4},
  [1685] = {.lex_state = 123, .external_lex_state = 8},
  [1686] = {.lex_state = 219, .external_lex_state = 2},
  [1687] = {.lex_state = 214, .external_lex_state = 22},
  [1688] = {.lex_state = 138, .external_lex_state = 4},
  [1689] = {.lex_state = 142, .external_lex_state = 8},
  [1690] = {.lex_state = 125, .external_lex_state = 5},
  [1691] = {.lex_state = 125, .external_lex_state = 5},
  [1692] = {.lex_state = 125, .external_lex_state = 5},
  [1693] = {.lex_state = 238, .external_lex_state = 16},
  [1694] = {.lex_state = 238, .external_lex_state = 16},
  [1695] = {.lex_state = 238, .external_lex_state = 22},
  [1696] = {.lex_state = 238, .external_lex_state = 22},
  [1697] = {.lex_state = 214, .external_lex_state = 22},
  [1698] = {.lex_state = 214, .external_lex_state = 22},
  [1699] = {.lex_state = 214, .external_lex_state = 16},
  [1700] = {.lex_state = 236, .external_lex_state = 16},
  [1701] = {.lex_state = 238, .external_lex_state = 22},
  [1702] = {.lex_state = 240},
  [1703] = {.lex_state = 238, .external_lex_state = 16},
  [1704] = {.lex_state = 240},
  [1705] = {.lex_state = 238, .external_lex_state = 16},
  [1706] = {.lex_state = 238, .external_lex_state = 16},
  [1707] = {.lex_state = 238, .external_lex_state = 22},
  [1708] = {.lex_state = 238, .external_lex_state = 16},
  [1709] = {.lex_state = 125, .external_lex_state = 5},
  [1710] = {.lex_state = 238, .external_lex_state = 22},
  [1711] = {.lex_state = 219, .external_lex_state = 2},
  [1712] = {.lex_state = 64, .external_lex_state = 2},
  [1713] = {.lex_state = 238, .external_lex_state = 22},
  [1714] = {.lex_state = 219, .external_lex_state = 2},
  [1715] = {.lex_state = 123, .external_lex_state = 21},
  [1716] = {.lex_state = 81},
  [1717] = {.lex_state = 275, .external_lex_state = 10},
  [1718] = {.lex_state = 275, .external_lex_state = 10},
  [1719] = {.lex_state = 81},
  [1720] = {.lex_state = 247, .external_lex_state = 23},
  [1721] = {.lex_state = 247, .external_lex_state = 23},
  [1722] = {.lex_state = 247, .external_lex_state = 23},
  [1723] = {.lex_state = 247, .external_lex_state = 23},
  [1724] = {.lex_state = 247, .external_lex_state = 21},
  [1725] = {.lex_state = 247, .external_lex_state = 5},
  [1726] = {.lex_state = 178, .external_lex_state = 17},
  [1727] = {.lex_state = 214, .external_lex_state = 22},
  [1728] = {.lex_state = 214, .external_lex_state = 22},
  [1729] = {.lex_state = 214, .external_lex_state = 16},
  [1730] = {.lex_state = 236, .external_lex_state = 16},
  [1731] = {.lex_state = 178, .external_lex_state = 17},
  [1732] = {.lex_state = 240},
  [1733] = {.lex_state = 238, .external_lex_state = 16},
  [1734] = {.lex_state = 240},
  [1735] = {.lex_state = 238, .external_lex_state = 16},
  [1736] = {.lex_state = 238, .external_lex_state = 16},
  [1737] = {.lex_state = 178, .external_lex_state = 17},
  [1738] = {.lex_state = 238, .external_lex_state = 16},
  [1739] = {.lex_state = 210, .external_lex_state = 13},
  [1740] = {.lex_state = 210, .external_lex_state = 13},
  [1741] = {.lex_state = 214, .external_lex_state = 22},
  [1742] = {.lex_state = 214, .external_lex_state = 22},
  [1743] = {.lex_state = 214, .external_lex_state = 16},
  [1744] = {.lex_state = 236, .external_lex_state = 16},
  [1745] = {.lex_state = 210, .external_lex_state = 13},
  [1746] = {.lex_state = 240},
  [1747] = {.lex_state = 238, .external_lex_state = 16},
  [1748] = {.lex_state = 240},
  [1749] = {.lex_state = 238, .external_lex_state = 16},
  [1750] = {.lex_state = 238, .external_lex_state = 16},
  [1751] = {.lex_state = 210, .external_lex_state = 13},
  [1752] = {.lex_state = 238, .external_lex_state = 16},
  [1753] = {.lex_state = 210, .external_lex_state = 13},
  [1754] = {.lex_state = 219, .external_lex_state = 2},
  [1755] = {.lex_state = 64, .external_lex_state = 2},
  [1756] = {.lex_state = 210, .external_lex_state = 13},
  [1757] = {.lex_state = 219, .external_lex_state = 2},
  [1758] = {.lex_state = 142, .external_lex_state = 19},
  [1759] = {.lex_state = 142, .external_lex_state = 19},
  [1760] = {.lex_state = 214, .external_lex_state = 22},
  [1761] = {.lex_state = 214, .external_lex_state = 22},
  [1762] = {.lex_state = 214, .external_lex_state = 16},
  [1763] = {.lex_state = 238, .external_lex_state = 16},
  [1764] = {.lex_state = 142, .external_lex_state = 19},
  [1765] = {.lex_state = 238, .external_lex_state = 16},
  [1766] = {.lex_state = 142, .external_lex_state = 19},
  [1767] = {.lex_state = 238, .external_lex_state = 16},
  [1768] = {.lex_state = 238, .external_lex_state = 16},
  [1769] = {.lex_state = 142, .external_lex_state = 19},
  [1770] = {.lex_state = 142, .external_lex_state = 19},
  [1771] = {.lex_state = 144, .external_lex_state = 4},
  [1772] = {.lex_state = 144, .external_lex_state = 4},
  [1773] = {.lex_state = 214, .external_lex_state = 20},
  [1774] = {.lex_state = 264},
  [1775] = {.lex_state = 264, .external_lex_state = 13},
  [1776] = {.lex_state = 264, .external_lex_state = 13},
  [1777] = {.lex_state = 264, .external_lex_state = 13},
  [1778] = {.lex_state = 167},
  [1779] = {.lex_state = 236, .external_lex_state = 16},
  [1780] = {.lex_state = 70},
  [1781] = {.lex_state = 175, .external_lex_state = 16},
  [1782] = {.lex_state = 175, .external_lex_state = 16},
  [1783] = {.lex_state = 264, .external_lex_state = 13},
  [1784] = {.lex_state = 240},
  [1785] = {.lex_state = 238, .external_lex_state = 16},
  [1786] = {.lex_state = 264, .external_lex_state = 13},
  [1787] = {.lex_state = 240},
  [1788] = {.lex_state = 238, .external_lex_state = 16},
  [1789] = {.lex_state = 219, .external_lex_state = 2},
  [1790] = {.lex_state = 264, .external_lex_state = 13},
  [1791] = {.lex_state = 138, .external_lex_state = 4},
  [1792] = {.lex_state = 142, .external_lex_state = 8},
  [1793] = {.lex_state = 64, .external_lex_state = 2},
  [1794] = {.lex_state = 93, .external_lex_state = 4},
  [1795] = {.lex_state = 123, .external_lex_state = 8},
  [1796] = {.lex_state = 219, .external_lex_state = 2},
  [1797] = {.lex_state = 264, .external_lex_state = 13},
  [1798] = {.lex_state = 138, .external_lex_state = 4},
  [1799] = {.lex_state = 142, .external_lex_state = 8},
  [1800] = {.lex_state = 261},
  [1801] = {.lex_state = 264},
  [1802] = {.lex_state = 264},
  [1803] = {.lex_state = 261},
  [1804] = {.lex_state = 251, .external_lex_state = 10},
  [1805] = {.lex_state = 251, .external_lex_state = 10},
  [1806] = {.lex_state = 214, .external_lex_state = 22},
  [1807] = {.lex_state = 214, .external_lex_state = 22},
  [1808] = {.lex_state = 214, .external_lex_state = 16},
  [1809] = {.lex_state = 238, .external_lex_state = 16},
  [1810] = {.lex_state = 251, .external_lex_state = 10},
  [1811] = {.lex_state = 238, .external_lex_state = 16},
  [1812] = {.lex_state = 251, .external_lex_state = 10},
  [1813] = {.lex_state = 238, .external_lex_state = 16},
  [1814] = {.lex_state = 238, .external_lex_state = 16},
  [1815] = {.lex_state = 251, .external_lex_state = 10},
  [1816] = {.lex_state = 251, .external_lex_state = 10},
  [1817] = {.lex_state = 264},
  [1818] = {.lex_state = 253, .external_lex_state = 10},
  [1819] = {.lex_state = 253, .external_lex_state = 10},
  [1820] = {.lex_state = 214, .external_lex_state = 22},
  [1821] = {.lex_state = 214, .external_lex_state = 22},
  [1822] = {.lex_state = 214, .external_lex_state = 16},
  [1823] = {.lex_state = 236, .external_lex_state = 16},
  [1824] = {.lex_state = 253, .external_lex_state = 10},
  [1825] = {.lex_state = 240},
  [1826] = {.lex_state = 238, .external_lex_state = 16},
  [1827] = {.lex_state = 240},
  [1828] = {.lex_state = 238, .external_lex_state = 16},
  [1829] = {.lex_state = 238, .external_lex_state = 16},
  [1830] = {.lex_state = 253, .external_lex_state = 10},
  [1831] = {.lex_state = 238, .external_lex_state = 16},
  [1832] = {.lex_state = 253, .external_lex_state = 10},
  [1833] = {.lex_state = 219, .external_lex_state = 2},
  [1834] = {.lex_state = 64, .external_lex_state = 2},
  [1835] = {.lex_state = 253, .external_lex_state = 10},
  [1836] = {.lex_state = 219, .external_lex_state = 2},
  [1837] = {.lex_state = 121, .external_lex_state = 10},
  [1838] = {.lex_state = 121, .external_lex_state = 10},
  [1839] = {.lex_state = 121, .external_lex_state = 10},
  [1840] = {.lex_state = 204, .external_lex_state = 23},
  [1841] = {.lex_state = 204, .external_lex_state = 23},
  [1842] = {.lex_state = 204, .external_lex_state = 23},
  [1843] = {.lex_state = 64, .external_lex_state = 2},
  [1844] = {.lex_state = 144, .external_lex_state = 4},
  [1845] = {.lex_state = 266, .external_lex_state = 13},
  [1846] = {.lex_state = 266, .external_lex_state = 13},
  [1847] = {.lex_state = 266},
  [1848] = {.lex_state = 70},
  [1849] = {.lex_state = 64, .external_lex_state = 2},
  [1850] = {.lex_state = 255},
  [1851] = {.lex_state = 81},
  [1852] = {.lex_state = 83, .external_lex_state = 2},
  [1853] = {.lex_state = 85},
  [1854] = {.lex_state = 85},
  [1855] = {.lex_state = 277, .external_lex_state = 3},
  [1856] = {.lex_state = 277, .external_lex_state = 4},
  [1857] = {.lex_state = 283, .external_lex_state = 5},
  [1858] = {.lex_state = 100},
  [1859] = {.lex_state = 107},
  [1860] = {.lex_state = 283, .external_lex_state = 5},
  [1861] = {.lex_state = 107, .external_lex_state = 6},
  [1862] = {.lex_state = 64, .external_lex_state = 2},
  [1863] = {.lex_state = 64, .external_lex_state = 2},
  [1864] = {.lex_state = 64, .external_lex_state = 2},
  [1865] = {.lex_state = 285, .external_lex_state = 5},
  [1866] = {.lex_state = 269, .external_lex_state = 4},
  [1867] = {.lex_state = 283, .external_lex_state = 7},
  [1868] = {.lex_state = 287, .external_lex_state = 8},
  [1869] = {.lex_state = 70},
  [1870] = {.lex_state = 283, .external_lex_state = 7},
  [1871] = {.lex_state = 271, .external_lex_state = 2},
  [1872] = {.lex_state = 81, .external_lex_state = 2},
  [1873] = {.lex_state = 271, .external_lex_state = 2},
  [1874] = {.lex_state = 266},
  [1875] = {.lex_state = 266, .external_lex_state = 13},
  [1876] = {.lex_state = 255},
  [1877] = {.lex_state = 269, .external_lex_state = 4},
  [1878] = {.lex_state = 287, .external_lex_state = 8},
  [1879] = {.lex_state = 271, .external_lex_state = 2},
  [1880] = {.lex_state = 271, .external_lex_state = 2},
  [1881] = {.lex_state = 144, .external_lex_state = 4},
  [1882] = {.lex_state = 266, .external_lex_state = 13},
  [1883] = {.lex_state = 266, .external_lex_state = 13},
  [1884] = {.lex_state = 266},
  [1885] = {.lex_state = 269},
  [1886] = {.lex_state = 144, .external_lex_state = 4},
  [1887] = {.lex_state = 269},
  [1888] = {.lex_state = 132, .external_lex_state = 10},
  [1889] = {.lex_state = 132, .external_lex_state = 10},
  [1890] = {.lex_state = 132, .external_lex_state = 10},
  [1891] = {.lex_state = 238, .external_lex_state = 16},
  [1892] = {.lex_state = 238, .external_lex_state = 16},
  [1893] = {.lex_state = 132, .external_lex_state = 10},
  [1894] = {.lex_state = 121, .external_lex_state = 10},
  [1895] = {.lex_state = 273, .external_lex_state = 10},
  [1896] = {.lex_state = 273, .external_lex_state = 10},
  [1897] = {.lex_state = 273, .external_lex_state = 10},
  [1898] = {.lex_state = 222, .external_lex_state = 23},
  [1899] = {.lex_state = 222, .external_lex_state = 23},
  [1900] = {.lex_state = 222, .external_lex_state = 23},
  [1901] = {.lex_state = 150, .external_lex_state = 11},
  [1902] = {.lex_state = 150, .external_lex_state = 11},
  [1903] = {.lex_state = 150, .external_lex_state = 11},
  [1904] = {.lex_state = 238, .external_lex_state = 16},
  [1905] = {.lex_state = 238, .external_lex_state = 16},
  [1906] = {.lex_state = 150, .external_lex_state = 11},
  [1907] = {.lex_state = 249, .external_lex_state = 23},
  [1908] = {.lex_state = 204, .external_lex_state = 23},
  [1909] = {.lex_state = 249, .external_lex_state = 23},
  [1910] = {.lex_state = 167},
  [1911] = {.lex_state = 236, .external_lex_state = 16},
  [1912] = {.lex_state = 70},
  [1913] = {.lex_state = 175, .external_lex_state = 16},
  [1914] = {.lex_state = 175, .external_lex_state = 16},
  [1915] = {.lex_state = 249, .external_lex_state = 23},
  [1916] = {.lex_state = 240},
  [1917] = {.lex_state = 238, .external_lex_state = 16},
  [1918] = {.lex_state = 249, .external_lex_state = 23},
  [1919] = {.lex_state = 240},
  [1920] = {.lex_state = 238, .external_lex_state = 16},
  [1921] = {.lex_state = 219, .external_lex_state = 2},
  [1922] = {.lex_state = 249, .external_lex_state = 23},
  [1923] = {.lex_state = 138, .external_lex_state = 4},
  [1924] = {.lex_state = 142, .external_lex_state = 8},
  [1925] = {.lex_state = 64, .external_lex_state = 2},
  [1926] = {.lex_state = 93, .external_lex_state = 4},
  [1927] = {.lex_state = 123, .external_lex_state = 8},
  [1928] = {.lex_state = 219, .external_lex_state = 2},
  [1929] = {.lex_state = 249, .external_lex_state = 23},
  [1930] = {.lex_state = 138, .external_lex_state = 4},
  [1931] = {.lex_state = 142, .external_lex_state = 8},
  [1932] = {.lex_state = 233, .external_lex_state = 13},
  [1933] = {.lex_state = 233, .external_lex_state = 13},
  [1934] = {.lex_state = 233, .external_lex_state = 13},
  [1935] = {.lex_state = 238, .external_lex_state = 16},
  [1936] = {.lex_state = 238, .external_lex_state = 16},
  [1937] = {.lex_state = 233, .external_lex_state = 13},
  [1938] = {.lex_state = 138, .external_lex_state = 14},
  [1939] = {.lex_state = 138, .external_lex_state = 14},
  [1940] = {.lex_state = 138, .external_lex_state = 14},
  [1941] = {.lex_state = 238, .external_lex_state = 16},
  [1942] = {.lex_state = 238, .external_lex_state = 16},
  [1943] = {.lex_state = 138, .external_lex_state = 14},
  [1944] = {.lex_state = 138, .external_lex_state = 10},
  [1945] = {.lex_state = 138, .external_lex_state = 10},
  [1946] = {.lex_state = 138, .external_lex_state = 10},
  [1947] = {.lex_state = 238, .external_lex_state = 16},
  [1948] = {.lex_state = 238, .external_lex_state = 16},
  [1949] = {.lex_state = 138, .external_lex_state = 10},
  [1950] = {.lex_state = 81, .external_lex_state = 15},
  [1951] = {.lex_state = 81, .external_lex_state = 15},
  [1952] = {.lex_state = 81, .external_lex_state = 15},
  [1953] = {.lex_state = 238, .external_lex_state = 16},
  [1954] = {.lex_state = 238, .external_lex_state = 16},
  [1955] = {.lex_state = 81, .external_lex_state = 15},
  [1956] = {.lex_state = 100, .external_lex_state = 13},
  [1957] = {.lex_state = 100, .external_lex_state = 13},
  [1958] = {.lex_state = 100, .external_lex_state = 13},
  [1959] = {.lex_state = 238, .external_lex_state = 16},
  [1960] = {.lex_state = 238, .external_lex_state = 16},
  [1961] = {.lex_state = 100, .external_lex_state = 13},
  [1962] = {.lex_state = 175, .external_lex_state = 16},
  [1963] = {.lex_state = 175, .external_lex_state = 16},
  [1964] = {.lex_state = 214, .external_lex_state = 22},
  [1965] = {.lex_state = 214, .external_lex_state = 22},
  [1966] = {.lex_state = 214, .external_lex_state = 22},
  [1967] = {.lex_state = 214, .external_lex_state = 22},
  [1968] = {.lex_state = 214, .external_lex_state = 16},
  [1969] = {.lex_state = 236, .external_lex_state = 16},
  [1970] = {.lex_state = 214, .external_lex_state = 22},
  [1971] = {.lex_state = 240},
  [1972] = {.lex_state = 238, .external_lex_state = 16},
  [1973] = {.lex_state = 240},
  [1974] = {.lex_state = 238, .external_lex_state = 16},
  [1975] = {.lex_state = 238, .external_lex_state = 16},
  [1976] = {.lex_state = 214, .external_lex_state = 22},
  [1977] = {.lex_state = 238, .external_lex_state = 16},
  [1978] = {.lex_state = 214, .external_lex_state = 22},
  [1979] = {.lex_state = 219, .external_lex_state = 2},
  [1980] = {.lex_state = 64, .external_lex_state = 2},
  [1981] = {.lex_state = 214, .external_lex_state = 22},
  [1982] = {.lex_state = 219, .external_lex_state = 2},
  [1983] = {.lex_state = 125, .external_lex_state = 5},
  [1984] = {.lex_state = 125, .external_lex_state = 5},
  [1985] = {.lex_state = 238, .external_lex_state = 22},
  [1986] = {.lex_state = 238, .external_lex_state = 22},
  [1987] = {.lex_state = 214, .external_lex_state = 22},
  [1988] = {.lex_state = 214, .external_lex_state = 22},
  [1989] = {.lex_state = 214, .external_lex_state = 16},
  [1990] = {.lex_state = 238, .external_lex_state = 16},
  [1991] = {.lex_state = 238, .external_lex_state = 22},
  [1992] = {.lex_state = 238, .external_lex_state = 16},
  [1993] = {.lex_state = 238, .external_lex_state = 22},
  [1994] = {.lex_state = 238, .external_lex_state = 16},
  [1995] = {.lex_state = 238, .external_lex_state = 16},
  [1996] = {.lex_state = 238, .external_lex_state = 22},
  [1997] = {.lex_state = 238, .external_lex_state = 22},
  [1998] = {.lex_state = 275, .external_lex_state = 10},
  [1999] = {.lex_state = 275, .external_lex_state = 10},
  [2000] = {.lex_state = 275, .external_lex_state = 10},
  [2001] = {.lex_state = 247, .external_lex_state = 23},
  [2002] = {.lex_state = 247, .external_lex_state = 23},
  [2003] = {.lex_state = 247, .external_lex_state = 23},
  [2004] = {.lex_state = 178, .external_lex_state = 17},
  [2005] = {.lex_state = 178, .external_lex_state = 17},
  [2006] = {.lex_state = 214, .external_lex_state = 22},
  [2007] = {.lex_state = 214, .external_lex_state = 22},
  [2008] = {.lex_state = 214, .external_lex_state = 16},
  [2009] = {.lex_state = 238, .external_lex_state = 16},
  [2010] = {.lex_state = 178, .external_lex_state = 17},
  [2011] = {.lex_state = 238, .external_lex_state = 16},
  [2012] = {.lex_state = 178, .external_lex_state = 17},
  [2013] = {.lex_state = 238, .external_lex_state = 16},
  [2014] = {.lex_state = 238, .external_lex_state = 16},
  [2015] = {.lex_state = 210, .external_lex_state = 13},
  [2016] = {.lex_state = 210, .external_lex_state = 13},
  [2017] = {.lex_state = 214, .external_lex_state = 22},
  [2018] = {.lex_state = 214, .external_lex_state = 22},
  [2019] = {.lex_state = 214, .external_lex_state = 16},
  [2020] = {.lex_state = 238, .external_lex_state = 16},
  [2021] = {.lex_state = 210, .external_lex_state = 13},
  [2022] = {.lex_state = 238, .external_lex_state = 16},
  [2023] = {.lex_state = 210, .external_lex_state = 13},
  [2024] = {.lex_state = 238, .external_lex_state = 16},
  [2025] = {.lex_state = 238, .external_lex_state = 16},
  [2026] = {.lex_state = 210, .external_lex_state = 13},
  [2027] = {.lex_state = 210, .external_lex_state = 13},
  [2028] = {.lex_state = 142, .external_lex_state = 19},
  [2029] = {.lex_state = 142, .external_lex_state = 19},
  [2030] = {.lex_state = 142, .external_lex_state = 19},
  [2031] = {.lex_state = 238, .external_lex_state = 16},
  [2032] = {.lex_state = 238, .external_lex_state = 16},
  [2033] = {.lex_state = 142, .external_lex_state = 19},
  [2034] = {.lex_state = 144, .external_lex_state = 4},
  [2035] = {.lex_state = 264, .external_lex_state = 13},
  [2036] = {.lex_state = 264, .external_lex_state = 13},
  [2037] = {.lex_state = 214, .external_lex_state = 22},
  [2038] = {.lex_state = 214, .external_lex_state = 22},
  [2039] = {.lex_state = 214, .external_lex_state = 16},
  [2040] = {.lex_state = 236, .external_lex_state = 16},
  [2041] = {.lex_state = 264, .external_lex_state = 13},
  [2042] = {.lex_state = 240},
  [2043] = {.lex_state = 238, .external_lex_state = 16},
  [2044] = {.lex_state = 240},
  [2045] = {.lex_state = 238, .external_lex_state = 16},
  [2046] = {.lex_state = 238, .external_lex_state = 16},
  [2047] = {.lex_state = 264, .external_lex_state = 13},
  [2048] = {.lex_state = 238, .external_lex_state = 16},
  [2049] = {.lex_state = 264, .external_lex_state = 13},
  [2050] = {.lex_state = 219, .external_lex_state = 2},
  [2051] = {.lex_state = 64, .external_lex_state = 2},
  [2052] = {.lex_state = 264, .external_lex_state = 13},
  [2053] = {.lex_state = 219, .external_lex_state = 2},
  [2054] = {.lex_state = 144, .external_lex_state = 4},
  [2055] = {.lex_state = 261},
  [2056] = {.lex_state = 251, .external_lex_state = 10},
  [2057] = {.lex_state = 251, .external_lex_state = 10},
  [2058] = {.lex_state = 251, .external_lex_state = 10},
  [2059] = {.lex_state = 238, .external_lex_state = 16},
  [2060] = {.lex_state = 238, .external_lex_state = 16},
  [2061] = {.lex_state = 251, .external_lex_state = 10},
  [2062] = {.lex_state = 261},
  [2063] = {.lex_state = 253, .external_lex_state = 10},
  [2064] = {.lex_state = 253, .external_lex_state = 10},
  [2065] = {.lex_state = 214, .external_lex_state = 22},
  [2066] = {.lex_state = 214, .external_lex_state = 22},
  [2067] = {.lex_state = 214, .external_lex_state = 16},
  [2068] = {.lex_state = 238, .external_lex_state = 16},
  [2069] = {.lex_state = 253, .external_lex_state = 10},
  [2070] = {.lex_state = 238, .external_lex_state = 16},
  [2071] = {.lex_state = 253, .external_lex_state = 10},
  [2072] = {.lex_state = 238, .external_lex_state = 16},
  [2073] = {.lex_state = 238, .external_lex_state = 16},
  [2074] = {.lex_state = 253, .external_lex_state = 10},
  [2075] = {.lex_state = 253, .external_lex_state = 10},
  [2076] = {.lex_state = 121, .external_lex_state = 10},
  [2077] = {.lex_state = 204, .external_lex_state = 23},
  [2078] = {.lex_state = 127, .external_lex_state = 9},
  [2079] = {.lex_state = 81},
  [2080] = {.lex_state = 136},
  [2081] = {.lex_state = 150, .external_lex_state = 12},
  [2082] = {.lex_state = 164},
  [2083] = {.lex_state = 70},
  [2084] = {.lex_state = 277, .external_lex_state = 14},
  [2085] = {.lex_state = 100},
  [2086] = {.lex_state = 107},
  [2087] = {.lex_state = 277, .external_lex_state = 14},
  [2088] = {.lex_state = 107, .external_lex_state = 6},
  [2089] = {.lex_state = 64, .external_lex_state = 2},
  [2090] = {.lex_state = 64, .external_lex_state = 2},
  [2091] = {.lex_state = 64, .external_lex_state = 2},
  [2092] = {.lex_state = 70},
  [2093] = {.lex_state = 277, .external_lex_state = 3},
  [2094] = {.lex_state = 277, .external_lex_state = 10},
  [2095] = {.lex_state = 100},
  [2096] = {.lex_state = 107},
  [2097] = {.lex_state = 277, .external_lex_state = 10},
  [2098] = {.lex_state = 107, .external_lex_state = 6},
  [2099] = {.lex_state = 64, .external_lex_state = 2},
  [2100] = {.lex_state = 64, .external_lex_state = 2},
  [2101] = {.lex_state = 64, .external_lex_state = 2},
  [2102] = {.lex_state = 277, .external_lex_state = 4},
  [2103] = {.lex_state = 81},
  [2104] = {.lex_state = 283, .external_lex_state = 5},
  [2105] = {.lex_state = 283, .external_lex_state = 5},
  [2106] = {.lex_state = 167},
  [2107] = {.lex_state = 100},
  [2108] = {.lex_state = 283, .external_lex_state = 5},
  [2109] = {.lex_state = 283, .external_lex_state = 5},
  [2110] = {.lex_state = 283, .external_lex_state = 5},
  [2111] = {.lex_state = 70},
  [2112] = {.lex_state = 173, .external_lex_state = 6},
  [2113] = {.lex_state = 175, .external_lex_state = 16},
  [2114] = {.lex_state = 175, .external_lex_state = 16},
  [2115] = {.lex_state = 138, .external_lex_state = 4},
  [2116] = {.lex_state = 142, .external_lex_state = 8},
  [2117] = {.lex_state = 64, .external_lex_state = 2},
  [2118] = {.lex_state = 93, .external_lex_state = 4},
  [2119] = {.lex_state = 123, .external_lex_state = 8},
  [2120] = {.lex_state = 64, .external_lex_state = 2},
  [2121] = {.lex_state = 138, .external_lex_state = 4},
  [2122] = {.lex_state = 142, .external_lex_state = 8},
  [2123] = {.lex_state = 64, .external_lex_state = 2},
  [2124] = {.lex_state = 83},
  [2125] = {.lex_state = 271, .external_lex_state = 2},
  [2126] = {.lex_state = 64, .external_lex_state = 2},
  [2127] = {.lex_state = 271, .external_lex_state = 2},
  [2128] = {.lex_state = 64, .external_lex_state = 2},
  [2129] = {.lex_state = 64},
  [2130] = {.lex_state = 181},
  [2131] = {.lex_state = 81},
  [2132] = {.lex_state = 81},
  [2133] = {.lex_state = 283, .external_lex_state = 5},
  [2134] = {.lex_state = 283, .external_lex_state = 5},
  [2135] = {.lex_state = 289, .external_lex_state = 7},
  [2136] = {.lex_state = 283, .external_lex_state = 7},
  [2137] = {.lex_state = 255},
  [2138] = {.lex_state = 269, .external_lex_state = 4},
  [2139] = {.lex_state = 287, .external_lex_state = 8},
  [2140] = {.lex_state = 271, .external_lex_state = 2},
  [2141] = {.lex_state = 283, .external_lex_state = 7},
  [2142] = {.lex_state = 271, .external_lex_state = 2},
  [2143] = {.lex_state = 271, .external_lex_state = 2},
  [2144] = {.lex_state = 255},
  [2145] = {.lex_state = 269, .external_lex_state = 4},
  [2146] = {.lex_state = 287, .external_lex_state = 8},
  [2147] = {.lex_state = 271, .external_lex_state = 2},
  [2148] = {.lex_state = 219, .external_lex_state = 2},
  [2149] = {.lex_state = 266},
  [2150] = {.lex_state = 219, .external_lex_state = 2},
  [2151] = {.lex_state = 266},
  [2152] = {.lex_state = 144, .external_lex_state = 4},
  [2153] = {.lex_state = 144, .external_lex_state = 4},
  [2154] = {.lex_state = 132, .external_lex_state = 10},
  [2155] = {.lex_state = 132, .external_lex_state = 10},
  [2156] = {.lex_state = 273, .external_lex_state = 10},
  [2157] = {.lex_state = 222, .external_lex_state = 23},
  [2158] = {.lex_state = 150, .external_lex_state = 11},
  [2159] = {.lex_state = 150, .external_lex_state = 11},
  [2160] = {.lex_state = 249, .external_lex_state = 23},
  [2161] = {.lex_state = 249, .external_lex_state = 23},
  [2162] = {.lex_state = 214, .external_lex_state = 22},
  [2163] = {.lex_state = 214, .external_lex_state = 22},
  [2164] = {.lex_state = 214, .external_lex_state = 16},
  [2165] = {.lex_state = 236, .external_lex_state = 16},
  [2166] = {.lex_state = 249, .external_lex_state = 23},
  [2167] = {.lex_state = 240},
  [2168] = {.lex_state = 238, .external_lex_state = 16},
  [2169] = {.lex_state = 240},
  [2170] = {.lex_state = 238, .external_lex_state = 16},
  [2171] = {.lex_state = 238, .external_lex_state = 16},
  [2172] = {.lex_state = 249, .external_lex_state = 23},
  [2173] = {.lex_state = 238, .external_lex_state = 16},
  [2174] = {.lex_state = 249, .external_lex_state = 23},
  [2175] = {.lex_state = 219, .external_lex_state = 2},
  [2176] = {.lex_state = 64, .external_lex_state = 2},
  [2177] = {.lex_state = 249, .external_lex_state = 23},
  [2178] = {.lex_state = 219, .external_lex_state = 2},
  [2179] = {.lex_state = 233, .external_lex_state = 13},
  [2180] = {.lex_state = 233, .external_lex_state = 13},
  [2181] = {.lex_state = 138, .external_lex_state = 14},
  [2182] = {.lex_state = 138, .external_lex_state = 14},
  [2183] = {.lex_state = 138, .external_lex_state = 10},
  [2184] = {.lex_state = 138, .external_lex_state = 10},
  [2185] = {.lex_state = 81, .external_lex_state = 15},
  [2186] = {.lex_state = 81, .external_lex_state = 15},
  [2187] = {.lex_state = 100, .external_lex_state = 13},
  [2188] = {.lex_state = 100, .external_lex_state = 13},
  [2189] = {.lex_state = 214, .external_lex_state = 22},
  [2190] = {.lex_state = 214, .external_lex_state = 22},
  [2191] = {.lex_state = 214, .external_lex_state = 22},
  [2192] = {.lex_state = 214, .external_lex_state = 22},
  [2193] = {.lex_state = 214, .external_lex_state = 16},
  [2194] = {.lex_state = 238, .external_lex_state = 16},
  [2195] = {.lex_state = 214, .external_lex_state = 22},
  [2196] = {.lex_state = 238, .external_lex_state = 16},
  [2197] = {.lex_state = 214, .external_lex_state = 22},
  [2198] = {.lex_state = 238, .external_lex_state = 16},
  [2199] = {.lex_state = 238, .external_lex_state = 16},
  [2200] = {.lex_state = 214, .external_lex_state = 22},
  [2201] = {.lex_state = 214, .external_lex_state = 22},
  [2202] = {.lex_state = 238, .external_lex_state = 22},
  [2203] = {.lex_state = 238, .external_lex_state = 22},
  [2204] = {.lex_state = 238, .external_lex_state = 22},
  [2205] = {.lex_state = 238, .external_lex_state = 16},
  [2206] = {.lex_state = 238, .external_lex_state = 16},
  [2207] = {.lex_state = 238, .external_lex_state = 22},
  [2208] = {.lex_state = 275, .external_lex_state = 10},
  [2209] = {.lex_state = 247, .external_lex_state = 23},
  [2210] = {.lex_state = 178, .external_lex_state = 17},
  [2211] = {.lex_state = 178, .external_lex_state = 17},
  [2212] = {.lex_state = 178, .external_lex_state = 17},
  [2213] = {.lex_state = 238, .external_lex_state = 16},
  [2214] = {.lex_state = 238, .external_lex_state = 16},
  [2215] = {.lex_state = 178, .external_lex_state = 17},
  [2216] = {.lex_state = 210, .external_lex_state = 13},
  [2217] = {.lex_state = 210, .external_lex_state = 13},
  [2218] = {.lex_state = 210, .external_lex_state = 13},
  [2219] = {.lex_state = 238, .external_lex_state = 16},
  [2220] = {.lex_state = 238, .external_lex_state = 16},
  [2221] = {.lex_state = 210, .external_lex_state = 13},
  [2222] = {.lex_state = 142, .external_lex_state = 19},
  [2223] = {.lex_state = 142, .external_lex_state = 19},
  [2224] = {.lex_state = 264, .external_lex_state = 13},
  [2225] = {.lex_state = 264, .external_lex_state = 13},
  [2226] = {.lex_state = 214, .external_lex_state = 22},
  [2227] = {.lex_state = 214, .external_lex_state = 22},
  [2228] = {.lex_state = 214, .external_lex_state = 16},
  [2229] = {.lex_state = 238, .external_lex_state = 16},
  [2230] = {.lex_state = 264, .external_lex_state = 13},
  [2231] = {.lex_state = 238, .external_lex_state = 16},
  [2232] = {.lex_state = 264, .external_lex_state = 13},
  [2233] = {.lex_state = 238, .external_lex_state = 16},
  [2234] = {.lex_state = 238, .external_lex_state = 16},
  [2235] = {.lex_state = 264, .external_lex_state = 13},
  [2236] = {.lex_state = 264, .external_lex_state = 13},
  [2237] = {.lex_state = 144, .external_lex_state = 4},
  [2238] = {.lex_state = 251, .external_lex_state = 10},
  [2239] = {.lex_state = 251, .external_lex_state = 10},
  [2240] = {.lex_state = 261},
  [2241] = {.lex_state = 253, .external_lex_state = 10},
  [2242] = {.lex_state = 253, .external_lex_state = 10},
  [2243] = {.lex_state = 253, .external_lex_state = 10},
  [2244] = {.lex_state = 238, .external_lex_state = 16},
  [2245] = {.lex_state = 238, .external_lex_state = 16},
  [2246] = {.lex_state = 253, .external_lex_state = 10},
  [2247] = {.lex_state = 287, .external_lex_state = 8},
  [2248] = {.lex_state = 210},
  [2249] = {.lex_state = 287, .external_lex_state = 19},
  [2250] = {.lex_state = 100},
  [2251] = {.lex_state = 107},
  [2252] = {.lex_state = 287, .external_lex_state = 19},
  [2253] = {.lex_state = 107, .external_lex_state = 6},
  [2254] = {.lex_state = 64, .external_lex_state = 2},
  [2255] = {.lex_state = 64, .external_lex_state = 2},
  [2256] = {.lex_state = 64, .external_lex_state = 2},
  [2257] = {.lex_state = 289, .external_lex_state = 7},
  [2258] = {.lex_state = 83},
  [2259] = {.lex_state = 291, .external_lex_state = 21},
  [2260] = {.lex_state = 289, .external_lex_state = 21},
  [2261] = {.lex_state = 127, .external_lex_state = 9},
  [2262] = {.lex_state = 81},
  [2263] = {.lex_state = 277, .external_lex_state = 14},
  [2264] = {.lex_state = 277, .external_lex_state = 14},
  [2265] = {.lex_state = 167},
  [2266] = {.lex_state = 100},
  [2267] = {.lex_state = 277, .external_lex_state = 14},
  [2268] = {.lex_state = 277, .external_lex_state = 14},
  [2269] = {.lex_state = 277, .external_lex_state = 14},
  [2270] = {.lex_state = 70},
  [2271] = {.lex_state = 173, .external_lex_state = 6},
  [2272] = {.lex_state = 175, .external_lex_state = 16},
  [2273] = {.lex_state = 175, .external_lex_state = 16},
  [2274] = {.lex_state = 138, .external_lex_state = 4},
  [2275] = {.lex_state = 142, .external_lex_state = 8},
  [2276] = {.lex_state = 64, .external_lex_state = 2},
  [2277] = {.lex_state = 93, .external_lex_state = 4},
  [2278] = {.lex_state = 123, .external_lex_state = 8},
  [2279] = {.lex_state = 64, .external_lex_state = 2},
  [2280] = {.lex_state = 138, .external_lex_state = 4},
  [2281] = {.lex_state = 142, .external_lex_state = 8},
  [2282] = {.lex_state = 64, .external_lex_state = 2},
  [2283] = {.lex_state = 277, .external_lex_state = 3},
  [2284] = {.lex_state = 81},
  [2285] = {.lex_state = 277, .external_lex_state = 10},
  [2286] = {.lex_state = 277, .external_lex_state = 10},
  [2287] = {.lex_state = 167},
  [2288] = {.lex_state = 100},
  [2289] = {.lex_state = 277, .external_lex_state = 10},
  [2290] = {.lex_state = 277, .external_lex_state = 10},
  [2291] = {.lex_state = 277, .external_lex_state = 10},
  [2292] = {.lex_state = 70},
  [2293] = {.lex_state = 173, .external_lex_state = 6},
  [2294] = {.lex_state = 175, .external_lex_state = 16},
  [2295] = {.lex_state = 175, .external_lex_state = 16},
  [2296] = {.lex_state = 138, .external_lex_state = 4},
  [2297] = {.lex_state = 142, .external_lex_state = 8},
  [2298] = {.lex_state = 64, .external_lex_state = 2},
  [2299] = {.lex_state = 93, .external_lex_state = 4},
  [2300] = {.lex_state = 123, .external_lex_state = 8},
  [2301] = {.lex_state = 64, .external_lex_state = 2},
  [2302] = {.lex_state = 138, .external_lex_state = 4},
  [2303] = {.lex_state = 142, .external_lex_state = 8},
  [2304] = {.lex_state = 64, .external_lex_state = 2},
  [2305] = {.lex_state = 277, .external_lex_state = 4},
  [2306] = {.lex_state = 283, .external_lex_state = 5},
  [2307] = {.lex_state = 283, .external_lex_state = 5},
  [2308] = {.lex_state = 283, .external_lex_state = 5},
  [2309] = {.lex_state = 167},
  [2310] = {.lex_state = 236, .external_lex_state = 16},
  [2311] = {.lex_state = 70},
  [2312] = {.lex_state = 175, .external_lex_state = 16},
  [2313] = {.lex_state = 175, .external_lex_state = 16},
  [2314] = {.lex_state = 283, .external_lex_state = 5},
  [2315] = {.lex_state = 240},
  [2316] = {.lex_state = 238, .external_lex_state = 16},
  [2317] = {.lex_state = 283, .external_lex_state = 5},
  [2318] = {.lex_state = 240},
  [2319] = {.lex_state = 238, .external_lex_state = 16},
  [2320] = {.lex_state = 219, .external_lex_state = 2},
  [2321] = {.lex_state = 283, .external_lex_state = 5},
  [2322] = {.lex_state = 138, .external_lex_state = 4},
  [2323] = {.lex_state = 142, .external_lex_state = 8},
  [2324] = {.lex_state = 64, .external_lex_state = 2},
  [2325] = {.lex_state = 93, .external_lex_state = 4},
  [2326] = {.lex_state = 123, .external_lex_state = 8},
  [2327] = {.lex_state = 219, .external_lex_state = 2},
  [2328] = {.lex_state = 283, .external_lex_state = 5},
  [2329] = {.lex_state = 138, .external_lex_state = 4},
  [2330] = {.lex_state = 142, .external_lex_state = 8},
  [2331] = {.lex_state = 136},
  [2332] = {.lex_state = 287, .external_lex_state = 8},
  [2333] = {.lex_state = 269, .external_lex_state = 4},
  [2334] = {.lex_state = 287, .external_lex_state = 8},
  [2335] = {.lex_state = 81},
  [2336] = {.lex_state = 283, .external_lex_state = 5},
  [2337] = {.lex_state = 283, .external_lex_state = 5},
  [2338] = {.lex_state = 283, .external_lex_state = 7},
  [2339] = {.lex_state = 289, .external_lex_state = 5},
  [2340] = {.lex_state = 100},
  [2341] = {.lex_state = 107},
  [2342] = {.lex_state = 289, .external_lex_state = 5},
  [2343] = {.lex_state = 107, .external_lex_state = 6},
  [2344] = {.lex_state = 64, .external_lex_state = 2},
  [2345] = {.lex_state = 64, .external_lex_state = 2},
  [2346] = {.lex_state = 64, .external_lex_state = 2},
  [2347] = {.lex_state = 289, .external_lex_state = 5},
  [2348] = {.lex_state = 289, .external_lex_state = 5},
  [2349] = {.lex_state = 289, .external_lex_state = 7},
  [2350] = {.lex_state = 289, .external_lex_state = 7},
  [2351] = {.lex_state = 283, .external_lex_state = 7},
  [2352] = {.lex_state = 271, .external_lex_state = 2},
  [2353] = {.lex_state = 93, .external_lex_state = 4},
  [2354] = {.lex_state = 123, .external_lex_state = 8},
  [2355] = {.lex_state = 283, .external_lex_state = 7},
  [2356] = {.lex_state = 255},
  [2357] = {.lex_state = 269, .external_lex_state = 4},
  [2358] = {.lex_state = 287, .external_lex_state = 8},
  [2359] = {.lex_state = 271, .external_lex_state = 2},
  [2360] = {.lex_state = 255},
  [2361] = {.lex_state = 269, .external_lex_state = 4},
  [2362] = {.lex_state = 287, .external_lex_state = 8},
  [2363] = {.lex_state = 81},
  [2364] = {.lex_state = 93, .external_lex_state = 4},
  [2365] = {.lex_state = 123, .external_lex_state = 8},
  [2366] = {.lex_state = 219, .external_lex_state = 2},
  [2367] = {.lex_state = 219, .external_lex_state = 2},
  [2368] = {.lex_state = 81},
  [2369] = {.lex_state = 93, .external_lex_state = 4},
  [2370] = {.lex_state = 123, .external_lex_state = 8},
  [2371] = {.lex_state = 219, .external_lex_state = 2},
  [2372] = {.lex_state = 219, .external_lex_state = 2},
  [2373] = {.lex_state = 249, .external_lex_state = 23},
  [2374] = {.lex_state = 249, .external_lex_state = 23},
  [2375] = {.lex_state = 214, .external_lex_state = 22},
  [2376] = {.lex_state = 214, .external_lex_state = 22},
  [2377] = {.lex_state = 214, .external_lex_state = 16},
  [2378] = {.lex_state = 238, .external_lex_state = 16},
  [2379] = {.lex_state = 249, .external_lex_state = 23},
  [2380] = {.lex_state = 238, .external_lex_state = 16},
  [2381] = {.lex_state = 249, .external_lex_state = 23},
  [2382] = {.lex_state = 238, .external_lex_state = 16},
  [2383] = {.lex_state = 238, .external_lex_state = 16},
  [2384] = {.lex_state = 249, .external_lex_state = 23},
  [2385] = {.lex_state = 249, .external_lex_state = 23},
  [2386] = {.lex_state = 214, .external_lex_state = 22},
  [2387] = {.lex_state = 214, .external_lex_state = 22},
  [2388] = {.lex_state = 214, .external_lex_state = 22},
  [2389] = {.lex_state = 238, .external_lex_state = 16},
  [2390] = {.lex_state = 238, .external_lex_state = 16},
  [2391] = {.lex_state = 214, .external_lex_state = 22},
  [2392] = {.lex_state = 238, .external_lex_state = 22},
  [2393] = {.lex_state = 238, .external_lex_state = 22},
  [2394] = {.lex_state = 178, .external_lex_state = 17},
  [2395] = {.lex_state = 178, .external_lex_state = 17},
  [2396] = {.lex_state = 210, .external_lex_state = 13},
  [2397] = {.lex_state = 210, .external_lex_state = 13},
  [2398] = {.lex_state = 264, .external_lex_state = 13},
  [2399] = {.lex_state = 264, .external_lex_state = 13},
  [2400] = {.lex_state = 264, .external_lex_state = 13},
  [2401] = {.lex_state = 238, .external_lex_state = 16},
  [2402] = {.lex_state = 238, .external_lex_state = 16},
  [2403] = {.lex_state = 264, .external_lex_state = 13},
  [2404] = {.lex_state = 144, .external_lex_state = 4},
  [2405] = {.lex_state = 253, .external_lex_state = 10},
  [2406] = {.lex_state = 253, .external_lex_state = 10},
  [2407] = {.lex_state = 287, .external_lex_state = 8},
  [2408] = {.lex_state = 210},
  [2409] = {.lex_state = 81},
  [2410] = {.lex_state = 287, .external_lex_state = 19},
  [2411] = {.lex_state = 287, .external_lex_state = 19},
  [2412] = {.lex_state = 167},
  [2413] = {.lex_state = 100},
  [2414] = {.lex_state = 287, .external_lex_state = 19},
  [2415] = {.lex_state = 287, .external_lex_state = 19},
  [2416] = {.lex_state = 287, .external_lex_state = 19},
  [2417] = {.lex_state = 70},
  [2418] = {.lex_state = 173, .external_lex_state = 6},
  [2419] = {.lex_state = 175, .external_lex_state = 16},
  [2420] = {.lex_state = 175, .external_lex_state = 16},
  [2421] = {.lex_state = 138, .external_lex_state = 4},
  [2422] = {.lex_state = 142, .external_lex_state = 8},
  [2423] = {.lex_state = 64, .external_lex_state = 2},
  [2424] = {.lex_state = 93, .external_lex_state = 4},
  [2425] = {.lex_state = 123, .external_lex_state = 8},
  [2426] = {.lex_state = 64, .external_lex_state = 2},
  [2427] = {.lex_state = 138, .external_lex_state = 4},
  [2428] = {.lex_state = 142, .external_lex_state = 8},
  [2429] = {.lex_state = 64, .external_lex_state = 2},
  [2430] = {.lex_state = 289, .external_lex_state = 7},
  [2431] = {.lex_state = 136},
  [2432] = {.lex_state = 64},
  [2433] = {.lex_state = 81},
  [2434] = {.lex_state = 64},
  [2435] = {.lex_state = 81},
  [2436] = {.lex_state = 81},
  [2437] = {.lex_state = 289, .external_lex_state = 21},
  [2438] = {.lex_state = 277, .external_lex_state = 3},
  [2439] = {.lex_state = 210},
  [2440] = {.lex_state = 277, .external_lex_state = 14},
  [2441] = {.lex_state = 277, .external_lex_state = 14},
  [2442] = {.lex_state = 277, .external_lex_state = 14},
  [2443] = {.lex_state = 277, .external_lex_state = 14},
  [2444] = {.lex_state = 277, .external_lex_state = 14},
  [2445] = {.lex_state = 167},
  [2446] = {.lex_state = 236, .external_lex_state = 16},
  [2447] = {.lex_state = 70},
  [2448] = {.lex_state = 175, .external_lex_state = 16},
  [2449] = {.lex_state = 175, .external_lex_state = 16},
  [2450] = {.lex_state = 277, .external_lex_state = 14},
  [2451] = {.lex_state = 240},
  [2452] = {.lex_state = 238, .external_lex_state = 16},
  [2453] = {.lex_state = 277, .external_lex_state = 14},
  [2454] = {.lex_state = 240},
  [2455] = {.lex_state = 238, .external_lex_state = 16},
  [2456] = {.lex_state = 219, .external_lex_state = 2},
  [2457] = {.lex_state = 277, .external_lex_state = 14},
  [2458] = {.lex_state = 138, .external_lex_state = 4},
  [2459] = {.lex_state = 142, .external_lex_state = 8},
  [2460] = {.lex_state = 64, .external_lex_state = 2},
  [2461] = {.lex_state = 93, .external_lex_state = 4},
  [2462] = {.lex_state = 123, .external_lex_state = 8},
  [2463] = {.lex_state = 219, .external_lex_state = 2},
  [2464] = {.lex_state = 277, .external_lex_state = 14},
  [2465] = {.lex_state = 138, .external_lex_state = 4},
  [2466] = {.lex_state = 142, .external_lex_state = 8},
  [2467] = {.lex_state = 277, .external_lex_state = 10},
  [2468] = {.lex_state = 277, .external_lex_state = 10},
  [2469] = {.lex_state = 277, .external_lex_state = 10},
  [2470] = {.lex_state = 167},
  [2471] = {.lex_state = 236, .external_lex_state = 16},
  [2472] = {.lex_state = 70},
  [2473] = {.lex_state = 175, .external_lex_state = 16},
  [2474] = {.lex_state = 175, .external_lex_state = 16},
  [2475] = {.lex_state = 277, .external_lex_state = 10},
  [2476] = {.lex_state = 240},
  [2477] = {.lex_state = 238, .external_lex_state = 16},
  [2478] = {.lex_state = 277, .external_lex_state = 10},
  [2479] = {.lex_state = 240},
  [2480] = {.lex_state = 238, .external_lex_state = 16},
  [2481] = {.lex_state = 219, .external_lex_state = 2},
  [2482] = {.lex_state = 277, .external_lex_state = 10},
  [2483] = {.lex_state = 138, .external_lex_state = 4},
  [2484] = {.lex_state = 142, .external_lex_state = 8},
  [2485] = {.lex_state = 64, .external_lex_state = 2},
  [2486] = {.lex_state = 93, .external_lex_state = 4},
  [2487] = {.lex_state = 123, .external_lex_state = 8},
  [2488] = {.lex_state = 219, .external_lex_state = 2},
  [2489] = {.lex_state = 277, .external_lex_state = 10},
  [2490] = {.lex_state = 138, .external_lex_state = 4},
  [2491] = {.lex_state = 142, .external_lex_state = 8},
  [2492] = {.lex_state = 283, .external_lex_state = 5},
  [2493] = {.lex_state = 283, .external_lex_state = 5},
  [2494] = {.lex_state = 214, .external_lex_state = 22},
  [2495] = {.lex_state = 214, .external_lex_state = 22},
  [2496] = {.lex_state = 214, .external_lex_state = 16},
  [2497] = {.lex_state = 236, .external_lex_state = 16},
  [2498] = {.lex_state = 283, .external_lex_state = 5},
  [2499] = {.lex_state = 240},
  [2500] = {.lex_state = 238, .external_lex_state = 16},
  [2501] = {.lex_state = 240},
  [2502] = {.lex_state = 238, .external_lex_state = 16},
  [2503] = {.lex_state = 238, .external_lex_state = 16},
  [2504] = {.lex_state = 283, .external_lex_state = 5},
  [2505] = {.lex_state = 238, .external_lex_state = 16},
  [2506] = {.lex_state = 283, .external_lex_state = 5},
  [2507] = {.lex_state = 219, .external_lex_state = 2},
  [2508] = {.lex_state = 64, .external_lex_state = 2},
  [2509] = {.lex_state = 283, .external_lex_state = 5},
  [2510] = {.lex_state = 219, .external_lex_state = 2},
  [2511] = {.lex_state = 291, .external_lex_state = 21},
  [2512] = {.lex_state = 289, .external_lex_state = 5},
  [2513] = {.lex_state = 289, .external_lex_state = 5},
  [2514] = {.lex_state = 81},
  [2515] = {.lex_state = 289, .external_lex_state = 5},
  [2516] = {.lex_state = 289, .external_lex_state = 5},
  [2517] = {.lex_state = 167},
  [2518] = {.lex_state = 100},
  [2519] = {.lex_state = 289, .external_lex_state = 5},
  [2520] = {.lex_state = 289, .external_lex_state = 5},
  [2521] = {.lex_state = 289, .external_lex_state = 5},
  [2522] = {.lex_state = 70},
  [2523] = {.lex_state = 173, .external_lex_state = 6},
  [2524] = {.lex_state = 175, .external_lex_state = 16},
  [2525] = {.lex_state = 175, .external_lex_state = 16},
  [2526] = {.lex_state = 138, .external_lex_state = 4},
  [2527] = {.lex_state = 142, .external_lex_state = 8},
  [2528] = {.lex_state = 64, .external_lex_state = 2},
  [2529] = {.lex_state = 93, .external_lex_state = 4},
  [2530] = {.lex_state = 123, .external_lex_state = 8},
  [2531] = {.lex_state = 64, .external_lex_state = 2},
  [2532] = {.lex_state = 138, .external_lex_state = 4},
  [2533] = {.lex_state = 142, .external_lex_state = 8},
  [2534] = {.lex_state = 64, .external_lex_state = 2},
  [2535] = {.lex_state = 289, .external_lex_state = 7},
  [2536] = {.lex_state = 271, .external_lex_state = 2},
  [2537] = {.lex_state = 271, .external_lex_state = 2},
  [2538] = {.lex_state = 219, .external_lex_state = 2},
  [2539] = {.lex_state = 81},
  [2540] = {.lex_state = 93, .external_lex_state = 4},
  [2541] = {.lex_state = 123, .external_lex_state = 8},
  [2542] = {.lex_state = 219, .external_lex_state = 2},
  [2543] = {.lex_state = 219, .external_lex_state = 2},
  [2544] = {.lex_state = 219, .external_lex_state = 2},
  [2545] = {.lex_state = 81},
  [2546] = {.lex_state = 93, .external_lex_state = 4},
  [2547] = {.lex_state = 123, .external_lex_state = 8},
  [2548] = {.lex_state = 219, .external_lex_state = 2},
  [2549] = {.lex_state = 249, .external_lex_state = 23},
  [2550] = {.lex_state = 249, .external_lex_state = 23},
  [2551] = {.lex_state = 249, .external_lex_state = 23},
  [2552] = {.lex_state = 238, .external_lex_state = 16},
  [2553] = {.lex_state = 238, .external_lex_state = 16},
  [2554] = {.lex_state = 249, .external_lex_state = 23},
  [2555] = {.lex_state = 214, .external_lex_state = 22},
  [2556] = {.lex_state = 214, .external_lex_state = 22},
  [2557] = {.lex_state = 264, .external_lex_state = 13},
  [2558] = {.lex_state = 264, .external_lex_state = 13},
  [2559] = {.lex_state = 287, .external_lex_state = 8},
  [2560] = {.lex_state = 287, .external_lex_state = 19},
  [2561] = {.lex_state = 287, .external_lex_state = 19},
  [2562] = {.lex_state = 287, .external_lex_state = 19},
  [2563] = {.lex_state = 167},
  [2564] = {.lex_state = 236, .external_lex_state = 16},
  [2565] = {.lex_state = 70},
  [2566] = {.lex_state = 175, .external_lex_state = 16},
  [2567] = {.lex_state = 175, .external_lex_state = 16},
  [2568] = {.lex_state = 287, .external_lex_state = 19},
  [2569] = {.lex_state = 240},
  [2570] = {.lex_state = 238, .external_lex_state = 16},
  [2571] = {.lex_state = 287, .external_lex_state = 19},
  [2572] = {.lex_state = 240},
  [2573] = {.lex_state = 238, .external_lex_state = 16},
  [2574] = {.lex_state = 219, .external_lex_state = 2},
  [2575] = {.lex_state = 287, .external_lex_state = 19},
  [2576] = {.lex_state = 138, .external_lex_state = 4},
  [2577] = {.lex_state = 142, .external_lex_state = 8},
  [2578] = {.lex_state = 64, .external_lex_state = 2},
  [2579] = {.lex_state = 93, .external_lex_state = 4},
  [2580] = {.lex_state = 123, .external_lex_state = 8},
  [2581] = {.lex_state = 219, .external_lex_state = 2},
  [2582] = {.lex_state = 287, .external_lex_state = 19},
  [2583] = {.lex_state = 138, .external_lex_state = 4},
  [2584] = {.lex_state = 142, .external_lex_state = 8},
  [2585] = {.lex_state = 291, .external_lex_state = 21},
  [2586] = {.lex_state = 81},
  [2587] = {.lex_state = 269, .external_lex_state = 10},
  [2588] = {.lex_state = 269, .external_lex_state = 10},
  [2589] = {.lex_state = 81},
  [2590] = {.lex_state = 289, .external_lex_state = 23},
  [2591] = {.lex_state = 289, .external_lex_state = 23},
  [2592] = {.lex_state = 289, .external_lex_state = 23},
  [2593] = {.lex_state = 289, .external_lex_state = 23},
  [2594] = {.lex_state = 289, .external_lex_state = 21},
  [2595] = {.lex_state = 277, .external_lex_state = 3},
  [2596] = {.lex_state = 210},
  [2597] = {.lex_state = 277, .external_lex_state = 14},
  [2598] = {.lex_state = 277, .external_lex_state = 14},
  [2599] = {.lex_state = 214, .external_lex_state = 22},
  [2600] = {.lex_state = 214, .external_lex_state = 22},
  [2601] = {.lex_state = 214, .external_lex_state = 16},
  [2602] = {.lex_state = 236, .external_lex_state = 16},
  [2603] = {.lex_state = 277, .external_lex_state = 14},
  [2604] = {.lex_state = 240},
  [2605] = {.lex_state = 238, .external_lex_state = 16},
  [2606] = {.lex_state = 240},
  [2607] = {.lex_state = 238, .external_lex_state = 16},
  [2608] = {.lex_state = 238, .external_lex_state = 16},
  [2609] = {.lex_state = 277, .external_lex_state = 14},
  [2610] = {.lex_state = 238, .external_lex_state = 16},
  [2611] = {.lex_state = 277, .external_lex_state = 14},
  [2612] = {.lex_state = 219, .external_lex_state = 2},
  [2613] = {.lex_state = 64, .external_lex_state = 2},
  [2614] = {.lex_state = 277, .external_lex_state = 14},
  [2615] = {.lex_state = 219, .external_lex_state = 2},
  [2616] = {.lex_state = 277, .external_lex_state = 10},
  [2617] = {.lex_state = 277, .external_lex_state = 10},
  [2618] = {.lex_state = 214, .external_lex_state = 22},
  [2619] = {.lex_state = 214, .external_lex_state = 22},
  [2620] = {.lex_state = 214, .external_lex_state = 16},
  [2621] = {.lex_state = 236, .external_lex_state = 16},
  [2622] = {.lex_state = 277, .external_lex_state = 10},
  [2623] = {.lex_state = 240},
  [2624] = {.lex_state = 238, .external_lex_state = 16},
  [2625] = {.lex_state = 240},
  [2626] = {.lex_state = 238, .external_lex_state = 16},
  [2627] = {.lex_state = 238, .external_lex_state = 16},
  [2628] = {.lex_state = 277, .external_lex_state = 10},
  [2629] = {.lex_state = 238, .external_lex_state = 16},
  [2630] = {.lex_state = 277, .external_lex_state = 10},
  [2631] = {.lex_state = 219, .external_lex_state = 2},
  [2632] = {.lex_state = 64, .external_lex_state = 2},
  [2633] = {.lex_state = 277, .external_lex_state = 10},
  [2634] = {.lex_state = 219, .external_lex_state = 2},
  [2635] = {.lex_state = 283, .external_lex_state = 5},
  [2636] = {.lex_state = 283, .external_lex_state = 5},
  [2637] = {.lex_state = 214, .external_lex_state = 22},
  [2638] = {.lex_state = 214, .external_lex_state = 22},
  [2639] = {.lex_state = 214, .external_lex_state = 16},
  [2640] = {.lex_state = 238, .external_lex_state = 16},
  [2641] = {.lex_state = 283, .external_lex_state = 5},
  [2642] = {.lex_state = 238, .external_lex_state = 16},
  [2643] = {.lex_state = 283, .external_lex_state = 5},
  [2644] = {.lex_state = 238, .external_lex_state = 16},
  [2645] = {.lex_state = 238, .external_lex_state = 16},
  [2646] = {.lex_state = 283, .external_lex_state = 5},
  [2647] = {.lex_state = 283, .external_lex_state = 5},
  [2648] = {.lex_state = 289, .external_lex_state = 5},
  [2649] = {.lex_state = 289, .external_lex_state = 5},
  [2650] = {.lex_state = 289, .external_lex_state = 5},
  [2651] = {.lex_state = 167},
  [2652] = {.lex_state = 236, .external_lex_state = 16},
  [2653] = {.lex_state = 70},
  [2654] = {.lex_state = 175, .external_lex_state = 16},
  [2655] = {.lex_state = 175, .external_lex_state = 16},
  [2656] = {.lex_state = 289, .external_lex_state = 5},
  [2657] = {.lex_state = 240},
  [2658] = {.lex_state = 238, .external_lex_state = 16},
  [2659] = {.lex_state = 289, .external_lex_state = 5},
  [2660] = {.lex_state = 240},
  [2661] = {.lex_state = 238, .external_lex_state = 16},
  [2662] = {.lex_state = 219, .external_lex_state = 2},
  [2663] = {.lex_state = 289, .external_lex_state = 5},
  [2664] = {.lex_state = 138, .external_lex_state = 4},
  [2665] = {.lex_state = 142, .external_lex_state = 8},
  [2666] = {.lex_state = 64, .external_lex_state = 2},
  [2667] = {.lex_state = 93, .external_lex_state = 4},
  [2668] = {.lex_state = 123, .external_lex_state = 8},
  [2669] = {.lex_state = 219, .external_lex_state = 2},
  [2670] = {.lex_state = 289, .external_lex_state = 5},
  [2671] = {.lex_state = 138, .external_lex_state = 4},
  [2672] = {.lex_state = 142, .external_lex_state = 8},
  [2673] = {.lex_state = 219, .external_lex_state = 2},
  [2674] = {.lex_state = 81},
  [2675] = {.lex_state = 93, .external_lex_state = 4},
  [2676] = {.lex_state = 123, .external_lex_state = 8},
  [2677] = {.lex_state = 219, .external_lex_state = 2},
  [2678] = {.lex_state = 81},
  [2679] = {.lex_state = 93, .external_lex_state = 4},
  [2680] = {.lex_state = 123, .external_lex_state = 8},
  [2681] = {.lex_state = 249, .external_lex_state = 23},
  [2682] = {.lex_state = 249, .external_lex_state = 23},
  [2683] = {.lex_state = 287, .external_lex_state = 19},
  [2684] = {.lex_state = 287, .external_lex_state = 19},
  [2685] = {.lex_state = 214, .external_lex_state = 22},
  [2686] = {.lex_state = 214, .external_lex_state = 22},
  [2687] = {.lex_state = 214, .external_lex_state = 16},
  [2688] = {.lex_state = 236, .external_lex_state = 16},
  [2689] = {.lex_state = 287, .external_lex_state = 19},
  [2690] = {.lex_state = 240},
  [2691] = {.lex_state = 238, .external_lex_state = 16},
  [2692] = {.lex_state = 240},
  [2693] = {.lex_state = 238, .external_lex_state = 16},
  [2694] = {.lex_state = 238, .external_lex_state = 16},
  [2695] = {.lex_state = 287, .external_lex_state = 19},
  [2696] = {.lex_state = 238, .external_lex_state = 16},
  [2697] = {.lex_state = 287, .external_lex_state = 19},
  [2698] = {.lex_state = 219, .external_lex_state = 2},
  [2699] = {.lex_state = 64, .external_lex_state = 2},
  [2700] = {.lex_state = 287, .external_lex_state = 19},
  [2701] = {.lex_state = 219, .external_lex_state = 2},
  [2702] = {.lex_state = 269, .external_lex_state = 10},
  [2703] = {.lex_state = 269, .external_lex_state = 10},
  [2704] = {.lex_state = 269, .external_lex_state = 10},
  [2705] = {.lex_state = 289, .external_lex_state = 23},
  [2706] = {.lex_state = 289, .external_lex_state = 23},
  [2707] = {.lex_state = 289, .external_lex_state = 23},
  [2708] = {.lex_state = 277, .external_lex_state = 3},
  [2709] = {.lex_state = 277, .external_lex_state = 14},
  [2710] = {.lex_state = 277, .external_lex_state = 14},
  [2711] = {.lex_state = 214, .external_lex_state = 22},
  [2712] = {.lex_state = 214, .external_lex_state = 22},
  [2713] = {.lex_state = 214, .external_lex_state = 16},
  [2714] = {.lex_state = 238, .external_lex_state = 16},
  [2715] = {.lex_state = 277, .external_lex_state = 14},
  [2716] = {.lex_state = 238, .external_lex_state = 16},
  [2717] = {.lex_state = 277, .external_lex_state = 14},
  [2718] = {.lex_state = 238, .external_lex_state = 16},
  [2719] = {.lex_state = 238, .external_lex_state = 16},
  [2720] = {.lex_state = 277, .external_lex_state = 14},
  [2721] = {.lex_state = 277, .external_lex_state = 14},
  [2722] = {.lex_state = 277, .external_lex_state = 10},
  [2723] = {.lex_state = 277, .external_lex_state = 10},
  [2724] = {.lex_state = 214, .external_lex_state = 22},
  [2725] = {.lex_state = 214, .external_lex_state = 22},
  [2726] = {.lex_state = 214, .external_lex_state = 16},
  [2727] = {.lex_state = 238, .external_lex_state = 16},
  [2728] = {.lex_state = 277, .external_lex_state = 10},
  [2729] = {.lex_state = 238, .external_lex_state = 16},
  [2730] = {.lex_state = 277, .external_lex_state = 10},
  [2731] = {.lex_state = 238, .external_lex_state = 16},
  [2732] = {.lex_state = 238, .external_lex_state = 16},
  [2733] = {.lex_state = 277, .external_lex_state = 10},
  [2734] = {.lex_state = 277, .external_lex_state = 10},
  [2735] = {.lex_state = 283, .external_lex_state = 5},
  [2736] = {.lex_state = 283, .external_lex_state = 5},
  [2737] = {.lex_state = 283, .external_lex_state = 5},
  [2738] = {.lex_state = 238, .external_lex_state = 16},
  [2739] = {.lex_state = 238, .external_lex_state = 16},
  [2740] = {.lex_state = 283, .external_lex_state = 5},
  [2741] = {.lex_state = 289, .external_lex_state = 5},
  [2742] = {.lex_state = 289, .external_lex_state = 5},
  [2743] = {.lex_state = 214, .external_lex_state = 22},
  [2744] = {.lex_state = 214, .external_lex_state = 22},
  [2745] = {.lex_state = 214, .external_lex_state = 16},
  [2746] = {.lex_state = 236, .external_lex_state = 16},
  [2747] = {.lex_state = 289, .external_lex_state = 5},
  [2748] = {.lex_state = 240},
  [2749] = {.lex_state = 238, .external_lex_state = 16},
  [2750] = {.lex_state = 240},
  [2751] = {.lex_state = 238, .external_lex_state = 16},
  [2752] = {.lex_state = 238, .external_lex_state = 16},
  [2753] = {.lex_state = 289, .external_lex_state = 5},
  [2754] = {.lex_state = 238, .external_lex_state = 16},
  [2755] = {.lex_state = 289, .external_lex_state = 5},
  [2756] = {.lex_state = 219, .external_lex_state = 2},
  [2757] = {.lex_state = 64, .external_lex_state = 2},
  [2758] = {.lex_state = 289, .external_lex_state = 5},
  [2759] = {.lex_state = 219, .external_lex_state = 2},
  [2760] = {.lex_state = 219, .external_lex_state = 2},
  [2761] = {.lex_state = 219, .external_lex_state = 2},
  [2762] = {.lex_state = 287, .external_lex_state = 19},
  [2763] = {.lex_state = 287, .external_lex_state = 19},
  [2764] = {.lex_state = 214, .external_lex_state = 22},
  [2765] = {.lex_state = 214, .external_lex_state = 22},
  [2766] = {.lex_state = 214, .external_lex_state = 16},
  [2767] = {.lex_state = 238, .external_lex_state = 16},
  [2768] = {.lex_state = 287, .external_lex_state = 19},
  [2769] = {.lex_state = 238, .external_lex_state = 16},
  [2770] = {.lex_state = 287, .external_lex_state = 19},
  [2771] = {.lex_state = 238, .external_lex_state = 16},
  [2772] = {.lex_state = 238, .external_lex_state = 16},
  [2773] = {.lex_state = 287, .external_lex_state = 19},
  [2774] = {.lex_state = 287, .external_lex_state = 19},
  [2775] = {.lex_state = 269, .external_lex_state = 10},
  [2776] = {.lex_state = 289, .external_lex_state = 23},
  [2777] = {.lex_state = 277, .external_lex_state = 14},
  [2778] = {.lex_state = 277, .external_lex_state = 14},
  [2779] = {.lex_state = 277, .external_lex_state = 14},
  [2780] = {.lex_state = 238, .external_lex_state = 16},
  [2781] = {.lex_state = 238, .external_lex_state = 16},
  [2782] = {.lex_state = 277, .external_lex_state = 14},
  [2783] = {.lex_state = 277, .external_lex_state = 10},
  [2784] = {.lex_state = 277, .external_lex_state = 10},
  [2785] = {.lex_state = 277, .external_lex_state = 10},
  [2786] = {.lex_state = 238, .external_lex_state = 16},
  [2787] = {.lex_state = 238, .external_lex_state = 16},
  [2788] = {.lex_state = 277, .external_lex_state = 10},
  [2789] = {.lex_state = 283, .external_lex_state = 5},
  [2790] = {.lex_state = 283, .external_lex_state = 5},
  [2791] = {.lex_state = 289, .external_lex_state = 5},
  [2792] = {.lex_state = 289, .external_lex_state = 5},
  [2793] = {.lex_state = 214, .external_lex_state = 22},
  [2794] = {.lex_state = 214, .external_lex_state = 22},
  [2795] = {.lex_state = 214, .external_lex_state = 16},
  [2796] = {.lex_state = 238, .external_lex_state = 16},
  [2797] = {.lex_state = 289, .external_lex_state = 5},
  [2798] = {.lex_state = 238, .external_lex_state = 16},
  [2799] = {.lex_state = 289, .external_lex_state = 5},
  [2800] = {.lex_state = 238, .external_lex_state = 16},
  [2801] = {.lex_state = 238, .external_lex_state = 16},
  [2802] = {.lex_state = 289, .external_lex_state = 5},
  [2803] = {.lex_state = 289, .external_lex_state = 5},
  [2804] = {.lex_state = 287, .external_lex_state = 19},
  [2805] = {.lex_state = 287, .external_lex_state = 19},
  [2806] = {.lex_state = 287, .external_lex_state = 19},
  [2807] = {.lex_state = 238, .external_lex_state = 16},
  [2808] = {.lex_state = 238, .external_lex_state = 16},
  [2809] = {.lex_state = 287, .external_lex_state = 19},
  [2810] = {.lex_state = 277, .external_lex_state = 14},
  [2811] = {.lex_state = 277, .external_lex_state = 14},
  [2812] = {.lex_state = 277, .external_lex_state = 10},
  [2813] = {.lex_state = 277, .external_lex_state = 10},
  [2814] = {.lex_state = 289, .external_lex_state = 5},
  [2815] = {.lex_state = 289, .external_lex_state = 5},
  [2816] = {.lex_state = 289, .external_lex_state = 5},
  [2817] = {.lex_state = 238, .external_lex_state = 16},
  [2818] = {.lex_state = 238, .external_lex_state = 16},
  [2819] = {.lex_state = 289, .external_lex_state = 5},
  [2820] = {.lex_state = 287, .external_lex_state = 19},
  [2821] = {.lex_state = 287, .external_lex_state = 19},
  [2822] = {.lex_state = 289, .external_lex_state = 5},
  [2823] = {.lex_state = 289, .external_lex_state = 5},
};

enum {
  ts_external_token_heredoc_start,
  ts_external_token__simple_heredoc_body,
  ts_external_token__heredoc_body_beginning,
  ts_external_token__heredoc_body_middle,
  ts_external_token__heredoc_body_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_RBRACE,
  ts_external_token_RBRACK,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token__simple_heredoc_body] = sym__simple_heredoc_body,
  [ts_external_token__heredoc_body_beginning] = sym__heredoc_body_beginning,
  [ts_external_token__heredoc_body_middle] = sym__heredoc_body_middle,
  [ts_external_token__heredoc_body_end] = sym__heredoc_body_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[24][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_heredoc_start] = true,
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_LF] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token_variable_name] = true,
  },
  [7] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [8] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [9] = {
    [ts_external_token__empty_value] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [11] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [12] = {
    [ts_external_token_RBRACK] = true,
  },
  [13] = {
    [ts_external_token__concat] = true,
  },
  [14] = {
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [16] = {
    [ts_external_token_RBRACE] = true,
  },
  [17] = {
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
  },
  [18] = {
    [ts_external_token_heredoc_start] = true,
  },
  [19] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [20] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
  },
  [21] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [22] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
  },
  [23] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_start] = ACTIONS(1),
    [sym__simple_heredoc_body] = ACTIONS(1),
    [sym__heredoc_body_beginning] = ACTIONS(1),
    [sym__heredoc_body_middle] = ACTIONS(1),
    [sym__heredoc_body_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_done] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_fi] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_esac] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_typeset] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(3),
    [anon_sym_unsetenv] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [sym__special_characters] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_LF] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(25),
    [sym__terminated_statement] = STATE(31),
    [sym_for_statement] = STATE(26),
    [sym_c_style_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_subshell] = STATE(26),
    [sym_pipeline] = STATE(26),
    [sym_list] = STATE(26),
    [sym_negated_command] = STATE(26),
    [sym_test_command] = STATE(26),
    [sym_declaration_command] = STATE(26),
    [sym_unset_command] = STATE(26),
    [sym_command] = STATE(26),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(28),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(32),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym__statements_repeat1] = STATE(31),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(9),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(57),
    [anon_sym_GT] = ACTIONS(57),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_AMP_GT] = ACTIONS(57),
    [anon_sym_AMP_GT_GT] = ACTIONS(59),
    [anon_sym_LT_AMP] = ACTIONS(59),
    [anon_sym_GT_AMP] = ACTIONS(59),
    [sym_comment] = ACTIONS(53),
  },
  [3] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(63),
    [anon_sym_PLUS_EQ] = ACTIONS(63),
    [sym_comment] = ACTIONS(53),
  },
  [4] = {
    [anon_sym_LPAREN_LPAREN] = ACTIONS(65),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(67),
  },
  [5] = {
    [sym__terminated_statement] = STATE(49),
    [sym_for_statement] = STATE(50),
    [sym_c_style_for_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_case_statement] = STATE(50),
    [sym_function_definition] = STATE(50),
    [sym_subshell] = STATE(50),
    [sym_pipeline] = STATE(50),
    [sym_list] = STATE(50),
    [sym_negated_command] = STATE(50),
    [sym_test_command] = STATE(50),
    [sym_declaration_command] = STATE(50),
    [sym_unset_command] = STATE(50),
    [sym_command] = STATE(50),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(52),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [6] = {
    [sym__terminated_statement] = STATE(55),
    [sym_for_statement] = STATE(50),
    [sym_c_style_for_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_case_statement] = STATE(50),
    [sym_function_definition] = STATE(50),
    [sym_subshell] = STATE(50),
    [sym_pipeline] = STATE(50),
    [sym_list] = STATE(50),
    [sym_negated_command] = STATE(50),
    [sym_test_command] = STATE(50),
    [sym_declaration_command] = STATE(50),
    [sym_unset_command] = STATE(50),
    [sym_command] = STATE(50),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(52),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [7] = {
    [sym_concatenation] = STATE(64),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_string_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [sym__special_characters] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [anon_sym_DOLLAR] = ACTIONS(95),
    [sym_raw_string] = ACTIONS(97),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(99),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(103),
    [anon_sym_LT_LPAREN] = ACTIONS(105),
    [anon_sym_GT_LPAREN] = ACTIONS(105),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(97),
  },
  [8] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(107),
  },
  [9] = {
    [sym__terminated_statement] = STATE(81),
    [sym_for_statement] = STATE(77),
    [sym_c_style_for_statement] = STATE(77),
    [sym_while_statement] = STATE(77),
    [sym_if_statement] = STATE(77),
    [sym_case_statement] = STATE(77),
    [sym_function_definition] = STATE(77),
    [sym_subshell] = STATE(77),
    [sym_pipeline] = STATE(77),
    [sym_list] = STATE(77),
    [sym_negated_command] = STATE(77),
    [sym_test_command] = STATE(77),
    [sym_declaration_command] = STATE(77),
    [sym_unset_command] = STATE(77),
    [sym_command] = STATE(77),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(79),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(81),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [10] = {
    [sym_subshell] = STATE(84),
    [sym_test_command] = STATE(84),
    [sym_command] = STATE(84),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(32),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(32),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(43),
  },
  [11] = {
    [sym__expression] = STATE(96),
    [sym_binary_expression] = STATE(96),
    [sym_unary_expression] = STATE(96),
    [sym_parenthesized_expression] = STATE(96),
    [sym_concatenation] = STATE(96),
    [sym_string] = STATE(91),
    [sym_simple_expansion] = STATE(91),
    [sym_string_expansion] = STATE(91),
    [sym_expansion] = STATE(91),
    [sym_command_substitution] = STATE(91),
    [sym_process_substitution] = STATE(91),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [12] = {
    [sym__expression] = STATE(107),
    [sym_binary_expression] = STATE(107),
    [sym_unary_expression] = STATE(107),
    [sym_parenthesized_expression] = STATE(107),
    [sym_concatenation] = STATE(107),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(177),
    [sym_test_operator] = ACTIONS(179),
  },
  [13] = {
    [sym_variable_assignment] = STATE(118),
    [sym_subscript] = STATE(117),
    [sym_concatenation] = STATE(118),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_string_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_declaration_command_repeat1] = STATE(118),
    [sym_variable_name] = ACTIONS(181),
    [ts_builtin_sym_end] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_SEMI_SEMI] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [sym__special_characters] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(203),
    [sym_word] = ACTIONS(205),
    [anon_sym_LF] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [14] = {
    [sym_concatenation] = STATE(127),
    [sym_string] = STATE(122),
    [sym_simple_expansion] = STATE(122),
    [sym_string_expansion] = STATE(122),
    [sym_expansion] = STATE(122),
    [sym_command_substitution] = STATE(122),
    [sym_process_substitution] = STATE(122),
    [aux_sym_unset_command_repeat1] = STATE(127),
    [ts_builtin_sym_end] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_SEMI_SEMI] = ACTIONS(207),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [sym__special_characters] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(227),
    [sym_word] = ACTIONS(229),
    [anon_sym_LF] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(209),
  },
  [15] = {
    [sym_concatenation] = STATE(136),
    [sym_string] = STATE(131),
    [sym_simple_expansion] = STATE(131),
    [sym_string_expansion] = STATE(131),
    [sym_expansion] = STATE(131),
    [sym_command_substitution] = STATE(131),
    [sym_process_substitution] = STATE(131),
    [sym__special_characters] = ACTIONS(231),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_raw_string] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(241),
    [anon_sym_BQUOTE] = ACTIONS(243),
    [anon_sym_LT_LPAREN] = ACTIONS(245),
    [anon_sym_GT_LPAREN] = ACTIONS(245),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(237),
  },
  [16] = {
    [aux_sym_concatenation_repeat1] = STATE(138),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [anon_sym_SEMI_SEMI] = ACTIONS(247),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(251),
    [anon_sym_EQ_EQ] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(251),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(251),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(251),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(251),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(251),
  },
  [17] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(145),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [18] = {
    [sym_string] = STATE(147),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(267),
    [sym_raw_string] = ACTIONS(269),
    [anon_sym_POUND] = ACTIONS(267),
    [anon_sym_DASH] = ACTIONS(267),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(271),
    [anon_sym_STAR] = ACTIONS(273),
    [anon_sym_AT] = ACTIONS(273),
    [anon_sym_QMARK] = ACTIONS(273),
    [anon_sym_0] = ACTIONS(271),
    [anon_sym__] = ACTIONS(271),
  },
  [19] = {
    [aux_sym_concatenation_repeat1] = STATE(138),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [20] = {
    [sym_subscript] = STATE(152),
    [sym_variable_name] = ACTIONS(279),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_POUND] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(285),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_AT] = ACTIONS(287),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_0] = ACTIONS(285),
    [anon_sym__] = ACTIONS(285),
  },
  [21] = {
    [sym__terminated_statement] = STATE(155),
    [sym_for_statement] = STATE(153),
    [sym_c_style_for_statement] = STATE(153),
    [sym_while_statement] = STATE(153),
    [sym_if_statement] = STATE(153),
    [sym_case_statement] = STATE(153),
    [sym_function_definition] = STATE(153),
    [sym_subshell] = STATE(153),
    [sym_pipeline] = STATE(153),
    [sym_list] = STATE(153),
    [sym_negated_command] = STATE(153),
    [sym_test_command] = STATE(153),
    [sym_declaration_command] = STATE(153),
    [sym_unset_command] = STATE(153),
    [sym_command] = STATE(153),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(154),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(155),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [22] = {
    [sym__terminated_statement] = STATE(167),
    [sym_for_statement] = STATE(164),
    [sym_c_style_for_statement] = STATE(164),
    [sym_while_statement] = STATE(164),
    [sym_if_statement] = STATE(164),
    [sym_case_statement] = STATE(164),
    [sym_function_definition] = STATE(164),
    [sym_subshell] = STATE(164),
    [sym_pipeline] = STATE(164),
    [sym_list] = STATE(164),
    [sym_negated_command] = STATE(164),
    [sym_test_command] = STATE(164),
    [sym_declaration_command] = STATE(164),
    [sym_unset_command] = STATE(164),
    [sym_command] = STATE(164),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(166),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(167),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [23] = {
    [sym__terminated_statement] = STATE(171),
    [sym_for_statement] = STATE(169),
    [sym_c_style_for_statement] = STATE(169),
    [sym_while_statement] = STATE(169),
    [sym_if_statement] = STATE(169),
    [sym_case_statement] = STATE(169),
    [sym_function_definition] = STATE(169),
    [sym_subshell] = STATE(169),
    [sym_pipeline] = STATE(169),
    [sym_list] = STATE(169),
    [sym_negated_command] = STATE(169),
    [sym_test_command] = STATE(169),
    [sym_declaration_command] = STATE(169),
    [sym_unset_command] = STATE(169),
    [sym_command] = STATE(169),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(170),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(171),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [24] = {
    [aux_sym_concatenation_repeat1] = STATE(138),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [25] = {
    [ts_builtin_sym_end] = ACTIONS(307),
    [sym_comment] = ACTIONS(53),
  },
  [26] = {
    [ts_builtin_sym_end] = ACTIONS(309),
    [anon_sym_SEMI] = ACTIONS(311),
    [anon_sym_PIPE] = ACTIONS(313),
    [anon_sym_SEMI_SEMI] = ACTIONS(315),
    [anon_sym_PIPE_AMP] = ACTIONS(317),
    [anon_sym_AMP_AMP] = ACTIONS(319),
    [anon_sym_PIPE_PIPE] = ACTIONS(319),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(315),
    [anon_sym_AMP] = ACTIONS(311),
  },
  [27] = {
    [sym_file_redirect] = STATE(186),
    [sym_heredoc_redirect] = STATE(186),
    [sym_heredoc_body] = STATE(185),
    [sym_herestring_redirect] = STATE(186),
    [sym_concatenation] = STATE(187),
    [sym_string] = STATE(184),
    [sym_simple_expansion] = STATE(184),
    [sym_string_expansion] = STATE(184),
    [sym_expansion] = STATE(184),
    [sym_command_substitution] = STATE(184),
    [sym_process_substitution] = STATE(184),
    [aux_sym_while_statement_repeat1] = STATE(186),
    [aux_sym_command_repeat2] = STATE(187),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(327),
    [anon_sym_PIPE_AMP] = ACTIONS(327),
    [anon_sym_AMP_AMP] = ACTIONS(327),
    [anon_sym_PIPE_PIPE] = ACTIONS(327),
    [anon_sym_EQ_TILDE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(341),
    [sym__special_characters] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(347),
    [anon_sym_LF] = ACTIONS(327),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [28] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [ts_builtin_sym_end] = ACTIONS(309),
    [anon_sym_SEMI] = ACTIONS(311),
    [anon_sym_PIPE] = ACTIONS(313),
    [anon_sym_SEMI_SEMI] = ACTIONS(315),
    [anon_sym_PIPE_AMP] = ACTIONS(317),
    [anon_sym_AMP_AMP] = ACTIONS(319),
    [anon_sym_PIPE_PIPE] = ACTIONS(319),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(315),
    [anon_sym_AMP] = ACTIONS(311),
  },
  [29] = {
    [anon_sym_EQ] = ACTIONS(63),
    [anon_sym_PLUS_EQ] = ACTIONS(63),
    [sym_comment] = ACTIONS(53),
  },
  [30] = {
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [ts_builtin_sym_end] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [31] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(188),
    [sym_c_style_for_statement] = STATE(188),
    [sym_while_statement] = STATE(188),
    [sym_if_statement] = STATE(188),
    [sym_case_statement] = STATE(188),
    [sym_function_definition] = STATE(188),
    [sym_subshell] = STATE(188),
    [sym_pipeline] = STATE(188),
    [sym_list] = STATE(188),
    [sym_negated_command] = STATE(188),
    [sym_test_command] = STATE(188),
    [sym_declaration_command] = STATE(188),
    [sym_unset_command] = STATE(188),
    [sym_command] = STATE(188),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(189),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(32),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [32] = {
    [sym_command_name] = STATE(191),
    [sym_variable_assignment] = STATE(192),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(192),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(192),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(43),
  },
  [33] = {
    [sym_concatenation] = STATE(195),
    [sym_string] = STATE(194),
    [sym_simple_expansion] = STATE(194),
    [sym_string_expansion] = STATE(194),
    [sym_expansion] = STATE(194),
    [sym_command_substitution] = STATE(194),
    [sym_process_substitution] = STATE(194),
    [sym__special_characters] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_raw_string] = ACTIONS(357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(241),
    [anon_sym_BQUOTE] = ACTIONS(243),
    [anon_sym_LT_LPAREN] = ACTIONS(245),
    [anon_sym_GT_LPAREN] = ACTIONS(245),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(357),
  },
  [34] = {
    [sym_concatenation] = STATE(198),
    [sym_string] = STATE(197),
    [sym_simple_expansion] = STATE(197),
    [sym_string_expansion] = STATE(197),
    [sym_expansion] = STATE(197),
    [sym_command_substitution] = STATE(197),
    [sym_process_substitution] = STATE(197),
    [sym__special_characters] = ACTIONS(359),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(361),
  },
  [35] = {
    [sym_concatenation] = STATE(199),
    [sym_string] = STATE(204),
    [sym_array] = STATE(199),
    [sym_simple_expansion] = STATE(204),
    [sym_string_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [sym_process_substitution] = STATE(204),
    [sym__empty_value] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(365),
    [sym__special_characters] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LT_LPAREN] = ACTIONS(381),
    [anon_sym_GT_LPAREN] = ACTIONS(381),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(373),
  },
  [36] = {
    [sym__expression] = STATE(220),
    [sym_binary_expression] = STATE(220),
    [sym_unary_expression] = STATE(220),
    [sym_parenthesized_expression] = STATE(220),
    [sym_concatenation] = STATE(220),
    [sym_string] = STATE(215),
    [sym_simple_expansion] = STATE(215),
    [sym_string_expansion] = STATE(215),
    [sym_expansion] = STATE(215),
    [sym_command_substitution] = STATE(215),
    [sym_process_substitution] = STATE(215),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_SEMI_SEMI] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(389),
    [sym__special_characters] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(407),
    [sym_test_operator] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
  },
  [37] = {
    [anon_sym_in] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(413),
    [anon_sym_SEMI_SEMI] = ACTIONS(415),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(415),
  },
  [38] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [sym_comment] = ACTIONS(53),
  },
  [39] = {
    [sym__terminated_statement] = STATE(224),
    [sym_for_statement] = STATE(50),
    [sym_c_style_for_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_case_statement] = STATE(50),
    [sym_function_definition] = STATE(50),
    [sym_subshell] = STATE(50),
    [sym_pipeline] = STATE(50),
    [sym_list] = STATE(50),
    [sym_negated_command] = STATE(50),
    [sym_test_command] = STATE(50),
    [sym_declaration_command] = STATE(50),
    [sym_unset_command] = STATE(50),
    [sym_command] = STATE(50),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(52),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [40] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(419),
  },
  [41] = {
    [sym_subshell] = STATE(84),
    [sym_test_command] = STATE(84),
    [sym_command] = STATE(84),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(54),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(87),
  },
  [42] = {
    [sym__expression] = STATE(226),
    [sym_binary_expression] = STATE(226),
    [sym_unary_expression] = STATE(226),
    [sym_parenthesized_expression] = STATE(226),
    [sym_concatenation] = STATE(226),
    [sym_string] = STATE(91),
    [sym_simple_expansion] = STATE(91),
    [sym_string_expansion] = STATE(91),
    [sym_expansion] = STATE(91),
    [sym_command_substitution] = STATE(91),
    [sym_process_substitution] = STATE(91),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [43] = {
    [sym__expression] = STATE(227),
    [sym_binary_expression] = STATE(227),
    [sym_unary_expression] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_concatenation] = STATE(227),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(177),
    [sym_test_operator] = ACTIONS(179),
  },
  [44] = {
    [sym_variable_assignment] = STATE(232),
    [sym_subscript] = STATE(231),
    [sym_concatenation] = STATE(232),
    [sym_string] = STATE(230),
    [sym_simple_expansion] = STATE(230),
    [sym_string_expansion] = STATE(230),
    [sym_expansion] = STATE(230),
    [sym_command_substitution] = STATE(230),
    [sym_process_substitution] = STATE(230),
    [aux_sym_declaration_command_repeat1] = STATE(232),
    [sym_variable_name] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_SEMI_SEMI] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [sym__special_characters] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(425),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(427),
    [sym_word] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [45] = {
    [sym_concatenation] = STATE(235),
    [sym_string] = STATE(234),
    [sym_simple_expansion] = STATE(234),
    [sym_string_expansion] = STATE(234),
    [sym_expansion] = STATE(234),
    [sym_command_substitution] = STATE(234),
    [sym_process_substitution] = STATE(234),
    [aux_sym_unset_command_repeat1] = STATE(235),
    [anon_sym_SEMI] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_SEMI_SEMI] = ACTIONS(207),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [sym__special_characters] = ACTIONS(431),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(209),
  },
  [46] = {
    [aux_sym_concatenation_repeat1] = STATE(236),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [anon_sym_SEMI_SEMI] = ACTIONS(247),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(251),
    [anon_sym_EQ_EQ] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(251),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(251),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(251),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(251),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(251),
  },
  [47] = {
    [aux_sym_concatenation_repeat1] = STATE(236),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [48] = {
    [aux_sym_concatenation_repeat1] = STATE(236),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [49] = {
    [sym_do_group] = STATE(239),
    [anon_sym_do] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [50] = {
    [anon_sym_SEMI] = ACTIONS(443),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(447),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(447),
    [anon_sym_AMP] = ACTIONS(443),
  },
  [51] = {
    [sym_file_redirect] = STATE(249),
    [sym_heredoc_redirect] = STATE(249),
    [sym_heredoc_body] = STATE(185),
    [sym_herestring_redirect] = STATE(249),
    [sym_concatenation] = STATE(250),
    [sym_string] = STATE(248),
    [sym_simple_expansion] = STATE(248),
    [sym_string_expansion] = STATE(248),
    [sym_expansion] = STATE(248),
    [sym_command_substitution] = STATE(248),
    [sym_process_substitution] = STATE(248),
    [aux_sym_while_statement_repeat1] = STATE(249),
    [aux_sym_command_repeat2] = STATE(250),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(327),
    [anon_sym_PIPE_AMP] = ACTIONS(327),
    [anon_sym_AMP_AMP] = ACTIONS(327),
    [anon_sym_PIPE_PIPE] = ACTIONS(327),
    [anon_sym_EQ_TILDE] = ACTIONS(455),
    [anon_sym_EQ_EQ] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [sym__special_characters] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(467),
    [anon_sym_LF] = ACTIONS(327),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [52] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(443),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(447),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(447),
    [anon_sym_AMP] = ACTIONS(443),
  },
  [53] = {
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [sym_comment] = ACTIONS(53),
  },
  [54] = {
    [sym_command_name] = STATE(251),
    [sym_variable_assignment] = STATE(192),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(192),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(192),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(87),
  },
  [55] = {
    [anon_sym_then] = ACTIONS(471),
    [sym_comment] = ACTIONS(53),
  },
  [56] = {
    [aux_sym_concatenation_repeat1] = STATE(256),
    [sym__concat] = ACTIONS(473),
    [anon_sym_in] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(477),
    [anon_sym_SEMI_SEMI] = ACTIONS(479),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(479),
  },
  [57] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(259),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [anon_sym_DOLLAR] = ACTIONS(483),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [58] = {
    [sym_string] = STATE(261),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [anon_sym_DOLLAR] = ACTIONS(485),
    [sym_raw_string] = ACTIONS(487),
    [anon_sym_POUND] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_AT] = ACTIONS(491),
    [anon_sym_QMARK] = ACTIONS(491),
    [anon_sym_0] = ACTIONS(489),
    [anon_sym__] = ACTIONS(489),
  },
  [59] = {
    [aux_sym_concatenation_repeat1] = STATE(256),
    [sym__concat] = ACTIONS(473),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_SEMI_SEMI] = ACTIONS(497),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(497),
  },
  [60] = {
    [sym_subscript] = STATE(268),
    [sym_variable_name] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_DOLLAR] = ACTIONS(503),
    [anon_sym_POUND] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(505),
    [anon_sym_STAR] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(507),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_0] = ACTIONS(505),
    [anon_sym__] = ACTIONS(505),
  },
  [61] = {
    [sym__terminated_statement] = STATE(271),
    [sym_for_statement] = STATE(269),
    [sym_c_style_for_statement] = STATE(269),
    [sym_while_statement] = STATE(269),
    [sym_if_statement] = STATE(269),
    [sym_case_statement] = STATE(269),
    [sym_function_definition] = STATE(269),
    [sym_subshell] = STATE(269),
    [sym_pipeline] = STATE(269),
    [sym_list] = STATE(269),
    [sym_negated_command] = STATE(269),
    [sym_test_command] = STATE(269),
    [sym_declaration_command] = STATE(269),
    [sym_unset_command] = STATE(269),
    [sym_command] = STATE(269),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(270),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(271),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [62] = {
    [sym__terminated_statement] = STATE(274),
    [sym_for_statement] = STATE(272),
    [sym_c_style_for_statement] = STATE(272),
    [sym_while_statement] = STATE(272),
    [sym_if_statement] = STATE(272),
    [sym_case_statement] = STATE(272),
    [sym_function_definition] = STATE(272),
    [sym_subshell] = STATE(272),
    [sym_pipeline] = STATE(272),
    [sym_list] = STATE(272),
    [sym_negated_command] = STATE(272),
    [sym_test_command] = STATE(272),
    [sym_declaration_command] = STATE(272),
    [sym_unset_command] = STATE(272),
    [sym_command] = STATE(272),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(273),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(274),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [63] = {
    [sym__terminated_statement] = STATE(277),
    [sym_for_statement] = STATE(275),
    [sym_c_style_for_statement] = STATE(275),
    [sym_while_statement] = STATE(275),
    [sym_if_statement] = STATE(275),
    [sym_case_statement] = STATE(275),
    [sym_function_definition] = STATE(275),
    [sym_subshell] = STATE(275),
    [sym_pipeline] = STATE(275),
    [sym_list] = STATE(275),
    [sym_negated_command] = STATE(275),
    [sym_test_command] = STATE(275),
    [sym_declaration_command] = STATE(275),
    [sym_unset_command] = STATE(275),
    [sym_command] = STATE(275),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(276),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(277),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [64] = {
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_SEMI_SEMI] = ACTIONS(497),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(497),
  },
  [65] = {
    [sym_compound_statement] = STATE(280),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [66] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_PLUS_EQ] = ACTIONS(513),
    [sym_comment] = ACTIONS(53),
  },
  [67] = {
    [sym__terminated_statement] = STATE(282),
    [sym_for_statement] = STATE(50),
    [sym_c_style_for_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_case_statement] = STATE(50),
    [sym_function_definition] = STATE(50),
    [sym_subshell] = STATE(50),
    [sym_pipeline] = STATE(50),
    [sym_list] = STATE(50),
    [sym_negated_command] = STATE(50),
    [sym_test_command] = STATE(50),
    [sym_declaration_command] = STATE(50),
    [sym_unset_command] = STATE(50),
    [sym_command] = STATE(50),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(52),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [68] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(515),
  },
  [69] = {
    [sym_subshell] = STATE(84),
    [sym_test_command] = STATE(84),
    [sym_command] = STATE(84),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(82),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(127),
  },
  [70] = {
    [sym__expression] = STATE(284),
    [sym_binary_expression] = STATE(284),
    [sym_unary_expression] = STATE(284),
    [sym_parenthesized_expression] = STATE(284),
    [sym_concatenation] = STATE(284),
    [sym_string] = STATE(91),
    [sym_simple_expansion] = STATE(91),
    [sym_string_expansion] = STATE(91),
    [sym_expansion] = STATE(91),
    [sym_command_substitution] = STATE(91),
    [sym_process_substitution] = STATE(91),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [71] = {
    [sym__expression] = STATE(285),
    [sym_binary_expression] = STATE(285),
    [sym_unary_expression] = STATE(285),
    [sym_parenthesized_expression] = STATE(285),
    [sym_concatenation] = STATE(285),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(177),
    [sym_test_operator] = ACTIONS(179),
  },
  [72] = {
    [sym_variable_assignment] = STATE(290),
    [sym_subscript] = STATE(289),
    [sym_concatenation] = STATE(290),
    [sym_string] = STATE(288),
    [sym_simple_expansion] = STATE(288),
    [sym_string_expansion] = STATE(288),
    [sym_expansion] = STATE(288),
    [sym_command_substitution] = STATE(288),
    [sym_process_substitution] = STATE(288),
    [aux_sym_declaration_command_repeat1] = STATE(290),
    [sym_variable_name] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_SEMI_SEMI] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [sym__special_characters] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(523),
    [sym_word] = ACTIONS(525),
    [anon_sym_LF] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [73] = {
    [sym_concatenation] = STATE(293),
    [sym_string] = STATE(292),
    [sym_simple_expansion] = STATE(292),
    [sym_string_expansion] = STATE(292),
    [sym_expansion] = STATE(292),
    [sym_command_substitution] = STATE(292),
    [sym_process_substitution] = STATE(292),
    [aux_sym_unset_command_repeat1] = STATE(293),
    [anon_sym_SEMI] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_SEMI_SEMI] = ACTIONS(207),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [sym__special_characters] = ACTIONS(527),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(529),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(531),
    [sym_word] = ACTIONS(533),
    [anon_sym_LF] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(209),
  },
  [74] = {
    [aux_sym_concatenation_repeat1] = STATE(294),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [anon_sym_RPAREN] = ACTIONS(247),
    [anon_sym_SEMI_SEMI] = ACTIONS(247),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(251),
    [anon_sym_EQ_EQ] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(251),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(251),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(251),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(251),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(251),
  },
  [75] = {
    [aux_sym_concatenation_repeat1] = STATE(294),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [76] = {
    [aux_sym_concatenation_repeat1] = STATE(294),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [77] = {
    [anon_sym_SEMI] = ACTIONS(537),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(541),
    [anon_sym_SEMI_SEMI] = ACTIONS(543),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(537),
  },
  [78] = {
    [sym_file_redirect] = STATE(306),
    [sym_heredoc_redirect] = STATE(306),
    [sym_heredoc_body] = STATE(185),
    [sym_herestring_redirect] = STATE(306),
    [sym_concatenation] = STATE(307),
    [sym_string] = STATE(305),
    [sym_simple_expansion] = STATE(305),
    [sym_string_expansion] = STATE(305),
    [sym_expansion] = STATE(305),
    [sym_command_substitution] = STATE(305),
    [sym_process_substitution] = STATE(305),
    [aux_sym_while_statement_repeat1] = STATE(306),
    [aux_sym_command_repeat2] = STATE(307),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(327),
    [anon_sym_SEMI_SEMI] = ACTIONS(327),
    [anon_sym_PIPE_AMP] = ACTIONS(327),
    [anon_sym_AMP_AMP] = ACTIONS(327),
    [anon_sym_PIPE_PIPE] = ACTIONS(327),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(557),
    [sym__special_characters] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(563),
    [anon_sym_LF] = ACTIONS(327),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [79] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(537),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(541),
    [anon_sym_SEMI_SEMI] = ACTIONS(543),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(537),
  },
  [80] = {
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_PLUS_EQ] = ACTIONS(513),
    [sym_comment] = ACTIONS(53),
  },
  [81] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(308),
    [sym_c_style_for_statement] = STATE(308),
    [sym_while_statement] = STATE(308),
    [sym_if_statement] = STATE(308),
    [sym_case_statement] = STATE(308),
    [sym_function_definition] = STATE(308),
    [sym_subshell] = STATE(308),
    [sym_pipeline] = STATE(308),
    [sym_list] = STATE(308),
    [sym_negated_command] = STATE(308),
    [sym_test_command] = STATE(308),
    [sym_declaration_command] = STATE(308),
    [sym_unset_command] = STATE(308),
    [sym_command] = STATE(308),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(309),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [82] = {
    [sym_command_name] = STATE(310),
    [sym_variable_assignment] = STATE(192),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(192),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym_command_repeat1] = STATE(192),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(127),
  },
  [83] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(567),
    [sym_comment] = ACTIONS(53),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(569),
    [anon_sym_SEMI] = ACTIONS(571),
    [anon_sym_esac] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_SEMI_SEMI] = ACTIONS(569),
    [anon_sym_PIPE_AMP] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(569),
    [anon_sym_BQUOTE] = ACTIONS(569),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(569),
    [anon_sym_AMP] = ACTIONS(571),
  },
  [85] = {
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(567),
    [sym_comment] = ACTIONS(53),
  },
  [86] = {
    [sym__expression] = STATE(315),
    [sym_binary_expression] = STATE(315),
    [sym_unary_expression] = STATE(315),
    [sym_parenthesized_expression] = STATE(315),
    [sym_concatenation] = STATE(315),
    [sym_string] = STATE(314),
    [sym_simple_expansion] = STATE(314),
    [sym_string_expansion] = STATE(314),
    [sym_expansion] = STATE(314),
    [sym_command_substitution] = STATE(314),
    [sym_process_substitution] = STATE(314),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(573),
    [sym__special_characters] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(579),
    [sym_test_operator] = ACTIONS(581),
  },
  [87] = {
    [sym__expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_parenthesized_expression] = STATE(316),
    [sym_concatenation] = STATE(316),
    [sym_string] = STATE(91),
    [sym_simple_expansion] = STATE(91),
    [sym_string_expansion] = STATE(91),
    [sym_expansion] = STATE(91),
    [sym_command_substitution] = STATE(91),
    [sym_process_substitution] = STATE(91),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [88] = {
    [aux_sym_concatenation_repeat1] = STATE(318),
    [sym__concat] = ACTIONS(583),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_RBRACK] = ACTIONS(585),
    [anon_sym_EQ_TILDE] = ACTIONS(585),
    [anon_sym_EQ_EQ] = ACTIONS(585),
    [anon_sym_EQ] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(585),
    [anon_sym_BANG_EQ] = ACTIONS(585),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(585),
  },
  [89] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(321),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [90] = {
    [sym_string] = STATE(323),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(593),
    [sym_raw_string] = ACTIONS(595),
    [anon_sym_POUND] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AT] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(599),
    [anon_sym_0] = ACTIONS(597),
    [anon_sym__] = ACTIONS(597),
  },
  [91] = {
    [aux_sym_concatenation_repeat1] = STATE(318),
    [sym__concat] = ACTIONS(583),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [anon_sym_RBRACK] = ACTIONS(601),
    [anon_sym_EQ_TILDE] = ACTIONS(601),
    [anon_sym_EQ_EQ] = ACTIONS(601),
    [anon_sym_EQ] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_GT] = ACTIONS(601),
    [anon_sym_BANG_EQ] = ACTIONS(601),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(601),
  },
  [92] = {
    [sym_subscript] = STATE(328),
    [sym_variable_name] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [anon_sym_POUND] = ACTIONS(607),
    [anon_sym_DASH] = ACTIONS(609),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(611),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_AT] = ACTIONS(613),
    [anon_sym_QMARK] = ACTIONS(613),
    [anon_sym_0] = ACTIONS(611),
    [anon_sym__] = ACTIONS(611),
  },
  [93] = {
    [sym__terminated_statement] = STATE(331),
    [sym_for_statement] = STATE(329),
    [sym_c_style_for_statement] = STATE(329),
    [sym_while_statement] = STATE(329),
    [sym_if_statement] = STATE(329),
    [sym_case_statement] = STATE(329),
    [sym_function_definition] = STATE(329),
    [sym_subshell] = STATE(329),
    [sym_pipeline] = STATE(329),
    [sym_list] = STATE(329),
    [sym_negated_command] = STATE(329),
    [sym_test_command] = STATE(329),
    [sym_declaration_command] = STATE(329),
    [sym_unset_command] = STATE(329),
    [sym_command] = STATE(329),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(330),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(331),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [94] = {
    [sym__terminated_statement] = STATE(334),
    [sym_for_statement] = STATE(332),
    [sym_c_style_for_statement] = STATE(332),
    [sym_while_statement] = STATE(332),
    [sym_if_statement] = STATE(332),
    [sym_case_statement] = STATE(332),
    [sym_function_definition] = STATE(332),
    [sym_subshell] = STATE(332),
    [sym_pipeline] = STATE(332),
    [sym_list] = STATE(332),
    [sym_negated_command] = STATE(332),
    [sym_test_command] = STATE(332),
    [sym_declaration_command] = STATE(332),
    [sym_unset_command] = STATE(332),
    [sym_command] = STATE(332),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(333),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(334),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [95] = {
    [sym__terminated_statement] = STATE(337),
    [sym_for_statement] = STATE(335),
    [sym_c_style_for_statement] = STATE(335),
    [sym_while_statement] = STATE(335),
    [sym_if_statement] = STATE(335),
    [sym_case_statement] = STATE(335),
    [sym_function_definition] = STATE(335),
    [sym_subshell] = STATE(335),
    [sym_pipeline] = STATE(335),
    [sym_list] = STATE(335),
    [sym_negated_command] = STATE(335),
    [sym_test_command] = STATE(335),
    [sym_declaration_command] = STATE(335),
    [sym_unset_command] = STATE(335),
    [sym_command] = STATE(335),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(336),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(337),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [96] = {
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(617),
    [anon_sym_EQ_TILDE] = ACTIONS(619),
    [anon_sym_EQ_EQ] = ACTIONS(619),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_BANG_EQ] = ACTIONS(615),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(615),
  },
  [97] = {
    [sym__expression] = STATE(341),
    [sym_binary_expression] = STATE(341),
    [sym_unary_expression] = STATE(341),
    [sym_parenthesized_expression] = STATE(341),
    [sym_concatenation] = STATE(341),
    [sym_string] = STATE(314),
    [sym_simple_expansion] = STATE(314),
    [sym_string_expansion] = STATE(314),
    [sym_expansion] = STATE(314),
    [sym_command_substitution] = STATE(314),
    [sym_process_substitution] = STATE(314),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(573),
    [sym__special_characters] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(579),
    [sym_test_operator] = ACTIONS(581),
  },
  [98] = {
    [sym__expression] = STATE(342),
    [sym_binary_expression] = STATE(342),
    [sym_unary_expression] = STATE(342),
    [sym_parenthesized_expression] = STATE(342),
    [sym_concatenation] = STATE(342),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(177),
    [sym_test_operator] = ACTIONS(179),
  },
  [99] = {
    [aux_sym_concatenation_repeat1] = STATE(344),
    [sym__concat] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(585),
    [anon_sym_EQ_TILDE] = ACTIONS(585),
    [anon_sym_EQ_EQ] = ACTIONS(585),
    [anon_sym_EQ] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(585),
    [anon_sym_BANG_EQ] = ACTIONS(585),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(585),
  },
  [100] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(347),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [101] = {
    [sym_string] = STATE(349),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(629),
    [sym_raw_string] = ACTIONS(631),
    [anon_sym_POUND] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(635),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_0] = ACTIONS(633),
    [anon_sym__] = ACTIONS(633),
  },
  [102] = {
    [aux_sym_concatenation_repeat1] = STATE(344),
    [sym__concat] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(601),
    [anon_sym_EQ_TILDE] = ACTIONS(601),
    [anon_sym_EQ_EQ] = ACTIONS(601),
    [anon_sym_EQ] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_GT] = ACTIONS(601),
    [anon_sym_BANG_EQ] = ACTIONS(601),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(601),
  },
  [103] = {
    [sym_subscript] = STATE(354),
    [sym_variable_name] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(639),
    [anon_sym_DOLLAR] = ACTIONS(641),
    [anon_sym_POUND] = ACTIONS(639),
    [anon_sym_DASH] = ACTIONS(641),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(645),
    [anon_sym_AT] = ACTIONS(645),
    [anon_sym_QMARK] = ACTIONS(645),
    [anon_sym_0] = ACTIONS(643),
    [anon_sym__] = ACTIONS(643),
  },
  [104] = {
    [sym__terminated_statement] = STATE(357),
    [sym_for_statement] = STATE(355),
    [sym_c_style_for_statement] = STATE(355),
    [sym_while_statement] = STATE(355),
    [sym_if_statement] = STATE(355),
    [sym_case_statement] = STATE(355),
    [sym_function_definition] = STATE(355),
    [sym_subshell] = STATE(355),
    [sym_pipeline] = STATE(355),
    [sym_list] = STATE(355),
    [sym_negated_command] = STATE(355),
    [sym_test_command] = STATE(355),
    [sym_declaration_command] = STATE(355),
    [sym_unset_command] = STATE(355),
    [sym_command] = STATE(355),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(356),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(357),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [105] = {
    [sym__terminated_statement] = STATE(360),
    [sym_for_statement] = STATE(358),
    [sym_c_style_for_statement] = STATE(358),
    [sym_while_statement] = STATE(358),
    [sym_if_statement] = STATE(358),
    [sym_case_statement] = STATE(358),
    [sym_function_definition] = STATE(358),
    [sym_subshell] = STATE(358),
    [sym_pipeline] = STATE(358),
    [sym_list] = STATE(358),
    [sym_negated_command] = STATE(358),
    [sym_test_command] = STATE(358),
    [sym_declaration_command] = STATE(358),
    [sym_unset_command] = STATE(358),
    [sym_command] = STATE(358),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(359),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(360),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [106] = {
    [sym__terminated_statement] = STATE(363),
    [sym_for_statement] = STATE(361),
    [sym_c_style_for_statement] = STATE(361),
    [sym_while_statement] = STATE(361),
    [sym_if_statement] = STATE(361),
    [sym_case_statement] = STATE(361),
    [sym_function_definition] = STATE(361),
    [sym_subshell] = STATE(361),
    [sym_pipeline] = STATE(361),
    [sym_list] = STATE(361),
    [sym_negated_command] = STATE(361),
    [sym_test_command] = STATE(361),
    [sym_declaration_command] = STATE(361),
    [sym_unset_command] = STATE(361),
    [sym_command] = STATE(361),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(362),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(363),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [107] = {
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(617),
    [anon_sym_EQ_TILDE] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(647),
  },
  [108] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(653),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [sym_comment] = ACTIONS(53),
  },
  [109] = {
    [aux_sym_concatenation_repeat1] = STATE(368),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(657),
    [ts_builtin_sym_end] = ACTIONS(657),
    [anon_sym_SEMI] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_SEMI_SEMI] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(657),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [sym__special_characters] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [sym_raw_string] = ACTIONS(657),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(657),
    [anon_sym_BQUOTE] = ACTIONS(657),
    [anon_sym_LT_LPAREN] = ACTIONS(657),
    [anon_sym_GT_LPAREN] = ACTIONS(657),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(659),
    [sym_word] = ACTIONS(659),
    [anon_sym_LF] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(659),
  },
  [110] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(371),
    [anon_sym_DQUOTE] = ACTIONS(661),
    [anon_sym_DOLLAR] = ACTIONS(663),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [111] = {
    [sym_string] = STATE(373),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [sym_raw_string] = ACTIONS(667),
    [anon_sym_POUND] = ACTIONS(665),
    [anon_sym_DASH] = ACTIONS(665),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(671),
    [anon_sym_QMARK] = ACTIONS(671),
    [anon_sym_0] = ACTIONS(669),
    [anon_sym__] = ACTIONS(669),
  },
  [112] = {
    [aux_sym_concatenation_repeat1] = STATE(368),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(673),
    [ts_builtin_sym_end] = ACTIONS(673),
    [anon_sym_SEMI] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(675),
    [anon_sym_SEMI_SEMI] = ACTIONS(673),
    [anon_sym_PIPE_AMP] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(673),
    [anon_sym_PIPE_PIPE] = ACTIONS(673),
    [sym__special_characters] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(673),
    [anon_sym_BQUOTE] = ACTIONS(673),
    [anon_sym_LT_LPAREN] = ACTIONS(673),
    [anon_sym_GT_LPAREN] = ACTIONS(673),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [anon_sym_LF] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
  },
  [113] = {
    [sym_subscript] = STATE(378),
    [sym_variable_name] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(679),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [anon_sym_POUND] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(681),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_QMARK] = ACTIONS(685),
    [anon_sym_0] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
  },
  [114] = {
    [sym__terminated_statement] = STATE(381),
    [sym_for_statement] = STATE(379),
    [sym_c_style_for_statement] = STATE(379),
    [sym_while_statement] = STATE(379),
    [sym_if_statement] = STATE(379),
    [sym_case_statement] = STATE(379),
    [sym_function_definition] = STATE(379),
    [sym_subshell] = STATE(379),
    [sym_pipeline] = STATE(379),
    [sym_list] = STATE(379),
    [sym_negated_command] = STATE(379),
    [sym_test_command] = STATE(379),
    [sym_declaration_command] = STATE(379),
    [sym_unset_command] = STATE(379),
    [sym_command] = STATE(379),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(380),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(381),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [115] = {
    [sym__terminated_statement] = STATE(384),
    [sym_for_statement] = STATE(382),
    [sym_c_style_for_statement] = STATE(382),
    [sym_while_statement] = STATE(382),
    [sym_if_statement] = STATE(382),
    [sym_case_statement] = STATE(382),
    [sym_function_definition] = STATE(382),
    [sym_subshell] = STATE(382),
    [sym_pipeline] = STATE(382),
    [sym_list] = STATE(382),
    [sym_negated_command] = STATE(382),
    [sym_test_command] = STATE(382),
    [sym_declaration_command] = STATE(382),
    [sym_unset_command] = STATE(382),
    [sym_command] = STATE(382),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(383),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(384),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [116] = {
    [sym__terminated_statement] = STATE(387),
    [sym_for_statement] = STATE(385),
    [sym_c_style_for_statement] = STATE(385),
    [sym_while_statement] = STATE(385),
    [sym_if_statement] = STATE(385),
    [sym_case_statement] = STATE(385),
    [sym_function_definition] = STATE(385),
    [sym_subshell] = STATE(385),
    [sym_pipeline] = STATE(385),
    [sym_list] = STATE(385),
    [sym_negated_command] = STATE(385),
    [sym_test_command] = STATE(385),
    [sym_declaration_command] = STATE(385),
    [sym_unset_command] = STATE(385),
    [sym_command] = STATE(385),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(386),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(387),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [117] = {
    [anon_sym_EQ] = ACTIONS(653),
    [anon_sym_PLUS_EQ] = ACTIONS(653),
    [sym_comment] = ACTIONS(53),
  },
  [118] = {
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(117),
    [sym_concatenation] = STATE(388),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_string_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_declaration_command_repeat1] = STATE(388),
    [sym_variable_name] = ACTIONS(181),
    [ts_builtin_sym_end] = ACTIONS(687),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_SEMI_SEMI] = ACTIONS(687),
    [anon_sym_PIPE_AMP] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [sym__special_characters] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(691),
    [sym_word] = ACTIONS(205),
    [anon_sym_LF] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
  },
  [119] = {
    [aux_sym_concatenation_repeat1] = STATE(390),
    [sym__concat] = ACTIONS(693),
    [ts_builtin_sym_end] = ACTIONS(695),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(697),
    [sym_word] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [120] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(393),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [anon_sym_DOLLAR] = ACTIONS(701),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [121] = {
    [sym_string] = STATE(395),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [sym_raw_string] = ACTIONS(705),
    [anon_sym_POUND] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(707),
    [anon_sym_STAR] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_0] = ACTIONS(707),
    [anon_sym__] = ACTIONS(707),
  },
  [122] = {
    [aux_sym_concatenation_repeat1] = STATE(390),
    [sym__concat] = ACTIONS(693),
    [ts_builtin_sym_end] = ACTIONS(711),
    [anon_sym_SEMI] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_SEMI_SEMI] = ACTIONS(711),
    [anon_sym_PIPE_AMP] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(711),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [sym__special_characters] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_DOLLAR] = ACTIONS(713),
    [sym_raw_string] = ACTIONS(711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(711),
    [anon_sym_BQUOTE] = ACTIONS(711),
    [anon_sym_LT_LPAREN] = ACTIONS(711),
    [anon_sym_GT_LPAREN] = ACTIONS(711),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(713),
    [sym_word] = ACTIONS(713),
    [anon_sym_LF] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
  },
  [123] = {
    [sym_subscript] = STATE(400),
    [sym_variable_name] = ACTIONS(715),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_DOLLAR] = ACTIONS(719),
    [anon_sym_POUND] = ACTIONS(717),
    [anon_sym_DASH] = ACTIONS(719),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(721),
    [anon_sym_STAR] = ACTIONS(723),
    [anon_sym_AT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_0] = ACTIONS(721),
    [anon_sym__] = ACTIONS(721),
  },
  [124] = {
    [sym__terminated_statement] = STATE(403),
    [sym_for_statement] = STATE(401),
    [sym_c_style_for_statement] = STATE(401),
    [sym_while_statement] = STATE(401),
    [sym_if_statement] = STATE(401),
    [sym_case_statement] = STATE(401),
    [sym_function_definition] = STATE(401),
    [sym_subshell] = STATE(401),
    [sym_pipeline] = STATE(401),
    [sym_list] = STATE(401),
    [sym_negated_command] = STATE(401),
    [sym_test_command] = STATE(401),
    [sym_declaration_command] = STATE(401),
    [sym_unset_command] = STATE(401),
    [sym_command] = STATE(401),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(402),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(403),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [125] = {
    [sym__terminated_statement] = STATE(406),
    [sym_for_statement] = STATE(404),
    [sym_c_style_for_statement] = STATE(404),
    [sym_while_statement] = STATE(404),
    [sym_if_statement] = STATE(404),
    [sym_case_statement] = STATE(404),
    [sym_function_definition] = STATE(404),
    [sym_subshell] = STATE(404),
    [sym_pipeline] = STATE(404),
    [sym_list] = STATE(404),
    [sym_negated_command] = STATE(404),
    [sym_test_command] = STATE(404),
    [sym_declaration_command] = STATE(404),
    [sym_unset_command] = STATE(404),
    [sym_command] = STATE(404),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(405),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(406),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [126] = {
    [sym__terminated_statement] = STATE(409),
    [sym_for_statement] = STATE(407),
    [sym_c_style_for_statement] = STATE(407),
    [sym_while_statement] = STATE(407),
    [sym_if_statement] = STATE(407),
    [sym_case_statement] = STATE(407),
    [sym_function_definition] = STATE(407),
    [sym_subshell] = STATE(407),
    [sym_pipeline] = STATE(407),
    [sym_list] = STATE(407),
    [sym_negated_command] = STATE(407),
    [sym_test_command] = STATE(407),
    [sym_declaration_command] = STATE(407),
    [sym_unset_command] = STATE(407),
    [sym_command] = STATE(407),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(408),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(409),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [127] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(122),
    [sym_simple_expansion] = STATE(122),
    [sym_string_expansion] = STATE(122),
    [sym_expansion] = STATE(122),
    [sym_command_substitution] = STATE(122),
    [sym_process_substitution] = STATE(122),
    [aux_sym_unset_command_repeat1] = STATE(410),
    [ts_builtin_sym_end] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_SEMI_SEMI] = ACTIONS(725),
    [anon_sym_PIPE_AMP] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [sym__special_characters] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(729),
    [sym_word] = ACTIONS(229),
    [anon_sym_LF] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(727),
  },
  [128] = {
    [aux_sym_concatenation_repeat1] = STATE(412),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(733),
    [sym_variable_name] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [sym__special_characters] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(735),
    [sym_raw_string] = ACTIONS(731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [anon_sym_LT_LPAREN] = ACTIONS(731),
    [anon_sym_GT_LPAREN] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(731),
  },
  [129] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(415),
    [anon_sym_DQUOTE] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(739),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [130] = {
    [sym_string] = STATE(417),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [sym_raw_string] = ACTIONS(743),
    [anon_sym_POUND] = ACTIONS(741),
    [anon_sym_DASH] = ACTIONS(741),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(747),
    [anon_sym_AT] = ACTIONS(747),
    [anon_sym_QMARK] = ACTIONS(747),
    [anon_sym_0] = ACTIONS(745),
    [anon_sym__] = ACTIONS(745),
  },
  [131] = {
    [aux_sym_concatenation_repeat1] = STATE(412),
    [sym_file_descriptor] = ACTIONS(749),
    [sym__concat] = ACTIONS(733),
    [sym_variable_name] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [sym__special_characters] = ACTIONS(749),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(749),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [anon_sym_LT_LPAREN] = ACTIONS(749),
    [anon_sym_GT_LPAREN] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(749),
  },
  [132] = {
    [sym_subscript] = STATE(422),
    [sym_variable_name] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_POUND] = ACTIONS(755),
    [anon_sym_DASH] = ACTIONS(757),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(759),
    [anon_sym_STAR] = ACTIONS(761),
    [anon_sym_AT] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(761),
    [anon_sym_0] = ACTIONS(759),
    [anon_sym__] = ACTIONS(759),
  },
  [133] = {
    [sym__terminated_statement] = STATE(425),
    [sym_for_statement] = STATE(423),
    [sym_c_style_for_statement] = STATE(423),
    [sym_while_statement] = STATE(423),
    [sym_if_statement] = STATE(423),
    [sym_case_statement] = STATE(423),
    [sym_function_definition] = STATE(423),
    [sym_subshell] = STATE(423),
    [sym_pipeline] = STATE(423),
    [sym_list] = STATE(423),
    [sym_negated_command] = STATE(423),
    [sym_test_command] = STATE(423),
    [sym_declaration_command] = STATE(423),
    [sym_unset_command] = STATE(423),
    [sym_command] = STATE(423),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(424),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(425),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [134] = {
    [sym__terminated_statement] = STATE(428),
    [sym_for_statement] = STATE(426),
    [sym_c_style_for_statement] = STATE(426),
    [sym_while_statement] = STATE(426),
    [sym_if_statement] = STATE(426),
    [sym_case_statement] = STATE(426),
    [sym_function_definition] = STATE(426),
    [sym_subshell] = STATE(426),
    [sym_pipeline] = STATE(426),
    [sym_list] = STATE(426),
    [sym_negated_command] = STATE(426),
    [sym_test_command] = STATE(426),
    [sym_declaration_command] = STATE(426),
    [sym_unset_command] = STATE(426),
    [sym_command] = STATE(426),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(427),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(428),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [135] = {
    [sym__terminated_statement] = STATE(431),
    [sym_for_statement] = STATE(429),
    [sym_c_style_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_case_statement] = STATE(429),
    [sym_function_definition] = STATE(429),
    [sym_subshell] = STATE(429),
    [sym_pipeline] = STATE(429),
    [sym_list] = STATE(429),
    [sym_negated_command] = STATE(429),
    [sym_test_command] = STATE(429),
    [sym_declaration_command] = STATE(429),
    [sym_unset_command] = STATE(429),
    [sym_command] = STATE(429),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(430),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(431),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [136] = {
    [sym_file_descriptor] = ACTIONS(749),
    [sym_variable_name] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [sym__special_characters] = ACTIONS(749),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(749),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(749),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [anon_sym_LT_LPAREN] = ACTIONS(749),
    [anon_sym_GT_LPAREN] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(749),
  },
  [137] = {
    [sym_string] = STATE(432),
    [sym_simple_expansion] = STATE(432),
    [sym_string_expansion] = STATE(432),
    [sym_expansion] = STATE(432),
    [sym_command_substitution] = STATE(432),
    [sym_process_substitution] = STATE(432),
    [sym__special_characters] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(763),
  },
  [138] = {
    [aux_sym_concatenation_repeat1] = STATE(433),
    [sym__simple_heredoc_body] = ACTIONS(765),
    [sym__heredoc_body_beginning] = ACTIONS(765),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_EQ_TILDE] = ACTIONS(767),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [139] = {
    [sym__simple_heredoc_body] = ACTIONS(769),
    [sym__heredoc_body_beginning] = ACTIONS(769),
    [sym_file_descriptor] = ACTIONS(769),
    [sym__concat] = ACTIONS(769),
    [ts_builtin_sym_end] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_EQ_TILDE] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_AMP_GT] = ACTIONS(771),
    [anon_sym_AMP_GT_GT] = ACTIONS(769),
    [anon_sym_LT_AMP] = ACTIONS(769),
    [anon_sym_GT_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_LT_LT_DASH] = ACTIONS(769),
    [anon_sym_LT_LT_LT] = ACTIONS(769),
    [sym__special_characters] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [140] = {
    [anon_sym_DQUOTE] = ACTIONS(773),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [141] = {
    [sym__concat] = ACTIONS(785),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [sym__string_content] = ACTIONS(789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(787),
    [sym_comment] = ACTIONS(265),
  },
  [142] = {
    [sym_subscript] = STATE(442),
    [sym_variable_name] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(793),
    [anon_sym_DOLLAR] = ACTIONS(795),
    [anon_sym_POUND] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(795),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_AT] = ACTIONS(799),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_0] = ACTIONS(797),
    [anon_sym__] = ACTIONS(797),
  },
  [143] = {
    [sym__terminated_statement] = STATE(445),
    [sym_for_statement] = STATE(443),
    [sym_c_style_for_statement] = STATE(443),
    [sym_while_statement] = STATE(443),
    [sym_if_statement] = STATE(443),
    [sym_case_statement] = STATE(443),
    [sym_function_definition] = STATE(443),
    [sym_subshell] = STATE(443),
    [sym_pipeline] = STATE(443),
    [sym_list] = STATE(443),
    [sym_negated_command] = STATE(443),
    [sym_test_command] = STATE(443),
    [sym_declaration_command] = STATE(443),
    [sym_unset_command] = STATE(443),
    [sym_command] = STATE(443),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(444),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(445),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [144] = {
    [sym__terminated_statement] = STATE(448),
    [sym_for_statement] = STATE(446),
    [sym_c_style_for_statement] = STATE(446),
    [sym_while_statement] = STATE(446),
    [sym_if_statement] = STATE(446),
    [sym_case_statement] = STATE(446),
    [sym_function_definition] = STATE(446),
    [sym_subshell] = STATE(446),
    [sym_pipeline] = STATE(446),
    [sym_list] = STATE(446),
    [sym_negated_command] = STATE(446),
    [sym_test_command] = STATE(446),
    [sym_declaration_command] = STATE(446),
    [sym_unset_command] = STATE(446),
    [sym_command] = STATE(446),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(447),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(448),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [145] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(773),
    [anon_sym_DOLLAR] = ACTIONS(801),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [146] = {
    [sym__simple_heredoc_body] = ACTIONS(803),
    [sym__heredoc_body_beginning] = ACTIONS(803),
    [sym_file_descriptor] = ACTIONS(803),
    [sym__concat] = ACTIONS(803),
    [ts_builtin_sym_end] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [anon_sym_PIPE_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_EQ_TILDE] = ACTIONS(805),
    [anon_sym_EQ_EQ] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_AMP_GT] = ACTIONS(805),
    [anon_sym_AMP_GT_GT] = ACTIONS(803),
    [anon_sym_LT_AMP] = ACTIONS(803),
    [anon_sym_GT_AMP] = ACTIONS(803),
    [anon_sym_LT_LT] = ACTIONS(805),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_LT] = ACTIONS(803),
    [sym__special_characters] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_raw_string] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(805),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(805),
  },
  [147] = {
    [sym__simple_heredoc_body] = ACTIONS(807),
    [sym__heredoc_body_beginning] = ACTIONS(807),
    [sym_file_descriptor] = ACTIONS(807),
    [sym__concat] = ACTIONS(807),
    [ts_builtin_sym_end] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [anon_sym_PIPE_AMP] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_EQ_TILDE] = ACTIONS(809),
    [anon_sym_EQ_EQ] = ACTIONS(809),
    [anon_sym_LT] = ACTIONS(809),
    [anon_sym_GT] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(807),
    [anon_sym_AMP_GT] = ACTIONS(809),
    [anon_sym_AMP_GT_GT] = ACTIONS(807),
    [anon_sym_LT_AMP] = ACTIONS(807),
    [anon_sym_GT_AMP] = ACTIONS(807),
    [anon_sym_LT_LT] = ACTIONS(809),
    [anon_sym_LT_LT_DASH] = ACTIONS(807),
    [anon_sym_LT_LT_LT] = ACTIONS(807),
    [sym__special_characters] = ACTIONS(807),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(807),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_LT_LPAREN] = ACTIONS(807),
    [anon_sym_GT_LPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(809),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(809),
  },
  [148] = {
    [sym__simple_heredoc_body] = ACTIONS(811),
    [sym__heredoc_body_beginning] = ACTIONS(811),
    [sym_file_descriptor] = ACTIONS(811),
    [sym__concat] = ACTIONS(811),
    [ts_builtin_sym_end] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_EQ_TILDE] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_AMP_GT] = ACTIONS(813),
    [anon_sym_AMP_GT_GT] = ACTIONS(811),
    [anon_sym_LT_AMP] = ACTIONS(811),
    [anon_sym_GT_AMP] = ACTIONS(811),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_LT] = ACTIONS(811),
    [sym__special_characters] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_LT_LPAREN] = ACTIONS(811),
    [anon_sym_GT_LPAREN] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(813),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(813),
  },
  [149] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(817),
    [sym_comment] = ACTIONS(53),
  },
  [150] = {
    [sym_subscript] = STATE(455),
    [sym_variable_name] = ACTIONS(819),
    [anon_sym_DOLLAR] = ACTIONS(821),
    [anon_sym_DASH] = ACTIONS(821),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(823),
    [anon_sym_STAR] = ACTIONS(825),
    [anon_sym_AT] = ACTIONS(825),
    [anon_sym_QMARK] = ACTIONS(825),
    [anon_sym_0] = ACTIONS(823),
    [anon_sym__] = ACTIONS(823),
  },
  [151] = {
    [sym_concatenation] = STATE(466),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(466),
    [anon_sym_RBRACE] = ACTIONS(827),
    [anon_sym_EQ] = ACTIONS(829),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(829),
    [anon_sym_COLON_QMARK] = ACTIONS(829),
    [anon_sym_COLON_DASH] = ACTIONS(829),
    [anon_sym_PERCENT] = ACTIONS(829),
    [anon_sym_DASH] = ACTIONS(829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [152] = {
    [sym_concatenation] = STATE(469),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(469),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_EQ] = ACTIONS(855),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(855),
    [anon_sym_COLON_QMARK] = ACTIONS(855),
    [anon_sym_COLON_DASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [153] = {
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_SEMI_SEMI] = ACTIONS(865),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(861),
  },
  [154] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_SEMI_SEMI] = ACTIONS(865),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(861),
  },
  [155] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(472),
    [sym_c_style_for_statement] = STATE(472),
    [sym_while_statement] = STATE(472),
    [sym_if_statement] = STATE(472),
    [sym_case_statement] = STATE(472),
    [sym_function_definition] = STATE(472),
    [sym_subshell] = STATE(472),
    [sym_pipeline] = STATE(472),
    [sym_list] = STATE(472),
    [sym_negated_command] = STATE(472),
    [sym_test_command] = STATE(472),
    [sym_declaration_command] = STATE(472),
    [sym_unset_command] = STATE(472),
    [sym_command] = STATE(472),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(473),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [156] = {
    [sym__terminated_statement] = STATE(474),
    [sym_for_statement] = STATE(50),
    [sym_c_style_for_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_case_statement] = STATE(50),
    [sym_function_definition] = STATE(50),
    [sym_subshell] = STATE(50),
    [sym_pipeline] = STATE(50),
    [sym_list] = STATE(50),
    [sym_negated_command] = STATE(50),
    [sym_test_command] = STATE(50),
    [sym_declaration_command] = STATE(50),
    [sym_unset_command] = STATE(50),
    [sym_command] = STATE(50),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(52),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [157] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(867),
  },
  [158] = {
    [sym_subshell] = STATE(84),
    [sym_test_command] = STATE(84),
    [sym_command] = STATE(84),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(168),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(87),
  },
  [159] = {
    [sym__expression] = STATE(476),
    [sym_binary_expression] = STATE(476),
    [sym_unary_expression] = STATE(476),
    [sym_parenthesized_expression] = STATE(476),
    [sym_concatenation] = STATE(476),
    [sym_string] = STATE(91),
    [sym_simple_expansion] = STATE(91),
    [sym_string_expansion] = STATE(91),
    [sym_expansion] = STATE(91),
    [sym_command_substitution] = STATE(91),
    [sym_process_substitution] = STATE(91),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [160] = {
    [sym__expression] = STATE(477),
    [sym_binary_expression] = STATE(477),
    [sym_unary_expression] = STATE(477),
    [sym_parenthesized_expression] = STATE(477),
    [sym_concatenation] = STATE(477),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(177),
    [sym_test_operator] = ACTIONS(179),
  },
  [161] = {
    [sym_variable_assignment] = STATE(478),
    [sym_subscript] = STATE(231),
    [sym_concatenation] = STATE(478),
    [sym_string] = STATE(230),
    [sym_simple_expansion] = STATE(230),
    [sym_string_expansion] = STATE(230),
    [sym_expansion] = STATE(230),
    [sym_command_substitution] = STATE(230),
    [sym_process_substitution] = STATE(230),
    [aux_sym_declaration_command_repeat1] = STATE(478),
    [sym_variable_name] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_SEMI_SEMI] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [sym__special_characters] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(425),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(183),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(869),
    [sym_word] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [162] = {
    [sym_concatenation] = STATE(479),
    [sym_string] = STATE(234),
    [sym_simple_expansion] = STATE(234),
    [sym_string_expansion] = STATE(234),
    [sym_expansion] = STATE(234),
    [sym_command_substitution] = STATE(234),
    [sym_process_substitution] = STATE(234),
    [aux_sym_unset_command_repeat1] = STATE(479),
    [anon_sym_SEMI] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_SEMI_SEMI] = ACTIONS(207),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [sym__special_characters] = ACTIONS(431),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(871),
    [sym_word] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(209),
  },
  [163] = {
    [aux_sym_concatenation_repeat1] = STATE(236),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [164] = {
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(875),
  },
  [165] = {
    [sym_file_redirect] = STATE(487),
    [sym_heredoc_redirect] = STATE(487),
    [sym_heredoc_body] = STATE(185),
    [sym_herestring_redirect] = STATE(487),
    [sym_concatenation] = STATE(488),
    [sym_string] = STATE(248),
    [sym_simple_expansion] = STATE(248),
    [sym_string_expansion] = STATE(248),
    [sym_expansion] = STATE(248),
    [sym_command_substitution] = STATE(248),
    [sym_process_substitution] = STATE(248),
    [aux_sym_while_statement_repeat1] = STATE(487),
    [aux_sym_command_repeat2] = STATE(488),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(327),
    [anon_sym_PIPE_AMP] = ACTIONS(327),
    [anon_sym_AMP_AMP] = ACTIONS(327),
    [anon_sym_PIPE_PIPE] = ACTIONS(327),
    [anon_sym_EQ_TILDE] = ACTIONS(455),
    [anon_sym_EQ_EQ] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_AMP_GT] = ACTIONS(887),
    [anon_sym_AMP_GT_GT] = ACTIONS(889),
    [anon_sym_LT_AMP] = ACTIONS(889),
    [anon_sym_GT_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(891),
    [sym__special_characters] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(327),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(467),
    [anon_sym_LF] = ACTIONS(327),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [166] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(875),
  },
  [167] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(489),
    [sym_c_style_for_statement] = STATE(489),
    [sym_while_statement] = STATE(489),
    [sym_if_statement] = STATE(489),
    [sym_case_statement] = STATE(489),
    [sym_function_definition] = STATE(489),
    [sym_subshell] = STATE(489),
    [sym_pipeline] = STATE(489),
    [sym_list] = STATE(489),
    [sym_negated_command] = STATE(489),
    [sym_test_command] = STATE(489),
    [sym_declaration_command] = STATE(489),
    [sym_unset_command] = STATE(489),
    [sym_command] = STATE(489),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(490),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [168] = {
    [sym_command_name] = STATE(491),
    [sym_variable_assignment] = STATE(192),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(192),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(192),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(87),
  },
  [169] = {
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_SEMI_SEMI] = ACTIONS(897),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(893),
  },
  [170] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_SEMI_SEMI] = ACTIONS(897),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(893),
  },
  [171] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(494),
    [sym_c_style_for_statement] = STATE(494),
    [sym_while_statement] = STATE(494),
    [sym_if_statement] = STATE(494),
    [sym_case_statement] = STATE(494),
    [sym_function_definition] = STATE(494),
    [sym_subshell] = STATE(494),
    [sym_pipeline] = STATE(494),
    [sym_list] = STATE(494),
    [sym_negated_command] = STATE(494),
    [sym_test_command] = STATE(494),
    [sym_declaration_command] = STATE(494),
    [sym_unset_command] = STATE(494),
    [sym_command] = STATE(494),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(495),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [172] = {
    [anon_sym_RPAREN] = ACTIONS(899),
    [sym_comment] = ACTIONS(53),
  },
  [173] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [ts_builtin_sym_end] = ACTIONS(903),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [174] = {
    [sym_for_statement] = STATE(497),
    [sym_c_style_for_statement] = STATE(497),
    [sym_while_statement] = STATE(497),
    [sym_if_statement] = STATE(497),
    [sym_case_statement] = STATE(497),
    [sym_function_definition] = STATE(497),
    [sym_subshell] = STATE(497),
    [sym_pipeline] = STATE(497),
    [sym_list] = STATE(497),
    [sym_negated_command] = STATE(497),
    [sym_test_command] = STATE(497),
    [sym_declaration_command] = STATE(497),
    [sym_unset_command] = STATE(497),
    [sym_command] = STATE(497),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(498),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(32),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [175] = {
    [sym_for_statement] = STATE(499),
    [sym_c_style_for_statement] = STATE(499),
    [sym_while_statement] = STATE(499),
    [sym_if_statement] = STATE(499),
    [sym_case_statement] = STATE(499),
    [sym_function_definition] = STATE(499),
    [sym_subshell] = STATE(499),
    [sym_pipeline] = STATE(499),
    [sym_list] = STATE(499),
    [sym_negated_command] = STATE(499),
    [sym_test_command] = STATE(499),
    [sym_declaration_command] = STATE(499),
    [sym_unset_command] = STATE(499),
    [sym_command] = STATE(499),
    [sym_command_name] = STATE(27),
    [sym_variable_assignment] = STATE(500),
    [sym_subscript] = STATE(29),
    [sym_file_redirect] = STATE(32),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(19),
    [sym_simple_expansion] = STATE(19),
    [sym_string_expansion] = STATE(19),
    [sym_expansion] = STATE(19),
    [sym_command_substitution] = STATE(19),
    [sym_process_substitution] = STATE(19),
    [aux_sym_command_repeat1] = STATE(32),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(13),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(27),
    [anon_sym_declare] = ACTIONS(29),
    [anon_sym_typeset] = ACTIONS(29),
    [anon_sym_export] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(29),
    [anon_sym_unset] = ACTIONS(31),
    [anon_sym_unsetenv] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(37),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(43),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(55),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_esac] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_SEMI_SEMI] = ACTIONS(907),
    [anon_sym_PIPE_AMP] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_BQUOTE] = ACTIONS(907),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(909),
  },
  [177] = {
    [sym_simple_expansion] = STATE(504),
    [sym_expansion] = STATE(504),
    [aux_sym_heredoc_body_repeat1] = STATE(504),
    [sym__heredoc_body_middle] = ACTIONS(911),
    [sym__heredoc_body_end] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(917),
    [sym_comment] = ACTIONS(53),
  },
  [178] = {
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_AMP_GT] = ACTIONS(919),
    [anon_sym_AMP_GT_GT] = ACTIONS(921),
    [anon_sym_LT_AMP] = ACTIONS(921),
    [anon_sym_GT_AMP] = ACTIONS(921),
    [sym_comment] = ACTIONS(53),
  },
  [179] = {
    [sym_concatenation] = STATE(508),
    [sym_string] = STATE(507),
    [sym_simple_expansion] = STATE(507),
    [sym_string_expansion] = STATE(507),
    [sym_expansion] = STATE(507),
    [sym_command_substitution] = STATE(507),
    [sym_process_substitution] = STATE(507),
    [sym__special_characters] = ACTIONS(923),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(931),
    [anon_sym_BQUOTE] = ACTIONS(933),
    [anon_sym_LT_LPAREN] = ACTIONS(935),
    [anon_sym_GT_LPAREN] = ACTIONS(935),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(927),
    [sym_regex] = ACTIONS(937),
  },
  [180] = {
    [sym_concatenation] = STATE(511),
    [sym_string] = STATE(510),
    [sym_simple_expansion] = STATE(510),
    [sym_string_expansion] = STATE(510),
    [sym_expansion] = STATE(510),
    [sym_command_substitution] = STATE(510),
    [sym_process_substitution] = STATE(510),
    [sym__special_characters] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(941),
  },
  [181] = {
    [sym_heredoc_start] = ACTIONS(943),
    [sym_comment] = ACTIONS(53),
  },
  [182] = {
    [sym_concatenation] = STATE(515),
    [sym_string] = STATE(514),
    [sym_simple_expansion] = STATE(514),
    [sym_string_expansion] = STATE(514),
    [sym_expansion] = STATE(514),
    [sym_command_substitution] = STATE(514),
    [sym_process_substitution] = STATE(514),
    [sym__special_characters] = ACTIONS(945),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(947),
  },
  [183] = {
    [aux_sym_concatenation_repeat1] = STATE(138),
    [sym__simple_heredoc_body] = ACTIONS(949),
    [sym__heredoc_body_beginning] = ACTIONS(949),
    [sym_file_descriptor] = ACTIONS(949),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(949),
    [anon_sym_SEMI] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(951),
    [anon_sym_SEMI_SEMI] = ACTIONS(949),
    [anon_sym_PIPE_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(949),
    [anon_sym_EQ_TILDE] = ACTIONS(951),
    [anon_sym_EQ_EQ] = ACTIONS(951),
    [anon_sym_LT] = ACTIONS(951),
    [anon_sym_GT] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(949),
    [anon_sym_AMP_GT] = ACTIONS(951),
    [anon_sym_AMP_GT_GT] = ACTIONS(949),
    [anon_sym_LT_AMP] = ACTIONS(949),
    [anon_sym_GT_AMP] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(951),
    [anon_sym_LT_LT_DASH] = ACTIONS(949),
    [anon_sym_LT_LT_LT] = ACTIONS(949),
    [sym__special_characters] = ACTIONS(949),
    [anon_sym_DQUOTE] = ACTIONS(949),
    [anon_sym_DOLLAR] = ACTIONS(951),
    [sym_raw_string] = ACTIONS(949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(949),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(949),
    [anon_sym_BQUOTE] = ACTIONS(949),
    [anon_sym_LT_LPAREN] = ACTIONS(949),
    [anon_sym_GT_LPAREN] = ACTIONS(949),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(951),
    [anon_sym_LF] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
  },
  [184] = {
    [aux_sym_concatenation_repeat1] = STATE(138),
    [sym__simple_heredoc_body] = ACTIONS(953),
    [sym__heredoc_body_beginning] = ACTIONS(953),
    [sym_file_descriptor] = ACTIONS(953),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(953),
    [anon_sym_SEMI] = ACTIONS(955),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_SEMI_SEMI] = ACTIONS(953),
    [anon_sym_PIPE_AMP] = ACTIONS(953),
    [anon_sym_AMP_AMP] = ACTIONS(953),
    [anon_sym_PIPE_PIPE] = ACTIONS(953),
    [anon_sym_EQ_TILDE] = ACTIONS(955),
    [anon_sym_EQ_EQ] = ACTIONS(955),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_GT] = ACTIONS(955),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_AMP_GT] = ACTIONS(955),
    [anon_sym_AMP_GT_GT] = ACTIONS(953),
    [anon_sym_LT_AMP] = ACTIONS(953),
    [anon_sym_GT_AMP] = ACTIONS(953),
    [anon_sym_LT_LT] = ACTIONS(955),
    [anon_sym_LT_LT_DASH] = ACTIONS(953),
    [anon_sym_LT_LT_LT] = ACTIONS(953),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_DOLLAR] = ACTIONS(955),
    [sym_raw_string] = ACTIONS(953),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(953),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_BQUOTE] = ACTIONS(953),
    [anon_sym_LT_LPAREN] = ACTIONS(953),
    [anon_sym_GT_LPAREN] = ACTIONS(953),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(955),
    [anon_sym_LF] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(955),
  },
  [185] = {
    [ts_builtin_sym_end] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_esac] = ACTIONS(957),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [186] = {
    [sym_file_redirect] = STATE(517),
    [sym_heredoc_redirect] = STATE(517),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(517),
    [aux_sym_while_statement_repeat1] = STATE(517),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(341),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [187] = {
    [sym_file_redirect] = STATE(518),
    [sym_heredoc_redirect] = STATE(518),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(518),
    [sym_concatenation] = STATE(519),
    [sym_string] = STATE(184),
    [sym_simple_expansion] = STATE(184),
    [sym_string_expansion] = STATE(184),
    [sym_expansion] = STATE(184),
    [sym_command_substitution] = STATE(184),
    [sym_process_substitution] = STATE(184),
    [aux_sym_while_statement_repeat1] = STATE(518),
    [aux_sym_command_repeat2] = STATE(519),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(341),
    [sym__special_characters] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(347),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [188] = {
    [ts_builtin_sym_end] = ACTIONS(903),
    [anon_sym_SEMI] = ACTIONS(961),
    [anon_sym_PIPE] = ACTIONS(313),
    [anon_sym_SEMI_SEMI] = ACTIONS(963),
    [anon_sym_PIPE_AMP] = ACTIONS(317),
    [anon_sym_AMP_AMP] = ACTIONS(319),
    [anon_sym_PIPE_PIPE] = ACTIONS(319),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(961),
  },
  [189] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [ts_builtin_sym_end] = ACTIONS(903),
    [anon_sym_SEMI] = ACTIONS(961),
    [anon_sym_PIPE] = ACTIONS(313),
    [anon_sym_SEMI_SEMI] = ACTIONS(963),
    [anon_sym_PIPE_AMP] = ACTIONS(317),
    [anon_sym_AMP_AMP] = ACTIONS(319),
    [anon_sym_PIPE_PIPE] = ACTIONS(319),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(961),
  },
  [190] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(968),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_function] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(998),
    [anon_sym_typeset] = ACTIONS(998),
    [anon_sym_export] = ACTIONS(998),
    [anon_sym_readonly] = ACTIONS(998),
    [anon_sym_local] = ACTIONS(998),
    [anon_sym_unset] = ACTIONS(1001),
    [anon_sym_unsetenv] = ACTIONS(1001),
    [anon_sym_LT] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_AMP_GT] = ACTIONS(1004),
    [anon_sym_AMP_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_AMP] = ACTIONS(1007),
    [anon_sym_GT_AMP] = ACTIONS(1007),
    [sym__special_characters] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1013),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1022),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1025),
    [anon_sym_BQUOTE] = ACTIONS(1028),
    [anon_sym_LT_LPAREN] = ACTIONS(1031),
    [anon_sym_GT_LPAREN] = ACTIONS(1031),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1034),
  },
  [191] = {
    [sym_file_redirect] = STATE(518),
    [sym_heredoc_redirect] = STATE(518),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(518),
    [sym_concatenation] = STATE(523),
    [sym_string] = STATE(184),
    [sym_simple_expansion] = STATE(184),
    [sym_string_expansion] = STATE(184),
    [sym_expansion] = STATE(184),
    [sym_command_substitution] = STATE(184),
    [sym_process_substitution] = STATE(184),
    [aux_sym_while_statement_repeat1] = STATE(518),
    [aux_sym_command_repeat2] = STATE(523),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(341),
    [sym__special_characters] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(347),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [192] = {
    [sym_variable_assignment] = STATE(192),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(192),
    [aux_sym_command_repeat1] = STATE(192),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym_variable_name] = ACTIONS(1040),
    [anon_sym_LT] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(1043),
    [anon_sym_GT_GT] = ACTIONS(1046),
    [anon_sym_AMP_GT] = ACTIONS(1043),
    [anon_sym_AMP_GT_GT] = ACTIONS(1046),
    [anon_sym_LT_AMP] = ACTIONS(1046),
    [anon_sym_GT_AMP] = ACTIONS(1046),
    [sym__special_characters] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1049),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [anon_sym_LT_LPAREN] = ACTIONS(1049),
    [anon_sym_GT_LPAREN] = ACTIONS(1049),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1049),
  },
  [193] = {
    [aux_sym_concatenation_repeat1] = STATE(412),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(733),
    [sym_variable_name] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [sym__special_characters] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1055),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1053),
  },
  [194] = {
    [aux_sym_concatenation_repeat1] = STATE(412),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(733),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [sym__special_characters] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1057),
  },
  [195] = {
    [sym_file_descriptor] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [sym__special_characters] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1057),
  },
  [196] = {
    [aux_sym_concatenation_repeat1] = STATE(526),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(1063),
    [sym_comment] = ACTIONS(53),
  },
  [197] = {
    [aux_sym_concatenation_repeat1] = STATE(526),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_RBRACK] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
  },
  [198] = {
    [sym__concat] = ACTIONS(1069),
    [anon_sym_RBRACK] = ACTIONS(1067),
    [sym_comment] = ACTIONS(53),
  },
  [199] = {
    [sym_file_descriptor] = ACTIONS(1071),
    [sym_variable_name] = ACTIONS(1071),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [200] = {
    [sym_concatenation] = STATE(539),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_string_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [aux_sym_for_statement_repeat1] = STATE(539),
    [anon_sym_RPAREN] = ACTIONS(1075),
    [sym__special_characters] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym_raw_string] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1083),
  },
  [201] = {
    [aux_sym_concatenation_repeat1] = STATE(541),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1093),
    [ts_builtin_sym_end] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [202] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(544),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [203] = {
    [sym_string] = STATE(546),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_POUND] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_0] = ACTIONS(1107),
    [anon_sym__] = ACTIONS(1107),
  },
  [204] = {
    [aux_sym_concatenation_repeat1] = STATE(541),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1071),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [205] = {
    [sym_subscript] = STATE(551),
    [sym_variable_name] = ACTIONS(1111),
    [anon_sym_BANG] = ACTIONS(1113),
    [anon_sym_DOLLAR] = ACTIONS(1115),
    [anon_sym_POUND] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1115),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_0] = ACTIONS(1117),
    [anon_sym__] = ACTIONS(1117),
  },
  [206] = {
    [sym__terminated_statement] = STATE(554),
    [sym_for_statement] = STATE(552),
    [sym_c_style_for_statement] = STATE(552),
    [sym_while_statement] = STATE(552),
    [sym_if_statement] = STATE(552),
    [sym_case_statement] = STATE(552),
    [sym_function_definition] = STATE(552),
    [sym_subshell] = STATE(552),
    [sym_pipeline] = STATE(552),
    [sym_list] = STATE(552),
    [sym_negated_command] = STATE(552),
    [sym_test_command] = STATE(552),
    [sym_declaration_command] = STATE(552),
    [sym_unset_command] = STATE(552),
    [sym_command] = STATE(552),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(553),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(554),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [207] = {
    [sym__terminated_statement] = STATE(557),
    [sym_for_statement] = STATE(555),
    [sym_c_style_for_statement] = STATE(555),
    [sym_while_statement] = STATE(555),
    [sym_if_statement] = STATE(555),
    [sym_case_statement] = STATE(555),
    [sym_function_definition] = STATE(555),
    [sym_subshell] = STATE(555),
    [sym_pipeline] = STATE(555),
    [sym_list] = STATE(555),
    [sym_negated_command] = STATE(555),
    [sym_test_command] = STATE(555),
    [sym_declaration_command] = STATE(555),
    [sym_unset_command] = STATE(555),
    [sym_command] = STATE(555),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(556),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(557),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [208] = {
    [sym__terminated_statement] = STATE(560),
    [sym_for_statement] = STATE(558),
    [sym_c_style_for_statement] = STATE(558),
    [sym_while_statement] = STATE(558),
    [sym_if_statement] = STATE(558),
    [sym_case_statement] = STATE(558),
    [sym_function_definition] = STATE(558),
    [sym_subshell] = STATE(558),
    [sym_pipeline] = STATE(558),
    [sym_list] = STATE(558),
    [sym_negated_command] = STATE(558),
    [sym_test_command] = STATE(558),
    [sym_declaration_command] = STATE(558),
    [sym_unset_command] = STATE(558),
    [sym_command] = STATE(558),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(559),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(560),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [209] = {
    [sym__expression] = STATE(562),
    [sym_binary_expression] = STATE(562),
    [sym_unary_expression] = STATE(562),
    [sym_parenthesized_expression] = STATE(562),
    [sym_concatenation] = STATE(562),
    [sym_string] = STATE(215),
    [sym_simple_expansion] = STATE(215),
    [sym_string_expansion] = STATE(215),
    [sym_expansion] = STATE(215),
    [sym_command_substitution] = STATE(215),
    [sym_process_substitution] = STATE(215),
    [anon_sym_SEMI] = ACTIONS(1121),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(389),
    [sym__special_characters] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(407),
    [sym_test_operator] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1123),
  },
  [210] = {
    [sym__expression] = STATE(563),
    [sym_binary_expression] = STATE(563),
    [sym_unary_expression] = STATE(563),
    [sym_parenthesized_expression] = STATE(563),
    [sym_concatenation] = STATE(563),
    [sym_string] = STATE(314),
    [sym_simple_expansion] = STATE(314),
    [sym_string_expansion] = STATE(314),
    [sym_expansion] = STATE(314),
    [sym_command_substitution] = STATE(314),
    [sym_process_substitution] = STATE(314),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(573),
    [sym__special_characters] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(579),
    [sym_test_operator] = ACTIONS(581),
  },
  [211] = {
    [sym__expression] = STATE(564),
    [sym_binary_expression] = STATE(564),
    [sym_unary_expression] = STATE(564),
    [sym_parenthesized_expression] = STATE(564),
    [sym_concatenation] = STATE(564),
    [sym_string] = STATE(215),
    [sym_simple_expansion] = STATE(215),
    [sym_string_expansion] = STATE(215),
    [sym_expansion] = STATE(215),
    [sym_command_substitution] = STATE(215),
    [sym_process_substitution] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(389),
    [sym__special_characters] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(407),
    [sym_test_operator] = ACTIONS(409),
  },
  [212] = {
    [aux_sym_concatenation_repeat1] = STATE(566),
    [sym__concat] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(587),
    [anon_sym_SEMI_SEMI] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_EQ_TILDE] = ACTIONS(585),
    [anon_sym_EQ_EQ] = ACTIONS(585),
    [anon_sym_EQ] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(585),
    [anon_sym_BANG_EQ] = ACTIONS(585),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_AMP] = ACTIONS(587),
  },
  [213] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(569),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [214] = {
    [sym_string] = STATE(571),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(1137),
    [anon_sym_0] = ACTIONS(1135),
    [anon_sym__] = ACTIONS(1135),
  },
  [215] = {
    [aux_sym_concatenation_repeat1] = STATE(566),
    [sym__concat] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(603),
    [anon_sym_SEMI_SEMI] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [anon_sym_EQ_TILDE] = ACTIONS(601),
    [anon_sym_EQ_EQ] = ACTIONS(601),
    [anon_sym_EQ] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_GT] = ACTIONS(601),
    [anon_sym_BANG_EQ] = ACTIONS(601),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(601),
    [anon_sym_AMP] = ACTIONS(603),
  },
  [216] = {
    [sym_subscript] = STATE(576),
    [sym_variable_name] = ACTIONS(1139),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_DOLLAR] = ACTIONS(1143),
    [anon_sym_POUND] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1143),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_0] = ACTIONS(1145),
    [anon_sym__] = ACTIONS(1145),
  },
  [217] = {
    [sym__terminated_statement] = STATE(579),
    [sym_for_statement] = STATE(577),
    [sym_c_style_for_statement] = STATE(577),
    [sym_while_statement] = STATE(577),
    [sym_if_statement] = STATE(577),
    [sym_case_statement] = STATE(577),
    [sym_function_definition] = STATE(577),
    [sym_subshell] = STATE(577),
    [sym_pipeline] = STATE(577),
    [sym_list] = STATE(577),
    [sym_negated_command] = STATE(577),
    [sym_test_command] = STATE(577),
    [sym_declaration_command] = STATE(577),
    [sym_unset_command] = STATE(577),
    [sym_command] = STATE(577),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(578),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(579),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [218] = {
    [sym__terminated_statement] = STATE(582),
    [sym_for_statement] = STATE(580),
    [sym_c_style_for_statement] = STATE(580),
    [sym_while_statement] = STATE(580),
    [sym_if_statement] = STATE(580),
    [sym_case_statement] = STATE(580),
    [sym_function_definition] = STATE(580),
    [sym_subshell] = STATE(580),
    [sym_pipeline] = STATE(580),
    [sym_list] = STATE(580),
    [sym_negated_command] = STATE(580),
    [sym_test_command] = STATE(580),
    [sym_declaration_command] = STATE(580),
    [sym_unset_command] = STATE(580),
    [sym_command] = STATE(580),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(581),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(582),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [219] = {
    [sym__terminated_statement] = STATE(585),
    [sym_for_statement] = STATE(583),
    [sym_c_style_for_statement] = STATE(583),
    [sym_while_statement] = STATE(583),
    [sym_if_statement] = STATE(583),
    [sym_case_statement] = STATE(583),
    [sym_function_definition] = STATE(583),
    [sym_subshell] = STATE(583),
    [sym_pipeline] = STATE(583),
    [sym_list] = STATE(583),
    [sym_negated_command] = STATE(583),
    [sym_test_command] = STATE(583),
    [sym_declaration_command] = STATE(583),
    [sym_unset_command] = STATE(583),
    [sym_command] = STATE(583),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(584),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(585),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [220] = {
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_SEMI_SEMI] = ACTIONS(1151),
    [anon_sym_AMP_AMP] = ACTIONS(1153),
    [anon_sym_PIPE_PIPE] = ACTIONS(1153),
    [anon_sym_EQ_TILDE] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(1153),
    [anon_sym_BANG_EQ] = ACTIONS(1153),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1153),
    [anon_sym_LF] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1149),
  },
  [221] = {
    [sym_concatenation] = STATE(597),
    [sym_string] = STATE(592),
    [sym_simple_expansion] = STATE(592),
    [sym_string_expansion] = STATE(592),
    [sym_expansion] = STATE(592),
    [sym_command_substitution] = STATE(592),
    [sym_process_substitution] = STATE(592),
    [aux_sym_for_statement_repeat1] = STATE(597),
    [sym__special_characters] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(1161),
    [anon_sym_DOLLAR] = ACTIONS(1163),
    [sym_raw_string] = ACTIONS(1165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1167),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1171),
    [anon_sym_LT_LPAREN] = ACTIONS(1173),
    [anon_sym_GT_LPAREN] = ACTIONS(1173),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1165),
  },
  [222] = {
    [sym_do_group] = STATE(599),
    [anon_sym_do] = ACTIONS(1175),
    [sym_comment] = ACTIONS(53),
  },
  [223] = {
    [sym_concatenation] = STATE(199),
    [sym_string] = STATE(601),
    [sym_array] = STATE(199),
    [sym_simple_expansion] = STATE(601),
    [sym_string_expansion] = STATE(601),
    [sym_expansion] = STATE(601),
    [sym_command_substitution] = STATE(601),
    [sym_process_substitution] = STATE(601),
    [sym__empty_value] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(365),
    [sym__special_characters] = ACTIONS(1177),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(1179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LT_LPAREN] = ACTIONS(381),
    [anon_sym_GT_LPAREN] = ACTIONS(381),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1179),
  },
  [224] = {
    [sym_do_group] = STATE(602),
    [anon_sym_do] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [225] = {
    [sym_compound_statement] = STATE(604),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [226] = {
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(1183),
    [anon_sym_EQ_TILDE] = ACTIONS(619),
    [anon_sym_EQ_EQ] = ACTIONS(619),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_BANG_EQ] = ACTIONS(615),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(615),
  },
  [227] = {
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1183),
    [anon_sym_EQ_TILDE] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(647),
  },
  [228] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_PLUS_EQ] = ACTIONS(1185),
    [sym_comment] = ACTIONS(53),
  },
  [229] = {
    [aux_sym_concatenation_repeat1] = STATE(607),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(657),
    [anon_sym_SEMI] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_SEMI_SEMI] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(657),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [sym__special_characters] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [sym_raw_string] = ACTIONS(657),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(657),
    [anon_sym_BQUOTE] = ACTIONS(657),
    [anon_sym_LT_LPAREN] = ACTIONS(657),
    [anon_sym_GT_LPAREN] = ACTIONS(657),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(659),
    [sym_word] = ACTIONS(659),
    [anon_sym_LF] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(659),
  },
  [230] = {
    [aux_sym_concatenation_repeat1] = STATE(607),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(673),
    [anon_sym_SEMI] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(675),
    [anon_sym_SEMI_SEMI] = ACTIONS(673),
    [anon_sym_PIPE_AMP] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(673),
    [anon_sym_PIPE_PIPE] = ACTIONS(673),
    [sym__special_characters] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(673),
    [anon_sym_BQUOTE] = ACTIONS(673),
    [anon_sym_LT_LPAREN] = ACTIONS(673),
    [anon_sym_GT_LPAREN] = ACTIONS(673),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [anon_sym_LF] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
  },
  [231] = {
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_PLUS_EQ] = ACTIONS(1185),
    [sym_comment] = ACTIONS(53),
  },
  [232] = {
    [sym_variable_assignment] = STATE(608),
    [sym_subscript] = STATE(231),
    [sym_concatenation] = STATE(608),
    [sym_string] = STATE(230),
    [sym_simple_expansion] = STATE(230),
    [sym_string_expansion] = STATE(230),
    [sym_expansion] = STATE(230),
    [sym_command_substitution] = STATE(230),
    [sym_process_substitution] = STATE(230),
    [aux_sym_declaration_command_repeat1] = STATE(608),
    [sym_variable_name] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_SEMI_SEMI] = ACTIONS(687),
    [anon_sym_PIPE_AMP] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [sym__special_characters] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(425),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1187),
    [sym_word] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
  },
  [233] = {
    [aux_sym_concatenation_repeat1] = STATE(609),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(697),
    [sym_word] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [234] = {
    [aux_sym_concatenation_repeat1] = STATE(609),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_SEMI_SEMI] = ACTIONS(711),
    [anon_sym_PIPE_AMP] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(711),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [sym__special_characters] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_DOLLAR] = ACTIONS(713),
    [sym_raw_string] = ACTIONS(711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(711),
    [anon_sym_BQUOTE] = ACTIONS(711),
    [anon_sym_LT_LPAREN] = ACTIONS(711),
    [anon_sym_GT_LPAREN] = ACTIONS(711),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(713),
    [sym_word] = ACTIONS(713),
    [anon_sym_LF] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
  },
  [235] = {
    [sym_concatenation] = STATE(610),
    [sym_string] = STATE(234),
    [sym_simple_expansion] = STATE(234),
    [sym_string_expansion] = STATE(234),
    [sym_expansion] = STATE(234),
    [sym_command_substitution] = STATE(234),
    [sym_process_substitution] = STATE(234),
    [aux_sym_unset_command_repeat1] = STATE(610),
    [anon_sym_SEMI] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_SEMI_SEMI] = ACTIONS(725),
    [anon_sym_PIPE_AMP] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [sym__special_characters] = ACTIONS(431),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1189),
    [sym_word] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(727),
  },
  [236] = {
    [aux_sym_concatenation_repeat1] = STATE(611),
    [sym__simple_heredoc_body] = ACTIONS(765),
    [sym__heredoc_body_beginning] = ACTIONS(765),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_EQ_TILDE] = ACTIONS(767),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [237] = {
    [anon_sym_RPAREN] = ACTIONS(1191),
    [sym_comment] = ACTIONS(53),
  },
  [238] = {
    [sym__terminated_statement] = STATE(614),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(614),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_done] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [239] = {
    [sym_file_redirect] = STATE(616),
    [sym_heredoc_redirect] = STATE(616),
    [sym_heredoc_body] = STATE(615),
    [sym_herestring_redirect] = STATE(616),
    [aux_sym_while_statement_repeat1] = STATE(616),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(1195),
    [anon_sym_SEMI] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1197),
    [anon_sym_SEMI_SEMI] = ACTIONS(1195),
    [anon_sym_PIPE_AMP] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(341),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1197),
  },
  [240] = {
    [anon_sym_do] = ACTIONS(901),
    [anon_sym_then] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
  },
  [241] = {
    [sym_for_statement] = STATE(497),
    [sym_c_style_for_statement] = STATE(497),
    [sym_while_statement] = STATE(497),
    [sym_if_statement] = STATE(497),
    [sym_case_statement] = STATE(497),
    [sym_function_definition] = STATE(497),
    [sym_subshell] = STATE(497),
    [sym_pipeline] = STATE(497),
    [sym_list] = STATE(497),
    [sym_negated_command] = STATE(497),
    [sym_test_command] = STATE(497),
    [sym_declaration_command] = STATE(497),
    [sym_unset_command] = STATE(497),
    [sym_command] = STATE(497),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(498),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [242] = {
    [sym_for_statement] = STATE(617),
    [sym_c_style_for_statement] = STATE(617),
    [sym_while_statement] = STATE(617),
    [sym_if_statement] = STATE(617),
    [sym_case_statement] = STATE(617),
    [sym_function_definition] = STATE(617),
    [sym_subshell] = STATE(617),
    [sym_pipeline] = STATE(617),
    [sym_list] = STATE(617),
    [sym_negated_command] = STATE(617),
    [sym_test_command] = STATE(617),
    [sym_declaration_command] = STATE(617),
    [sym_unset_command] = STATE(617),
    [sym_command] = STATE(617),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(618),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [243] = {
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_AMP_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT_GT] = ACTIONS(1201),
    [anon_sym_LT_AMP] = ACTIONS(1201),
    [anon_sym_GT_AMP] = ACTIONS(1201),
    [sym_comment] = ACTIONS(53),
  },
  [244] = {
    [sym_concatenation] = STATE(508),
    [sym_string] = STATE(621),
    [sym_simple_expansion] = STATE(621),
    [sym_string_expansion] = STATE(621),
    [sym_expansion] = STATE(621),
    [sym_command_substitution] = STATE(621),
    [sym_process_substitution] = STATE(621),
    [sym__special_characters] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(931),
    [anon_sym_BQUOTE] = ACTIONS(933),
    [anon_sym_LT_LPAREN] = ACTIONS(935),
    [anon_sym_GT_LPAREN] = ACTIONS(935),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1205),
    [sym_regex] = ACTIONS(937),
  },
  [245] = {
    [sym_concatenation] = STATE(511),
    [sym_string] = STATE(623),
    [sym_simple_expansion] = STATE(623),
    [sym_string_expansion] = STATE(623),
    [sym_expansion] = STATE(623),
    [sym_command_substitution] = STATE(623),
    [sym_process_substitution] = STATE(623),
    [sym__special_characters] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1209),
  },
  [246] = {
    [sym_concatenation] = STATE(515),
    [sym_string] = STATE(625),
    [sym_simple_expansion] = STATE(625),
    [sym_string_expansion] = STATE(625),
    [sym_expansion] = STATE(625),
    [sym_command_substitution] = STATE(625),
    [sym_process_substitution] = STATE(625),
    [sym__special_characters] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1213),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1213),
  },
  [247] = {
    [aux_sym_concatenation_repeat1] = STATE(236),
    [sym__simple_heredoc_body] = ACTIONS(949),
    [sym__heredoc_body_beginning] = ACTIONS(949),
    [sym_file_descriptor] = ACTIONS(949),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(951),
    [anon_sym_SEMI_SEMI] = ACTIONS(949),
    [anon_sym_PIPE_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(949),
    [anon_sym_EQ_TILDE] = ACTIONS(951),
    [anon_sym_EQ_EQ] = ACTIONS(951),
    [anon_sym_LT] = ACTIONS(951),
    [anon_sym_GT] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(949),
    [anon_sym_AMP_GT] = ACTIONS(951),
    [anon_sym_AMP_GT_GT] = ACTIONS(949),
    [anon_sym_LT_AMP] = ACTIONS(949),
    [anon_sym_GT_AMP] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(951),
    [anon_sym_LT_LT_DASH] = ACTIONS(949),
    [anon_sym_LT_LT_LT] = ACTIONS(949),
    [sym__special_characters] = ACTIONS(949),
    [anon_sym_DQUOTE] = ACTIONS(949),
    [anon_sym_DOLLAR] = ACTIONS(951),
    [sym_raw_string] = ACTIONS(949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(949),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(949),
    [anon_sym_BQUOTE] = ACTIONS(949),
    [anon_sym_LT_LPAREN] = ACTIONS(949),
    [anon_sym_GT_LPAREN] = ACTIONS(949),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(951),
    [anon_sym_LF] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
  },
  [248] = {
    [aux_sym_concatenation_repeat1] = STATE(236),
    [sym__simple_heredoc_body] = ACTIONS(953),
    [sym__heredoc_body_beginning] = ACTIONS(953),
    [sym_file_descriptor] = ACTIONS(953),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(955),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_SEMI_SEMI] = ACTIONS(953),
    [anon_sym_PIPE_AMP] = ACTIONS(953),
    [anon_sym_AMP_AMP] = ACTIONS(953),
    [anon_sym_PIPE_PIPE] = ACTIONS(953),
    [anon_sym_EQ_TILDE] = ACTIONS(955),
    [anon_sym_EQ_EQ] = ACTIONS(955),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_GT] = ACTIONS(955),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_AMP_GT] = ACTIONS(955),
    [anon_sym_AMP_GT_GT] = ACTIONS(953),
    [anon_sym_LT_AMP] = ACTIONS(953),
    [anon_sym_GT_AMP] = ACTIONS(953),
    [anon_sym_LT_LT] = ACTIONS(955),
    [anon_sym_LT_LT_DASH] = ACTIONS(953),
    [anon_sym_LT_LT_LT] = ACTIONS(953),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_DOLLAR] = ACTIONS(955),
    [sym_raw_string] = ACTIONS(953),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(953),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_BQUOTE] = ACTIONS(953),
    [anon_sym_LT_LPAREN] = ACTIONS(953),
    [anon_sym_GT_LPAREN] = ACTIONS(953),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(955),
    [anon_sym_LF] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(955),
  },
  [249] = {
    [sym_file_redirect] = STATE(626),
    [sym_heredoc_redirect] = STATE(626),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(626),
    [aux_sym_while_statement_repeat1] = STATE(626),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [250] = {
    [sym_file_redirect] = STATE(627),
    [sym_heredoc_redirect] = STATE(627),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(627),
    [sym_concatenation] = STATE(628),
    [sym_string] = STATE(248),
    [sym_simple_expansion] = STATE(248),
    [sym_string_expansion] = STATE(248),
    [sym_expansion] = STATE(248),
    [sym_command_substitution] = STATE(248),
    [sym_process_substitution] = STATE(248),
    [aux_sym_while_statement_repeat1] = STATE(627),
    [aux_sym_command_repeat2] = STATE(628),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(455),
    [anon_sym_EQ_EQ] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [sym__special_characters] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(467),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [251] = {
    [sym_file_redirect] = STATE(627),
    [sym_heredoc_redirect] = STATE(627),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(627),
    [sym_concatenation] = STATE(629),
    [sym_string] = STATE(248),
    [sym_simple_expansion] = STATE(248),
    [sym_string_expansion] = STATE(248),
    [sym_expansion] = STATE(248),
    [sym_command_substitution] = STATE(248),
    [sym_process_substitution] = STATE(248),
    [aux_sym_while_statement_repeat1] = STATE(627),
    [aux_sym_command_repeat2] = STATE(629),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(455),
    [anon_sym_EQ_EQ] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [sym__special_characters] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(467),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [252] = {
    [sym__terminated_statement] = STATE(634),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_elif_clause] = STATE(635),
    [sym_else_clause] = STATE(633),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(634),
    [aux_sym_if_statement_repeat1] = STATE(635),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(1215),
    [anon_sym_elif] = ACTIONS(1217),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [253] = {
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [sym__special_characters] = ACTIONS(1221),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [anon_sym_DOLLAR] = ACTIONS(95),
    [sym_raw_string] = ACTIONS(1221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(99),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(103),
    [anon_sym_LT_LPAREN] = ACTIONS(105),
    [anon_sym_GT_LPAREN] = ACTIONS(105),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1221),
  },
  [254] = {
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_SEMI_SEMI] = ACTIONS(1225),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1225),
  },
  [255] = {
    [anon_sym_in] = ACTIONS(1227),
    [sym_comment] = ACTIONS(53),
  },
  [256] = {
    [aux_sym_concatenation_repeat1] = STATE(639),
    [sym__concat] = ACTIONS(473),
    [anon_sym_in] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(765),
  },
  [257] = {
    [sym__concat] = ACTIONS(769),
    [anon_sym_in] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
  },
  [258] = {
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [259] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_DOLLAR] = ACTIONS(1231),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [260] = {
    [sym__concat] = ACTIONS(803),
    [anon_sym_in] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(803),
  },
  [261] = {
    [sym__concat] = ACTIONS(807),
    [anon_sym_in] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(807),
  },
  [262] = {
    [sym__concat] = ACTIONS(811),
    [anon_sym_in] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(811),
  },
  [263] = {
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_SEMI_SEMI] = ACTIONS(1235),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
  },
  [264] = {
    [anon_sym_in] = ACTIONS(1237),
    [sym_comment] = ACTIONS(53),
  },
  [265] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1239),
    [sym_comment] = ACTIONS(53),
  },
  [266] = {
    [sym_subscript] = STATE(647),
    [sym_variable_name] = ACTIONS(1241),
    [anon_sym_DOLLAR] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AT] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(1247),
    [anon_sym_0] = ACTIONS(1245),
    [anon_sym__] = ACTIONS(1245),
  },
  [267] = {
    [sym_concatenation] = STATE(650),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(650),
    [anon_sym_RBRACE] = ACTIONS(1249),
    [anon_sym_EQ] = ACTIONS(1251),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_COLON] = ACTIONS(1251),
    [anon_sym_COLON_QMARK] = ACTIONS(1251),
    [anon_sym_COLON_DASH] = ACTIONS(1251),
    [anon_sym_PERCENT] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [268] = {
    [sym_concatenation] = STATE(653),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(653),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_EQ] = ACTIONS(1259),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1263),
    [anon_sym_COLON] = ACTIONS(1259),
    [anon_sym_COLON_QMARK] = ACTIONS(1259),
    [anon_sym_COLON_DASH] = ACTIONS(1259),
    [anon_sym_PERCENT] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [269] = {
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [270] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [271] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(656),
    [sym_c_style_for_statement] = STATE(656),
    [sym_while_statement] = STATE(656),
    [sym_if_statement] = STATE(656),
    [sym_case_statement] = STATE(656),
    [sym_function_definition] = STATE(656),
    [sym_subshell] = STATE(656),
    [sym_pipeline] = STATE(656),
    [sym_list] = STATE(656),
    [sym_negated_command] = STATE(656),
    [sym_test_command] = STATE(656),
    [sym_declaration_command] = STATE(656),
    [sym_unset_command] = STATE(656),
    [sym_command] = STATE(656),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(657),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [272] = {
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1271),
  },
  [273] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1271),
  },
  [274] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(659),
    [sym_c_style_for_statement] = STATE(659),
    [sym_while_statement] = STATE(659),
    [sym_if_statement] = STATE(659),
    [sym_case_statement] = STATE(659),
    [sym_function_definition] = STATE(659),
    [sym_subshell] = STATE(659),
    [sym_pipeline] = STATE(659),
    [sym_list] = STATE(659),
    [sym_negated_command] = STATE(659),
    [sym_test_command] = STATE(659),
    [sym_declaration_command] = STATE(659),
    [sym_unset_command] = STATE(659),
    [sym_command] = STATE(659),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(660),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [275] = {
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1277),
    [anon_sym_SEMI_SEMI] = ACTIONS(1279),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [276] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1277),
    [anon_sym_SEMI_SEMI] = ACTIONS(1279),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [277] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(663),
    [sym_c_style_for_statement] = STATE(663),
    [sym_while_statement] = STATE(663),
    [sym_if_statement] = STATE(663),
    [sym_case_statement] = STATE(663),
    [sym_function_definition] = STATE(663),
    [sym_subshell] = STATE(663),
    [sym_pipeline] = STATE(663),
    [sym_list] = STATE(663),
    [sym_negated_command] = STATE(663),
    [sym_test_command] = STATE(663),
    [sym_declaration_command] = STATE(663),
    [sym_unset_command] = STATE(663),
    [sym_command] = STATE(663),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(664),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [278] = {
    [anon_sym_RPAREN] = ACTIONS(1281),
    [sym_comment] = ACTIONS(53),
  },
  [279] = {
    [sym__terminated_statement] = STATE(669),
    [sym_for_statement] = STATE(667),
    [sym_c_style_for_statement] = STATE(667),
    [sym_while_statement] = STATE(667),
    [sym_if_statement] = STATE(667),
    [sym_case_statement] = STATE(667),
    [sym_function_definition] = STATE(667),
    [sym_subshell] = STATE(667),
    [sym_pipeline] = STATE(667),
    [sym_list] = STATE(667),
    [sym_negated_command] = STATE(667),
    [sym_test_command] = STATE(667),
    [sym_declaration_command] = STATE(667),
    [sym_unset_command] = STATE(667),
    [sym_command] = STATE(667),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(668),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(669),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [280] = {
    [sym_file_redirect] = STATE(672),
    [sym_file_descriptor] = ACTIONS(1285),
    [ts_builtin_sym_end] = ACTIONS(1287),
    [anon_sym_SEMI] = ACTIONS(1289),
    [anon_sym_PIPE] = ACTIONS(1289),
    [anon_sym_SEMI_SEMI] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_LT] = ACTIONS(1291),
    [anon_sym_GT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_AMP_GT] = ACTIONS(1291),
    [anon_sym_AMP_GT_GT] = ACTIONS(1293),
    [anon_sym_LT_AMP] = ACTIONS(1293),
    [anon_sym_GT_AMP] = ACTIONS(1293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1289),
  },
  [281] = {
    [sym_concatenation] = STATE(199),
    [sym_string] = STATE(674),
    [sym_array] = STATE(199),
    [sym_simple_expansion] = STATE(674),
    [sym_string_expansion] = STATE(674),
    [sym_expansion] = STATE(674),
    [sym_command_substitution] = STATE(674),
    [sym_process_substitution] = STATE(674),
    [sym__empty_value] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(365),
    [sym__special_characters] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(1297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LT_LPAREN] = ACTIONS(381),
    [anon_sym_GT_LPAREN] = ACTIONS(381),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1297),
  },
  [282] = {
    [sym_do_group] = STATE(675),
    [anon_sym_do] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [283] = {
    [sym_compound_statement] = STATE(677),
    [anon_sym_LPAREN] = ACTIONS(1299),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [284] = {
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(619),
    [anon_sym_EQ_EQ] = ACTIONS(619),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_BANG_EQ] = ACTIONS(615),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(615),
  },
  [285] = {
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(647),
  },
  [286] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(1303),
    [anon_sym_PLUS_EQ] = ACTIONS(1303),
    [sym_comment] = ACTIONS(53),
  },
  [287] = {
    [aux_sym_concatenation_repeat1] = STATE(680),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(657),
    [anon_sym_SEMI] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_RPAREN] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(657),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [sym__special_characters] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [sym_raw_string] = ACTIONS(657),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(657),
    [anon_sym_BQUOTE] = ACTIONS(657),
    [anon_sym_LT_LPAREN] = ACTIONS(657),
    [anon_sym_GT_LPAREN] = ACTIONS(657),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(659),
    [sym_word] = ACTIONS(659),
    [anon_sym_LF] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(659),
  },
  [288] = {
    [aux_sym_concatenation_repeat1] = STATE(680),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(673),
    [anon_sym_SEMI] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(675),
    [anon_sym_RPAREN] = ACTIONS(673),
    [anon_sym_SEMI_SEMI] = ACTIONS(673),
    [anon_sym_PIPE_AMP] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(673),
    [anon_sym_PIPE_PIPE] = ACTIONS(673),
    [sym__special_characters] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(673),
    [anon_sym_BQUOTE] = ACTIONS(673),
    [anon_sym_LT_LPAREN] = ACTIONS(673),
    [anon_sym_GT_LPAREN] = ACTIONS(673),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [anon_sym_LF] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
  },
  [289] = {
    [anon_sym_EQ] = ACTIONS(1303),
    [anon_sym_PLUS_EQ] = ACTIONS(1303),
    [sym_comment] = ACTIONS(53),
  },
  [290] = {
    [sym_variable_assignment] = STATE(681),
    [sym_subscript] = STATE(289),
    [sym_concatenation] = STATE(681),
    [sym_string] = STATE(288),
    [sym_simple_expansion] = STATE(288),
    [sym_string_expansion] = STATE(288),
    [sym_expansion] = STATE(288),
    [sym_command_substitution] = STATE(288),
    [sym_process_substitution] = STATE(288),
    [aux_sym_declaration_command_repeat1] = STATE(681),
    [sym_variable_name] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_RPAREN] = ACTIONS(687),
    [anon_sym_SEMI_SEMI] = ACTIONS(687),
    [anon_sym_PIPE_AMP] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [sym__special_characters] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1305),
    [sym_word] = ACTIONS(525),
    [anon_sym_LF] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
  },
  [291] = {
    [aux_sym_concatenation_repeat1] = STATE(682),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_RPAREN] = ACTIONS(695),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(697),
    [sym_word] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [292] = {
    [aux_sym_concatenation_repeat1] = STATE(682),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym_SEMI_SEMI] = ACTIONS(711),
    [anon_sym_PIPE_AMP] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(711),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [sym__special_characters] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_DOLLAR] = ACTIONS(713),
    [sym_raw_string] = ACTIONS(711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(711),
    [anon_sym_BQUOTE] = ACTIONS(711),
    [anon_sym_LT_LPAREN] = ACTIONS(711),
    [anon_sym_GT_LPAREN] = ACTIONS(711),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(713),
    [sym_word] = ACTIONS(713),
    [anon_sym_LF] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
  },
  [293] = {
    [sym_concatenation] = STATE(683),
    [sym_string] = STATE(292),
    [sym_simple_expansion] = STATE(292),
    [sym_string_expansion] = STATE(292),
    [sym_expansion] = STATE(292),
    [sym_command_substitution] = STATE(292),
    [sym_process_substitution] = STATE(292),
    [aux_sym_unset_command_repeat1] = STATE(683),
    [anon_sym_SEMI] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_SEMI_SEMI] = ACTIONS(725),
    [anon_sym_PIPE_AMP] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [sym__special_characters] = ACTIONS(527),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(529),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1307),
    [sym_word] = ACTIONS(533),
    [anon_sym_LF] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(727),
  },
  [294] = {
    [aux_sym_concatenation_repeat1] = STATE(684),
    [sym__simple_heredoc_body] = ACTIONS(765),
    [sym__heredoc_body_beginning] = ACTIONS(765),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_EQ_TILDE] = ACTIONS(767),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [295] = {
    [anon_sym_RPAREN] = ACTIONS(1309),
    [sym_comment] = ACTIONS(53),
  },
  [296] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(1311),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [297] = {
    [sym_for_statement] = STATE(497),
    [sym_c_style_for_statement] = STATE(497),
    [sym_while_statement] = STATE(497),
    [sym_if_statement] = STATE(497),
    [sym_case_statement] = STATE(497),
    [sym_function_definition] = STATE(497),
    [sym_subshell] = STATE(497),
    [sym_pipeline] = STATE(497),
    [sym_list] = STATE(497),
    [sym_negated_command] = STATE(497),
    [sym_test_command] = STATE(497),
    [sym_declaration_command] = STATE(497),
    [sym_unset_command] = STATE(497),
    [sym_command] = STATE(497),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(498),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [298] = {
    [ts_builtin_sym_end] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_esac] = ACTIONS(1313),
    [anon_sym_PIPE] = ACTIONS(1315),
    [anon_sym_RPAREN] = ACTIONS(1313),
    [anon_sym_SEMI_SEMI] = ACTIONS(1313),
    [anon_sym_PIPE_AMP] = ACTIONS(1313),
    [anon_sym_AMP_AMP] = ACTIONS(1313),
    [anon_sym_PIPE_PIPE] = ACTIONS(1313),
    [anon_sym_BQUOTE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1315),
  },
  [299] = {
    [sym_for_statement] = STATE(687),
    [sym_c_style_for_statement] = STATE(687),
    [sym_while_statement] = STATE(687),
    [sym_if_statement] = STATE(687),
    [sym_case_statement] = STATE(687),
    [sym_function_definition] = STATE(687),
    [sym_subshell] = STATE(687),
    [sym_pipeline] = STATE(687),
    [sym_list] = STATE(687),
    [sym_negated_command] = STATE(687),
    [sym_test_command] = STATE(687),
    [sym_declaration_command] = STATE(687),
    [sym_unset_command] = STATE(687),
    [sym_command] = STATE(687),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(688),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [300] = {
    [anon_sym_LT] = ACTIONS(1317),
    [anon_sym_GT] = ACTIONS(1317),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_AMP_GT] = ACTIONS(1317),
    [anon_sym_AMP_GT_GT] = ACTIONS(1319),
    [anon_sym_LT_AMP] = ACTIONS(1319),
    [anon_sym_GT_AMP] = ACTIONS(1319),
    [sym_comment] = ACTIONS(53),
  },
  [301] = {
    [sym_concatenation] = STATE(508),
    [sym_string] = STATE(691),
    [sym_simple_expansion] = STATE(691),
    [sym_string_expansion] = STATE(691),
    [sym_expansion] = STATE(691),
    [sym_command_substitution] = STATE(691),
    [sym_process_substitution] = STATE(691),
    [sym__special_characters] = ACTIONS(1321),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(931),
    [anon_sym_BQUOTE] = ACTIONS(933),
    [anon_sym_LT_LPAREN] = ACTIONS(935),
    [anon_sym_GT_LPAREN] = ACTIONS(935),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1323),
    [sym_regex] = ACTIONS(937),
  },
  [302] = {
    [sym_concatenation] = STATE(511),
    [sym_string] = STATE(693),
    [sym_simple_expansion] = STATE(693),
    [sym_string_expansion] = STATE(693),
    [sym_expansion] = STATE(693),
    [sym_command_substitution] = STATE(693),
    [sym_process_substitution] = STATE(693),
    [sym__special_characters] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1327),
  },
  [303] = {
    [sym_concatenation] = STATE(515),
    [sym_string] = STATE(695),
    [sym_simple_expansion] = STATE(695),
    [sym_string_expansion] = STATE(695),
    [sym_expansion] = STATE(695),
    [sym_command_substitution] = STATE(695),
    [sym_process_substitution] = STATE(695),
    [sym__special_characters] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1331),
  },
  [304] = {
    [aux_sym_concatenation_repeat1] = STATE(294),
    [sym__simple_heredoc_body] = ACTIONS(949),
    [sym__heredoc_body_beginning] = ACTIONS(949),
    [sym_file_descriptor] = ACTIONS(949),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(949),
    [anon_sym_SEMI_SEMI] = ACTIONS(949),
    [anon_sym_PIPE_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(949),
    [anon_sym_EQ_TILDE] = ACTIONS(951),
    [anon_sym_EQ_EQ] = ACTIONS(951),
    [anon_sym_LT] = ACTIONS(951),
    [anon_sym_GT] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(949),
    [anon_sym_AMP_GT] = ACTIONS(951),
    [anon_sym_AMP_GT_GT] = ACTIONS(949),
    [anon_sym_LT_AMP] = ACTIONS(949),
    [anon_sym_GT_AMP] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(951),
    [anon_sym_LT_LT_DASH] = ACTIONS(949),
    [anon_sym_LT_LT_LT] = ACTIONS(949),
    [sym__special_characters] = ACTIONS(949),
    [anon_sym_DQUOTE] = ACTIONS(949),
    [anon_sym_DOLLAR] = ACTIONS(951),
    [sym_raw_string] = ACTIONS(949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(949),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(949),
    [anon_sym_BQUOTE] = ACTIONS(949),
    [anon_sym_LT_LPAREN] = ACTIONS(949),
    [anon_sym_GT_LPAREN] = ACTIONS(949),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(951),
    [anon_sym_LF] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
  },
  [305] = {
    [aux_sym_concatenation_repeat1] = STATE(294),
    [sym__simple_heredoc_body] = ACTIONS(953),
    [sym__heredoc_body_beginning] = ACTIONS(953),
    [sym_file_descriptor] = ACTIONS(953),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(955),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_RPAREN] = ACTIONS(953),
    [anon_sym_SEMI_SEMI] = ACTIONS(953),
    [anon_sym_PIPE_AMP] = ACTIONS(953),
    [anon_sym_AMP_AMP] = ACTIONS(953),
    [anon_sym_PIPE_PIPE] = ACTIONS(953),
    [anon_sym_EQ_TILDE] = ACTIONS(955),
    [anon_sym_EQ_EQ] = ACTIONS(955),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_GT] = ACTIONS(955),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_AMP_GT] = ACTIONS(955),
    [anon_sym_AMP_GT_GT] = ACTIONS(953),
    [anon_sym_LT_AMP] = ACTIONS(953),
    [anon_sym_GT_AMP] = ACTIONS(953),
    [anon_sym_LT_LT] = ACTIONS(955),
    [anon_sym_LT_LT_DASH] = ACTIONS(953),
    [anon_sym_LT_LT_LT] = ACTIONS(953),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_DOLLAR] = ACTIONS(955),
    [sym_raw_string] = ACTIONS(953),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(953),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_BQUOTE] = ACTIONS(953),
    [anon_sym_LT_LPAREN] = ACTIONS(953),
    [anon_sym_GT_LPAREN] = ACTIONS(953),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(955),
    [anon_sym_LF] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(955),
  },
  [306] = {
    [sym_file_redirect] = STATE(696),
    [sym_heredoc_redirect] = STATE(696),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(696),
    [aux_sym_while_statement_repeat1] = STATE(696),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(557),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [307] = {
    [sym_file_redirect] = STATE(697),
    [sym_heredoc_redirect] = STATE(697),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(697),
    [sym_concatenation] = STATE(698),
    [sym_string] = STATE(305),
    [sym_simple_expansion] = STATE(305),
    [sym_string_expansion] = STATE(305),
    [sym_expansion] = STATE(305),
    [sym_command_substitution] = STATE(305),
    [sym_process_substitution] = STATE(305),
    [aux_sym_while_statement_repeat1] = STATE(697),
    [aux_sym_command_repeat2] = STATE(698),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(557),
    [sym__special_characters] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(563),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [308] = {
    [anon_sym_SEMI] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1311),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1333),
  },
  [309] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1311),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1333),
  },
  [310] = {
    [sym_file_redirect] = STATE(697),
    [sym_heredoc_redirect] = STATE(697),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(697),
    [sym_concatenation] = STATE(700),
    [sym_string] = STATE(305),
    [sym_simple_expansion] = STATE(305),
    [sym_string_expansion] = STATE(305),
    [sym_expansion] = STATE(305),
    [sym_command_substitution] = STATE(305),
    [sym_process_substitution] = STATE(305),
    [aux_sym_while_statement_repeat1] = STATE(697),
    [aux_sym_command_repeat2] = STATE(700),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(557),
    [sym__special_characters] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(563),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [311] = {
    [sym_concatenation] = STATE(701),
    [sym_string] = STATE(704),
    [sym_array] = STATE(701),
    [sym_simple_expansion] = STATE(704),
    [sym_string_expansion] = STATE(704),
    [sym_expansion] = STATE(704),
    [sym_command_substitution] = STATE(704),
    [sym_process_substitution] = STATE(704),
    [sym__empty_value] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [sym__special_characters] = ACTIONS(1341),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_raw_string] = ACTIONS(1343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(241),
    [anon_sym_BQUOTE] = ACTIONS(243),
    [anon_sym_LT_LPAREN] = ACTIONS(245),
    [anon_sym_GT_LPAREN] = ACTIONS(245),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1343),
  },
  [312] = {
    [sym__expression] = STATE(705),
    [sym_binary_expression] = STATE(705),
    [sym_unary_expression] = STATE(705),
    [sym_parenthesized_expression] = STATE(705),
    [sym_concatenation] = STATE(705),
    [sym_string] = STATE(314),
    [sym_simple_expansion] = STATE(314),
    [sym_string_expansion] = STATE(314),
    [sym_expansion] = STATE(314),
    [sym_command_substitution] = STATE(314),
    [sym_process_substitution] = STATE(314),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(573),
    [sym__special_characters] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(579),
    [sym_test_operator] = ACTIONS(581),
  },
  [313] = {
    [aux_sym_concatenation_repeat1] = STATE(706),
    [sym__concat] = ACTIONS(623),
    [anon_sym_RPAREN] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_EQ_TILDE] = ACTIONS(585),
    [anon_sym_EQ_EQ] = ACTIONS(585),
    [anon_sym_EQ] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(585),
    [anon_sym_BANG_EQ] = ACTIONS(585),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(585),
  },
  [314] = {
    [aux_sym_concatenation_repeat1] = STATE(706),
    [sym__concat] = ACTIONS(623),
    [anon_sym_RPAREN] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [anon_sym_EQ_TILDE] = ACTIONS(601),
    [anon_sym_EQ_EQ] = ACTIONS(601),
    [anon_sym_EQ] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_GT] = ACTIONS(601),
    [anon_sym_BANG_EQ] = ACTIONS(601),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(601),
  },
  [315] = {
    [anon_sym_RPAREN] = ACTIONS(1345),
    [anon_sym_AMP_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1347),
    [anon_sym_EQ_TILDE] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1347),
  },
  [316] = {
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(1353),
    [anon_sym_EQ_TILDE] = ACTIONS(619),
    [anon_sym_EQ_EQ] = ACTIONS(619),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_BANG_EQ] = ACTIONS(615),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(615),
  },
  [317] = {
    [sym_string] = STATE(710),
    [sym_simple_expansion] = STATE(710),
    [sym_string_expansion] = STATE(710),
    [sym_expansion] = STATE(710),
    [sym_command_substitution] = STATE(710),
    [sym_process_substitution] = STATE(710),
    [sym__special_characters] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(1355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1355),
  },
  [318] = {
    [aux_sym_concatenation_repeat1] = STATE(711),
    [sym__concat] = ACTIONS(583),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_RBRACK] = ACTIONS(765),
    [anon_sym_EQ_TILDE] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(765),
  },
  [319] = {
    [sym__concat] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_RBRACK] = ACTIONS(769),
    [anon_sym_EQ_TILDE] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(769),
  },
  [320] = {
    [anon_sym_DQUOTE] = ACTIONS(1357),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [321] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(1357),
    [anon_sym_DOLLAR] = ACTIONS(1359),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [322] = {
    [sym__concat] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_RBRACK] = ACTIONS(803),
    [anon_sym_EQ_TILDE] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_EQ] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(803),
  },
  [323] = {
    [sym__concat] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_RBRACK] = ACTIONS(807),
    [anon_sym_EQ_TILDE] = ACTIONS(807),
    [anon_sym_EQ_EQ] = ACTIONS(807),
    [anon_sym_EQ] = ACTIONS(809),
    [anon_sym_LT] = ACTIONS(807),
    [anon_sym_GT] = ACTIONS(807),
    [anon_sym_BANG_EQ] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(807),
  },
  [324] = {
    [sym__concat] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(811),
    [anon_sym_EQ_TILDE] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_EQ] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(811),
  },
  [325] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1361),
    [sym_comment] = ACTIONS(53),
  },
  [326] = {
    [sym_subscript] = STATE(717),
    [sym_variable_name] = ACTIONS(1363),
    [anon_sym_DOLLAR] = ACTIONS(1365),
    [anon_sym_DASH] = ACTIONS(1365),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1367),
    [anon_sym_STAR] = ACTIONS(1369),
    [anon_sym_AT] = ACTIONS(1369),
    [anon_sym_QMARK] = ACTIONS(1369),
    [anon_sym_0] = ACTIONS(1367),
    [anon_sym__] = ACTIONS(1367),
  },
  [327] = {
    [sym_concatenation] = STATE(720),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(720),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_EQ] = ACTIONS(1373),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1377),
    [anon_sym_COLON] = ACTIONS(1373),
    [anon_sym_COLON_QMARK] = ACTIONS(1373),
    [anon_sym_COLON_DASH] = ACTIONS(1373),
    [anon_sym_PERCENT] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [328] = {
    [sym_concatenation] = STATE(723),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(723),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_EQ] = ACTIONS(1381),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1381),
    [anon_sym_COLON_QMARK] = ACTIONS(1381),
    [anon_sym_COLON_DASH] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [329] = {
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1389),
    [anon_sym_SEMI_SEMI] = ACTIONS(1391),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1391),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [330] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1389),
    [anon_sym_SEMI_SEMI] = ACTIONS(1391),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1391),
    [anon_sym_AMP] = ACTIONS(1387),
  },
  [331] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(726),
    [sym_c_style_for_statement] = STATE(726),
    [sym_while_statement] = STATE(726),
    [sym_if_statement] = STATE(726),
    [sym_case_statement] = STATE(726),
    [sym_function_definition] = STATE(726),
    [sym_subshell] = STATE(726),
    [sym_pipeline] = STATE(726),
    [sym_list] = STATE(726),
    [sym_negated_command] = STATE(726),
    [sym_test_command] = STATE(726),
    [sym_declaration_command] = STATE(726),
    [sym_unset_command] = STATE(726),
    [sym_command] = STATE(726),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(727),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [332] = {
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1395),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(1389),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1395),
    [anon_sym_AMP] = ACTIONS(1393),
  },
  [333] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1395),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(1389),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1395),
    [anon_sym_AMP] = ACTIONS(1393),
  },
  [334] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(729),
    [sym_c_style_for_statement] = STATE(729),
    [sym_while_statement] = STATE(729),
    [sym_if_statement] = STATE(729),
    [sym_case_statement] = STATE(729),
    [sym_function_definition] = STATE(729),
    [sym_subshell] = STATE(729),
    [sym_pipeline] = STATE(729),
    [sym_list] = STATE(729),
    [sym_negated_command] = STATE(729),
    [sym_test_command] = STATE(729),
    [sym_declaration_command] = STATE(729),
    [sym_unset_command] = STATE(729),
    [sym_command] = STATE(729),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(730),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [335] = {
    [anon_sym_SEMI] = ACTIONS(1397),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1399),
    [anon_sym_SEMI_SEMI] = ACTIONS(1401),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1401),
    [anon_sym_AMP] = ACTIONS(1397),
  },
  [336] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1397),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1399),
    [anon_sym_SEMI_SEMI] = ACTIONS(1401),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1401),
    [anon_sym_AMP] = ACTIONS(1397),
  },
  [337] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(733),
    [sym_c_style_for_statement] = STATE(733),
    [sym_while_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym_case_statement] = STATE(733),
    [sym_function_definition] = STATE(733),
    [sym_subshell] = STATE(733),
    [sym_pipeline] = STATE(733),
    [sym_list] = STATE(733),
    [sym_negated_command] = STATE(733),
    [sym_test_command] = STATE(733),
    [sym_declaration_command] = STATE(733),
    [sym_unset_command] = STATE(733),
    [sym_command] = STATE(733),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(734),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [338] = {
    [sym__expression] = STATE(735),
    [sym_binary_expression] = STATE(735),
    [sym_unary_expression] = STATE(735),
    [sym_parenthesized_expression] = STATE(735),
    [sym_concatenation] = STATE(735),
    [sym_string] = STATE(91),
    [sym_simple_expansion] = STATE(91),
    [sym_string_expansion] = STATE(91),
    [sym_expansion] = STATE(91),
    [sym_command_substitution] = STATE(91),
    [sym_process_substitution] = STATE(91),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [339] = {
    [sym_file_redirect] = STATE(740),
    [sym_heredoc_redirect] = STATE(740),
    [sym_herestring_redirect] = STATE(740),
    [aux_sym_while_statement_repeat1] = STATE(740),
    [sym_file_descriptor] = ACTIONS(1403),
    [ts_builtin_sym_end] = ACTIONS(1405),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_SEMI_SEMI] = ACTIONS(1405),
    [anon_sym_PIPE_AMP] = ACTIONS(1405),
    [anon_sym_AMP_AMP] = ACTIONS(1405),
    [anon_sym_PIPE_PIPE] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT] = ACTIONS(1409),
    [anon_sym_AMP_GT_GT] = ACTIONS(1411),
    [anon_sym_LT_AMP] = ACTIONS(1411),
    [anon_sym_GT_AMP] = ACTIONS(1411),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_LT_LT_DASH] = ACTIONS(1415),
    [anon_sym_LT_LT_LT] = ACTIONS(1417),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1405),
    [anon_sym_AMP] = ACTIONS(1407),
  },
  [340] = {
    [sym__expression] = STATE(735),
    [sym_binary_expression] = STATE(735),
    [sym_unary_expression] = STATE(735),
    [sym_parenthesized_expression] = STATE(735),
    [sym_concatenation] = STATE(735),
    [sym_string] = STATE(91),
    [sym_simple_expansion] = STATE(91),
    [sym_string_expansion] = STATE(91),
    [sym_expansion] = STATE(91),
    [sym_command_substitution] = STATE(91),
    [sym_process_substitution] = STATE(91),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(1421),
    [anon_sym_DQUOTE] = ACTIONS(1423),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1427),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [anon_sym_LT_LPAREN] = ACTIONS(1431),
    [anon_sym_GT_LPAREN] = ACTIONS(1431),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(135),
    [sym_regex] = ACTIONS(1433),
  },
  [341] = {
    [anon_sym_RPAREN] = ACTIONS(1435),
    [anon_sym_AMP_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1347),
    [anon_sym_EQ_TILDE] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1347),
  },
  [342] = {
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1353),
    [anon_sym_EQ_TILDE] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(647),
  },
  [343] = {
    [sym_string] = STATE(743),
    [sym_simple_expansion] = STATE(743),
    [sym_string_expansion] = STATE(743),
    [sym_expansion] = STATE(743),
    [sym_command_substitution] = STATE(743),
    [sym_process_substitution] = STATE(743),
    [sym__special_characters] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1437),
  },
  [344] = {
    [aux_sym_concatenation_repeat1] = STATE(744),
    [sym__concat] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(765),
    [anon_sym_EQ_TILDE] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(765),
  },
  [345] = {
    [sym__concat] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(769),
    [anon_sym_EQ_TILDE] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(769),
  },
  [346] = {
    [anon_sym_DQUOTE] = ACTIONS(1439),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [347] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(1439),
    [anon_sym_DOLLAR] = ACTIONS(1441),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [348] = {
    [sym__concat] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(803),
    [anon_sym_EQ_TILDE] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_EQ] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(803),
  },
  [349] = {
    [sym__concat] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(807),
    [anon_sym_EQ_TILDE] = ACTIONS(807),
    [anon_sym_EQ_EQ] = ACTIONS(807),
    [anon_sym_EQ] = ACTIONS(809),
    [anon_sym_LT] = ACTIONS(807),
    [anon_sym_GT] = ACTIONS(807),
    [anon_sym_BANG_EQ] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(807),
  },
  [350] = {
    [sym__concat] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(811),
    [anon_sym_EQ_TILDE] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_EQ] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(811),
  },
  [351] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1443),
    [sym_comment] = ACTIONS(53),
  },
  [352] = {
    [sym_subscript] = STATE(750),
    [sym_variable_name] = ACTIONS(1445),
    [anon_sym_DOLLAR] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1449),
    [anon_sym_STAR] = ACTIONS(1451),
    [anon_sym_AT] = ACTIONS(1451),
    [anon_sym_QMARK] = ACTIONS(1451),
    [anon_sym_0] = ACTIONS(1449),
    [anon_sym__] = ACTIONS(1449),
  },
  [353] = {
    [sym_concatenation] = STATE(753),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(753),
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_EQ] = ACTIONS(1455),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1459),
    [anon_sym_COLON] = ACTIONS(1455),
    [anon_sym_COLON_QMARK] = ACTIONS(1455),
    [anon_sym_COLON_DASH] = ACTIONS(1455),
    [anon_sym_PERCENT] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [354] = {
    [sym_concatenation] = STATE(756),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(756),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_EQ] = ACTIONS(1463),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1467),
    [anon_sym_COLON] = ACTIONS(1463),
    [anon_sym_COLON_QMARK] = ACTIONS(1463),
    [anon_sym_COLON_DASH] = ACTIONS(1463),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_DASH] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [355] = {
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1471),
    [anon_sym_SEMI_SEMI] = ACTIONS(1473),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1473),
    [anon_sym_AMP] = ACTIONS(1469),
  },
  [356] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1471),
    [anon_sym_SEMI_SEMI] = ACTIONS(1473),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1473),
    [anon_sym_AMP] = ACTIONS(1469),
  },
  [357] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(759),
    [sym_c_style_for_statement] = STATE(759),
    [sym_while_statement] = STATE(759),
    [sym_if_statement] = STATE(759),
    [sym_case_statement] = STATE(759),
    [sym_function_definition] = STATE(759),
    [sym_subshell] = STATE(759),
    [sym_pipeline] = STATE(759),
    [sym_list] = STATE(759),
    [sym_negated_command] = STATE(759),
    [sym_test_command] = STATE(759),
    [sym_declaration_command] = STATE(759),
    [sym_unset_command] = STATE(759),
    [sym_command] = STATE(759),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(760),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [358] = {
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1477),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1475),
  },
  [359] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1477),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1477),
    [anon_sym_AMP] = ACTIONS(1475),
  },
  [360] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(762),
    [sym_c_style_for_statement] = STATE(762),
    [sym_while_statement] = STATE(762),
    [sym_if_statement] = STATE(762),
    [sym_case_statement] = STATE(762),
    [sym_function_definition] = STATE(762),
    [sym_subshell] = STATE(762),
    [sym_pipeline] = STATE(762),
    [sym_list] = STATE(762),
    [sym_negated_command] = STATE(762),
    [sym_test_command] = STATE(762),
    [sym_declaration_command] = STATE(762),
    [sym_unset_command] = STATE(762),
    [sym_command] = STATE(762),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(763),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [361] = {
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1481),
    [anon_sym_SEMI_SEMI] = ACTIONS(1483),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1479),
  },
  [362] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1481),
    [anon_sym_SEMI_SEMI] = ACTIONS(1483),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1479),
  },
  [363] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(766),
    [sym_c_style_for_statement] = STATE(766),
    [sym_while_statement] = STATE(766),
    [sym_if_statement] = STATE(766),
    [sym_case_statement] = STATE(766),
    [sym_function_definition] = STATE(766),
    [sym_subshell] = STATE(766),
    [sym_pipeline] = STATE(766),
    [sym_list] = STATE(766),
    [sym_negated_command] = STATE(766),
    [sym_test_command] = STATE(766),
    [sym_declaration_command] = STATE(766),
    [sym_unset_command] = STATE(766),
    [sym_command] = STATE(766),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(767),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [364] = {
    [sym__expression] = STATE(768),
    [sym_binary_expression] = STATE(768),
    [sym_unary_expression] = STATE(768),
    [sym_parenthesized_expression] = STATE(768),
    [sym_concatenation] = STATE(768),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(177),
    [sym_test_operator] = ACTIONS(179),
  },
  [365] = {
    [sym__expression] = STATE(768),
    [sym_binary_expression] = STATE(768),
    [sym_unary_expression] = STATE(768),
    [sym_parenthesized_expression] = STATE(768),
    [sym_concatenation] = STATE(768),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(1487),
    [anon_sym_DQUOTE] = ACTIONS(1489),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1491),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1493),
    [anon_sym_BQUOTE] = ACTIONS(1495),
    [anon_sym_LT_LPAREN] = ACTIONS(1497),
    [anon_sym_GT_LPAREN] = ACTIONS(1497),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(177),
    [sym_test_operator] = ACTIONS(159),
    [sym_regex] = ACTIONS(1499),
  },
  [366] = {
    [sym_concatenation] = STATE(770),
    [sym_string] = STATE(773),
    [sym_array] = STATE(770),
    [sym_simple_expansion] = STATE(773),
    [sym_string_expansion] = STATE(773),
    [sym_expansion] = STATE(773),
    [sym_command_substitution] = STATE(773),
    [sym_process_substitution] = STATE(773),
    [sym__empty_value] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [sym__special_characters] = ACTIONS(1505),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(1507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1507),
  },
  [367] = {
    [sym_string] = STATE(774),
    [sym_simple_expansion] = STATE(774),
    [sym_string_expansion] = STATE(774),
    [sym_expansion] = STATE(774),
    [sym_command_substitution] = STATE(774),
    [sym_process_substitution] = STATE(774),
    [sym__special_characters] = ACTIONS(1509),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(1509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1509),
  },
  [368] = {
    [aux_sym_concatenation_repeat1] = STATE(775),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(765),
    [ts_builtin_sym_end] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(767),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [369] = {
    [sym__concat] = ACTIONS(769),
    [sym_variable_name] = ACTIONS(769),
    [ts_builtin_sym_end] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [sym__special_characters] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(771),
    [sym_word] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [370] = {
    [anon_sym_DQUOTE] = ACTIONS(1511),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [371] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(1511),
    [anon_sym_DOLLAR] = ACTIONS(1513),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [372] = {
    [sym__concat] = ACTIONS(803),
    [sym_variable_name] = ACTIONS(803),
    [ts_builtin_sym_end] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [anon_sym_PIPE_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [sym__special_characters] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_raw_string] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(805),
    [sym_word] = ACTIONS(805),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(805),
  },
  [373] = {
    [sym__concat] = ACTIONS(807),
    [sym_variable_name] = ACTIONS(807),
    [ts_builtin_sym_end] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [anon_sym_PIPE_AMP] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [sym__special_characters] = ACTIONS(807),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(807),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_LT_LPAREN] = ACTIONS(807),
    [anon_sym_GT_LPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(809),
    [sym_word] = ACTIONS(809),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(809),
  },
  [374] = {
    [sym__concat] = ACTIONS(811),
    [sym_variable_name] = ACTIONS(811),
    [ts_builtin_sym_end] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [sym__special_characters] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_LT_LPAREN] = ACTIONS(811),
    [anon_sym_GT_LPAREN] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(813),
    [sym_word] = ACTIONS(813),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(813),
  },
  [375] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1515),
    [sym_comment] = ACTIONS(53),
  },
  [376] = {
    [sym_subscript] = STATE(781),
    [sym_variable_name] = ACTIONS(1517),
    [anon_sym_DOLLAR] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_AT] = ACTIONS(1523),
    [anon_sym_QMARK] = ACTIONS(1523),
    [anon_sym_0] = ACTIONS(1521),
    [anon_sym__] = ACTIONS(1521),
  },
  [377] = {
    [sym_concatenation] = STATE(784),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(784),
    [anon_sym_RBRACE] = ACTIONS(1525),
    [anon_sym_EQ] = ACTIONS(1527),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1529),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1527),
    [anon_sym_COLON_QMARK] = ACTIONS(1527),
    [anon_sym_COLON_DASH] = ACTIONS(1527),
    [anon_sym_PERCENT] = ACTIONS(1527),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [378] = {
    [sym_concatenation] = STATE(787),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(787),
    [anon_sym_RBRACE] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1535),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1537),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_COLON_QMARK] = ACTIONS(1535),
    [anon_sym_COLON_DASH] = ACTIONS(1535),
    [anon_sym_PERCENT] = ACTIONS(1535),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [379] = {
    [anon_sym_SEMI] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1543),
    [anon_sym_SEMI_SEMI] = ACTIONS(1545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1541),
  },
  [380] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1543),
    [anon_sym_SEMI_SEMI] = ACTIONS(1545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1541),
  },
  [381] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(790),
    [sym_c_style_for_statement] = STATE(790),
    [sym_while_statement] = STATE(790),
    [sym_if_statement] = STATE(790),
    [sym_case_statement] = STATE(790),
    [sym_function_definition] = STATE(790),
    [sym_subshell] = STATE(790),
    [sym_pipeline] = STATE(790),
    [sym_list] = STATE(790),
    [sym_negated_command] = STATE(790),
    [sym_test_command] = STATE(790),
    [sym_declaration_command] = STATE(790),
    [sym_unset_command] = STATE(790),
    [sym_command] = STATE(790),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(791),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [382] = {
    [anon_sym_SEMI] = ACTIONS(1547),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1549),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(1543),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1549),
    [anon_sym_AMP] = ACTIONS(1547),
  },
  [383] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1547),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1549),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(1543),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1549),
    [anon_sym_AMP] = ACTIONS(1547),
  },
  [384] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(793),
    [sym_c_style_for_statement] = STATE(793),
    [sym_while_statement] = STATE(793),
    [sym_if_statement] = STATE(793),
    [sym_case_statement] = STATE(793),
    [sym_function_definition] = STATE(793),
    [sym_subshell] = STATE(793),
    [sym_pipeline] = STATE(793),
    [sym_list] = STATE(793),
    [sym_negated_command] = STATE(793),
    [sym_test_command] = STATE(793),
    [sym_declaration_command] = STATE(793),
    [sym_unset_command] = STATE(793),
    [sym_command] = STATE(793),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(794),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [385] = {
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1553),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1551),
  },
  [386] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1553),
    [anon_sym_SEMI_SEMI] = ACTIONS(1555),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1551),
  },
  [387] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(797),
    [sym_c_style_for_statement] = STATE(797),
    [sym_while_statement] = STATE(797),
    [sym_if_statement] = STATE(797),
    [sym_case_statement] = STATE(797),
    [sym_function_definition] = STATE(797),
    [sym_subshell] = STATE(797),
    [sym_pipeline] = STATE(797),
    [sym_list] = STATE(797),
    [sym_negated_command] = STATE(797),
    [sym_test_command] = STATE(797),
    [sym_declaration_command] = STATE(797),
    [sym_unset_command] = STATE(797),
    [sym_command] = STATE(797),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(798),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [388] = {
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(117),
    [sym_concatenation] = STATE(388),
    [sym_string] = STATE(112),
    [sym_simple_expansion] = STATE(112),
    [sym_string_expansion] = STATE(112),
    [sym_expansion] = STATE(112),
    [sym_command_substitution] = STATE(112),
    [sym_process_substitution] = STATE(112),
    [aux_sym_declaration_command_repeat1] = STATE(388),
    [sym_variable_name] = ACTIONS(1557),
    [ts_builtin_sym_end] = ACTIONS(1560),
    [anon_sym_SEMI] = ACTIONS(1562),
    [anon_sym_PIPE] = ACTIONS(1562),
    [anon_sym_SEMI_SEMI] = ACTIONS(1560),
    [anon_sym_PIPE_AMP] = ACTIONS(1560),
    [anon_sym_AMP_AMP] = ACTIONS(1560),
    [anon_sym_PIPE_PIPE] = ACTIONS(1560),
    [sym__special_characters] = ACTIONS(1564),
    [anon_sym_DQUOTE] = ACTIONS(1567),
    [anon_sym_DOLLAR] = ACTIONS(1570),
    [sym_raw_string] = ACTIONS(1573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [anon_sym_BQUOTE] = ACTIONS(1582),
    [anon_sym_LT_LPAREN] = ACTIONS(1585),
    [anon_sym_GT_LPAREN] = ACTIONS(1585),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1588),
    [sym_word] = ACTIONS(1591),
    [anon_sym_LF] = ACTIONS(1560),
    [anon_sym_AMP] = ACTIONS(1562),
  },
  [389] = {
    [sym_string] = STATE(799),
    [sym_simple_expansion] = STATE(799),
    [sym_string_expansion] = STATE(799),
    [sym_expansion] = STATE(799),
    [sym_command_substitution] = STATE(799),
    [sym_process_substitution] = STATE(799),
    [sym__special_characters] = ACTIONS(1594),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(1594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1594),
  },
  [390] = {
    [aux_sym_concatenation_repeat1] = STATE(800),
    [sym__concat] = ACTIONS(693),
    [ts_builtin_sym_end] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(767),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [391] = {
    [sym__concat] = ACTIONS(769),
    [ts_builtin_sym_end] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [sym__special_characters] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(771),
    [sym_word] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [392] = {
    [anon_sym_DQUOTE] = ACTIONS(1596),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [393] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(1596),
    [anon_sym_DOLLAR] = ACTIONS(1598),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [394] = {
    [sym__concat] = ACTIONS(803),
    [ts_builtin_sym_end] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [anon_sym_PIPE_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [sym__special_characters] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_raw_string] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(805),
    [sym_word] = ACTIONS(805),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(805),
  },
  [395] = {
    [sym__concat] = ACTIONS(807),
    [ts_builtin_sym_end] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [anon_sym_PIPE_AMP] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [sym__special_characters] = ACTIONS(807),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(807),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_LT_LPAREN] = ACTIONS(807),
    [anon_sym_GT_LPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(809),
    [sym_word] = ACTIONS(809),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(809),
  },
  [396] = {
    [sym__concat] = ACTIONS(811),
    [ts_builtin_sym_end] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [sym__special_characters] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_LT_LPAREN] = ACTIONS(811),
    [anon_sym_GT_LPAREN] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(813),
    [sym_word] = ACTIONS(813),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(813),
  },
  [397] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1600),
    [sym_comment] = ACTIONS(53),
  },
  [398] = {
    [sym_subscript] = STATE(806),
    [sym_variable_name] = ACTIONS(1602),
    [anon_sym_DOLLAR] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1604),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1608),
    [anon_sym_AT] = ACTIONS(1608),
    [anon_sym_QMARK] = ACTIONS(1608),
    [anon_sym_0] = ACTIONS(1606),
    [anon_sym__] = ACTIONS(1606),
  },
  [399] = {
    [sym_concatenation] = STATE(809),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(809),
    [anon_sym_RBRACE] = ACTIONS(1610),
    [anon_sym_EQ] = ACTIONS(1612),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1614),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_COLON] = ACTIONS(1612),
    [anon_sym_COLON_QMARK] = ACTIONS(1612),
    [anon_sym_COLON_DASH] = ACTIONS(1612),
    [anon_sym_PERCENT] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [400] = {
    [sym_concatenation] = STATE(812),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(812),
    [anon_sym_RBRACE] = ACTIONS(1618),
    [anon_sym_EQ] = ACTIONS(1620),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1622),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1624),
    [anon_sym_COLON] = ACTIONS(1620),
    [anon_sym_COLON_QMARK] = ACTIONS(1620),
    [anon_sym_COLON_DASH] = ACTIONS(1620),
    [anon_sym_PERCENT] = ACTIONS(1620),
    [anon_sym_DASH] = ACTIONS(1620),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [401] = {
    [anon_sym_SEMI] = ACTIONS(1626),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1628),
    [anon_sym_SEMI_SEMI] = ACTIONS(1630),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1630),
    [anon_sym_AMP] = ACTIONS(1626),
  },
  [402] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1626),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1628),
    [anon_sym_SEMI_SEMI] = ACTIONS(1630),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1630),
    [anon_sym_AMP] = ACTIONS(1626),
  },
  [403] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(815),
    [sym_c_style_for_statement] = STATE(815),
    [sym_while_statement] = STATE(815),
    [sym_if_statement] = STATE(815),
    [sym_case_statement] = STATE(815),
    [sym_function_definition] = STATE(815),
    [sym_subshell] = STATE(815),
    [sym_pipeline] = STATE(815),
    [sym_list] = STATE(815),
    [sym_negated_command] = STATE(815),
    [sym_test_command] = STATE(815),
    [sym_declaration_command] = STATE(815),
    [sym_unset_command] = STATE(815),
    [sym_command] = STATE(815),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(816),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [404] = {
    [anon_sym_SEMI] = ACTIONS(1632),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1634),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(1628),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1634),
    [anon_sym_AMP] = ACTIONS(1632),
  },
  [405] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1632),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1634),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(1628),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1634),
    [anon_sym_AMP] = ACTIONS(1632),
  },
  [406] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(818),
    [sym_c_style_for_statement] = STATE(818),
    [sym_while_statement] = STATE(818),
    [sym_if_statement] = STATE(818),
    [sym_case_statement] = STATE(818),
    [sym_function_definition] = STATE(818),
    [sym_subshell] = STATE(818),
    [sym_pipeline] = STATE(818),
    [sym_list] = STATE(818),
    [sym_negated_command] = STATE(818),
    [sym_test_command] = STATE(818),
    [sym_declaration_command] = STATE(818),
    [sym_unset_command] = STATE(818),
    [sym_command] = STATE(818),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(819),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [407] = {
    [anon_sym_SEMI] = ACTIONS(1636),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1638),
    [anon_sym_SEMI_SEMI] = ACTIONS(1640),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1640),
    [anon_sym_AMP] = ACTIONS(1636),
  },
  [408] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1636),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1638),
    [anon_sym_SEMI_SEMI] = ACTIONS(1640),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1640),
    [anon_sym_AMP] = ACTIONS(1636),
  },
  [409] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(822),
    [sym_c_style_for_statement] = STATE(822),
    [sym_while_statement] = STATE(822),
    [sym_if_statement] = STATE(822),
    [sym_case_statement] = STATE(822),
    [sym_function_definition] = STATE(822),
    [sym_subshell] = STATE(822),
    [sym_pipeline] = STATE(822),
    [sym_list] = STATE(822),
    [sym_negated_command] = STATE(822),
    [sym_test_command] = STATE(822),
    [sym_declaration_command] = STATE(822),
    [sym_unset_command] = STATE(822),
    [sym_command] = STATE(822),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(823),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [410] = {
    [sym_concatenation] = STATE(410),
    [sym_string] = STATE(122),
    [sym_simple_expansion] = STATE(122),
    [sym_string_expansion] = STATE(122),
    [sym_expansion] = STATE(122),
    [sym_command_substitution] = STATE(122),
    [sym_process_substitution] = STATE(122),
    [aux_sym_unset_command_repeat1] = STATE(410),
    [ts_builtin_sym_end] = ACTIONS(1642),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(1649),
    [anon_sym_DOLLAR] = ACTIONS(1652),
    [sym_raw_string] = ACTIONS(1655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1661),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1667),
    [anon_sym_GT_LPAREN] = ACTIONS(1667),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1670),
    [sym_word] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [411] = {
    [sym_string] = STATE(824),
    [sym_simple_expansion] = STATE(824),
    [sym_string_expansion] = STATE(824),
    [sym_expansion] = STATE(824),
    [sym_command_substitution] = STATE(824),
    [sym_process_substitution] = STATE(824),
    [sym__special_characters] = ACTIONS(1676),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_raw_string] = ACTIONS(1676),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(241),
    [anon_sym_BQUOTE] = ACTIONS(243),
    [anon_sym_LT_LPAREN] = ACTIONS(245),
    [anon_sym_GT_LPAREN] = ACTIONS(245),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1676),
  },
  [412] = {
    [aux_sym_concatenation_repeat1] = STATE(825),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(733),
    [sym_variable_name] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(765),
  },
  [413] = {
    [sym_file_descriptor] = ACTIONS(769),
    [sym__concat] = ACTIONS(769),
    [sym_variable_name] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_AMP_GT] = ACTIONS(771),
    [anon_sym_AMP_GT_GT] = ACTIONS(769),
    [anon_sym_LT_AMP] = ACTIONS(769),
    [anon_sym_GT_AMP] = ACTIONS(769),
    [sym__special_characters] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(769),
  },
  [414] = {
    [anon_sym_DQUOTE] = ACTIONS(1678),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [415] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(1678),
    [anon_sym_DOLLAR] = ACTIONS(1680),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [416] = {
    [sym_file_descriptor] = ACTIONS(803),
    [sym__concat] = ACTIONS(803),
    [sym_variable_name] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_AMP_GT] = ACTIONS(805),
    [anon_sym_AMP_GT_GT] = ACTIONS(803),
    [anon_sym_LT_AMP] = ACTIONS(803),
    [anon_sym_GT_AMP] = ACTIONS(803),
    [sym__special_characters] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_raw_string] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(803),
  },
  [417] = {
    [sym_file_descriptor] = ACTIONS(807),
    [sym__concat] = ACTIONS(807),
    [sym_variable_name] = ACTIONS(807),
    [anon_sym_LT] = ACTIONS(809),
    [anon_sym_GT] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(807),
    [anon_sym_AMP_GT] = ACTIONS(809),
    [anon_sym_AMP_GT_GT] = ACTIONS(807),
    [anon_sym_LT_AMP] = ACTIONS(807),
    [anon_sym_GT_AMP] = ACTIONS(807),
    [sym__special_characters] = ACTIONS(807),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(807),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_LT_LPAREN] = ACTIONS(807),
    [anon_sym_GT_LPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(807),
  },
  [418] = {
    [sym_file_descriptor] = ACTIONS(811),
    [sym__concat] = ACTIONS(811),
    [sym_variable_name] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_AMP_GT] = ACTIONS(813),
    [anon_sym_AMP_GT_GT] = ACTIONS(811),
    [anon_sym_LT_AMP] = ACTIONS(811),
    [anon_sym_GT_AMP] = ACTIONS(811),
    [sym__special_characters] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_LT_LPAREN] = ACTIONS(811),
    [anon_sym_GT_LPAREN] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(811),
  },
  [419] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1682),
    [sym_comment] = ACTIONS(53),
  },
  [420] = {
    [sym_subscript] = STATE(831),
    [sym_variable_name] = ACTIONS(1684),
    [anon_sym_DOLLAR] = ACTIONS(1686),
    [anon_sym_DASH] = ACTIONS(1686),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(1690),
    [anon_sym_AT] = ACTIONS(1690),
    [anon_sym_QMARK] = ACTIONS(1690),
    [anon_sym_0] = ACTIONS(1688),
    [anon_sym__] = ACTIONS(1688),
  },
  [421] = {
    [sym_concatenation] = STATE(834),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(834),
    [anon_sym_RBRACE] = ACTIONS(1692),
    [anon_sym_EQ] = ACTIONS(1694),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1698),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_COLON_QMARK] = ACTIONS(1694),
    [anon_sym_COLON_DASH] = ACTIONS(1694),
    [anon_sym_PERCENT] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(1694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [422] = {
    [sym_concatenation] = STATE(837),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(837),
    [anon_sym_RBRACE] = ACTIONS(1700),
    [anon_sym_EQ] = ACTIONS(1702),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1706),
    [anon_sym_COLON] = ACTIONS(1702),
    [anon_sym_COLON_QMARK] = ACTIONS(1702),
    [anon_sym_COLON_DASH] = ACTIONS(1702),
    [anon_sym_PERCENT] = ACTIONS(1702),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [423] = {
    [anon_sym_SEMI] = ACTIONS(1708),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1710),
    [anon_sym_SEMI_SEMI] = ACTIONS(1712),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1712),
    [anon_sym_AMP] = ACTIONS(1708),
  },
  [424] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1708),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1710),
    [anon_sym_SEMI_SEMI] = ACTIONS(1712),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1712),
    [anon_sym_AMP] = ACTIONS(1708),
  },
  [425] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(840),
    [sym_c_style_for_statement] = STATE(840),
    [sym_while_statement] = STATE(840),
    [sym_if_statement] = STATE(840),
    [sym_case_statement] = STATE(840),
    [sym_function_definition] = STATE(840),
    [sym_subshell] = STATE(840),
    [sym_pipeline] = STATE(840),
    [sym_list] = STATE(840),
    [sym_negated_command] = STATE(840),
    [sym_test_command] = STATE(840),
    [sym_declaration_command] = STATE(840),
    [sym_unset_command] = STATE(840),
    [sym_command] = STATE(840),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(841),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [426] = {
    [anon_sym_SEMI] = ACTIONS(1714),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1716),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1716),
    [anon_sym_AMP] = ACTIONS(1714),
  },
  [427] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1714),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1716),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1716),
    [anon_sym_AMP] = ACTIONS(1714),
  },
  [428] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(843),
    [sym_c_style_for_statement] = STATE(843),
    [sym_while_statement] = STATE(843),
    [sym_if_statement] = STATE(843),
    [sym_case_statement] = STATE(843),
    [sym_function_definition] = STATE(843),
    [sym_subshell] = STATE(843),
    [sym_pipeline] = STATE(843),
    [sym_list] = STATE(843),
    [sym_negated_command] = STATE(843),
    [sym_test_command] = STATE(843),
    [sym_declaration_command] = STATE(843),
    [sym_unset_command] = STATE(843),
    [sym_command] = STATE(843),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(844),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [429] = {
    [anon_sym_SEMI] = ACTIONS(1718),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1720),
    [anon_sym_SEMI_SEMI] = ACTIONS(1722),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1722),
    [anon_sym_AMP] = ACTIONS(1718),
  },
  [430] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1718),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1720),
    [anon_sym_SEMI_SEMI] = ACTIONS(1722),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1722),
    [anon_sym_AMP] = ACTIONS(1718),
  },
  [431] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(847),
    [sym_c_style_for_statement] = STATE(847),
    [sym_while_statement] = STATE(847),
    [sym_if_statement] = STATE(847),
    [sym_case_statement] = STATE(847),
    [sym_function_definition] = STATE(847),
    [sym_subshell] = STATE(847),
    [sym_pipeline] = STATE(847),
    [sym_list] = STATE(847),
    [sym_negated_command] = STATE(847),
    [sym_test_command] = STATE(847),
    [sym_declaration_command] = STATE(847),
    [sym_unset_command] = STATE(847),
    [sym_command] = STATE(847),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(848),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [432] = {
    [sym__simple_heredoc_body] = ACTIONS(1724),
    [sym__heredoc_body_beginning] = ACTIONS(1724),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1724),
    [ts_builtin_sym_end] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [433] = {
    [aux_sym_concatenation_repeat1] = STATE(433),
    [sym__simple_heredoc_body] = ACTIONS(1724),
    [sym__heredoc_body_beginning] = ACTIONS(1724),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1728),
    [ts_builtin_sym_end] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [434] = {
    [sym__simple_heredoc_body] = ACTIONS(1731),
    [sym__heredoc_body_beginning] = ACTIONS(1731),
    [sym_file_descriptor] = ACTIONS(1731),
    [sym__concat] = ACTIONS(1731),
    [ts_builtin_sym_end] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_RPAREN] = ACTIONS(1731),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [anon_sym_PIPE_AMP] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [anon_sym_EQ_TILDE] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1731),
    [anon_sym_AMP_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT_GT] = ACTIONS(1731),
    [anon_sym_LT_AMP] = ACTIONS(1731),
    [anon_sym_GT_AMP] = ACTIONS(1731),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_LT_LT_DASH] = ACTIONS(1731),
    [anon_sym_LT_LT_LT] = ACTIONS(1731),
    [sym__special_characters] = ACTIONS(1731),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1731),
    [anon_sym_GT_LPAREN] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1733),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [435] = {
    [sym__concat] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(805),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym__string_content] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(805),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(805),
    [anon_sym_BQUOTE] = ACTIONS(805),
    [sym_comment] = ACTIONS(265),
  },
  [436] = {
    [sym__concat] = ACTIONS(1735),
    [anon_sym_DQUOTE] = ACTIONS(1737),
    [anon_sym_DOLLAR] = ACTIONS(1737),
    [sym__string_content] = ACTIONS(1739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1737),
    [anon_sym_BQUOTE] = ACTIONS(1737),
    [sym_comment] = ACTIONS(265),
  },
  [437] = {
    [sym__concat] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(813),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym__string_content] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_comment] = ACTIONS(265),
  },
  [438] = {
    [anon_sym_DQUOTE] = ACTIONS(1737),
    [anon_sym_DOLLAR] = ACTIONS(1737),
    [sym__string_content] = ACTIONS(1739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1737),
    [anon_sym_BQUOTE] = ACTIONS(1737),
    [sym_comment] = ACTIONS(265),
  },
  [439] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1741),
    [sym_comment] = ACTIONS(53),
  },
  [440] = {
    [sym_subscript] = STATE(853),
    [sym_variable_name] = ACTIONS(1743),
    [anon_sym_DOLLAR] = ACTIONS(1745),
    [anon_sym_DASH] = ACTIONS(1745),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1749),
    [anon_sym_AT] = ACTIONS(1749),
    [anon_sym_QMARK] = ACTIONS(1749),
    [anon_sym_0] = ACTIONS(1747),
    [anon_sym__] = ACTIONS(1747),
  },
  [441] = {
    [sym_concatenation] = STATE(856),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(856),
    [anon_sym_RBRACE] = ACTIONS(1751),
    [anon_sym_EQ] = ACTIONS(1753),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1757),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_COLON_QMARK] = ACTIONS(1753),
    [anon_sym_COLON_DASH] = ACTIONS(1753),
    [anon_sym_PERCENT] = ACTIONS(1753),
    [anon_sym_DASH] = ACTIONS(1753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [442] = {
    [sym_concatenation] = STATE(859),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(859),
    [anon_sym_RBRACE] = ACTIONS(1759),
    [anon_sym_EQ] = ACTIONS(1761),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1763),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1765),
    [anon_sym_COLON] = ACTIONS(1761),
    [anon_sym_COLON_QMARK] = ACTIONS(1761),
    [anon_sym_COLON_DASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [443] = {
    [anon_sym_SEMI] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_SEMI_SEMI] = ACTIONS(1771),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1771),
    [anon_sym_AMP] = ACTIONS(1767),
  },
  [444] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_SEMI_SEMI] = ACTIONS(1771),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1771),
    [anon_sym_AMP] = ACTIONS(1767),
  },
  [445] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(862),
    [sym_c_style_for_statement] = STATE(862),
    [sym_while_statement] = STATE(862),
    [sym_if_statement] = STATE(862),
    [sym_case_statement] = STATE(862),
    [sym_function_definition] = STATE(862),
    [sym_subshell] = STATE(862),
    [sym_pipeline] = STATE(862),
    [sym_list] = STATE(862),
    [sym_negated_command] = STATE(862),
    [sym_test_command] = STATE(862),
    [sym_declaration_command] = STATE(862),
    [sym_unset_command] = STATE(862),
    [sym_command] = STATE(862),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(863),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [446] = {
    [anon_sym_SEMI] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1775),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(1769),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(1773),
  },
  [447] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1775),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(1769),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(1773),
  },
  [448] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(865),
    [sym_c_style_for_statement] = STATE(865),
    [sym_while_statement] = STATE(865),
    [sym_if_statement] = STATE(865),
    [sym_case_statement] = STATE(865),
    [sym_function_definition] = STATE(865),
    [sym_subshell] = STATE(865),
    [sym_pipeline] = STATE(865),
    [sym_list] = STATE(865),
    [sym_negated_command] = STATE(865),
    [sym_test_command] = STATE(865),
    [sym_declaration_command] = STATE(865),
    [sym_unset_command] = STATE(865),
    [sym_command] = STATE(865),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(866),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [449] = {
    [anon_sym_DQUOTE] = ACTIONS(1777),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [450] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(1737),
    [anon_sym_DOLLAR] = ACTIONS(1779),
    [sym__string_content] = ACTIONS(1782),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1785),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1788),
    [anon_sym_BQUOTE] = ACTIONS(1791),
    [sym_comment] = ACTIONS(265),
  },
  [451] = {
    [sym_concatenation] = STATE(871),
    [sym_string] = STATE(870),
    [sym_simple_expansion] = STATE(870),
    [sym_string_expansion] = STATE(870),
    [sym_expansion] = STATE(870),
    [sym_command_substitution] = STATE(870),
    [sym_process_substitution] = STATE(870),
    [sym__special_characters] = ACTIONS(1794),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(1796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1796),
  },
  [452] = {
    [sym_concatenation] = STATE(881),
    [sym_string] = STATE(876),
    [sym_simple_expansion] = STATE(876),
    [sym_string_expansion] = STATE(876),
    [sym_expansion] = STATE(876),
    [sym_command_substitution] = STATE(876),
    [sym_process_substitution] = STATE(876),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [sym__special_characters] = ACTIONS(1800),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(1806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1806),
  },
  [453] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1816),
    [sym_comment] = ACTIONS(53),
  },
  [454] = {
    [sym_concatenation] = STATE(885),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(885),
    [anon_sym_RBRACE] = ACTIONS(1818),
    [anon_sym_EQ] = ACTIONS(1820),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1824),
    [anon_sym_COLON] = ACTIONS(1820),
    [anon_sym_COLON_QMARK] = ACTIONS(1820),
    [anon_sym_COLON_DASH] = ACTIONS(1820),
    [anon_sym_PERCENT] = ACTIONS(1820),
    [anon_sym_DASH] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [455] = {
    [sym_concatenation] = STATE(887),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(887),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1826),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1828),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(1830),
    [anon_sym_COLON] = ACTIONS(1826),
    [anon_sym_COLON_QMARK] = ACTIONS(1826),
    [anon_sym_COLON_DASH] = ACTIONS(1826),
    [anon_sym_PERCENT] = ACTIONS(1826),
    [anon_sym_DASH] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [456] = {
    [sym__simple_heredoc_body] = ACTIONS(1832),
    [sym__heredoc_body_beginning] = ACTIONS(1832),
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [ts_builtin_sym_end] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_EQ_TILDE] = ACTIONS(1834),
    [anon_sym_EQ_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [anon_sym_LT_LT] = ACTIONS(1834),
    [anon_sym_LT_LT_DASH] = ACTIONS(1832),
    [anon_sym_LT_LT_LT] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [457] = {
    [aux_sym_concatenation_repeat1] = STATE(889),
    [sym__concat] = ACTIONS(1836),
    [anon_sym_RBRACE] = ACTIONS(1838),
    [anon_sym_EQ] = ACTIONS(1840),
    [sym__special_characters] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1838),
    [anon_sym_DOLLAR] = ACTIONS(1840),
    [sym_raw_string] = ACTIONS(1838),
    [anon_sym_POUND] = ACTIONS(1838),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1838),
    [anon_sym_COLON] = ACTIONS(1840),
    [anon_sym_COLON_QMARK] = ACTIONS(1840),
    [anon_sym_COLON_DASH] = ACTIONS(1840),
    [anon_sym_PERCENT] = ACTIONS(1840),
    [anon_sym_DASH] = ACTIONS(1840),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1838),
    [anon_sym_BQUOTE] = ACTIONS(1838),
    [anon_sym_LT_LPAREN] = ACTIONS(1838),
    [anon_sym_GT_LPAREN] = ACTIONS(1838),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1840),
  },
  [458] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(892),
    [anon_sym_DQUOTE] = ACTIONS(1842),
    [anon_sym_DOLLAR] = ACTIONS(1844),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [459] = {
    [sym_string] = STATE(894),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(1846),
    [sym_raw_string] = ACTIONS(1848),
    [anon_sym_POUND] = ACTIONS(1846),
    [anon_sym_DASH] = ACTIONS(1846),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(1852),
    [anon_sym_AT] = ACTIONS(1852),
    [anon_sym_QMARK] = ACTIONS(1852),
    [anon_sym_0] = ACTIONS(1850),
    [anon_sym__] = ACTIONS(1850),
  },
  [460] = {
    [aux_sym_concatenation_repeat1] = STATE(889),
    [sym__concat] = ACTIONS(1836),
    [anon_sym_RBRACE] = ACTIONS(1854),
    [anon_sym_EQ] = ACTIONS(1856),
    [sym__special_characters] = ACTIONS(1856),
    [anon_sym_DQUOTE] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1856),
    [sym_raw_string] = ACTIONS(1854),
    [anon_sym_POUND] = ACTIONS(1854),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1854),
    [anon_sym_COLON] = ACTIONS(1856),
    [anon_sym_COLON_QMARK] = ACTIONS(1856),
    [anon_sym_COLON_DASH] = ACTIONS(1856),
    [anon_sym_PERCENT] = ACTIONS(1856),
    [anon_sym_DASH] = ACTIONS(1856),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1854),
    [anon_sym_BQUOTE] = ACTIONS(1854),
    [anon_sym_LT_LPAREN] = ACTIONS(1854),
    [anon_sym_GT_LPAREN] = ACTIONS(1854),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1856),
  },
  [461] = {
    [sym_subscript] = STATE(899),
    [sym_variable_name] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_DOLLAR] = ACTIONS(1862),
    [anon_sym_POUND] = ACTIONS(1860),
    [anon_sym_DASH] = ACTIONS(1862),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1864),
    [anon_sym_STAR] = ACTIONS(1866),
    [anon_sym_AT] = ACTIONS(1866),
    [anon_sym_QMARK] = ACTIONS(1866),
    [anon_sym_0] = ACTIONS(1864),
    [anon_sym__] = ACTIONS(1864),
  },
  [462] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(1868),
  },
  [463] = {
    [sym__terminated_statement] = STATE(903),
    [sym_for_statement] = STATE(901),
    [sym_c_style_for_statement] = STATE(901),
    [sym_while_statement] = STATE(901),
    [sym_if_statement] = STATE(901),
    [sym_case_statement] = STATE(901),
    [sym_function_definition] = STATE(901),
    [sym_subshell] = STATE(901),
    [sym_pipeline] = STATE(901),
    [sym_list] = STATE(901),
    [sym_negated_command] = STATE(901),
    [sym_test_command] = STATE(901),
    [sym_declaration_command] = STATE(901),
    [sym_unset_command] = STATE(901),
    [sym_command] = STATE(901),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(902),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(903),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [464] = {
    [sym__terminated_statement] = STATE(906),
    [sym_for_statement] = STATE(904),
    [sym_c_style_for_statement] = STATE(904),
    [sym_while_statement] = STATE(904),
    [sym_if_statement] = STATE(904),
    [sym_case_statement] = STATE(904),
    [sym_function_definition] = STATE(904),
    [sym_subshell] = STATE(904),
    [sym_pipeline] = STATE(904),
    [sym_list] = STATE(904),
    [sym_negated_command] = STATE(904),
    [sym_test_command] = STATE(904),
    [sym_declaration_command] = STATE(904),
    [sym_unset_command] = STATE(904),
    [sym_command] = STATE(904),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(905),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(906),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [465] = {
    [sym__terminated_statement] = STATE(909),
    [sym_for_statement] = STATE(907),
    [sym_c_style_for_statement] = STATE(907),
    [sym_while_statement] = STATE(907),
    [sym_if_statement] = STATE(907),
    [sym_case_statement] = STATE(907),
    [sym_function_definition] = STATE(907),
    [sym_subshell] = STATE(907),
    [sym_pipeline] = STATE(907),
    [sym_list] = STATE(907),
    [sym_negated_command] = STATE(907),
    [sym_test_command] = STATE(907),
    [sym_declaration_command] = STATE(907),
    [sym_unset_command] = STATE(907),
    [sym_command] = STATE(907),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(908),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(909),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [466] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(1870),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [467] = {
    [sym__simple_heredoc_body] = ACTIONS(1876),
    [sym__heredoc_body_beginning] = ACTIONS(1876),
    [sym_file_descriptor] = ACTIONS(1876),
    [sym__concat] = ACTIONS(1876),
    [ts_builtin_sym_end] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_RPAREN] = ACTIONS(1876),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [anon_sym_PIPE_AMP] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [anon_sym_EQ_TILDE] = ACTIONS(1878),
    [anon_sym_EQ_EQ] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_GT_GT] = ACTIONS(1876),
    [anon_sym_AMP_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT_GT] = ACTIONS(1876),
    [anon_sym_LT_AMP] = ACTIONS(1876),
    [anon_sym_GT_AMP] = ACTIONS(1876),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [anon_sym_LT_LT_DASH] = ACTIONS(1876),
    [anon_sym_LT_LT_LT] = ACTIONS(1876),
    [sym__special_characters] = ACTIONS(1876),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [anon_sym_LT_LPAREN] = ACTIONS(1876),
    [anon_sym_GT_LPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [468] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(1880),
  },
  [469] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [470] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [471] = {
    [sym__simple_heredoc_body] = ACTIONS(1884),
    [sym__heredoc_body_beginning] = ACTIONS(1884),
    [sym_file_descriptor] = ACTIONS(1884),
    [sym__concat] = ACTIONS(1884),
    [ts_builtin_sym_end] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [anon_sym_EQ_TILDE] = ACTIONS(1886),
    [anon_sym_EQ_EQ] = ACTIONS(1886),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_GT] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT] = ACTIONS(1886),
    [anon_sym_AMP_GT_GT] = ACTIONS(1884),
    [anon_sym_LT_AMP] = ACTIONS(1884),
    [anon_sym_GT_AMP] = ACTIONS(1884),
    [anon_sym_LT_LT] = ACTIONS(1886),
    [anon_sym_LT_LT_DASH] = ACTIONS(1884),
    [anon_sym_LT_LT_LT] = ACTIONS(1884),
    [sym__special_characters] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym_raw_string] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(1884),
    [anon_sym_GT_LPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [472] = {
    [anon_sym_SEMI] = ACTIONS(1888),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1888),
  },
  [473] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1888),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1888),
  },
  [474] = {
    [sym_do_group] = STATE(915),
    [anon_sym_do] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [475] = {
    [sym_compound_statement] = STATE(917),
    [anon_sym_LPAREN] = ACTIONS(1892),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [476] = {
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(1894),
    [anon_sym_EQ_TILDE] = ACTIONS(619),
    [anon_sym_EQ_EQ] = ACTIONS(619),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_BANG_EQ] = ACTIONS(615),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(615),
  },
  [477] = {
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1894),
    [anon_sym_EQ_TILDE] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(647),
  },
  [478] = {
    [sym_variable_assignment] = STATE(608),
    [sym_subscript] = STATE(231),
    [sym_concatenation] = STATE(608),
    [sym_string] = STATE(230),
    [sym_simple_expansion] = STATE(230),
    [sym_string_expansion] = STATE(230),
    [sym_expansion] = STATE(230),
    [sym_command_substitution] = STATE(230),
    [sym_process_substitution] = STATE(230),
    [aux_sym_declaration_command_repeat1] = STATE(608),
    [sym_variable_name] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_SEMI_SEMI] = ACTIONS(687),
    [anon_sym_PIPE_AMP] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [sym__special_characters] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(425),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1187),
    [sym_word] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
  },
  [479] = {
    [sym_concatenation] = STATE(610),
    [sym_string] = STATE(234),
    [sym_simple_expansion] = STATE(234),
    [sym_string_expansion] = STATE(234),
    [sym_expansion] = STATE(234),
    [sym_command_substitution] = STATE(234),
    [sym_process_substitution] = STATE(234),
    [aux_sym_unset_command_repeat1] = STATE(610),
    [anon_sym_SEMI] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_SEMI_SEMI] = ACTIONS(725),
    [anon_sym_PIPE_AMP] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [sym__special_characters] = ACTIONS(431),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1189),
    [sym_word] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(727),
  },
  [480] = {
    [anon_sym_RPAREN] = ACTIONS(1896),
    [sym_comment] = ACTIONS(53),
  },
  [481] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [482] = {
    [sym_for_statement] = STATE(497),
    [sym_c_style_for_statement] = STATE(497),
    [sym_while_statement] = STATE(497),
    [sym_if_statement] = STATE(497),
    [sym_case_statement] = STATE(497),
    [sym_function_definition] = STATE(497),
    [sym_subshell] = STATE(497),
    [sym_pipeline] = STATE(497),
    [sym_list] = STATE(497),
    [sym_negated_command] = STATE(497),
    [sym_test_command] = STATE(497),
    [sym_declaration_command] = STATE(497),
    [sym_unset_command] = STATE(497),
    [sym_command] = STATE(497),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(920),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [483] = {
    [sym_for_statement] = STATE(921),
    [sym_c_style_for_statement] = STATE(921),
    [sym_while_statement] = STATE(921),
    [sym_if_statement] = STATE(921),
    [sym_case_statement] = STATE(921),
    [sym_function_definition] = STATE(921),
    [sym_subshell] = STATE(921),
    [sym_pipeline] = STATE(921),
    [sym_list] = STATE(921),
    [sym_negated_command] = STATE(921),
    [sym_test_command] = STATE(921),
    [sym_declaration_command] = STATE(921),
    [sym_unset_command] = STATE(921),
    [sym_command] = STATE(921),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(922),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [484] = {
    [anon_sym_LT] = ACTIONS(1898),
    [anon_sym_GT] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1900),
    [anon_sym_AMP_GT] = ACTIONS(1898),
    [anon_sym_AMP_GT_GT] = ACTIONS(1900),
    [anon_sym_LT_AMP] = ACTIONS(1900),
    [anon_sym_GT_AMP] = ACTIONS(1900),
    [sym_comment] = ACTIONS(53),
  },
  [485] = {
    [sym_concatenation] = STATE(511),
    [sym_string] = STATE(925),
    [sym_simple_expansion] = STATE(925),
    [sym_string_expansion] = STATE(925),
    [sym_expansion] = STATE(925),
    [sym_command_substitution] = STATE(925),
    [sym_process_substitution] = STATE(925),
    [sym__special_characters] = ACTIONS(1902),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1904),
  },
  [486] = {
    [sym_concatenation] = STATE(515),
    [sym_string] = STATE(927),
    [sym_simple_expansion] = STATE(927),
    [sym_string_expansion] = STATE(927),
    [sym_expansion] = STATE(927),
    [sym_command_substitution] = STATE(927),
    [sym_process_substitution] = STATE(927),
    [sym__special_characters] = ACTIONS(1906),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1908),
  },
  [487] = {
    [sym_file_redirect] = STATE(928),
    [sym_heredoc_redirect] = STATE(928),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(928),
    [aux_sym_while_statement_repeat1] = STATE(928),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_AMP_GT] = ACTIONS(887),
    [anon_sym_AMP_GT_GT] = ACTIONS(889),
    [anon_sym_LT_AMP] = ACTIONS(889),
    [anon_sym_GT_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(891),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [488] = {
    [sym_file_redirect] = STATE(929),
    [sym_heredoc_redirect] = STATE(929),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(929),
    [sym_concatenation] = STATE(628),
    [sym_string] = STATE(248),
    [sym_simple_expansion] = STATE(248),
    [sym_string_expansion] = STATE(248),
    [sym_expansion] = STATE(248),
    [sym_command_substitution] = STATE(248),
    [sym_process_substitution] = STATE(248),
    [aux_sym_while_statement_repeat1] = STATE(929),
    [aux_sym_command_repeat2] = STATE(628),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(455),
    [anon_sym_EQ_EQ] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_AMP_GT] = ACTIONS(887),
    [anon_sym_AMP_GT_GT] = ACTIONS(889),
    [anon_sym_LT_AMP] = ACTIONS(889),
    [anon_sym_GT_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(891),
    [sym__special_characters] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(467),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [489] = {
    [anon_sym_SEMI] = ACTIONS(1910),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1912),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(1910),
  },
  [490] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1910),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1912),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(1910),
  },
  [491] = {
    [sym_file_redirect] = STATE(929),
    [sym_heredoc_redirect] = STATE(929),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(929),
    [sym_concatenation] = STATE(931),
    [sym_string] = STATE(248),
    [sym_simple_expansion] = STATE(248),
    [sym_string_expansion] = STATE(248),
    [sym_expansion] = STATE(248),
    [sym_command_substitution] = STATE(248),
    [sym_process_substitution] = STATE(248),
    [aux_sym_while_statement_repeat1] = STATE(929),
    [aux_sym_command_repeat2] = STATE(931),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(455),
    [anon_sym_EQ_EQ] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_AMP_GT] = ACTIONS(887),
    [anon_sym_AMP_GT_GT] = ACTIONS(889),
    [anon_sym_LT_AMP] = ACTIONS(889),
    [anon_sym_GT_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(891),
    [sym__special_characters] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(467),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [492] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(1914),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [493] = {
    [sym__simple_heredoc_body] = ACTIONS(1916),
    [sym__heredoc_body_beginning] = ACTIONS(1916),
    [sym_file_descriptor] = ACTIONS(1916),
    [sym__concat] = ACTIONS(1916),
    [ts_builtin_sym_end] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_RPAREN] = ACTIONS(1916),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [anon_sym_EQ_TILDE] = ACTIONS(1918),
    [anon_sym_EQ_EQ] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1916),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT_GT] = ACTIONS(1916),
    [anon_sym_LT_AMP] = ACTIONS(1916),
    [anon_sym_GT_AMP] = ACTIONS(1916),
    [anon_sym_LT_LT] = ACTIONS(1918),
    [anon_sym_LT_LT_DASH] = ACTIONS(1916),
    [anon_sym_LT_LT_LT] = ACTIONS(1916),
    [sym__special_characters] = ACTIONS(1916),
    [anon_sym_DQUOTE] = ACTIONS(1916),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1916),
    [anon_sym_GT_LPAREN] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [494] = {
    [anon_sym_SEMI] = ACTIONS(1920),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1922),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1920),
  },
  [495] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1920),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1922),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1920),
  },
  [496] = {
    [sym_compound_statement] = STATE(934),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_esac] = ACTIONS(1924),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_RPAREN] = ACTIONS(1924),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [498] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [ts_builtin_sym_end] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_RPAREN] = ACTIONS(1924),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(1928),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(313),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(317),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [500] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [ts_builtin_sym_end] = ACTIONS(1928),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(313),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(317),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(1932),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym_esac] = ACTIONS(1932),
    [anon_sym_PIPE] = ACTIONS(1934),
    [anon_sym_RPAREN] = ACTIONS(1932),
    [anon_sym_SEMI_SEMI] = ACTIONS(1932),
    [anon_sym_PIPE_AMP] = ACTIONS(1932),
    [anon_sym_AMP_AMP] = ACTIONS(1932),
    [anon_sym_PIPE_PIPE] = ACTIONS(1932),
    [anon_sym_BQUOTE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1932),
    [anon_sym_AMP] = ACTIONS(1934),
  },
  [502] = {
    [anon_sym_DOLLAR] = ACTIONS(1936),
    [anon_sym_POUND] = ACTIONS(1936),
    [anon_sym_DASH] = ACTIONS(1936),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1940),
    [anon_sym_AT] = ACTIONS(1940),
    [anon_sym_QMARK] = ACTIONS(1940),
    [anon_sym_0] = ACTIONS(1938),
    [anon_sym__] = ACTIONS(1938),
  },
  [503] = {
    [sym_subscript] = STATE(940),
    [sym_variable_name] = ACTIONS(1942),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_POUND] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1946),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(1950),
    [anon_sym_AT] = ACTIONS(1950),
    [anon_sym_QMARK] = ACTIONS(1950),
    [anon_sym_0] = ACTIONS(1948),
    [anon_sym__] = ACTIONS(1948),
  },
  [504] = {
    [sym_simple_expansion] = STATE(942),
    [sym_expansion] = STATE(942),
    [aux_sym_heredoc_body_repeat1] = STATE(942),
    [sym__heredoc_body_middle] = ACTIONS(1952),
    [sym__heredoc_body_end] = ACTIONS(1954),
    [anon_sym_DOLLAR] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(917),
    [sym_comment] = ACTIONS(53),
  },
  [505] = {
    [sym_concatenation] = STATE(945),
    [sym_string] = STATE(944),
    [sym_simple_expansion] = STATE(944),
    [sym_string_expansion] = STATE(944),
    [sym_expansion] = STATE(944),
    [sym_command_substitution] = STATE(944),
    [sym_process_substitution] = STATE(944),
    [sym__special_characters] = ACTIONS(1956),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1958),
  },
  [506] = {
    [aux_sym_concatenation_repeat1] = STATE(138),
    [sym__simple_heredoc_body] = ACTIONS(1960),
    [sym__heredoc_body_beginning] = ACTIONS(1960),
    [sym_file_descriptor] = ACTIONS(1960),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(1960),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1962),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [anon_sym_EQ_TILDE] = ACTIONS(1962),
    [anon_sym_EQ_EQ] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1962),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1962),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [sym__special_characters] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1962),
    [sym_raw_string] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1962),
    [anon_sym_LF] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1962),
  },
  [507] = {
    [aux_sym_concatenation_repeat1] = STATE(138),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_EQ_TILDE] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1966),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1966),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [508] = {
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [ts_builtin_sym_end] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_RPAREN] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_EQ_TILDE] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1966),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1966),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [509] = {
    [aux_sym_concatenation_repeat1] = STATE(946),
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(731),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [510] = {
    [aux_sym_concatenation_repeat1] = STATE(946),
    [sym__simple_heredoc_body] = ACTIONS(749),
    [sym__heredoc_body_beginning] = ACTIONS(749),
    [sym_file_descriptor] = ACTIONS(749),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_LT_LT_DASH] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [511] = {
    [sym__simple_heredoc_body] = ACTIONS(749),
    [sym__heredoc_body_beginning] = ACTIONS(749),
    [sym_file_descriptor] = ACTIONS(749),
    [ts_builtin_sym_end] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_esac] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_LT_LT_DASH] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(749),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [512] = {
    [sym__simple_heredoc_body] = ACTIONS(1968),
    [sym__heredoc_body_beginning] = ACTIONS(1968),
    [sym_file_descriptor] = ACTIONS(1968),
    [ts_builtin_sym_end] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_esac] = ACTIONS(1968),
    [anon_sym_PIPE] = ACTIONS(1970),
    [anon_sym_RPAREN] = ACTIONS(1968),
    [anon_sym_SEMI_SEMI] = ACTIONS(1968),
    [anon_sym_PIPE_AMP] = ACTIONS(1968),
    [anon_sym_AMP_AMP] = ACTIONS(1968),
    [anon_sym_PIPE_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(1970),
    [anon_sym_GT_GT] = ACTIONS(1968),
    [anon_sym_AMP_GT] = ACTIONS(1970),
    [anon_sym_AMP_GT_GT] = ACTIONS(1968),
    [anon_sym_LT_AMP] = ACTIONS(1968),
    [anon_sym_GT_AMP] = ACTIONS(1968),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1968),
    [anon_sym_LT_LT_LT] = ACTIONS(1968),
    [anon_sym_BQUOTE] = ACTIONS(1968),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1970),
  },
  [513] = {
    [aux_sym_concatenation_repeat1] = STATE(946),
    [sym__simple_heredoc_body] = ACTIONS(1972),
    [sym__heredoc_body_beginning] = ACTIONS(1972),
    [sym_file_descriptor] = ACTIONS(1972),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_PIPE_AMP] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_PIPE_PIPE] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_AMP_GT] = ACTIONS(1974),
    [anon_sym_AMP_GT_GT] = ACTIONS(1972),
    [anon_sym_LT_AMP] = ACTIONS(1972),
    [anon_sym_GT_AMP] = ACTIONS(1972),
    [anon_sym_LT_LT] = ACTIONS(1974),
    [anon_sym_LT_LT_DASH] = ACTIONS(1972),
    [anon_sym_LT_LT_LT] = ACTIONS(1972),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1974),
  },
  [514] = {
    [aux_sym_concatenation_repeat1] = STATE(946),
    [sym__simple_heredoc_body] = ACTIONS(1976),
    [sym__heredoc_body_beginning] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [515] = {
    [sym__simple_heredoc_body] = ACTIONS(1976),
    [sym__heredoc_body_beginning] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(1976),
    [ts_builtin_sym_end] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_esac] = ACTIONS(1976),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_RPAREN] = ACTIONS(1976),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [anon_sym_BQUOTE] = ACTIONS(1976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [516] = {
    [ts_builtin_sym_end] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_esac] = ACTIONS(1980),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_BQUOTE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [517] = {
    [sym_file_redirect] = STATE(517),
    [sym_heredoc_redirect] = STATE(517),
    [sym_herestring_redirect] = STATE(517),
    [aux_sym_while_statement_repeat1] = STATE(517),
    [sym__simple_heredoc_body] = ACTIONS(1984),
    [sym__heredoc_body_beginning] = ACTIONS(1984),
    [sym_file_descriptor] = ACTIONS(1986),
    [ts_builtin_sym_end] = ACTIONS(1984),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1994),
    [anon_sym_AMP_GT] = ACTIONS(1991),
    [anon_sym_AMP_GT_GT] = ACTIONS(1994),
    [anon_sym_LT_AMP] = ACTIONS(1994),
    [anon_sym_GT_AMP] = ACTIONS(1994),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_LT_LT_DASH] = ACTIONS(2000),
    [anon_sym_LT_LT_LT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1989),
  },
  [518] = {
    [sym_file_redirect] = STATE(517),
    [sym_heredoc_redirect] = STATE(517),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(517),
    [aux_sym_while_statement_repeat1] = STATE(517),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(341),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [519] = {
    [sym_concatenation] = STATE(519),
    [sym_string] = STATE(184),
    [sym_simple_expansion] = STATE(184),
    [sym_string_expansion] = STATE(184),
    [sym_expansion] = STATE(184),
    [sym_command_substitution] = STATE(184),
    [sym_process_substitution] = STATE(184),
    [aux_sym_command_repeat2] = STATE(519),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [ts_builtin_sym_end] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_EQ_TILDE] = ACTIONS(2006),
    [anon_sym_EQ_EQ] = ACTIONS(2006),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(2009),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [anon_sym_DOLLAR] = ACTIONS(2015),
    [sym_raw_string] = ACTIONS(2018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2024),
    [anon_sym_BQUOTE] = ACTIONS(2027),
    [anon_sym_LT_LPAREN] = ACTIONS(2030),
    [anon_sym_GT_LPAREN] = ACTIONS(2030),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2033),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [520] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [ts_builtin_sym_end] = ACTIONS(2036),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [521] = {
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(2040),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [522] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(2040),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [523] = {
    [sym_file_redirect] = STATE(949),
    [sym_heredoc_redirect] = STATE(949),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(949),
    [sym_concatenation] = STATE(519),
    [sym_string] = STATE(184),
    [sym_simple_expansion] = STATE(184),
    [sym_string_expansion] = STATE(184),
    [sym_expansion] = STATE(184),
    [sym_command_substitution] = STATE(184),
    [sym_process_substitution] = STATE(184),
    [aux_sym_while_statement_repeat1] = STATE(949),
    [aux_sym_command_repeat2] = STATE(519),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_EQ_TILDE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(341),
    [sym__special_characters] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(347),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [524] = {
    [sym_string] = STATE(710),
    [sym_simple_expansion] = STATE(710),
    [sym_string_expansion] = STATE(710),
    [sym_expansion] = STATE(710),
    [sym_command_substitution] = STATE(710),
    [sym_process_substitution] = STATE(710),
    [anon_sym_RBRACK] = ACTIONS(2042),
    [sym__special_characters] = ACTIONS(2044),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(1355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1355),
  },
  [525] = {
    [sym__concat] = ACTIONS(2046),
    [anon_sym_EQ] = ACTIONS(2048),
    [anon_sym_PLUS_EQ] = ACTIONS(2048),
    [sym_comment] = ACTIONS(53),
  },
  [526] = {
    [aux_sym_concatenation_repeat1] = STATE(952),
    [sym__concat] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
  },
  [527] = {
    [sym_string] = STATE(710),
    [sym_simple_expansion] = STATE(710),
    [sym_string_expansion] = STATE(710),
    [sym_expansion] = STATE(710),
    [sym_command_substitution] = STATE(710),
    [sym_process_substitution] = STATE(710),
    [anon_sym_RBRACK] = ACTIONS(2050),
    [sym__special_characters] = ACTIONS(2044),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(1355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1355),
  },
  [528] = {
    [sym__concat] = ACTIONS(2052),
    [anon_sym_EQ] = ACTIONS(2054),
    [anon_sym_PLUS_EQ] = ACTIONS(2054),
    [sym_comment] = ACTIONS(53),
  },
  [529] = {
    [anon_sym_RBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(53),
  },
  [530] = {
    [sym_file_descriptor] = ACTIONS(2056),
    [sym_variable_name] = ACTIONS(2056),
    [ts_builtin_sym_end] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_PIPE] = ACTIONS(2058),
    [anon_sym_RPAREN] = ACTIONS(2056),
    [anon_sym_SEMI_SEMI] = ACTIONS(2056),
    [anon_sym_PIPE_AMP] = ACTIONS(2056),
    [anon_sym_AMP_AMP] = ACTIONS(2056),
    [anon_sym_PIPE_PIPE] = ACTIONS(2056),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_GT] = ACTIONS(2058),
    [anon_sym_GT_GT] = ACTIONS(2056),
    [anon_sym_AMP_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT_GT] = ACTIONS(2056),
    [anon_sym_LT_AMP] = ACTIONS(2056),
    [anon_sym_GT_AMP] = ACTIONS(2056),
    [sym__special_characters] = ACTIONS(2056),
    [anon_sym_DQUOTE] = ACTIONS(2056),
    [anon_sym_DOLLAR] = ACTIONS(2058),
    [sym_raw_string] = ACTIONS(2056),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2056),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2056),
    [anon_sym_BQUOTE] = ACTIONS(2056),
    [anon_sym_LT_LPAREN] = ACTIONS(2056),
    [anon_sym_GT_LPAREN] = ACTIONS(2056),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2058),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2058),
  },
  [531] = {
    [aux_sym_concatenation_repeat1] = STATE(956),
    [sym__concat] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(2062),
    [sym__special_characters] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [anon_sym_DOLLAR] = ACTIONS(2064),
    [sym_raw_string] = ACTIONS(2062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2062),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [anon_sym_LT_LPAREN] = ACTIONS(2062),
    [anon_sym_GT_LPAREN] = ACTIONS(2062),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2062),
  },
  [532] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(959),
    [anon_sym_DQUOTE] = ACTIONS(2066),
    [anon_sym_DOLLAR] = ACTIONS(2068),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [533] = {
    [sym_string] = STATE(961),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(2070),
    [sym_raw_string] = ACTIONS(2072),
    [anon_sym_POUND] = ACTIONS(2070),
    [anon_sym_DASH] = ACTIONS(2070),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2074),
    [anon_sym_STAR] = ACTIONS(2076),
    [anon_sym_AT] = ACTIONS(2076),
    [anon_sym_QMARK] = ACTIONS(2076),
    [anon_sym_0] = ACTIONS(2074),
    [anon_sym__] = ACTIONS(2074),
  },
  [534] = {
    [aux_sym_concatenation_repeat1] = STATE(956),
    [sym__concat] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(2078),
    [sym__special_characters] = ACTIONS(2078),
    [anon_sym_DQUOTE] = ACTIONS(2078),
    [anon_sym_DOLLAR] = ACTIONS(2080),
    [sym_raw_string] = ACTIONS(2078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2078),
    [anon_sym_BQUOTE] = ACTIONS(2078),
    [anon_sym_LT_LPAREN] = ACTIONS(2078),
    [anon_sym_GT_LPAREN] = ACTIONS(2078),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2078),
  },
  [535] = {
    [sym_subscript] = STATE(966),
    [sym_variable_name] = ACTIONS(2082),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_DOLLAR] = ACTIONS(2086),
    [anon_sym_POUND] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2086),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(2090),
    [anon_sym_AT] = ACTIONS(2090),
    [anon_sym_QMARK] = ACTIONS(2090),
    [anon_sym_0] = ACTIONS(2088),
    [anon_sym__] = ACTIONS(2088),
  },
  [536] = {
    [sym__terminated_statement] = STATE(969),
    [sym_for_statement] = STATE(967),
    [sym_c_style_for_statement] = STATE(967),
    [sym_while_statement] = STATE(967),
    [sym_if_statement] = STATE(967),
    [sym_case_statement] = STATE(967),
    [sym_function_definition] = STATE(967),
    [sym_subshell] = STATE(967),
    [sym_pipeline] = STATE(967),
    [sym_list] = STATE(967),
    [sym_negated_command] = STATE(967),
    [sym_test_command] = STATE(967),
    [sym_declaration_command] = STATE(967),
    [sym_unset_command] = STATE(967),
    [sym_command] = STATE(967),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(968),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(969),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [537] = {
    [sym__terminated_statement] = STATE(972),
    [sym_for_statement] = STATE(970),
    [sym_c_style_for_statement] = STATE(970),
    [sym_while_statement] = STATE(970),
    [sym_if_statement] = STATE(970),
    [sym_case_statement] = STATE(970),
    [sym_function_definition] = STATE(970),
    [sym_subshell] = STATE(970),
    [sym_pipeline] = STATE(970),
    [sym_list] = STATE(970),
    [sym_negated_command] = STATE(970),
    [sym_test_command] = STATE(970),
    [sym_declaration_command] = STATE(970),
    [sym_unset_command] = STATE(970),
    [sym_command] = STATE(970),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(971),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(972),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [538] = {
    [sym__terminated_statement] = STATE(975),
    [sym_for_statement] = STATE(973),
    [sym_c_style_for_statement] = STATE(973),
    [sym_while_statement] = STATE(973),
    [sym_if_statement] = STATE(973),
    [sym_case_statement] = STATE(973),
    [sym_function_definition] = STATE(973),
    [sym_subshell] = STATE(973),
    [sym_pipeline] = STATE(973),
    [sym_list] = STATE(973),
    [sym_negated_command] = STATE(973),
    [sym_test_command] = STATE(973),
    [sym_declaration_command] = STATE(973),
    [sym_unset_command] = STATE(973),
    [sym_command] = STATE(973),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(974),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(975),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [539] = {
    [sym_concatenation] = STATE(977),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_string_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [aux_sym_for_statement_repeat1] = STATE(977),
    [anon_sym_RPAREN] = ACTIONS(2092),
    [sym__special_characters] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym_raw_string] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1083),
  },
  [540] = {
    [sym_string] = STATE(978),
    [sym_simple_expansion] = STATE(978),
    [sym_string_expansion] = STATE(978),
    [sym_expansion] = STATE(978),
    [sym_command_substitution] = STATE(978),
    [sym_process_substitution] = STATE(978),
    [sym__special_characters] = ACTIONS(2094),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(2094),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LT_LPAREN] = ACTIONS(381),
    [anon_sym_GT_LPAREN] = ACTIONS(381),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2094),
  },
  [541] = {
    [aux_sym_concatenation_repeat1] = STATE(979),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(765),
    [ts_builtin_sym_end] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [542] = {
    [sym_file_descriptor] = ACTIONS(769),
    [sym__concat] = ACTIONS(769),
    [sym_variable_name] = ACTIONS(769),
    [ts_builtin_sym_end] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_AMP_GT] = ACTIONS(771),
    [anon_sym_AMP_GT_GT] = ACTIONS(769),
    [anon_sym_LT_AMP] = ACTIONS(769),
    [anon_sym_GT_AMP] = ACTIONS(769),
    [sym__special_characters] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [543] = {
    [anon_sym_DQUOTE] = ACTIONS(2096),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [544] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(2096),
    [anon_sym_DOLLAR] = ACTIONS(2098),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [545] = {
    [sym_file_descriptor] = ACTIONS(803),
    [sym__concat] = ACTIONS(803),
    [sym_variable_name] = ACTIONS(803),
    [ts_builtin_sym_end] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [anon_sym_PIPE_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_AMP_GT] = ACTIONS(805),
    [anon_sym_AMP_GT_GT] = ACTIONS(803),
    [anon_sym_LT_AMP] = ACTIONS(803),
    [anon_sym_GT_AMP] = ACTIONS(803),
    [sym__special_characters] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_raw_string] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(805),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(805),
  },
  [546] = {
    [sym_file_descriptor] = ACTIONS(807),
    [sym__concat] = ACTIONS(807),
    [sym_variable_name] = ACTIONS(807),
    [ts_builtin_sym_end] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [anon_sym_PIPE_AMP] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_LT] = ACTIONS(809),
    [anon_sym_GT] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(807),
    [anon_sym_AMP_GT] = ACTIONS(809),
    [anon_sym_AMP_GT_GT] = ACTIONS(807),
    [anon_sym_LT_AMP] = ACTIONS(807),
    [anon_sym_GT_AMP] = ACTIONS(807),
    [sym__special_characters] = ACTIONS(807),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(807),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_LT_LPAREN] = ACTIONS(807),
    [anon_sym_GT_LPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(809),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(809),
  },
  [547] = {
    [sym_file_descriptor] = ACTIONS(811),
    [sym__concat] = ACTIONS(811),
    [sym_variable_name] = ACTIONS(811),
    [ts_builtin_sym_end] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_AMP_GT] = ACTIONS(813),
    [anon_sym_AMP_GT_GT] = ACTIONS(811),
    [anon_sym_LT_AMP] = ACTIONS(811),
    [anon_sym_GT_AMP] = ACTIONS(811),
    [sym__special_characters] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_LT_LPAREN] = ACTIONS(811),
    [anon_sym_GT_LPAREN] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(813),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(813),
  },
  [548] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(2100),
    [sym_comment] = ACTIONS(53),
  },
  [549] = {
    [sym_subscript] = STATE(985),
    [sym_variable_name] = ACTIONS(2102),
    [anon_sym_DOLLAR] = ACTIONS(2104),
    [anon_sym_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2106),
    [anon_sym_STAR] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2108),
    [anon_sym_QMARK] = ACTIONS(2108),
    [anon_sym_0] = ACTIONS(2106),
    [anon_sym__] = ACTIONS(2106),
  },
  [550] = {
    [sym_concatenation] = STATE(988),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(988),
    [anon_sym_RBRACE] = ACTIONS(2110),
    [anon_sym_EQ] = ACTIONS(2112),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2116),
    [anon_sym_COLON] = ACTIONS(2112),
    [anon_sym_COLON_QMARK] = ACTIONS(2112),
    [anon_sym_COLON_DASH] = ACTIONS(2112),
    [anon_sym_PERCENT] = ACTIONS(2112),
    [anon_sym_DASH] = ACTIONS(2112),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [551] = {
    [sym_concatenation] = STATE(991),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(991),
    [anon_sym_RBRACE] = ACTIONS(2118),
    [anon_sym_EQ] = ACTIONS(2120),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2122),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2124),
    [anon_sym_COLON] = ACTIONS(2120),
    [anon_sym_COLON_QMARK] = ACTIONS(2120),
    [anon_sym_COLON_DASH] = ACTIONS(2120),
    [anon_sym_PERCENT] = ACTIONS(2120),
    [anon_sym_DASH] = ACTIONS(2120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [552] = {
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2128),
    [anon_sym_SEMI_SEMI] = ACTIONS(2130),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2130),
    [anon_sym_AMP] = ACTIONS(2126),
  },
  [553] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2128),
    [anon_sym_SEMI_SEMI] = ACTIONS(2130),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2130),
    [anon_sym_AMP] = ACTIONS(2126),
  },
  [554] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(994),
    [sym_c_style_for_statement] = STATE(994),
    [sym_while_statement] = STATE(994),
    [sym_if_statement] = STATE(994),
    [sym_case_statement] = STATE(994),
    [sym_function_definition] = STATE(994),
    [sym_subshell] = STATE(994),
    [sym_pipeline] = STATE(994),
    [sym_list] = STATE(994),
    [sym_negated_command] = STATE(994),
    [sym_test_command] = STATE(994),
    [sym_declaration_command] = STATE(994),
    [sym_unset_command] = STATE(994),
    [sym_command] = STATE(994),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(995),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [555] = {
    [anon_sym_SEMI] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2134),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(2128),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2134),
    [anon_sym_AMP] = ACTIONS(2132),
  },
  [556] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2134),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(2128),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2134),
    [anon_sym_AMP] = ACTIONS(2132),
  },
  [557] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(997),
    [sym_c_style_for_statement] = STATE(997),
    [sym_while_statement] = STATE(997),
    [sym_if_statement] = STATE(997),
    [sym_case_statement] = STATE(997),
    [sym_function_definition] = STATE(997),
    [sym_subshell] = STATE(997),
    [sym_pipeline] = STATE(997),
    [sym_list] = STATE(997),
    [sym_negated_command] = STATE(997),
    [sym_test_command] = STATE(997),
    [sym_declaration_command] = STATE(997),
    [sym_unset_command] = STATE(997),
    [sym_command] = STATE(997),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(998),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [558] = {
    [anon_sym_SEMI] = ACTIONS(2136),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2138),
    [anon_sym_SEMI_SEMI] = ACTIONS(2140),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2140),
    [anon_sym_AMP] = ACTIONS(2136),
  },
  [559] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2136),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2138),
    [anon_sym_SEMI_SEMI] = ACTIONS(2140),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2140),
    [anon_sym_AMP] = ACTIONS(2136),
  },
  [560] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1001),
    [sym_c_style_for_statement] = STATE(1001),
    [sym_while_statement] = STATE(1001),
    [sym_if_statement] = STATE(1001),
    [sym_case_statement] = STATE(1001),
    [sym_function_definition] = STATE(1001),
    [sym_subshell] = STATE(1001),
    [sym_pipeline] = STATE(1001),
    [sym_list] = STATE(1001),
    [sym_negated_command] = STATE(1001),
    [sym_test_command] = STATE(1001),
    [sym_declaration_command] = STATE(1001),
    [sym_unset_command] = STATE(1001),
    [sym_command] = STATE(1001),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1002),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [561] = {
    [sym__expression] = STATE(1014),
    [sym_binary_expression] = STATE(1014),
    [sym_unary_expression] = STATE(1014),
    [sym_parenthesized_expression] = STATE(1014),
    [sym_concatenation] = STATE(1014),
    [sym_string] = STATE(1009),
    [sym_simple_expansion] = STATE(1009),
    [sym_string_expansion] = STATE(1009),
    [sym_expansion] = STATE(1009),
    [sym_command_substitution] = STATE(1009),
    [sym_process_substitution] = STATE(1009),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2146),
    [sym__special_characters] = ACTIONS(2148),
    [anon_sym_DQUOTE] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [sym_raw_string] = ACTIONS(2154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2158),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [anon_sym_LT_LPAREN] = ACTIONS(2162),
    [anon_sym_GT_LPAREN] = ACTIONS(2162),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2164),
    [sym_test_operator] = ACTIONS(2166),
  },
  [562] = {
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_SEMI_SEMI] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(1153),
    [anon_sym_PIPE_PIPE] = ACTIONS(1153),
    [anon_sym_EQ_TILDE] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(1153),
    [anon_sym_BANG_EQ] = ACTIONS(1153),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1153),
    [anon_sym_LF] = ACTIONS(2170),
    [anon_sym_AMP] = ACTIONS(2168),
  },
  [563] = {
    [anon_sym_RPAREN] = ACTIONS(2172),
    [anon_sym_AMP_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1347),
    [anon_sym_EQ_TILDE] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1347),
  },
  [564] = {
    [anon_sym_SEMI] = ACTIONS(2174),
    [anon_sym_SEMI_SEMI] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1153),
    [anon_sym_PIPE_PIPE] = ACTIONS(1153),
    [anon_sym_EQ_TILDE] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(1153),
    [anon_sym_BANG_EQ] = ACTIONS(1153),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1153),
    [anon_sym_LF] = ACTIONS(1353),
    [anon_sym_AMP] = ACTIONS(2174),
  },
  [565] = {
    [sym_string] = STATE(1017),
    [sym_simple_expansion] = STATE(1017),
    [sym_string_expansion] = STATE(1017),
    [sym_expansion] = STATE(1017),
    [sym_command_substitution] = STATE(1017),
    [sym_process_substitution] = STATE(1017),
    [sym__special_characters] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(2176),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2176),
  },
  [566] = {
    [aux_sym_concatenation_repeat1] = STATE(1018),
    [sym__concat] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_EQ_TILDE] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(765),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [567] = {
    [sym__concat] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_esac] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_EQ_TILDE] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [568] = {
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [569] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [570] = {
    [sym__concat] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_esac] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [anon_sym_PIPE_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_EQ_TILDE] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_EQ] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(803),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(805),
  },
  [571] = {
    [sym__concat] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_esac] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [anon_sym_PIPE_AMP] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_EQ_TILDE] = ACTIONS(807),
    [anon_sym_EQ_EQ] = ACTIONS(807),
    [anon_sym_EQ] = ACTIONS(809),
    [anon_sym_LT] = ACTIONS(807),
    [anon_sym_GT] = ACTIONS(807),
    [anon_sym_BANG_EQ] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(807),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(809),
  },
  [572] = {
    [sym__concat] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_esac] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_EQ_TILDE] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_EQ] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(811),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(813),
  },
  [573] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(2182),
    [sym_comment] = ACTIONS(53),
  },
  [574] = {
    [sym_subscript] = STATE(1024),
    [sym_variable_name] = ACTIONS(2184),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_DASH] = ACTIONS(2186),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2188),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_AT] = ACTIONS(2190),
    [anon_sym_QMARK] = ACTIONS(2190),
    [anon_sym_0] = ACTIONS(2188),
    [anon_sym__] = ACTIONS(2188),
  },
  [575] = {
    [sym_concatenation] = STATE(1027),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1027),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2194),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2196),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_COLON_QMARK] = ACTIONS(2194),
    [anon_sym_COLON_DASH] = ACTIONS(2194),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [576] = {
    [sym_concatenation] = STATE(1030),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1030),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_EQ] = ACTIONS(2202),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2206),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym_COLON_QMARK] = ACTIONS(2202),
    [anon_sym_COLON_DASH] = ACTIONS(2202),
    [anon_sym_PERCENT] = ACTIONS(2202),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [577] = {
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2210),
    [anon_sym_SEMI_SEMI] = ACTIONS(2212),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2208),
  },
  [578] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2208),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2210),
    [anon_sym_SEMI_SEMI] = ACTIONS(2212),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2208),
  },
  [579] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1033),
    [sym_c_style_for_statement] = STATE(1033),
    [sym_while_statement] = STATE(1033),
    [sym_if_statement] = STATE(1033),
    [sym_case_statement] = STATE(1033),
    [sym_function_definition] = STATE(1033),
    [sym_subshell] = STATE(1033),
    [sym_pipeline] = STATE(1033),
    [sym_list] = STATE(1033),
    [sym_negated_command] = STATE(1033),
    [sym_test_command] = STATE(1033),
    [sym_declaration_command] = STATE(1033),
    [sym_unset_command] = STATE(1033),
    [sym_command] = STATE(1033),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1034),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [580] = {
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2216),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2216),
    [anon_sym_AMP] = ACTIONS(2214),
  },
  [581] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2216),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(2210),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2216),
    [anon_sym_AMP] = ACTIONS(2214),
  },
  [582] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1036),
    [sym_c_style_for_statement] = STATE(1036),
    [sym_while_statement] = STATE(1036),
    [sym_if_statement] = STATE(1036),
    [sym_case_statement] = STATE(1036),
    [sym_function_definition] = STATE(1036),
    [sym_subshell] = STATE(1036),
    [sym_pipeline] = STATE(1036),
    [sym_list] = STATE(1036),
    [sym_negated_command] = STATE(1036),
    [sym_test_command] = STATE(1036),
    [sym_declaration_command] = STATE(1036),
    [sym_unset_command] = STATE(1036),
    [sym_command] = STATE(1036),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(1037),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [583] = {
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2220),
    [anon_sym_SEMI_SEMI] = ACTIONS(2222),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2218),
  },
  [584] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2220),
    [anon_sym_SEMI_SEMI] = ACTIONS(2222),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2218),
  },
  [585] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1040),
    [sym_c_style_for_statement] = STATE(1040),
    [sym_while_statement] = STATE(1040),
    [sym_if_statement] = STATE(1040),
    [sym_case_statement] = STATE(1040),
    [sym_function_definition] = STATE(1040),
    [sym_subshell] = STATE(1040),
    [sym_pipeline] = STATE(1040),
    [sym_list] = STATE(1040),
    [sym_negated_command] = STATE(1040),
    [sym_test_command] = STATE(1040),
    [sym_declaration_command] = STATE(1040),
    [sym_unset_command] = STATE(1040),
    [sym_command] = STATE(1040),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1041),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [586] = {
    [sym__expression] = STATE(1042),
    [sym_binary_expression] = STATE(1042),
    [sym_unary_expression] = STATE(1042),
    [sym_parenthesized_expression] = STATE(1042),
    [sym_concatenation] = STATE(1042),
    [sym_string] = STATE(215),
    [sym_simple_expansion] = STATE(215),
    [sym_string_expansion] = STATE(215),
    [sym_expansion] = STATE(215),
    [sym_command_substitution] = STATE(215),
    [sym_process_substitution] = STATE(215),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_SEMI_SEMI] = ACTIONS(2170),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(389),
    [sym__special_characters] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(407),
    [sym_test_operator] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(2170),
    [anon_sym_AMP] = ACTIONS(2170),
  },
  [587] = {
    [sym__expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym_parenthesized_expression] = STATE(1043),
    [sym_concatenation] = STATE(1043),
    [sym_string] = STATE(215),
    [sym_simple_expansion] = STATE(215),
    [sym_string_expansion] = STATE(215),
    [sym_expansion] = STATE(215),
    [sym_command_substitution] = STATE(215),
    [sym_process_substitution] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(389),
    [sym__special_characters] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(407),
    [sym_test_operator] = ACTIONS(409),
  },
  [588] = {
    [sym__expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym_parenthesized_expression] = STATE(1043),
    [sym_concatenation] = STATE(1043),
    [sym_string] = STATE(215),
    [sym_simple_expansion] = STATE(215),
    [sym_string_expansion] = STATE(215),
    [sym_expansion] = STATE(215),
    [sym_command_substitution] = STATE(215),
    [sym_process_substitution] = STATE(215),
    [anon_sym_LPAREN] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(389),
    [sym__special_characters] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2230),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2232),
    [anon_sym_BQUOTE] = ACTIONS(2234),
    [anon_sym_LT_LPAREN] = ACTIONS(2236),
    [anon_sym_GT_LPAREN] = ACTIONS(2236),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(407),
    [sym_test_operator] = ACTIONS(389),
    [sym_regex] = ACTIONS(2238),
  },
  [589] = {
    [aux_sym_concatenation_repeat1] = STATE(1046),
    [sym__concat] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_SEMI_SEMI] = ACTIONS(2062),
    [sym__special_characters] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [anon_sym_DOLLAR] = ACTIONS(2064),
    [sym_raw_string] = ACTIONS(2062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2062),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [anon_sym_LT_LPAREN] = ACTIONS(2062),
    [anon_sym_GT_LPAREN] = ACTIONS(2062),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2064),
    [anon_sym_LF] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2062),
  },
  [590] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(1049),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_DOLLAR] = ACTIONS(2244),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [591] = {
    [sym_string] = STATE(1051),
    [anon_sym_DQUOTE] = ACTIONS(1161),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [sym_raw_string] = ACTIONS(2248),
    [anon_sym_POUND] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_0] = ACTIONS(2250),
    [anon_sym__] = ACTIONS(2250),
  },
  [592] = {
    [aux_sym_concatenation_repeat1] = STATE(1046),
    [sym__concat] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2080),
    [anon_sym_SEMI_SEMI] = ACTIONS(2078),
    [sym__special_characters] = ACTIONS(2078),
    [anon_sym_DQUOTE] = ACTIONS(2078),
    [anon_sym_DOLLAR] = ACTIONS(2080),
    [sym_raw_string] = ACTIONS(2078),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2078),
    [anon_sym_BQUOTE] = ACTIONS(2078),
    [anon_sym_LT_LPAREN] = ACTIONS(2078),
    [anon_sym_GT_LPAREN] = ACTIONS(2078),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2080),
    [anon_sym_LF] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2078),
  },
  [593] = {
    [sym_subscript] = STATE(1056),
    [sym_variable_name] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2258),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_AT] = ACTIONS(2262),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_0] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2260),
  },
  [594] = {
    [sym__terminated_statement] = STATE(1059),
    [sym_for_statement] = STATE(1057),
    [sym_c_style_for_statement] = STATE(1057),
    [sym_while_statement] = STATE(1057),
    [sym_if_statement] = STATE(1057),
    [sym_case_statement] = STATE(1057),
    [sym_function_definition] = STATE(1057),
    [sym_subshell] = STATE(1057),
    [sym_pipeline] = STATE(1057),
    [sym_list] = STATE(1057),
    [sym_negated_command] = STATE(1057),
    [sym_test_command] = STATE(1057),
    [sym_declaration_command] = STATE(1057),
    [sym_unset_command] = STATE(1057),
    [sym_command] = STATE(1057),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1058),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(1059),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [595] = {
    [sym__terminated_statement] = STATE(1062),
    [sym_for_statement] = STATE(1060),
    [sym_c_style_for_statement] = STATE(1060),
    [sym_while_statement] = STATE(1060),
    [sym_if_statement] = STATE(1060),
    [sym_case_statement] = STATE(1060),
    [sym_function_definition] = STATE(1060),
    [sym_subshell] = STATE(1060),
    [sym_pipeline] = STATE(1060),
    [sym_list] = STATE(1060),
    [sym_negated_command] = STATE(1060),
    [sym_test_command] = STATE(1060),
    [sym_declaration_command] = STATE(1060),
    [sym_unset_command] = STATE(1060),
    [sym_command] = STATE(1060),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(1061),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1062),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [596] = {
    [sym__terminated_statement] = STATE(1065),
    [sym_for_statement] = STATE(1063),
    [sym_c_style_for_statement] = STATE(1063),
    [sym_while_statement] = STATE(1063),
    [sym_if_statement] = STATE(1063),
    [sym_case_statement] = STATE(1063),
    [sym_function_definition] = STATE(1063),
    [sym_subshell] = STATE(1063),
    [sym_pipeline] = STATE(1063),
    [sym_list] = STATE(1063),
    [sym_negated_command] = STATE(1063),
    [sym_test_command] = STATE(1063),
    [sym_declaration_command] = STATE(1063),
    [sym_unset_command] = STATE(1063),
    [sym_command] = STATE(1063),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1064),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(1065),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [597] = {
    [sym_concatenation] = STATE(1067),
    [sym_string] = STATE(592),
    [sym_simple_expansion] = STATE(592),
    [sym_string_expansion] = STATE(592),
    [sym_expansion] = STATE(592),
    [sym_command_substitution] = STATE(592),
    [sym_process_substitution] = STATE(592),
    [aux_sym_for_statement_repeat1] = STATE(1067),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym_SEMI_SEMI] = ACTIONS(2266),
    [sym__special_characters] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(1161),
    [anon_sym_DOLLAR] = ACTIONS(1163),
    [sym_raw_string] = ACTIONS(1165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1167),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1171),
    [anon_sym_LT_LPAREN] = ACTIONS(1173),
    [anon_sym_GT_LPAREN] = ACTIONS(1173),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2268),
    [anon_sym_LF] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2266),
  },
  [598] = {
    [sym__terminated_statement] = STATE(1069),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1069),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_done] = ACTIONS(2270),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym_esac] = ACTIONS(2272),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_RPAREN] = ACTIONS(2272),
    [anon_sym_SEMI_SEMI] = ACTIONS(2272),
    [anon_sym_PIPE_AMP] = ACTIONS(2272),
    [anon_sym_AMP_AMP] = ACTIONS(2272),
    [anon_sym_PIPE_PIPE] = ACTIONS(2272),
    [anon_sym_BQUOTE] = ACTIONS(2272),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2274),
  },
  [600] = {
    [aux_sym_concatenation_repeat1] = STATE(1070),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [601] = {
    [aux_sym_concatenation_repeat1] = STATE(1070),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [602] = {
    [sym_file_redirect] = STATE(1071),
    [sym_heredoc_redirect] = STATE(1071),
    [sym_heredoc_body] = STATE(615),
    [sym_herestring_redirect] = STATE(1071),
    [aux_sym_while_statement_repeat1] = STATE(1071),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1197),
    [anon_sym_SEMI_SEMI] = ACTIONS(1195),
    [anon_sym_PIPE_AMP] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1197),
  },
  [603] = {
    [anon_sym_RPAREN] = ACTIONS(2276),
    [sym_comment] = ACTIONS(53),
  },
  [604] = {
    [sym_file_redirect] = STATE(672),
    [sym_file_descriptor] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(1289),
    [anon_sym_PIPE] = ACTIONS(1289),
    [anon_sym_SEMI_SEMI] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_GT] = ACTIONS(2282),
    [anon_sym_AMP_GT] = ACTIONS(2280),
    [anon_sym_AMP_GT_GT] = ACTIONS(2282),
    [anon_sym_LT_AMP] = ACTIONS(2282),
    [anon_sym_GT_AMP] = ACTIONS(2282),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1289),
  },
  [605] = {
    [sym_file_redirect] = STATE(1078),
    [sym_heredoc_redirect] = STATE(1078),
    [sym_herestring_redirect] = STATE(1078),
    [aux_sym_while_statement_repeat1] = STATE(1078),
    [sym_file_descriptor] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_SEMI_SEMI] = ACTIONS(1405),
    [anon_sym_PIPE_AMP] = ACTIONS(1405),
    [anon_sym_AMP_AMP] = ACTIONS(1405),
    [anon_sym_PIPE_PIPE] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_AMP_GT] = ACTIONS(2286),
    [anon_sym_AMP_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_AMP] = ACTIONS(2288),
    [anon_sym_GT_AMP] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_LT_LT_DASH] = ACTIONS(1415),
    [anon_sym_LT_LT_LT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1405),
    [anon_sym_AMP] = ACTIONS(1407),
  },
  [606] = {
    [sym_concatenation] = STATE(770),
    [sym_string] = STATE(1080),
    [sym_array] = STATE(770),
    [sym_simple_expansion] = STATE(1080),
    [sym_string_expansion] = STATE(1080),
    [sym_expansion] = STATE(1080),
    [sym_command_substitution] = STATE(1080),
    [sym_process_substitution] = STATE(1080),
    [sym__empty_value] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [sym__special_characters] = ACTIONS(2292),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(2294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2294),
  },
  [607] = {
    [aux_sym_concatenation_repeat1] = STATE(1081),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(767),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [608] = {
    [sym_variable_assignment] = STATE(608),
    [sym_subscript] = STATE(231),
    [sym_concatenation] = STATE(608),
    [sym_string] = STATE(230),
    [sym_simple_expansion] = STATE(230),
    [sym_string_expansion] = STATE(230),
    [sym_expansion] = STATE(230),
    [sym_command_substitution] = STATE(230),
    [sym_process_substitution] = STATE(230),
    [aux_sym_declaration_command_repeat1] = STATE(608),
    [sym_variable_name] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(1562),
    [anon_sym_PIPE] = ACTIONS(1562),
    [anon_sym_SEMI_SEMI] = ACTIONS(1560),
    [anon_sym_PIPE_AMP] = ACTIONS(1560),
    [anon_sym_AMP_AMP] = ACTIONS(1560),
    [anon_sym_PIPE_PIPE] = ACTIONS(1560),
    [sym__special_characters] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(1567),
    [anon_sym_DOLLAR] = ACTIONS(1570),
    [sym_raw_string] = ACTIONS(2302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [anon_sym_BQUOTE] = ACTIONS(1582),
    [anon_sym_LT_LPAREN] = ACTIONS(1585),
    [anon_sym_GT_LPAREN] = ACTIONS(1585),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2305),
    [sym_word] = ACTIONS(2308),
    [anon_sym_LF] = ACTIONS(1560),
    [anon_sym_AMP] = ACTIONS(1562),
  },
  [609] = {
    [aux_sym_concatenation_repeat1] = STATE(1082),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(767),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [610] = {
    [sym_concatenation] = STATE(610),
    [sym_string] = STATE(234),
    [sym_simple_expansion] = STATE(234),
    [sym_string_expansion] = STATE(234),
    [sym_expansion] = STATE(234),
    [sym_command_substitution] = STATE(234),
    [sym_process_substitution] = STATE(234),
    [aux_sym_unset_command_repeat1] = STATE(610),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(2311),
    [anon_sym_DQUOTE] = ACTIONS(1649),
    [anon_sym_DOLLAR] = ACTIONS(1652),
    [sym_raw_string] = ACTIONS(2314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1661),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1667),
    [anon_sym_GT_LPAREN] = ACTIONS(1667),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2317),
    [sym_word] = ACTIONS(2320),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [611] = {
    [aux_sym_concatenation_repeat1] = STATE(611),
    [sym__simple_heredoc_body] = ACTIONS(1724),
    [sym__heredoc_body_beginning] = ACTIONS(1724),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [612] = {
    [sym_compound_statement] = STATE(1083),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [613] = {
    [sym__simple_heredoc_body] = ACTIONS(2323),
    [sym__heredoc_body_beginning] = ACTIONS(2323),
    [sym_file_descriptor] = ACTIONS(2323),
    [ts_builtin_sym_end] = ACTIONS(2323),
    [anon_sym_SEMI] = ACTIONS(2325),
    [anon_sym_esac] = ACTIONS(2323),
    [anon_sym_PIPE] = ACTIONS(2325),
    [anon_sym_RPAREN] = ACTIONS(2323),
    [anon_sym_SEMI_SEMI] = ACTIONS(2323),
    [anon_sym_PIPE_AMP] = ACTIONS(2323),
    [anon_sym_AMP_AMP] = ACTIONS(2323),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2325),
    [anon_sym_GT] = ACTIONS(2325),
    [anon_sym_GT_GT] = ACTIONS(2323),
    [anon_sym_AMP_GT] = ACTIONS(2325),
    [anon_sym_AMP_GT_GT] = ACTIONS(2323),
    [anon_sym_LT_AMP] = ACTIONS(2323),
    [anon_sym_GT_AMP] = ACTIONS(2323),
    [anon_sym_LT_LT] = ACTIONS(2325),
    [anon_sym_LT_LT_DASH] = ACTIONS(2323),
    [anon_sym_LT_LT_LT] = ACTIONS(2323),
    [anon_sym_BQUOTE] = ACTIONS(2323),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2325),
  },
  [614] = {
    [sym__terminated_statement] = STATE(1085),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1085),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_done] = ACTIONS(2327),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(2329),
    [anon_sym_SEMI] = ACTIONS(2331),
    [anon_sym_esac] = ACTIONS(2329),
    [anon_sym_PIPE] = ACTIONS(2331),
    [anon_sym_RPAREN] = ACTIONS(2329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2329),
    [anon_sym_PIPE_AMP] = ACTIONS(2329),
    [anon_sym_AMP_AMP] = ACTIONS(2329),
    [anon_sym_PIPE_PIPE] = ACTIONS(2329),
    [anon_sym_BQUOTE] = ACTIONS(2329),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2329),
    [anon_sym_AMP] = ACTIONS(2331),
  },
  [616] = {
    [sym_file_redirect] = STATE(517),
    [sym_heredoc_redirect] = STATE(517),
    [sym_heredoc_body] = STATE(1086),
    [sym_herestring_redirect] = STATE(517),
    [aux_sym_while_statement_repeat1] = STATE(517),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(2329),
    [anon_sym_SEMI] = ACTIONS(2331),
    [anon_sym_PIPE] = ACTIONS(2331),
    [anon_sym_SEMI_SEMI] = ACTIONS(2329),
    [anon_sym_PIPE_AMP] = ACTIONS(2329),
    [anon_sym_AMP_AMP] = ACTIONS(2329),
    [anon_sym_PIPE_PIPE] = ACTIONS(2329),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(341),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2329),
    [anon_sym_AMP] = ACTIONS(2331),
  },
  [617] = {
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [618] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [619] = {
    [sym_concatenation] = STATE(945),
    [sym_string] = STATE(1088),
    [sym_simple_expansion] = STATE(1088),
    [sym_string_expansion] = STATE(1088),
    [sym_expansion] = STATE(1088),
    [sym_command_substitution] = STATE(1088),
    [sym_process_substitution] = STATE(1088),
    [sym__special_characters] = ACTIONS(2333),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(2335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2335),
  },
  [620] = {
    [aux_sym_concatenation_repeat1] = STATE(236),
    [sym__simple_heredoc_body] = ACTIONS(1960),
    [sym__heredoc_body_beginning] = ACTIONS(1960),
    [sym_file_descriptor] = ACTIONS(1960),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1962),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [anon_sym_EQ_TILDE] = ACTIONS(1962),
    [anon_sym_EQ_EQ] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1962),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1962),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [sym__special_characters] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1962),
    [sym_raw_string] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1962),
    [anon_sym_LF] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1962),
  },
  [621] = {
    [aux_sym_concatenation_repeat1] = STATE(236),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_EQ_TILDE] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1966),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1966),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [622] = {
    [aux_sym_concatenation_repeat1] = STATE(1089),
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [623] = {
    [aux_sym_concatenation_repeat1] = STATE(1089),
    [sym__simple_heredoc_body] = ACTIONS(749),
    [sym__heredoc_body_beginning] = ACTIONS(749),
    [sym_file_descriptor] = ACTIONS(749),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_LT_LT_DASH] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [624] = {
    [aux_sym_concatenation_repeat1] = STATE(1089),
    [sym__simple_heredoc_body] = ACTIONS(1972),
    [sym__heredoc_body_beginning] = ACTIONS(1972),
    [sym_file_descriptor] = ACTIONS(1972),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_PIPE_AMP] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_PIPE_PIPE] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_AMP_GT] = ACTIONS(1974),
    [anon_sym_AMP_GT_GT] = ACTIONS(1972),
    [anon_sym_LT_AMP] = ACTIONS(1972),
    [anon_sym_GT_AMP] = ACTIONS(1972),
    [anon_sym_LT_LT] = ACTIONS(1974),
    [anon_sym_LT_LT_DASH] = ACTIONS(1972),
    [anon_sym_LT_LT_LT] = ACTIONS(1972),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1974),
  },
  [625] = {
    [aux_sym_concatenation_repeat1] = STATE(1089),
    [sym__simple_heredoc_body] = ACTIONS(1976),
    [sym__heredoc_body_beginning] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [626] = {
    [sym_file_redirect] = STATE(626),
    [sym_heredoc_redirect] = STATE(626),
    [sym_herestring_redirect] = STATE(626),
    [aux_sym_while_statement_repeat1] = STATE(626),
    [sym__simple_heredoc_body] = ACTIONS(1984),
    [sym__heredoc_body_beginning] = ACTIONS(1984),
    [sym_file_descriptor] = ACTIONS(2337),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(2340),
    [anon_sym_GT] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_AMP_GT] = ACTIONS(2340),
    [anon_sym_AMP_GT_GT] = ACTIONS(2343),
    [anon_sym_LT_AMP] = ACTIONS(2343),
    [anon_sym_GT_AMP] = ACTIONS(2343),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_LT_LT_DASH] = ACTIONS(2000),
    [anon_sym_LT_LT_LT] = ACTIONS(2346),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1989),
  },
  [627] = {
    [sym_file_redirect] = STATE(626),
    [sym_heredoc_redirect] = STATE(626),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(626),
    [aux_sym_while_statement_repeat1] = STATE(626),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [628] = {
    [sym_concatenation] = STATE(628),
    [sym_string] = STATE(248),
    [sym_simple_expansion] = STATE(248),
    [sym_string_expansion] = STATE(248),
    [sym_expansion] = STATE(248),
    [sym_command_substitution] = STATE(248),
    [sym_process_substitution] = STATE(248),
    [aux_sym_command_repeat2] = STATE(628),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_EQ_TILDE] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(2352),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [anon_sym_DOLLAR] = ACTIONS(2015),
    [sym_raw_string] = ACTIONS(2355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2024),
    [anon_sym_BQUOTE] = ACTIONS(2027),
    [anon_sym_LT_LPAREN] = ACTIONS(2030),
    [anon_sym_GT_LPAREN] = ACTIONS(2030),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2358),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [629] = {
    [sym_file_redirect] = STATE(1090),
    [sym_heredoc_redirect] = STATE(1090),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(1090),
    [sym_concatenation] = STATE(628),
    [sym_string] = STATE(248),
    [sym_simple_expansion] = STATE(248),
    [sym_string_expansion] = STATE(248),
    [sym_expansion] = STATE(248),
    [sym_command_substitution] = STATE(248),
    [sym_process_substitution] = STATE(248),
    [aux_sym_while_statement_repeat1] = STATE(1090),
    [aux_sym_command_repeat2] = STATE(628),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_EQ_TILDE] = ACTIONS(455),
    [anon_sym_EQ_EQ] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [sym__special_characters] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(467),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [630] = {
    [ts_builtin_sym_end] = ACTIONS(2361),
    [anon_sym_SEMI] = ACTIONS(2363),
    [anon_sym_esac] = ACTIONS(2361),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_RPAREN] = ACTIONS(2361),
    [anon_sym_SEMI_SEMI] = ACTIONS(2361),
    [anon_sym_PIPE_AMP] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_PIPE_PIPE] = ACTIONS(2361),
    [anon_sym_BQUOTE] = ACTIONS(2361),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2363),
  },
  [631] = {
    [sym__terminated_statement] = STATE(1091),
    [sym_for_statement] = STATE(50),
    [sym_c_style_for_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_case_statement] = STATE(50),
    [sym_function_definition] = STATE(50),
    [sym_subshell] = STATE(50),
    [sym_pipeline] = STATE(50),
    [sym_list] = STATE(50),
    [sym_negated_command] = STATE(50),
    [sym_test_command] = STATE(50),
    [sym_declaration_command] = STATE(50),
    [sym_unset_command] = STATE(50),
    [sym_command] = STATE(50),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(52),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [632] = {
    [sym__terminated_statement] = STATE(1092),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1092),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(2365),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [633] = {
    [anon_sym_fi] = ACTIONS(2367),
    [sym_comment] = ACTIONS(53),
  },
  [634] = {
    [sym__terminated_statement] = STATE(1095),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_elif_clause] = STATE(1096),
    [sym_else_clause] = STATE(1094),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1095),
    [aux_sym_if_statement_repeat1] = STATE(1096),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(2369),
    [anon_sym_elif] = ACTIONS(1217),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [635] = {
    [sym_elif_clause] = STATE(1097),
    [sym_else_clause] = STATE(1094),
    [aux_sym_if_statement_repeat1] = STATE(1097),
    [anon_sym_fi] = ACTIONS(2367),
    [anon_sym_elif] = ACTIONS(2371),
    [anon_sym_else] = ACTIONS(2373),
    [sym_comment] = ACTIONS(53),
  },
  [636] = {
    [sym__concat] = ACTIONS(1724),
    [anon_sym_in] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1724),
  },
  [637] = {
    [sym_case_item] = STATE(1103),
    [sym_last_case_item] = STATE(1101),
    [sym_concatenation] = STATE(1102),
    [sym_string] = STATE(1100),
    [sym_simple_expansion] = STATE(1100),
    [sym_string_expansion] = STATE(1100),
    [sym_expansion] = STATE(1100),
    [sym_command_substitution] = STATE(1100),
    [sym_process_substitution] = STATE(1100),
    [aux_sym_case_statement_repeat1] = STATE(1103),
    [anon_sym_esac] = ACTIONS(2375),
    [sym__special_characters] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(2379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2381),
  },
  [638] = {
    [anon_sym_SEMI] = ACTIONS(2383),
    [anon_sym_SEMI_SEMI] = ACTIONS(2385),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2385),
    [anon_sym_AMP] = ACTIONS(2385),
  },
  [639] = {
    [aux_sym_concatenation_repeat1] = STATE(639),
    [sym__concat] = ACTIONS(2387),
    [anon_sym_in] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1724),
  },
  [640] = {
    [sym__concat] = ACTIONS(1731),
    [anon_sym_in] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1731),
  },
  [641] = {
    [anon_sym_DQUOTE] = ACTIONS(2390),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [642] = {
    [sym_case_item] = STATE(1108),
    [sym_last_case_item] = STATE(1107),
    [sym_concatenation] = STATE(1102),
    [sym_string] = STATE(1100),
    [sym_simple_expansion] = STATE(1100),
    [sym_string_expansion] = STATE(1100),
    [sym_expansion] = STATE(1100),
    [sym_command_substitution] = STATE(1100),
    [sym_process_substitution] = STATE(1100),
    [aux_sym_case_statement_repeat1] = STATE(1108),
    [anon_sym_esac] = ACTIONS(2392),
    [sym__special_characters] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(2379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2381),
  },
  [643] = {
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_SEMI_SEMI] = ACTIONS(2396),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2396),
  },
  [644] = {
    [sym_concatenation] = STATE(1113),
    [sym_string] = STATE(1112),
    [sym_simple_expansion] = STATE(1112),
    [sym_string_expansion] = STATE(1112),
    [sym_expansion] = STATE(1112),
    [sym_command_substitution] = STATE(1112),
    [sym_process_substitution] = STATE(1112),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [sym__special_characters] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(2402),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2402),
  },
  [645] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(2404),
    [sym_comment] = ACTIONS(53),
  },
  [646] = {
    [sym_concatenation] = STATE(1117),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1117),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(2408),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2412),
    [anon_sym_COLON] = ACTIONS(2408),
    [anon_sym_COLON_QMARK] = ACTIONS(2408),
    [anon_sym_COLON_DASH] = ACTIONS(2408),
    [anon_sym_PERCENT] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [647] = {
    [sym_concatenation] = STATE(1119),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1119),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_EQ] = ACTIONS(2414),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2416),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2418),
    [anon_sym_COLON] = ACTIONS(2414),
    [anon_sym_COLON_QMARK] = ACTIONS(2414),
    [anon_sym_COLON_DASH] = ACTIONS(2414),
    [anon_sym_PERCENT] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [648] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_in] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1832),
  },
  [649] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2420),
  },
  [650] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [651] = {
    [sym__concat] = ACTIONS(1876),
    [anon_sym_in] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1876),
  },
  [652] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2424),
  },
  [653] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [654] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2426),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [655] = {
    [sym__concat] = ACTIONS(1884),
    [anon_sym_in] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1884),
  },
  [656] = {
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2426),
    [anon_sym_SEMI_SEMI] = ACTIONS(2430),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2428),
  },
  [657] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2426),
    [anon_sym_SEMI_SEMI] = ACTIONS(2430),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2428),
  },
  [658] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2426),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [659] = {
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2434),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(2426),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2432),
  },
  [660] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2434),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(2426),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2432),
  },
  [661] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2436),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [662] = {
    [sym__concat] = ACTIONS(1916),
    [anon_sym_in] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1916),
  },
  [663] = {
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2436),
    [anon_sym_SEMI_SEMI] = ACTIONS(2440),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2440),
    [anon_sym_AMP] = ACTIONS(2438),
  },
  [664] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2436),
    [anon_sym_SEMI_SEMI] = ACTIONS(2440),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2440),
    [anon_sym_AMP] = ACTIONS(2438),
  },
  [665] = {
    [sym_compound_statement] = STATE(1128),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [666] = {
    [sym_file_descriptor] = ACTIONS(2442),
    [ts_builtin_sym_end] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_esac] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [667] = {
    [anon_sym_SEMI] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(2448),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2446),
  },
  [668] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(2448),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2446),
  },
  [669] = {
    [sym__terminated_statement] = STATE(1131),
    [sym_for_statement] = STATE(667),
    [sym_c_style_for_statement] = STATE(667),
    [sym_while_statement] = STATE(667),
    [sym_if_statement] = STATE(667),
    [sym_case_statement] = STATE(667),
    [sym_function_definition] = STATE(667),
    [sym_subshell] = STATE(667),
    [sym_pipeline] = STATE(667),
    [sym_list] = STATE(667),
    [sym_negated_command] = STATE(667),
    [sym_test_command] = STATE(667),
    [sym_declaration_command] = STATE(667),
    [sym_unset_command] = STATE(667),
    [sym_command] = STATE(667),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(668),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1131),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [670] = {
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_AMP_GT] = ACTIONS(2452),
    [anon_sym_AMP_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_AMP] = ACTIONS(2454),
    [anon_sym_GT_AMP] = ACTIONS(2454),
    [sym_comment] = ACTIONS(53),
  },
  [671] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(1134),
    [sym_simple_expansion] = STATE(1134),
    [sym_string_expansion] = STATE(1134),
    [sym_expansion] = STATE(1134),
    [sym_command_substitution] = STATE(1134),
    [sym_process_substitution] = STATE(1134),
    [sym__special_characters] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(2458),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2458),
  },
  [672] = {
    [ts_builtin_sym_end] = ACTIONS(2460),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_esac] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_RPAREN] = ACTIONS(2460),
    [anon_sym_SEMI_SEMI] = ACTIONS(2460),
    [anon_sym_PIPE_AMP] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
  },
  [673] = {
    [aux_sym_concatenation_repeat1] = STATE(1136),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [674] = {
    [aux_sym_concatenation_repeat1] = STATE(1136),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [675] = {
    [sym_file_redirect] = STATE(1137),
    [sym_heredoc_redirect] = STATE(1137),
    [sym_heredoc_body] = STATE(615),
    [sym_herestring_redirect] = STATE(1137),
    [aux_sym_while_statement_repeat1] = STATE(1137),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(1195),
    [anon_sym_SEMI_SEMI] = ACTIONS(1195),
    [anon_sym_PIPE_AMP] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(557),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1197),
  },
  [676] = {
    [anon_sym_RPAREN] = ACTIONS(2464),
    [sym_comment] = ACTIONS(53),
  },
  [677] = {
    [sym_file_redirect] = STATE(672),
    [sym_file_descriptor] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(1289),
    [anon_sym_PIPE] = ACTIONS(1289),
    [anon_sym_RPAREN] = ACTIONS(1287),
    [anon_sym_SEMI_SEMI] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_AMP_GT] = ACTIONS(2468),
    [anon_sym_AMP_GT_GT] = ACTIONS(2470),
    [anon_sym_LT_AMP] = ACTIONS(2470),
    [anon_sym_GT_AMP] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1289),
  },
  [678] = {
    [sym_file_redirect] = STATE(1144),
    [sym_heredoc_redirect] = STATE(1144),
    [sym_herestring_redirect] = STATE(1144),
    [aux_sym_while_statement_repeat1] = STATE(1144),
    [sym_file_descriptor] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_RPAREN] = ACTIONS(1405),
    [anon_sym_SEMI_SEMI] = ACTIONS(1405),
    [anon_sym_PIPE_AMP] = ACTIONS(1405),
    [anon_sym_AMP_AMP] = ACTIONS(1405),
    [anon_sym_PIPE_PIPE] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_GT] = ACTIONS(2474),
    [anon_sym_GT_GT] = ACTIONS(2476),
    [anon_sym_AMP_GT] = ACTIONS(2474),
    [anon_sym_AMP_GT_GT] = ACTIONS(2476),
    [anon_sym_LT_AMP] = ACTIONS(2476),
    [anon_sym_GT_AMP] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_LT_LT_DASH] = ACTIONS(1415),
    [anon_sym_LT_LT_LT] = ACTIONS(2478),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1405),
    [anon_sym_AMP] = ACTIONS(1407),
  },
  [679] = {
    [sym_concatenation] = STATE(770),
    [sym_string] = STATE(1146),
    [sym_array] = STATE(770),
    [sym_simple_expansion] = STATE(1146),
    [sym_string_expansion] = STATE(1146),
    [sym_expansion] = STATE(1146),
    [sym_command_substitution] = STATE(1146),
    [sym_process_substitution] = STATE(1146),
    [sym__empty_value] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [sym__special_characters] = ACTIONS(2480),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(2482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(197),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2482),
  },
  [680] = {
    [aux_sym_concatenation_repeat1] = STATE(1147),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(767),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [681] = {
    [sym_variable_assignment] = STATE(681),
    [sym_subscript] = STATE(289),
    [sym_concatenation] = STATE(681),
    [sym_string] = STATE(288),
    [sym_simple_expansion] = STATE(288),
    [sym_string_expansion] = STATE(288),
    [sym_expansion] = STATE(288),
    [sym_command_substitution] = STATE(288),
    [sym_process_substitution] = STATE(288),
    [aux_sym_declaration_command_repeat1] = STATE(681),
    [sym_variable_name] = ACTIONS(2484),
    [anon_sym_SEMI] = ACTIONS(1562),
    [anon_sym_PIPE] = ACTIONS(1562),
    [anon_sym_RPAREN] = ACTIONS(1560),
    [anon_sym_SEMI_SEMI] = ACTIONS(1560),
    [anon_sym_PIPE_AMP] = ACTIONS(1560),
    [anon_sym_AMP_AMP] = ACTIONS(1560),
    [anon_sym_PIPE_PIPE] = ACTIONS(1560),
    [sym__special_characters] = ACTIONS(2487),
    [anon_sym_DQUOTE] = ACTIONS(1567),
    [anon_sym_DOLLAR] = ACTIONS(1570),
    [sym_raw_string] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [anon_sym_BQUOTE] = ACTIONS(1582),
    [anon_sym_LT_LPAREN] = ACTIONS(1585),
    [anon_sym_GT_LPAREN] = ACTIONS(1585),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2493),
    [sym_word] = ACTIONS(2496),
    [anon_sym_LF] = ACTIONS(1560),
    [anon_sym_AMP] = ACTIONS(1562),
  },
  [682] = {
    [aux_sym_concatenation_repeat1] = STATE(1148),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(767),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [683] = {
    [sym_concatenation] = STATE(683),
    [sym_string] = STATE(292),
    [sym_simple_expansion] = STATE(292),
    [sym_string_expansion] = STATE(292),
    [sym_expansion] = STATE(292),
    [sym_command_substitution] = STATE(292),
    [sym_process_substitution] = STATE(292),
    [aux_sym_unset_command_repeat1] = STATE(683),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_SEMI_SEMI] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(2499),
    [anon_sym_DQUOTE] = ACTIONS(1649),
    [anon_sym_DOLLAR] = ACTIONS(1652),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1661),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LT_LPAREN] = ACTIONS(1667),
    [anon_sym_GT_LPAREN] = ACTIONS(1667),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2505),
    [sym_word] = ACTIONS(2508),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [684] = {
    [aux_sym_concatenation_repeat1] = STATE(684),
    [sym__simple_heredoc_body] = ACTIONS(1724),
    [sym__heredoc_body_beginning] = ACTIONS(1724),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [685] = {
    [sym_compound_statement] = STATE(1149),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [686] = {
    [ts_builtin_sym_end] = ACTIONS(2511),
    [anon_sym_SEMI] = ACTIONS(2513),
    [anon_sym_esac] = ACTIONS(2511),
    [anon_sym_PIPE] = ACTIONS(2513),
    [anon_sym_RPAREN] = ACTIONS(2511),
    [anon_sym_SEMI_SEMI] = ACTIONS(2511),
    [anon_sym_PIPE_AMP] = ACTIONS(2511),
    [anon_sym_AMP_AMP] = ACTIONS(2511),
    [anon_sym_PIPE_PIPE] = ACTIONS(2511),
    [anon_sym_BQUOTE] = ACTIONS(2511),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2511),
    [anon_sym_AMP] = ACTIONS(2513),
  },
  [687] = {
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1928),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [688] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(1928),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [689] = {
    [sym_concatenation] = STATE(945),
    [sym_string] = STATE(1151),
    [sym_simple_expansion] = STATE(1151),
    [sym_string_expansion] = STATE(1151),
    [sym_expansion] = STATE(1151),
    [sym_command_substitution] = STATE(1151),
    [sym_process_substitution] = STATE(1151),
    [sym__special_characters] = ACTIONS(2515),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(2517),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2517),
  },
  [690] = {
    [aux_sym_concatenation_repeat1] = STATE(294),
    [sym__simple_heredoc_body] = ACTIONS(1960),
    [sym__heredoc_body_beginning] = ACTIONS(1960),
    [sym_file_descriptor] = ACTIONS(1960),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1962),
    [anon_sym_RPAREN] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [anon_sym_EQ_TILDE] = ACTIONS(1962),
    [anon_sym_EQ_EQ] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1962),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1962),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [sym__special_characters] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1962),
    [sym_raw_string] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1962),
    [anon_sym_LF] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1962),
  },
  [691] = {
    [aux_sym_concatenation_repeat1] = STATE(294),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_RPAREN] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_EQ_TILDE] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1966),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1966),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [692] = {
    [aux_sym_concatenation_repeat1] = STATE(1152),
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [693] = {
    [aux_sym_concatenation_repeat1] = STATE(1152),
    [sym__simple_heredoc_body] = ACTIONS(749),
    [sym__heredoc_body_beginning] = ACTIONS(749),
    [sym_file_descriptor] = ACTIONS(749),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_LT_LT_DASH] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [694] = {
    [aux_sym_concatenation_repeat1] = STATE(1152),
    [sym__simple_heredoc_body] = ACTIONS(1972),
    [sym__heredoc_body_beginning] = ACTIONS(1972),
    [sym_file_descriptor] = ACTIONS(1972),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_RPAREN] = ACTIONS(1972),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_PIPE_AMP] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_PIPE_PIPE] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_AMP_GT] = ACTIONS(1974),
    [anon_sym_AMP_GT_GT] = ACTIONS(1972),
    [anon_sym_LT_AMP] = ACTIONS(1972),
    [anon_sym_GT_AMP] = ACTIONS(1972),
    [anon_sym_LT_LT] = ACTIONS(1974),
    [anon_sym_LT_LT_DASH] = ACTIONS(1972),
    [anon_sym_LT_LT_LT] = ACTIONS(1972),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1974),
  },
  [695] = {
    [aux_sym_concatenation_repeat1] = STATE(1152),
    [sym__simple_heredoc_body] = ACTIONS(1976),
    [sym__heredoc_body_beginning] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_RPAREN] = ACTIONS(1976),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [696] = {
    [sym_file_redirect] = STATE(696),
    [sym_heredoc_redirect] = STATE(696),
    [sym_herestring_redirect] = STATE(696),
    [aux_sym_while_statement_repeat1] = STATE(696),
    [sym__simple_heredoc_body] = ACTIONS(1984),
    [sym__heredoc_body_beginning] = ACTIONS(1984),
    [sym_file_descriptor] = ACTIONS(2519),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2525),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2525),
    [anon_sym_LT_AMP] = ACTIONS(2525),
    [anon_sym_GT_AMP] = ACTIONS(2525),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_LT_LT_DASH] = ACTIONS(2000),
    [anon_sym_LT_LT_LT] = ACTIONS(2528),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1989),
  },
  [697] = {
    [sym_file_redirect] = STATE(696),
    [sym_heredoc_redirect] = STATE(696),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(696),
    [aux_sym_while_statement_repeat1] = STATE(696),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(557),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [698] = {
    [sym_concatenation] = STATE(698),
    [sym_string] = STATE(305),
    [sym_simple_expansion] = STATE(305),
    [sym_string_expansion] = STATE(305),
    [sym_expansion] = STATE(305),
    [sym_command_substitution] = STATE(305),
    [sym_process_substitution] = STATE(305),
    [aux_sym_command_repeat2] = STATE(698),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_RPAREN] = ACTIONS(1964),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_EQ_TILDE] = ACTIONS(2531),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [anon_sym_DOLLAR] = ACTIONS(2015),
    [sym_raw_string] = ACTIONS(2537),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2024),
    [anon_sym_BQUOTE] = ACTIONS(2027),
    [anon_sym_LT_LPAREN] = ACTIONS(2030),
    [anon_sym_GT_LPAREN] = ACTIONS(2030),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2540),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [699] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2543),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [700] = {
    [sym_file_redirect] = STATE(1154),
    [sym_heredoc_redirect] = STATE(1154),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(1154),
    [sym_concatenation] = STATE(698),
    [sym_string] = STATE(305),
    [sym_simple_expansion] = STATE(305),
    [sym_string_expansion] = STATE(305),
    [sym_expansion] = STATE(305),
    [sym_command_substitution] = STATE(305),
    [sym_process_substitution] = STATE(305),
    [aux_sym_while_statement_repeat1] = STATE(1154),
    [aux_sym_command_repeat2] = STATE(698),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1980),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(557),
    [sym__special_characters] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(563),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [701] = {
    [sym_file_descriptor] = ACTIONS(1071),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1071),
  },
  [702] = {
    [sym_concatenation] = STATE(1156),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_string_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [aux_sym_for_statement_repeat1] = STATE(1156),
    [anon_sym_RPAREN] = ACTIONS(2545),
    [sym__special_characters] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym_raw_string] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1083),
  },
  [703] = {
    [aux_sym_concatenation_repeat1] = STATE(412),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(733),
    [sym_variable_name] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1093),
  },
  [704] = {
    [aux_sym_concatenation_repeat1] = STATE(412),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(733),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1071),
  },
  [705] = {
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1347),
    [anon_sym_EQ_TILDE] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1347),
  },
  [706] = {
    [aux_sym_concatenation_repeat1] = STATE(1157),
    [sym__concat] = ACTIONS(623),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_EQ_TILDE] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(765),
  },
  [707] = {
    [anon_sym_AMP_AMP] = ACTIONS(2547),
    [anon_sym_PIPE_PIPE] = ACTIONS(2547),
    [anon_sym_RBRACK] = ACTIONS(2547),
    [anon_sym_EQ_TILDE] = ACTIONS(2547),
    [anon_sym_EQ_EQ] = ACTIONS(2547),
    [anon_sym_EQ] = ACTIONS(2549),
    [anon_sym_LT] = ACTIONS(2547),
    [anon_sym_GT] = ACTIONS(2547),
    [anon_sym_BANG_EQ] = ACTIONS(2547),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2547),
  },
  [708] = {
    [sym__expression] = STATE(768),
    [sym_binary_expression] = STATE(768),
    [sym_unary_expression] = STATE(768),
    [sym_parenthesized_expression] = STATE(768),
    [sym_concatenation] = STATE(768),
    [sym_string] = STATE(314),
    [sym_simple_expansion] = STATE(314),
    [sym_string_expansion] = STATE(314),
    [sym_expansion] = STATE(314),
    [sym_command_substitution] = STATE(314),
    [sym_process_substitution] = STATE(314),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(573),
    [sym__special_characters] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(579),
    [sym_test_operator] = ACTIONS(581),
  },
  [709] = {
    [sym__expression] = STATE(768),
    [sym_binary_expression] = STATE(768),
    [sym_unary_expression] = STATE(768),
    [sym_parenthesized_expression] = STATE(768),
    [sym_concatenation] = STATE(768),
    [sym_string] = STATE(314),
    [sym_simple_expansion] = STATE(314),
    [sym_string_expansion] = STATE(314),
    [sym_expansion] = STATE(314),
    [sym_command_substitution] = STATE(314),
    [sym_process_substitution] = STATE(314),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(573),
    [sym__special_characters] = ACTIONS(2551),
    [anon_sym_DQUOTE] = ACTIONS(1489),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1491),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1493),
    [anon_sym_BQUOTE] = ACTIONS(1495),
    [anon_sym_LT_LPAREN] = ACTIONS(1497),
    [anon_sym_GT_LPAREN] = ACTIONS(1497),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(579),
    [sym_test_operator] = ACTIONS(573),
    [sym_regex] = ACTIONS(1499),
  },
  [710] = {
    [sym__concat] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_RBRACK] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1724),
    [anon_sym_EQ_EQ] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1724),
    [anon_sym_GT] = ACTIONS(1724),
    [anon_sym_BANG_EQ] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1724),
  },
  [711] = {
    [aux_sym_concatenation_repeat1] = STATE(711),
    [sym__concat] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_RBRACK] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1724),
    [anon_sym_EQ_EQ] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1724),
    [anon_sym_GT] = ACTIONS(1724),
    [anon_sym_BANG_EQ] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1724),
  },
  [712] = {
    [sym__concat] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [anon_sym_RBRACK] = ACTIONS(1731),
    [anon_sym_EQ_TILDE] = ACTIONS(1731),
    [anon_sym_EQ_EQ] = ACTIONS(1731),
    [anon_sym_EQ] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_GT] = ACTIONS(1731),
    [anon_sym_BANG_EQ] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1731),
  },
  [713] = {
    [anon_sym_DQUOTE] = ACTIONS(2556),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [714] = {
    [sym_concatenation] = STATE(1162),
    [sym_string] = STATE(1161),
    [sym_simple_expansion] = STATE(1161),
    [sym_string_expansion] = STATE(1161),
    [sym_expansion] = STATE(1161),
    [sym_command_substitution] = STATE(1161),
    [sym_process_substitution] = STATE(1161),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [sym__special_characters] = ACTIONS(2560),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2562),
  },
  [715] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(2564),
    [sym_comment] = ACTIONS(53),
  },
  [716] = {
    [sym_concatenation] = STATE(1166),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1166),
    [anon_sym_RBRACE] = ACTIONS(2566),
    [anon_sym_EQ] = ACTIONS(2568),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2572),
    [anon_sym_COLON] = ACTIONS(2568),
    [anon_sym_COLON_QMARK] = ACTIONS(2568),
    [anon_sym_COLON_DASH] = ACTIONS(2568),
    [anon_sym_PERCENT] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [717] = {
    [sym_concatenation] = STATE(1168),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1168),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [anon_sym_EQ] = ACTIONS(2574),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2574),
    [anon_sym_COLON_QMARK] = ACTIONS(2574),
    [anon_sym_COLON_DASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2574),
    [anon_sym_DASH] = ACTIONS(2574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [718] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_RBRACK] = ACTIONS(1832),
    [anon_sym_EQ_TILDE] = ACTIONS(1832),
    [anon_sym_EQ_EQ] = ACTIONS(1832),
    [anon_sym_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1832),
    [anon_sym_GT] = ACTIONS(1832),
    [anon_sym_BANG_EQ] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1832),
  },
  [719] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2580),
  },
  [720] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2582),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [721] = {
    [sym__concat] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [anon_sym_RBRACK] = ACTIONS(1876),
    [anon_sym_EQ_TILDE] = ACTIONS(1876),
    [anon_sym_EQ_EQ] = ACTIONS(1876),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_GT] = ACTIONS(1876),
    [anon_sym_BANG_EQ] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1876),
  },
  [722] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2584),
  },
  [723] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [724] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [725] = {
    [sym__concat] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [anon_sym_RBRACK] = ACTIONS(1884),
    [anon_sym_EQ_TILDE] = ACTIONS(1884),
    [anon_sym_EQ_EQ] = ACTIONS(1884),
    [anon_sym_EQ] = ACTIONS(1886),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_BANG_EQ] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1884),
  },
  [726] = {
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2588),
  },
  [727] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2588),
  },
  [728] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [729] = {
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2594),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(2592),
  },
  [730] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2594),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(2592),
  },
  [731] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2596),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [732] = {
    [sym__concat] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [anon_sym_RBRACK] = ACTIONS(1916),
    [anon_sym_EQ_TILDE] = ACTIONS(1916),
    [anon_sym_EQ_EQ] = ACTIONS(1916),
    [anon_sym_EQ] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1916),
    [anon_sym_BANG_EQ] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1916),
  },
  [733] = {
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2596),
    [anon_sym_SEMI_SEMI] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [734] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2596),
    [anon_sym_SEMI_SEMI] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [735] = {
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_RBRACK] = ACTIONS(2602),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_EQ] = ACTIONS(2604),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2602),
  },
  [736] = {
    [anon_sym_LT] = ACTIONS(2606),
    [anon_sym_GT] = ACTIONS(2606),
    [anon_sym_GT_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT] = ACTIONS(2606),
    [anon_sym_AMP_GT_GT] = ACTIONS(2608),
    [anon_sym_LT_AMP] = ACTIONS(2608),
    [anon_sym_GT_AMP] = ACTIONS(2608),
    [sym_comment] = ACTIONS(53),
  },
  [737] = {
    [sym_concatenation] = STATE(1186),
    [sym_string] = STATE(1181),
    [sym_simple_expansion] = STATE(1181),
    [sym_string_expansion] = STATE(1181),
    [sym_expansion] = STATE(1181),
    [sym_command_substitution] = STATE(1181),
    [sym_process_substitution] = STATE(1181),
    [sym__special_characters] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2616),
  },
  [738] = {
    [sym_heredoc_start] = ACTIONS(2626),
    [sym_comment] = ACTIONS(53),
  },
  [739] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(1189),
    [sym_simple_expansion] = STATE(1189),
    [sym_string_expansion] = STATE(1189),
    [sym_expansion] = STATE(1189),
    [sym_command_substitution] = STATE(1189),
    [sym_process_substitution] = STATE(1189),
    [sym__special_characters] = ACTIONS(2628),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2630),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2630),
  },
  [740] = {
    [sym_file_redirect] = STATE(1191),
    [sym_heredoc_redirect] = STATE(1191),
    [sym_herestring_redirect] = STATE(1191),
    [aux_sym_while_statement_repeat1] = STATE(1191),
    [sym_file_descriptor] = ACTIONS(1403),
    [ts_builtin_sym_end] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1409),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_AMP_GT] = ACTIONS(1409),
    [anon_sym_AMP_GT_GT] = ACTIONS(1411),
    [anon_sym_LT_AMP] = ACTIONS(1411),
    [anon_sym_GT_AMP] = ACTIONS(1411),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_LT_LT_DASH] = ACTIONS(1415),
    [anon_sym_LT_LT_LT] = ACTIONS(1417),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [741] = {
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_RBRACK] = ACTIONS(2602),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_EQ] = ACTIONS(2604),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2602),
  },
  [742] = {
    [anon_sym_RPAREN] = ACTIONS(2547),
    [anon_sym_AMP_AMP] = ACTIONS(2547),
    [anon_sym_PIPE_PIPE] = ACTIONS(2547),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2547),
    [anon_sym_EQ_TILDE] = ACTIONS(2547),
    [anon_sym_EQ_EQ] = ACTIONS(2547),
    [anon_sym_EQ] = ACTIONS(2549),
    [anon_sym_LT] = ACTIONS(2547),
    [anon_sym_GT] = ACTIONS(2547),
    [anon_sym_BANG_EQ] = ACTIONS(2547),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2547),
  },
  [743] = {
    [sym__concat] = ACTIONS(1724),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1724),
    [anon_sym_EQ_EQ] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1724),
    [anon_sym_GT] = ACTIONS(1724),
    [anon_sym_BANG_EQ] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1724),
  },
  [744] = {
    [aux_sym_concatenation_repeat1] = STATE(744),
    [sym__concat] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1724),
    [anon_sym_EQ_EQ] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1724),
    [anon_sym_GT] = ACTIONS(1724),
    [anon_sym_BANG_EQ] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1724),
  },
  [745] = {
    [sym__concat] = ACTIONS(1731),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_RPAREN] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1731),
    [anon_sym_EQ_TILDE] = ACTIONS(1731),
    [anon_sym_EQ_EQ] = ACTIONS(1731),
    [anon_sym_EQ] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_GT] = ACTIONS(1731),
    [anon_sym_BANG_EQ] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1731),
  },
  [746] = {
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [747] = {
    [sym_concatenation] = STATE(1196),
    [sym_string] = STATE(1195),
    [sym_simple_expansion] = STATE(1195),
    [sym_string_expansion] = STATE(1195),
    [sym_expansion] = STATE(1195),
    [sym_command_substitution] = STATE(1195),
    [sym_process_substitution] = STATE(1195),
    [anon_sym_RBRACE] = ACTIONS(2641),
    [sym__special_characters] = ACTIONS(2643),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(2645),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2645),
  },
  [748] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(2647),
    [sym_comment] = ACTIONS(53),
  },
  [749] = {
    [sym_concatenation] = STATE(1200),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1200),
    [anon_sym_RBRACE] = ACTIONS(2649),
    [anon_sym_EQ] = ACTIONS(2651),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2655),
    [anon_sym_COLON] = ACTIONS(2651),
    [anon_sym_COLON_QMARK] = ACTIONS(2651),
    [anon_sym_COLON_DASH] = ACTIONS(2651),
    [anon_sym_PERCENT] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2651),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [750] = {
    [sym_concatenation] = STATE(1202),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1202),
    [anon_sym_RBRACE] = ACTIONS(2641),
    [anon_sym_EQ] = ACTIONS(2657),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2661),
    [anon_sym_COLON] = ACTIONS(2657),
    [anon_sym_COLON_QMARK] = ACTIONS(2657),
    [anon_sym_COLON_DASH] = ACTIONS(2657),
    [anon_sym_PERCENT] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [751] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1832),
    [anon_sym_EQ_TILDE] = ACTIONS(1832),
    [anon_sym_EQ_EQ] = ACTIONS(1832),
    [anon_sym_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1832),
    [anon_sym_GT] = ACTIONS(1832),
    [anon_sym_BANG_EQ] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1832),
  },
  [752] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2663),
  },
  [753] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2665),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [754] = {
    [sym__concat] = ACTIONS(1876),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_RPAREN] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1876),
    [anon_sym_EQ_TILDE] = ACTIONS(1876),
    [anon_sym_EQ_EQ] = ACTIONS(1876),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_GT] = ACTIONS(1876),
    [anon_sym_BANG_EQ] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1876),
  },
  [755] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2667),
  },
  [756] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2641),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [757] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2669),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [758] = {
    [sym__concat] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1884),
    [anon_sym_EQ_TILDE] = ACTIONS(1884),
    [anon_sym_EQ_EQ] = ACTIONS(1884),
    [anon_sym_EQ] = ACTIONS(1886),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_BANG_EQ] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1884),
  },
  [759] = {
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2669),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2671),
  },
  [760] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2669),
    [anon_sym_SEMI_SEMI] = ACTIONS(2673),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(2671),
  },
  [761] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2669),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [762] = {
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2677),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(2669),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2677),
    [anon_sym_AMP] = ACTIONS(2675),
  },
  [763] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2677),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(2669),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2677),
    [anon_sym_AMP] = ACTIONS(2675),
  },
  [764] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2679),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [765] = {
    [sym__concat] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_RPAREN] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1916),
    [anon_sym_EQ_TILDE] = ACTIONS(1916),
    [anon_sym_EQ_EQ] = ACTIONS(1916),
    [anon_sym_EQ] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1916),
    [anon_sym_BANG_EQ] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1916),
  },
  [766] = {
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2679),
    [anon_sym_SEMI_SEMI] = ACTIONS(2683),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
  },
  [767] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2679),
    [anon_sym_SEMI_SEMI] = ACTIONS(2683),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
  },
  [768] = {
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2602),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_EQ] = ACTIONS(2604),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2602),
  },
  [769] = {
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2602),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_EQ] = ACTIONS(2604),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2602),
  },
  [770] = {
    [sym_variable_name] = ACTIONS(1071),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1073),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [771] = {
    [sym_concatenation] = STATE(1212),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_string_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [aux_sym_for_statement_repeat1] = STATE(1212),
    [anon_sym_RPAREN] = ACTIONS(2685),
    [sym__special_characters] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym_raw_string] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1083),
  },
  [772] = {
    [aux_sym_concatenation_repeat1] = STATE(368),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(1093),
    [ts_builtin_sym_end] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [773] = {
    [aux_sym_concatenation_repeat1] = STATE(368),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(1071),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1073),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [774] = {
    [sym__concat] = ACTIONS(1724),
    [sym_variable_name] = ACTIONS(1724),
    [ts_builtin_sym_end] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1726),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [775] = {
    [aux_sym_concatenation_repeat1] = STATE(775),
    [sym__concat] = ACTIONS(2687),
    [sym_variable_name] = ACTIONS(1724),
    [ts_builtin_sym_end] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1726),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [776] = {
    [sym__concat] = ACTIONS(1731),
    [sym_variable_name] = ACTIONS(1731),
    [ts_builtin_sym_end] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_RPAREN] = ACTIONS(1731),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [anon_sym_PIPE_AMP] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [sym__special_characters] = ACTIONS(1731),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1731),
    [anon_sym_GT_LPAREN] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1733),
    [sym_word] = ACTIONS(1733),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [777] = {
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [778] = {
    [sym_concatenation] = STATE(1217),
    [sym_string] = STATE(1216),
    [sym_simple_expansion] = STATE(1216),
    [sym_string_expansion] = STATE(1216),
    [sym_expansion] = STATE(1216),
    [sym_command_substitution] = STATE(1216),
    [sym_process_substitution] = STATE(1216),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [sym__special_characters] = ACTIONS(2694),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(2696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2696),
  },
  [779] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(2698),
    [sym_comment] = ACTIONS(53),
  },
  [780] = {
    [sym_concatenation] = STATE(1221),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1221),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_EQ] = ACTIONS(2702),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2706),
    [anon_sym_COLON] = ACTIONS(2702),
    [anon_sym_COLON_QMARK] = ACTIONS(2702),
    [anon_sym_COLON_DASH] = ACTIONS(2702),
    [anon_sym_PERCENT] = ACTIONS(2702),
    [anon_sym_DASH] = ACTIONS(2702),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [781] = {
    [sym_concatenation] = STATE(1223),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1223),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_EQ] = ACTIONS(2708),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2712),
    [anon_sym_COLON] = ACTIONS(2708),
    [anon_sym_COLON_QMARK] = ACTIONS(2708),
    [anon_sym_COLON_DASH] = ACTIONS(2708),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [782] = {
    [sym__concat] = ACTIONS(1832),
    [sym_variable_name] = ACTIONS(1832),
    [ts_builtin_sym_end] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1834),
    [sym_word] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [783] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2714),
  },
  [784] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2716),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [785] = {
    [sym__concat] = ACTIONS(1876),
    [sym_variable_name] = ACTIONS(1876),
    [ts_builtin_sym_end] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_RPAREN] = ACTIONS(1876),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [anon_sym_PIPE_AMP] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [sym__special_characters] = ACTIONS(1876),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [anon_sym_LT_LPAREN] = ACTIONS(1876),
    [anon_sym_GT_LPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1878),
    [sym_word] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [786] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2718),
  },
  [787] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [788] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2720),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [789] = {
    [sym__concat] = ACTIONS(1884),
    [sym_variable_name] = ACTIONS(1884),
    [ts_builtin_sym_end] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [sym__special_characters] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym_raw_string] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(1884),
    [anon_sym_GT_LPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1886),
    [sym_word] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [790] = {
    [anon_sym_SEMI] = ACTIONS(2722),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2720),
    [anon_sym_SEMI_SEMI] = ACTIONS(2724),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2724),
    [anon_sym_AMP] = ACTIONS(2722),
  },
  [791] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2722),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2720),
    [anon_sym_SEMI_SEMI] = ACTIONS(2724),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2724),
    [anon_sym_AMP] = ACTIONS(2722),
  },
  [792] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2720),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [793] = {
    [anon_sym_SEMI] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2728),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(2720),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2726),
  },
  [794] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2728),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(2720),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2726),
  },
  [795] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [796] = {
    [sym__concat] = ACTIONS(1916),
    [sym_variable_name] = ACTIONS(1916),
    [ts_builtin_sym_end] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_RPAREN] = ACTIONS(1916),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [sym__special_characters] = ACTIONS(1916),
    [anon_sym_DQUOTE] = ACTIONS(1916),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1916),
    [anon_sym_GT_LPAREN] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1918),
    [sym_word] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [797] = {
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_SEMI_SEMI] = ACTIONS(2734),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [798] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_SEMI_SEMI] = ACTIONS(2734),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2732),
  },
  [799] = {
    [sym__concat] = ACTIONS(1724),
    [ts_builtin_sym_end] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1726),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [800] = {
    [aux_sym_concatenation_repeat1] = STATE(800),
    [sym__concat] = ACTIONS(2736),
    [ts_builtin_sym_end] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1726),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [801] = {
    [sym__concat] = ACTIONS(1731),
    [ts_builtin_sym_end] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_RPAREN] = ACTIONS(1731),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [anon_sym_PIPE_AMP] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [sym__special_characters] = ACTIONS(1731),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1731),
    [anon_sym_GT_LPAREN] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1733),
    [sym_word] = ACTIONS(1733),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [802] = {
    [anon_sym_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [803] = {
    [sym_concatenation] = STATE(1236),
    [sym_string] = STATE(1235),
    [sym_simple_expansion] = STATE(1235),
    [sym_string_expansion] = STATE(1235),
    [sym_expansion] = STATE(1235),
    [sym_command_substitution] = STATE(1235),
    [sym_process_substitution] = STATE(1235),
    [anon_sym_RBRACE] = ACTIONS(2741),
    [sym__special_characters] = ACTIONS(2743),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(2745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2745),
  },
  [804] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(2747),
    [sym_comment] = ACTIONS(53),
  },
  [805] = {
    [sym_concatenation] = STATE(1240),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1240),
    [anon_sym_RBRACE] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(2751),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2755),
    [anon_sym_COLON] = ACTIONS(2751),
    [anon_sym_COLON_QMARK] = ACTIONS(2751),
    [anon_sym_COLON_DASH] = ACTIONS(2751),
    [anon_sym_PERCENT] = ACTIONS(2751),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [806] = {
    [sym_concatenation] = STATE(1242),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1242),
    [anon_sym_RBRACE] = ACTIONS(2741),
    [anon_sym_EQ] = ACTIONS(2757),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_COLON] = ACTIONS(2757),
    [anon_sym_COLON_QMARK] = ACTIONS(2757),
    [anon_sym_COLON_DASH] = ACTIONS(2757),
    [anon_sym_PERCENT] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [807] = {
    [sym__concat] = ACTIONS(1832),
    [ts_builtin_sym_end] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1834),
    [sym_word] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [808] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2763),
  },
  [809] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [810] = {
    [sym__concat] = ACTIONS(1876),
    [ts_builtin_sym_end] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_RPAREN] = ACTIONS(1876),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [anon_sym_PIPE_AMP] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [sym__special_characters] = ACTIONS(1876),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [anon_sym_LT_LPAREN] = ACTIONS(1876),
    [anon_sym_GT_LPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1878),
    [sym_word] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [811] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2767),
  },
  [812] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2741),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [813] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2769),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [814] = {
    [sym__concat] = ACTIONS(1884),
    [ts_builtin_sym_end] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [sym__special_characters] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym_raw_string] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(1884),
    [anon_sym_GT_LPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1886),
    [sym_word] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [815] = {
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2769),
    [anon_sym_SEMI_SEMI] = ACTIONS(2773),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
  },
  [816] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2769),
    [anon_sym_SEMI_SEMI] = ACTIONS(2773),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
  },
  [817] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2769),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [818] = {
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2777),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(2769),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2775),
  },
  [819] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2777),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(2769),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2775),
  },
  [820] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [821] = {
    [sym__concat] = ACTIONS(1916),
    [ts_builtin_sym_end] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_RPAREN] = ACTIONS(1916),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [sym__special_characters] = ACTIONS(1916),
    [anon_sym_DQUOTE] = ACTIONS(1916),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1916),
    [anon_sym_GT_LPAREN] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1918),
    [sym_word] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [822] = {
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [anon_sym_SEMI_SEMI] = ACTIONS(2783),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2783),
    [anon_sym_AMP] = ACTIONS(2781),
  },
  [823] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [anon_sym_SEMI_SEMI] = ACTIONS(2783),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2783),
    [anon_sym_AMP] = ACTIONS(2781),
  },
  [824] = {
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1724),
    [sym_variable_name] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1724),
  },
  [825] = {
    [aux_sym_concatenation_repeat1] = STATE(825),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(2785),
    [sym_variable_name] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1724),
  },
  [826] = {
    [sym_file_descriptor] = ACTIONS(1731),
    [sym__concat] = ACTIONS(1731),
    [sym_variable_name] = ACTIONS(1731),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1731),
    [anon_sym_AMP_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT_GT] = ACTIONS(1731),
    [anon_sym_LT_AMP] = ACTIONS(1731),
    [anon_sym_GT_AMP] = ACTIONS(1731),
    [sym__special_characters] = ACTIONS(1731),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1731),
    [anon_sym_GT_LPAREN] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1731),
  },
  [827] = {
    [anon_sym_DQUOTE] = ACTIONS(2788),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [828] = {
    [sym_concatenation] = STATE(1255),
    [sym_string] = STATE(1254),
    [sym_simple_expansion] = STATE(1254),
    [sym_string_expansion] = STATE(1254),
    [sym_expansion] = STATE(1254),
    [sym_command_substitution] = STATE(1254),
    [sym_process_substitution] = STATE(1254),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [sym__special_characters] = ACTIONS(2792),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(2794),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2794),
  },
  [829] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(2796),
    [sym_comment] = ACTIONS(53),
  },
  [830] = {
    [sym_concatenation] = STATE(1259),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1259),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_EQ] = ACTIONS(2800),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2802),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2804),
    [anon_sym_COLON] = ACTIONS(2800),
    [anon_sym_COLON_QMARK] = ACTIONS(2800),
    [anon_sym_COLON_DASH] = ACTIONS(2800),
    [anon_sym_PERCENT] = ACTIONS(2800),
    [anon_sym_DASH] = ACTIONS(2800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [831] = {
    [sym_concatenation] = STATE(1261),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1261),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_EQ] = ACTIONS(2806),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2810),
    [anon_sym_COLON] = ACTIONS(2806),
    [anon_sym_COLON_QMARK] = ACTIONS(2806),
    [anon_sym_COLON_DASH] = ACTIONS(2806),
    [anon_sym_PERCENT] = ACTIONS(2806),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [832] = {
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [sym_variable_name] = ACTIONS(1832),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1832),
  },
  [833] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2812),
  },
  [834] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [835] = {
    [sym_file_descriptor] = ACTIONS(1876),
    [sym__concat] = ACTIONS(1876),
    [sym_variable_name] = ACTIONS(1876),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_GT_GT] = ACTIONS(1876),
    [anon_sym_AMP_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT_GT] = ACTIONS(1876),
    [anon_sym_LT_AMP] = ACTIONS(1876),
    [anon_sym_GT_AMP] = ACTIONS(1876),
    [sym__special_characters] = ACTIONS(1876),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [anon_sym_LT_LPAREN] = ACTIONS(1876),
    [anon_sym_GT_LPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1876),
  },
  [836] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2816),
  },
  [837] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [838] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [839] = {
    [sym_file_descriptor] = ACTIONS(1884),
    [sym__concat] = ACTIONS(1884),
    [sym_variable_name] = ACTIONS(1884),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_GT] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT] = ACTIONS(1886),
    [anon_sym_AMP_GT_GT] = ACTIONS(1884),
    [anon_sym_LT_AMP] = ACTIONS(1884),
    [anon_sym_GT_AMP] = ACTIONS(1884),
    [sym__special_characters] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym_raw_string] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(1884),
    [anon_sym_GT_LPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1884),
  },
  [840] = {
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_SEMI_SEMI] = ACTIONS(2822),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2820),
  },
  [841] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_SEMI_SEMI] = ACTIONS(2822),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2820),
  },
  [842] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [843] = {
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2826),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [844] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2826),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2824),
  },
  [845] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [846] = {
    [sym_file_descriptor] = ACTIONS(1916),
    [sym__concat] = ACTIONS(1916),
    [sym_variable_name] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1916),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT_GT] = ACTIONS(1916),
    [anon_sym_LT_AMP] = ACTIONS(1916),
    [anon_sym_GT_AMP] = ACTIONS(1916),
    [sym__special_characters] = ACTIONS(1916),
    [anon_sym_DQUOTE] = ACTIONS(1916),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1916),
    [anon_sym_GT_LPAREN] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1916),
  },
  [847] = {
    [anon_sym_SEMI] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2828),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
  },
  [848] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2828),
    [anon_sym_SEMI_SEMI] = ACTIONS(2832),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
  },
  [849] = {
    [anon_sym_DQUOTE] = ACTIONS(2834),
    [anon_sym_DOLLAR] = ACTIONS(2834),
    [sym__string_content] = ACTIONS(2836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2834),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [sym_comment] = ACTIONS(265),
  },
  [850] = {
    [sym_concatenation] = STATE(1273),
    [sym_string] = STATE(1272),
    [sym_simple_expansion] = STATE(1272),
    [sym_string_expansion] = STATE(1272),
    [sym_expansion] = STATE(1272),
    [sym_command_substitution] = STATE(1272),
    [sym_process_substitution] = STATE(1272),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [sym__special_characters] = ACTIONS(2840),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(2842),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2842),
  },
  [851] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(2844),
    [sym_comment] = ACTIONS(53),
  },
  [852] = {
    [sym_concatenation] = STATE(1277),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1277),
    [anon_sym_RBRACE] = ACTIONS(2846),
    [anon_sym_EQ] = ACTIONS(2848),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2852),
    [anon_sym_COLON] = ACTIONS(2848),
    [anon_sym_COLON_QMARK] = ACTIONS(2848),
    [anon_sym_COLON_DASH] = ACTIONS(2848),
    [anon_sym_PERCENT] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [853] = {
    [sym_concatenation] = STATE(1279),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1279),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_EQ] = ACTIONS(2854),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2858),
    [anon_sym_COLON] = ACTIONS(2854),
    [anon_sym_COLON_QMARK] = ACTIONS(2854),
    [anon_sym_COLON_DASH] = ACTIONS(2854),
    [anon_sym_PERCENT] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(2854),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [854] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym__string_content] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1834),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [sym_comment] = ACTIONS(265),
  },
  [855] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2860),
  },
  [856] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [857] = {
    [sym__concat] = ACTIONS(1876),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym__string_content] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(265),
  },
  [858] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2864),
  },
  [859] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [860] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(2866),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [861] = {
    [sym__concat] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1886),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym__string_content] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1886),
    [anon_sym_BQUOTE] = ACTIONS(1886),
    [sym_comment] = ACTIONS(265),
  },
  [862] = {
    [anon_sym_SEMI] = ACTIONS(2868),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2866),
    [anon_sym_SEMI_SEMI] = ACTIONS(2870),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2870),
    [anon_sym_AMP] = ACTIONS(2868),
  },
  [863] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2868),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2866),
    [anon_sym_SEMI_SEMI] = ACTIONS(2870),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2870),
    [anon_sym_AMP] = ACTIONS(2868),
  },
  [864] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(2866),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [865] = {
    [anon_sym_SEMI] = ACTIONS(2872),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2874),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(2866),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2872),
  },
  [866] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2872),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2874),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(2866),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2872),
  },
  [867] = {
    [sym__simple_heredoc_body] = ACTIONS(2876),
    [sym__heredoc_body_beginning] = ACTIONS(2876),
    [sym_file_descriptor] = ACTIONS(2876),
    [sym__concat] = ACTIONS(2876),
    [ts_builtin_sym_end] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_RPAREN] = ACTIONS(2876),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [anon_sym_EQ_TILDE] = ACTIONS(2878),
    [anon_sym_EQ_EQ] = ACTIONS(2878),
    [anon_sym_LT] = ACTIONS(2878),
    [anon_sym_GT] = ACTIONS(2878),
    [anon_sym_GT_GT] = ACTIONS(2876),
    [anon_sym_AMP_GT] = ACTIONS(2878),
    [anon_sym_AMP_GT_GT] = ACTIONS(2876),
    [anon_sym_LT_AMP] = ACTIONS(2876),
    [anon_sym_GT_AMP] = ACTIONS(2876),
    [anon_sym_LT_LT] = ACTIONS(2878),
    [anon_sym_LT_LT_DASH] = ACTIONS(2876),
    [anon_sym_LT_LT_LT] = ACTIONS(2876),
    [sym__special_characters] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [anon_sym_LT_LPAREN] = ACTIONS(2876),
    [anon_sym_GT_LPAREN] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2878),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2878),
  },
  [868] = {
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [869] = {
    [aux_sym_concatenation_repeat1] = STATE(526),
    [sym__concat] = ACTIONS(2880),
    [anon_sym_RBRACK] = ACTIONS(2882),
    [sym_comment] = ACTIONS(53),
  },
  [870] = {
    [aux_sym_concatenation_repeat1] = STATE(526),
    [sym__concat] = ACTIONS(2884),
    [anon_sym_RBRACK] = ACTIONS(2886),
    [sym_comment] = ACTIONS(53),
  },
  [871] = {
    [sym__concat] = ACTIONS(2888),
    [anon_sym_RBRACK] = ACTIONS(2886),
    [sym_comment] = ACTIONS(53),
  },
  [872] = {
    [sym__simple_heredoc_body] = ACTIONS(2890),
    [sym__heredoc_body_beginning] = ACTIONS(2890),
    [sym_file_descriptor] = ACTIONS(2890),
    [sym__concat] = ACTIONS(2890),
    [ts_builtin_sym_end] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [anon_sym_PIPE_AMP] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_EQ_TILDE] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2890),
    [anon_sym_AMP_GT] = ACTIONS(2892),
    [anon_sym_AMP_GT_GT] = ACTIONS(2890),
    [anon_sym_LT_AMP] = ACTIONS(2890),
    [anon_sym_GT_AMP] = ACTIONS(2890),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_LT_LT_DASH] = ACTIONS(2890),
    [anon_sym_LT_LT_LT] = ACTIONS(2890),
    [sym__special_characters] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [anon_sym_LT_LPAREN] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2892),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2892),
  },
  [873] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2896),
    [sym_comment] = ACTIONS(53),
  },
  [874] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(1296),
    [anon_sym_DQUOTE] = ACTIONS(2898),
    [anon_sym_DOLLAR] = ACTIONS(2900),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [875] = {
    [sym_string] = STATE(1298),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [sym_raw_string] = ACTIONS(2904),
    [anon_sym_POUND] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2906),
    [anon_sym_STAR] = ACTIONS(2908),
    [anon_sym_AT] = ACTIONS(2908),
    [anon_sym_QMARK] = ACTIONS(2908),
    [anon_sym_0] = ACTIONS(2906),
    [anon_sym__] = ACTIONS(2906),
  },
  [876] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2910),
    [sym_comment] = ACTIONS(53),
  },
  [877] = {
    [sym_subscript] = STATE(1304),
    [sym_variable_name] = ACTIONS(2912),
    [anon_sym_BANG] = ACTIONS(2914),
    [anon_sym_DOLLAR] = ACTIONS(2916),
    [anon_sym_POUND] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2916),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2918),
    [anon_sym_STAR] = ACTIONS(2920),
    [anon_sym_AT] = ACTIONS(2920),
    [anon_sym_QMARK] = ACTIONS(2920),
    [anon_sym_0] = ACTIONS(2918),
    [anon_sym__] = ACTIONS(2918),
  },
  [878] = {
    [sym__terminated_statement] = STATE(1307),
    [sym_for_statement] = STATE(1305),
    [sym_c_style_for_statement] = STATE(1305),
    [sym_while_statement] = STATE(1305),
    [sym_if_statement] = STATE(1305),
    [sym_case_statement] = STATE(1305),
    [sym_function_definition] = STATE(1305),
    [sym_subshell] = STATE(1305),
    [sym_pipeline] = STATE(1305),
    [sym_list] = STATE(1305),
    [sym_negated_command] = STATE(1305),
    [sym_test_command] = STATE(1305),
    [sym_declaration_command] = STATE(1305),
    [sym_unset_command] = STATE(1305),
    [sym_command] = STATE(1305),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1306),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(1307),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [879] = {
    [sym__terminated_statement] = STATE(1310),
    [sym_for_statement] = STATE(1308),
    [sym_c_style_for_statement] = STATE(1308),
    [sym_while_statement] = STATE(1308),
    [sym_if_statement] = STATE(1308),
    [sym_case_statement] = STATE(1308),
    [sym_function_definition] = STATE(1308),
    [sym_subshell] = STATE(1308),
    [sym_pipeline] = STATE(1308),
    [sym_list] = STATE(1308),
    [sym_negated_command] = STATE(1308),
    [sym_test_command] = STATE(1308),
    [sym_declaration_command] = STATE(1308),
    [sym_unset_command] = STATE(1308),
    [sym_command] = STATE(1308),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(1309),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1310),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [880] = {
    [sym__terminated_statement] = STATE(1313),
    [sym_for_statement] = STATE(1311),
    [sym_c_style_for_statement] = STATE(1311),
    [sym_while_statement] = STATE(1311),
    [sym_if_statement] = STATE(1311),
    [sym_case_statement] = STATE(1311),
    [sym_function_definition] = STATE(1311),
    [sym_subshell] = STATE(1311),
    [sym_pipeline] = STATE(1311),
    [sym_list] = STATE(1311),
    [sym_negated_command] = STATE(1311),
    [sym_test_command] = STATE(1311),
    [sym_declaration_command] = STATE(1311),
    [sym_unset_command] = STATE(1311),
    [sym_command] = STATE(1311),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1312),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(1313),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [881] = {
    [anon_sym_RBRACE] = ACTIONS(2910),
    [sym_comment] = ACTIONS(53),
  },
  [882] = {
    [sym_concatenation] = STATE(1316),
    [sym_string] = STATE(1315),
    [sym_simple_expansion] = STATE(1315),
    [sym_string_expansion] = STATE(1315),
    [sym_expansion] = STATE(1315),
    [sym_command_substitution] = STATE(1315),
    [sym_process_substitution] = STATE(1315),
    [anon_sym_RBRACE] = ACTIONS(2910),
    [sym__special_characters] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(2924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2924),
  },
  [883] = {
    [sym__simple_heredoc_body] = ACTIONS(2926),
    [sym__heredoc_body_beginning] = ACTIONS(2926),
    [sym_file_descriptor] = ACTIONS(2926),
    [sym__concat] = ACTIONS(2926),
    [ts_builtin_sym_end] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_PIPE] = ACTIONS(2928),
    [anon_sym_RPAREN] = ACTIONS(2926),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE_AMP] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_EQ_TILDE] = ACTIONS(2928),
    [anon_sym_EQ_EQ] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_GT] = ACTIONS(2928),
    [anon_sym_GT_GT] = ACTIONS(2926),
    [anon_sym_AMP_GT] = ACTIONS(2928),
    [anon_sym_AMP_GT_GT] = ACTIONS(2926),
    [anon_sym_LT_AMP] = ACTIONS(2926),
    [anon_sym_GT_AMP] = ACTIONS(2926),
    [anon_sym_LT_LT] = ACTIONS(2928),
    [anon_sym_LT_LT_DASH] = ACTIONS(2926),
    [anon_sym_LT_LT_LT] = ACTIONS(2926),
    [sym__special_characters] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym_raw_string] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [anon_sym_LT_LPAREN] = ACTIONS(2926),
    [anon_sym_GT_LPAREN] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2928),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2928),
  },
  [884] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2930),
  },
  [885] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [886] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(2934),
  },
  [887] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [888] = {
    [sym_string] = STATE(1320),
    [sym_simple_expansion] = STATE(1320),
    [sym_string_expansion] = STATE(1320),
    [sym_expansion] = STATE(1320),
    [sym_command_substitution] = STATE(1320),
    [sym_process_substitution] = STATE(1320),
    [sym__special_characters] = ACTIONS(2936),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(2936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2936),
  },
  [889] = {
    [aux_sym_concatenation_repeat1] = STATE(1321),
    [sym__concat] = ACTIONS(1836),
    [anon_sym_RBRACE] = ACTIONS(765),
    [anon_sym_EQ] = ACTIONS(767),
    [sym__special_characters] = ACTIONS(767),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_POUND] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_COLON_QMARK] = ACTIONS(767),
    [anon_sym_COLON_DASH] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(767),
  },
  [890] = {
    [sym__concat] = ACTIONS(769),
    [anon_sym_RBRACE] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(771),
    [sym__special_characters] = ACTIONS(771),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_POUND] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_COLON] = ACTIONS(771),
    [anon_sym_COLON_QMARK] = ACTIONS(771),
    [anon_sym_COLON_DASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(771),
  },
  [891] = {
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [892] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_DOLLAR] = ACTIONS(2940),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [893] = {
    [sym__concat] = ACTIONS(803),
    [anon_sym_RBRACE] = ACTIONS(803),
    [anon_sym_EQ] = ACTIONS(805),
    [sym__special_characters] = ACTIONS(805),
    [anon_sym_DQUOTE] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_raw_string] = ACTIONS(803),
    [anon_sym_POUND] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [anon_sym_COLON] = ACTIONS(805),
    [anon_sym_COLON_QMARK] = ACTIONS(805),
    [anon_sym_COLON_DASH] = ACTIONS(805),
    [anon_sym_PERCENT] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(805),
  },
  [894] = {
    [sym__concat] = ACTIONS(807),
    [anon_sym_RBRACE] = ACTIONS(807),
    [anon_sym_EQ] = ACTIONS(809),
    [sym__special_characters] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(807),
    [anon_sym_POUND] = ACTIONS(807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(807),
    [anon_sym_COLON] = ACTIONS(809),
    [anon_sym_COLON_QMARK] = ACTIONS(809),
    [anon_sym_COLON_DASH] = ACTIONS(809),
    [anon_sym_PERCENT] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_LT_LPAREN] = ACTIONS(807),
    [anon_sym_GT_LPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(809),
  },
  [895] = {
    [sym__concat] = ACTIONS(811),
    [anon_sym_RBRACE] = ACTIONS(811),
    [anon_sym_EQ] = ACTIONS(813),
    [sym__special_characters] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(813),
    [anon_sym_COLON_QMARK] = ACTIONS(813),
    [anon_sym_COLON_DASH] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_LT_LPAREN] = ACTIONS(811),
    [anon_sym_GT_LPAREN] = ACTIONS(811),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(813),
  },
  [896] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(2942),
    [sym_comment] = ACTIONS(53),
  },
  [897] = {
    [sym_subscript] = STATE(1327),
    [sym_variable_name] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2948),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_AT] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_0] = ACTIONS(2948),
    [anon_sym__] = ACTIONS(2948),
  },
  [898] = {
    [sym_concatenation] = STATE(1330),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1330),
    [anon_sym_RBRACE] = ACTIONS(2952),
    [anon_sym_EQ] = ACTIONS(2954),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2958),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_DASH] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [899] = {
    [sym_concatenation] = STATE(1333),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1333),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_EQ] = ACTIONS(2962),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(2966),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_DASH] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [900] = {
    [sym_concatenation] = STATE(1335),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1335),
    [anon_sym_RBRACE] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(2970),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(2972),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_DASH] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [901] = {
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2976),
    [anon_sym_SEMI_SEMI] = ACTIONS(2978),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2978),
    [anon_sym_AMP] = ACTIONS(2974),
  },
  [902] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2976),
    [anon_sym_SEMI_SEMI] = ACTIONS(2978),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2978),
    [anon_sym_AMP] = ACTIONS(2974),
  },
  [903] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1338),
    [sym_c_style_for_statement] = STATE(1338),
    [sym_while_statement] = STATE(1338),
    [sym_if_statement] = STATE(1338),
    [sym_case_statement] = STATE(1338),
    [sym_function_definition] = STATE(1338),
    [sym_subshell] = STATE(1338),
    [sym_pipeline] = STATE(1338),
    [sym_list] = STATE(1338),
    [sym_negated_command] = STATE(1338),
    [sym_test_command] = STATE(1338),
    [sym_declaration_command] = STATE(1338),
    [sym_unset_command] = STATE(1338),
    [sym_command] = STATE(1338),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1339),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [904] = {
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2982),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(2976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2980),
  },
  [905] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2982),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(2976),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2980),
  },
  [906] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1341),
    [sym_c_style_for_statement] = STATE(1341),
    [sym_while_statement] = STATE(1341),
    [sym_if_statement] = STATE(1341),
    [sym_case_statement] = STATE(1341),
    [sym_function_definition] = STATE(1341),
    [sym_subshell] = STATE(1341),
    [sym_pipeline] = STATE(1341),
    [sym_list] = STATE(1341),
    [sym_negated_command] = STATE(1341),
    [sym_test_command] = STATE(1341),
    [sym_declaration_command] = STATE(1341),
    [sym_unset_command] = STATE(1341),
    [sym_command] = STATE(1341),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(1342),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [907] = {
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2986),
    [anon_sym_SEMI_SEMI] = ACTIONS(2988),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(2984),
  },
  [908] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(2986),
    [anon_sym_SEMI_SEMI] = ACTIONS(2988),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(2984),
  },
  [909] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1345),
    [sym_c_style_for_statement] = STATE(1345),
    [sym_while_statement] = STATE(1345),
    [sym_if_statement] = STATE(1345),
    [sym_case_statement] = STATE(1345),
    [sym_function_definition] = STATE(1345),
    [sym_subshell] = STATE(1345),
    [sym_pipeline] = STATE(1345),
    [sym_list] = STATE(1345),
    [sym_negated_command] = STATE(1345),
    [sym_test_command] = STATE(1345),
    [sym_declaration_command] = STATE(1345),
    [sym_unset_command] = STATE(1345),
    [sym_command] = STATE(1345),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1346),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [910] = {
    [sym__simple_heredoc_body] = ACTIONS(2990),
    [sym__heredoc_body_beginning] = ACTIONS(2990),
    [sym_file_descriptor] = ACTIONS(2990),
    [sym__concat] = ACTIONS(2990),
    [ts_builtin_sym_end] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(2992),
    [anon_sym_RPAREN] = ACTIONS(2990),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [anon_sym_PIPE_AMP] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [anon_sym_EQ_TILDE] = ACTIONS(2992),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(2990),
    [anon_sym_AMP_GT] = ACTIONS(2992),
    [anon_sym_AMP_GT_GT] = ACTIONS(2990),
    [anon_sym_LT_AMP] = ACTIONS(2990),
    [anon_sym_GT_AMP] = ACTIONS(2990),
    [anon_sym_LT_LT] = ACTIONS(2992),
    [anon_sym_LT_LT_DASH] = ACTIONS(2990),
    [anon_sym_LT_LT_LT] = ACTIONS(2990),
    [sym__special_characters] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym_raw_string] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_LT_LPAREN] = ACTIONS(2990),
    [anon_sym_GT_LPAREN] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2992),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2992),
  },
  [911] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(2994),
    [anon_sym_EQ] = ACTIONS(2996),
    [sym__special_characters] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(3002),
    [anon_sym_DOLLAR] = ACTIONS(3005),
    [sym_raw_string] = ACTIONS(3008),
    [anon_sym_POUND] = ACTIONS(3011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3014),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_DASH] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3017),
    [anon_sym_BQUOTE] = ACTIONS(3020),
    [anon_sym_LT_LPAREN] = ACTIONS(3023),
    [anon_sym_GT_LPAREN] = ACTIONS(3023),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3026),
  },
  [912] = {
    [sym_concatenation] = STATE(1347),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1347),
    [anon_sym_RBRACE] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(3029),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3031),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3029),
    [anon_sym_COLON_QMARK] = ACTIONS(3029),
    [anon_sym_COLON_DASH] = ACTIONS(3029),
    [anon_sym_PERCENT] = ACTIONS(3029),
    [anon_sym_DASH] = ACTIONS(3029),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [913] = {
    [sym__simple_heredoc_body] = ACTIONS(3033),
    [sym__heredoc_body_beginning] = ACTIONS(3033),
    [sym_file_descriptor] = ACTIONS(3033),
    [sym__concat] = ACTIONS(3033),
    [ts_builtin_sym_end] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(3033),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [anon_sym_PIPE_AMP] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [anon_sym_EQ_TILDE] = ACTIONS(3035),
    [anon_sym_EQ_EQ] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_GT_GT] = ACTIONS(3033),
    [anon_sym_AMP_GT] = ACTIONS(3035),
    [anon_sym_AMP_GT_GT] = ACTIONS(3033),
    [anon_sym_LT_AMP] = ACTIONS(3033),
    [anon_sym_GT_AMP] = ACTIONS(3033),
    [anon_sym_LT_LT] = ACTIONS(3035),
    [anon_sym_LT_LT_DASH] = ACTIONS(3033),
    [anon_sym_LT_LT_LT] = ACTIONS(3033),
    [sym__special_characters] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [anon_sym_LT_LPAREN] = ACTIONS(3033),
    [anon_sym_GT_LPAREN] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3035),
  },
  [914] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [915] = {
    [sym_file_redirect] = STATE(1349),
    [sym_heredoc_redirect] = STATE(1349),
    [sym_heredoc_body] = STATE(615),
    [sym_herestring_redirect] = STATE(1349),
    [aux_sym_while_statement_repeat1] = STATE(1349),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1197),
    [anon_sym_SEMI_SEMI] = ACTIONS(1195),
    [anon_sym_PIPE_AMP] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_AMP_GT] = ACTIONS(887),
    [anon_sym_AMP_GT_GT] = ACTIONS(889),
    [anon_sym_LT_AMP] = ACTIONS(889),
    [anon_sym_GT_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(891),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1197),
  },
  [916] = {
    [anon_sym_RPAREN] = ACTIONS(3039),
    [sym_comment] = ACTIONS(53),
  },
  [917] = {
    [sym_file_redirect] = STATE(672),
    [sym_file_descriptor] = ACTIONS(3041),
    [anon_sym_SEMI] = ACTIONS(1289),
    [anon_sym_PIPE] = ACTIONS(1289),
    [anon_sym_SEMI_SEMI] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_LT] = ACTIONS(3043),
    [anon_sym_GT] = ACTIONS(3043),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_GT] = ACTIONS(3043),
    [anon_sym_AMP_GT_GT] = ACTIONS(3045),
    [anon_sym_LT_AMP] = ACTIONS(3045),
    [anon_sym_GT_AMP] = ACTIONS(3045),
    [anon_sym_BQUOTE] = ACTIONS(1287),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1289),
  },
  [918] = {
    [sym_file_redirect] = STATE(1356),
    [sym_heredoc_redirect] = STATE(1356),
    [sym_herestring_redirect] = STATE(1356),
    [aux_sym_while_statement_repeat1] = STATE(1356),
    [sym_file_descriptor] = ACTIONS(3047),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_SEMI_SEMI] = ACTIONS(1405),
    [anon_sym_PIPE_AMP] = ACTIONS(1405),
    [anon_sym_AMP_AMP] = ACTIONS(1405),
    [anon_sym_PIPE_PIPE] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_GT_GT] = ACTIONS(3051),
    [anon_sym_AMP_GT] = ACTIONS(3049),
    [anon_sym_AMP_GT_GT] = ACTIONS(3051),
    [anon_sym_LT_AMP] = ACTIONS(3051),
    [anon_sym_GT_AMP] = ACTIONS(3051),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_LT_LT_DASH] = ACTIONS(1415),
    [anon_sym_LT_LT_LT] = ACTIONS(3053),
    [anon_sym_BQUOTE] = ACTIONS(1405),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1405),
    [anon_sym_AMP] = ACTIONS(1407),
  },
  [919] = {
    [sym_compound_statement] = STATE(1357),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [920] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [921] = {
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [922] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [923] = {
    [sym_concatenation] = STATE(945),
    [sym_string] = STATE(1359),
    [sym_simple_expansion] = STATE(1359),
    [sym_string_expansion] = STATE(1359),
    [sym_expansion] = STATE(1359),
    [sym_command_substitution] = STATE(1359),
    [sym_process_substitution] = STATE(1359),
    [sym__special_characters] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(3057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3057),
  },
  [924] = {
    [aux_sym_concatenation_repeat1] = STATE(1360),
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [925] = {
    [aux_sym_concatenation_repeat1] = STATE(1360),
    [sym__simple_heredoc_body] = ACTIONS(749),
    [sym__heredoc_body_beginning] = ACTIONS(749),
    [sym_file_descriptor] = ACTIONS(749),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_LT_LT_DASH] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(749),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [926] = {
    [aux_sym_concatenation_repeat1] = STATE(1360),
    [sym__simple_heredoc_body] = ACTIONS(1972),
    [sym__heredoc_body_beginning] = ACTIONS(1972),
    [sym_file_descriptor] = ACTIONS(1972),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_PIPE_AMP] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_PIPE_PIPE] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_AMP_GT] = ACTIONS(1974),
    [anon_sym_AMP_GT_GT] = ACTIONS(1972),
    [anon_sym_LT_AMP] = ACTIONS(1972),
    [anon_sym_GT_AMP] = ACTIONS(1972),
    [anon_sym_LT_LT] = ACTIONS(1974),
    [anon_sym_LT_LT_DASH] = ACTIONS(1972),
    [anon_sym_LT_LT_LT] = ACTIONS(1972),
    [anon_sym_BQUOTE] = ACTIONS(1972),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1974),
  },
  [927] = {
    [aux_sym_concatenation_repeat1] = STATE(1360),
    [sym__simple_heredoc_body] = ACTIONS(1976),
    [sym__heredoc_body_beginning] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [anon_sym_BQUOTE] = ACTIONS(1976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [928] = {
    [sym_file_redirect] = STATE(928),
    [sym_heredoc_redirect] = STATE(928),
    [sym_herestring_redirect] = STATE(928),
    [aux_sym_while_statement_repeat1] = STATE(928),
    [sym__simple_heredoc_body] = ACTIONS(1984),
    [sym__heredoc_body_beginning] = ACTIONS(1984),
    [sym_file_descriptor] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3062),
    [anon_sym_GT] = ACTIONS(3062),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_AMP_GT] = ACTIONS(3062),
    [anon_sym_AMP_GT_GT] = ACTIONS(3065),
    [anon_sym_LT_AMP] = ACTIONS(3065),
    [anon_sym_GT_AMP] = ACTIONS(3065),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_LT_LT_DASH] = ACTIONS(2000),
    [anon_sym_LT_LT_LT] = ACTIONS(3068),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1989),
  },
  [929] = {
    [sym_file_redirect] = STATE(928),
    [sym_heredoc_redirect] = STATE(928),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(928),
    [aux_sym_while_statement_repeat1] = STATE(928),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_AMP_GT] = ACTIONS(887),
    [anon_sym_AMP_GT_GT] = ACTIONS(889),
    [anon_sym_LT_AMP] = ACTIONS(889),
    [anon_sym_GT_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(891),
    [anon_sym_BQUOTE] = ACTIONS(1980),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [930] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3037),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [931] = {
    [sym_file_redirect] = STATE(1361),
    [sym_heredoc_redirect] = STATE(1361),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(1361),
    [sym_concatenation] = STATE(628),
    [sym_string] = STATE(248),
    [sym_simple_expansion] = STATE(248),
    [sym_string_expansion] = STATE(248),
    [sym_expansion] = STATE(248),
    [sym_command_substitution] = STATE(248),
    [sym_process_substitution] = STATE(248),
    [aux_sym_while_statement_repeat1] = STATE(1361),
    [aux_sym_command_repeat2] = STATE(628),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_EQ_TILDE] = ACTIONS(455),
    [anon_sym_EQ_EQ] = ACTIONS(455),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_AMP_GT] = ACTIONS(887),
    [anon_sym_AMP_GT_GT] = ACTIONS(889),
    [anon_sym_LT_AMP] = ACTIONS(889),
    [anon_sym_GT_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(891),
    [sym__special_characters] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(1980),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(467),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [932] = {
    [sym__simple_heredoc_body] = ACTIONS(3071),
    [sym__heredoc_body_beginning] = ACTIONS(3071),
    [sym_file_descriptor] = ACTIONS(3071),
    [sym__concat] = ACTIONS(3071),
    [ts_builtin_sym_end] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [anon_sym_PIPE_AMP] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_EQ_TILDE] = ACTIONS(3073),
    [anon_sym_EQ_EQ] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_GT_GT] = ACTIONS(3071),
    [anon_sym_AMP_GT] = ACTIONS(3073),
    [anon_sym_AMP_GT_GT] = ACTIONS(3071),
    [anon_sym_LT_AMP] = ACTIONS(3071),
    [anon_sym_GT_AMP] = ACTIONS(3071),
    [anon_sym_LT_LT] = ACTIONS(3073),
    [anon_sym_LT_LT_DASH] = ACTIONS(3071),
    [anon_sym_LT_LT_LT] = ACTIONS(3071),
    [sym__special_characters] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [sym_raw_string] = ACTIONS(3071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_LT_LPAREN] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
  },
  [933] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [934] = {
    [sym_file_redirect] = STATE(1363),
    [sym_file_descriptor] = ACTIONS(1285),
    [ts_builtin_sym_end] = ACTIONS(2460),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_SEMI_SEMI] = ACTIONS(2460),
    [anon_sym_PIPE_AMP] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(1291),
    [anon_sym_GT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_AMP_GT] = ACTIONS(1291),
    [anon_sym_AMP_GT_GT] = ACTIONS(1293),
    [anon_sym_LT_AMP] = ACTIONS(1293),
    [anon_sym_GT_AMP] = ACTIONS(1293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
  },
  [935] = {
    [sym__heredoc_body_middle] = ACTIONS(803),
    [sym__heredoc_body_end] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
  },
  [936] = {
    [sym__heredoc_body_middle] = ACTIONS(811),
    [sym__heredoc_body_end] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
  },
  [937] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(3077),
    [sym_comment] = ACTIONS(53),
  },
  [938] = {
    [sym_subscript] = STATE(1367),
    [sym_variable_name] = ACTIONS(3079),
    [anon_sym_DOLLAR] = ACTIONS(3081),
    [anon_sym_DASH] = ACTIONS(3081),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_AT] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3085),
    [anon_sym_0] = ACTIONS(3083),
    [anon_sym__] = ACTIONS(3083),
  },
  [939] = {
    [sym_concatenation] = STATE(1370),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1370),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3089),
    [anon_sym_COLON_QMARK] = ACTIONS(3089),
    [anon_sym_COLON_DASH] = ACTIONS(3089),
    [anon_sym_PERCENT] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [940] = {
    [sym_concatenation] = STATE(1373),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1373),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_COLON_QMARK] = ACTIONS(3097),
    [anon_sym_COLON_DASH] = ACTIONS(3097),
    [anon_sym_PERCENT] = ACTIONS(3097),
    [anon_sym_DASH] = ACTIONS(3097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [941] = {
    [ts_builtin_sym_end] = ACTIONS(3103),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym_esac] = ACTIONS(3103),
    [anon_sym_PIPE] = ACTIONS(3105),
    [anon_sym_RPAREN] = ACTIONS(3103),
    [anon_sym_SEMI_SEMI] = ACTIONS(3103),
    [anon_sym_PIPE_AMP] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BQUOTE] = ACTIONS(3103),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3105),
  },
  [942] = {
    [sym_simple_expansion] = STATE(942),
    [sym_expansion] = STATE(942),
    [aux_sym_heredoc_body_repeat1] = STATE(942),
    [sym__heredoc_body_middle] = ACTIONS(3107),
    [sym__heredoc_body_end] = ACTIONS(3110),
    [anon_sym_DOLLAR] = ACTIONS(3112),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3115),
    [sym_comment] = ACTIONS(53),
  },
  [943] = {
    [aux_sym_concatenation_repeat1] = STATE(946),
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [944] = {
    [aux_sym_concatenation_repeat1] = STATE(946),
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [945] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_esac] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [946] = {
    [aux_sym_concatenation_repeat1] = STATE(1374),
    [sym__simple_heredoc_body] = ACTIONS(765),
    [sym__heredoc_body_beginning] = ACTIONS(765),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(249),
    [ts_builtin_sym_end] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [947] = {
    [ts_builtin_sym_end] = ACTIONS(3118),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_esac] = ACTIONS(3118),
    [anon_sym_PIPE] = ACTIONS(3120),
    [anon_sym_RPAREN] = ACTIONS(3118),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_PIPE_AMP] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [anon_sym_BQUOTE] = ACTIONS(3118),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3120),
  },
  [948] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_done] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_fi] = ACTIONS(905),
    [anon_sym_elif] = ACTIONS(905),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [949] = {
    [sym_file_redirect] = STATE(517),
    [sym_heredoc_redirect] = STATE(517),
    [sym_heredoc_body] = STATE(1375),
    [sym_herestring_redirect] = STATE(517),
    [aux_sym_while_statement_repeat1] = STATE(517),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(3118),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3120),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_PIPE_AMP] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(341),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3120),
  },
  [950] = {
    [sym__concat] = ACTIONS(3122),
    [anon_sym_EQ] = ACTIONS(3124),
    [anon_sym_PLUS_EQ] = ACTIONS(3124),
    [sym_comment] = ACTIONS(53),
  },
  [951] = {
    [anon_sym_EQ] = ACTIONS(3124),
    [anon_sym_PLUS_EQ] = ACTIONS(3124),
    [sym_comment] = ACTIONS(53),
  },
  [952] = {
    [aux_sym_concatenation_repeat1] = STATE(952),
    [sym__concat] = ACTIONS(2553),
    [anon_sym_RBRACK] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
  },
  [953] = {
    [sym__concat] = ACTIONS(3126),
    [anon_sym_EQ] = ACTIONS(3128),
    [anon_sym_PLUS_EQ] = ACTIONS(3128),
    [sym_comment] = ACTIONS(53),
  },
  [954] = {
    [anon_sym_EQ] = ACTIONS(3128),
    [anon_sym_PLUS_EQ] = ACTIONS(3128),
    [sym_comment] = ACTIONS(53),
  },
  [955] = {
    [sym_string] = STATE(1378),
    [sym_simple_expansion] = STATE(1378),
    [sym_string_expansion] = STATE(1378),
    [sym_expansion] = STATE(1378),
    [sym_command_substitution] = STATE(1378),
    [sym_process_substitution] = STATE(1378),
    [sym__special_characters] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym_raw_string] = ACTIONS(3130),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3130),
  },
  [956] = {
    [aux_sym_concatenation_repeat1] = STATE(1379),
    [sym__concat] = ACTIONS(2060),
    [anon_sym_RPAREN] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(765),
  },
  [957] = {
    [sym__concat] = ACTIONS(769),
    [anon_sym_RPAREN] = ACTIONS(769),
    [sym__special_characters] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(769),
  },
  [958] = {
    [anon_sym_DQUOTE] = ACTIONS(3132),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [959] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(3132),
    [anon_sym_DOLLAR] = ACTIONS(3134),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [960] = {
    [sym__concat] = ACTIONS(803),
    [anon_sym_RPAREN] = ACTIONS(803),
    [sym__special_characters] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_raw_string] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(803),
  },
  [961] = {
    [sym__concat] = ACTIONS(807),
    [anon_sym_RPAREN] = ACTIONS(807),
    [sym__special_characters] = ACTIONS(807),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(807),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_LT_LPAREN] = ACTIONS(807),
    [anon_sym_GT_LPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(807),
  },
  [962] = {
    [sym__concat] = ACTIONS(811),
    [anon_sym_RPAREN] = ACTIONS(811),
    [sym__special_characters] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_LT_LPAREN] = ACTIONS(811),
    [anon_sym_GT_LPAREN] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(811),
  },
  [963] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(3136),
    [sym_comment] = ACTIONS(53),
  },
  [964] = {
    [sym_subscript] = STATE(1385),
    [sym_variable_name] = ACTIONS(3138),
    [anon_sym_DOLLAR] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3140),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3142),
    [anon_sym_STAR] = ACTIONS(3144),
    [anon_sym_AT] = ACTIONS(3144),
    [anon_sym_QMARK] = ACTIONS(3144),
    [anon_sym_0] = ACTIONS(3142),
    [anon_sym__] = ACTIONS(3142),
  },
  [965] = {
    [sym_concatenation] = STATE(1388),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1388),
    [anon_sym_RBRACE] = ACTIONS(3146),
    [anon_sym_EQ] = ACTIONS(3148),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3150),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_COLON] = ACTIONS(3148),
    [anon_sym_COLON_QMARK] = ACTIONS(3148),
    [anon_sym_COLON_DASH] = ACTIONS(3148),
    [anon_sym_PERCENT] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [966] = {
    [sym_concatenation] = STATE(1391),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1391),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3156),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3158),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3160),
    [anon_sym_COLON] = ACTIONS(3156),
    [anon_sym_COLON_QMARK] = ACTIONS(3156),
    [anon_sym_COLON_DASH] = ACTIONS(3156),
    [anon_sym_PERCENT] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [967] = {
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3164),
    [anon_sym_SEMI_SEMI] = ACTIONS(3166),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3162),
  },
  [968] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3164),
    [anon_sym_SEMI_SEMI] = ACTIONS(3166),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3162),
  },
  [969] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1394),
    [sym_c_style_for_statement] = STATE(1394),
    [sym_while_statement] = STATE(1394),
    [sym_if_statement] = STATE(1394),
    [sym_case_statement] = STATE(1394),
    [sym_function_definition] = STATE(1394),
    [sym_subshell] = STATE(1394),
    [sym_pipeline] = STATE(1394),
    [sym_list] = STATE(1394),
    [sym_negated_command] = STATE(1394),
    [sym_test_command] = STATE(1394),
    [sym_declaration_command] = STATE(1394),
    [sym_unset_command] = STATE(1394),
    [sym_command] = STATE(1394),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1395),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [970] = {
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(3170),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(3164),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3168),
  },
  [971] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(3170),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(3164),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3168),
  },
  [972] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1397),
    [sym_c_style_for_statement] = STATE(1397),
    [sym_while_statement] = STATE(1397),
    [sym_if_statement] = STATE(1397),
    [sym_case_statement] = STATE(1397),
    [sym_function_definition] = STATE(1397),
    [sym_subshell] = STATE(1397),
    [sym_pipeline] = STATE(1397),
    [sym_list] = STATE(1397),
    [sym_negated_command] = STATE(1397),
    [sym_test_command] = STATE(1397),
    [sym_declaration_command] = STATE(1397),
    [sym_unset_command] = STATE(1397),
    [sym_command] = STATE(1397),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(1398),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [973] = {
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3174),
    [anon_sym_SEMI_SEMI] = ACTIONS(3176),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3176),
    [anon_sym_AMP] = ACTIONS(3172),
  },
  [974] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3174),
    [anon_sym_SEMI_SEMI] = ACTIONS(3176),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3176),
    [anon_sym_AMP] = ACTIONS(3172),
  },
  [975] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1401),
    [sym_c_style_for_statement] = STATE(1401),
    [sym_while_statement] = STATE(1401),
    [sym_if_statement] = STATE(1401),
    [sym_case_statement] = STATE(1401),
    [sym_function_definition] = STATE(1401),
    [sym_subshell] = STATE(1401),
    [sym_pipeline] = STATE(1401),
    [sym_list] = STATE(1401),
    [sym_negated_command] = STATE(1401),
    [sym_test_command] = STATE(1401),
    [sym_declaration_command] = STATE(1401),
    [sym_unset_command] = STATE(1401),
    [sym_command] = STATE(1401),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1402),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [976] = {
    [sym_file_descriptor] = ACTIONS(3178),
    [sym_variable_name] = ACTIONS(3178),
    [ts_builtin_sym_end] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym_PIPE] = ACTIONS(3180),
    [anon_sym_RPAREN] = ACTIONS(3178),
    [anon_sym_SEMI_SEMI] = ACTIONS(3178),
    [anon_sym_PIPE_AMP] = ACTIONS(3178),
    [anon_sym_AMP_AMP] = ACTIONS(3178),
    [anon_sym_PIPE_PIPE] = ACTIONS(3178),
    [anon_sym_LT] = ACTIONS(3180),
    [anon_sym_GT] = ACTIONS(3180),
    [anon_sym_GT_GT] = ACTIONS(3178),
    [anon_sym_AMP_GT] = ACTIONS(3180),
    [anon_sym_AMP_GT_GT] = ACTIONS(3178),
    [anon_sym_LT_AMP] = ACTIONS(3178),
    [anon_sym_GT_AMP] = ACTIONS(3178),
    [sym__special_characters] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_DOLLAR] = ACTIONS(3180),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3178),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3178),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(3178),
    [anon_sym_GT_LPAREN] = ACTIONS(3178),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3180),
    [anon_sym_LF] = ACTIONS(3178),
    [anon_sym_AMP] = ACTIONS(3180),
  },
  [977] = {
    [sym_concatenation] = STATE(977),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_string_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [aux_sym_for_statement_repeat1] = STATE(977),
    [anon_sym_RPAREN] = ACTIONS(3182),
    [sym__special_characters] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [anon_sym_DOLLAR] = ACTIONS(3190),
    [sym_raw_string] = ACTIONS(3193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3199),
    [anon_sym_BQUOTE] = ACTIONS(3202),
    [anon_sym_LT_LPAREN] = ACTIONS(3205),
    [anon_sym_GT_LPAREN] = ACTIONS(3205),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3193),
  },
  [978] = {
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1724),
    [sym_variable_name] = ACTIONS(1724),
    [ts_builtin_sym_end] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [979] = {
    [aux_sym_concatenation_repeat1] = STATE(979),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(3208),
    [sym_variable_name] = ACTIONS(1724),
    [ts_builtin_sym_end] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [980] = {
    [sym_file_descriptor] = ACTIONS(1731),
    [sym__concat] = ACTIONS(1731),
    [sym_variable_name] = ACTIONS(1731),
    [ts_builtin_sym_end] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_RPAREN] = ACTIONS(1731),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [anon_sym_PIPE_AMP] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1731),
    [anon_sym_AMP_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT_GT] = ACTIONS(1731),
    [anon_sym_LT_AMP] = ACTIONS(1731),
    [anon_sym_GT_AMP] = ACTIONS(1731),
    [sym__special_characters] = ACTIONS(1731),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1731),
    [anon_sym_GT_LPAREN] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1733),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [981] = {
    [anon_sym_DQUOTE] = ACTIONS(3211),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [982] = {
    [sym_concatenation] = STATE(1407),
    [sym_string] = STATE(1406),
    [sym_simple_expansion] = STATE(1406),
    [sym_string_expansion] = STATE(1406),
    [sym_expansion] = STATE(1406),
    [sym_command_substitution] = STATE(1406),
    [sym_process_substitution] = STATE(1406),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [sym__special_characters] = ACTIONS(3215),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3217),
  },
  [983] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(3219),
    [sym_comment] = ACTIONS(53),
  },
  [984] = {
    [sym_concatenation] = STATE(1411),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1411),
    [anon_sym_RBRACE] = ACTIONS(3221),
    [anon_sym_EQ] = ACTIONS(3223),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3227),
    [anon_sym_COLON] = ACTIONS(3223),
    [anon_sym_COLON_QMARK] = ACTIONS(3223),
    [anon_sym_COLON_DASH] = ACTIONS(3223),
    [anon_sym_PERCENT] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [985] = {
    [sym_concatenation] = STATE(1413),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1413),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3229),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3233),
    [anon_sym_COLON] = ACTIONS(3229),
    [anon_sym_COLON_QMARK] = ACTIONS(3229),
    [anon_sym_COLON_DASH] = ACTIONS(3229),
    [anon_sym_PERCENT] = ACTIONS(3229),
    [anon_sym_DASH] = ACTIONS(3229),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [986] = {
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [sym_variable_name] = ACTIONS(1832),
    [ts_builtin_sym_end] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [987] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3235),
  },
  [988] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3237),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [989] = {
    [sym_file_descriptor] = ACTIONS(1876),
    [sym__concat] = ACTIONS(1876),
    [sym_variable_name] = ACTIONS(1876),
    [ts_builtin_sym_end] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_RPAREN] = ACTIONS(1876),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [anon_sym_PIPE_AMP] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_GT_GT] = ACTIONS(1876),
    [anon_sym_AMP_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT_GT] = ACTIONS(1876),
    [anon_sym_LT_AMP] = ACTIONS(1876),
    [anon_sym_GT_AMP] = ACTIONS(1876),
    [sym__special_characters] = ACTIONS(1876),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [anon_sym_LT_LPAREN] = ACTIONS(1876),
    [anon_sym_GT_LPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [990] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3239),
  },
  [991] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [992] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3241),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [993] = {
    [sym_file_descriptor] = ACTIONS(1884),
    [sym__concat] = ACTIONS(1884),
    [sym_variable_name] = ACTIONS(1884),
    [ts_builtin_sym_end] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_GT] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT] = ACTIONS(1886),
    [anon_sym_AMP_GT_GT] = ACTIONS(1884),
    [anon_sym_LT_AMP] = ACTIONS(1884),
    [anon_sym_GT_AMP] = ACTIONS(1884),
    [sym__special_characters] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym_raw_string] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(1884),
    [anon_sym_GT_LPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [994] = {
    [anon_sym_SEMI] = ACTIONS(3243),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3241),
    [anon_sym_SEMI_SEMI] = ACTIONS(3245),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3243),
  },
  [995] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3243),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3241),
    [anon_sym_SEMI_SEMI] = ACTIONS(3245),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3243),
  },
  [996] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3241),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [997] = {
    [anon_sym_SEMI] = ACTIONS(3247),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(3249),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(3241),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3249),
    [anon_sym_AMP] = ACTIONS(3247),
  },
  [998] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3247),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(3249),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(3241),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3249),
    [anon_sym_AMP] = ACTIONS(3247),
  },
  [999] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3251),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1000] = {
    [sym_file_descriptor] = ACTIONS(1916),
    [sym__concat] = ACTIONS(1916),
    [sym_variable_name] = ACTIONS(1916),
    [ts_builtin_sym_end] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_RPAREN] = ACTIONS(1916),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1916),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT_GT] = ACTIONS(1916),
    [anon_sym_LT_AMP] = ACTIONS(1916),
    [anon_sym_GT_AMP] = ACTIONS(1916),
    [sym__special_characters] = ACTIONS(1916),
    [anon_sym_DQUOTE] = ACTIONS(1916),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1916),
    [anon_sym_GT_LPAREN] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [1001] = {
    [anon_sym_SEMI] = ACTIONS(3253),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3251),
    [anon_sym_SEMI_SEMI] = ACTIONS(3255),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3255),
    [anon_sym_AMP] = ACTIONS(3253),
  },
  [1002] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3253),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3251),
    [anon_sym_SEMI_SEMI] = ACTIONS(3255),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3255),
    [anon_sym_AMP] = ACTIONS(3253),
  },
  [1003] = {
    [sym_do_group] = STATE(1424),
    [sym_compound_statement] = STATE(1424),
    [anon_sym_SEMI] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [sym_comment] = ACTIONS(53),
  },
  [1004] = {
    [sym__expression] = STATE(1425),
    [sym_binary_expression] = STATE(1425),
    [sym_unary_expression] = STATE(1425),
    [sym_parenthesized_expression] = STATE(1425),
    [sym_concatenation] = STATE(1425),
    [sym_string] = STATE(314),
    [sym_simple_expansion] = STATE(314),
    [sym_string_expansion] = STATE(314),
    [sym_expansion] = STATE(314),
    [sym_command_substitution] = STATE(314),
    [sym_process_substitution] = STATE(314),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(573),
    [sym__special_characters] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(579),
    [sym_test_operator] = ACTIONS(581),
  },
  [1005] = {
    [sym__expression] = STATE(1426),
    [sym_binary_expression] = STATE(1426),
    [sym_unary_expression] = STATE(1426),
    [sym_parenthesized_expression] = STATE(1426),
    [sym_concatenation] = STATE(1426),
    [sym_string] = STATE(1009),
    [sym_simple_expansion] = STATE(1009),
    [sym_string_expansion] = STATE(1009),
    [sym_expansion] = STATE(1009),
    [sym_command_substitution] = STATE(1009),
    [sym_process_substitution] = STATE(1009),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2146),
    [sym__special_characters] = ACTIONS(2148),
    [anon_sym_DQUOTE] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [sym_raw_string] = ACTIONS(2154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2158),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [anon_sym_LT_LPAREN] = ACTIONS(2162),
    [anon_sym_GT_LPAREN] = ACTIONS(2162),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2164),
    [sym_test_operator] = ACTIONS(2166),
  },
  [1006] = {
    [aux_sym_concatenation_repeat1] = STATE(1428),
    [sym__concat] = ACTIONS(3261),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_EQ_TILDE] = ACTIONS(585),
    [anon_sym_EQ_EQ] = ACTIONS(585),
    [anon_sym_EQ] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(585),
    [anon_sym_BANG_EQ] = ACTIONS(585),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(585),
  },
  [1007] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(1431),
    [anon_sym_DQUOTE] = ACTIONS(3263),
    [anon_sym_DOLLAR] = ACTIONS(3265),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [1008] = {
    [sym_string] = STATE(1433),
    [anon_sym_DQUOTE] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(3267),
    [sym_raw_string] = ACTIONS(3269),
    [anon_sym_POUND] = ACTIONS(3267),
    [anon_sym_DASH] = ACTIONS(3267),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3271),
    [anon_sym_STAR] = ACTIONS(3273),
    [anon_sym_AT] = ACTIONS(3273),
    [anon_sym_QMARK] = ACTIONS(3273),
    [anon_sym_0] = ACTIONS(3271),
    [anon_sym__] = ACTIONS(3271),
  },
  [1009] = {
    [aux_sym_concatenation_repeat1] = STATE(1428),
    [sym__concat] = ACTIONS(3261),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [anon_sym_EQ_TILDE] = ACTIONS(601),
    [anon_sym_EQ_EQ] = ACTIONS(601),
    [anon_sym_EQ] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_GT] = ACTIONS(601),
    [anon_sym_BANG_EQ] = ACTIONS(601),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(601),
  },
  [1010] = {
    [sym_subscript] = STATE(1438),
    [sym_variable_name] = ACTIONS(3275),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_DOLLAR] = ACTIONS(3279),
    [anon_sym_POUND] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3279),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3281),
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_AT] = ACTIONS(3283),
    [anon_sym_QMARK] = ACTIONS(3283),
    [anon_sym_0] = ACTIONS(3281),
    [anon_sym__] = ACTIONS(3281),
  },
  [1011] = {
    [sym__terminated_statement] = STATE(1441),
    [sym_for_statement] = STATE(1439),
    [sym_c_style_for_statement] = STATE(1439),
    [sym_while_statement] = STATE(1439),
    [sym_if_statement] = STATE(1439),
    [sym_case_statement] = STATE(1439),
    [sym_function_definition] = STATE(1439),
    [sym_subshell] = STATE(1439),
    [sym_pipeline] = STATE(1439),
    [sym_list] = STATE(1439),
    [sym_negated_command] = STATE(1439),
    [sym_test_command] = STATE(1439),
    [sym_declaration_command] = STATE(1439),
    [sym_unset_command] = STATE(1439),
    [sym_command] = STATE(1439),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1440),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(1441),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1012] = {
    [sym__terminated_statement] = STATE(1444),
    [sym_for_statement] = STATE(1442),
    [sym_c_style_for_statement] = STATE(1442),
    [sym_while_statement] = STATE(1442),
    [sym_if_statement] = STATE(1442),
    [sym_case_statement] = STATE(1442),
    [sym_function_definition] = STATE(1442),
    [sym_subshell] = STATE(1442),
    [sym_pipeline] = STATE(1442),
    [sym_list] = STATE(1442),
    [sym_negated_command] = STATE(1442),
    [sym_test_command] = STATE(1442),
    [sym_declaration_command] = STATE(1442),
    [sym_unset_command] = STATE(1442),
    [sym_command] = STATE(1442),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(1443),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1444),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [1013] = {
    [sym__terminated_statement] = STATE(1447),
    [sym_for_statement] = STATE(1445),
    [sym_c_style_for_statement] = STATE(1445),
    [sym_while_statement] = STATE(1445),
    [sym_if_statement] = STATE(1445),
    [sym_case_statement] = STATE(1445),
    [sym_function_definition] = STATE(1445),
    [sym_subshell] = STATE(1445),
    [sym_pipeline] = STATE(1445),
    [sym_list] = STATE(1445),
    [sym_negated_command] = STATE(1445),
    [sym_test_command] = STATE(1445),
    [sym_declaration_command] = STATE(1445),
    [sym_unset_command] = STATE(1445),
    [sym_command] = STATE(1445),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1446),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(1447),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1014] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_PIPE_PIPE] = ACTIONS(3287),
    [anon_sym_EQ_TILDE] = ACTIONS(3289),
    [anon_sym_EQ_EQ] = ACTIONS(3289),
    [anon_sym_EQ] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3287),
    [anon_sym_BANG_EQ] = ACTIONS(3287),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3287),
  },
  [1015] = {
    [sym__expression] = STATE(1451),
    [sym_binary_expression] = STATE(1451),
    [sym_unary_expression] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_concatenation] = STATE(1451),
    [sym_string] = STATE(1009),
    [sym_simple_expansion] = STATE(1009),
    [sym_string_expansion] = STATE(1009),
    [sym_expansion] = STATE(1009),
    [sym_command_substitution] = STATE(1009),
    [sym_process_substitution] = STATE(1009),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2146),
    [sym__special_characters] = ACTIONS(2148),
    [anon_sym_DQUOTE] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [sym_raw_string] = ACTIONS(2154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2158),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [anon_sym_LT_LPAREN] = ACTIONS(2162),
    [anon_sym_GT_LPAREN] = ACTIONS(2162),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2164),
    [sym_test_operator] = ACTIONS(2166),
  },
  [1016] = {
    [anon_sym_SEMI] = ACTIONS(2549),
    [anon_sym_SEMI_SEMI] = ACTIONS(2547),
    [anon_sym_AMP_AMP] = ACTIONS(2547),
    [anon_sym_PIPE_PIPE] = ACTIONS(2547),
    [anon_sym_EQ_TILDE] = ACTIONS(2547),
    [anon_sym_EQ_EQ] = ACTIONS(2547),
    [anon_sym_EQ] = ACTIONS(2549),
    [anon_sym_LT] = ACTIONS(2547),
    [anon_sym_GT] = ACTIONS(2547),
    [anon_sym_BANG_EQ] = ACTIONS(2547),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2547),
    [anon_sym_LF] = ACTIONS(2547),
    [anon_sym_AMP] = ACTIONS(2549),
  },
  [1017] = {
    [sym__concat] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1724),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1724),
    [anon_sym_EQ_EQ] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1724),
    [anon_sym_GT] = ACTIONS(1724),
    [anon_sym_BANG_EQ] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1724),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1018] = {
    [aux_sym_concatenation_repeat1] = STATE(1018),
    [sym__concat] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1724),
    [anon_sym_EQ_EQ] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1724),
    [anon_sym_GT] = ACTIONS(1724),
    [anon_sym_BANG_EQ] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1724),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1019] = {
    [sym__concat] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_esac] = ACTIONS(1731),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [anon_sym_PIPE_AMP] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [anon_sym_EQ_TILDE] = ACTIONS(1731),
    [anon_sym_EQ_EQ] = ACTIONS(1731),
    [anon_sym_EQ] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_GT] = ACTIONS(1731),
    [anon_sym_BANG_EQ] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1731),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [1020] = {
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [1021] = {
    [sym_concatenation] = STATE(1456),
    [sym_string] = STATE(1455),
    [sym_simple_expansion] = STATE(1455),
    [sym_string_expansion] = STATE(1455),
    [sym_expansion] = STATE(1455),
    [sym_command_substitution] = STATE(1455),
    [sym_process_substitution] = STATE(1455),
    [anon_sym_RBRACE] = ACTIONS(3298),
    [sym__special_characters] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3302),
  },
  [1022] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(3304),
    [sym_comment] = ACTIONS(53),
  },
  [1023] = {
    [sym_concatenation] = STATE(1460),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1460),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_EQ] = ACTIONS(3308),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_DASH] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1024] = {
    [sym_concatenation] = STATE(1462),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1462),
    [anon_sym_RBRACE] = ACTIONS(3298),
    [anon_sym_EQ] = ACTIONS(3314),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3316),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_DASH] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1025] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_esac] = ACTIONS(1832),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_EQ_TILDE] = ACTIONS(1832),
    [anon_sym_EQ_EQ] = ACTIONS(1832),
    [anon_sym_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1832),
    [anon_sym_GT] = ACTIONS(1832),
    [anon_sym_BANG_EQ] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1832),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [1026] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3320),
  },
  [1027] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3322),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1028] = {
    [sym__concat] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1876),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [anon_sym_PIPE_AMP] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [anon_sym_EQ_TILDE] = ACTIONS(1876),
    [anon_sym_EQ_EQ] = ACTIONS(1876),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_GT] = ACTIONS(1876),
    [anon_sym_BANG_EQ] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1876),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [1029] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3324),
  },
  [1030] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3298),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1031] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3326),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1032] = {
    [sym__concat] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_esac] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [anon_sym_EQ_TILDE] = ACTIONS(1884),
    [anon_sym_EQ_EQ] = ACTIONS(1884),
    [anon_sym_EQ] = ACTIONS(1886),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_BANG_EQ] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1884),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [1033] = {
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3326),
    [anon_sym_SEMI_SEMI] = ACTIONS(3330),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3328),
  },
  [1034] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3326),
    [anon_sym_SEMI_SEMI] = ACTIONS(3330),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3328),
  },
  [1035] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3326),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1036] = {
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(3334),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(3326),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3332),
  },
  [1037] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(3334),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(3326),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3332),
  },
  [1038] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1039] = {
    [sym__concat] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_esac] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [anon_sym_EQ_TILDE] = ACTIONS(1916),
    [anon_sym_EQ_EQ] = ACTIONS(1916),
    [anon_sym_EQ] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1916),
    [anon_sym_BANG_EQ] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1916),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [1040] = {
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [anon_sym_SEMI_SEMI] = ACTIONS(3340),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3338),
  },
  [1041] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [anon_sym_SEMI_SEMI] = ACTIONS(3340),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3340),
    [anon_sym_AMP] = ACTIONS(3338),
  },
  [1042] = {
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym_SEMI_SEMI] = ACTIONS(3344),
    [anon_sym_AMP_AMP] = ACTIONS(1153),
    [anon_sym_PIPE_PIPE] = ACTIONS(1153),
    [anon_sym_EQ_TILDE] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(1153),
    [anon_sym_BANG_EQ] = ACTIONS(1153),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1153),
    [anon_sym_LF] = ACTIONS(3344),
    [anon_sym_AMP] = ACTIONS(3342),
  },
  [1043] = {
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_EQ] = ACTIONS(2604),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2604),
  },
  [1044] = {
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_EQ] = ACTIONS(2604),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2604),
  },
  [1045] = {
    [sym_string] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_command_substitution] = STATE(1472),
    [sym_process_substitution] = STATE(1472),
    [sym__special_characters] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(1161),
    [anon_sym_DOLLAR] = ACTIONS(1163),
    [sym_raw_string] = ACTIONS(3346),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1167),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1171),
    [anon_sym_LT_LPAREN] = ACTIONS(1173),
    [anon_sym_GT_LPAREN] = ACTIONS(1173),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3346),
  },
  [1046] = {
    [aux_sym_concatenation_repeat1] = STATE(1473),
    [sym__concat] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(765),
  },
  [1047] = {
    [sym__concat] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [sym__special_characters] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
  },
  [1048] = {
    [anon_sym_DQUOTE] = ACTIONS(3348),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [1049] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(3348),
    [anon_sym_DOLLAR] = ACTIONS(3350),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [1050] = {
    [sym__concat] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [sym__special_characters] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_raw_string] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(805),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(803),
  },
  [1051] = {
    [sym__concat] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [sym__special_characters] = ACTIONS(807),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(807),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_LT_LPAREN] = ACTIONS(807),
    [anon_sym_GT_LPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(809),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(807),
  },
  [1052] = {
    [sym__concat] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [sym__special_characters] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_LT_LPAREN] = ACTIONS(811),
    [anon_sym_GT_LPAREN] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(813),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(811),
  },
  [1053] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(3352),
    [sym_comment] = ACTIONS(53),
  },
  [1054] = {
    [sym_subscript] = STATE(1479),
    [sym_variable_name] = ACTIONS(3354),
    [anon_sym_DOLLAR] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3358),
    [anon_sym_STAR] = ACTIONS(3360),
    [anon_sym_AT] = ACTIONS(3360),
    [anon_sym_QMARK] = ACTIONS(3360),
    [anon_sym_0] = ACTIONS(3358),
    [anon_sym__] = ACTIONS(3358),
  },
  [1055] = {
    [sym_concatenation] = STATE(1482),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1482),
    [anon_sym_RBRACE] = ACTIONS(3362),
    [anon_sym_EQ] = ACTIONS(3364),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_COLON] = ACTIONS(3364),
    [anon_sym_COLON_QMARK] = ACTIONS(3364),
    [anon_sym_COLON_DASH] = ACTIONS(3364),
    [anon_sym_PERCENT] = ACTIONS(3364),
    [anon_sym_DASH] = ACTIONS(3364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1056] = {
    [sym_concatenation] = STATE(1485),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1485),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_EQ] = ACTIONS(3372),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3374),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3376),
    [anon_sym_COLON] = ACTIONS(3372),
    [anon_sym_COLON_QMARK] = ACTIONS(3372),
    [anon_sym_COLON_DASH] = ACTIONS(3372),
    [anon_sym_PERCENT] = ACTIONS(3372),
    [anon_sym_DASH] = ACTIONS(3372),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1057] = {
    [anon_sym_SEMI] = ACTIONS(3378),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3380),
    [anon_sym_SEMI_SEMI] = ACTIONS(3382),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3382),
    [anon_sym_AMP] = ACTIONS(3378),
  },
  [1058] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3378),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3380),
    [anon_sym_SEMI_SEMI] = ACTIONS(3382),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3382),
    [anon_sym_AMP] = ACTIONS(3378),
  },
  [1059] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1488),
    [sym_c_style_for_statement] = STATE(1488),
    [sym_while_statement] = STATE(1488),
    [sym_if_statement] = STATE(1488),
    [sym_case_statement] = STATE(1488),
    [sym_function_definition] = STATE(1488),
    [sym_subshell] = STATE(1488),
    [sym_pipeline] = STATE(1488),
    [sym_list] = STATE(1488),
    [sym_negated_command] = STATE(1488),
    [sym_test_command] = STATE(1488),
    [sym_declaration_command] = STATE(1488),
    [sym_unset_command] = STATE(1488),
    [sym_command] = STATE(1488),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1489),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1060] = {
    [anon_sym_SEMI] = ACTIONS(3384),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(3386),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(3380),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3386),
    [anon_sym_AMP] = ACTIONS(3384),
  },
  [1061] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3384),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(3386),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(3380),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3386),
    [anon_sym_AMP] = ACTIONS(3384),
  },
  [1062] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1491),
    [sym_c_style_for_statement] = STATE(1491),
    [sym_while_statement] = STATE(1491),
    [sym_if_statement] = STATE(1491),
    [sym_case_statement] = STATE(1491),
    [sym_function_definition] = STATE(1491),
    [sym_subshell] = STATE(1491),
    [sym_pipeline] = STATE(1491),
    [sym_list] = STATE(1491),
    [sym_negated_command] = STATE(1491),
    [sym_test_command] = STATE(1491),
    [sym_declaration_command] = STATE(1491),
    [sym_unset_command] = STATE(1491),
    [sym_command] = STATE(1491),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(1492),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [1063] = {
    [anon_sym_SEMI] = ACTIONS(3388),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [anon_sym_SEMI_SEMI] = ACTIONS(3392),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3392),
    [anon_sym_AMP] = ACTIONS(3388),
  },
  [1064] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3388),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [anon_sym_SEMI_SEMI] = ACTIONS(3392),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3392),
    [anon_sym_AMP] = ACTIONS(3388),
  },
  [1065] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1495),
    [sym_c_style_for_statement] = STATE(1495),
    [sym_while_statement] = STATE(1495),
    [sym_if_statement] = STATE(1495),
    [sym_case_statement] = STATE(1495),
    [sym_function_definition] = STATE(1495),
    [sym_subshell] = STATE(1495),
    [sym_pipeline] = STATE(1495),
    [sym_list] = STATE(1495),
    [sym_negated_command] = STATE(1495),
    [sym_test_command] = STATE(1495),
    [sym_declaration_command] = STATE(1495),
    [sym_unset_command] = STATE(1495),
    [sym_command] = STATE(1495),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1496),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1066] = {
    [sym_do_group] = STATE(1497),
    [anon_sym_do] = ACTIONS(1175),
    [sym_comment] = ACTIONS(53),
  },
  [1067] = {
    [sym_concatenation] = STATE(1067),
    [sym_string] = STATE(592),
    [sym_simple_expansion] = STATE(592),
    [sym_string_expansion] = STATE(592),
    [sym_expansion] = STATE(592),
    [sym_command_substitution] = STATE(592),
    [sym_process_substitution] = STATE(592),
    [aux_sym_for_statement_repeat1] = STATE(1067),
    [anon_sym_SEMI] = ACTIONS(3394),
    [anon_sym_SEMI_SEMI] = ACTIONS(3182),
    [sym__special_characters] = ACTIONS(3396),
    [anon_sym_DQUOTE] = ACTIONS(3399),
    [anon_sym_DOLLAR] = ACTIONS(3402),
    [sym_raw_string] = ACTIONS(3405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3411),
    [anon_sym_BQUOTE] = ACTIONS(3414),
    [anon_sym_LT_LPAREN] = ACTIONS(3417),
    [anon_sym_GT_LPAREN] = ACTIONS(3417),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3420),
    [anon_sym_LF] = ACTIONS(3182),
    [anon_sym_AMP] = ACTIONS(3182),
  },
  [1068] = {
    [ts_builtin_sym_end] = ACTIONS(2323),
    [anon_sym_SEMI] = ACTIONS(2325),
    [anon_sym_esac] = ACTIONS(2323),
    [anon_sym_PIPE] = ACTIONS(2325),
    [anon_sym_RPAREN] = ACTIONS(2323),
    [anon_sym_SEMI_SEMI] = ACTIONS(2323),
    [anon_sym_PIPE_AMP] = ACTIONS(2323),
    [anon_sym_AMP_AMP] = ACTIONS(2323),
    [anon_sym_PIPE_PIPE] = ACTIONS(2323),
    [anon_sym_BQUOTE] = ACTIONS(2323),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2325),
  },
  [1069] = {
    [sym__terminated_statement] = STATE(1085),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1085),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_done] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [1070] = {
    [aux_sym_concatenation_repeat1] = STATE(1499),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [1071] = {
    [sym_file_redirect] = STATE(626),
    [sym_heredoc_redirect] = STATE(626),
    [sym_heredoc_body] = STATE(1086),
    [sym_herestring_redirect] = STATE(626),
    [aux_sym_while_statement_repeat1] = STATE(626),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(2331),
    [anon_sym_PIPE] = ACTIONS(2331),
    [anon_sym_SEMI_SEMI] = ACTIONS(2329),
    [anon_sym_PIPE_AMP] = ACTIONS(2329),
    [anon_sym_AMP_AMP] = ACTIONS(2329),
    [anon_sym_PIPE_PIPE] = ACTIONS(2329),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2329),
    [anon_sym_AMP] = ACTIONS(2331),
  },
  [1072] = {
    [sym_compound_statement] = STATE(1500),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [1073] = {
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_GT] = ACTIONS(3425),
    [anon_sym_GT_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT] = ACTIONS(3425),
    [anon_sym_AMP_GT_GT] = ACTIONS(3427),
    [anon_sym_LT_AMP] = ACTIONS(3427),
    [anon_sym_GT_AMP] = ACTIONS(3427),
    [sym_comment] = ACTIONS(53),
  },
  [1074] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(1503),
    [sym_simple_expansion] = STATE(1503),
    [sym_string_expansion] = STATE(1503),
    [sym_expansion] = STATE(1503),
    [sym_command_substitution] = STATE(1503),
    [sym_process_substitution] = STATE(1503),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(3431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3431),
  },
  [1075] = {
    [anon_sym_LT] = ACTIONS(3433),
    [anon_sym_GT] = ACTIONS(3433),
    [anon_sym_GT_GT] = ACTIONS(3435),
    [anon_sym_AMP_GT] = ACTIONS(3433),
    [anon_sym_AMP_GT_GT] = ACTIONS(3435),
    [anon_sym_LT_AMP] = ACTIONS(3435),
    [anon_sym_GT_AMP] = ACTIONS(3435),
    [sym_comment] = ACTIONS(53),
  },
  [1076] = {
    [sym_concatenation] = STATE(1186),
    [sym_string] = STATE(1506),
    [sym_simple_expansion] = STATE(1506),
    [sym_string_expansion] = STATE(1506),
    [sym_expansion] = STATE(1506),
    [sym_command_substitution] = STATE(1506),
    [sym_process_substitution] = STATE(1506),
    [sym__special_characters] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(3439),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3439),
  },
  [1077] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(1508),
    [sym_simple_expansion] = STATE(1508),
    [sym_string_expansion] = STATE(1508),
    [sym_expansion] = STATE(1508),
    [sym_command_substitution] = STATE(1508),
    [sym_process_substitution] = STATE(1508),
    [sym__special_characters] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(3443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3443),
  },
  [1078] = {
    [sym_file_redirect] = STATE(1509),
    [sym_heredoc_redirect] = STATE(1509),
    [sym_herestring_redirect] = STATE(1509),
    [aux_sym_while_statement_repeat1] = STATE(1509),
    [sym_file_descriptor] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_AMP_GT] = ACTIONS(2286),
    [anon_sym_AMP_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_AMP] = ACTIONS(2288),
    [anon_sym_GT_AMP] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_LT_LT_DASH] = ACTIONS(1415),
    [anon_sym_LT_LT_LT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [1079] = {
    [aux_sym_concatenation_repeat1] = STATE(607),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [1080] = {
    [aux_sym_concatenation_repeat1] = STATE(607),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1073),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [1081] = {
    [aux_sym_concatenation_repeat1] = STATE(1081),
    [sym__concat] = ACTIONS(2687),
    [sym_variable_name] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1726),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1082] = {
    [aux_sym_concatenation_repeat1] = STATE(1082),
    [sym__concat] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1726),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1083] = {
    [sym_file_redirect] = STATE(1363),
    [sym_file_descriptor] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_SEMI_SEMI] = ACTIONS(2460),
    [anon_sym_PIPE_AMP] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_GT] = ACTIONS(2282),
    [anon_sym_AMP_GT] = ACTIONS(2280),
    [anon_sym_AMP_GT_GT] = ACTIONS(2282),
    [anon_sym_LT_AMP] = ACTIONS(2282),
    [anon_sym_GT_AMP] = ACTIONS(2282),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
  },
  [1084] = {
    [sym__simple_heredoc_body] = ACTIONS(3445),
    [sym__heredoc_body_beginning] = ACTIONS(3445),
    [sym_file_descriptor] = ACTIONS(3445),
    [ts_builtin_sym_end] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym_esac] = ACTIONS(3445),
    [anon_sym_PIPE] = ACTIONS(3447),
    [anon_sym_RPAREN] = ACTIONS(3445),
    [anon_sym_SEMI_SEMI] = ACTIONS(3445),
    [anon_sym_PIPE_AMP] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_PIPE_PIPE] = ACTIONS(3445),
    [anon_sym_LT] = ACTIONS(3447),
    [anon_sym_GT] = ACTIONS(3447),
    [anon_sym_GT_GT] = ACTIONS(3445),
    [anon_sym_AMP_GT] = ACTIONS(3447),
    [anon_sym_AMP_GT_GT] = ACTIONS(3445),
    [anon_sym_LT_AMP] = ACTIONS(3445),
    [anon_sym_GT_AMP] = ACTIONS(3445),
    [anon_sym_LT_LT] = ACTIONS(3447),
    [anon_sym_LT_LT_DASH] = ACTIONS(3445),
    [anon_sym_LT_LT_LT] = ACTIONS(3445),
    [anon_sym_BQUOTE] = ACTIONS(3445),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3447),
  },
  [1085] = {
    [sym__terminated_statement] = STATE(1085),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1085),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(968),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_done] = ACTIONS(3449),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_function] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(998),
    [anon_sym_typeset] = ACTIONS(998),
    [anon_sym_export] = ACTIONS(998),
    [anon_sym_readonly] = ACTIONS(998),
    [anon_sym_local] = ACTIONS(998),
    [anon_sym_unset] = ACTIONS(1001),
    [anon_sym_unsetenv] = ACTIONS(1001),
    [anon_sym_LT] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_AMP_GT] = ACTIONS(1004),
    [anon_sym_AMP_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_AMP] = ACTIONS(1007),
    [anon_sym_GT_AMP] = ACTIONS(1007),
    [sym__special_characters] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1013),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1022),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1025),
    [anon_sym_BQUOTE] = ACTIONS(1028),
    [anon_sym_LT_LPAREN] = ACTIONS(1031),
    [anon_sym_GT_LPAREN] = ACTIONS(1031),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1034),
  },
  [1086] = {
    [ts_builtin_sym_end] = ACTIONS(3451),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym_esac] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(3453),
    [anon_sym_RPAREN] = ACTIONS(3451),
    [anon_sym_SEMI_SEMI] = ACTIONS(3451),
    [anon_sym_PIPE_AMP] = ACTIONS(3451),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_BQUOTE] = ACTIONS(3451),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3453),
  },
  [1087] = {
    [aux_sym_concatenation_repeat1] = STATE(1089),
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1088] = {
    [aux_sym_concatenation_repeat1] = STATE(1089),
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1089] = {
    [aux_sym_concatenation_repeat1] = STATE(1510),
    [sym__simple_heredoc_body] = ACTIONS(765),
    [sym__heredoc_body_beginning] = ACTIONS(765),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [1090] = {
    [sym_file_redirect] = STATE(626),
    [sym_heredoc_redirect] = STATE(626),
    [sym_heredoc_body] = STATE(1375),
    [sym_herestring_redirect] = STATE(626),
    [aux_sym_while_statement_repeat1] = STATE(626),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3120),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_PIPE_AMP] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3120),
  },
  [1091] = {
    [anon_sym_then] = ACTIONS(3455),
    [sym_comment] = ACTIONS(53),
  },
  [1092] = {
    [sym__terminated_statement] = STATE(1512),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1512),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(3457),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [1093] = {
    [ts_builtin_sym_end] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3461),
    [anon_sym_esac] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_SEMI_SEMI] = ACTIONS(3459),
    [anon_sym_PIPE_AMP] = ACTIONS(3459),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_BQUOTE] = ACTIONS(3459),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3459),
    [anon_sym_AMP] = ACTIONS(3461),
  },
  [1094] = {
    [anon_sym_fi] = ACTIONS(3463),
    [sym_comment] = ACTIONS(53),
  },
  [1095] = {
    [sym__terminated_statement] = STATE(1095),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1095),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(968),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_fi] = ACTIONS(3449),
    [anon_sym_elif] = ACTIONS(3449),
    [anon_sym_else] = ACTIONS(3449),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_function] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(998),
    [anon_sym_typeset] = ACTIONS(998),
    [anon_sym_export] = ACTIONS(998),
    [anon_sym_readonly] = ACTIONS(998),
    [anon_sym_local] = ACTIONS(998),
    [anon_sym_unset] = ACTIONS(1001),
    [anon_sym_unsetenv] = ACTIONS(1001),
    [anon_sym_LT] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_AMP_GT] = ACTIONS(1004),
    [anon_sym_AMP_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_AMP] = ACTIONS(1007),
    [anon_sym_GT_AMP] = ACTIONS(1007),
    [sym__special_characters] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1013),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1022),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1025),
    [anon_sym_BQUOTE] = ACTIONS(1028),
    [anon_sym_LT_LPAREN] = ACTIONS(1031),
    [anon_sym_GT_LPAREN] = ACTIONS(1031),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1034),
  },
  [1096] = {
    [sym_elif_clause] = STATE(1097),
    [sym_else_clause] = STATE(1514),
    [aux_sym_if_statement_repeat1] = STATE(1097),
    [anon_sym_fi] = ACTIONS(3463),
    [anon_sym_elif] = ACTIONS(2371),
    [anon_sym_else] = ACTIONS(2373),
    [sym_comment] = ACTIONS(53),
  },
  [1097] = {
    [sym_elif_clause] = STATE(1097),
    [aux_sym_if_statement_repeat1] = STATE(1097),
    [anon_sym_fi] = ACTIONS(3465),
    [anon_sym_elif] = ACTIONS(3467),
    [anon_sym_else] = ACTIONS(3465),
    [sym_comment] = ACTIONS(53),
  },
  [1098] = {
    [ts_builtin_sym_end] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(3472),
    [anon_sym_esac] = ACTIONS(3470),
    [anon_sym_PIPE] = ACTIONS(3472),
    [anon_sym_RPAREN] = ACTIONS(3470),
    [anon_sym_SEMI_SEMI] = ACTIONS(3470),
    [anon_sym_PIPE_AMP] = ACTIONS(3470),
    [anon_sym_AMP_AMP] = ACTIONS(3470),
    [anon_sym_PIPE_PIPE] = ACTIONS(3470),
    [anon_sym_BQUOTE] = ACTIONS(3470),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
  },
  [1099] = {
    [aux_sym_case_item_repeat1] = STATE(1517),
    [aux_sym_concatenation_repeat1] = STATE(1518),
    [sym__concat] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(3476),
    [sym_comment] = ACTIONS(53),
  },
  [1100] = {
    [aux_sym_case_item_repeat1] = STATE(1520),
    [aux_sym_concatenation_repeat1] = STATE(1518),
    [sym__concat] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(3478),
    [sym_comment] = ACTIONS(53),
  },
  [1101] = {
    [anon_sym_esac] = ACTIONS(3480),
    [sym_comment] = ACTIONS(53),
  },
  [1102] = {
    [aux_sym_case_item_repeat1] = STATE(1520),
    [anon_sym_PIPE] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(3478),
    [sym_comment] = ACTIONS(53),
  },
  [1103] = {
    [sym_case_item] = STATE(1523),
    [sym_last_case_item] = STATE(1522),
    [sym_concatenation] = STATE(1102),
    [sym_string] = STATE(1100),
    [sym_simple_expansion] = STATE(1100),
    [sym_string_expansion] = STATE(1100),
    [sym_expansion] = STATE(1100),
    [sym_command_substitution] = STATE(1100),
    [sym_process_substitution] = STATE(1100),
    [aux_sym_case_statement_repeat1] = STATE(1523),
    [sym__special_characters] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(2379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2379),
  },
  [1104] = {
    [sym_case_item] = STATE(1524),
    [sym_last_case_item] = STATE(1522),
    [sym_concatenation] = STATE(1102),
    [sym_string] = STATE(1100),
    [sym_simple_expansion] = STATE(1100),
    [sym_string_expansion] = STATE(1100),
    [sym_expansion] = STATE(1100),
    [sym_command_substitution] = STATE(1100),
    [sym_process_substitution] = STATE(1100),
    [aux_sym_case_statement_repeat1] = STATE(1524),
    [anon_sym_esac] = ACTIONS(3482),
    [sym__special_characters] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(2379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2381),
  },
  [1105] = {
    [sym__concat] = ACTIONS(2876),
    [anon_sym_in] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2876),
  },
  [1106] = {
    [ts_builtin_sym_end] = ACTIONS(3484),
    [anon_sym_SEMI] = ACTIONS(3486),
    [anon_sym_esac] = ACTIONS(3484),
    [anon_sym_PIPE] = ACTIONS(3486),
    [anon_sym_RPAREN] = ACTIONS(3484),
    [anon_sym_SEMI_SEMI] = ACTIONS(3484),
    [anon_sym_PIPE_AMP] = ACTIONS(3484),
    [anon_sym_AMP_AMP] = ACTIONS(3484),
    [anon_sym_PIPE_PIPE] = ACTIONS(3484),
    [anon_sym_BQUOTE] = ACTIONS(3484),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3484),
    [anon_sym_AMP] = ACTIONS(3486),
  },
  [1107] = {
    [anon_sym_esac] = ACTIONS(3488),
    [sym_comment] = ACTIONS(53),
  },
  [1108] = {
    [sym_case_item] = STATE(1523),
    [sym_last_case_item] = STATE(1526),
    [sym_concatenation] = STATE(1102),
    [sym_string] = STATE(1100),
    [sym_simple_expansion] = STATE(1100),
    [sym_string_expansion] = STATE(1100),
    [sym_expansion] = STATE(1100),
    [sym_command_substitution] = STATE(1100),
    [sym_process_substitution] = STATE(1100),
    [aux_sym_case_statement_repeat1] = STATE(1523),
    [sym__special_characters] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(2379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2379),
  },
  [1109] = {
    [sym_case_item] = STATE(1527),
    [sym_last_case_item] = STATE(1526),
    [sym_concatenation] = STATE(1102),
    [sym_string] = STATE(1100),
    [sym_simple_expansion] = STATE(1100),
    [sym_string_expansion] = STATE(1100),
    [sym_expansion] = STATE(1100),
    [sym_command_substitution] = STATE(1100),
    [sym_process_substitution] = STATE(1100),
    [aux_sym_case_statement_repeat1] = STATE(1527),
    [anon_sym_esac] = ACTIONS(3490),
    [sym__special_characters] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(2379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2381),
  },
  [1110] = {
    [sym__concat] = ACTIONS(2890),
    [anon_sym_in] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2890),
  },
  [1111] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3492),
    [sym_comment] = ACTIONS(53),
  },
  [1112] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3494),
    [sym_comment] = ACTIONS(53),
  },
  [1113] = {
    [anon_sym_RBRACE] = ACTIONS(3494),
    [sym_comment] = ACTIONS(53),
  },
  [1114] = {
    [sym_concatenation] = STATE(1532),
    [sym_string] = STATE(1531),
    [sym_simple_expansion] = STATE(1531),
    [sym_string_expansion] = STATE(1531),
    [sym_expansion] = STATE(1531),
    [sym_command_substitution] = STATE(1531),
    [sym_process_substitution] = STATE(1531),
    [anon_sym_RBRACE] = ACTIONS(3494),
    [sym__special_characters] = ACTIONS(3496),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3498),
  },
  [1115] = {
    [sym__concat] = ACTIONS(2926),
    [anon_sym_in] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2926),
  },
  [1116] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3500),
  },
  [1117] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3502),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1118] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3504),
  },
  [1119] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1120] = {
    [sym_concatenation] = STATE(1537),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1537),
    [anon_sym_RBRACE] = ACTIONS(3506),
    [anon_sym_EQ] = ACTIONS(3508),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3508),
    [anon_sym_COLON_QMARK] = ACTIONS(3508),
    [anon_sym_COLON_DASH] = ACTIONS(3508),
    [anon_sym_PERCENT] = ACTIONS(3508),
    [anon_sym_DASH] = ACTIONS(3508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1121] = {
    [sym__concat] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2990),
  },
  [1122] = {
    [sym_concatenation] = STATE(1538),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1538),
    [anon_sym_RBRACE] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3512),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3514),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3512),
    [anon_sym_COLON_QMARK] = ACTIONS(3512),
    [anon_sym_COLON_DASH] = ACTIONS(3512),
    [anon_sym_PERCENT] = ACTIONS(3512),
    [anon_sym_DASH] = ACTIONS(3512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1123] = {
    [sym__concat] = ACTIONS(3033),
    [anon_sym_in] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3033),
  },
  [1124] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3516),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1125] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3516),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1126] = {
    [sym__concat] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3071),
  },
  [1127] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3518),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1128] = {
    [sym_file_redirect] = STATE(1541),
    [sym_file_descriptor] = ACTIONS(1285),
    [ts_builtin_sym_end] = ACTIONS(3520),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(3522),
    [anon_sym_SEMI_SEMI] = ACTIONS(3520),
    [anon_sym_PIPE_AMP] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(1291),
    [anon_sym_GT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_AMP_GT] = ACTIONS(1291),
    [anon_sym_AMP_GT_GT] = ACTIONS(1293),
    [anon_sym_LT_AMP] = ACTIONS(1293),
    [anon_sym_GT_AMP] = ACTIONS(1293),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3522),
  },
  [1129] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_RBRACE] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1130] = {
    [sym_file_descriptor] = ACTIONS(3524),
    [ts_builtin_sym_end] = ACTIONS(3524),
    [anon_sym_SEMI] = ACTIONS(3526),
    [anon_sym_esac] = ACTIONS(3524),
    [anon_sym_PIPE] = ACTIONS(3526),
    [anon_sym_RPAREN] = ACTIONS(3524),
    [anon_sym_SEMI_SEMI] = ACTIONS(3524),
    [anon_sym_PIPE_AMP] = ACTIONS(3524),
    [anon_sym_AMP_AMP] = ACTIONS(3524),
    [anon_sym_PIPE_PIPE] = ACTIONS(3524),
    [anon_sym_LT] = ACTIONS(3526),
    [anon_sym_GT] = ACTIONS(3526),
    [anon_sym_GT_GT] = ACTIONS(3524),
    [anon_sym_AMP_GT] = ACTIONS(3526),
    [anon_sym_AMP_GT_GT] = ACTIONS(3524),
    [anon_sym_LT_AMP] = ACTIONS(3524),
    [anon_sym_GT_AMP] = ACTIONS(3524),
    [anon_sym_BQUOTE] = ACTIONS(3524),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3524),
    [anon_sym_AMP] = ACTIONS(3526),
  },
  [1131] = {
    [sym__terminated_statement] = STATE(1131),
    [sym_for_statement] = STATE(667),
    [sym_c_style_for_statement] = STATE(667),
    [sym_while_statement] = STATE(667),
    [sym_if_statement] = STATE(667),
    [sym_case_statement] = STATE(667),
    [sym_function_definition] = STATE(667),
    [sym_subshell] = STATE(667),
    [sym_pipeline] = STATE(667),
    [sym_list] = STATE(667),
    [sym_negated_command] = STATE(667),
    [sym_test_command] = STATE(667),
    [sym_declaration_command] = STATE(667),
    [sym_unset_command] = STATE(667),
    [sym_command] = STATE(667),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(668),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1131),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(968),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_function] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(3528),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(998),
    [anon_sym_typeset] = ACTIONS(998),
    [anon_sym_export] = ACTIONS(998),
    [anon_sym_readonly] = ACTIONS(998),
    [anon_sym_local] = ACTIONS(998),
    [anon_sym_unset] = ACTIONS(1001),
    [anon_sym_unsetenv] = ACTIONS(1001),
    [anon_sym_LT] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_AMP_GT] = ACTIONS(1004),
    [anon_sym_AMP_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_AMP] = ACTIONS(1007),
    [anon_sym_GT_AMP] = ACTIONS(1007),
    [sym__special_characters] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1013),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1022),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1025),
    [anon_sym_BQUOTE] = ACTIONS(1028),
    [anon_sym_LT_LPAREN] = ACTIONS(1031),
    [anon_sym_GT_LPAREN] = ACTIONS(1031),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1034),
  },
  [1132] = {
    [sym_concatenation] = STATE(1544),
    [sym_string] = STATE(1543),
    [sym_simple_expansion] = STATE(1543),
    [sym_string_expansion] = STATE(1543),
    [sym_expansion] = STATE(1543),
    [sym_command_substitution] = STATE(1543),
    [sym_process_substitution] = STATE(1543),
    [sym__special_characters] = ACTIONS(3530),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(3532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3532),
  },
  [1133] = {
    [aux_sym_concatenation_repeat1] = STATE(1545),
    [sym__concat] = ACTIONS(693),
    [ts_builtin_sym_end] = ACTIONS(731),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [1134] = {
    [aux_sym_concatenation_repeat1] = STATE(1545),
    [sym__concat] = ACTIONS(693),
    [ts_builtin_sym_end] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [1135] = {
    [ts_builtin_sym_end] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_esac] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [1136] = {
    [aux_sym_concatenation_repeat1] = STATE(1546),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(1095),
    [sym_variable_name] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [1137] = {
    [sym_file_redirect] = STATE(696),
    [sym_heredoc_redirect] = STATE(696),
    [sym_heredoc_body] = STATE(1086),
    [sym_herestring_redirect] = STATE(696),
    [aux_sym_while_statement_repeat1] = STATE(696),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(2331),
    [anon_sym_PIPE] = ACTIONS(2331),
    [anon_sym_RPAREN] = ACTIONS(2329),
    [anon_sym_SEMI_SEMI] = ACTIONS(2329),
    [anon_sym_PIPE_AMP] = ACTIONS(2329),
    [anon_sym_AMP_AMP] = ACTIONS(2329),
    [anon_sym_PIPE_PIPE] = ACTIONS(2329),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(557),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2329),
    [anon_sym_AMP] = ACTIONS(2331),
  },
  [1138] = {
    [sym_compound_statement] = STATE(1547),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [1139] = {
    [anon_sym_LT] = ACTIONS(3534),
    [anon_sym_GT] = ACTIONS(3534),
    [anon_sym_GT_GT] = ACTIONS(3536),
    [anon_sym_AMP_GT] = ACTIONS(3534),
    [anon_sym_AMP_GT_GT] = ACTIONS(3536),
    [anon_sym_LT_AMP] = ACTIONS(3536),
    [anon_sym_GT_AMP] = ACTIONS(3536),
    [sym_comment] = ACTIONS(53),
  },
  [1140] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(1550),
    [sym_simple_expansion] = STATE(1550),
    [sym_string_expansion] = STATE(1550),
    [sym_expansion] = STATE(1550),
    [sym_command_substitution] = STATE(1550),
    [sym_process_substitution] = STATE(1550),
    [sym__special_characters] = ACTIONS(3538),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(3540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3540),
  },
  [1141] = {
    [anon_sym_LT] = ACTIONS(3542),
    [anon_sym_GT] = ACTIONS(3542),
    [anon_sym_GT_GT] = ACTIONS(3544),
    [anon_sym_AMP_GT] = ACTIONS(3542),
    [anon_sym_AMP_GT_GT] = ACTIONS(3544),
    [anon_sym_LT_AMP] = ACTIONS(3544),
    [anon_sym_GT_AMP] = ACTIONS(3544),
    [sym_comment] = ACTIONS(53),
  },
  [1142] = {
    [sym_concatenation] = STATE(1186),
    [sym_string] = STATE(1553),
    [sym_simple_expansion] = STATE(1553),
    [sym_string_expansion] = STATE(1553),
    [sym_expansion] = STATE(1553),
    [sym_command_substitution] = STATE(1553),
    [sym_process_substitution] = STATE(1553),
    [sym__special_characters] = ACTIONS(3546),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(3548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3548),
  },
  [1143] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(1555),
    [sym_simple_expansion] = STATE(1555),
    [sym_string_expansion] = STATE(1555),
    [sym_expansion] = STATE(1555),
    [sym_command_substitution] = STATE(1555),
    [sym_process_substitution] = STATE(1555),
    [sym__special_characters] = ACTIONS(3550),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(3552),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3552),
  },
  [1144] = {
    [sym_file_redirect] = STATE(1556),
    [sym_heredoc_redirect] = STATE(1556),
    [sym_herestring_redirect] = STATE(1556),
    [aux_sym_while_statement_repeat1] = STATE(1556),
    [sym_file_descriptor] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_RPAREN] = ACTIONS(2632),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_GT] = ACTIONS(2474),
    [anon_sym_GT_GT] = ACTIONS(2476),
    [anon_sym_AMP_GT] = ACTIONS(2474),
    [anon_sym_AMP_GT_GT] = ACTIONS(2476),
    [anon_sym_LT_AMP] = ACTIONS(2476),
    [anon_sym_GT_AMP] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_LT_LT_DASH] = ACTIONS(1415),
    [anon_sym_LT_LT_LT] = ACTIONS(2478),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [1145] = {
    [aux_sym_concatenation_repeat1] = STATE(680),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [1146] = {
    [aux_sym_concatenation_repeat1] = STATE(680),
    [sym__concat] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1073),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [1147] = {
    [aux_sym_concatenation_repeat1] = STATE(1147),
    [sym__concat] = ACTIONS(2687),
    [sym_variable_name] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1726),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1148] = {
    [aux_sym_concatenation_repeat1] = STATE(1148),
    [sym__concat] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1726),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1149] = {
    [sym_file_redirect] = STATE(1363),
    [sym_file_descriptor] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_RPAREN] = ACTIONS(2460),
    [anon_sym_SEMI_SEMI] = ACTIONS(2460),
    [anon_sym_PIPE_AMP] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_AMP_GT] = ACTIONS(2468),
    [anon_sym_AMP_GT_GT] = ACTIONS(2470),
    [anon_sym_LT_AMP] = ACTIONS(2470),
    [anon_sym_GT_AMP] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
  },
  [1150] = {
    [aux_sym_concatenation_repeat1] = STATE(1152),
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1151] = {
    [aux_sym_concatenation_repeat1] = STATE(1152),
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1152] = {
    [aux_sym_concatenation_repeat1] = STATE(1557),
    [sym__simple_heredoc_body] = ACTIONS(765),
    [sym__heredoc_body_beginning] = ACTIONS(765),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [1153] = {
    [ts_builtin_sym_end] = ACTIONS(3554),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym_esac] = ACTIONS(3554),
    [anon_sym_PIPE] = ACTIONS(3556),
    [anon_sym_RPAREN] = ACTIONS(3554),
    [anon_sym_SEMI_SEMI] = ACTIONS(3554),
    [anon_sym_PIPE_AMP] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_BQUOTE] = ACTIONS(3554),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3554),
    [anon_sym_AMP] = ACTIONS(3556),
  },
  [1154] = {
    [sym_file_redirect] = STATE(696),
    [sym_heredoc_redirect] = STATE(696),
    [sym_heredoc_body] = STATE(1375),
    [sym_herestring_redirect] = STATE(696),
    [aux_sym_while_statement_repeat1] = STATE(696),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3120),
    [anon_sym_RPAREN] = ACTIONS(3118),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_PIPE_AMP] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(557),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3120),
  },
  [1155] = {
    [sym_file_descriptor] = ACTIONS(2056),
    [sym_variable_name] = ACTIONS(2056),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_GT] = ACTIONS(2058),
    [anon_sym_GT_GT] = ACTIONS(2056),
    [anon_sym_AMP_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT_GT] = ACTIONS(2056),
    [anon_sym_LT_AMP] = ACTIONS(2056),
    [anon_sym_GT_AMP] = ACTIONS(2056),
    [sym__special_characters] = ACTIONS(2056),
    [anon_sym_DQUOTE] = ACTIONS(2056),
    [anon_sym_DOLLAR] = ACTIONS(2058),
    [sym_raw_string] = ACTIONS(2056),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2056),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2056),
    [anon_sym_BQUOTE] = ACTIONS(2056),
    [anon_sym_LT_LPAREN] = ACTIONS(2056),
    [anon_sym_GT_LPAREN] = ACTIONS(2056),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2056),
  },
  [1156] = {
    [sym_concatenation] = STATE(977),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_string_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [aux_sym_for_statement_repeat1] = STATE(977),
    [anon_sym_RPAREN] = ACTIONS(3558),
    [sym__special_characters] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym_raw_string] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1083),
  },
  [1157] = {
    [aux_sym_concatenation_repeat1] = STATE(1157),
    [sym__concat] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1724),
    [anon_sym_EQ_EQ] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1724),
    [anon_sym_GT] = ACTIONS(1724),
    [anon_sym_BANG_EQ] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1724),
  },
  [1158] = {
    [sym__concat] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [anon_sym_RBRACK] = ACTIONS(2876),
    [anon_sym_EQ_TILDE] = ACTIONS(2876),
    [anon_sym_EQ_EQ] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2878),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2876),
    [anon_sym_BANG_EQ] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2876),
  },
  [1159] = {
    [sym__concat] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_RBRACK] = ACTIONS(2890),
    [anon_sym_EQ_TILDE] = ACTIONS(2890),
    [anon_sym_EQ_EQ] = ACTIONS(2890),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2890),
    [anon_sym_GT] = ACTIONS(2890),
    [anon_sym_BANG_EQ] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2890),
  },
  [1160] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [sym_comment] = ACTIONS(53),
  },
  [1161] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3562),
    [sym_comment] = ACTIONS(53),
  },
  [1162] = {
    [anon_sym_RBRACE] = ACTIONS(3562),
    [sym_comment] = ACTIONS(53),
  },
  [1163] = {
    [sym_concatenation] = STATE(1563),
    [sym_string] = STATE(1562),
    [sym_simple_expansion] = STATE(1562),
    [sym_string_expansion] = STATE(1562),
    [sym_expansion] = STATE(1562),
    [sym_command_substitution] = STATE(1562),
    [sym_process_substitution] = STATE(1562),
    [anon_sym_RBRACE] = ACTIONS(3562),
    [sym__special_characters] = ACTIONS(3564),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3566),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3566),
  },
  [1164] = {
    [sym__concat] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_RBRACK] = ACTIONS(2926),
    [anon_sym_EQ_TILDE] = ACTIONS(2926),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2926),
    [anon_sym_GT] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2926),
  },
  [1165] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3568),
  },
  [1166] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3570),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1167] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3572),
  },
  [1168] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1169] = {
    [sym_concatenation] = STATE(1568),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1568),
    [anon_sym_RBRACE] = ACTIONS(3574),
    [anon_sym_EQ] = ACTIONS(3576),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3576),
    [anon_sym_COLON_QMARK] = ACTIONS(3576),
    [anon_sym_COLON_DASH] = ACTIONS(3576),
    [anon_sym_PERCENT] = ACTIONS(3576),
    [anon_sym_DASH] = ACTIONS(3576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1170] = {
    [sym__concat] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [anon_sym_RBRACK] = ACTIONS(2990),
    [anon_sym_EQ_TILDE] = ACTIONS(2990),
    [anon_sym_EQ_EQ] = ACTIONS(2990),
    [anon_sym_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_GT] = ACTIONS(2990),
    [anon_sym_BANG_EQ] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2990),
  },
  [1171] = {
    [sym_concatenation] = STATE(1569),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1569),
    [anon_sym_RBRACE] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3580),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3580),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_COLON_DASH] = ACTIONS(3580),
    [anon_sym_PERCENT] = ACTIONS(3580),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1172] = {
    [sym__concat] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [anon_sym_RBRACK] = ACTIONS(3033),
    [anon_sym_EQ_TILDE] = ACTIONS(3033),
    [anon_sym_EQ_EQ] = ACTIONS(3033),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_GT] = ACTIONS(3033),
    [anon_sym_BANG_EQ] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3033),
  },
  [1173] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3584),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1174] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3584),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1175] = {
    [sym__concat] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_EQ_TILDE] = ACTIONS(3071),
    [anon_sym_EQ_EQ] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3071),
    [anon_sym_GT] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3071),
  },
  [1176] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3586),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1177] = {
    [sym_concatenation] = STATE(1574),
    [sym_string] = STATE(1573),
    [sym_simple_expansion] = STATE(1573),
    [sym_string_expansion] = STATE(1573),
    [sym_expansion] = STATE(1573),
    [sym_command_substitution] = STATE(1573),
    [sym_process_substitution] = STATE(1573),
    [sym__special_characters] = ACTIONS(3588),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(3590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3590),
  },
  [1178] = {
    [aux_sym_concatenation_repeat1] = STATE(1576),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(3592),
    [ts_builtin_sym_end] = ACTIONS(731),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [1179] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(1579),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_DOLLAR] = ACTIONS(3596),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [1180] = {
    [sym_string] = STATE(1581),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(3598),
    [sym_raw_string] = ACTIONS(3600),
    [anon_sym_POUND] = ACTIONS(3598),
    [anon_sym_DASH] = ACTIONS(3598),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3602),
    [anon_sym_STAR] = ACTIONS(3604),
    [anon_sym_AT] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_0] = ACTIONS(3602),
    [anon_sym__] = ACTIONS(3602),
  },
  [1181] = {
    [aux_sym_concatenation_repeat1] = STATE(1576),
    [sym_file_descriptor] = ACTIONS(749),
    [sym__concat] = ACTIONS(3592),
    [ts_builtin_sym_end] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_LT_LT_DASH] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [1182] = {
    [sym_subscript] = STATE(1586),
    [sym_variable_name] = ACTIONS(3606),
    [anon_sym_BANG] = ACTIONS(3608),
    [anon_sym_DOLLAR] = ACTIONS(3610),
    [anon_sym_POUND] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3610),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3612),
    [anon_sym_STAR] = ACTIONS(3614),
    [anon_sym_AT] = ACTIONS(3614),
    [anon_sym_QMARK] = ACTIONS(3614),
    [anon_sym_0] = ACTIONS(3612),
    [anon_sym__] = ACTIONS(3612),
  },
  [1183] = {
    [sym__terminated_statement] = STATE(1589),
    [sym_for_statement] = STATE(1587),
    [sym_c_style_for_statement] = STATE(1587),
    [sym_while_statement] = STATE(1587),
    [sym_if_statement] = STATE(1587),
    [sym_case_statement] = STATE(1587),
    [sym_function_definition] = STATE(1587),
    [sym_subshell] = STATE(1587),
    [sym_pipeline] = STATE(1587),
    [sym_list] = STATE(1587),
    [sym_negated_command] = STATE(1587),
    [sym_test_command] = STATE(1587),
    [sym_declaration_command] = STATE(1587),
    [sym_unset_command] = STATE(1587),
    [sym_command] = STATE(1587),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1588),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(1589),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1184] = {
    [sym__terminated_statement] = STATE(1592),
    [sym_for_statement] = STATE(1590),
    [sym_c_style_for_statement] = STATE(1590),
    [sym_while_statement] = STATE(1590),
    [sym_if_statement] = STATE(1590),
    [sym_case_statement] = STATE(1590),
    [sym_function_definition] = STATE(1590),
    [sym_subshell] = STATE(1590),
    [sym_pipeline] = STATE(1590),
    [sym_list] = STATE(1590),
    [sym_negated_command] = STATE(1590),
    [sym_test_command] = STATE(1590),
    [sym_declaration_command] = STATE(1590),
    [sym_unset_command] = STATE(1590),
    [sym_command] = STATE(1590),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(1591),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1592),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [1185] = {
    [sym__terminated_statement] = STATE(1595),
    [sym_for_statement] = STATE(1593),
    [sym_c_style_for_statement] = STATE(1593),
    [sym_while_statement] = STATE(1593),
    [sym_if_statement] = STATE(1593),
    [sym_case_statement] = STATE(1593),
    [sym_function_definition] = STATE(1593),
    [sym_subshell] = STATE(1593),
    [sym_pipeline] = STATE(1593),
    [sym_list] = STATE(1593),
    [sym_negated_command] = STATE(1593),
    [sym_test_command] = STATE(1593),
    [sym_declaration_command] = STATE(1593),
    [sym_unset_command] = STATE(1593),
    [sym_command] = STATE(1593),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1594),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(1595),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1186] = {
    [sym_file_descriptor] = ACTIONS(749),
    [ts_builtin_sym_end] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_esac] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_LT_LT_DASH] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(749),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [1187] = {
    [sym_file_descriptor] = ACTIONS(1968),
    [ts_builtin_sym_end] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_esac] = ACTIONS(1968),
    [anon_sym_PIPE] = ACTIONS(1970),
    [anon_sym_RPAREN] = ACTIONS(1968),
    [anon_sym_SEMI_SEMI] = ACTIONS(1968),
    [anon_sym_PIPE_AMP] = ACTIONS(1968),
    [anon_sym_AMP_AMP] = ACTIONS(1968),
    [anon_sym_PIPE_PIPE] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(1970),
    [anon_sym_GT_GT] = ACTIONS(1968),
    [anon_sym_AMP_GT] = ACTIONS(1970),
    [anon_sym_AMP_GT_GT] = ACTIONS(1968),
    [anon_sym_LT_AMP] = ACTIONS(1968),
    [anon_sym_GT_AMP] = ACTIONS(1968),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1968),
    [anon_sym_LT_LT_LT] = ACTIONS(1968),
    [anon_sym_BQUOTE] = ACTIONS(1968),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1970),
  },
  [1188] = {
    [aux_sym_concatenation_repeat1] = STATE(1576),
    [sym_file_descriptor] = ACTIONS(1972),
    [sym__concat] = ACTIONS(3592),
    [ts_builtin_sym_end] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_PIPE_AMP] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_PIPE_PIPE] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_AMP_GT] = ACTIONS(1974),
    [anon_sym_AMP_GT_GT] = ACTIONS(1972),
    [anon_sym_LT_AMP] = ACTIONS(1972),
    [anon_sym_GT_AMP] = ACTIONS(1972),
    [anon_sym_LT_LT] = ACTIONS(1974),
    [anon_sym_LT_LT_DASH] = ACTIONS(1972),
    [anon_sym_LT_LT_LT] = ACTIONS(1972),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1974),
  },
  [1189] = {
    [aux_sym_concatenation_repeat1] = STATE(1576),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(3592),
    [ts_builtin_sym_end] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [1190] = {
    [sym_file_descriptor] = ACTIONS(1976),
    [ts_builtin_sym_end] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_esac] = ACTIONS(1976),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_RPAREN] = ACTIONS(1976),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [anon_sym_BQUOTE] = ACTIONS(1976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [1191] = {
    [sym_file_redirect] = STATE(1191),
    [sym_heredoc_redirect] = STATE(1191),
    [sym_herestring_redirect] = STATE(1191),
    [aux_sym_while_statement_repeat1] = STATE(1191),
    [sym_file_descriptor] = ACTIONS(3616),
    [ts_builtin_sym_end] = ACTIONS(1984),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3619),
    [anon_sym_GT_GT] = ACTIONS(3622),
    [anon_sym_AMP_GT] = ACTIONS(3619),
    [anon_sym_AMP_GT_GT] = ACTIONS(3622),
    [anon_sym_LT_AMP] = ACTIONS(3622),
    [anon_sym_GT_AMP] = ACTIONS(3622),
    [anon_sym_LT_LT] = ACTIONS(3625),
    [anon_sym_LT_LT_DASH] = ACTIONS(3628),
    [anon_sym_LT_LT_LT] = ACTIONS(3631),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1989),
  },
  [1192] = {
    [sym__concat] = ACTIONS(2876),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_RPAREN] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2876),
    [anon_sym_EQ_TILDE] = ACTIONS(2876),
    [anon_sym_EQ_EQ] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2878),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2876),
    [anon_sym_BANG_EQ] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2876),
  },
  [1193] = {
    [sym__concat] = ACTIONS(2890),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2890),
    [anon_sym_EQ_TILDE] = ACTIONS(2890),
    [anon_sym_EQ_EQ] = ACTIONS(2890),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2890),
    [anon_sym_GT] = ACTIONS(2890),
    [anon_sym_BANG_EQ] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2890),
  },
  [1194] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3634),
    [sym_comment] = ACTIONS(53),
  },
  [1195] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3636),
    [sym_comment] = ACTIONS(53),
  },
  [1196] = {
    [anon_sym_RBRACE] = ACTIONS(3636),
    [sym_comment] = ACTIONS(53),
  },
  [1197] = {
    [sym_concatenation] = STATE(1600),
    [sym_string] = STATE(1599),
    [sym_simple_expansion] = STATE(1599),
    [sym_string_expansion] = STATE(1599),
    [sym_expansion] = STATE(1599),
    [sym_command_substitution] = STATE(1599),
    [sym_process_substitution] = STATE(1599),
    [anon_sym_RBRACE] = ACTIONS(3636),
    [sym__special_characters] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3640),
  },
  [1198] = {
    [sym__concat] = ACTIONS(2926),
    [anon_sym_PIPE] = ACTIONS(2928),
    [anon_sym_RPAREN] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2926),
    [anon_sym_EQ_TILDE] = ACTIONS(2926),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2926),
    [anon_sym_GT] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2926),
  },
  [1199] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3642),
  },
  [1200] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3644),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1201] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3646),
  },
  [1202] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3636),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1203] = {
    [sym_concatenation] = STATE(1605),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1605),
    [anon_sym_RBRACE] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3650),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3650),
    [anon_sym_COLON_QMARK] = ACTIONS(3650),
    [anon_sym_COLON_DASH] = ACTIONS(3650),
    [anon_sym_PERCENT] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1204] = {
    [sym__concat] = ACTIONS(2990),
    [anon_sym_PIPE] = ACTIONS(2992),
    [anon_sym_RPAREN] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2990),
    [anon_sym_EQ_TILDE] = ACTIONS(2990),
    [anon_sym_EQ_EQ] = ACTIONS(2990),
    [anon_sym_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_GT] = ACTIONS(2990),
    [anon_sym_BANG_EQ] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2990),
  },
  [1205] = {
    [sym_concatenation] = STATE(1606),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1606),
    [anon_sym_RBRACE] = ACTIONS(3636),
    [anon_sym_EQ] = ACTIONS(3654),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3656),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3654),
    [anon_sym_COLON_QMARK] = ACTIONS(3654),
    [anon_sym_COLON_DASH] = ACTIONS(3654),
    [anon_sym_PERCENT] = ACTIONS(3654),
    [anon_sym_DASH] = ACTIONS(3654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1206] = {
    [sym__concat] = ACTIONS(3033),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3033),
    [anon_sym_EQ_TILDE] = ACTIONS(3033),
    [anon_sym_EQ_EQ] = ACTIONS(3033),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_GT] = ACTIONS(3033),
    [anon_sym_BANG_EQ] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3033),
  },
  [1207] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1208] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3658),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1209] = {
    [sym__concat] = ACTIONS(3071),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3071),
    [anon_sym_EQ_TILDE] = ACTIONS(3071),
    [anon_sym_EQ_EQ] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3071),
    [anon_sym_GT] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3071),
  },
  [1210] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3660),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1211] = {
    [sym_variable_name] = ACTIONS(2056),
    [ts_builtin_sym_end] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_PIPE] = ACTIONS(2058),
    [anon_sym_RPAREN] = ACTIONS(2056),
    [anon_sym_SEMI_SEMI] = ACTIONS(2056),
    [anon_sym_PIPE_AMP] = ACTIONS(2056),
    [anon_sym_AMP_AMP] = ACTIONS(2056),
    [anon_sym_PIPE_PIPE] = ACTIONS(2056),
    [sym__special_characters] = ACTIONS(2056),
    [anon_sym_DQUOTE] = ACTIONS(2056),
    [anon_sym_DOLLAR] = ACTIONS(2058),
    [sym_raw_string] = ACTIONS(2056),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2056),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2056),
    [anon_sym_BQUOTE] = ACTIONS(2056),
    [anon_sym_LT_LPAREN] = ACTIONS(2056),
    [anon_sym_GT_LPAREN] = ACTIONS(2056),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2058),
    [sym_word] = ACTIONS(2058),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2058),
  },
  [1212] = {
    [sym_concatenation] = STATE(977),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_string_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [aux_sym_for_statement_repeat1] = STATE(977),
    [anon_sym_RPAREN] = ACTIONS(3662),
    [sym__special_characters] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym_raw_string] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1083),
  },
  [1213] = {
    [sym__concat] = ACTIONS(2876),
    [sym_variable_name] = ACTIONS(2876),
    [ts_builtin_sym_end] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_RPAREN] = ACTIONS(2876),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [sym__special_characters] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [anon_sym_LT_LPAREN] = ACTIONS(2876),
    [anon_sym_GT_LPAREN] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2878),
    [sym_word] = ACTIONS(2878),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2878),
  },
  [1214] = {
    [sym__concat] = ACTIONS(2890),
    [sym_variable_name] = ACTIONS(2890),
    [ts_builtin_sym_end] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [anon_sym_PIPE_AMP] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [sym__special_characters] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [anon_sym_LT_LPAREN] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2892),
    [sym_word] = ACTIONS(2892),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2892),
  },
  [1215] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [sym_comment] = ACTIONS(53),
  },
  [1216] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3666),
    [sym_comment] = ACTIONS(53),
  },
  [1217] = {
    [anon_sym_RBRACE] = ACTIONS(3666),
    [sym_comment] = ACTIONS(53),
  },
  [1218] = {
    [sym_concatenation] = STATE(1614),
    [sym_string] = STATE(1613),
    [sym_simple_expansion] = STATE(1613),
    [sym_string_expansion] = STATE(1613),
    [sym_expansion] = STATE(1613),
    [sym_command_substitution] = STATE(1613),
    [sym_process_substitution] = STATE(1613),
    [anon_sym_RBRACE] = ACTIONS(3666),
    [sym__special_characters] = ACTIONS(3668),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3670),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3670),
  },
  [1219] = {
    [sym__concat] = ACTIONS(2926),
    [sym_variable_name] = ACTIONS(2926),
    [ts_builtin_sym_end] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_PIPE] = ACTIONS(2928),
    [anon_sym_RPAREN] = ACTIONS(2926),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE_AMP] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [sym__special_characters] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym_raw_string] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [anon_sym_LT_LPAREN] = ACTIONS(2926),
    [anon_sym_GT_LPAREN] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2928),
    [sym_word] = ACTIONS(2928),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2928),
  },
  [1220] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3672),
  },
  [1221] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3674),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1222] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3676),
  },
  [1223] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3666),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1224] = {
    [sym_concatenation] = STATE(1619),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1619),
    [anon_sym_RBRACE] = ACTIONS(3678),
    [anon_sym_EQ] = ACTIONS(3680),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3680),
    [anon_sym_COLON_QMARK] = ACTIONS(3680),
    [anon_sym_COLON_DASH] = ACTIONS(3680),
    [anon_sym_PERCENT] = ACTIONS(3680),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1225] = {
    [sym__concat] = ACTIONS(2990),
    [sym_variable_name] = ACTIONS(2990),
    [ts_builtin_sym_end] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(2992),
    [anon_sym_RPAREN] = ACTIONS(2990),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [anon_sym_PIPE_AMP] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [sym__special_characters] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym_raw_string] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_LT_LPAREN] = ACTIONS(2990),
    [anon_sym_GT_LPAREN] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2992),
    [sym_word] = ACTIONS(2992),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2992),
  },
  [1226] = {
    [sym_concatenation] = STATE(1620),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1620),
    [anon_sym_RBRACE] = ACTIONS(3666),
    [anon_sym_EQ] = ACTIONS(3684),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3684),
    [anon_sym_COLON_QMARK] = ACTIONS(3684),
    [anon_sym_COLON_DASH] = ACTIONS(3684),
    [anon_sym_PERCENT] = ACTIONS(3684),
    [anon_sym_DASH] = ACTIONS(3684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1227] = {
    [sym__concat] = ACTIONS(3033),
    [sym_variable_name] = ACTIONS(3033),
    [ts_builtin_sym_end] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(3033),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [anon_sym_PIPE_AMP] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [sym__special_characters] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [anon_sym_LT_LPAREN] = ACTIONS(3033),
    [anon_sym_GT_LPAREN] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3035),
    [sym_word] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3035),
  },
  [1228] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3688),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1229] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3688),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1230] = {
    [sym__concat] = ACTIONS(3071),
    [sym_variable_name] = ACTIONS(3071),
    [ts_builtin_sym_end] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [anon_sym_PIPE_AMP] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [sym__special_characters] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [sym_raw_string] = ACTIONS(3071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_LT_LPAREN] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3073),
    [sym_word] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
  },
  [1231] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3690),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1232] = {
    [sym__concat] = ACTIONS(2876),
    [ts_builtin_sym_end] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_RPAREN] = ACTIONS(2876),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [sym__special_characters] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [anon_sym_LT_LPAREN] = ACTIONS(2876),
    [anon_sym_GT_LPAREN] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2878),
    [sym_word] = ACTIONS(2878),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2878),
  },
  [1233] = {
    [sym__concat] = ACTIONS(2890),
    [ts_builtin_sym_end] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [anon_sym_PIPE_AMP] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [sym__special_characters] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [anon_sym_LT_LPAREN] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2892),
    [sym_word] = ACTIONS(2892),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2892),
  },
  [1234] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3692),
    [sym_comment] = ACTIONS(53),
  },
  [1235] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3694),
    [sym_comment] = ACTIONS(53),
  },
  [1236] = {
    [anon_sym_RBRACE] = ACTIONS(3694),
    [sym_comment] = ACTIONS(53),
  },
  [1237] = {
    [sym_concatenation] = STATE(1627),
    [sym_string] = STATE(1626),
    [sym_simple_expansion] = STATE(1626),
    [sym_string_expansion] = STATE(1626),
    [sym_expansion] = STATE(1626),
    [sym_command_substitution] = STATE(1626),
    [sym_process_substitution] = STATE(1626),
    [anon_sym_RBRACE] = ACTIONS(3694),
    [sym__special_characters] = ACTIONS(3696),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3698),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3698),
  },
  [1238] = {
    [sym__concat] = ACTIONS(2926),
    [ts_builtin_sym_end] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_PIPE] = ACTIONS(2928),
    [anon_sym_RPAREN] = ACTIONS(2926),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE_AMP] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [sym__special_characters] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym_raw_string] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [anon_sym_LT_LPAREN] = ACTIONS(2926),
    [anon_sym_GT_LPAREN] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2928),
    [sym_word] = ACTIONS(2928),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2928),
  },
  [1239] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3700),
  },
  [1240] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3702),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1241] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3704),
  },
  [1242] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3694),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1243] = {
    [sym_concatenation] = STATE(1632),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1632),
    [anon_sym_RBRACE] = ACTIONS(3706),
    [anon_sym_EQ] = ACTIONS(3708),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3708),
    [anon_sym_COLON_QMARK] = ACTIONS(3708),
    [anon_sym_COLON_DASH] = ACTIONS(3708),
    [anon_sym_PERCENT] = ACTIONS(3708),
    [anon_sym_DASH] = ACTIONS(3708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1244] = {
    [sym__concat] = ACTIONS(2990),
    [ts_builtin_sym_end] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(2992),
    [anon_sym_RPAREN] = ACTIONS(2990),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [anon_sym_PIPE_AMP] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [sym__special_characters] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym_raw_string] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_LT_LPAREN] = ACTIONS(2990),
    [anon_sym_GT_LPAREN] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2992),
    [sym_word] = ACTIONS(2992),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2992),
  },
  [1245] = {
    [sym_concatenation] = STATE(1633),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1633),
    [anon_sym_RBRACE] = ACTIONS(3694),
    [anon_sym_EQ] = ACTIONS(3712),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_COLON_QMARK] = ACTIONS(3712),
    [anon_sym_COLON_DASH] = ACTIONS(3712),
    [anon_sym_PERCENT] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1246] = {
    [sym__concat] = ACTIONS(3033),
    [ts_builtin_sym_end] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(3033),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [anon_sym_PIPE_AMP] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [sym__special_characters] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [anon_sym_LT_LPAREN] = ACTIONS(3033),
    [anon_sym_GT_LPAREN] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3035),
    [sym_word] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3035),
  },
  [1247] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3716),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1248] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3716),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1249] = {
    [sym__concat] = ACTIONS(3071),
    [ts_builtin_sym_end] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [anon_sym_PIPE_AMP] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [sym__special_characters] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [sym_raw_string] = ACTIONS(3071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_LT_LPAREN] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3073),
    [sym_word] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
  },
  [1250] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3718),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1251] = {
    [sym_file_descriptor] = ACTIONS(2876),
    [sym__concat] = ACTIONS(2876),
    [sym_variable_name] = ACTIONS(2876),
    [anon_sym_LT] = ACTIONS(2878),
    [anon_sym_GT] = ACTIONS(2878),
    [anon_sym_GT_GT] = ACTIONS(2876),
    [anon_sym_AMP_GT] = ACTIONS(2878),
    [anon_sym_AMP_GT_GT] = ACTIONS(2876),
    [anon_sym_LT_AMP] = ACTIONS(2876),
    [anon_sym_GT_AMP] = ACTIONS(2876),
    [sym__special_characters] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [anon_sym_LT_LPAREN] = ACTIONS(2876),
    [anon_sym_GT_LPAREN] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2876),
  },
  [1252] = {
    [sym_file_descriptor] = ACTIONS(2890),
    [sym__concat] = ACTIONS(2890),
    [sym_variable_name] = ACTIONS(2890),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2890),
    [anon_sym_AMP_GT] = ACTIONS(2892),
    [anon_sym_AMP_GT_GT] = ACTIONS(2890),
    [anon_sym_LT_AMP] = ACTIONS(2890),
    [anon_sym_GT_AMP] = ACTIONS(2890),
    [sym__special_characters] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [anon_sym_LT_LPAREN] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2890),
  },
  [1253] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3720),
    [sym_comment] = ACTIONS(53),
  },
  [1254] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [sym_comment] = ACTIONS(53),
  },
  [1255] = {
    [anon_sym_RBRACE] = ACTIONS(3722),
    [sym_comment] = ACTIONS(53),
  },
  [1256] = {
    [sym_concatenation] = STATE(1640),
    [sym_string] = STATE(1639),
    [sym_simple_expansion] = STATE(1639),
    [sym_string_expansion] = STATE(1639),
    [sym_expansion] = STATE(1639),
    [sym_command_substitution] = STATE(1639),
    [sym_process_substitution] = STATE(1639),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [sym__special_characters] = ACTIONS(3724),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3726),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3726),
  },
  [1257] = {
    [sym_file_descriptor] = ACTIONS(2926),
    [sym__concat] = ACTIONS(2926),
    [sym_variable_name] = ACTIONS(2926),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_GT] = ACTIONS(2928),
    [anon_sym_GT_GT] = ACTIONS(2926),
    [anon_sym_AMP_GT] = ACTIONS(2928),
    [anon_sym_AMP_GT_GT] = ACTIONS(2926),
    [anon_sym_LT_AMP] = ACTIONS(2926),
    [anon_sym_GT_AMP] = ACTIONS(2926),
    [sym__special_characters] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym_raw_string] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [anon_sym_LT_LPAREN] = ACTIONS(2926),
    [anon_sym_GT_LPAREN] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2926),
  },
  [1258] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3728),
  },
  [1259] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3730),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1260] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3732),
  },
  [1261] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1262] = {
    [sym_concatenation] = STATE(1645),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1645),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_EQ] = ACTIONS(3736),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3738),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3736),
    [anon_sym_COLON_QMARK] = ACTIONS(3736),
    [anon_sym_COLON_DASH] = ACTIONS(3736),
    [anon_sym_PERCENT] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1263] = {
    [sym_file_descriptor] = ACTIONS(2990),
    [sym__concat] = ACTIONS(2990),
    [sym_variable_name] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(2990),
    [anon_sym_AMP_GT] = ACTIONS(2992),
    [anon_sym_AMP_GT_GT] = ACTIONS(2990),
    [anon_sym_LT_AMP] = ACTIONS(2990),
    [anon_sym_GT_AMP] = ACTIONS(2990),
    [sym__special_characters] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym_raw_string] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_LT_LPAREN] = ACTIONS(2990),
    [anon_sym_GT_LPAREN] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2990),
  },
  [1264] = {
    [sym_concatenation] = STATE(1646),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1646),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [anon_sym_EQ] = ACTIONS(3740),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3742),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3740),
    [anon_sym_COLON_QMARK] = ACTIONS(3740),
    [anon_sym_COLON_DASH] = ACTIONS(3740),
    [anon_sym_PERCENT] = ACTIONS(3740),
    [anon_sym_DASH] = ACTIONS(3740),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1265] = {
    [sym_file_descriptor] = ACTIONS(3033),
    [sym__concat] = ACTIONS(3033),
    [sym_variable_name] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_GT_GT] = ACTIONS(3033),
    [anon_sym_AMP_GT] = ACTIONS(3035),
    [anon_sym_AMP_GT_GT] = ACTIONS(3033),
    [anon_sym_LT_AMP] = ACTIONS(3033),
    [anon_sym_GT_AMP] = ACTIONS(3033),
    [sym__special_characters] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [anon_sym_LT_LPAREN] = ACTIONS(3033),
    [anon_sym_GT_LPAREN] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3033),
  },
  [1266] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1267] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3744),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1268] = {
    [sym_file_descriptor] = ACTIONS(3071),
    [sym__concat] = ACTIONS(3071),
    [sym_variable_name] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_GT_GT] = ACTIONS(3071),
    [anon_sym_AMP_GT] = ACTIONS(3073),
    [anon_sym_AMP_GT_GT] = ACTIONS(3071),
    [anon_sym_LT_AMP] = ACTIONS(3071),
    [anon_sym_GT_AMP] = ACTIONS(3071),
    [sym__special_characters] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [sym_raw_string] = ACTIONS(3071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_LT_LPAREN] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3071),
  },
  [1269] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3746),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1270] = {
    [sym__concat] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2892),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym__string_content] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2892),
    [anon_sym_BQUOTE] = ACTIONS(2892),
    [sym_comment] = ACTIONS(265),
  },
  [1271] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3748),
    [sym_comment] = ACTIONS(53),
  },
  [1272] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3750),
    [sym_comment] = ACTIONS(53),
  },
  [1273] = {
    [anon_sym_RBRACE] = ACTIONS(3750),
    [sym_comment] = ACTIONS(53),
  },
  [1274] = {
    [sym_concatenation] = STATE(1653),
    [sym_string] = STATE(1652),
    [sym_simple_expansion] = STATE(1652),
    [sym_string_expansion] = STATE(1652),
    [sym_expansion] = STATE(1652),
    [sym_command_substitution] = STATE(1652),
    [sym_process_substitution] = STATE(1652),
    [anon_sym_RBRACE] = ACTIONS(3750),
    [sym__special_characters] = ACTIONS(3752),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3754),
  },
  [1275] = {
    [sym__concat] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym__string_content] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2928),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2928),
    [anon_sym_BQUOTE] = ACTIONS(2928),
    [sym_comment] = ACTIONS(265),
  },
  [1276] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3756),
  },
  [1277] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1278] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3760),
  },
  [1279] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3750),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1280] = {
    [sym_concatenation] = STATE(1658),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1658),
    [anon_sym_RBRACE] = ACTIONS(3762),
    [anon_sym_EQ] = ACTIONS(3764),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3764),
    [anon_sym_COLON_QMARK] = ACTIONS(3764),
    [anon_sym_COLON_DASH] = ACTIONS(3764),
    [anon_sym_PERCENT] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1281] = {
    [sym__concat] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym__string_content] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2992),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(2992),
    [sym_comment] = ACTIONS(265),
  },
  [1282] = {
    [sym_concatenation] = STATE(1659),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1659),
    [anon_sym_RBRACE] = ACTIONS(3750),
    [anon_sym_EQ] = ACTIONS(3768),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3768),
    [anon_sym_COLON_QMARK] = ACTIONS(3768),
    [anon_sym_COLON_DASH] = ACTIONS(3768),
    [anon_sym_PERCENT] = ACTIONS(3768),
    [anon_sym_DASH] = ACTIONS(3768),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1283] = {
    [sym__concat] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym__string_content] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3035),
    [anon_sym_BQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(265),
  },
  [1284] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1285] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3772),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1286] = {
    [sym_string] = STATE(710),
    [sym_simple_expansion] = STATE(710),
    [sym_string_expansion] = STATE(710),
    [sym_expansion] = STATE(710),
    [sym_command_substitution] = STATE(710),
    [sym_process_substitution] = STATE(710),
    [anon_sym_RBRACK] = ACTIONS(3774),
    [sym__special_characters] = ACTIONS(2044),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(1355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1355),
  },
  [1287] = {
    [sym__concat] = ACTIONS(3776),
    [anon_sym_RBRACE] = ACTIONS(2048),
    [anon_sym_EQ] = ACTIONS(3778),
    [sym__special_characters] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(2048),
    [anon_sym_DOLLAR] = ACTIONS(3778),
    [sym_raw_string] = ACTIONS(2048),
    [anon_sym_POUND] = ACTIONS(2048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2048),
    [anon_sym_SLASH] = ACTIONS(2048),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_COLON_QMARK] = ACTIONS(3778),
    [anon_sym_COLON_DASH] = ACTIONS(3778),
    [anon_sym_PERCENT] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2048),
    [anon_sym_BQUOTE] = ACTIONS(2048),
    [anon_sym_LT_LPAREN] = ACTIONS(2048),
    [anon_sym_GT_LPAREN] = ACTIONS(2048),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3778),
  },
  [1288] = {
    [sym_string] = STATE(710),
    [sym_simple_expansion] = STATE(710),
    [sym_string_expansion] = STATE(710),
    [sym_expansion] = STATE(710),
    [sym_command_substitution] = STATE(710),
    [sym_process_substitution] = STATE(710),
    [anon_sym_RBRACK] = ACTIONS(3780),
    [sym__special_characters] = ACTIONS(2044),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(1355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1355),
  },
  [1289] = {
    [sym__concat] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_EQ] = ACTIONS(3784),
    [sym__special_characters] = ACTIONS(3784),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [anon_sym_DOLLAR] = ACTIONS(3784),
    [sym_raw_string] = ACTIONS(2054),
    [anon_sym_POUND] = ACTIONS(2054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2054),
    [anon_sym_SLASH] = ACTIONS(2054),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_COLON_QMARK] = ACTIONS(3784),
    [anon_sym_COLON_DASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_DASH] = ACTIONS(3784),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2054),
    [anon_sym_BQUOTE] = ACTIONS(2054),
    [anon_sym_LT_LPAREN] = ACTIONS(2054),
    [anon_sym_GT_LPAREN] = ACTIONS(2054),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3784),
  },
  [1290] = {
    [anon_sym_RBRACK] = ACTIONS(3780),
    [sym_comment] = ACTIONS(53),
  },
  [1291] = {
    [sym_string] = STATE(1665),
    [sym_simple_expansion] = STATE(1665),
    [sym_string_expansion] = STATE(1665),
    [sym_expansion] = STATE(1665),
    [sym_command_substitution] = STATE(1665),
    [sym_process_substitution] = STATE(1665),
    [sym__special_characters] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3786),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3786),
  },
  [1292] = {
    [sym__simple_heredoc_body] = ACTIONS(3788),
    [sym__heredoc_body_beginning] = ACTIONS(3788),
    [sym_file_descriptor] = ACTIONS(3788),
    [sym__concat] = ACTIONS(3788),
    [ts_builtin_sym_end] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_PIPE] = ACTIONS(3790),
    [anon_sym_RPAREN] = ACTIONS(3788),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [anon_sym_PIPE_AMP] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_EQ_TILDE] = ACTIONS(3790),
    [anon_sym_EQ_EQ] = ACTIONS(3790),
    [anon_sym_LT] = ACTIONS(3790),
    [anon_sym_GT] = ACTIONS(3790),
    [anon_sym_GT_GT] = ACTIONS(3788),
    [anon_sym_AMP_GT] = ACTIONS(3790),
    [anon_sym_AMP_GT_GT] = ACTIONS(3788),
    [anon_sym_LT_AMP] = ACTIONS(3788),
    [anon_sym_GT_AMP] = ACTIONS(3788),
    [anon_sym_LT_LT] = ACTIONS(3790),
    [anon_sym_LT_LT_DASH] = ACTIONS(3788),
    [anon_sym_LT_LT_LT] = ACTIONS(3788),
    [sym__special_characters] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LT_LPAREN] = ACTIONS(3788),
    [anon_sym_GT_LPAREN] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3790),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3790),
  },
  [1293] = {
    [aux_sym_concatenation_repeat1] = STATE(1666),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
  },
  [1294] = {
    [sym__concat] = ACTIONS(769),
    [anon_sym_RBRACE] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
  },
  [1295] = {
    [anon_sym_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [1296] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(3794),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [1297] = {
    [sym__concat] = ACTIONS(803),
    [anon_sym_RBRACE] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
  },
  [1298] = {
    [sym__concat] = ACTIONS(807),
    [anon_sym_RBRACE] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
  },
  [1299] = {
    [sym__concat] = ACTIONS(811),
    [anon_sym_RBRACE] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
  },
  [1300] = {
    [sym__simple_heredoc_body] = ACTIONS(3796),
    [sym__heredoc_body_beginning] = ACTIONS(3796),
    [sym_file_descriptor] = ACTIONS(3796),
    [sym__concat] = ACTIONS(3796),
    [ts_builtin_sym_end] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3798),
    [anon_sym_RPAREN] = ACTIONS(3796),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [anon_sym_PIPE_AMP] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [anon_sym_EQ_TILDE] = ACTIONS(3798),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_GT] = ACTIONS(3798),
    [anon_sym_GT_GT] = ACTIONS(3796),
    [anon_sym_AMP_GT] = ACTIONS(3798),
    [anon_sym_AMP_GT_GT] = ACTIONS(3796),
    [anon_sym_LT_AMP] = ACTIONS(3796),
    [anon_sym_GT_AMP] = ACTIONS(3796),
    [anon_sym_LT_LT] = ACTIONS(3798),
    [anon_sym_LT_LT_DASH] = ACTIONS(3796),
    [anon_sym_LT_LT_LT] = ACTIONS(3796),
    [sym__special_characters] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym_raw_string] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3796),
    [anon_sym_GT_LPAREN] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3798),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3798),
  },
  [1301] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(3800),
    [sym_comment] = ACTIONS(53),
  },
  [1302] = {
    [sym_subscript] = STATE(1672),
    [sym_variable_name] = ACTIONS(3802),
    [anon_sym_DOLLAR] = ACTIONS(3804),
    [anon_sym_DASH] = ACTIONS(3804),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3806),
    [anon_sym_STAR] = ACTIONS(3808),
    [anon_sym_AT] = ACTIONS(3808),
    [anon_sym_QMARK] = ACTIONS(3808),
    [anon_sym_0] = ACTIONS(3806),
    [anon_sym__] = ACTIONS(3806),
  },
  [1303] = {
    [sym_concatenation] = STATE(1675),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1675),
    [anon_sym_RBRACE] = ACTIONS(3810),
    [anon_sym_EQ] = ACTIONS(3812),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3814),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3812),
    [anon_sym_COLON_QMARK] = ACTIONS(3812),
    [anon_sym_COLON_DASH] = ACTIONS(3812),
    [anon_sym_PERCENT] = ACTIONS(3812),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1304] = {
    [sym_concatenation] = STATE(1678),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1678),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3824),
    [anon_sym_COLON] = ACTIONS(3820),
    [anon_sym_COLON_QMARK] = ACTIONS(3820),
    [anon_sym_COLON_DASH] = ACTIONS(3820),
    [anon_sym_PERCENT] = ACTIONS(3820),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1305] = {
    [anon_sym_SEMI] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3828),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3826),
  },
  [1306] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3826),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3828),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3826),
  },
  [1307] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1681),
    [sym_c_style_for_statement] = STATE(1681),
    [sym_while_statement] = STATE(1681),
    [sym_if_statement] = STATE(1681),
    [sym_case_statement] = STATE(1681),
    [sym_function_definition] = STATE(1681),
    [sym_subshell] = STATE(1681),
    [sym_pipeline] = STATE(1681),
    [sym_list] = STATE(1681),
    [sym_negated_command] = STATE(1681),
    [sym_test_command] = STATE(1681),
    [sym_declaration_command] = STATE(1681),
    [sym_unset_command] = STATE(1681),
    [sym_command] = STATE(1681),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1682),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1308] = {
    [anon_sym_SEMI] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(3834),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(3828),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3832),
  },
  [1309] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3832),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(3834),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(3828),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3832),
  },
  [1310] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1684),
    [sym_c_style_for_statement] = STATE(1684),
    [sym_while_statement] = STATE(1684),
    [sym_if_statement] = STATE(1684),
    [sym_case_statement] = STATE(1684),
    [sym_function_definition] = STATE(1684),
    [sym_subshell] = STATE(1684),
    [sym_pipeline] = STATE(1684),
    [sym_list] = STATE(1684),
    [sym_negated_command] = STATE(1684),
    [sym_test_command] = STATE(1684),
    [sym_declaration_command] = STATE(1684),
    [sym_unset_command] = STATE(1684),
    [sym_command] = STATE(1684),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(1685),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [1311] = {
    [anon_sym_SEMI] = ACTIONS(3836),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3838),
    [anon_sym_SEMI_SEMI] = ACTIONS(3840),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3840),
    [anon_sym_AMP] = ACTIONS(3836),
  },
  [1312] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3836),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3838),
    [anon_sym_SEMI_SEMI] = ACTIONS(3840),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3840),
    [anon_sym_AMP] = ACTIONS(3836),
  },
  [1313] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1688),
    [sym_c_style_for_statement] = STATE(1688),
    [sym_while_statement] = STATE(1688),
    [sym_if_statement] = STATE(1688),
    [sym_case_statement] = STATE(1688),
    [sym_function_definition] = STATE(1688),
    [sym_subshell] = STATE(1688),
    [sym_pipeline] = STATE(1688),
    [sym_list] = STATE(1688),
    [sym_negated_command] = STATE(1688),
    [sym_test_command] = STATE(1688),
    [sym_declaration_command] = STATE(1688),
    [sym_unset_command] = STATE(1688),
    [sym_command] = STATE(1688),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1689),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1314] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3842),
    [sym_comment] = ACTIONS(53),
  },
  [1315] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(3844),
    [sym_comment] = ACTIONS(53),
  },
  [1316] = {
    [anon_sym_RBRACE] = ACTIONS(3844),
    [sym_comment] = ACTIONS(53),
  },
  [1317] = {
    [sym_concatenation] = STATE(1693),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1693),
    [anon_sym_RBRACE] = ACTIONS(3846),
    [anon_sym_EQ] = ACTIONS(3848),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3848),
    [anon_sym_COLON_QMARK] = ACTIONS(3848),
    [anon_sym_COLON_DASH] = ACTIONS(3848),
    [anon_sym_PERCENT] = ACTIONS(3848),
    [anon_sym_DASH] = ACTIONS(3848),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1318] = {
    [sym__simple_heredoc_body] = ACTIONS(3852),
    [sym__heredoc_body_beginning] = ACTIONS(3852),
    [sym_file_descriptor] = ACTIONS(3852),
    [sym__concat] = ACTIONS(3852),
    [ts_builtin_sym_end] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_PIPE] = ACTIONS(3854),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [anon_sym_PIPE_AMP] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3854),
    [anon_sym_EQ_EQ] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_GT] = ACTIONS(3854),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_AMP_GT] = ACTIONS(3854),
    [anon_sym_AMP_GT_GT] = ACTIONS(3852),
    [anon_sym_LT_AMP] = ACTIONS(3852),
    [anon_sym_GT_AMP] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3854),
    [anon_sym_LT_LT_DASH] = ACTIONS(3852),
    [anon_sym_LT_LT_LT] = ACTIONS(3852),
    [sym__special_characters] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym_raw_string] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_LT_LPAREN] = ACTIONS(3852),
    [anon_sym_GT_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3854),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3854),
  },
  [1319] = {
    [sym_concatenation] = STATE(1694),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1694),
    [anon_sym_RBRACE] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(3856),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3858),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_COLON_DASH] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1320] = {
    [sym__concat] = ACTIONS(1724),
    [anon_sym_RBRACE] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_POUND] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_COLON] = ACTIONS(1726),
    [anon_sym_COLON_QMARK] = ACTIONS(1726),
    [anon_sym_COLON_DASH] = ACTIONS(1726),
    [anon_sym_PERCENT] = ACTIONS(1726),
    [anon_sym_DASH] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1726),
  },
  [1321] = {
    [aux_sym_concatenation_repeat1] = STATE(1321),
    [sym__concat] = ACTIONS(3860),
    [anon_sym_RBRACE] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1726),
    [sym__special_characters] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_POUND] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_COLON] = ACTIONS(1726),
    [anon_sym_COLON_QMARK] = ACTIONS(1726),
    [anon_sym_COLON_DASH] = ACTIONS(1726),
    [anon_sym_PERCENT] = ACTIONS(1726),
    [anon_sym_DASH] = ACTIONS(1726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1726),
  },
  [1322] = {
    [sym__concat] = ACTIONS(1731),
    [anon_sym_RBRACE] = ACTIONS(1731),
    [anon_sym_EQ] = ACTIONS(1733),
    [sym__special_characters] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_POUND] = ACTIONS(1731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1731),
    [anon_sym_COLON] = ACTIONS(1733),
    [anon_sym_COLON_QMARK] = ACTIONS(1733),
    [anon_sym_COLON_DASH] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(1733),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1731),
    [anon_sym_GT_LPAREN] = ACTIONS(1731),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1733),
  },
  [1323] = {
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [1324] = {
    [sym_concatenation] = STATE(1699),
    [sym_string] = STATE(1698),
    [sym_simple_expansion] = STATE(1698),
    [sym_string_expansion] = STATE(1698),
    [sym_expansion] = STATE(1698),
    [sym_command_substitution] = STATE(1698),
    [sym_process_substitution] = STATE(1698),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [sym__special_characters] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3869),
  },
  [1325] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(3871),
    [sym_comment] = ACTIONS(53),
  },
  [1326] = {
    [sym_concatenation] = STATE(1703),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1703),
    [anon_sym_RBRACE] = ACTIONS(3873),
    [anon_sym_EQ] = ACTIONS(3875),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3875),
    [anon_sym_COLON_QMARK] = ACTIONS(3875),
    [anon_sym_COLON_DASH] = ACTIONS(3875),
    [anon_sym_PERCENT] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1327] = {
    [sym_concatenation] = STATE(1705),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1705),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_EQ] = ACTIONS(3881),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3885),
    [anon_sym_COLON] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3881),
    [anon_sym_COLON_DASH] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1328] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_RBRACE] = ACTIONS(1832),
    [anon_sym_EQ] = ACTIONS(1834),
    [sym__special_characters] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_POUND] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_COLON] = ACTIONS(1834),
    [anon_sym_COLON_QMARK] = ACTIONS(1834),
    [anon_sym_COLON_DASH] = ACTIONS(1834),
    [anon_sym_PERCENT] = ACTIONS(1834),
    [anon_sym_DASH] = ACTIONS(1834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1834),
  },
  [1329] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3887),
  },
  [1330] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3889),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1331] = {
    [sym__concat] = ACTIONS(1876),
    [anon_sym_RBRACE] = ACTIONS(1876),
    [anon_sym_EQ] = ACTIONS(1878),
    [sym__special_characters] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1876),
    [anon_sym_POUND] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [anon_sym_COLON] = ACTIONS(1878),
    [anon_sym_COLON_QMARK] = ACTIONS(1878),
    [anon_sym_COLON_DASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [anon_sym_LT_LPAREN] = ACTIONS(1876),
    [anon_sym_GT_LPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1878),
  },
  [1332] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3891),
  },
  [1333] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1334] = {
    [sym__simple_heredoc_body] = ACTIONS(3893),
    [sym__heredoc_body_beginning] = ACTIONS(3893),
    [sym_file_descriptor] = ACTIONS(3893),
    [sym__concat] = ACTIONS(3893),
    [ts_builtin_sym_end] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_RPAREN] = ACTIONS(3893),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [anon_sym_PIPE_AMP] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_EQ_TILDE] = ACTIONS(3895),
    [anon_sym_EQ_EQ] = ACTIONS(3895),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_GT_GT] = ACTIONS(3893),
    [anon_sym_AMP_GT] = ACTIONS(3895),
    [anon_sym_AMP_GT_GT] = ACTIONS(3893),
    [anon_sym_LT_AMP] = ACTIONS(3893),
    [anon_sym_GT_AMP] = ACTIONS(3893),
    [anon_sym_LT_LT] = ACTIONS(3895),
    [anon_sym_LT_LT_DASH] = ACTIONS(3893),
    [anon_sym_LT_LT_LT] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LT_LPAREN] = ACTIONS(3893),
    [anon_sym_GT_LPAREN] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3895),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3895),
  },
  [1335] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3897),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1336] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3899),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1337] = {
    [sym__concat] = ACTIONS(1884),
    [anon_sym_RBRACE] = ACTIONS(1884),
    [anon_sym_EQ] = ACTIONS(1886),
    [sym__special_characters] = ACTIONS(1886),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym_raw_string] = ACTIONS(1884),
    [anon_sym_POUND] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_COLON] = ACTIONS(1886),
    [anon_sym_COLON_QMARK] = ACTIONS(1886),
    [anon_sym_COLON_DASH] = ACTIONS(1886),
    [anon_sym_PERCENT] = ACTIONS(1886),
    [anon_sym_DASH] = ACTIONS(1886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(1884),
    [anon_sym_GT_LPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1886),
  },
  [1338] = {
    [anon_sym_SEMI] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3899),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3901),
  },
  [1339] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3899),
    [anon_sym_SEMI_SEMI] = ACTIONS(3903),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3901),
  },
  [1340] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(3899),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1341] = {
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(3907),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(3899),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3907),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [1342] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(3907),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(3899),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3907),
    [anon_sym_AMP] = ACTIONS(3905),
  },
  [1343] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(3909),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1344] = {
    [sym__concat] = ACTIONS(1916),
    [anon_sym_RBRACE] = ACTIONS(1916),
    [anon_sym_EQ] = ACTIONS(1918),
    [sym__special_characters] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1916),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1916),
    [anon_sym_POUND] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1916),
    [anon_sym_COLON] = ACTIONS(1918),
    [anon_sym_COLON_QMARK] = ACTIONS(1918),
    [anon_sym_COLON_DASH] = ACTIONS(1918),
    [anon_sym_PERCENT] = ACTIONS(1918),
    [anon_sym_DASH] = ACTIONS(1918),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1916),
    [anon_sym_GT_LPAREN] = ACTIONS(1916),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(1918),
  },
  [1345] = {
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3909),
    [anon_sym_SEMI_SEMI] = ACTIONS(3913),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3913),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [1346] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(3909),
    [anon_sym_SEMI_SEMI] = ACTIONS(3913),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(3913),
    [anon_sym_AMP] = ACTIONS(3911),
  },
  [1347] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1348] = {
    [sym__simple_heredoc_body] = ACTIONS(3915),
    [sym__heredoc_body_beginning] = ACTIONS(3915),
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [ts_builtin_sym_end] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_EQ_TILDE] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3915),
    [anon_sym_LT_AMP] = ACTIONS(3915),
    [anon_sym_GT_AMP] = ACTIONS(3915),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_LT_LT_DASH] = ACTIONS(3915),
    [anon_sym_LT_LT_LT] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [1349] = {
    [sym_file_redirect] = STATE(928),
    [sym_heredoc_redirect] = STATE(928),
    [sym_heredoc_body] = STATE(1086),
    [sym_herestring_redirect] = STATE(928),
    [aux_sym_while_statement_repeat1] = STATE(928),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(2331),
    [anon_sym_PIPE] = ACTIONS(2331),
    [anon_sym_SEMI_SEMI] = ACTIONS(2329),
    [anon_sym_PIPE_AMP] = ACTIONS(2329),
    [anon_sym_AMP_AMP] = ACTIONS(2329),
    [anon_sym_PIPE_PIPE] = ACTIONS(2329),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_AMP_GT] = ACTIONS(887),
    [anon_sym_AMP_GT_GT] = ACTIONS(889),
    [anon_sym_LT_AMP] = ACTIONS(889),
    [anon_sym_GT_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(891),
    [anon_sym_BQUOTE] = ACTIONS(2329),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2329),
    [anon_sym_AMP] = ACTIONS(2331),
  },
  [1350] = {
    [sym_compound_statement] = STATE(1715),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [1351] = {
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_GT_GT] = ACTIONS(3921),
    [anon_sym_AMP_GT] = ACTIONS(3919),
    [anon_sym_AMP_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_AMP] = ACTIONS(3921),
    [anon_sym_GT_AMP] = ACTIONS(3921),
    [sym_comment] = ACTIONS(53),
  },
  [1352] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(1718),
    [sym_simple_expansion] = STATE(1718),
    [sym_string_expansion] = STATE(1718),
    [sym_expansion] = STATE(1718),
    [sym_command_substitution] = STATE(1718),
    [sym_process_substitution] = STATE(1718),
    [sym__special_characters] = ACTIONS(3923),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(3925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3925),
  },
  [1353] = {
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_AMP] = ACTIONS(3929),
    [anon_sym_GT_AMP] = ACTIONS(3929),
    [sym_comment] = ACTIONS(53),
  },
  [1354] = {
    [sym_concatenation] = STATE(1186),
    [sym_string] = STATE(1721),
    [sym_simple_expansion] = STATE(1721),
    [sym_string_expansion] = STATE(1721),
    [sym_expansion] = STATE(1721),
    [sym_command_substitution] = STATE(1721),
    [sym_process_substitution] = STATE(1721),
    [sym__special_characters] = ACTIONS(3931),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(3933),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3933),
  },
  [1355] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(1723),
    [sym_simple_expansion] = STATE(1723),
    [sym_string_expansion] = STATE(1723),
    [sym_expansion] = STATE(1723),
    [sym_command_substitution] = STATE(1723),
    [sym_process_substitution] = STATE(1723),
    [sym__special_characters] = ACTIONS(3935),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(3937),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3937),
  },
  [1356] = {
    [sym_file_redirect] = STATE(1724),
    [sym_heredoc_redirect] = STATE(1724),
    [sym_herestring_redirect] = STATE(1724),
    [aux_sym_while_statement_repeat1] = STATE(1724),
    [sym_file_descriptor] = ACTIONS(3047),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_GT_GT] = ACTIONS(3051),
    [anon_sym_AMP_GT] = ACTIONS(3049),
    [anon_sym_AMP_GT_GT] = ACTIONS(3051),
    [anon_sym_LT_AMP] = ACTIONS(3051),
    [anon_sym_GT_AMP] = ACTIONS(3051),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_LT_LT_DASH] = ACTIONS(1415),
    [anon_sym_LT_LT_LT] = ACTIONS(3053),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [1357] = {
    [sym_file_redirect] = STATE(1363),
    [sym_file_descriptor] = ACTIONS(3041),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_SEMI_SEMI] = ACTIONS(2460),
    [anon_sym_PIPE_AMP] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(3043),
    [anon_sym_GT] = ACTIONS(3043),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_GT] = ACTIONS(3043),
    [anon_sym_AMP_GT_GT] = ACTIONS(3045),
    [anon_sym_LT_AMP] = ACTIONS(3045),
    [anon_sym_GT_AMP] = ACTIONS(3045),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
  },
  [1358] = {
    [aux_sym_concatenation_repeat1] = STATE(1360),
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1359] = {
    [aux_sym_concatenation_repeat1] = STATE(1360),
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1360] = {
    [aux_sym_concatenation_repeat1] = STATE(1725),
    [sym__simple_heredoc_body] = ACTIONS(765),
    [sym__heredoc_body_beginning] = ACTIONS(765),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [1361] = {
    [sym_file_redirect] = STATE(928),
    [sym_heredoc_redirect] = STATE(928),
    [sym_heredoc_body] = STATE(1375),
    [sym_herestring_redirect] = STATE(928),
    [aux_sym_while_statement_repeat1] = STATE(928),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3120),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_PIPE_AMP] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_AMP_GT] = ACTIONS(887),
    [anon_sym_AMP_GT_GT] = ACTIONS(889),
    [anon_sym_LT_AMP] = ACTIONS(889),
    [anon_sym_GT_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(891),
    [anon_sym_BQUOTE] = ACTIONS(3118),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3120),
  },
  [1362] = {
    [sym__simple_heredoc_body] = ACTIONS(3939),
    [sym__heredoc_body_beginning] = ACTIONS(3939),
    [sym_file_descriptor] = ACTIONS(3939),
    [sym__concat] = ACTIONS(3939),
    [ts_builtin_sym_end] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_RPAREN] = ACTIONS(3939),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [anon_sym_PIPE_AMP] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_EQ_TILDE] = ACTIONS(3941),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3939),
    [anon_sym_AMP_GT] = ACTIONS(3941),
    [anon_sym_AMP_GT_GT] = ACTIONS(3939),
    [anon_sym_LT_AMP] = ACTIONS(3939),
    [anon_sym_GT_AMP] = ACTIONS(3939),
    [anon_sym_LT_LT] = ACTIONS(3941),
    [anon_sym_LT_LT_DASH] = ACTIONS(3939),
    [anon_sym_LT_LT_LT] = ACTIONS(3939),
    [sym__special_characters] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [sym_raw_string] = ACTIONS(3939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LT_LPAREN] = ACTIONS(3939),
    [anon_sym_GT_LPAREN] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3941),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3941),
  },
  [1363] = {
    [ts_builtin_sym_end] = ACTIONS(3520),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_esac] = ACTIONS(3520),
    [anon_sym_PIPE] = ACTIONS(3522),
    [anon_sym_RPAREN] = ACTIONS(3520),
    [anon_sym_SEMI_SEMI] = ACTIONS(3520),
    [anon_sym_PIPE_AMP] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_BQUOTE] = ACTIONS(3520),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3522),
  },
  [1364] = {
    [sym_concatenation] = STATE(1729),
    [sym_string] = STATE(1728),
    [sym_simple_expansion] = STATE(1728),
    [sym_string_expansion] = STATE(1728),
    [sym_expansion] = STATE(1728),
    [sym_command_substitution] = STATE(1728),
    [sym_process_substitution] = STATE(1728),
    [anon_sym_RBRACE] = ACTIONS(3943),
    [sym__special_characters] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3947),
  },
  [1365] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(3949),
    [sym_comment] = ACTIONS(53),
  },
  [1366] = {
    [sym_concatenation] = STATE(1733),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1733),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [anon_sym_EQ] = ACTIONS(3953),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3957),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_COLON_QMARK] = ACTIONS(3953),
    [anon_sym_COLON_DASH] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1367] = {
    [sym_concatenation] = STATE(1735),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1735),
    [anon_sym_RBRACE] = ACTIONS(3943),
    [anon_sym_EQ] = ACTIONS(3959),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3959),
    [anon_sym_COLON_QMARK] = ACTIONS(3959),
    [anon_sym_COLON_DASH] = ACTIONS(3959),
    [anon_sym_PERCENT] = ACTIONS(3959),
    [anon_sym_DASH] = ACTIONS(3959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1368] = {
    [sym__heredoc_body_middle] = ACTIONS(1832),
    [sym__heredoc_body_end] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
  },
  [1369] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3965),
  },
  [1370] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1371] = {
    [sym__heredoc_body_middle] = ACTIONS(1876),
    [sym__heredoc_body_end] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
  },
  [1372] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(3969),
  },
  [1373] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3943),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1374] = {
    [aux_sym_concatenation_repeat1] = STATE(1374),
    [sym__simple_heredoc_body] = ACTIONS(1724),
    [sym__heredoc_body_beginning] = ACTIONS(1724),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1728),
    [ts_builtin_sym_end] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1375] = {
    [ts_builtin_sym_end] = ACTIONS(3971),
    [anon_sym_SEMI] = ACTIONS(3973),
    [anon_sym_esac] = ACTIONS(3971),
    [anon_sym_PIPE] = ACTIONS(3973),
    [anon_sym_RPAREN] = ACTIONS(3971),
    [anon_sym_SEMI_SEMI] = ACTIONS(3971),
    [anon_sym_PIPE_AMP] = ACTIONS(3971),
    [anon_sym_AMP_AMP] = ACTIONS(3971),
    [anon_sym_PIPE_PIPE] = ACTIONS(3971),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3973),
  },
  [1376] = {
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_PLUS_EQ] = ACTIONS(3975),
    [sym_comment] = ACTIONS(53),
  },
  [1377] = {
    [anon_sym_EQ] = ACTIONS(3977),
    [anon_sym_PLUS_EQ] = ACTIONS(3977),
    [sym_comment] = ACTIONS(53),
  },
  [1378] = {
    [sym__concat] = ACTIONS(1724),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1724),
  },
  [1379] = {
    [aux_sym_concatenation_repeat1] = STATE(1379),
    [sym__concat] = ACTIONS(3979),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1724),
  },
  [1380] = {
    [sym__concat] = ACTIONS(1731),
    [anon_sym_RPAREN] = ACTIONS(1731),
    [sym__special_characters] = ACTIONS(1731),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1731),
    [anon_sym_GT_LPAREN] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1731),
  },
  [1381] = {
    [anon_sym_DQUOTE] = ACTIONS(3982),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [1382] = {
    [sym_concatenation] = STATE(1743),
    [sym_string] = STATE(1742),
    [sym_simple_expansion] = STATE(1742),
    [sym_string_expansion] = STATE(1742),
    [sym_expansion] = STATE(1742),
    [sym_command_substitution] = STATE(1742),
    [sym_process_substitution] = STATE(1742),
    [anon_sym_RBRACE] = ACTIONS(3984),
    [sym__special_characters] = ACTIONS(3986),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(3988),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3988),
  },
  [1383] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(3990),
    [sym_comment] = ACTIONS(53),
  },
  [1384] = {
    [sym_concatenation] = STATE(1747),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1747),
    [anon_sym_RBRACE] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3994),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(3996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(3998),
    [anon_sym_COLON] = ACTIONS(3994),
    [anon_sym_COLON_QMARK] = ACTIONS(3994),
    [anon_sym_COLON_DASH] = ACTIONS(3994),
    [anon_sym_PERCENT] = ACTIONS(3994),
    [anon_sym_DASH] = ACTIONS(3994),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1385] = {
    [sym_concatenation] = STATE(1749),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1749),
    [anon_sym_RBRACE] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(4000),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4004),
    [anon_sym_COLON] = ACTIONS(4000),
    [anon_sym_COLON_QMARK] = ACTIONS(4000),
    [anon_sym_COLON_DASH] = ACTIONS(4000),
    [anon_sym_PERCENT] = ACTIONS(4000),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1386] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1832),
  },
  [1387] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4006),
  },
  [1388] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1389] = {
    [sym__concat] = ACTIONS(1876),
    [anon_sym_RPAREN] = ACTIONS(1876),
    [sym__special_characters] = ACTIONS(1876),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [anon_sym_LT_LPAREN] = ACTIONS(1876),
    [anon_sym_GT_LPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1876),
  },
  [1390] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4010),
  },
  [1391] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1392] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1393] = {
    [sym__concat] = ACTIONS(1884),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [sym__special_characters] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym_raw_string] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(1884),
    [anon_sym_GT_LPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1884),
  },
  [1394] = {
    [anon_sym_SEMI] = ACTIONS(4014),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [anon_sym_SEMI_SEMI] = ACTIONS(4016),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4014),
  },
  [1395] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4014),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [anon_sym_SEMI_SEMI] = ACTIONS(4016),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4014),
  },
  [1396] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4012),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1397] = {
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(4020),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(4012),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [1398] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(4020),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(4012),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4018),
  },
  [1399] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4022),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1400] = {
    [sym__concat] = ACTIONS(1916),
    [anon_sym_RPAREN] = ACTIONS(1916),
    [sym__special_characters] = ACTIONS(1916),
    [anon_sym_DQUOTE] = ACTIONS(1916),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1916),
    [anon_sym_GT_LPAREN] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1916),
  },
  [1401] = {
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4022),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4024),
  },
  [1402] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4022),
    [anon_sym_SEMI_SEMI] = ACTIONS(4026),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4024),
  },
  [1403] = {
    [sym_file_descriptor] = ACTIONS(2876),
    [sym__concat] = ACTIONS(2876),
    [sym_variable_name] = ACTIONS(2876),
    [ts_builtin_sym_end] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_RPAREN] = ACTIONS(2876),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [anon_sym_LT] = ACTIONS(2878),
    [anon_sym_GT] = ACTIONS(2878),
    [anon_sym_GT_GT] = ACTIONS(2876),
    [anon_sym_AMP_GT] = ACTIONS(2878),
    [anon_sym_AMP_GT_GT] = ACTIONS(2876),
    [anon_sym_LT_AMP] = ACTIONS(2876),
    [anon_sym_GT_AMP] = ACTIONS(2876),
    [sym__special_characters] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [anon_sym_LT_LPAREN] = ACTIONS(2876),
    [anon_sym_GT_LPAREN] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2878),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2878),
  },
  [1404] = {
    [sym_file_descriptor] = ACTIONS(2890),
    [sym__concat] = ACTIONS(2890),
    [sym_variable_name] = ACTIONS(2890),
    [ts_builtin_sym_end] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [anon_sym_PIPE_AMP] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2890),
    [anon_sym_AMP_GT] = ACTIONS(2892),
    [anon_sym_AMP_GT_GT] = ACTIONS(2890),
    [anon_sym_LT_AMP] = ACTIONS(2890),
    [anon_sym_GT_AMP] = ACTIONS(2890),
    [sym__special_characters] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [anon_sym_LT_LPAREN] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2892),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2892),
  },
  [1405] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [sym_comment] = ACTIONS(53),
  },
  [1406] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4030),
    [sym_comment] = ACTIONS(53),
  },
  [1407] = {
    [anon_sym_RBRACE] = ACTIONS(4030),
    [sym_comment] = ACTIONS(53),
  },
  [1408] = {
    [sym_concatenation] = STATE(1762),
    [sym_string] = STATE(1761),
    [sym_simple_expansion] = STATE(1761),
    [sym_string_expansion] = STATE(1761),
    [sym_expansion] = STATE(1761),
    [sym_command_substitution] = STATE(1761),
    [sym_process_substitution] = STATE(1761),
    [anon_sym_RBRACE] = ACTIONS(4030),
    [sym__special_characters] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4034),
  },
  [1409] = {
    [sym_file_descriptor] = ACTIONS(2926),
    [sym__concat] = ACTIONS(2926),
    [sym_variable_name] = ACTIONS(2926),
    [ts_builtin_sym_end] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_PIPE] = ACTIONS(2928),
    [anon_sym_RPAREN] = ACTIONS(2926),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE_AMP] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_GT] = ACTIONS(2928),
    [anon_sym_GT_GT] = ACTIONS(2926),
    [anon_sym_AMP_GT] = ACTIONS(2928),
    [anon_sym_AMP_GT_GT] = ACTIONS(2926),
    [anon_sym_LT_AMP] = ACTIONS(2926),
    [anon_sym_GT_AMP] = ACTIONS(2926),
    [sym__special_characters] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym_raw_string] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [anon_sym_LT_LPAREN] = ACTIONS(2926),
    [anon_sym_GT_LPAREN] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2928),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2928),
  },
  [1410] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4036),
  },
  [1411] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4038),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1412] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4040),
  },
  [1413] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4030),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1414] = {
    [sym_concatenation] = STATE(1767),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1767),
    [anon_sym_RBRACE] = ACTIONS(4042),
    [anon_sym_EQ] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4044),
    [anon_sym_COLON_QMARK] = ACTIONS(4044),
    [anon_sym_COLON_DASH] = ACTIONS(4044),
    [anon_sym_PERCENT] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1415] = {
    [sym_file_descriptor] = ACTIONS(2990),
    [sym__concat] = ACTIONS(2990),
    [sym_variable_name] = ACTIONS(2990),
    [ts_builtin_sym_end] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(2992),
    [anon_sym_RPAREN] = ACTIONS(2990),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [anon_sym_PIPE_AMP] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(2990),
    [anon_sym_AMP_GT] = ACTIONS(2992),
    [anon_sym_AMP_GT_GT] = ACTIONS(2990),
    [anon_sym_LT_AMP] = ACTIONS(2990),
    [anon_sym_GT_AMP] = ACTIONS(2990),
    [sym__special_characters] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym_raw_string] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_LT_LPAREN] = ACTIONS(2990),
    [anon_sym_GT_LPAREN] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2992),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2992),
  },
  [1416] = {
    [sym_concatenation] = STATE(1768),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1768),
    [anon_sym_RBRACE] = ACTIONS(4030),
    [anon_sym_EQ] = ACTIONS(4048),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4048),
    [anon_sym_COLON_QMARK] = ACTIONS(4048),
    [anon_sym_COLON_DASH] = ACTIONS(4048),
    [anon_sym_PERCENT] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1417] = {
    [sym_file_descriptor] = ACTIONS(3033),
    [sym__concat] = ACTIONS(3033),
    [sym_variable_name] = ACTIONS(3033),
    [ts_builtin_sym_end] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(3033),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [anon_sym_PIPE_AMP] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_GT_GT] = ACTIONS(3033),
    [anon_sym_AMP_GT] = ACTIONS(3035),
    [anon_sym_AMP_GT_GT] = ACTIONS(3033),
    [anon_sym_LT_AMP] = ACTIONS(3033),
    [anon_sym_GT_AMP] = ACTIONS(3033),
    [sym__special_characters] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [anon_sym_LT_LPAREN] = ACTIONS(3033),
    [anon_sym_GT_LPAREN] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3035),
  },
  [1418] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4052),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1419] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4052),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1420] = {
    [sym_file_descriptor] = ACTIONS(3071),
    [sym__concat] = ACTIONS(3071),
    [sym_variable_name] = ACTIONS(3071),
    [ts_builtin_sym_end] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [anon_sym_PIPE_AMP] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_GT_GT] = ACTIONS(3071),
    [anon_sym_AMP_GT] = ACTIONS(3073),
    [anon_sym_AMP_GT_GT] = ACTIONS(3071),
    [anon_sym_LT_AMP] = ACTIONS(3071),
    [anon_sym_GT_AMP] = ACTIONS(3071),
    [sym__special_characters] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [sym_raw_string] = ACTIONS(3071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_LT_LPAREN] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
  },
  [1421] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4054),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1422] = {
    [sym_do_group] = STATE(1771),
    [sym_compound_statement] = STATE(1771),
    [anon_sym_do] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [sym_comment] = ACTIONS(53),
  },
  [1423] = {
    [sym__terminated_statement] = STATE(1773),
    [sym_for_statement] = STATE(667),
    [sym_c_style_for_statement] = STATE(667),
    [sym_while_statement] = STATE(667),
    [sym_if_statement] = STATE(667),
    [sym_case_statement] = STATE(667),
    [sym_function_definition] = STATE(667),
    [sym_subshell] = STATE(667),
    [sym_pipeline] = STATE(667),
    [sym_list] = STATE(667),
    [sym_negated_command] = STATE(667),
    [sym_test_command] = STATE(667),
    [sym_declaration_command] = STATE(667),
    [sym_unset_command] = STATE(667),
    [sym_command] = STATE(667),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(668),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1773),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [1424] = {
    [ts_builtin_sym_end] = ACTIONS(4058),
    [anon_sym_SEMI] = ACTIONS(4060),
    [anon_sym_esac] = ACTIONS(4058),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_SEMI_SEMI] = ACTIONS(4058),
    [anon_sym_PIPE_AMP] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_BQUOTE] = ACTIONS(4058),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4058),
    [anon_sym_AMP] = ACTIONS(4060),
  },
  [1425] = {
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1347),
    [anon_sym_EQ_TILDE] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1347),
  },
  [1426] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_PIPE_PIPE] = ACTIONS(3287),
    [anon_sym_EQ_TILDE] = ACTIONS(3289),
    [anon_sym_EQ_EQ] = ACTIONS(3289),
    [anon_sym_EQ] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3287),
    [anon_sym_BANG_EQ] = ACTIONS(3287),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3287),
  },
  [1427] = {
    [sym_string] = STATE(1775),
    [sym_simple_expansion] = STATE(1775),
    [sym_string_expansion] = STATE(1775),
    [sym_expansion] = STATE(1775),
    [sym_command_substitution] = STATE(1775),
    [sym_process_substitution] = STATE(1775),
    [sym__special_characters] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [sym_raw_string] = ACTIONS(4064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2158),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [anon_sym_LT_LPAREN] = ACTIONS(2162),
    [anon_sym_GT_LPAREN] = ACTIONS(2162),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4064),
  },
  [1428] = {
    [aux_sym_concatenation_repeat1] = STATE(1776),
    [sym__concat] = ACTIONS(3261),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_EQ_TILDE] = ACTIONS(765),
    [anon_sym_EQ_EQ] = ACTIONS(765),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(765),
  },
  [1429] = {
    [sym__concat] = ACTIONS(769),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_EQ_TILDE] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(769),
  },
  [1430] = {
    [anon_sym_DQUOTE] = ACTIONS(4066),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [1431] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(4066),
    [anon_sym_DOLLAR] = ACTIONS(4068),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [1432] = {
    [sym__concat] = ACTIONS(803),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_EQ_TILDE] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_EQ] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(803),
  },
  [1433] = {
    [sym__concat] = ACTIONS(807),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_EQ_TILDE] = ACTIONS(807),
    [anon_sym_EQ_EQ] = ACTIONS(807),
    [anon_sym_EQ] = ACTIONS(809),
    [anon_sym_LT] = ACTIONS(807),
    [anon_sym_GT] = ACTIONS(807),
    [anon_sym_BANG_EQ] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(807),
  },
  [1434] = {
    [sym__concat] = ACTIONS(811),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_EQ_TILDE] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_EQ] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(811),
  },
  [1435] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(4070),
    [sym_comment] = ACTIONS(53),
  },
  [1436] = {
    [sym_subscript] = STATE(1782),
    [sym_variable_name] = ACTIONS(4072),
    [anon_sym_DOLLAR] = ACTIONS(4074),
    [anon_sym_DASH] = ACTIONS(4074),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4076),
    [anon_sym_STAR] = ACTIONS(4078),
    [anon_sym_AT] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4078),
    [anon_sym_0] = ACTIONS(4076),
    [anon_sym__] = ACTIONS(4076),
  },
  [1437] = {
    [sym_concatenation] = STATE(1785),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1785),
    [anon_sym_RBRACE] = ACTIONS(4080),
    [anon_sym_EQ] = ACTIONS(4082),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4084),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4086),
    [anon_sym_COLON] = ACTIONS(4082),
    [anon_sym_COLON_QMARK] = ACTIONS(4082),
    [anon_sym_COLON_DASH] = ACTIONS(4082),
    [anon_sym_PERCENT] = ACTIONS(4082),
    [anon_sym_DASH] = ACTIONS(4082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1438] = {
    [sym_concatenation] = STATE(1788),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1788),
    [anon_sym_RBRACE] = ACTIONS(4088),
    [anon_sym_EQ] = ACTIONS(4090),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4092),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4094),
    [anon_sym_COLON] = ACTIONS(4090),
    [anon_sym_COLON_QMARK] = ACTIONS(4090),
    [anon_sym_COLON_DASH] = ACTIONS(4090),
    [anon_sym_PERCENT] = ACTIONS(4090),
    [anon_sym_DASH] = ACTIONS(4090),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1439] = {
    [anon_sym_SEMI] = ACTIONS(4096),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4098),
    [anon_sym_SEMI_SEMI] = ACTIONS(4100),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4100),
    [anon_sym_AMP] = ACTIONS(4096),
  },
  [1440] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4096),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4098),
    [anon_sym_SEMI_SEMI] = ACTIONS(4100),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4100),
    [anon_sym_AMP] = ACTIONS(4096),
  },
  [1441] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1791),
    [sym_c_style_for_statement] = STATE(1791),
    [sym_while_statement] = STATE(1791),
    [sym_if_statement] = STATE(1791),
    [sym_case_statement] = STATE(1791),
    [sym_function_definition] = STATE(1791),
    [sym_subshell] = STATE(1791),
    [sym_pipeline] = STATE(1791),
    [sym_list] = STATE(1791),
    [sym_negated_command] = STATE(1791),
    [sym_test_command] = STATE(1791),
    [sym_declaration_command] = STATE(1791),
    [sym_unset_command] = STATE(1791),
    [sym_command] = STATE(1791),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1792),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1442] = {
    [anon_sym_SEMI] = ACTIONS(4102),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(4104),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4102),
  },
  [1443] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4102),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(4104),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(4098),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4104),
    [anon_sym_AMP] = ACTIONS(4102),
  },
  [1444] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1794),
    [sym_c_style_for_statement] = STATE(1794),
    [sym_while_statement] = STATE(1794),
    [sym_if_statement] = STATE(1794),
    [sym_case_statement] = STATE(1794),
    [sym_function_definition] = STATE(1794),
    [sym_subshell] = STATE(1794),
    [sym_pipeline] = STATE(1794),
    [sym_list] = STATE(1794),
    [sym_negated_command] = STATE(1794),
    [sym_test_command] = STATE(1794),
    [sym_declaration_command] = STATE(1794),
    [sym_unset_command] = STATE(1794),
    [sym_command] = STATE(1794),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(1795),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [1445] = {
    [anon_sym_SEMI] = ACTIONS(4106),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4108),
    [anon_sym_SEMI_SEMI] = ACTIONS(4110),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4106),
  },
  [1446] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4106),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4108),
    [anon_sym_SEMI_SEMI] = ACTIONS(4110),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4110),
    [anon_sym_AMP] = ACTIONS(4106),
  },
  [1447] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1798),
    [sym_c_style_for_statement] = STATE(1798),
    [sym_while_statement] = STATE(1798),
    [sym_if_statement] = STATE(1798),
    [sym_case_statement] = STATE(1798),
    [sym_function_definition] = STATE(1798),
    [sym_subshell] = STATE(1798),
    [sym_pipeline] = STATE(1798),
    [sym_list] = STATE(1798),
    [sym_negated_command] = STATE(1798),
    [sym_test_command] = STATE(1798),
    [sym_declaration_command] = STATE(1798),
    [sym_unset_command] = STATE(1798),
    [sym_command] = STATE(1798),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1799),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1448] = {
    [sym_do_group] = STATE(1771),
    [sym_compound_statement] = STATE(1771),
    [anon_sym_SEMI] = ACTIONS(4112),
    [anon_sym_do] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [sym_comment] = ACTIONS(53),
  },
  [1449] = {
    [sym__expression] = STATE(1801),
    [sym_binary_expression] = STATE(1801),
    [sym_unary_expression] = STATE(1801),
    [sym_parenthesized_expression] = STATE(1801),
    [sym_concatenation] = STATE(1801),
    [sym_string] = STATE(1009),
    [sym_simple_expansion] = STATE(1009),
    [sym_string_expansion] = STATE(1009),
    [sym_expansion] = STATE(1009),
    [sym_command_substitution] = STATE(1009),
    [sym_process_substitution] = STATE(1009),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2146),
    [sym__special_characters] = ACTIONS(2148),
    [anon_sym_DQUOTE] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [sym_raw_string] = ACTIONS(2154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2158),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [anon_sym_LT_LPAREN] = ACTIONS(2162),
    [anon_sym_GT_LPAREN] = ACTIONS(2162),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2164),
    [sym_test_operator] = ACTIONS(2166),
  },
  [1450] = {
    [sym__expression] = STATE(1801),
    [sym_binary_expression] = STATE(1801),
    [sym_unary_expression] = STATE(1801),
    [sym_parenthesized_expression] = STATE(1801),
    [sym_concatenation] = STATE(1801),
    [sym_string] = STATE(1009),
    [sym_simple_expansion] = STATE(1009),
    [sym_string_expansion] = STATE(1009),
    [sym_expansion] = STATE(1009),
    [sym_command_substitution] = STATE(1009),
    [sym_process_substitution] = STATE(1009),
    [anon_sym_LPAREN] = ACTIONS(4114),
    [anon_sym_BANG] = ACTIONS(2146),
    [sym__special_characters] = ACTIONS(4116),
    [anon_sym_DQUOTE] = ACTIONS(4118),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [sym_raw_string] = ACTIONS(2164),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4122),
    [anon_sym_BQUOTE] = ACTIONS(4124),
    [anon_sym_LT_LPAREN] = ACTIONS(4126),
    [anon_sym_GT_LPAREN] = ACTIONS(4126),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(2164),
    [sym_test_operator] = ACTIONS(2146),
    [sym_regex] = ACTIONS(4128),
  },
  [1451] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_PIPE_PIPE] = ACTIONS(3287),
    [anon_sym_EQ_TILDE] = ACTIONS(3289),
    [anon_sym_EQ_EQ] = ACTIONS(3289),
    [anon_sym_EQ] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3287),
    [anon_sym_BANG_EQ] = ACTIONS(3287),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3287),
  },
  [1452] = {
    [sym__concat] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_esac] = ACTIONS(2876),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [anon_sym_EQ_TILDE] = ACTIONS(2876),
    [anon_sym_EQ_EQ] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2878),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2876),
    [anon_sym_BANG_EQ] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2876),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2878),
  },
  [1453] = {
    [sym__concat] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_esac] = ACTIONS(2890),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [anon_sym_PIPE_AMP] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_EQ_TILDE] = ACTIONS(2890),
    [anon_sym_EQ_EQ] = ACTIONS(2890),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2890),
    [anon_sym_GT] = ACTIONS(2890),
    [anon_sym_BANG_EQ] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2890),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2892),
  },
  [1454] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [sym_comment] = ACTIONS(53),
  },
  [1455] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4134),
    [sym_comment] = ACTIONS(53),
  },
  [1456] = {
    [anon_sym_RBRACE] = ACTIONS(4134),
    [sym_comment] = ACTIONS(53),
  },
  [1457] = {
    [sym_concatenation] = STATE(1808),
    [sym_string] = STATE(1807),
    [sym_simple_expansion] = STATE(1807),
    [sym_string_expansion] = STATE(1807),
    [sym_expansion] = STATE(1807),
    [sym_command_substitution] = STATE(1807),
    [sym_process_substitution] = STATE(1807),
    [anon_sym_RBRACE] = ACTIONS(4134),
    [sym__special_characters] = ACTIONS(4136),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(4138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4138),
  },
  [1458] = {
    [sym__concat] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_esac] = ACTIONS(2926),
    [anon_sym_PIPE] = ACTIONS(2928),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE_AMP] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_EQ_TILDE] = ACTIONS(2926),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2926),
    [anon_sym_GT] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2926),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2928),
  },
  [1459] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4140),
  },
  [1460] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1461] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4144),
  },
  [1462] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4134),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1463] = {
    [sym_concatenation] = STATE(1813),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1813),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4148),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4150),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4148),
    [anon_sym_COLON_QMARK] = ACTIONS(4148),
    [anon_sym_COLON_DASH] = ACTIONS(4148),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [anon_sym_DASH] = ACTIONS(4148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1464] = {
    [sym__concat] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_esac] = ACTIONS(2990),
    [anon_sym_PIPE] = ACTIONS(2992),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [anon_sym_PIPE_AMP] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [anon_sym_EQ_TILDE] = ACTIONS(2990),
    [anon_sym_EQ_EQ] = ACTIONS(2990),
    [anon_sym_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_GT] = ACTIONS(2990),
    [anon_sym_BANG_EQ] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2990),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2992),
  },
  [1465] = {
    [sym_concatenation] = STATE(1814),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1814),
    [anon_sym_RBRACE] = ACTIONS(4134),
    [anon_sym_EQ] = ACTIONS(4152),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4152),
    [anon_sym_COLON_QMARK] = ACTIONS(4152),
    [anon_sym_COLON_DASH] = ACTIONS(4152),
    [anon_sym_PERCENT] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4152),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1466] = {
    [sym__concat] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_esac] = ACTIONS(3033),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [anon_sym_PIPE_AMP] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [anon_sym_EQ_TILDE] = ACTIONS(3033),
    [anon_sym_EQ_EQ] = ACTIONS(3033),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_GT] = ACTIONS(3033),
    [anon_sym_BANG_EQ] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3033),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3035),
  },
  [1467] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4156),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1468] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4156),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1469] = {
    [sym__concat] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_esac] = ACTIONS(3071),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [anon_sym_PIPE_AMP] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_EQ_TILDE] = ACTIONS(3071),
    [anon_sym_EQ_EQ] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3071),
    [anon_sym_GT] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3071),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
  },
  [1470] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1471] = {
    [sym__expression] = STATE(1817),
    [sym_binary_expression] = STATE(1817),
    [sym_unary_expression] = STATE(1817),
    [sym_parenthesized_expression] = STATE(1817),
    [sym_concatenation] = STATE(1817),
    [sym_string] = STATE(1009),
    [sym_simple_expansion] = STATE(1009),
    [sym_string_expansion] = STATE(1009),
    [sym_expansion] = STATE(1009),
    [sym_command_substitution] = STATE(1009),
    [sym_process_substitution] = STATE(1009),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4130),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2146),
    [sym__special_characters] = ACTIONS(2148),
    [anon_sym_DQUOTE] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [sym_raw_string] = ACTIONS(2154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2158),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [anon_sym_LT_LPAREN] = ACTIONS(2162),
    [anon_sym_GT_LPAREN] = ACTIONS(2162),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2164),
    [sym_test_operator] = ACTIONS(2166),
  },
  [1472] = {
    [sym__concat] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1724),
  },
  [1473] = {
    [aux_sym_concatenation_repeat1] = STATE(1473),
    [sym__concat] = ACTIONS(4160),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1724),
  },
  [1474] = {
    [sym__concat] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [sym__special_characters] = ACTIONS(1731),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1731),
    [anon_sym_GT_LPAREN] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1733),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1731),
  },
  [1475] = {
    [anon_sym_DQUOTE] = ACTIONS(4163),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [1476] = {
    [sym_concatenation] = STATE(1822),
    [sym_string] = STATE(1821),
    [sym_simple_expansion] = STATE(1821),
    [sym_string_expansion] = STATE(1821),
    [sym_expansion] = STATE(1821),
    [sym_command_substitution] = STATE(1821),
    [sym_process_substitution] = STATE(1821),
    [anon_sym_RBRACE] = ACTIONS(4165),
    [sym__special_characters] = ACTIONS(4167),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(4169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4169),
  },
  [1477] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(4171),
    [sym_comment] = ACTIONS(53),
  },
  [1478] = {
    [sym_concatenation] = STATE(1826),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1826),
    [anon_sym_RBRACE] = ACTIONS(4173),
    [anon_sym_EQ] = ACTIONS(4175),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4179),
    [anon_sym_COLON] = ACTIONS(4175),
    [anon_sym_COLON_QMARK] = ACTIONS(4175),
    [anon_sym_COLON_DASH] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(4175),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1479] = {
    [sym_concatenation] = STATE(1828),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1828),
    [anon_sym_RBRACE] = ACTIONS(4165),
    [anon_sym_EQ] = ACTIONS(4181),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4185),
    [anon_sym_COLON] = ACTIONS(4181),
    [anon_sym_COLON_QMARK] = ACTIONS(4181),
    [anon_sym_COLON_DASH] = ACTIONS(4181),
    [anon_sym_PERCENT] = ACTIONS(4181),
    [anon_sym_DASH] = ACTIONS(4181),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1480] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1832),
  },
  [1481] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4187),
  },
  [1482] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4189),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1483] = {
    [sym__concat] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [sym__special_characters] = ACTIONS(1876),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [anon_sym_LT_LPAREN] = ACTIONS(1876),
    [anon_sym_GT_LPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1876),
  },
  [1484] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4191),
  },
  [1485] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4165),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1486] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4193),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1487] = {
    [sym__concat] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [sym__special_characters] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym_raw_string] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(1884),
    [anon_sym_GT_LPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1884),
  },
  [1488] = {
    [anon_sym_SEMI] = ACTIONS(4195),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4193),
    [anon_sym_SEMI_SEMI] = ACTIONS(4197),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4197),
    [anon_sym_AMP] = ACTIONS(4195),
  },
  [1489] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4195),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4193),
    [anon_sym_SEMI_SEMI] = ACTIONS(4197),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4197),
    [anon_sym_AMP] = ACTIONS(4195),
  },
  [1490] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4193),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1491] = {
    [anon_sym_SEMI] = ACTIONS(4199),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(4201),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(4193),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4199),
  },
  [1492] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4199),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(4201),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(4193),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4199),
  },
  [1493] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4203),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1494] = {
    [sym__concat] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [sym__special_characters] = ACTIONS(1916),
    [anon_sym_DQUOTE] = ACTIONS(1916),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1916),
    [anon_sym_GT_LPAREN] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1916),
  },
  [1495] = {
    [anon_sym_SEMI] = ACTIONS(4205),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4203),
    [anon_sym_SEMI_SEMI] = ACTIONS(4207),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4207),
    [anon_sym_AMP] = ACTIONS(4205),
  },
  [1496] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4205),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4203),
    [anon_sym_SEMI_SEMI] = ACTIONS(4207),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4207),
    [anon_sym_AMP] = ACTIONS(4205),
  },
  [1497] = {
    [ts_builtin_sym_end] = ACTIONS(4209),
    [anon_sym_SEMI] = ACTIONS(4211),
    [anon_sym_esac] = ACTIONS(4209),
    [anon_sym_PIPE] = ACTIONS(4211),
    [anon_sym_RPAREN] = ACTIONS(4209),
    [anon_sym_SEMI_SEMI] = ACTIONS(4209),
    [anon_sym_PIPE_AMP] = ACTIONS(4209),
    [anon_sym_AMP_AMP] = ACTIONS(4209),
    [anon_sym_PIPE_PIPE] = ACTIONS(4209),
    [anon_sym_BQUOTE] = ACTIONS(4209),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4209),
    [anon_sym_AMP] = ACTIONS(4211),
  },
  [1498] = {
    [ts_builtin_sym_end] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym_esac] = ACTIONS(3445),
    [anon_sym_PIPE] = ACTIONS(3447),
    [anon_sym_RPAREN] = ACTIONS(3445),
    [anon_sym_SEMI_SEMI] = ACTIONS(3445),
    [anon_sym_PIPE_AMP] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_PIPE_PIPE] = ACTIONS(3445),
    [anon_sym_BQUOTE] = ACTIONS(3445),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3447),
  },
  [1499] = {
    [aux_sym_concatenation_repeat1] = STATE(1499),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(3208),
    [sym_variable_name] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1500] = {
    [sym_file_redirect] = STATE(1541),
    [sym_file_descriptor] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(3522),
    [anon_sym_SEMI_SEMI] = ACTIONS(3520),
    [anon_sym_PIPE_AMP] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_GT] = ACTIONS(2282),
    [anon_sym_AMP_GT] = ACTIONS(2280),
    [anon_sym_AMP_GT_GT] = ACTIONS(2282),
    [anon_sym_LT_AMP] = ACTIONS(2282),
    [anon_sym_GT_AMP] = ACTIONS(2282),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3522),
  },
  [1501] = {
    [sym_concatenation] = STATE(1544),
    [sym_string] = STATE(1838),
    [sym_simple_expansion] = STATE(1838),
    [sym_string_expansion] = STATE(1838),
    [sym_expansion] = STATE(1838),
    [sym_command_substitution] = STATE(1838),
    [sym_process_substitution] = STATE(1838),
    [sym__special_characters] = ACTIONS(4213),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(4215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4215),
  },
  [1502] = {
    [aux_sym_concatenation_repeat1] = STATE(1839),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [1503] = {
    [aux_sym_concatenation_repeat1] = STATE(1839),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [1504] = {
    [sym_concatenation] = STATE(1574),
    [sym_string] = STATE(1841),
    [sym_simple_expansion] = STATE(1841),
    [sym_string_expansion] = STATE(1841),
    [sym_expansion] = STATE(1841),
    [sym_command_substitution] = STATE(1841),
    [sym_process_substitution] = STATE(1841),
    [sym__special_characters] = ACTIONS(4217),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4219),
  },
  [1505] = {
    [aux_sym_concatenation_repeat1] = STATE(1842),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [1506] = {
    [aux_sym_concatenation_repeat1] = STATE(1842),
    [sym_file_descriptor] = ACTIONS(749),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_LT_LT_DASH] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [1507] = {
    [aux_sym_concatenation_repeat1] = STATE(1842),
    [sym_file_descriptor] = ACTIONS(1972),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_PIPE_AMP] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_PIPE_PIPE] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_AMP_GT] = ACTIONS(1974),
    [anon_sym_AMP_GT_GT] = ACTIONS(1972),
    [anon_sym_LT_AMP] = ACTIONS(1972),
    [anon_sym_GT_AMP] = ACTIONS(1972),
    [anon_sym_LT_LT] = ACTIONS(1974),
    [anon_sym_LT_LT_DASH] = ACTIONS(1972),
    [anon_sym_LT_LT_LT] = ACTIONS(1972),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1974),
  },
  [1508] = {
    [aux_sym_concatenation_repeat1] = STATE(1842),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [1509] = {
    [sym_file_redirect] = STATE(1509),
    [sym_heredoc_redirect] = STATE(1509),
    [sym_herestring_redirect] = STATE(1509),
    [aux_sym_while_statement_repeat1] = STATE(1509),
    [sym_file_descriptor] = ACTIONS(4221),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(4224),
    [anon_sym_GT] = ACTIONS(4224),
    [anon_sym_GT_GT] = ACTIONS(4227),
    [anon_sym_AMP_GT] = ACTIONS(4224),
    [anon_sym_AMP_GT_GT] = ACTIONS(4227),
    [anon_sym_LT_AMP] = ACTIONS(4227),
    [anon_sym_GT_AMP] = ACTIONS(4227),
    [anon_sym_LT_LT] = ACTIONS(3625),
    [anon_sym_LT_LT_DASH] = ACTIONS(3628),
    [anon_sym_LT_LT_LT] = ACTIONS(4230),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1989),
  },
  [1510] = {
    [aux_sym_concatenation_repeat1] = STATE(1510),
    [sym__simple_heredoc_body] = ACTIONS(1724),
    [sym__heredoc_body_beginning] = ACTIONS(1724),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1511] = {
    [sym__terminated_statement] = STATE(1843),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1843),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(4233),
    [anon_sym_elif] = ACTIONS(4233),
    [anon_sym_else] = ACTIONS(4233),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [1512] = {
    [sym__terminated_statement] = STATE(1512),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1512),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(968),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_fi] = ACTIONS(3449),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_function] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(998),
    [anon_sym_typeset] = ACTIONS(998),
    [anon_sym_export] = ACTIONS(998),
    [anon_sym_readonly] = ACTIONS(998),
    [anon_sym_local] = ACTIONS(998),
    [anon_sym_unset] = ACTIONS(1001),
    [anon_sym_unsetenv] = ACTIONS(1001),
    [anon_sym_LT] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_AMP_GT] = ACTIONS(1004),
    [anon_sym_AMP_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_AMP] = ACTIONS(1007),
    [anon_sym_GT_AMP] = ACTIONS(1007),
    [sym__special_characters] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1013),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1022),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1025),
    [anon_sym_BQUOTE] = ACTIONS(1028),
    [anon_sym_LT_LPAREN] = ACTIONS(1031),
    [anon_sym_GT_LPAREN] = ACTIONS(1031),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1034),
  },
  [1513] = {
    [ts_builtin_sym_end] = ACTIONS(4235),
    [anon_sym_SEMI] = ACTIONS(4237),
    [anon_sym_esac] = ACTIONS(4235),
    [anon_sym_PIPE] = ACTIONS(4237),
    [anon_sym_RPAREN] = ACTIONS(4235),
    [anon_sym_SEMI_SEMI] = ACTIONS(4235),
    [anon_sym_PIPE_AMP] = ACTIONS(4235),
    [anon_sym_AMP_AMP] = ACTIONS(4235),
    [anon_sym_PIPE_PIPE] = ACTIONS(4235),
    [anon_sym_BQUOTE] = ACTIONS(4235),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4235),
    [anon_sym_AMP] = ACTIONS(4237),
  },
  [1514] = {
    [anon_sym_fi] = ACTIONS(4239),
    [sym_comment] = ACTIONS(53),
  },
  [1515] = {
    [sym_concatenation] = STATE(1847),
    [sym_string] = STATE(1846),
    [sym_simple_expansion] = STATE(1846),
    [sym_string_expansion] = STATE(1846),
    [sym_expansion] = STATE(1846),
    [sym_command_substitution] = STATE(1846),
    [sym_process_substitution] = STATE(1846),
    [sym__special_characters] = ACTIONS(4241),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(4243),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4243),
  },
  [1516] = {
    [sym__terminated_statement] = STATE(1871),
    [sym_for_statement] = STATE(1866),
    [sym_c_style_for_statement] = STATE(1866),
    [sym_while_statement] = STATE(1866),
    [sym_if_statement] = STATE(1866),
    [sym_case_statement] = STATE(1866),
    [sym_function_definition] = STATE(1866),
    [sym_subshell] = STATE(1866),
    [sym_pipeline] = STATE(1866),
    [sym_list] = STATE(1866),
    [sym_negated_command] = STATE(1866),
    [sym_test_command] = STATE(1866),
    [sym_declaration_command] = STATE(1866),
    [sym_unset_command] = STATE(1866),
    [sym_command] = STATE(1866),
    [sym_command_name] = STATE(1867),
    [sym_variable_assignment] = STATE(1868),
    [sym_subscript] = STATE(1869),
    [sym_file_redirect] = STATE(1872),
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_string_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [aux_sym__statements_repeat1] = STATE(1871),
    [aux_sym_command_repeat1] = STATE(1872),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4245),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(4249),
    [anon_sym_SEMI_SEMI] = ACTIONS(4251),
    [anon_sym_function] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(4257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4259),
    [anon_sym_declare] = ACTIONS(4261),
    [anon_sym_typeset] = ACTIONS(4261),
    [anon_sym_export] = ACTIONS(4261),
    [anon_sym_readonly] = ACTIONS(4261),
    [anon_sym_local] = ACTIONS(4261),
    [anon_sym_unset] = ACTIONS(4263),
    [anon_sym_unsetenv] = ACTIONS(4263),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4265),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4281),
  },
  [1517] = {
    [aux_sym_case_item_repeat1] = STATE(1874),
    [anon_sym_PIPE] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(4283),
    [sym_comment] = ACTIONS(53),
  },
  [1518] = {
    [aux_sym_concatenation_repeat1] = STATE(1875),
    [sym__concat] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
  },
  [1519] = {
    [sym__terminated_statement] = STATE(1879),
    [sym_for_statement] = STATE(1877),
    [sym_c_style_for_statement] = STATE(1877),
    [sym_while_statement] = STATE(1877),
    [sym_if_statement] = STATE(1877),
    [sym_case_statement] = STATE(1877),
    [sym_function_definition] = STATE(1877),
    [sym_subshell] = STATE(1877),
    [sym_pipeline] = STATE(1877),
    [sym_list] = STATE(1877),
    [sym_negated_command] = STATE(1877),
    [sym_test_command] = STATE(1877),
    [sym_declaration_command] = STATE(1877),
    [sym_unset_command] = STATE(1877),
    [sym_command] = STATE(1877),
    [sym_command_name] = STATE(1867),
    [sym_variable_assignment] = STATE(1878),
    [sym_subscript] = STATE(1869),
    [sym_file_redirect] = STATE(1872),
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_string_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [aux_sym__statements_repeat1] = STATE(1879),
    [aux_sym_command_repeat1] = STATE(1872),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4245),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(4285),
    [anon_sym_SEMI_SEMI] = ACTIONS(4287),
    [anon_sym_function] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(4257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4259),
    [anon_sym_declare] = ACTIONS(4261),
    [anon_sym_typeset] = ACTIONS(4261),
    [anon_sym_export] = ACTIONS(4261),
    [anon_sym_readonly] = ACTIONS(4261),
    [anon_sym_local] = ACTIONS(4261),
    [anon_sym_unset] = ACTIONS(4263),
    [anon_sym_unsetenv] = ACTIONS(4263),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4265),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4281),
  },
  [1520] = {
    [aux_sym_case_item_repeat1] = STATE(1874),
    [anon_sym_PIPE] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(4289),
    [sym_comment] = ACTIONS(53),
  },
  [1521] = {
    [ts_builtin_sym_end] = ACTIONS(4291),
    [anon_sym_SEMI] = ACTIONS(4293),
    [anon_sym_esac] = ACTIONS(4291),
    [anon_sym_PIPE] = ACTIONS(4293),
    [anon_sym_RPAREN] = ACTIONS(4291),
    [anon_sym_SEMI_SEMI] = ACTIONS(4291),
    [anon_sym_PIPE_AMP] = ACTIONS(4291),
    [anon_sym_AMP_AMP] = ACTIONS(4291),
    [anon_sym_PIPE_PIPE] = ACTIONS(4291),
    [anon_sym_BQUOTE] = ACTIONS(4291),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4291),
    [anon_sym_AMP] = ACTIONS(4293),
  },
  [1522] = {
    [anon_sym_esac] = ACTIONS(4295),
    [sym_comment] = ACTIONS(53),
  },
  [1523] = {
    [sym_case_item] = STATE(1523),
    [sym_concatenation] = STATE(1884),
    [sym_string] = STATE(1883),
    [sym_simple_expansion] = STATE(1883),
    [sym_string_expansion] = STATE(1883),
    [sym_expansion] = STATE(1883),
    [sym_command_substitution] = STATE(1883),
    [sym_process_substitution] = STATE(1883),
    [aux_sym_case_statement_repeat1] = STATE(1523),
    [sym__special_characters] = ACTIONS(4297),
    [anon_sym_DQUOTE] = ACTIONS(4300),
    [anon_sym_DOLLAR] = ACTIONS(4303),
    [sym_raw_string] = ACTIONS(4306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4309),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4312),
    [anon_sym_BQUOTE] = ACTIONS(4315),
    [anon_sym_LT_LPAREN] = ACTIONS(4318),
    [anon_sym_GT_LPAREN] = ACTIONS(4318),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4306),
  },
  [1524] = {
    [sym_case_item] = STATE(1523),
    [sym_last_case_item] = STATE(1885),
    [sym_concatenation] = STATE(1102),
    [sym_string] = STATE(1100),
    [sym_simple_expansion] = STATE(1100),
    [sym_string_expansion] = STATE(1100),
    [sym_expansion] = STATE(1100),
    [sym_command_substitution] = STATE(1100),
    [sym_process_substitution] = STATE(1100),
    [aux_sym_case_statement_repeat1] = STATE(1523),
    [sym__special_characters] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(2379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2379),
  },
  [1525] = {
    [ts_builtin_sym_end] = ACTIONS(4321),
    [anon_sym_SEMI] = ACTIONS(4323),
    [anon_sym_esac] = ACTIONS(4321),
    [anon_sym_PIPE] = ACTIONS(4323),
    [anon_sym_RPAREN] = ACTIONS(4321),
    [anon_sym_SEMI_SEMI] = ACTIONS(4321),
    [anon_sym_PIPE_AMP] = ACTIONS(4321),
    [anon_sym_AMP_AMP] = ACTIONS(4321),
    [anon_sym_PIPE_PIPE] = ACTIONS(4321),
    [anon_sym_BQUOTE] = ACTIONS(4321),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4321),
    [anon_sym_AMP] = ACTIONS(4323),
  },
  [1526] = {
    [anon_sym_esac] = ACTIONS(4325),
    [sym_comment] = ACTIONS(53),
  },
  [1527] = {
    [sym_case_item] = STATE(1523),
    [sym_last_case_item] = STATE(1887),
    [sym_concatenation] = STATE(1102),
    [sym_string] = STATE(1100),
    [sym_simple_expansion] = STATE(1100),
    [sym_string_expansion] = STATE(1100),
    [sym_expansion] = STATE(1100),
    [sym_command_substitution] = STATE(1100),
    [sym_process_substitution] = STATE(1100),
    [aux_sym_case_statement_repeat1] = STATE(1523),
    [sym__special_characters] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(2379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2379),
  },
  [1528] = {
    [sym__concat] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3788),
  },
  [1529] = {
    [sym__concat] = ACTIONS(3796),
    [anon_sym_in] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3796),
  },
  [1530] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4327),
    [sym_comment] = ACTIONS(53),
  },
  [1531] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4329),
    [sym_comment] = ACTIONS(53),
  },
  [1532] = {
    [anon_sym_RBRACE] = ACTIONS(4329),
    [sym_comment] = ACTIONS(53),
  },
  [1533] = {
    [sym_concatenation] = STATE(1891),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1891),
    [anon_sym_RBRACE] = ACTIONS(4331),
    [anon_sym_EQ] = ACTIONS(4333),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4333),
    [anon_sym_COLON_QMARK] = ACTIONS(4333),
    [anon_sym_COLON_DASH] = ACTIONS(4333),
    [anon_sym_PERCENT] = ACTIONS(4333),
    [anon_sym_DASH] = ACTIONS(4333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1534] = {
    [sym__concat] = ACTIONS(3852),
    [anon_sym_in] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3852),
  },
  [1535] = {
    [sym_concatenation] = STATE(1892),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1892),
    [anon_sym_RBRACE] = ACTIONS(4329),
    [anon_sym_EQ] = ACTIONS(4337),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4337),
    [anon_sym_COLON_QMARK] = ACTIONS(4337),
    [anon_sym_COLON_DASH] = ACTIONS(4337),
    [anon_sym_PERCENT] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1536] = {
    [sym__concat] = ACTIONS(3893),
    [anon_sym_in] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3893),
  },
  [1537] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4341),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1538] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4329),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1539] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_in] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3915),
  },
  [1540] = {
    [sym__concat] = ACTIONS(3939),
    [anon_sym_in] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3939),
  },
  [1541] = {
    [ts_builtin_sym_end] = ACTIONS(4343),
    [anon_sym_SEMI] = ACTIONS(4345),
    [anon_sym_esac] = ACTIONS(4343),
    [anon_sym_PIPE] = ACTIONS(4345),
    [anon_sym_RPAREN] = ACTIONS(4343),
    [anon_sym_SEMI_SEMI] = ACTIONS(4343),
    [anon_sym_PIPE_AMP] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4343),
    [anon_sym_PIPE_PIPE] = ACTIONS(4343),
    [anon_sym_BQUOTE] = ACTIONS(4343),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4345),
  },
  [1542] = {
    [aux_sym_concatenation_repeat1] = STATE(1545),
    [sym__concat] = ACTIONS(693),
    [ts_builtin_sym_end] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1543] = {
    [aux_sym_concatenation_repeat1] = STATE(1545),
    [sym__concat] = ACTIONS(693),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1544] = {
    [ts_builtin_sym_end] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_esac] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1545] = {
    [aux_sym_concatenation_repeat1] = STATE(1894),
    [sym__concat] = ACTIONS(693),
    [ts_builtin_sym_end] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [1546] = {
    [aux_sym_concatenation_repeat1] = STATE(1546),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(3208),
    [sym_variable_name] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1547] = {
    [sym_file_redirect] = STATE(1541),
    [sym_file_descriptor] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(3522),
    [anon_sym_RPAREN] = ACTIONS(3520),
    [anon_sym_SEMI_SEMI] = ACTIONS(3520),
    [anon_sym_PIPE_AMP] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_AMP_GT] = ACTIONS(2468),
    [anon_sym_AMP_GT_GT] = ACTIONS(2470),
    [anon_sym_LT_AMP] = ACTIONS(2470),
    [anon_sym_GT_AMP] = ACTIONS(2470),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3522),
  },
  [1548] = {
    [sym_concatenation] = STATE(1544),
    [sym_string] = STATE(1896),
    [sym_simple_expansion] = STATE(1896),
    [sym_string_expansion] = STATE(1896),
    [sym_expansion] = STATE(1896),
    [sym_command_substitution] = STATE(1896),
    [sym_process_substitution] = STATE(1896),
    [sym__special_characters] = ACTIONS(4347),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(4349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4349),
  },
  [1549] = {
    [aux_sym_concatenation_repeat1] = STATE(1897),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [1550] = {
    [aux_sym_concatenation_repeat1] = STATE(1897),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [1551] = {
    [sym_concatenation] = STATE(1574),
    [sym_string] = STATE(1899),
    [sym_simple_expansion] = STATE(1899),
    [sym_string_expansion] = STATE(1899),
    [sym_expansion] = STATE(1899),
    [sym_command_substitution] = STATE(1899),
    [sym_process_substitution] = STATE(1899),
    [sym__special_characters] = ACTIONS(4351),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(4353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4353),
  },
  [1552] = {
    [aux_sym_concatenation_repeat1] = STATE(1900),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [1553] = {
    [aux_sym_concatenation_repeat1] = STATE(1900),
    [sym_file_descriptor] = ACTIONS(749),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_LT_LT_DASH] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [1554] = {
    [aux_sym_concatenation_repeat1] = STATE(1900),
    [sym_file_descriptor] = ACTIONS(1972),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_RPAREN] = ACTIONS(1972),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_PIPE_AMP] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_PIPE_PIPE] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_AMP_GT] = ACTIONS(1974),
    [anon_sym_AMP_GT_GT] = ACTIONS(1972),
    [anon_sym_LT_AMP] = ACTIONS(1972),
    [anon_sym_GT_AMP] = ACTIONS(1972),
    [anon_sym_LT_LT] = ACTIONS(1974),
    [anon_sym_LT_LT_DASH] = ACTIONS(1972),
    [anon_sym_LT_LT_LT] = ACTIONS(1972),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1974),
  },
  [1555] = {
    [aux_sym_concatenation_repeat1] = STATE(1900),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_RPAREN] = ACTIONS(1976),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [1556] = {
    [sym_file_redirect] = STATE(1556),
    [sym_heredoc_redirect] = STATE(1556),
    [sym_herestring_redirect] = STATE(1556),
    [aux_sym_while_statement_repeat1] = STATE(1556),
    [sym_file_descriptor] = ACTIONS(4355),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(4358),
    [anon_sym_GT] = ACTIONS(4358),
    [anon_sym_GT_GT] = ACTIONS(4361),
    [anon_sym_AMP_GT] = ACTIONS(4358),
    [anon_sym_AMP_GT_GT] = ACTIONS(4361),
    [anon_sym_LT_AMP] = ACTIONS(4361),
    [anon_sym_GT_AMP] = ACTIONS(4361),
    [anon_sym_LT_LT] = ACTIONS(3625),
    [anon_sym_LT_LT_DASH] = ACTIONS(3628),
    [anon_sym_LT_LT_LT] = ACTIONS(4364),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1989),
  },
  [1557] = {
    [aux_sym_concatenation_repeat1] = STATE(1557),
    [sym__simple_heredoc_body] = ACTIONS(1724),
    [sym__heredoc_body_beginning] = ACTIONS(1724),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1558] = {
    [sym_file_descriptor] = ACTIONS(3178),
    [sym_variable_name] = ACTIONS(3178),
    [anon_sym_LT] = ACTIONS(3180),
    [anon_sym_GT] = ACTIONS(3180),
    [anon_sym_GT_GT] = ACTIONS(3178),
    [anon_sym_AMP_GT] = ACTIONS(3180),
    [anon_sym_AMP_GT_GT] = ACTIONS(3178),
    [anon_sym_LT_AMP] = ACTIONS(3178),
    [anon_sym_GT_AMP] = ACTIONS(3178),
    [sym__special_characters] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_DOLLAR] = ACTIONS(3180),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3178),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3178),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(3178),
    [anon_sym_GT_LPAREN] = ACTIONS(3178),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3178),
  },
  [1559] = {
    [sym__concat] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_RBRACK] = ACTIONS(3788),
    [anon_sym_EQ_TILDE] = ACTIONS(3788),
    [anon_sym_EQ_EQ] = ACTIONS(3788),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_BANG_EQ] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3788),
  },
  [1560] = {
    [sym__concat] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [anon_sym_RBRACK] = ACTIONS(3796),
    [anon_sym_EQ_TILDE] = ACTIONS(3796),
    [anon_sym_EQ_EQ] = ACTIONS(3796),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_GT] = ACTIONS(3796),
    [anon_sym_BANG_EQ] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3796),
  },
  [1561] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4367),
    [sym_comment] = ACTIONS(53),
  },
  [1562] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4369),
    [sym_comment] = ACTIONS(53),
  },
  [1563] = {
    [anon_sym_RBRACE] = ACTIONS(4369),
    [sym_comment] = ACTIONS(53),
  },
  [1564] = {
    [sym_concatenation] = STATE(1904),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1904),
    [anon_sym_RBRACE] = ACTIONS(4371),
    [anon_sym_EQ] = ACTIONS(4373),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4373),
    [anon_sym_COLON_QMARK] = ACTIONS(4373),
    [anon_sym_COLON_DASH] = ACTIONS(4373),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_DASH] = ACTIONS(4373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1565] = {
    [sym__concat] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_RBRACK] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [anon_sym_EQ_EQ] = ACTIONS(3852),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3852),
    [anon_sym_GT] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3852),
  },
  [1566] = {
    [sym_concatenation] = STATE(1905),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1905),
    [anon_sym_RBRACE] = ACTIONS(4369),
    [anon_sym_EQ] = ACTIONS(4377),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4377),
    [anon_sym_COLON_QMARK] = ACTIONS(4377),
    [anon_sym_COLON_DASH] = ACTIONS(4377),
    [anon_sym_PERCENT] = ACTIONS(4377),
    [anon_sym_DASH] = ACTIONS(4377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1567] = {
    [sym__concat] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_RBRACK] = ACTIONS(3893),
    [anon_sym_EQ_TILDE] = ACTIONS(3893),
    [anon_sym_EQ_EQ] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3895),
    [anon_sym_LT] = ACTIONS(3893),
    [anon_sym_GT] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3893),
  },
  [1568] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4381),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1569] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4369),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1570] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_RBRACK] = ACTIONS(3915),
    [anon_sym_EQ_TILDE] = ACTIONS(3915),
    [anon_sym_EQ_EQ] = ACTIONS(3915),
    [anon_sym_EQ] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_GT] = ACTIONS(3915),
    [anon_sym_BANG_EQ] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3915),
  },
  [1571] = {
    [sym__concat] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_RBRACK] = ACTIONS(3939),
    [anon_sym_EQ_TILDE] = ACTIONS(3939),
    [anon_sym_EQ_EQ] = ACTIONS(3939),
    [anon_sym_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_GT] = ACTIONS(3939),
    [anon_sym_BANG_EQ] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3939),
  },
  [1572] = {
    [aux_sym_concatenation_repeat1] = STATE(1576),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(3592),
    [ts_builtin_sym_end] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1573] = {
    [aux_sym_concatenation_repeat1] = STATE(1576),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(3592),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1574] = {
    [sym_file_descriptor] = ACTIONS(1057),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_esac] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1575] = {
    [sym_string] = STATE(1907),
    [sym_simple_expansion] = STATE(1907),
    [sym_string_expansion] = STATE(1907),
    [sym_expansion] = STATE(1907),
    [sym_command_substitution] = STATE(1907),
    [sym_process_substitution] = STATE(1907),
    [sym__special_characters] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4383),
  },
  [1576] = {
    [aux_sym_concatenation_repeat1] = STATE(1908),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(3592),
    [ts_builtin_sym_end] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [1577] = {
    [sym_file_descriptor] = ACTIONS(769),
    [sym__concat] = ACTIONS(769),
    [ts_builtin_sym_end] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_esac] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_AMP_GT] = ACTIONS(771),
    [anon_sym_AMP_GT_GT] = ACTIONS(769),
    [anon_sym_LT_AMP] = ACTIONS(769),
    [anon_sym_GT_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_LT_LT_DASH] = ACTIONS(769),
    [anon_sym_LT_LT_LT] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [1578] = {
    [anon_sym_DQUOTE] = ACTIONS(4385),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [1579] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(4385),
    [anon_sym_DOLLAR] = ACTIONS(4387),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [1580] = {
    [sym_file_descriptor] = ACTIONS(803),
    [sym__concat] = ACTIONS(803),
    [ts_builtin_sym_end] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_esac] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [anon_sym_PIPE_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_AMP_GT] = ACTIONS(805),
    [anon_sym_AMP_GT_GT] = ACTIONS(803),
    [anon_sym_LT_AMP] = ACTIONS(803),
    [anon_sym_GT_AMP] = ACTIONS(803),
    [anon_sym_LT_LT] = ACTIONS(805),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_LT] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(805),
  },
  [1581] = {
    [sym_file_descriptor] = ACTIONS(807),
    [sym__concat] = ACTIONS(807),
    [ts_builtin_sym_end] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_esac] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [anon_sym_PIPE_AMP] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_LT] = ACTIONS(809),
    [anon_sym_GT] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(807),
    [anon_sym_AMP_GT] = ACTIONS(809),
    [anon_sym_AMP_GT_GT] = ACTIONS(807),
    [anon_sym_LT_AMP] = ACTIONS(807),
    [anon_sym_GT_AMP] = ACTIONS(807),
    [anon_sym_LT_LT] = ACTIONS(809),
    [anon_sym_LT_LT_DASH] = ACTIONS(807),
    [anon_sym_LT_LT_LT] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(809),
  },
  [1582] = {
    [sym_file_descriptor] = ACTIONS(811),
    [sym__concat] = ACTIONS(811),
    [ts_builtin_sym_end] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_esac] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_AMP_GT] = ACTIONS(813),
    [anon_sym_AMP_GT_GT] = ACTIONS(811),
    [anon_sym_LT_AMP] = ACTIONS(811),
    [anon_sym_GT_AMP] = ACTIONS(811),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_LT] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(813),
  },
  [1583] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(4389),
    [sym_comment] = ACTIONS(53),
  },
  [1584] = {
    [sym_subscript] = STATE(1914),
    [sym_variable_name] = ACTIONS(4391),
    [anon_sym_DOLLAR] = ACTIONS(4393),
    [anon_sym_DASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4395),
    [anon_sym_STAR] = ACTIONS(4397),
    [anon_sym_AT] = ACTIONS(4397),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_0] = ACTIONS(4395),
    [anon_sym__] = ACTIONS(4395),
  },
  [1585] = {
    [sym_concatenation] = STATE(1917),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1917),
    [anon_sym_RBRACE] = ACTIONS(4399),
    [anon_sym_EQ] = ACTIONS(4401),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_COLON] = ACTIONS(4401),
    [anon_sym_COLON_QMARK] = ACTIONS(4401),
    [anon_sym_COLON_DASH] = ACTIONS(4401),
    [anon_sym_PERCENT] = ACTIONS(4401),
    [anon_sym_DASH] = ACTIONS(4401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1586] = {
    [sym_concatenation] = STATE(1920),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1920),
    [anon_sym_RBRACE] = ACTIONS(4407),
    [anon_sym_EQ] = ACTIONS(4409),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4413),
    [anon_sym_COLON] = ACTIONS(4409),
    [anon_sym_COLON_QMARK] = ACTIONS(4409),
    [anon_sym_COLON_DASH] = ACTIONS(4409),
    [anon_sym_PERCENT] = ACTIONS(4409),
    [anon_sym_DASH] = ACTIONS(4409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1587] = {
    [anon_sym_SEMI] = ACTIONS(4415),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4417),
    [anon_sym_SEMI_SEMI] = ACTIONS(4419),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4419),
    [anon_sym_AMP] = ACTIONS(4415),
  },
  [1588] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4415),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4417),
    [anon_sym_SEMI_SEMI] = ACTIONS(4419),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4419),
    [anon_sym_AMP] = ACTIONS(4415),
  },
  [1589] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1923),
    [sym_c_style_for_statement] = STATE(1923),
    [sym_while_statement] = STATE(1923),
    [sym_if_statement] = STATE(1923),
    [sym_case_statement] = STATE(1923),
    [sym_function_definition] = STATE(1923),
    [sym_subshell] = STATE(1923),
    [sym_pipeline] = STATE(1923),
    [sym_list] = STATE(1923),
    [sym_negated_command] = STATE(1923),
    [sym_test_command] = STATE(1923),
    [sym_declaration_command] = STATE(1923),
    [sym_unset_command] = STATE(1923),
    [sym_command] = STATE(1923),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1924),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1590] = {
    [anon_sym_SEMI] = ACTIONS(4421),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(4423),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(4417),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4423),
    [anon_sym_AMP] = ACTIONS(4421),
  },
  [1591] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4421),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(4423),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(4417),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4423),
    [anon_sym_AMP] = ACTIONS(4421),
  },
  [1592] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1926),
    [sym_c_style_for_statement] = STATE(1926),
    [sym_while_statement] = STATE(1926),
    [sym_if_statement] = STATE(1926),
    [sym_case_statement] = STATE(1926),
    [sym_function_definition] = STATE(1926),
    [sym_subshell] = STATE(1926),
    [sym_pipeline] = STATE(1926),
    [sym_list] = STATE(1926),
    [sym_negated_command] = STATE(1926),
    [sym_test_command] = STATE(1926),
    [sym_declaration_command] = STATE(1926),
    [sym_unset_command] = STATE(1926),
    [sym_command] = STATE(1926),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(1927),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [1593] = {
    [anon_sym_SEMI] = ACTIONS(4425),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4427),
    [anon_sym_SEMI_SEMI] = ACTIONS(4429),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4429),
    [anon_sym_AMP] = ACTIONS(4425),
  },
  [1594] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4425),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4427),
    [anon_sym_SEMI_SEMI] = ACTIONS(4429),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4429),
    [anon_sym_AMP] = ACTIONS(4425),
  },
  [1595] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(1930),
    [sym_c_style_for_statement] = STATE(1930),
    [sym_while_statement] = STATE(1930),
    [sym_if_statement] = STATE(1930),
    [sym_case_statement] = STATE(1930),
    [sym_function_definition] = STATE(1930),
    [sym_subshell] = STATE(1930),
    [sym_pipeline] = STATE(1930),
    [sym_list] = STATE(1930),
    [sym_negated_command] = STATE(1930),
    [sym_test_command] = STATE(1930),
    [sym_declaration_command] = STATE(1930),
    [sym_unset_command] = STATE(1930),
    [sym_command] = STATE(1930),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(1931),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1596] = {
    [sym__concat] = ACTIONS(3788),
    [anon_sym_PIPE] = ACTIONS(3790),
    [anon_sym_RPAREN] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3788),
    [anon_sym_EQ_TILDE] = ACTIONS(3788),
    [anon_sym_EQ_EQ] = ACTIONS(3788),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_BANG_EQ] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3788),
  },
  [1597] = {
    [sym__concat] = ACTIONS(3796),
    [anon_sym_PIPE] = ACTIONS(3798),
    [anon_sym_RPAREN] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3796),
    [anon_sym_EQ_TILDE] = ACTIONS(3796),
    [anon_sym_EQ_EQ] = ACTIONS(3796),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_GT] = ACTIONS(3796),
    [anon_sym_BANG_EQ] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3796),
  },
  [1598] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4431),
    [sym_comment] = ACTIONS(53),
  },
  [1599] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4433),
    [sym_comment] = ACTIONS(53),
  },
  [1600] = {
    [anon_sym_RBRACE] = ACTIONS(4433),
    [sym_comment] = ACTIONS(53),
  },
  [1601] = {
    [sym_concatenation] = STATE(1935),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1935),
    [anon_sym_RBRACE] = ACTIONS(4435),
    [anon_sym_EQ] = ACTIONS(4437),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4439),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4437),
    [anon_sym_COLON_QMARK] = ACTIONS(4437),
    [anon_sym_COLON_DASH] = ACTIONS(4437),
    [anon_sym_PERCENT] = ACTIONS(4437),
    [anon_sym_DASH] = ACTIONS(4437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1602] = {
    [sym__concat] = ACTIONS(3852),
    [anon_sym_PIPE] = ACTIONS(3854),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [anon_sym_EQ_EQ] = ACTIONS(3852),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3852),
    [anon_sym_GT] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3852),
  },
  [1603] = {
    [sym_concatenation] = STATE(1936),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1936),
    [anon_sym_RBRACE] = ACTIONS(4433),
    [anon_sym_EQ] = ACTIONS(4441),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4441),
    [anon_sym_COLON_QMARK] = ACTIONS(4441),
    [anon_sym_COLON_DASH] = ACTIONS(4441),
    [anon_sym_PERCENT] = ACTIONS(4441),
    [anon_sym_DASH] = ACTIONS(4441),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1604] = {
    [sym__concat] = ACTIONS(3893),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_RPAREN] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3893),
    [anon_sym_EQ_TILDE] = ACTIONS(3893),
    [anon_sym_EQ_EQ] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3895),
    [anon_sym_LT] = ACTIONS(3893),
    [anon_sym_GT] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3893),
  },
  [1605] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4445),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1606] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4433),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1607] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3915),
    [anon_sym_EQ_TILDE] = ACTIONS(3915),
    [anon_sym_EQ_EQ] = ACTIONS(3915),
    [anon_sym_EQ] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_GT] = ACTIONS(3915),
    [anon_sym_BANG_EQ] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3915),
  },
  [1608] = {
    [sym__concat] = ACTIONS(3939),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_RPAREN] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3939),
    [anon_sym_EQ_TILDE] = ACTIONS(3939),
    [anon_sym_EQ_EQ] = ACTIONS(3939),
    [anon_sym_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_GT] = ACTIONS(3939),
    [anon_sym_BANG_EQ] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3939),
  },
  [1609] = {
    [sym_variable_name] = ACTIONS(3178),
    [ts_builtin_sym_end] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym_PIPE] = ACTIONS(3180),
    [anon_sym_RPAREN] = ACTIONS(3178),
    [anon_sym_SEMI_SEMI] = ACTIONS(3178),
    [anon_sym_PIPE_AMP] = ACTIONS(3178),
    [anon_sym_AMP_AMP] = ACTIONS(3178),
    [anon_sym_PIPE_PIPE] = ACTIONS(3178),
    [sym__special_characters] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_DOLLAR] = ACTIONS(3180),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3178),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3178),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(3178),
    [anon_sym_GT_LPAREN] = ACTIONS(3178),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3180),
    [sym_word] = ACTIONS(3180),
    [anon_sym_LF] = ACTIONS(3178),
    [anon_sym_AMP] = ACTIONS(3180),
  },
  [1610] = {
    [sym__concat] = ACTIONS(3788),
    [sym_variable_name] = ACTIONS(3788),
    [ts_builtin_sym_end] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_PIPE] = ACTIONS(3790),
    [anon_sym_RPAREN] = ACTIONS(3788),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [anon_sym_PIPE_AMP] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [sym__special_characters] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LT_LPAREN] = ACTIONS(3788),
    [anon_sym_GT_LPAREN] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3790),
    [sym_word] = ACTIONS(3790),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3790),
  },
  [1611] = {
    [sym__concat] = ACTIONS(3796),
    [sym_variable_name] = ACTIONS(3796),
    [ts_builtin_sym_end] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3798),
    [anon_sym_RPAREN] = ACTIONS(3796),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [anon_sym_PIPE_AMP] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [sym__special_characters] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym_raw_string] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3796),
    [anon_sym_GT_LPAREN] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3798),
    [sym_word] = ACTIONS(3798),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3798),
  },
  [1612] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4447),
    [sym_comment] = ACTIONS(53),
  },
  [1613] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4449),
    [sym_comment] = ACTIONS(53),
  },
  [1614] = {
    [anon_sym_RBRACE] = ACTIONS(4449),
    [sym_comment] = ACTIONS(53),
  },
  [1615] = {
    [sym_concatenation] = STATE(1941),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1941),
    [anon_sym_RBRACE] = ACTIONS(4451),
    [anon_sym_EQ] = ACTIONS(4453),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COLON_QMARK] = ACTIONS(4453),
    [anon_sym_COLON_DASH] = ACTIONS(4453),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_DASH] = ACTIONS(4453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1616] = {
    [sym__concat] = ACTIONS(3852),
    [sym_variable_name] = ACTIONS(3852),
    [ts_builtin_sym_end] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_PIPE] = ACTIONS(3854),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [anon_sym_PIPE_AMP] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [sym__special_characters] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym_raw_string] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_LT_LPAREN] = ACTIONS(3852),
    [anon_sym_GT_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3854),
    [sym_word] = ACTIONS(3854),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3854),
  },
  [1617] = {
    [sym_concatenation] = STATE(1942),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1942),
    [anon_sym_RBRACE] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(4457),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4457),
    [anon_sym_COLON_QMARK] = ACTIONS(4457),
    [anon_sym_COLON_DASH] = ACTIONS(4457),
    [anon_sym_PERCENT] = ACTIONS(4457),
    [anon_sym_DASH] = ACTIONS(4457),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1618] = {
    [sym__concat] = ACTIONS(3893),
    [sym_variable_name] = ACTIONS(3893),
    [ts_builtin_sym_end] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_RPAREN] = ACTIONS(3893),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [anon_sym_PIPE_AMP] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LT_LPAREN] = ACTIONS(3893),
    [anon_sym_GT_LPAREN] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3895),
    [sym_word] = ACTIONS(3895),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3895),
  },
  [1619] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4461),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1620] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1621] = {
    [sym__concat] = ACTIONS(3915),
    [sym_variable_name] = ACTIONS(3915),
    [ts_builtin_sym_end] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3917),
    [sym_word] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [1622] = {
    [sym__concat] = ACTIONS(3939),
    [sym_variable_name] = ACTIONS(3939),
    [ts_builtin_sym_end] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_RPAREN] = ACTIONS(3939),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [anon_sym_PIPE_AMP] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [sym__special_characters] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [sym_raw_string] = ACTIONS(3939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LT_LPAREN] = ACTIONS(3939),
    [anon_sym_GT_LPAREN] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3941),
    [sym_word] = ACTIONS(3941),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3941),
  },
  [1623] = {
    [sym__concat] = ACTIONS(3788),
    [ts_builtin_sym_end] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_PIPE] = ACTIONS(3790),
    [anon_sym_RPAREN] = ACTIONS(3788),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [anon_sym_PIPE_AMP] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [sym__special_characters] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LT_LPAREN] = ACTIONS(3788),
    [anon_sym_GT_LPAREN] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3790),
    [sym_word] = ACTIONS(3790),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3790),
  },
  [1624] = {
    [sym__concat] = ACTIONS(3796),
    [ts_builtin_sym_end] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3798),
    [anon_sym_RPAREN] = ACTIONS(3796),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [anon_sym_PIPE_AMP] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [sym__special_characters] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym_raw_string] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3796),
    [anon_sym_GT_LPAREN] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3798),
    [sym_word] = ACTIONS(3798),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3798),
  },
  [1625] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4463),
    [sym_comment] = ACTIONS(53),
  },
  [1626] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4465),
    [sym_comment] = ACTIONS(53),
  },
  [1627] = {
    [anon_sym_RBRACE] = ACTIONS(4465),
    [sym_comment] = ACTIONS(53),
  },
  [1628] = {
    [sym_concatenation] = STATE(1947),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(4467),
    [anon_sym_EQ] = ACTIONS(4469),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4469),
    [anon_sym_COLON_QMARK] = ACTIONS(4469),
    [anon_sym_COLON_DASH] = ACTIONS(4469),
    [anon_sym_PERCENT] = ACTIONS(4469),
    [anon_sym_DASH] = ACTIONS(4469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1629] = {
    [sym__concat] = ACTIONS(3852),
    [ts_builtin_sym_end] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_PIPE] = ACTIONS(3854),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [anon_sym_PIPE_AMP] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [sym__special_characters] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym_raw_string] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_LT_LPAREN] = ACTIONS(3852),
    [anon_sym_GT_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3854),
    [sym_word] = ACTIONS(3854),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3854),
  },
  [1630] = {
    [sym_concatenation] = STATE(1948),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1948),
    [anon_sym_RBRACE] = ACTIONS(4465),
    [anon_sym_EQ] = ACTIONS(4473),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4475),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4473),
    [anon_sym_COLON_QMARK] = ACTIONS(4473),
    [anon_sym_COLON_DASH] = ACTIONS(4473),
    [anon_sym_PERCENT] = ACTIONS(4473),
    [anon_sym_DASH] = ACTIONS(4473),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1631] = {
    [sym__concat] = ACTIONS(3893),
    [ts_builtin_sym_end] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_RPAREN] = ACTIONS(3893),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [anon_sym_PIPE_AMP] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LT_LPAREN] = ACTIONS(3893),
    [anon_sym_GT_LPAREN] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3895),
    [sym_word] = ACTIONS(3895),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3895),
  },
  [1632] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4477),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1633] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4465),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1634] = {
    [sym__concat] = ACTIONS(3915),
    [ts_builtin_sym_end] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3917),
    [sym_word] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [1635] = {
    [sym__concat] = ACTIONS(3939),
    [ts_builtin_sym_end] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_RPAREN] = ACTIONS(3939),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [anon_sym_PIPE_AMP] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [sym__special_characters] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [sym_raw_string] = ACTIONS(3939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LT_LPAREN] = ACTIONS(3939),
    [anon_sym_GT_LPAREN] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3941),
    [sym_word] = ACTIONS(3941),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3941),
  },
  [1636] = {
    [sym_file_descriptor] = ACTIONS(3788),
    [sym__concat] = ACTIONS(3788),
    [sym_variable_name] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3790),
    [anon_sym_GT] = ACTIONS(3790),
    [anon_sym_GT_GT] = ACTIONS(3788),
    [anon_sym_AMP_GT] = ACTIONS(3790),
    [anon_sym_AMP_GT_GT] = ACTIONS(3788),
    [anon_sym_LT_AMP] = ACTIONS(3788),
    [anon_sym_GT_AMP] = ACTIONS(3788),
    [sym__special_characters] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LT_LPAREN] = ACTIONS(3788),
    [anon_sym_GT_LPAREN] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3788),
  },
  [1637] = {
    [sym_file_descriptor] = ACTIONS(3796),
    [sym__concat] = ACTIONS(3796),
    [sym_variable_name] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_GT] = ACTIONS(3798),
    [anon_sym_GT_GT] = ACTIONS(3796),
    [anon_sym_AMP_GT] = ACTIONS(3798),
    [anon_sym_AMP_GT_GT] = ACTIONS(3796),
    [anon_sym_LT_AMP] = ACTIONS(3796),
    [anon_sym_GT_AMP] = ACTIONS(3796),
    [sym__special_characters] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym_raw_string] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3796),
    [anon_sym_GT_LPAREN] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3796),
  },
  [1638] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4479),
    [sym_comment] = ACTIONS(53),
  },
  [1639] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4481),
    [sym_comment] = ACTIONS(53),
  },
  [1640] = {
    [anon_sym_RBRACE] = ACTIONS(4481),
    [sym_comment] = ACTIONS(53),
  },
  [1641] = {
    [sym_concatenation] = STATE(1953),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1953),
    [anon_sym_RBRACE] = ACTIONS(4483),
    [anon_sym_EQ] = ACTIONS(4485),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4485),
    [anon_sym_COLON_QMARK] = ACTIONS(4485),
    [anon_sym_COLON_DASH] = ACTIONS(4485),
    [anon_sym_PERCENT] = ACTIONS(4485),
    [anon_sym_DASH] = ACTIONS(4485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1642] = {
    [sym_file_descriptor] = ACTIONS(3852),
    [sym__concat] = ACTIONS(3852),
    [sym_variable_name] = ACTIONS(3852),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_GT] = ACTIONS(3854),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_AMP_GT] = ACTIONS(3854),
    [anon_sym_AMP_GT_GT] = ACTIONS(3852),
    [anon_sym_LT_AMP] = ACTIONS(3852),
    [anon_sym_GT_AMP] = ACTIONS(3852),
    [sym__special_characters] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym_raw_string] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_LT_LPAREN] = ACTIONS(3852),
    [anon_sym_GT_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3852),
  },
  [1643] = {
    [sym_concatenation] = STATE(1954),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1954),
    [anon_sym_RBRACE] = ACTIONS(4481),
    [anon_sym_EQ] = ACTIONS(4489),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4491),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4489),
    [anon_sym_COLON_QMARK] = ACTIONS(4489),
    [anon_sym_COLON_DASH] = ACTIONS(4489),
    [anon_sym_PERCENT] = ACTIONS(4489),
    [anon_sym_DASH] = ACTIONS(4489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1644] = {
    [sym_file_descriptor] = ACTIONS(3893),
    [sym__concat] = ACTIONS(3893),
    [sym_variable_name] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_GT_GT] = ACTIONS(3893),
    [anon_sym_AMP_GT] = ACTIONS(3895),
    [anon_sym_AMP_GT_GT] = ACTIONS(3893),
    [anon_sym_LT_AMP] = ACTIONS(3893),
    [anon_sym_GT_AMP] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LT_LPAREN] = ACTIONS(3893),
    [anon_sym_GT_LPAREN] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3893),
  },
  [1645] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4493),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1646] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4481),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1647] = {
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [sym_variable_name] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3915),
    [anon_sym_LT_AMP] = ACTIONS(3915),
    [anon_sym_GT_AMP] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3915),
  },
  [1648] = {
    [sym_file_descriptor] = ACTIONS(3939),
    [sym__concat] = ACTIONS(3939),
    [sym_variable_name] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3939),
    [anon_sym_AMP_GT] = ACTIONS(3941),
    [anon_sym_AMP_GT_GT] = ACTIONS(3939),
    [anon_sym_LT_AMP] = ACTIONS(3939),
    [anon_sym_GT_AMP] = ACTIONS(3939),
    [sym__special_characters] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [sym_raw_string] = ACTIONS(3939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LT_LPAREN] = ACTIONS(3939),
    [anon_sym_GT_LPAREN] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3939),
  },
  [1649] = {
    [sym__concat] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym__string_content] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3790),
    [anon_sym_BQUOTE] = ACTIONS(3790),
    [sym_comment] = ACTIONS(265),
  },
  [1650] = {
    [sym__concat] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym__string_content] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3798),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3798),
    [anon_sym_BQUOTE] = ACTIONS(3798),
    [sym_comment] = ACTIONS(265),
  },
  [1651] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4495),
    [sym_comment] = ACTIONS(53),
  },
  [1652] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4497),
    [sym_comment] = ACTIONS(53),
  },
  [1653] = {
    [anon_sym_RBRACE] = ACTIONS(4497),
    [sym_comment] = ACTIONS(53),
  },
  [1654] = {
    [sym_concatenation] = STATE(1959),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1959),
    [anon_sym_RBRACE] = ACTIONS(4499),
    [anon_sym_EQ] = ACTIONS(4501),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4501),
    [anon_sym_COLON_QMARK] = ACTIONS(4501),
    [anon_sym_COLON_DASH] = ACTIONS(4501),
    [anon_sym_PERCENT] = ACTIONS(4501),
    [anon_sym_DASH] = ACTIONS(4501),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1655] = {
    [sym__concat] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3854),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym__string_content] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3854),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3854),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_comment] = ACTIONS(265),
  },
  [1656] = {
    [sym_concatenation] = STATE(1960),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1960),
    [anon_sym_RBRACE] = ACTIONS(4497),
    [anon_sym_EQ] = ACTIONS(4505),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4505),
    [anon_sym_COLON_QMARK] = ACTIONS(4505),
    [anon_sym_COLON_DASH] = ACTIONS(4505),
    [anon_sym_PERCENT] = ACTIONS(4505),
    [anon_sym_DASH] = ACTIONS(4505),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1657] = {
    [sym__concat] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym__string_content] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3895),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3895),
    [anon_sym_BQUOTE] = ACTIONS(3895),
    [sym_comment] = ACTIONS(265),
  },
  [1658] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4509),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1659] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4497),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1660] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym__string_content] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3917),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [sym_comment] = ACTIONS(265),
  },
  [1661] = {
    [sym__concat] = ACTIONS(4511),
    [anon_sym_RBRACE] = ACTIONS(3124),
    [anon_sym_EQ] = ACTIONS(4513),
    [sym__special_characters] = ACTIONS(4513),
    [anon_sym_DQUOTE] = ACTIONS(3124),
    [anon_sym_DOLLAR] = ACTIONS(4513),
    [sym_raw_string] = ACTIONS(3124),
    [anon_sym_POUND] = ACTIONS(3124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3124),
    [anon_sym_SLASH] = ACTIONS(3124),
    [anon_sym_COLON] = ACTIONS(4513),
    [anon_sym_COLON_QMARK] = ACTIONS(4513),
    [anon_sym_COLON_DASH] = ACTIONS(4513),
    [anon_sym_PERCENT] = ACTIONS(4513),
    [anon_sym_DASH] = ACTIONS(4513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3124),
    [anon_sym_BQUOTE] = ACTIONS(3124),
    [anon_sym_LT_LPAREN] = ACTIONS(3124),
    [anon_sym_GT_LPAREN] = ACTIONS(3124),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4513),
  },
  [1662] = {
    [anon_sym_RBRACE] = ACTIONS(3124),
    [anon_sym_EQ] = ACTIONS(4513),
    [sym__special_characters] = ACTIONS(4513),
    [anon_sym_DQUOTE] = ACTIONS(3124),
    [anon_sym_DOLLAR] = ACTIONS(4513),
    [sym_raw_string] = ACTIONS(3124),
    [anon_sym_POUND] = ACTIONS(3124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3124),
    [anon_sym_SLASH] = ACTIONS(3124),
    [anon_sym_COLON] = ACTIONS(4513),
    [anon_sym_COLON_QMARK] = ACTIONS(4513),
    [anon_sym_COLON_DASH] = ACTIONS(4513),
    [anon_sym_PERCENT] = ACTIONS(4513),
    [anon_sym_DASH] = ACTIONS(4513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3124),
    [anon_sym_BQUOTE] = ACTIONS(3124),
    [anon_sym_LT_LPAREN] = ACTIONS(3124),
    [anon_sym_GT_LPAREN] = ACTIONS(3124),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4513),
  },
  [1663] = {
    [sym__concat] = ACTIONS(4515),
    [anon_sym_RBRACE] = ACTIONS(3128),
    [anon_sym_EQ] = ACTIONS(4517),
    [sym__special_characters] = ACTIONS(4517),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [anon_sym_DOLLAR] = ACTIONS(4517),
    [sym_raw_string] = ACTIONS(3128),
    [anon_sym_POUND] = ACTIONS(3128),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3128),
    [anon_sym_SLASH] = ACTIONS(3128),
    [anon_sym_COLON] = ACTIONS(4517),
    [anon_sym_COLON_QMARK] = ACTIONS(4517),
    [anon_sym_COLON_DASH] = ACTIONS(4517),
    [anon_sym_PERCENT] = ACTIONS(4517),
    [anon_sym_DASH] = ACTIONS(4517),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3128),
    [anon_sym_BQUOTE] = ACTIONS(3128),
    [anon_sym_LT_LPAREN] = ACTIONS(3128),
    [anon_sym_GT_LPAREN] = ACTIONS(3128),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4517),
  },
  [1664] = {
    [anon_sym_RBRACE] = ACTIONS(3128),
    [anon_sym_EQ] = ACTIONS(4517),
    [sym__special_characters] = ACTIONS(4517),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [anon_sym_DOLLAR] = ACTIONS(4517),
    [sym_raw_string] = ACTIONS(3128),
    [anon_sym_POUND] = ACTIONS(3128),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3128),
    [anon_sym_SLASH] = ACTIONS(3128),
    [anon_sym_COLON] = ACTIONS(4517),
    [anon_sym_COLON_QMARK] = ACTIONS(4517),
    [anon_sym_COLON_DASH] = ACTIONS(4517),
    [anon_sym_PERCENT] = ACTIONS(4517),
    [anon_sym_DASH] = ACTIONS(4517),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3128),
    [anon_sym_BQUOTE] = ACTIONS(3128),
    [anon_sym_LT_LPAREN] = ACTIONS(3128),
    [anon_sym_GT_LPAREN] = ACTIONS(3128),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4517),
  },
  [1665] = {
    [sym__concat] = ACTIONS(1724),
    [anon_sym_RBRACE] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
  },
  [1666] = {
    [aux_sym_concatenation_repeat1] = STATE(1666),
    [sym__concat] = ACTIONS(4519),
    [anon_sym_RBRACE] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
  },
  [1667] = {
    [sym__concat] = ACTIONS(1731),
    [anon_sym_RBRACE] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
  },
  [1668] = {
    [anon_sym_DQUOTE] = ACTIONS(4522),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [1669] = {
    [sym_concatenation] = STATE(1968),
    [sym_string] = STATE(1967),
    [sym_simple_expansion] = STATE(1967),
    [sym_string_expansion] = STATE(1967),
    [sym_expansion] = STATE(1967),
    [sym_command_substitution] = STATE(1967),
    [sym_process_substitution] = STATE(1967),
    [anon_sym_RBRACE] = ACTIONS(4524),
    [sym__special_characters] = ACTIONS(4526),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(4528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4528),
  },
  [1670] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(4530),
    [sym_comment] = ACTIONS(53),
  },
  [1671] = {
    [sym_concatenation] = STATE(1972),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1972),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [anon_sym_EQ] = ACTIONS(4534),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4534),
    [anon_sym_COLON_QMARK] = ACTIONS(4534),
    [anon_sym_COLON_DASH] = ACTIONS(4534),
    [anon_sym_PERCENT] = ACTIONS(4534),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1672] = {
    [sym_concatenation] = STATE(1974),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1974),
    [anon_sym_RBRACE] = ACTIONS(4524),
    [anon_sym_EQ] = ACTIONS(4540),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4544),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_COLON_QMARK] = ACTIONS(4540),
    [anon_sym_COLON_DASH] = ACTIONS(4540),
    [anon_sym_PERCENT] = ACTIONS(4540),
    [anon_sym_DASH] = ACTIONS(4540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1673] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_RBRACE] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
  },
  [1674] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4546),
  },
  [1675] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1676] = {
    [sym__concat] = ACTIONS(1876),
    [anon_sym_RBRACE] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
  },
  [1677] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4550),
  },
  [1678] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4524),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1679] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4552),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1680] = {
    [sym__concat] = ACTIONS(1884),
    [anon_sym_RBRACE] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
  },
  [1681] = {
    [anon_sym_SEMI] = ACTIONS(4554),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4552),
    [anon_sym_SEMI_SEMI] = ACTIONS(4556),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(4554),
  },
  [1682] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4554),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4552),
    [anon_sym_SEMI_SEMI] = ACTIONS(4556),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(4554),
  },
  [1683] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4552),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1684] = {
    [anon_sym_SEMI] = ACTIONS(4558),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(4560),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(4552),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4560),
    [anon_sym_AMP] = ACTIONS(4558),
  },
  [1685] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4558),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(4560),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(4552),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4560),
    [anon_sym_AMP] = ACTIONS(4558),
  },
  [1686] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4562),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1687] = {
    [sym__concat] = ACTIONS(1916),
    [anon_sym_RBRACE] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
  },
  [1688] = {
    [anon_sym_SEMI] = ACTIONS(4564),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4562),
    [anon_sym_SEMI_SEMI] = ACTIONS(4566),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4566),
    [anon_sym_AMP] = ACTIONS(4564),
  },
  [1689] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4564),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4562),
    [anon_sym_SEMI_SEMI] = ACTIONS(4566),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4566),
    [anon_sym_AMP] = ACTIONS(4564),
  },
  [1690] = {
    [sym__simple_heredoc_body] = ACTIONS(4568),
    [sym__heredoc_body_beginning] = ACTIONS(4568),
    [sym_file_descriptor] = ACTIONS(4568),
    [sym__concat] = ACTIONS(4568),
    [ts_builtin_sym_end] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_EQ_TILDE] = ACTIONS(4570),
    [anon_sym_EQ_EQ] = ACTIONS(4570),
    [anon_sym_LT] = ACTIONS(4570),
    [anon_sym_GT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_AMP_GT] = ACTIONS(4570),
    [anon_sym_AMP_GT_GT] = ACTIONS(4568),
    [anon_sym_LT_AMP] = ACTIONS(4568),
    [anon_sym_GT_AMP] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4570),
    [anon_sym_LT_LT_DASH] = ACTIONS(4568),
    [anon_sym_LT_LT_LT] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_LT_LPAREN] = ACTIONS(4568),
    [anon_sym_GT_LPAREN] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4570),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4570),
  },
  [1691] = {
    [sym__simple_heredoc_body] = ACTIONS(4572),
    [sym__heredoc_body_beginning] = ACTIONS(4572),
    [sym_file_descriptor] = ACTIONS(4572),
    [sym__concat] = ACTIONS(4572),
    [ts_builtin_sym_end] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_PIPE] = ACTIONS(4574),
    [anon_sym_RPAREN] = ACTIONS(4572),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [anon_sym_PIPE_AMP] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [anon_sym_EQ_TILDE] = ACTIONS(4574),
    [anon_sym_EQ_EQ] = ACTIONS(4574),
    [anon_sym_LT] = ACTIONS(4574),
    [anon_sym_GT] = ACTIONS(4574),
    [anon_sym_GT_GT] = ACTIONS(4572),
    [anon_sym_AMP_GT] = ACTIONS(4574),
    [anon_sym_AMP_GT_GT] = ACTIONS(4572),
    [anon_sym_LT_AMP] = ACTIONS(4572),
    [anon_sym_GT_AMP] = ACTIONS(4572),
    [anon_sym_LT_LT] = ACTIONS(4574),
    [anon_sym_LT_LT_DASH] = ACTIONS(4572),
    [anon_sym_LT_LT_LT] = ACTIONS(4572),
    [sym__special_characters] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4574),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4574),
  },
  [1692] = {
    [sym__simple_heredoc_body] = ACTIONS(4576),
    [sym__heredoc_body_beginning] = ACTIONS(4576),
    [sym_file_descriptor] = ACTIONS(4576),
    [sym__concat] = ACTIONS(4576),
    [ts_builtin_sym_end] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(4578),
    [anon_sym_RPAREN] = ACTIONS(4576),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [anon_sym_PIPE_AMP] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [anon_sym_EQ_TILDE] = ACTIONS(4578),
    [anon_sym_EQ_EQ] = ACTIONS(4578),
    [anon_sym_LT] = ACTIONS(4578),
    [anon_sym_GT] = ACTIONS(4578),
    [anon_sym_GT_GT] = ACTIONS(4576),
    [anon_sym_AMP_GT] = ACTIONS(4578),
    [anon_sym_AMP_GT_GT] = ACTIONS(4576),
    [anon_sym_LT_AMP] = ACTIONS(4576),
    [anon_sym_GT_AMP] = ACTIONS(4576),
    [anon_sym_LT_LT] = ACTIONS(4578),
    [anon_sym_LT_LT_DASH] = ACTIONS(4576),
    [anon_sym_LT_LT_LT] = ACTIONS(4576),
    [sym__special_characters] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_LT_LPAREN] = ACTIONS(4576),
    [anon_sym_GT_LPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4578),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4578),
  },
  [1693] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4580),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1694] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4582),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1695] = {
    [sym__concat] = ACTIONS(2876),
    [anon_sym_RBRACE] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2878),
    [sym__special_characters] = ACTIONS(2878),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_POUND] = ACTIONS(2876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_COLON] = ACTIONS(2878),
    [anon_sym_COLON_QMARK] = ACTIONS(2878),
    [anon_sym_COLON_DASH] = ACTIONS(2878),
    [anon_sym_PERCENT] = ACTIONS(2878),
    [anon_sym_DASH] = ACTIONS(2878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [anon_sym_LT_LPAREN] = ACTIONS(2876),
    [anon_sym_GT_LPAREN] = ACTIONS(2876),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(2878),
  },
  [1696] = {
    [sym__concat] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2890),
    [anon_sym_EQ] = ACTIONS(2892),
    [sym__special_characters] = ACTIONS(2892),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_POUND] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [anon_sym_COLON] = ACTIONS(2892),
    [anon_sym_COLON_QMARK] = ACTIONS(2892),
    [anon_sym_COLON_DASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [anon_sym_LT_LPAREN] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(2892),
  },
  [1697] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4584),
    [sym_comment] = ACTIONS(53),
  },
  [1698] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4586),
    [sym_comment] = ACTIONS(53),
  },
  [1699] = {
    [anon_sym_RBRACE] = ACTIONS(4586),
    [sym_comment] = ACTIONS(53),
  },
  [1700] = {
    [sym_concatenation] = STATE(1989),
    [sym_string] = STATE(1988),
    [sym_simple_expansion] = STATE(1988),
    [sym_string_expansion] = STATE(1988),
    [sym_expansion] = STATE(1988),
    [sym_command_substitution] = STATE(1988),
    [sym_process_substitution] = STATE(1988),
    [anon_sym_RBRACE] = ACTIONS(4586),
    [sym__special_characters] = ACTIONS(4588),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(4590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4590),
  },
  [1701] = {
    [sym__concat] = ACTIONS(2926),
    [anon_sym_RBRACE] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [sym__special_characters] = ACTIONS(2928),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym_raw_string] = ACTIONS(2926),
    [anon_sym_POUND] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [anon_sym_COLON] = ACTIONS(2928),
    [anon_sym_COLON_QMARK] = ACTIONS(2928),
    [anon_sym_COLON_DASH] = ACTIONS(2928),
    [anon_sym_PERCENT] = ACTIONS(2928),
    [anon_sym_DASH] = ACTIONS(2928),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [anon_sym_LT_LPAREN] = ACTIONS(2926),
    [anon_sym_GT_LPAREN] = ACTIONS(2926),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(2928),
  },
  [1702] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4592),
  },
  [1703] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4594),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1704] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4596),
  },
  [1705] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1706] = {
    [sym_concatenation] = STATE(1994),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1994),
    [anon_sym_RBRACE] = ACTIONS(4598),
    [anon_sym_EQ] = ACTIONS(4600),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4600),
    [anon_sym_COLON_QMARK] = ACTIONS(4600),
    [anon_sym_COLON_DASH] = ACTIONS(4600),
    [anon_sym_PERCENT] = ACTIONS(4600),
    [anon_sym_DASH] = ACTIONS(4600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1707] = {
    [sym__concat] = ACTIONS(2990),
    [anon_sym_RBRACE] = ACTIONS(2990),
    [anon_sym_EQ] = ACTIONS(2992),
    [sym__special_characters] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym_raw_string] = ACTIONS(2990),
    [anon_sym_POUND] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_DASH] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_LT_LPAREN] = ACTIONS(2990),
    [anon_sym_GT_LPAREN] = ACTIONS(2990),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(2992),
  },
  [1708] = {
    [sym_concatenation] = STATE(1995),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(1995),
    [anon_sym_RBRACE] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(4604),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4606),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COLON_QMARK] = ACTIONS(4604),
    [anon_sym_COLON_DASH] = ACTIONS(4604),
    [anon_sym_PERCENT] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1709] = {
    [sym__simple_heredoc_body] = ACTIONS(4608),
    [sym__heredoc_body_beginning] = ACTIONS(4608),
    [sym_file_descriptor] = ACTIONS(4608),
    [sym__concat] = ACTIONS(4608),
    [ts_builtin_sym_end] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4610),
    [anon_sym_RPAREN] = ACTIONS(4608),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [anon_sym_PIPE_AMP] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT] = ACTIONS(4610),
    [anon_sym_GT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_AMP_GT] = ACTIONS(4610),
    [anon_sym_AMP_GT_GT] = ACTIONS(4608),
    [anon_sym_LT_AMP] = ACTIONS(4608),
    [anon_sym_GT_AMP] = ACTIONS(4608),
    [anon_sym_LT_LT] = ACTIONS(4610),
    [anon_sym_LT_LT_DASH] = ACTIONS(4608),
    [anon_sym_LT_LT_LT] = ACTIONS(4608),
    [sym__special_characters] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_LT_LPAREN] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4610),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4610),
  },
  [1710] = {
    [sym__concat] = ACTIONS(3033),
    [anon_sym_RBRACE] = ACTIONS(3033),
    [anon_sym_EQ] = ACTIONS(3035),
    [sym__special_characters] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_POUND] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_DASH] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [anon_sym_LT_LPAREN] = ACTIONS(3033),
    [anon_sym_GT_LPAREN] = ACTIONS(3033),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3035),
  },
  [1711] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4612),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1712] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4612),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1713] = {
    [sym__concat] = ACTIONS(3071),
    [anon_sym_RBRACE] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [sym__special_characters] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [sym_raw_string] = ACTIONS(3071),
    [anon_sym_POUND] = ACTIONS(3071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3073),
    [anon_sym_COLON_QMARK] = ACTIONS(3073),
    [anon_sym_COLON_DASH] = ACTIONS(3073),
    [anon_sym_PERCENT] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_LT_LPAREN] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(3071),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3073),
  },
  [1714] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4614),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1715] = {
    [sym_file_redirect] = STATE(1541),
    [sym_file_descriptor] = ACTIONS(3041),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(3522),
    [anon_sym_SEMI_SEMI] = ACTIONS(3520),
    [anon_sym_PIPE_AMP] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(3043),
    [anon_sym_GT] = ACTIONS(3043),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_AMP_GT] = ACTIONS(3043),
    [anon_sym_AMP_GT_GT] = ACTIONS(3045),
    [anon_sym_LT_AMP] = ACTIONS(3045),
    [anon_sym_GT_AMP] = ACTIONS(3045),
    [anon_sym_BQUOTE] = ACTIONS(3520),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3522),
  },
  [1716] = {
    [sym_concatenation] = STATE(1544),
    [sym_string] = STATE(1999),
    [sym_simple_expansion] = STATE(1999),
    [sym_string_expansion] = STATE(1999),
    [sym_expansion] = STATE(1999),
    [sym_command_substitution] = STATE(1999),
    [sym_process_substitution] = STATE(1999),
    [sym__special_characters] = ACTIONS(4616),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_DOLLAR] = ACTIONS(215),
    [sym_raw_string] = ACTIONS(4618),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(223),
    [anon_sym_LT_LPAREN] = ACTIONS(225),
    [anon_sym_GT_LPAREN] = ACTIONS(225),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4618),
  },
  [1717] = {
    [aux_sym_concatenation_repeat1] = STATE(2000),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [1718] = {
    [aux_sym_concatenation_repeat1] = STATE(2000),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [1719] = {
    [sym_concatenation] = STATE(1574),
    [sym_string] = STATE(2002),
    [sym_simple_expansion] = STATE(2002),
    [sym_string_expansion] = STATE(2002),
    [sym_expansion] = STATE(2002),
    [sym_command_substitution] = STATE(2002),
    [sym_process_substitution] = STATE(2002),
    [sym__special_characters] = ACTIONS(4620),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(4622),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4622),
  },
  [1720] = {
    [aux_sym_concatenation_repeat1] = STATE(2003),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [1721] = {
    [aux_sym_concatenation_repeat1] = STATE(2003),
    [sym_file_descriptor] = ACTIONS(749),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_LT_LT_DASH] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(749),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [1722] = {
    [aux_sym_concatenation_repeat1] = STATE(2003),
    [sym_file_descriptor] = ACTIONS(1972),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_PIPE_AMP] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_PIPE_PIPE] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_AMP_GT] = ACTIONS(1974),
    [anon_sym_AMP_GT_GT] = ACTIONS(1972),
    [anon_sym_LT_AMP] = ACTIONS(1972),
    [anon_sym_GT_AMP] = ACTIONS(1972),
    [anon_sym_LT_LT] = ACTIONS(1974),
    [anon_sym_LT_LT_DASH] = ACTIONS(1972),
    [anon_sym_LT_LT_LT] = ACTIONS(1972),
    [anon_sym_BQUOTE] = ACTIONS(1972),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1974),
  },
  [1723] = {
    [aux_sym_concatenation_repeat1] = STATE(2003),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [anon_sym_BQUOTE] = ACTIONS(1976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [1724] = {
    [sym_file_redirect] = STATE(1724),
    [sym_heredoc_redirect] = STATE(1724),
    [sym_herestring_redirect] = STATE(1724),
    [aux_sym_while_statement_repeat1] = STATE(1724),
    [sym_file_descriptor] = ACTIONS(4624),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(4627),
    [anon_sym_GT] = ACTIONS(4627),
    [anon_sym_GT_GT] = ACTIONS(4630),
    [anon_sym_AMP_GT] = ACTIONS(4627),
    [anon_sym_AMP_GT_GT] = ACTIONS(4630),
    [anon_sym_LT_AMP] = ACTIONS(4630),
    [anon_sym_GT_AMP] = ACTIONS(4630),
    [anon_sym_LT_LT] = ACTIONS(3625),
    [anon_sym_LT_LT_DASH] = ACTIONS(3628),
    [anon_sym_LT_LT_LT] = ACTIONS(4633),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1989),
  },
  [1725] = {
    [aux_sym_concatenation_repeat1] = STATE(1725),
    [sym__simple_heredoc_body] = ACTIONS(1724),
    [sym__heredoc_body_beginning] = ACTIONS(1724),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1726] = {
    [sym__heredoc_body_middle] = ACTIONS(2890),
    [sym__heredoc_body_end] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
  },
  [1727] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [sym_comment] = ACTIONS(53),
  },
  [1728] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4638),
    [sym_comment] = ACTIONS(53),
  },
  [1729] = {
    [anon_sym_RBRACE] = ACTIONS(4638),
    [sym_comment] = ACTIONS(53),
  },
  [1730] = {
    [sym_concatenation] = STATE(2008),
    [sym_string] = STATE(2007),
    [sym_simple_expansion] = STATE(2007),
    [sym_string_expansion] = STATE(2007),
    [sym_expansion] = STATE(2007),
    [sym_command_substitution] = STATE(2007),
    [sym_process_substitution] = STATE(2007),
    [anon_sym_RBRACE] = ACTIONS(4638),
    [sym__special_characters] = ACTIONS(4640),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(4642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4642),
  },
  [1731] = {
    [sym__heredoc_body_middle] = ACTIONS(2926),
    [sym__heredoc_body_end] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
  },
  [1732] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4644),
  },
  [1733] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1734] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4648),
  },
  [1735] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4638),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1736] = {
    [sym_concatenation] = STATE(2013),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2013),
    [anon_sym_RBRACE] = ACTIONS(4650),
    [anon_sym_EQ] = ACTIONS(4652),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4652),
    [anon_sym_COLON_QMARK] = ACTIONS(4652),
    [anon_sym_COLON_DASH] = ACTIONS(4652),
    [anon_sym_PERCENT] = ACTIONS(4652),
    [anon_sym_DASH] = ACTIONS(4652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1737] = {
    [sym__heredoc_body_middle] = ACTIONS(2990),
    [sym__heredoc_body_end] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
  },
  [1738] = {
    [sym_concatenation] = STATE(2014),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2014),
    [anon_sym_RBRACE] = ACTIONS(4638),
    [anon_sym_EQ] = ACTIONS(4656),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4656),
    [anon_sym_COLON_QMARK] = ACTIONS(4656),
    [anon_sym_COLON_DASH] = ACTIONS(4656),
    [anon_sym_PERCENT] = ACTIONS(4656),
    [anon_sym_DASH] = ACTIONS(4656),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1739] = {
    [sym__concat] = ACTIONS(2876),
    [anon_sym_RPAREN] = ACTIONS(2876),
    [sym__special_characters] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [anon_sym_LT_LPAREN] = ACTIONS(2876),
    [anon_sym_GT_LPAREN] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2876),
  },
  [1740] = {
    [sym__concat] = ACTIONS(2890),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [sym__special_characters] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [anon_sym_LT_LPAREN] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2890),
  },
  [1741] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4660),
    [sym_comment] = ACTIONS(53),
  },
  [1742] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4662),
    [sym_comment] = ACTIONS(53),
  },
  [1743] = {
    [anon_sym_RBRACE] = ACTIONS(4662),
    [sym_comment] = ACTIONS(53),
  },
  [1744] = {
    [sym_concatenation] = STATE(2019),
    [sym_string] = STATE(2018),
    [sym_simple_expansion] = STATE(2018),
    [sym_string_expansion] = STATE(2018),
    [sym_expansion] = STATE(2018),
    [sym_command_substitution] = STATE(2018),
    [sym_process_substitution] = STATE(2018),
    [anon_sym_RBRACE] = ACTIONS(4662),
    [sym__special_characters] = ACTIONS(4664),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(4666),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4666),
  },
  [1745] = {
    [sym__concat] = ACTIONS(2926),
    [anon_sym_RPAREN] = ACTIONS(2926),
    [sym__special_characters] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym_raw_string] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [anon_sym_LT_LPAREN] = ACTIONS(2926),
    [anon_sym_GT_LPAREN] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2926),
  },
  [1746] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4668),
  },
  [1747] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4670),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1748] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4672),
  },
  [1749] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4662),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1750] = {
    [sym_concatenation] = STATE(2024),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2024),
    [anon_sym_RBRACE] = ACTIONS(4674),
    [anon_sym_EQ] = ACTIONS(4676),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4678),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4676),
    [anon_sym_COLON_QMARK] = ACTIONS(4676),
    [anon_sym_COLON_DASH] = ACTIONS(4676),
    [anon_sym_PERCENT] = ACTIONS(4676),
    [anon_sym_DASH] = ACTIONS(4676),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1751] = {
    [sym__concat] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(2990),
    [sym__special_characters] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym_raw_string] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_LT_LPAREN] = ACTIONS(2990),
    [anon_sym_GT_LPAREN] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2990),
  },
  [1752] = {
    [sym_concatenation] = STATE(2025),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2025),
    [anon_sym_RBRACE] = ACTIONS(4662),
    [anon_sym_EQ] = ACTIONS(4680),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4680),
    [anon_sym_COLON_QMARK] = ACTIONS(4680),
    [anon_sym_COLON_DASH] = ACTIONS(4680),
    [anon_sym_PERCENT] = ACTIONS(4680),
    [anon_sym_DASH] = ACTIONS(4680),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1753] = {
    [sym__concat] = ACTIONS(3033),
    [anon_sym_RPAREN] = ACTIONS(3033),
    [sym__special_characters] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [anon_sym_LT_LPAREN] = ACTIONS(3033),
    [anon_sym_GT_LPAREN] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3033),
  },
  [1754] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4684),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1755] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4684),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1756] = {
    [sym__concat] = ACTIONS(3071),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [sym__special_characters] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [sym_raw_string] = ACTIONS(3071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_LT_LPAREN] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3071),
  },
  [1757] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4686),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1758] = {
    [sym_file_descriptor] = ACTIONS(3788),
    [sym__concat] = ACTIONS(3788),
    [sym_variable_name] = ACTIONS(3788),
    [ts_builtin_sym_end] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_PIPE] = ACTIONS(3790),
    [anon_sym_RPAREN] = ACTIONS(3788),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [anon_sym_PIPE_AMP] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3790),
    [anon_sym_GT] = ACTIONS(3790),
    [anon_sym_GT_GT] = ACTIONS(3788),
    [anon_sym_AMP_GT] = ACTIONS(3790),
    [anon_sym_AMP_GT_GT] = ACTIONS(3788),
    [anon_sym_LT_AMP] = ACTIONS(3788),
    [anon_sym_GT_AMP] = ACTIONS(3788),
    [sym__special_characters] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LT_LPAREN] = ACTIONS(3788),
    [anon_sym_GT_LPAREN] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3790),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3790),
  },
  [1759] = {
    [sym_file_descriptor] = ACTIONS(3796),
    [sym__concat] = ACTIONS(3796),
    [sym_variable_name] = ACTIONS(3796),
    [ts_builtin_sym_end] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3798),
    [anon_sym_RPAREN] = ACTIONS(3796),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [anon_sym_PIPE_AMP] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_GT] = ACTIONS(3798),
    [anon_sym_GT_GT] = ACTIONS(3796),
    [anon_sym_AMP_GT] = ACTIONS(3798),
    [anon_sym_AMP_GT_GT] = ACTIONS(3796),
    [anon_sym_LT_AMP] = ACTIONS(3796),
    [anon_sym_GT_AMP] = ACTIONS(3796),
    [sym__special_characters] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym_raw_string] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3796),
    [anon_sym_GT_LPAREN] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3798),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3798),
  },
  [1760] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4688),
    [sym_comment] = ACTIONS(53),
  },
  [1761] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4690),
    [sym_comment] = ACTIONS(53),
  },
  [1762] = {
    [anon_sym_RBRACE] = ACTIONS(4690),
    [sym_comment] = ACTIONS(53),
  },
  [1763] = {
    [sym_concatenation] = STATE(2031),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2031),
    [anon_sym_RBRACE] = ACTIONS(4692),
    [anon_sym_EQ] = ACTIONS(4694),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4694),
    [anon_sym_COLON_QMARK] = ACTIONS(4694),
    [anon_sym_COLON_DASH] = ACTIONS(4694),
    [anon_sym_PERCENT] = ACTIONS(4694),
    [anon_sym_DASH] = ACTIONS(4694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1764] = {
    [sym_file_descriptor] = ACTIONS(3852),
    [sym__concat] = ACTIONS(3852),
    [sym_variable_name] = ACTIONS(3852),
    [ts_builtin_sym_end] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_PIPE] = ACTIONS(3854),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [anon_sym_PIPE_AMP] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_GT] = ACTIONS(3854),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_AMP_GT] = ACTIONS(3854),
    [anon_sym_AMP_GT_GT] = ACTIONS(3852),
    [anon_sym_LT_AMP] = ACTIONS(3852),
    [anon_sym_GT_AMP] = ACTIONS(3852),
    [sym__special_characters] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym_raw_string] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_LT_LPAREN] = ACTIONS(3852),
    [anon_sym_GT_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3854),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3854),
  },
  [1765] = {
    [sym_concatenation] = STATE(2032),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2032),
    [anon_sym_RBRACE] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4698),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4700),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4698),
    [anon_sym_COLON_QMARK] = ACTIONS(4698),
    [anon_sym_COLON_DASH] = ACTIONS(4698),
    [anon_sym_PERCENT] = ACTIONS(4698),
    [anon_sym_DASH] = ACTIONS(4698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1766] = {
    [sym_file_descriptor] = ACTIONS(3893),
    [sym__concat] = ACTIONS(3893),
    [sym_variable_name] = ACTIONS(3893),
    [ts_builtin_sym_end] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_RPAREN] = ACTIONS(3893),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [anon_sym_PIPE_AMP] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_GT_GT] = ACTIONS(3893),
    [anon_sym_AMP_GT] = ACTIONS(3895),
    [anon_sym_AMP_GT_GT] = ACTIONS(3893),
    [anon_sym_LT_AMP] = ACTIONS(3893),
    [anon_sym_GT_AMP] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LT_LPAREN] = ACTIONS(3893),
    [anon_sym_GT_LPAREN] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3895),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3895),
  },
  [1767] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4702),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1768] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1769] = {
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [sym_variable_name] = ACTIONS(3915),
    [ts_builtin_sym_end] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3915),
    [anon_sym_LT_AMP] = ACTIONS(3915),
    [anon_sym_GT_AMP] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [1770] = {
    [sym_file_descriptor] = ACTIONS(3939),
    [sym__concat] = ACTIONS(3939),
    [sym_variable_name] = ACTIONS(3939),
    [ts_builtin_sym_end] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_RPAREN] = ACTIONS(3939),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [anon_sym_PIPE_AMP] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3939),
    [anon_sym_AMP_GT] = ACTIONS(3941),
    [anon_sym_AMP_GT_GT] = ACTIONS(3939),
    [anon_sym_LT_AMP] = ACTIONS(3939),
    [anon_sym_GT_AMP] = ACTIONS(3939),
    [sym__special_characters] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [sym_raw_string] = ACTIONS(3939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LT_LPAREN] = ACTIONS(3939),
    [anon_sym_GT_LPAREN] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3941),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3941),
  },
  [1771] = {
    [ts_builtin_sym_end] = ACTIONS(4704),
    [anon_sym_SEMI] = ACTIONS(4706),
    [anon_sym_esac] = ACTIONS(4704),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_RPAREN] = ACTIONS(4704),
    [anon_sym_SEMI_SEMI] = ACTIONS(4704),
    [anon_sym_PIPE_AMP] = ACTIONS(4704),
    [anon_sym_AMP_AMP] = ACTIONS(4704),
    [anon_sym_PIPE_PIPE] = ACTIONS(4704),
    [anon_sym_BQUOTE] = ACTIONS(4704),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4704),
    [anon_sym_AMP] = ACTIONS(4706),
  },
  [1772] = {
    [ts_builtin_sym_end] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_esac] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [1773] = {
    [sym__terminated_statement] = STATE(1131),
    [sym_for_statement] = STATE(667),
    [sym_c_style_for_statement] = STATE(667),
    [sym_while_statement] = STATE(667),
    [sym_if_statement] = STATE(667),
    [sym_case_statement] = STATE(667),
    [sym_function_definition] = STATE(667),
    [sym_subshell] = STATE(667),
    [sym_pipeline] = STATE(667),
    [sym_list] = STATE(667),
    [sym_negated_command] = STATE(667),
    [sym_test_command] = STATE(667),
    [sym_declaration_command] = STATE(667),
    [sym_unset_command] = STATE(667),
    [sym_command] = STATE(667),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(668),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1131),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_RBRACE] = ACTIONS(4708),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [1774] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2547),
    [anon_sym_AMP_AMP] = ACTIONS(2547),
    [anon_sym_PIPE_PIPE] = ACTIONS(2547),
    [anon_sym_EQ_TILDE] = ACTIONS(2547),
    [anon_sym_EQ_EQ] = ACTIONS(2547),
    [anon_sym_EQ] = ACTIONS(2549),
    [anon_sym_LT] = ACTIONS(2547),
    [anon_sym_GT] = ACTIONS(2547),
    [anon_sym_BANG_EQ] = ACTIONS(2547),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2547),
  },
  [1775] = {
    [sym__concat] = ACTIONS(1724),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1724),
    [anon_sym_EQ_EQ] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1724),
    [anon_sym_GT] = ACTIONS(1724),
    [anon_sym_BANG_EQ] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1724),
  },
  [1776] = {
    [aux_sym_concatenation_repeat1] = STATE(1776),
    [sym__concat] = ACTIONS(4710),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1724),
    [anon_sym_EQ_EQ] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1724),
    [anon_sym_GT] = ACTIONS(1724),
    [anon_sym_BANG_EQ] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1724),
  },
  [1777] = {
    [sym__concat] = ACTIONS(1731),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [anon_sym_EQ_TILDE] = ACTIONS(1731),
    [anon_sym_EQ_EQ] = ACTIONS(1731),
    [anon_sym_EQ] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_GT] = ACTIONS(1731),
    [anon_sym_BANG_EQ] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1731),
  },
  [1778] = {
    [anon_sym_DQUOTE] = ACTIONS(4713),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [1779] = {
    [sym_concatenation] = STATE(2039),
    [sym_string] = STATE(2038),
    [sym_simple_expansion] = STATE(2038),
    [sym_string_expansion] = STATE(2038),
    [sym_expansion] = STATE(2038),
    [sym_command_substitution] = STATE(2038),
    [sym_process_substitution] = STATE(2038),
    [anon_sym_RBRACE] = ACTIONS(4715),
    [sym__special_characters] = ACTIONS(4717),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(4719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4719),
  },
  [1780] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(4721),
    [sym_comment] = ACTIONS(53),
  },
  [1781] = {
    [sym_concatenation] = STATE(2043),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2043),
    [anon_sym_RBRACE] = ACTIONS(4723),
    [anon_sym_EQ] = ACTIONS(4725),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4729),
    [anon_sym_COLON] = ACTIONS(4725),
    [anon_sym_COLON_QMARK] = ACTIONS(4725),
    [anon_sym_COLON_DASH] = ACTIONS(4725),
    [anon_sym_PERCENT] = ACTIONS(4725),
    [anon_sym_DASH] = ACTIONS(4725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1782] = {
    [sym_concatenation] = STATE(2045),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2045),
    [anon_sym_RBRACE] = ACTIONS(4715),
    [anon_sym_EQ] = ACTIONS(4731),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4735),
    [anon_sym_COLON] = ACTIONS(4731),
    [anon_sym_COLON_QMARK] = ACTIONS(4731),
    [anon_sym_COLON_DASH] = ACTIONS(4731),
    [anon_sym_PERCENT] = ACTIONS(4731),
    [anon_sym_DASH] = ACTIONS(4731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1783] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_EQ_TILDE] = ACTIONS(1832),
    [anon_sym_EQ_EQ] = ACTIONS(1832),
    [anon_sym_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1832),
    [anon_sym_GT] = ACTIONS(1832),
    [anon_sym_BANG_EQ] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1832),
  },
  [1784] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4737),
  },
  [1785] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1786] = {
    [sym__concat] = ACTIONS(1876),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [anon_sym_EQ_TILDE] = ACTIONS(1876),
    [anon_sym_EQ_EQ] = ACTIONS(1876),
    [anon_sym_EQ] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_GT] = ACTIONS(1876),
    [anon_sym_BANG_EQ] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1876),
  },
  [1787] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4741),
  },
  [1788] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4715),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1789] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1790] = {
    [sym__concat] = ACTIONS(1884),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [anon_sym_EQ_TILDE] = ACTIONS(1884),
    [anon_sym_EQ_EQ] = ACTIONS(1884),
    [anon_sym_EQ] = ACTIONS(1886),
    [anon_sym_LT] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1884),
    [anon_sym_BANG_EQ] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1884),
  },
  [1791] = {
    [anon_sym_SEMI] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_SEMI_SEMI] = ACTIONS(4747),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4747),
    [anon_sym_AMP] = ACTIONS(4745),
  },
  [1792] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_SEMI_SEMI] = ACTIONS(4747),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4747),
    [anon_sym_AMP] = ACTIONS(4745),
  },
  [1793] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1794] = {
    [anon_sym_SEMI] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4749),
  },
  [1795] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(4751),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4751),
    [anon_sym_AMP] = ACTIONS(4749),
  },
  [1796] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1797] = {
    [sym__concat] = ACTIONS(1916),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [anon_sym_EQ_TILDE] = ACTIONS(1916),
    [anon_sym_EQ_EQ] = ACTIONS(1916),
    [anon_sym_EQ] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1916),
    [anon_sym_BANG_EQ] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(1916),
  },
  [1798] = {
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_SEMI_SEMI] = ACTIONS(4757),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [1799] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_SEMI_SEMI] = ACTIONS(4757),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4755),
  },
  [1800] = {
    [sym_do_group] = STATE(2054),
    [sym_compound_statement] = STATE(2054),
    [anon_sym_do] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [sym_comment] = ACTIONS(53),
  },
  [1801] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_EQ] = ACTIONS(2604),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2602),
  },
  [1802] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_EQ] = ACTIONS(2604),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2602),
  },
  [1803] = {
    [sym_do_group] = STATE(2054),
    [sym_compound_statement] = STATE(2054),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_do] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [sym_comment] = ACTIONS(53),
  },
  [1804] = {
    [sym__concat] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_esac] = ACTIONS(3788),
    [anon_sym_PIPE] = ACTIONS(3790),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [anon_sym_PIPE_AMP] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_EQ_TILDE] = ACTIONS(3788),
    [anon_sym_EQ_EQ] = ACTIONS(3788),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_BANG_EQ] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3788),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3790),
  },
  [1805] = {
    [sym__concat] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_esac] = ACTIONS(3796),
    [anon_sym_PIPE] = ACTIONS(3798),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [anon_sym_PIPE_AMP] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [anon_sym_EQ_TILDE] = ACTIONS(3796),
    [anon_sym_EQ_EQ] = ACTIONS(3796),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_GT] = ACTIONS(3796),
    [anon_sym_BANG_EQ] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3796),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3798),
  },
  [1806] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4761),
    [sym_comment] = ACTIONS(53),
  },
  [1807] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [sym_comment] = ACTIONS(53),
  },
  [1808] = {
    [anon_sym_RBRACE] = ACTIONS(4763),
    [sym_comment] = ACTIONS(53),
  },
  [1809] = {
    [sym_concatenation] = STATE(2059),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2059),
    [anon_sym_RBRACE] = ACTIONS(4765),
    [anon_sym_EQ] = ACTIONS(4767),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4767),
    [anon_sym_COLON_QMARK] = ACTIONS(4767),
    [anon_sym_COLON_DASH] = ACTIONS(4767),
    [anon_sym_PERCENT] = ACTIONS(4767),
    [anon_sym_DASH] = ACTIONS(4767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1810] = {
    [sym__concat] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_esac] = ACTIONS(3852),
    [anon_sym_PIPE] = ACTIONS(3854),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [anon_sym_PIPE_AMP] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [anon_sym_EQ_EQ] = ACTIONS(3852),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3852),
    [anon_sym_GT] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3852),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3854),
  },
  [1811] = {
    [sym_concatenation] = STATE(2060),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2060),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [anon_sym_EQ] = ACTIONS(4771),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4771),
    [anon_sym_COLON_QMARK] = ACTIONS(4771),
    [anon_sym_COLON_DASH] = ACTIONS(4771),
    [anon_sym_PERCENT] = ACTIONS(4771),
    [anon_sym_DASH] = ACTIONS(4771),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1812] = {
    [sym__concat] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_esac] = ACTIONS(3893),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [anon_sym_PIPE_AMP] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_EQ_TILDE] = ACTIONS(3893),
    [anon_sym_EQ_EQ] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3895),
    [anon_sym_LT] = ACTIONS(3893),
    [anon_sym_GT] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3893),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3895),
  },
  [1813] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4775),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1814] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1815] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_EQ_TILDE] = ACTIONS(3915),
    [anon_sym_EQ_EQ] = ACTIONS(3915),
    [anon_sym_EQ] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_GT] = ACTIONS(3915),
    [anon_sym_BANG_EQ] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3915),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [1816] = {
    [sym__concat] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_esac] = ACTIONS(3939),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [anon_sym_PIPE_AMP] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_EQ_TILDE] = ACTIONS(3939),
    [anon_sym_EQ_EQ] = ACTIONS(3939),
    [anon_sym_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_GT] = ACTIONS(3939),
    [anon_sym_BANG_EQ] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3939),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3941),
  },
  [1817] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_PIPE_PIPE] = ACTIONS(3287),
    [anon_sym_EQ_TILDE] = ACTIONS(3289),
    [anon_sym_EQ_EQ] = ACTIONS(3289),
    [anon_sym_EQ] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3287),
    [anon_sym_BANG_EQ] = ACTIONS(3287),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3287),
  },
  [1818] = {
    [sym__concat] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [sym__special_characters] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [anon_sym_LT_LPAREN] = ACTIONS(2876),
    [anon_sym_GT_LPAREN] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2878),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2876),
  },
  [1819] = {
    [sym__concat] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [sym__special_characters] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [anon_sym_LT_LPAREN] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2892),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2890),
  },
  [1820] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4779),
    [sym_comment] = ACTIONS(53),
  },
  [1821] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(4781),
    [sym_comment] = ACTIONS(53),
  },
  [1822] = {
    [anon_sym_RBRACE] = ACTIONS(4781),
    [sym_comment] = ACTIONS(53),
  },
  [1823] = {
    [sym_concatenation] = STATE(2067),
    [sym_string] = STATE(2066),
    [sym_simple_expansion] = STATE(2066),
    [sym_string_expansion] = STATE(2066),
    [sym_expansion] = STATE(2066),
    [sym_command_substitution] = STATE(2066),
    [sym_process_substitution] = STATE(2066),
    [anon_sym_RBRACE] = ACTIONS(4781),
    [sym__special_characters] = ACTIONS(4783),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(4785),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4785),
  },
  [1824] = {
    [sym__concat] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [sym__special_characters] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym_raw_string] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [anon_sym_LT_LPAREN] = ACTIONS(2926),
    [anon_sym_GT_LPAREN] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2928),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2926),
  },
  [1825] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4787),
  },
  [1826] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4789),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1827] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4791),
  },
  [1828] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4781),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1829] = {
    [sym_concatenation] = STATE(2072),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2072),
    [anon_sym_RBRACE] = ACTIONS(4793),
    [anon_sym_EQ] = ACTIONS(4795),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4797),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4795),
    [anon_sym_COLON_QMARK] = ACTIONS(4795),
    [anon_sym_COLON_DASH] = ACTIONS(4795),
    [anon_sym_PERCENT] = ACTIONS(4795),
    [anon_sym_DASH] = ACTIONS(4795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1830] = {
    [sym__concat] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [sym__special_characters] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym_raw_string] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_LT_LPAREN] = ACTIONS(2990),
    [anon_sym_GT_LPAREN] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2992),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2990),
  },
  [1831] = {
    [sym_concatenation] = STATE(2073),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2073),
    [anon_sym_RBRACE] = ACTIONS(4781),
    [anon_sym_EQ] = ACTIONS(4799),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4801),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(4799),
    [anon_sym_COLON_QMARK] = ACTIONS(4799),
    [anon_sym_COLON_DASH] = ACTIONS(4799),
    [anon_sym_PERCENT] = ACTIONS(4799),
    [anon_sym_DASH] = ACTIONS(4799),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1832] = {
    [sym__concat] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [sym__special_characters] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [anon_sym_LT_LPAREN] = ACTIONS(3033),
    [anon_sym_GT_LPAREN] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3033),
  },
  [1833] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4803),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1834] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(4803),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1835] = {
    [sym__concat] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [sym__special_characters] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [sym_raw_string] = ACTIONS(3071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_LT_LPAREN] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3071),
  },
  [1836] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(4805),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1837] = {
    [aux_sym_concatenation_repeat1] = STATE(1839),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1838] = {
    [aux_sym_concatenation_repeat1] = STATE(1839),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1839] = {
    [aux_sym_concatenation_repeat1] = STATE(2076),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [1840] = {
    [aux_sym_concatenation_repeat1] = STATE(1842),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1841] = {
    [aux_sym_concatenation_repeat1] = STATE(1842),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1842] = {
    [aux_sym_concatenation_repeat1] = STATE(2077),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [1843] = {
    [sym__terminated_statement] = STATE(1095),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(1095),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_fi] = ACTIONS(4807),
    [anon_sym_elif] = ACTIONS(4807),
    [anon_sym_else] = ACTIONS(4807),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [1844] = {
    [ts_builtin_sym_end] = ACTIONS(4809),
    [anon_sym_SEMI] = ACTIONS(4811),
    [anon_sym_esac] = ACTIONS(4809),
    [anon_sym_PIPE] = ACTIONS(4811),
    [anon_sym_RPAREN] = ACTIONS(4809),
    [anon_sym_SEMI_SEMI] = ACTIONS(4809),
    [anon_sym_PIPE_AMP] = ACTIONS(4809),
    [anon_sym_AMP_AMP] = ACTIONS(4809),
    [anon_sym_PIPE_PIPE] = ACTIONS(4809),
    [anon_sym_BQUOTE] = ACTIONS(4809),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4809),
    [anon_sym_AMP] = ACTIONS(4811),
  },
  [1845] = {
    [aux_sym_concatenation_repeat1] = STATE(1518),
    [sym__concat] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(4813),
    [anon_sym_RPAREN] = ACTIONS(4813),
    [sym_comment] = ACTIONS(53),
  },
  [1846] = {
    [aux_sym_concatenation_repeat1] = STATE(1518),
    [sym__concat] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_RPAREN] = ACTIONS(4815),
    [sym_comment] = ACTIONS(53),
  },
  [1847] = {
    [anon_sym_PIPE] = ACTIONS(4815),
    [anon_sym_RPAREN] = ACTIONS(4815),
    [sym_comment] = ACTIONS(53),
  },
  [1848] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(4817),
    [anon_sym_PLUS_EQ] = ACTIONS(4817),
    [sym_comment] = ACTIONS(53),
  },
  [1849] = {
    [sym__terminated_statement] = STATE(2079),
    [sym_for_statement] = STATE(50),
    [sym_c_style_for_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_case_statement] = STATE(50),
    [sym_function_definition] = STATE(50),
    [sym_subshell] = STATE(50),
    [sym_pipeline] = STATE(50),
    [sym_list] = STATE(50),
    [sym_negated_command] = STATE(50),
    [sym_test_command] = STATE(50),
    [sym_declaration_command] = STATE(50),
    [sym_unset_command] = STATE(50),
    [sym_command] = STATE(50),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(52),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [1850] = {
    [anon_sym_esac] = ACTIONS(4819),
    [sym__special_characters] = ACTIONS(4821),
    [anon_sym_DQUOTE] = ACTIONS(4821),
    [anon_sym_DOLLAR] = ACTIONS(4823),
    [sym_raw_string] = ACTIONS(4821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4821),
    [anon_sym_BQUOTE] = ACTIONS(4821),
    [anon_sym_LT_LPAREN] = ACTIONS(4821),
    [anon_sym_GT_LPAREN] = ACTIONS(4821),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4823),
  },
  [1851] = {
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4825),
  },
  [1852] = {
    [sym_subshell] = STATE(84),
    [sym_test_command] = STATE(84),
    [sym_command] = STATE(84),
    [sym_command_name] = STATE(1867),
    [sym_variable_assignment] = STATE(1872),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(1872),
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_string_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [aux_sym_command_repeat1] = STATE(1872),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(4257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4259),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4265),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4271),
  },
  [1853] = {
    [sym__expression] = STATE(2081),
    [sym_binary_expression] = STATE(2081),
    [sym_unary_expression] = STATE(2081),
    [sym_parenthesized_expression] = STATE(2081),
    [sym_concatenation] = STATE(2081),
    [sym_string] = STATE(91),
    [sym_simple_expansion] = STATE(91),
    [sym_string_expansion] = STATE(91),
    [sym_expansion] = STATE(91),
    [sym_command_substitution] = STATE(91),
    [sym_process_substitution] = STATE(91),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [sym__special_characters] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [sym_raw_string] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(149),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(153),
    [sym_test_operator] = ACTIONS(155),
  },
  [1854] = {
    [sym__expression] = STATE(2082),
    [sym_binary_expression] = STATE(2082),
    [sym_unary_expression] = STATE(2082),
    [sym_parenthesized_expression] = STATE(2082),
    [sym_concatenation] = STATE(2082),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(159),
    [sym__special_characters] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(177),
    [sym_test_operator] = ACTIONS(179),
  },
  [1855] = {
    [sym_variable_assignment] = STATE(2093),
    [sym_subscript] = STATE(2092),
    [sym_concatenation] = STATE(2093),
    [sym_string] = STATE(2087),
    [sym_simple_expansion] = STATE(2087),
    [sym_string_expansion] = STATE(2087),
    [sym_expansion] = STATE(2087),
    [sym_command_substitution] = STATE(2087),
    [sym_process_substitution] = STATE(2087),
    [aux_sym_declaration_command_repeat1] = STATE(2093),
    [sym_variable_name] = ACTIONS(4827),
    [anon_sym_SEMI] = ACTIONS(185),
    [anon_sym_esac] = ACTIONS(185),
    [anon_sym_PIPE] = ACTIONS(185),
    [anon_sym_SEMI_SEMI] = ACTIONS(183),
    [anon_sym_PIPE_AMP] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [sym__special_characters] = ACTIONS(4829),
    [anon_sym_DQUOTE] = ACTIONS(4831),
    [anon_sym_DOLLAR] = ACTIONS(4833),
    [sym_raw_string] = ACTIONS(4835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4839),
    [anon_sym_BQUOTE] = ACTIONS(4841),
    [anon_sym_LT_LPAREN] = ACTIONS(4843),
    [anon_sym_GT_LPAREN] = ACTIONS(4843),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4845),
    [sym_word] = ACTIONS(4847),
    [anon_sym_LF] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(185),
  },
  [1856] = {
    [sym_concatenation] = STATE(2102),
    [sym_string] = STATE(2097),
    [sym_simple_expansion] = STATE(2097),
    [sym_string_expansion] = STATE(2097),
    [sym_expansion] = STATE(2097),
    [sym_command_substitution] = STATE(2097),
    [sym_process_substitution] = STATE(2097),
    [aux_sym_unset_command_repeat1] = STATE(2102),
    [anon_sym_SEMI] = ACTIONS(209),
    [anon_sym_esac] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_SEMI_SEMI] = ACTIONS(207),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [sym__special_characters] = ACTIONS(4849),
    [anon_sym_DQUOTE] = ACTIONS(4851),
    [anon_sym_DOLLAR] = ACTIONS(4853),
    [sym_raw_string] = ACTIONS(4855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4859),
    [anon_sym_BQUOTE] = ACTIONS(4861),
    [anon_sym_LT_LPAREN] = ACTIONS(4863),
    [anon_sym_GT_LPAREN] = ACTIONS(4863),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4865),
    [sym_word] = ACTIONS(4867),
    [anon_sym_LF] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(209),
  },
  [1857] = {
    [aux_sym_concatenation_repeat1] = STATE(2104),
    [sym__simple_heredoc_body] = ACTIONS(247),
    [sym__heredoc_body_beginning] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(247),
    [sym__concat] = ACTIONS(4869),
    [anon_sym_SEMI] = ACTIONS(251),
    [anon_sym_esac] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [anon_sym_SEMI_SEMI] = ACTIONS(247),
    [anon_sym_PIPE_AMP] = ACTIONS(247),
    [anon_sym_AMP_AMP] = ACTIONS(247),
    [anon_sym_PIPE_PIPE] = ACTIONS(247),
    [anon_sym_EQ_TILDE] = ACTIONS(251),
    [anon_sym_EQ_EQ] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(247),
    [anon_sym_AMP_GT] = ACTIONS(251),
    [anon_sym_AMP_GT_GT] = ACTIONS(247),
    [anon_sym_LT_AMP] = ACTIONS(247),
    [anon_sym_GT_AMP] = ACTIONS(247),
    [anon_sym_LT_LT] = ACTIONS(251),
    [anon_sym_LT_LT_DASH] = ACTIONS(247),
    [anon_sym_LT_LT_LT] = ACTIONS(247),
    [sym__special_characters] = ACTIONS(247),
    [anon_sym_DQUOTE] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(251),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(247),
    [anon_sym_LT_LPAREN] = ACTIONS(247),
    [anon_sym_GT_LPAREN] = ACTIONS(247),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(251),
    [anon_sym_LF] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(251),
  },
  [1858] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(2107),
    [anon_sym_DQUOTE] = ACTIONS(4871),
    [anon_sym_DOLLAR] = ACTIONS(4873),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [1859] = {
    [sym_string] = STATE(2109),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4875),
    [sym_raw_string] = ACTIONS(4877),
    [anon_sym_POUND] = ACTIONS(4875),
    [anon_sym_DASH] = ACTIONS(4875),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4879),
    [anon_sym_STAR] = ACTIONS(4881),
    [anon_sym_AT] = ACTIONS(4881),
    [anon_sym_QMARK] = ACTIONS(4881),
    [anon_sym_0] = ACTIONS(4879),
    [anon_sym__] = ACTIONS(4879),
  },
  [1860] = {
    [aux_sym_concatenation_repeat1] = STATE(2104),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(4869),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_esac] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [1861] = {
    [sym_subscript] = STATE(2114),
    [sym_variable_name] = ACTIONS(4883),
    [anon_sym_BANG] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4887),
    [anon_sym_POUND] = ACTIONS(4885),
    [anon_sym_DASH] = ACTIONS(4887),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4889),
    [anon_sym_STAR] = ACTIONS(4891),
    [anon_sym_AT] = ACTIONS(4891),
    [anon_sym_QMARK] = ACTIONS(4891),
    [anon_sym_0] = ACTIONS(4889),
    [anon_sym__] = ACTIONS(4889),
  },
  [1862] = {
    [sym__terminated_statement] = STATE(2117),
    [sym_for_statement] = STATE(2115),
    [sym_c_style_for_statement] = STATE(2115),
    [sym_while_statement] = STATE(2115),
    [sym_if_statement] = STATE(2115),
    [sym_case_statement] = STATE(2115),
    [sym_function_definition] = STATE(2115),
    [sym_subshell] = STATE(2115),
    [sym_pipeline] = STATE(2115),
    [sym_list] = STATE(2115),
    [sym_negated_command] = STATE(2115),
    [sym_test_command] = STATE(2115),
    [sym_declaration_command] = STATE(2115),
    [sym_unset_command] = STATE(2115),
    [sym_command] = STATE(2115),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2116),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(2117),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1863] = {
    [sym__terminated_statement] = STATE(2120),
    [sym_for_statement] = STATE(2118),
    [sym_c_style_for_statement] = STATE(2118),
    [sym_while_statement] = STATE(2118),
    [sym_if_statement] = STATE(2118),
    [sym_case_statement] = STATE(2118),
    [sym_function_definition] = STATE(2118),
    [sym_subshell] = STATE(2118),
    [sym_pipeline] = STATE(2118),
    [sym_list] = STATE(2118),
    [sym_negated_command] = STATE(2118),
    [sym_test_command] = STATE(2118),
    [sym_declaration_command] = STATE(2118),
    [sym_unset_command] = STATE(2118),
    [sym_command] = STATE(2118),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(2119),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2120),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [1864] = {
    [sym__terminated_statement] = STATE(2123),
    [sym_for_statement] = STATE(2121),
    [sym_c_style_for_statement] = STATE(2121),
    [sym_while_statement] = STATE(2121),
    [sym_if_statement] = STATE(2121),
    [sym_case_statement] = STATE(2121),
    [sym_function_definition] = STATE(2121),
    [sym_subshell] = STATE(2121),
    [sym_pipeline] = STATE(2121),
    [sym_list] = STATE(2121),
    [sym_negated_command] = STATE(2121),
    [sym_test_command] = STATE(2121),
    [sym_declaration_command] = STATE(2121),
    [sym_unset_command] = STATE(2121),
    [sym_command] = STATE(2121),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2122),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(2123),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [1865] = {
    [aux_sym_concatenation_repeat1] = STATE(2104),
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [sym__concat] = ACTIONS(4869),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_esac] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(4893),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [1866] = {
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_esac] = ACTIONS(4897),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(4901),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [1867] = {
    [sym_file_redirect] = STATE(2135),
    [sym_heredoc_redirect] = STATE(2135),
    [sym_heredoc_body] = STATE(185),
    [sym_herestring_redirect] = STATE(2135),
    [sym_concatenation] = STATE(2136),
    [sym_string] = STATE(2134),
    [sym_simple_expansion] = STATE(2134),
    [sym_string_expansion] = STATE(2134),
    [sym_expansion] = STATE(2134),
    [sym_command_substitution] = STATE(2134),
    [sym_process_substitution] = STATE(2134),
    [aux_sym_while_statement_repeat1] = STATE(2135),
    [aux_sym_command_repeat2] = STATE(2136),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(4909),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_esac] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(327),
    [anon_sym_PIPE_AMP] = ACTIONS(327),
    [anon_sym_AMP_AMP] = ACTIONS(327),
    [anon_sym_PIPE_PIPE] = ACTIONS(327),
    [anon_sym_EQ_TILDE] = ACTIONS(4911),
    [anon_sym_EQ_EQ] = ACTIONS(4911),
    [anon_sym_LT] = ACTIONS(4913),
    [anon_sym_GT] = ACTIONS(4913),
    [anon_sym_GT_GT] = ACTIONS(4915),
    [anon_sym_AMP_GT] = ACTIONS(4913),
    [anon_sym_AMP_GT_GT] = ACTIONS(4915),
    [anon_sym_LT_AMP] = ACTIONS(4915),
    [anon_sym_GT_AMP] = ACTIONS(4915),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(4917),
    [sym__special_characters] = ACTIONS(4919),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4923),
    [anon_sym_LF] = ACTIONS(327),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1868] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_esac] = ACTIONS(4819),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(4901),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [1869] = {
    [anon_sym_EQ] = ACTIONS(4817),
    [anon_sym_PLUS_EQ] = ACTIONS(4817),
    [sym_comment] = ACTIONS(53),
  },
  [1870] = {
    [sym__simple_heredoc_body] = ACTIONS(275),
    [sym__heredoc_body_beginning] = ACTIONS(275),
    [sym_file_descriptor] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_esac] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_SEMI_SEMI] = ACTIONS(275),
    [anon_sym_PIPE_AMP] = ACTIONS(275),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_EQ_TILDE] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(275),
    [anon_sym_AMP_GT] = ACTIONS(277),
    [anon_sym_AMP_GT_GT] = ACTIONS(275),
    [anon_sym_LT_AMP] = ACTIONS(275),
    [anon_sym_GT_AMP] = ACTIONS(275),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_LT_LT_DASH] = ACTIONS(275),
    [anon_sym_LT_LT_LT] = ACTIONS(275),
    [sym__special_characters] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_raw_string] = ACTIONS(275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(275),
    [anon_sym_GT_LPAREN] = ACTIONS(275),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(275),
    [anon_sym_AMP] = ACTIONS(277),
  },
  [1871] = {
    [sym__terminated_statement] = STATE(2140),
    [sym_for_statement] = STATE(2138),
    [sym_c_style_for_statement] = STATE(2138),
    [sym_while_statement] = STATE(2138),
    [sym_if_statement] = STATE(2138),
    [sym_case_statement] = STATE(2138),
    [sym_function_definition] = STATE(2138),
    [sym_subshell] = STATE(2138),
    [sym_pipeline] = STATE(2138),
    [sym_list] = STATE(2138),
    [sym_negated_command] = STATE(2138),
    [sym_test_command] = STATE(2138),
    [sym_declaration_command] = STATE(2138),
    [sym_unset_command] = STATE(2138),
    [sym_command] = STATE(2138),
    [sym_command_name] = STATE(1867),
    [sym_variable_assignment] = STATE(2139),
    [sym_subscript] = STATE(1869),
    [sym_file_redirect] = STATE(1872),
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_string_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [aux_sym__statements_repeat1] = STATE(2140),
    [aux_sym_command_repeat1] = STATE(1872),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4245),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(4819),
    [anon_sym_SEMI_SEMI] = ACTIONS(4925),
    [anon_sym_function] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(4257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4259),
    [anon_sym_declare] = ACTIONS(4261),
    [anon_sym_typeset] = ACTIONS(4261),
    [anon_sym_export] = ACTIONS(4261),
    [anon_sym_readonly] = ACTIONS(4261),
    [anon_sym_local] = ACTIONS(4261),
    [anon_sym_unset] = ACTIONS(4263),
    [anon_sym_unsetenv] = ACTIONS(4263),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4265),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4281),
  },
  [1872] = {
    [sym_command_name] = STATE(2141),
    [sym_variable_assignment] = STATE(192),
    [sym_subscript] = STATE(85),
    [sym_file_redirect] = STATE(192),
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_string_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [aux_sym_command_repeat1] = STATE(192),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4927),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4271),
  },
  [1873] = {
    [sym__terminated_statement] = STATE(2142),
    [sym_for_statement] = STATE(2138),
    [sym_c_style_for_statement] = STATE(2138),
    [sym_while_statement] = STATE(2138),
    [sym_if_statement] = STATE(2138),
    [sym_case_statement] = STATE(2138),
    [sym_function_definition] = STATE(2138),
    [sym_subshell] = STATE(2138),
    [sym_pipeline] = STATE(2138),
    [sym_list] = STATE(2138),
    [sym_negated_command] = STATE(2138),
    [sym_test_command] = STATE(2138),
    [sym_declaration_command] = STATE(2138),
    [sym_unset_command] = STATE(2138),
    [sym_command] = STATE(2138),
    [sym_command_name] = STATE(1867),
    [sym_variable_assignment] = STATE(2139),
    [sym_subscript] = STATE(1869),
    [sym_file_redirect] = STATE(1872),
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_string_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [aux_sym__statements_repeat1] = STATE(2142),
    [aux_sym_command_repeat1] = STATE(1872),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4245),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(4819),
    [anon_sym_SEMI_SEMI] = ACTIONS(4925),
    [anon_sym_function] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(4257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4259),
    [anon_sym_declare] = ACTIONS(4261),
    [anon_sym_typeset] = ACTIONS(4261),
    [anon_sym_export] = ACTIONS(4261),
    [anon_sym_readonly] = ACTIONS(4261),
    [anon_sym_local] = ACTIONS(4261),
    [anon_sym_unset] = ACTIONS(4263),
    [anon_sym_unsetenv] = ACTIONS(4263),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4265),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4281),
  },
  [1874] = {
    [aux_sym_case_item_repeat1] = STATE(1874),
    [anon_sym_PIPE] = ACTIONS(4929),
    [anon_sym_RPAREN] = ACTIONS(4815),
    [sym_comment] = ACTIONS(53),
  },
  [1875] = {
    [aux_sym_concatenation_repeat1] = STATE(1875),
    [sym__concat] = ACTIONS(2636),
    [anon_sym_PIPE] = ACTIONS(1724),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
  },
  [1876] = {
    [anon_sym_esac] = ACTIONS(4932),
    [sym__special_characters] = ACTIONS(4934),
    [anon_sym_DQUOTE] = ACTIONS(4934),
    [anon_sym_DOLLAR] = ACTIONS(4936),
    [sym_raw_string] = ACTIONS(4934),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4934),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4934),
    [anon_sym_BQUOTE] = ACTIONS(4934),
    [anon_sym_LT_LPAREN] = ACTIONS(4934),
    [anon_sym_GT_LPAREN] = ACTIONS(4934),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4936),
  },
  [1877] = {
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_esac] = ACTIONS(4938),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(4940),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [1878] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_esac] = ACTIONS(4932),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(4940),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [1879] = {
    [sym__terminated_statement] = STATE(2140),
    [sym_for_statement] = STATE(2145),
    [sym_c_style_for_statement] = STATE(2145),
    [sym_while_statement] = STATE(2145),
    [sym_if_statement] = STATE(2145),
    [sym_case_statement] = STATE(2145),
    [sym_function_definition] = STATE(2145),
    [sym_subshell] = STATE(2145),
    [sym_pipeline] = STATE(2145),
    [sym_list] = STATE(2145),
    [sym_negated_command] = STATE(2145),
    [sym_test_command] = STATE(2145),
    [sym_declaration_command] = STATE(2145),
    [sym_unset_command] = STATE(2145),
    [sym_command] = STATE(2145),
    [sym_command_name] = STATE(1867),
    [sym_variable_assignment] = STATE(2146),
    [sym_subscript] = STATE(1869),
    [sym_file_redirect] = STATE(1872),
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_string_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [aux_sym__statements_repeat1] = STATE(2140),
    [aux_sym_command_repeat1] = STATE(1872),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4245),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(4932),
    [anon_sym_SEMI_SEMI] = ACTIONS(4942),
    [anon_sym_function] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(4257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4259),
    [anon_sym_declare] = ACTIONS(4261),
    [anon_sym_typeset] = ACTIONS(4261),
    [anon_sym_export] = ACTIONS(4261),
    [anon_sym_readonly] = ACTIONS(4261),
    [anon_sym_local] = ACTIONS(4261),
    [anon_sym_unset] = ACTIONS(4263),
    [anon_sym_unsetenv] = ACTIONS(4263),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4265),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4281),
  },
  [1880] = {
    [sym__terminated_statement] = STATE(2147),
    [sym_for_statement] = STATE(2145),
    [sym_c_style_for_statement] = STATE(2145),
    [sym_while_statement] = STATE(2145),
    [sym_if_statement] = STATE(2145),
    [sym_case_statement] = STATE(2145),
    [sym_function_definition] = STATE(2145),
    [sym_subshell] = STATE(2145),
    [sym_pipeline] = STATE(2145),
    [sym_list] = STATE(2145),
    [sym_negated_command] = STATE(2145),
    [sym_test_command] = STATE(2145),
    [sym_declaration_command] = STATE(2145),
    [sym_unset_command] = STATE(2145),
    [sym_command] = STATE(2145),
    [sym_command_name] = STATE(1867),
    [sym_variable_assignment] = STATE(2146),
    [sym_subscript] = STATE(1869),
    [sym_file_redirect] = STATE(1872),
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_string_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [aux_sym__statements_repeat1] = STATE(2147),
    [aux_sym_command_repeat1] = STATE(1872),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4245),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(4932),
    [anon_sym_SEMI_SEMI] = ACTIONS(4942),
    [anon_sym_function] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(4257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4259),
    [anon_sym_declare] = ACTIONS(4261),
    [anon_sym_typeset] = ACTIONS(4261),
    [anon_sym_export] = ACTIONS(4261),
    [anon_sym_readonly] = ACTIONS(4261),
    [anon_sym_local] = ACTIONS(4261),
    [anon_sym_unset] = ACTIONS(4263),
    [anon_sym_unsetenv] = ACTIONS(4263),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4265),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4281),
  },
  [1881] = {
    [ts_builtin_sym_end] = ACTIONS(4944),
    [anon_sym_SEMI] = ACTIONS(4946),
    [anon_sym_esac] = ACTIONS(4944),
    [anon_sym_PIPE] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(4944),
    [anon_sym_SEMI_SEMI] = ACTIONS(4944),
    [anon_sym_PIPE_AMP] = ACTIONS(4944),
    [anon_sym_AMP_AMP] = ACTIONS(4944),
    [anon_sym_PIPE_PIPE] = ACTIONS(4944),
    [anon_sym_BQUOTE] = ACTIONS(4944),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4944),
    [anon_sym_AMP] = ACTIONS(4946),
  },
  [1882] = {
    [aux_sym_case_item_repeat1] = STATE(2149),
    [aux_sym_concatenation_repeat1] = STATE(1518),
    [sym__concat] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(4948),
    [sym_comment] = ACTIONS(53),
  },
  [1883] = {
    [aux_sym_case_item_repeat1] = STATE(2151),
    [aux_sym_concatenation_repeat1] = STATE(1518),
    [sym__concat] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(4950),
    [sym_comment] = ACTIONS(53),
  },
  [1884] = {
    [aux_sym_case_item_repeat1] = STATE(2151),
    [anon_sym_PIPE] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(4950),
    [sym_comment] = ACTIONS(53),
  },
  [1885] = {
    [anon_sym_esac] = ACTIONS(4952),
    [sym_comment] = ACTIONS(53),
  },
  [1886] = {
    [ts_builtin_sym_end] = ACTIONS(4954),
    [anon_sym_SEMI] = ACTIONS(4956),
    [anon_sym_esac] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4956),
    [anon_sym_RPAREN] = ACTIONS(4954),
    [anon_sym_SEMI_SEMI] = ACTIONS(4954),
    [anon_sym_PIPE_AMP] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_BQUOTE] = ACTIONS(4954),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4956),
  },
  [1887] = {
    [anon_sym_esac] = ACTIONS(4958),
    [sym_comment] = ACTIONS(53),
  },
  [1888] = {
    [sym__concat] = ACTIONS(4568),
    [anon_sym_in] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
  },
  [1889] = {
    [sym__concat] = ACTIONS(4572),
    [anon_sym_in] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4572),
  },
  [1890] = {
    [sym__concat] = ACTIONS(4576),
    [anon_sym_in] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4576),
  },
  [1891] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4960),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1892] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4962),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1893] = {
    [sym__concat] = ACTIONS(4608),
    [anon_sym_in] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4608),
  },
  [1894] = {
    [aux_sym_concatenation_repeat1] = STATE(1894),
    [sym__concat] = ACTIONS(2736),
    [ts_builtin_sym_end] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1895] = {
    [aux_sym_concatenation_repeat1] = STATE(1897),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1896] = {
    [aux_sym_concatenation_repeat1] = STATE(1897),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1897] = {
    [aux_sym_concatenation_repeat1] = STATE(2156),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [1898] = {
    [aux_sym_concatenation_repeat1] = STATE(1900),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1899] = {
    [aux_sym_concatenation_repeat1] = STATE(1900),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1900] = {
    [aux_sym_concatenation_repeat1] = STATE(2157),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [1901] = {
    [sym__concat] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_RBRACK] = ACTIONS(4568),
    [anon_sym_EQ_TILDE] = ACTIONS(4568),
    [anon_sym_EQ_EQ] = ACTIONS(4568),
    [anon_sym_EQ] = ACTIONS(4570),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_BANG_EQ] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4568),
  },
  [1902] = {
    [sym__concat] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [anon_sym_RBRACK] = ACTIONS(4572),
    [anon_sym_EQ_TILDE] = ACTIONS(4572),
    [anon_sym_EQ_EQ] = ACTIONS(4572),
    [anon_sym_EQ] = ACTIONS(4574),
    [anon_sym_LT] = ACTIONS(4572),
    [anon_sym_GT] = ACTIONS(4572),
    [anon_sym_BANG_EQ] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4572),
  },
  [1903] = {
    [sym__concat] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [anon_sym_RBRACK] = ACTIONS(4576),
    [anon_sym_EQ_TILDE] = ACTIONS(4576),
    [anon_sym_EQ_EQ] = ACTIONS(4576),
    [anon_sym_EQ] = ACTIONS(4578),
    [anon_sym_LT] = ACTIONS(4576),
    [anon_sym_GT] = ACTIONS(4576),
    [anon_sym_BANG_EQ] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4576),
  },
  [1904] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4964),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1905] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4966),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1906] = {
    [sym__concat] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [anon_sym_RBRACK] = ACTIONS(4608),
    [anon_sym_EQ_TILDE] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4608),
    [anon_sym_EQ] = ACTIONS(4610),
    [anon_sym_LT] = ACTIONS(4608),
    [anon_sym_GT] = ACTIONS(4608),
    [anon_sym_BANG_EQ] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4608),
  },
  [1907] = {
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1724),
    [ts_builtin_sym_end] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1724),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1908] = {
    [aux_sym_concatenation_repeat1] = STATE(1908),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(4968),
    [ts_builtin_sym_end] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [1909] = {
    [sym_file_descriptor] = ACTIONS(1731),
    [sym__concat] = ACTIONS(1731),
    [ts_builtin_sym_end] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_esac] = ACTIONS(1731),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_RPAREN] = ACTIONS(1731),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [anon_sym_PIPE_AMP] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1731),
    [anon_sym_AMP_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT_GT] = ACTIONS(1731),
    [anon_sym_LT_AMP] = ACTIONS(1731),
    [anon_sym_GT_AMP] = ACTIONS(1731),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_LT_LT_DASH] = ACTIONS(1731),
    [anon_sym_LT_LT_LT] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [1910] = {
    [anon_sym_DQUOTE] = ACTIONS(4971),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [1911] = {
    [sym_concatenation] = STATE(2164),
    [sym_string] = STATE(2163),
    [sym_simple_expansion] = STATE(2163),
    [sym_string_expansion] = STATE(2163),
    [sym_expansion] = STATE(2163),
    [sym_command_substitution] = STATE(2163),
    [sym_process_substitution] = STATE(2163),
    [anon_sym_RBRACE] = ACTIONS(4973),
    [sym__special_characters] = ACTIONS(4975),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(4977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4977),
  },
  [1912] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(4979),
    [sym_comment] = ACTIONS(53),
  },
  [1913] = {
    [sym_concatenation] = STATE(2168),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2168),
    [anon_sym_RBRACE] = ACTIONS(4981),
    [anon_sym_EQ] = ACTIONS(4983),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4987),
    [anon_sym_COLON] = ACTIONS(4983),
    [anon_sym_COLON_QMARK] = ACTIONS(4983),
    [anon_sym_COLON_DASH] = ACTIONS(4983),
    [anon_sym_PERCENT] = ACTIONS(4983),
    [anon_sym_DASH] = ACTIONS(4983),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1914] = {
    [sym_concatenation] = STATE(2170),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2170),
    [anon_sym_RBRACE] = ACTIONS(4973),
    [anon_sym_EQ] = ACTIONS(4989),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(4991),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(4993),
    [anon_sym_COLON] = ACTIONS(4989),
    [anon_sym_COLON_QMARK] = ACTIONS(4989),
    [anon_sym_COLON_DASH] = ACTIONS(4989),
    [anon_sym_PERCENT] = ACTIONS(4989),
    [anon_sym_DASH] = ACTIONS(4989),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1915] = {
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [ts_builtin_sym_end] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_esac] = ACTIONS(1832),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [anon_sym_LT_LT] = ACTIONS(1834),
    [anon_sym_LT_LT_DASH] = ACTIONS(1832),
    [anon_sym_LT_LT_LT] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [1916] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4995),
  },
  [1917] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4997),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1918] = {
    [sym_file_descriptor] = ACTIONS(1876),
    [sym__concat] = ACTIONS(1876),
    [ts_builtin_sym_end] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1876),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_RPAREN] = ACTIONS(1876),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [anon_sym_PIPE_AMP] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_GT_GT] = ACTIONS(1876),
    [anon_sym_AMP_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT_GT] = ACTIONS(1876),
    [anon_sym_LT_AMP] = ACTIONS(1876),
    [anon_sym_GT_AMP] = ACTIONS(1876),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [anon_sym_LT_LT_DASH] = ACTIONS(1876),
    [anon_sym_LT_LT_LT] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [1919] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(4999),
  },
  [1920] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(4973),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1921] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(5001),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1922] = {
    [sym_file_descriptor] = ACTIONS(1884),
    [sym__concat] = ACTIONS(1884),
    [ts_builtin_sym_end] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_esac] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_GT] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT] = ACTIONS(1886),
    [anon_sym_AMP_GT_GT] = ACTIONS(1884),
    [anon_sym_LT_AMP] = ACTIONS(1884),
    [anon_sym_GT_AMP] = ACTIONS(1884),
    [anon_sym_LT_LT] = ACTIONS(1886),
    [anon_sym_LT_LT_DASH] = ACTIONS(1884),
    [anon_sym_LT_LT_LT] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [1923] = {
    [anon_sym_SEMI] = ACTIONS(5003),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5001),
    [anon_sym_SEMI_SEMI] = ACTIONS(5005),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5003),
  },
  [1924] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5003),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5001),
    [anon_sym_SEMI_SEMI] = ACTIONS(5005),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5003),
  },
  [1925] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(5001),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1926] = {
    [anon_sym_SEMI] = ACTIONS(5007),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5009),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(5001),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5009),
    [anon_sym_AMP] = ACTIONS(5007),
  },
  [1927] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5007),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5009),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(5001),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5009),
    [anon_sym_AMP] = ACTIONS(5007),
  },
  [1928] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(5011),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1929] = {
    [sym_file_descriptor] = ACTIONS(1916),
    [sym__concat] = ACTIONS(1916),
    [ts_builtin_sym_end] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_esac] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_RPAREN] = ACTIONS(1916),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1916),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT_GT] = ACTIONS(1916),
    [anon_sym_LT_AMP] = ACTIONS(1916),
    [anon_sym_GT_AMP] = ACTIONS(1916),
    [anon_sym_LT_LT] = ACTIONS(1918),
    [anon_sym_LT_LT_DASH] = ACTIONS(1916),
    [anon_sym_LT_LT_LT] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [1930] = {
    [anon_sym_SEMI] = ACTIONS(5013),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5011),
    [anon_sym_SEMI_SEMI] = ACTIONS(5015),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5015),
    [anon_sym_AMP] = ACTIONS(5013),
  },
  [1931] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5013),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5011),
    [anon_sym_SEMI_SEMI] = ACTIONS(5015),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5015),
    [anon_sym_AMP] = ACTIONS(5013),
  },
  [1932] = {
    [sym__concat] = ACTIONS(4568),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4568),
    [anon_sym_EQ_TILDE] = ACTIONS(4568),
    [anon_sym_EQ_EQ] = ACTIONS(4568),
    [anon_sym_EQ] = ACTIONS(4570),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_BANG_EQ] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4568),
  },
  [1933] = {
    [sym__concat] = ACTIONS(4572),
    [anon_sym_PIPE] = ACTIONS(4574),
    [anon_sym_RPAREN] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4572),
    [anon_sym_EQ_TILDE] = ACTIONS(4572),
    [anon_sym_EQ_EQ] = ACTIONS(4572),
    [anon_sym_EQ] = ACTIONS(4574),
    [anon_sym_LT] = ACTIONS(4572),
    [anon_sym_GT] = ACTIONS(4572),
    [anon_sym_BANG_EQ] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4572),
  },
  [1934] = {
    [sym__concat] = ACTIONS(4576),
    [anon_sym_PIPE] = ACTIONS(4578),
    [anon_sym_RPAREN] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4576),
    [anon_sym_EQ_TILDE] = ACTIONS(4576),
    [anon_sym_EQ_EQ] = ACTIONS(4576),
    [anon_sym_EQ] = ACTIONS(4578),
    [anon_sym_LT] = ACTIONS(4576),
    [anon_sym_GT] = ACTIONS(4576),
    [anon_sym_BANG_EQ] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4576),
  },
  [1935] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5017),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1936] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5019),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1937] = {
    [sym__concat] = ACTIONS(4608),
    [anon_sym_PIPE] = ACTIONS(4610),
    [anon_sym_RPAREN] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4608),
    [anon_sym_EQ_TILDE] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4608),
    [anon_sym_EQ] = ACTIONS(4610),
    [anon_sym_LT] = ACTIONS(4608),
    [anon_sym_GT] = ACTIONS(4608),
    [anon_sym_BANG_EQ] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4608),
  },
  [1938] = {
    [sym__concat] = ACTIONS(4568),
    [sym_variable_name] = ACTIONS(4568),
    [ts_builtin_sym_end] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_LT_LPAREN] = ACTIONS(4568),
    [anon_sym_GT_LPAREN] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4570),
    [sym_word] = ACTIONS(4570),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4570),
  },
  [1939] = {
    [sym__concat] = ACTIONS(4572),
    [sym_variable_name] = ACTIONS(4572),
    [ts_builtin_sym_end] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_PIPE] = ACTIONS(4574),
    [anon_sym_RPAREN] = ACTIONS(4572),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [anon_sym_PIPE_AMP] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [sym__special_characters] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4574),
    [sym_word] = ACTIONS(4574),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4574),
  },
  [1940] = {
    [sym__concat] = ACTIONS(4576),
    [sym_variable_name] = ACTIONS(4576),
    [ts_builtin_sym_end] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(4578),
    [anon_sym_RPAREN] = ACTIONS(4576),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [anon_sym_PIPE_AMP] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [sym__special_characters] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_LT_LPAREN] = ACTIONS(4576),
    [anon_sym_GT_LPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4578),
    [sym_word] = ACTIONS(4578),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4578),
  },
  [1941] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5021),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1942] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5023),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1943] = {
    [sym__concat] = ACTIONS(4608),
    [sym_variable_name] = ACTIONS(4608),
    [ts_builtin_sym_end] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4610),
    [anon_sym_RPAREN] = ACTIONS(4608),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [anon_sym_PIPE_AMP] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [sym__special_characters] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_LT_LPAREN] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4610),
    [sym_word] = ACTIONS(4610),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4610),
  },
  [1944] = {
    [sym__concat] = ACTIONS(4568),
    [ts_builtin_sym_end] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_LT_LPAREN] = ACTIONS(4568),
    [anon_sym_GT_LPAREN] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4570),
    [sym_word] = ACTIONS(4570),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4570),
  },
  [1945] = {
    [sym__concat] = ACTIONS(4572),
    [ts_builtin_sym_end] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_PIPE] = ACTIONS(4574),
    [anon_sym_RPAREN] = ACTIONS(4572),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [anon_sym_PIPE_AMP] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [sym__special_characters] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4574),
    [sym_word] = ACTIONS(4574),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4574),
  },
  [1946] = {
    [sym__concat] = ACTIONS(4576),
    [ts_builtin_sym_end] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(4578),
    [anon_sym_RPAREN] = ACTIONS(4576),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [anon_sym_PIPE_AMP] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [sym__special_characters] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_LT_LPAREN] = ACTIONS(4576),
    [anon_sym_GT_LPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4578),
    [sym_word] = ACTIONS(4578),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4578),
  },
  [1947] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5025),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1948] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5027),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1949] = {
    [sym__concat] = ACTIONS(4608),
    [ts_builtin_sym_end] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4610),
    [anon_sym_RPAREN] = ACTIONS(4608),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [anon_sym_PIPE_AMP] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [sym__special_characters] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_LT_LPAREN] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4610),
    [sym_word] = ACTIONS(4610),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4610),
  },
  [1950] = {
    [sym_file_descriptor] = ACTIONS(4568),
    [sym__concat] = ACTIONS(4568),
    [sym_variable_name] = ACTIONS(4568),
    [anon_sym_LT] = ACTIONS(4570),
    [anon_sym_GT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_AMP_GT] = ACTIONS(4570),
    [anon_sym_AMP_GT_GT] = ACTIONS(4568),
    [anon_sym_LT_AMP] = ACTIONS(4568),
    [anon_sym_GT_AMP] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_LT_LPAREN] = ACTIONS(4568),
    [anon_sym_GT_LPAREN] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4568),
  },
  [1951] = {
    [sym_file_descriptor] = ACTIONS(4572),
    [sym__concat] = ACTIONS(4572),
    [sym_variable_name] = ACTIONS(4572),
    [anon_sym_LT] = ACTIONS(4574),
    [anon_sym_GT] = ACTIONS(4574),
    [anon_sym_GT_GT] = ACTIONS(4572),
    [anon_sym_AMP_GT] = ACTIONS(4574),
    [anon_sym_AMP_GT_GT] = ACTIONS(4572),
    [anon_sym_LT_AMP] = ACTIONS(4572),
    [anon_sym_GT_AMP] = ACTIONS(4572),
    [sym__special_characters] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4572),
  },
  [1952] = {
    [sym_file_descriptor] = ACTIONS(4576),
    [sym__concat] = ACTIONS(4576),
    [sym_variable_name] = ACTIONS(4576),
    [anon_sym_LT] = ACTIONS(4578),
    [anon_sym_GT] = ACTIONS(4578),
    [anon_sym_GT_GT] = ACTIONS(4576),
    [anon_sym_AMP_GT] = ACTIONS(4578),
    [anon_sym_AMP_GT_GT] = ACTIONS(4576),
    [anon_sym_LT_AMP] = ACTIONS(4576),
    [anon_sym_GT_AMP] = ACTIONS(4576),
    [sym__special_characters] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_LT_LPAREN] = ACTIONS(4576),
    [anon_sym_GT_LPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4576),
  },
  [1953] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5029),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1954] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5031),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1955] = {
    [sym_file_descriptor] = ACTIONS(4608),
    [sym__concat] = ACTIONS(4608),
    [sym_variable_name] = ACTIONS(4608),
    [anon_sym_LT] = ACTIONS(4610),
    [anon_sym_GT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_AMP_GT] = ACTIONS(4610),
    [anon_sym_AMP_GT_GT] = ACTIONS(4608),
    [anon_sym_LT_AMP] = ACTIONS(4608),
    [anon_sym_GT_AMP] = ACTIONS(4608),
    [sym__special_characters] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_LT_LPAREN] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4608),
  },
  [1956] = {
    [sym__concat] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4570),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym__string_content] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4570),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4570),
    [anon_sym_BQUOTE] = ACTIONS(4570),
    [sym_comment] = ACTIONS(265),
  },
  [1957] = {
    [sym__concat] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4574),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym__string_content] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4574),
    [anon_sym_BQUOTE] = ACTIONS(4574),
    [sym_comment] = ACTIONS(265),
  },
  [1958] = {
    [sym__concat] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4578),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym__string_content] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4578),
    [anon_sym_BQUOTE] = ACTIONS(4578),
    [sym_comment] = ACTIONS(265),
  },
  [1959] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5033),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1960] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5035),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1961] = {
    [sym__concat] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4610),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym__string_content] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4610),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4610),
    [anon_sym_BQUOTE] = ACTIONS(4610),
    [sym_comment] = ACTIONS(265),
  },
  [1962] = {
    [anon_sym_RBRACE] = ACTIONS(3975),
    [anon_sym_EQ] = ACTIONS(5037),
    [sym__special_characters] = ACTIONS(5037),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(5037),
    [sym_raw_string] = ACTIONS(3975),
    [anon_sym_POUND] = ACTIONS(3975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3975),
    [anon_sym_COLON] = ACTIONS(5037),
    [anon_sym_COLON_QMARK] = ACTIONS(5037),
    [anon_sym_COLON_DASH] = ACTIONS(5037),
    [anon_sym_PERCENT] = ACTIONS(5037),
    [anon_sym_DASH] = ACTIONS(5037),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3975),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_LT_LPAREN] = ACTIONS(3975),
    [anon_sym_GT_LPAREN] = ACTIONS(3975),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(5037),
  },
  [1963] = {
    [anon_sym_RBRACE] = ACTIONS(3977),
    [anon_sym_EQ] = ACTIONS(5039),
    [sym__special_characters] = ACTIONS(5039),
    [anon_sym_DQUOTE] = ACTIONS(3977),
    [anon_sym_DOLLAR] = ACTIONS(5039),
    [sym_raw_string] = ACTIONS(3977),
    [anon_sym_POUND] = ACTIONS(3977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3977),
    [anon_sym_COLON] = ACTIONS(5039),
    [anon_sym_COLON_QMARK] = ACTIONS(5039),
    [anon_sym_COLON_DASH] = ACTIONS(5039),
    [anon_sym_PERCENT] = ACTIONS(5039),
    [anon_sym_DASH] = ACTIONS(5039),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3977),
    [anon_sym_BQUOTE] = ACTIONS(3977),
    [anon_sym_LT_LPAREN] = ACTIONS(3977),
    [anon_sym_GT_LPAREN] = ACTIONS(3977),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(5039),
  },
  [1964] = {
    [sym__concat] = ACTIONS(2876),
    [anon_sym_RBRACE] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
  },
  [1965] = {
    [sym__concat] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
  },
  [1966] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5041),
    [sym_comment] = ACTIONS(53),
  },
  [1967] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5043),
    [sym_comment] = ACTIONS(53),
  },
  [1968] = {
    [anon_sym_RBRACE] = ACTIONS(5043),
    [sym_comment] = ACTIONS(53),
  },
  [1969] = {
    [sym_concatenation] = STATE(2193),
    [sym_string] = STATE(2192),
    [sym_simple_expansion] = STATE(2192),
    [sym_string_expansion] = STATE(2192),
    [sym_expansion] = STATE(2192),
    [sym_command_substitution] = STATE(2192),
    [sym_process_substitution] = STATE(2192),
    [anon_sym_RBRACE] = ACTIONS(5043),
    [sym__special_characters] = ACTIONS(5045),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(5047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5047),
  },
  [1970] = {
    [sym__concat] = ACTIONS(2926),
    [anon_sym_RBRACE] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
  },
  [1971] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(5049),
  },
  [1972] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5051),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1973] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(5053),
  },
  [1974] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5043),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1975] = {
    [sym_concatenation] = STATE(2198),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2198),
    [anon_sym_RBRACE] = ACTIONS(5055),
    [anon_sym_EQ] = ACTIONS(5057),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5057),
    [anon_sym_COLON_QMARK] = ACTIONS(5057),
    [anon_sym_COLON_DASH] = ACTIONS(5057),
    [anon_sym_PERCENT] = ACTIONS(5057),
    [anon_sym_DASH] = ACTIONS(5057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1976] = {
    [sym__concat] = ACTIONS(2990),
    [anon_sym_RBRACE] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
  },
  [1977] = {
    [sym_concatenation] = STATE(2199),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2199),
    [anon_sym_RBRACE] = ACTIONS(5043),
    [anon_sym_EQ] = ACTIONS(5061),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5061),
    [anon_sym_COLON_QMARK] = ACTIONS(5061),
    [anon_sym_COLON_DASH] = ACTIONS(5061),
    [anon_sym_PERCENT] = ACTIONS(5061),
    [anon_sym_DASH] = ACTIONS(5061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1978] = {
    [sym__concat] = ACTIONS(3033),
    [anon_sym_RBRACE] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
  },
  [1979] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1980] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(5065),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1981] = {
    [sym__concat] = ACTIONS(3071),
    [anon_sym_RBRACE] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
  },
  [1982] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(5067),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [1983] = {
    [sym__simple_heredoc_body] = ACTIONS(5069),
    [sym__heredoc_body_beginning] = ACTIONS(5069),
    [sym_file_descriptor] = ACTIONS(5069),
    [sym__concat] = ACTIONS(5069),
    [ts_builtin_sym_end] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_PIPE] = ACTIONS(5071),
    [anon_sym_RPAREN] = ACTIONS(5069),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [anon_sym_PIPE_AMP] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [anon_sym_EQ_TILDE] = ACTIONS(5071),
    [anon_sym_EQ_EQ] = ACTIONS(5071),
    [anon_sym_LT] = ACTIONS(5071),
    [anon_sym_GT] = ACTIONS(5071),
    [anon_sym_GT_GT] = ACTIONS(5069),
    [anon_sym_AMP_GT] = ACTIONS(5071),
    [anon_sym_AMP_GT_GT] = ACTIONS(5069),
    [anon_sym_LT_AMP] = ACTIONS(5069),
    [anon_sym_GT_AMP] = ACTIONS(5069),
    [anon_sym_LT_LT] = ACTIONS(5071),
    [anon_sym_LT_LT_DASH] = ACTIONS(5069),
    [anon_sym_LT_LT_LT] = ACTIONS(5069),
    [sym__special_characters] = ACTIONS(5069),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [anon_sym_LT_LPAREN] = ACTIONS(5069),
    [anon_sym_GT_LPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5071),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5071),
  },
  [1984] = {
    [sym__simple_heredoc_body] = ACTIONS(5073),
    [sym__heredoc_body_beginning] = ACTIONS(5073),
    [sym_file_descriptor] = ACTIONS(5073),
    [sym__concat] = ACTIONS(5073),
    [ts_builtin_sym_end] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_PIPE] = ACTIONS(5075),
    [anon_sym_RPAREN] = ACTIONS(5073),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [anon_sym_PIPE_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [anon_sym_EQ_TILDE] = ACTIONS(5075),
    [anon_sym_EQ_EQ] = ACTIONS(5075),
    [anon_sym_LT] = ACTIONS(5075),
    [anon_sym_GT] = ACTIONS(5075),
    [anon_sym_GT_GT] = ACTIONS(5073),
    [anon_sym_AMP_GT] = ACTIONS(5075),
    [anon_sym_AMP_GT_GT] = ACTIONS(5073),
    [anon_sym_LT_AMP] = ACTIONS(5073),
    [anon_sym_GT_AMP] = ACTIONS(5073),
    [anon_sym_LT_LT] = ACTIONS(5075),
    [anon_sym_LT_LT_DASH] = ACTIONS(5073),
    [anon_sym_LT_LT_LT] = ACTIONS(5073),
    [sym__special_characters] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym_raw_string] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5075),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5075),
  },
  [1985] = {
    [sym__concat] = ACTIONS(3788),
    [anon_sym_RBRACE] = ACTIONS(3788),
    [anon_sym_EQ] = ACTIONS(3790),
    [sym__special_characters] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_POUND] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_COLON_QMARK] = ACTIONS(3790),
    [anon_sym_COLON_DASH] = ACTIONS(3790),
    [anon_sym_PERCENT] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LT_LPAREN] = ACTIONS(3788),
    [anon_sym_GT_LPAREN] = ACTIONS(3788),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3790),
  },
  [1986] = {
    [sym__concat] = ACTIONS(3796),
    [anon_sym_RBRACE] = ACTIONS(3796),
    [anon_sym_EQ] = ACTIONS(3798),
    [sym__special_characters] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym_raw_string] = ACTIONS(3796),
    [anon_sym_POUND] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [anon_sym_COLON] = ACTIONS(3798),
    [anon_sym_COLON_QMARK] = ACTIONS(3798),
    [anon_sym_COLON_DASH] = ACTIONS(3798),
    [anon_sym_PERCENT] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3798),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3796),
    [anon_sym_GT_LPAREN] = ACTIONS(3796),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3798),
  },
  [1987] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(53),
  },
  [1988] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5079),
    [sym_comment] = ACTIONS(53),
  },
  [1989] = {
    [anon_sym_RBRACE] = ACTIONS(5079),
    [sym_comment] = ACTIONS(53),
  },
  [1990] = {
    [sym_concatenation] = STATE(2205),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2205),
    [anon_sym_RBRACE] = ACTIONS(5081),
    [anon_sym_EQ] = ACTIONS(5083),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5083),
    [anon_sym_COLON_QMARK] = ACTIONS(5083),
    [anon_sym_COLON_DASH] = ACTIONS(5083),
    [anon_sym_PERCENT] = ACTIONS(5083),
    [anon_sym_DASH] = ACTIONS(5083),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1991] = {
    [sym__concat] = ACTIONS(3852),
    [anon_sym_RBRACE] = ACTIONS(3852),
    [anon_sym_EQ] = ACTIONS(3854),
    [sym__special_characters] = ACTIONS(3854),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym_raw_string] = ACTIONS(3852),
    [anon_sym_POUND] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [anon_sym_COLON] = ACTIONS(3854),
    [anon_sym_COLON_QMARK] = ACTIONS(3854),
    [anon_sym_COLON_DASH] = ACTIONS(3854),
    [anon_sym_PERCENT] = ACTIONS(3854),
    [anon_sym_DASH] = ACTIONS(3854),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_LT_LPAREN] = ACTIONS(3852),
    [anon_sym_GT_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3854),
  },
  [1992] = {
    [sym_concatenation] = STATE(2206),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2206),
    [anon_sym_RBRACE] = ACTIONS(5079),
    [anon_sym_EQ] = ACTIONS(5087),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5087),
    [anon_sym_COLON_QMARK] = ACTIONS(5087),
    [anon_sym_COLON_DASH] = ACTIONS(5087),
    [anon_sym_PERCENT] = ACTIONS(5087),
    [anon_sym_DASH] = ACTIONS(5087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1993] = {
    [sym__concat] = ACTIONS(3893),
    [anon_sym_RBRACE] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3895),
    [sym__special_characters] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_POUND] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [anon_sym_COLON] = ACTIONS(3895),
    [anon_sym_COLON_QMARK] = ACTIONS(3895),
    [anon_sym_COLON_DASH] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LT_LPAREN] = ACTIONS(3893),
    [anon_sym_GT_LPAREN] = ACTIONS(3893),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3895),
  },
  [1994] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5091),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1995] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5079),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [1996] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_RBRACE] = ACTIONS(3915),
    [anon_sym_EQ] = ACTIONS(3917),
    [sym__special_characters] = ACTIONS(3917),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_POUND] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_COLON_QMARK] = ACTIONS(3917),
    [anon_sym_COLON_DASH] = ACTIONS(3917),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_DASH] = ACTIONS(3917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3917),
  },
  [1997] = {
    [sym__concat] = ACTIONS(3939),
    [anon_sym_RBRACE] = ACTIONS(3939),
    [anon_sym_EQ] = ACTIONS(3941),
    [sym__special_characters] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [sym_raw_string] = ACTIONS(3939),
    [anon_sym_POUND] = ACTIONS(3939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_COLON_QMARK] = ACTIONS(3941),
    [anon_sym_COLON_DASH] = ACTIONS(3941),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LT_LPAREN] = ACTIONS(3939),
    [anon_sym_GT_LPAREN] = ACTIONS(3939),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(3941),
  },
  [1998] = {
    [aux_sym_concatenation_repeat1] = STATE(2000),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [1999] = {
    [aux_sym_concatenation_repeat1] = STATE(2000),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2000] = {
    [aux_sym_concatenation_repeat1] = STATE(2208),
    [sym__concat] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [2001] = {
    [aux_sym_concatenation_repeat1] = STATE(2003),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2002] = {
    [aux_sym_concatenation_repeat1] = STATE(2003),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2003] = {
    [aux_sym_concatenation_repeat1] = STATE(2209),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [2004] = {
    [sym__heredoc_body_middle] = ACTIONS(3788),
    [sym__heredoc_body_end] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
  },
  [2005] = {
    [sym__heredoc_body_middle] = ACTIONS(3796),
    [sym__heredoc_body_end] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
  },
  [2006] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5093),
    [sym_comment] = ACTIONS(53),
  },
  [2007] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5095),
    [sym_comment] = ACTIONS(53),
  },
  [2008] = {
    [anon_sym_RBRACE] = ACTIONS(5095),
    [sym_comment] = ACTIONS(53),
  },
  [2009] = {
    [sym_concatenation] = STATE(2213),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2213),
    [anon_sym_RBRACE] = ACTIONS(5097),
    [anon_sym_EQ] = ACTIONS(5099),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5099),
    [anon_sym_COLON_QMARK] = ACTIONS(5099),
    [anon_sym_COLON_DASH] = ACTIONS(5099),
    [anon_sym_PERCENT] = ACTIONS(5099),
    [anon_sym_DASH] = ACTIONS(5099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2010] = {
    [sym__heredoc_body_middle] = ACTIONS(3852),
    [sym__heredoc_body_end] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
  },
  [2011] = {
    [sym_concatenation] = STATE(2214),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2214),
    [anon_sym_RBRACE] = ACTIONS(5095),
    [anon_sym_EQ] = ACTIONS(5103),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_COLON_QMARK] = ACTIONS(5103),
    [anon_sym_COLON_DASH] = ACTIONS(5103),
    [anon_sym_PERCENT] = ACTIONS(5103),
    [anon_sym_DASH] = ACTIONS(5103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2012] = {
    [sym__heredoc_body_middle] = ACTIONS(3893),
    [sym__heredoc_body_end] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
  },
  [2013] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5107),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2014] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5095),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2015] = {
    [sym__concat] = ACTIONS(3788),
    [anon_sym_RPAREN] = ACTIONS(3788),
    [sym__special_characters] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LT_LPAREN] = ACTIONS(3788),
    [anon_sym_GT_LPAREN] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3788),
  },
  [2016] = {
    [sym__concat] = ACTIONS(3796),
    [anon_sym_RPAREN] = ACTIONS(3796),
    [sym__special_characters] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym_raw_string] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3796),
    [anon_sym_GT_LPAREN] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3796),
  },
  [2017] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5109),
    [sym_comment] = ACTIONS(53),
  },
  [2018] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5111),
    [sym_comment] = ACTIONS(53),
  },
  [2019] = {
    [anon_sym_RBRACE] = ACTIONS(5111),
    [sym_comment] = ACTIONS(53),
  },
  [2020] = {
    [sym_concatenation] = STATE(2219),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2219),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_EQ] = ACTIONS(5115),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5115),
    [anon_sym_COLON_QMARK] = ACTIONS(5115),
    [anon_sym_COLON_DASH] = ACTIONS(5115),
    [anon_sym_PERCENT] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2021] = {
    [sym__concat] = ACTIONS(3852),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [sym__special_characters] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym_raw_string] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_LT_LPAREN] = ACTIONS(3852),
    [anon_sym_GT_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3852),
  },
  [2022] = {
    [sym_concatenation] = STATE(2220),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2220),
    [anon_sym_RBRACE] = ACTIONS(5111),
    [anon_sym_EQ] = ACTIONS(5119),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5119),
    [anon_sym_COLON_QMARK] = ACTIONS(5119),
    [anon_sym_COLON_DASH] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2023] = {
    [sym__concat] = ACTIONS(3893),
    [anon_sym_RPAREN] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LT_LPAREN] = ACTIONS(3893),
    [anon_sym_GT_LPAREN] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3893),
  },
  [2024] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5123),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2025] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5111),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2026] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3915),
  },
  [2027] = {
    [sym__concat] = ACTIONS(3939),
    [anon_sym_RPAREN] = ACTIONS(3939),
    [sym__special_characters] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [sym_raw_string] = ACTIONS(3939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LT_LPAREN] = ACTIONS(3939),
    [anon_sym_GT_LPAREN] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3939),
  },
  [2028] = {
    [sym_file_descriptor] = ACTIONS(4568),
    [sym__concat] = ACTIONS(4568),
    [sym_variable_name] = ACTIONS(4568),
    [ts_builtin_sym_end] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_LT] = ACTIONS(4570),
    [anon_sym_GT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_AMP_GT] = ACTIONS(4570),
    [anon_sym_AMP_GT_GT] = ACTIONS(4568),
    [anon_sym_LT_AMP] = ACTIONS(4568),
    [anon_sym_GT_AMP] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_LT_LPAREN] = ACTIONS(4568),
    [anon_sym_GT_LPAREN] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4570),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4570),
  },
  [2029] = {
    [sym_file_descriptor] = ACTIONS(4572),
    [sym__concat] = ACTIONS(4572),
    [sym_variable_name] = ACTIONS(4572),
    [ts_builtin_sym_end] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_PIPE] = ACTIONS(4574),
    [anon_sym_RPAREN] = ACTIONS(4572),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [anon_sym_PIPE_AMP] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [anon_sym_LT] = ACTIONS(4574),
    [anon_sym_GT] = ACTIONS(4574),
    [anon_sym_GT_GT] = ACTIONS(4572),
    [anon_sym_AMP_GT] = ACTIONS(4574),
    [anon_sym_AMP_GT_GT] = ACTIONS(4572),
    [anon_sym_LT_AMP] = ACTIONS(4572),
    [anon_sym_GT_AMP] = ACTIONS(4572),
    [sym__special_characters] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4574),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4574),
  },
  [2030] = {
    [sym_file_descriptor] = ACTIONS(4576),
    [sym__concat] = ACTIONS(4576),
    [sym_variable_name] = ACTIONS(4576),
    [ts_builtin_sym_end] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(4578),
    [anon_sym_RPAREN] = ACTIONS(4576),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [anon_sym_PIPE_AMP] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [anon_sym_LT] = ACTIONS(4578),
    [anon_sym_GT] = ACTIONS(4578),
    [anon_sym_GT_GT] = ACTIONS(4576),
    [anon_sym_AMP_GT] = ACTIONS(4578),
    [anon_sym_AMP_GT_GT] = ACTIONS(4576),
    [anon_sym_LT_AMP] = ACTIONS(4576),
    [anon_sym_GT_AMP] = ACTIONS(4576),
    [sym__special_characters] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_LT_LPAREN] = ACTIONS(4576),
    [anon_sym_GT_LPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4578),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4578),
  },
  [2031] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5125),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2032] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5127),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2033] = {
    [sym_file_descriptor] = ACTIONS(4608),
    [sym__concat] = ACTIONS(4608),
    [sym_variable_name] = ACTIONS(4608),
    [ts_builtin_sym_end] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4610),
    [anon_sym_RPAREN] = ACTIONS(4608),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [anon_sym_PIPE_AMP] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [anon_sym_LT] = ACTIONS(4610),
    [anon_sym_GT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_AMP_GT] = ACTIONS(4610),
    [anon_sym_AMP_GT_GT] = ACTIONS(4608),
    [anon_sym_LT_AMP] = ACTIONS(4608),
    [anon_sym_GT_AMP] = ACTIONS(4608),
    [sym__special_characters] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_LT_LPAREN] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4610),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4610),
  },
  [2034] = {
    [ts_builtin_sym_end] = ACTIONS(3524),
    [anon_sym_SEMI] = ACTIONS(3526),
    [anon_sym_esac] = ACTIONS(3524),
    [anon_sym_PIPE] = ACTIONS(3526),
    [anon_sym_RPAREN] = ACTIONS(3524),
    [anon_sym_SEMI_SEMI] = ACTIONS(3524),
    [anon_sym_PIPE_AMP] = ACTIONS(3524),
    [anon_sym_AMP_AMP] = ACTIONS(3524),
    [anon_sym_PIPE_PIPE] = ACTIONS(3524),
    [anon_sym_BQUOTE] = ACTIONS(3524),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3524),
    [anon_sym_AMP] = ACTIONS(3526),
  },
  [2035] = {
    [sym__concat] = ACTIONS(2876),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [anon_sym_EQ_TILDE] = ACTIONS(2876),
    [anon_sym_EQ_EQ] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2878),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_GT] = ACTIONS(2876),
    [anon_sym_BANG_EQ] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2876),
  },
  [2036] = {
    [sym__concat] = ACTIONS(2890),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_EQ_TILDE] = ACTIONS(2890),
    [anon_sym_EQ_EQ] = ACTIONS(2890),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2890),
    [anon_sym_GT] = ACTIONS(2890),
    [anon_sym_BANG_EQ] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2890),
  },
  [2037] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [sym_comment] = ACTIONS(53),
  },
  [2038] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [sym_comment] = ACTIONS(53),
  },
  [2039] = {
    [anon_sym_RBRACE] = ACTIONS(5131),
    [sym_comment] = ACTIONS(53),
  },
  [2040] = {
    [sym_concatenation] = STATE(2228),
    [sym_string] = STATE(2227),
    [sym_simple_expansion] = STATE(2227),
    [sym_string_expansion] = STATE(2227),
    [sym_expansion] = STATE(2227),
    [sym_command_substitution] = STATE(2227),
    [sym_process_substitution] = STATE(2227),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [sym__special_characters] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(5135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5135),
  },
  [2041] = {
    [sym__concat] = ACTIONS(2926),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_EQ_TILDE] = ACTIONS(2926),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2926),
    [anon_sym_GT] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2926),
  },
  [2042] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(5137),
  },
  [2043] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5139),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2044] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(5141),
  },
  [2045] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2046] = {
    [sym_concatenation] = STATE(2233),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2233),
    [anon_sym_RBRACE] = ACTIONS(5143),
    [anon_sym_EQ] = ACTIONS(5145),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5145),
    [anon_sym_COLON_QMARK] = ACTIONS(5145),
    [anon_sym_COLON_DASH] = ACTIONS(5145),
    [anon_sym_PERCENT] = ACTIONS(5145),
    [anon_sym_DASH] = ACTIONS(5145),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2047] = {
    [sym__concat] = ACTIONS(2990),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [anon_sym_EQ_TILDE] = ACTIONS(2990),
    [anon_sym_EQ_EQ] = ACTIONS(2990),
    [anon_sym_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_GT] = ACTIONS(2990),
    [anon_sym_BANG_EQ] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(2990),
  },
  [2048] = {
    [sym_concatenation] = STATE(2234),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2234),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [anon_sym_EQ] = ACTIONS(5149),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5149),
    [anon_sym_COLON_QMARK] = ACTIONS(5149),
    [anon_sym_COLON_DASH] = ACTIONS(5149),
    [anon_sym_PERCENT] = ACTIONS(5149),
    [anon_sym_DASH] = ACTIONS(5149),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2049] = {
    [sym__concat] = ACTIONS(3033),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [anon_sym_EQ_TILDE] = ACTIONS(3033),
    [anon_sym_EQ_EQ] = ACTIONS(3033),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_GT] = ACTIONS(3033),
    [anon_sym_BANG_EQ] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3033),
  },
  [2050] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(5153),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2051] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(5153),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2052] = {
    [sym__concat] = ACTIONS(3071),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_EQ_TILDE] = ACTIONS(3071),
    [anon_sym_EQ_EQ] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3071),
    [anon_sym_GT] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3071),
  },
  [2053] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(5155),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2054] = {
    [ts_builtin_sym_end] = ACTIONS(5157),
    [anon_sym_SEMI] = ACTIONS(5159),
    [anon_sym_esac] = ACTIONS(5157),
    [anon_sym_PIPE] = ACTIONS(5159),
    [anon_sym_RPAREN] = ACTIONS(5157),
    [anon_sym_SEMI_SEMI] = ACTIONS(5157),
    [anon_sym_PIPE_AMP] = ACTIONS(5157),
    [anon_sym_AMP_AMP] = ACTIONS(5157),
    [anon_sym_PIPE_PIPE] = ACTIONS(5157),
    [anon_sym_BQUOTE] = ACTIONS(5157),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5157),
    [anon_sym_AMP] = ACTIONS(5159),
  },
  [2055] = {
    [sym_do_group] = STATE(2237),
    [sym_compound_statement] = STATE(2237),
    [anon_sym_do] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [sym_comment] = ACTIONS(53),
  },
  [2056] = {
    [sym__concat] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_esac] = ACTIONS(4568),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_EQ_TILDE] = ACTIONS(4568),
    [anon_sym_EQ_EQ] = ACTIONS(4568),
    [anon_sym_EQ] = ACTIONS(4570),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_BANG_EQ] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4568),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4570),
  },
  [2057] = {
    [sym__concat] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_esac] = ACTIONS(4572),
    [anon_sym_PIPE] = ACTIONS(4574),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [anon_sym_PIPE_AMP] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [anon_sym_EQ_TILDE] = ACTIONS(4572),
    [anon_sym_EQ_EQ] = ACTIONS(4572),
    [anon_sym_EQ] = ACTIONS(4574),
    [anon_sym_LT] = ACTIONS(4572),
    [anon_sym_GT] = ACTIONS(4572),
    [anon_sym_BANG_EQ] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4572),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4574),
  },
  [2058] = {
    [sym__concat] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_esac] = ACTIONS(4576),
    [anon_sym_PIPE] = ACTIONS(4578),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [anon_sym_PIPE_AMP] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [anon_sym_EQ_TILDE] = ACTIONS(4576),
    [anon_sym_EQ_EQ] = ACTIONS(4576),
    [anon_sym_EQ] = ACTIONS(4578),
    [anon_sym_LT] = ACTIONS(4576),
    [anon_sym_GT] = ACTIONS(4576),
    [anon_sym_BANG_EQ] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4576),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4578),
  },
  [2059] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5161),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2060] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5163),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2061] = {
    [sym__concat] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_esac] = ACTIONS(4608),
    [anon_sym_PIPE] = ACTIONS(4610),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [anon_sym_PIPE_AMP] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [anon_sym_EQ_TILDE] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4608),
    [anon_sym_EQ] = ACTIONS(4610),
    [anon_sym_LT] = ACTIONS(4608),
    [anon_sym_GT] = ACTIONS(4608),
    [anon_sym_BANG_EQ] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4608),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4610),
  },
  [2062] = {
    [sym_do_group] = STATE(2237),
    [sym_compound_statement] = STATE(2237),
    [anon_sym_SEMI] = ACTIONS(5165),
    [anon_sym_do] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [sym_comment] = ACTIONS(53),
  },
  [2063] = {
    [sym__concat] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [sym__special_characters] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LT_LPAREN] = ACTIONS(3788),
    [anon_sym_GT_LPAREN] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3790),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3788),
  },
  [2064] = {
    [sym__concat] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [sym__special_characters] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym_raw_string] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3796),
    [anon_sym_GT_LPAREN] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3798),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3796),
  },
  [2065] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5167),
    [sym_comment] = ACTIONS(53),
  },
  [2066] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5169),
    [sym_comment] = ACTIONS(53),
  },
  [2067] = {
    [anon_sym_RBRACE] = ACTIONS(5169),
    [sym_comment] = ACTIONS(53),
  },
  [2068] = {
    [sym_concatenation] = STATE(2244),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2244),
    [anon_sym_RBRACE] = ACTIONS(5171),
    [anon_sym_EQ] = ACTIONS(5173),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5173),
    [anon_sym_COLON_QMARK] = ACTIONS(5173),
    [anon_sym_COLON_DASH] = ACTIONS(5173),
    [anon_sym_PERCENT] = ACTIONS(5173),
    [anon_sym_DASH] = ACTIONS(5173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2069] = {
    [sym__concat] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [sym__special_characters] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym_raw_string] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_LT_LPAREN] = ACTIONS(3852),
    [anon_sym_GT_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3854),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3852),
  },
  [2070] = {
    [sym_concatenation] = STATE(2245),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2245),
    [anon_sym_RBRACE] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(5177),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5177),
    [anon_sym_COLON_QMARK] = ACTIONS(5177),
    [anon_sym_COLON_DASH] = ACTIONS(5177),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2071] = {
    [sym__concat] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LT_LPAREN] = ACTIONS(3893),
    [anon_sym_GT_LPAREN] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3895),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3893),
  },
  [2072] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2073] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5169),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2074] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3915),
  },
  [2075] = {
    [sym__concat] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [sym__special_characters] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [sym_raw_string] = ACTIONS(3939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LT_LPAREN] = ACTIONS(3939),
    [anon_sym_GT_LPAREN] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3941),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3939),
  },
  [2076] = {
    [aux_sym_concatenation_repeat1] = STATE(2076),
    [sym__concat] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2077] = {
    [aux_sym_concatenation_repeat1] = STATE(2077),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(4968),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2078] = {
    [sym_concatenation] = STATE(2247),
    [sym_string] = STATE(2252),
    [sym_array] = STATE(2247),
    [sym_simple_expansion] = STATE(2252),
    [sym_string_expansion] = STATE(2252),
    [sym_expansion] = STATE(2252),
    [sym_command_substitution] = STATE(2252),
    [sym_process_substitution] = STATE(2252),
    [sym__empty_value] = ACTIONS(5183),
    [anon_sym_LPAREN] = ACTIONS(5185),
    [sym__special_characters] = ACTIONS(5187),
    [anon_sym_DQUOTE] = ACTIONS(5189),
    [anon_sym_DOLLAR] = ACTIONS(5191),
    [sym_raw_string] = ACTIONS(5193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5197),
    [anon_sym_BQUOTE] = ACTIONS(5199),
    [anon_sym_LT_LPAREN] = ACTIONS(5201),
    [anon_sym_GT_LPAREN] = ACTIONS(5201),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5193),
  },
  [2079] = {
    [sym_do_group] = STATE(2257),
    [anon_sym_do] = ACTIONS(441),
    [sym_comment] = ACTIONS(53),
  },
  [2080] = {
    [sym_compound_statement] = STATE(2259),
    [anon_sym_LPAREN] = ACTIONS(5203),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [2081] = {
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(5205),
    [anon_sym_EQ_TILDE] = ACTIONS(619),
    [anon_sym_EQ_EQ] = ACTIONS(619),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_BANG_EQ] = ACTIONS(615),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(615),
  },
  [2082] = {
    [anon_sym_AMP_AMP] = ACTIONS(647),
    [anon_sym_PIPE_PIPE] = ACTIONS(647),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5205),
    [anon_sym_EQ_TILDE] = ACTIONS(649),
    [anon_sym_EQ_EQ] = ACTIONS(649),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(647),
  },
  [2083] = {
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(5207),
    [anon_sym_PLUS_EQ] = ACTIONS(5207),
    [sym_comment] = ACTIONS(53),
  },
  [2084] = {
    [aux_sym_concatenation_repeat1] = STATE(2263),
    [sym__concat] = ACTIONS(5209),
    [sym_variable_name] = ACTIONS(657),
    [anon_sym_SEMI] = ACTIONS(659),
    [anon_sym_esac] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_SEMI_SEMI] = ACTIONS(657),
    [anon_sym_PIPE_AMP] = ACTIONS(657),
    [anon_sym_AMP_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(657),
    [sym__special_characters] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [sym_raw_string] = ACTIONS(657),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(657),
    [anon_sym_BQUOTE] = ACTIONS(657),
    [anon_sym_LT_LPAREN] = ACTIONS(657),
    [anon_sym_GT_LPAREN] = ACTIONS(657),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(659),
    [sym_word] = ACTIONS(659),
    [anon_sym_LF] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(659),
  },
  [2085] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(2266),
    [anon_sym_DQUOTE] = ACTIONS(5211),
    [anon_sym_DOLLAR] = ACTIONS(5213),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2086] = {
    [sym_string] = STATE(2268),
    [anon_sym_DQUOTE] = ACTIONS(4831),
    [anon_sym_DOLLAR] = ACTIONS(5215),
    [sym_raw_string] = ACTIONS(5217),
    [anon_sym_POUND] = ACTIONS(5215),
    [anon_sym_DASH] = ACTIONS(5215),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5219),
    [anon_sym_STAR] = ACTIONS(5221),
    [anon_sym_AT] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5221),
    [anon_sym_0] = ACTIONS(5219),
    [anon_sym__] = ACTIONS(5219),
  },
  [2087] = {
    [aux_sym_concatenation_repeat1] = STATE(2263),
    [sym__concat] = ACTIONS(5209),
    [sym_variable_name] = ACTIONS(673),
    [anon_sym_SEMI] = ACTIONS(675),
    [anon_sym_esac] = ACTIONS(675),
    [anon_sym_PIPE] = ACTIONS(675),
    [anon_sym_SEMI_SEMI] = ACTIONS(673),
    [anon_sym_PIPE_AMP] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(673),
    [anon_sym_PIPE_PIPE] = ACTIONS(673),
    [sym__special_characters] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(673),
    [anon_sym_BQUOTE] = ACTIONS(673),
    [anon_sym_LT_LPAREN] = ACTIONS(673),
    [anon_sym_GT_LPAREN] = ACTIONS(673),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(675),
    [sym_word] = ACTIONS(675),
    [anon_sym_LF] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
  },
  [2088] = {
    [sym_subscript] = STATE(2273),
    [sym_variable_name] = ACTIONS(5223),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_DOLLAR] = ACTIONS(5227),
    [anon_sym_POUND] = ACTIONS(5225),
    [anon_sym_DASH] = ACTIONS(5227),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5229),
    [anon_sym_STAR] = ACTIONS(5231),
    [anon_sym_AT] = ACTIONS(5231),
    [anon_sym_QMARK] = ACTIONS(5231),
    [anon_sym_0] = ACTIONS(5229),
    [anon_sym__] = ACTIONS(5229),
  },
  [2089] = {
    [sym__terminated_statement] = STATE(2276),
    [sym_for_statement] = STATE(2274),
    [sym_c_style_for_statement] = STATE(2274),
    [sym_while_statement] = STATE(2274),
    [sym_if_statement] = STATE(2274),
    [sym_case_statement] = STATE(2274),
    [sym_function_definition] = STATE(2274),
    [sym_subshell] = STATE(2274),
    [sym_pipeline] = STATE(2274),
    [sym_list] = STATE(2274),
    [sym_negated_command] = STATE(2274),
    [sym_test_command] = STATE(2274),
    [sym_declaration_command] = STATE(2274),
    [sym_unset_command] = STATE(2274),
    [sym_command] = STATE(2274),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2275),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(2276),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2090] = {
    [sym__terminated_statement] = STATE(2279),
    [sym_for_statement] = STATE(2277),
    [sym_c_style_for_statement] = STATE(2277),
    [sym_while_statement] = STATE(2277),
    [sym_if_statement] = STATE(2277),
    [sym_case_statement] = STATE(2277),
    [sym_function_definition] = STATE(2277),
    [sym_subshell] = STATE(2277),
    [sym_pipeline] = STATE(2277),
    [sym_list] = STATE(2277),
    [sym_negated_command] = STATE(2277),
    [sym_test_command] = STATE(2277),
    [sym_declaration_command] = STATE(2277),
    [sym_unset_command] = STATE(2277),
    [sym_command] = STATE(2277),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(2278),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2279),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [2091] = {
    [sym__terminated_statement] = STATE(2282),
    [sym_for_statement] = STATE(2280),
    [sym_c_style_for_statement] = STATE(2280),
    [sym_while_statement] = STATE(2280),
    [sym_if_statement] = STATE(2280),
    [sym_case_statement] = STATE(2280),
    [sym_function_definition] = STATE(2280),
    [sym_subshell] = STATE(2280),
    [sym_pipeline] = STATE(2280),
    [sym_list] = STATE(2280),
    [sym_negated_command] = STATE(2280),
    [sym_test_command] = STATE(2280),
    [sym_declaration_command] = STATE(2280),
    [sym_unset_command] = STATE(2280),
    [sym_command] = STATE(2280),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2281),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(2282),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2092] = {
    [anon_sym_EQ] = ACTIONS(5207),
    [anon_sym_PLUS_EQ] = ACTIONS(5207),
    [sym_comment] = ACTIONS(53),
  },
  [2093] = {
    [sym_variable_assignment] = STATE(2283),
    [sym_subscript] = STATE(2092),
    [sym_concatenation] = STATE(2283),
    [sym_string] = STATE(2087),
    [sym_simple_expansion] = STATE(2087),
    [sym_string_expansion] = STATE(2087),
    [sym_expansion] = STATE(2087),
    [sym_command_substitution] = STATE(2087),
    [sym_process_substitution] = STATE(2087),
    [aux_sym_declaration_command_repeat1] = STATE(2283),
    [sym_variable_name] = ACTIONS(4827),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_esac] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_SEMI_SEMI] = ACTIONS(687),
    [anon_sym_PIPE_AMP] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [sym__special_characters] = ACTIONS(4829),
    [anon_sym_DQUOTE] = ACTIONS(4831),
    [anon_sym_DOLLAR] = ACTIONS(4833),
    [sym_raw_string] = ACTIONS(4835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4839),
    [anon_sym_BQUOTE] = ACTIONS(4841),
    [anon_sym_LT_LPAREN] = ACTIONS(4843),
    [anon_sym_GT_LPAREN] = ACTIONS(4843),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5233),
    [sym_word] = ACTIONS(4847),
    [anon_sym_LF] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
  },
  [2094] = {
    [aux_sym_concatenation_repeat1] = STATE(2285),
    [sym__concat] = ACTIONS(5235),
    [anon_sym_SEMI] = ACTIONS(697),
    [anon_sym_esac] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_SEMI_SEMI] = ACTIONS(695),
    [anon_sym_PIPE_AMP] = ACTIONS(695),
    [anon_sym_AMP_AMP] = ACTIONS(695),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [sym__special_characters] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(695),
    [anon_sym_BQUOTE] = ACTIONS(695),
    [anon_sym_LT_LPAREN] = ACTIONS(695),
    [anon_sym_GT_LPAREN] = ACTIONS(695),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(697),
    [sym_word] = ACTIONS(697),
    [anon_sym_LF] = ACTIONS(695),
    [anon_sym_AMP] = ACTIONS(697),
  },
  [2095] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(2288),
    [anon_sym_DQUOTE] = ACTIONS(5237),
    [anon_sym_DOLLAR] = ACTIONS(5239),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2096] = {
    [sym_string] = STATE(2290),
    [anon_sym_DQUOTE] = ACTIONS(4851),
    [anon_sym_DOLLAR] = ACTIONS(5241),
    [sym_raw_string] = ACTIONS(5243),
    [anon_sym_POUND] = ACTIONS(5241),
    [anon_sym_DASH] = ACTIONS(5241),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5245),
    [anon_sym_STAR] = ACTIONS(5247),
    [anon_sym_AT] = ACTIONS(5247),
    [anon_sym_QMARK] = ACTIONS(5247),
    [anon_sym_0] = ACTIONS(5245),
    [anon_sym__] = ACTIONS(5245),
  },
  [2097] = {
    [aux_sym_concatenation_repeat1] = STATE(2285),
    [sym__concat] = ACTIONS(5235),
    [anon_sym_SEMI] = ACTIONS(713),
    [anon_sym_esac] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_SEMI_SEMI] = ACTIONS(711),
    [anon_sym_PIPE_AMP] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(711),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [sym__special_characters] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_DOLLAR] = ACTIONS(713),
    [sym_raw_string] = ACTIONS(711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(711),
    [anon_sym_BQUOTE] = ACTIONS(711),
    [anon_sym_LT_LPAREN] = ACTIONS(711),
    [anon_sym_GT_LPAREN] = ACTIONS(711),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(713),
    [sym_word] = ACTIONS(713),
    [anon_sym_LF] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
  },
  [2098] = {
    [sym_subscript] = STATE(2295),
    [sym_variable_name] = ACTIONS(5249),
    [anon_sym_BANG] = ACTIONS(5251),
    [anon_sym_DOLLAR] = ACTIONS(5253),
    [anon_sym_POUND] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5253),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5255),
    [anon_sym_STAR] = ACTIONS(5257),
    [anon_sym_AT] = ACTIONS(5257),
    [anon_sym_QMARK] = ACTIONS(5257),
    [anon_sym_0] = ACTIONS(5255),
    [anon_sym__] = ACTIONS(5255),
  },
  [2099] = {
    [sym__terminated_statement] = STATE(2298),
    [sym_for_statement] = STATE(2296),
    [sym_c_style_for_statement] = STATE(2296),
    [sym_while_statement] = STATE(2296),
    [sym_if_statement] = STATE(2296),
    [sym_case_statement] = STATE(2296),
    [sym_function_definition] = STATE(2296),
    [sym_subshell] = STATE(2296),
    [sym_pipeline] = STATE(2296),
    [sym_list] = STATE(2296),
    [sym_negated_command] = STATE(2296),
    [sym_test_command] = STATE(2296),
    [sym_declaration_command] = STATE(2296),
    [sym_unset_command] = STATE(2296),
    [sym_command] = STATE(2296),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2297),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(2298),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2100] = {
    [sym__terminated_statement] = STATE(2301),
    [sym_for_statement] = STATE(2299),
    [sym_c_style_for_statement] = STATE(2299),
    [sym_while_statement] = STATE(2299),
    [sym_if_statement] = STATE(2299),
    [sym_case_statement] = STATE(2299),
    [sym_function_definition] = STATE(2299),
    [sym_subshell] = STATE(2299),
    [sym_pipeline] = STATE(2299),
    [sym_list] = STATE(2299),
    [sym_negated_command] = STATE(2299),
    [sym_test_command] = STATE(2299),
    [sym_declaration_command] = STATE(2299),
    [sym_unset_command] = STATE(2299),
    [sym_command] = STATE(2299),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(2300),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2301),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [2101] = {
    [sym__terminated_statement] = STATE(2304),
    [sym_for_statement] = STATE(2302),
    [sym_c_style_for_statement] = STATE(2302),
    [sym_while_statement] = STATE(2302),
    [sym_if_statement] = STATE(2302),
    [sym_case_statement] = STATE(2302),
    [sym_function_definition] = STATE(2302),
    [sym_subshell] = STATE(2302),
    [sym_pipeline] = STATE(2302),
    [sym_list] = STATE(2302),
    [sym_negated_command] = STATE(2302),
    [sym_test_command] = STATE(2302),
    [sym_declaration_command] = STATE(2302),
    [sym_unset_command] = STATE(2302),
    [sym_command] = STATE(2302),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2303),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(2304),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2102] = {
    [sym_concatenation] = STATE(2305),
    [sym_string] = STATE(2097),
    [sym_simple_expansion] = STATE(2097),
    [sym_string_expansion] = STATE(2097),
    [sym_expansion] = STATE(2097),
    [sym_command_substitution] = STATE(2097),
    [sym_process_substitution] = STATE(2097),
    [aux_sym_unset_command_repeat1] = STATE(2305),
    [anon_sym_SEMI] = ACTIONS(727),
    [anon_sym_esac] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_SEMI_SEMI] = ACTIONS(725),
    [anon_sym_PIPE_AMP] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [sym__special_characters] = ACTIONS(4849),
    [anon_sym_DQUOTE] = ACTIONS(4851),
    [anon_sym_DOLLAR] = ACTIONS(4853),
    [sym_raw_string] = ACTIONS(4855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4859),
    [anon_sym_BQUOTE] = ACTIONS(4861),
    [anon_sym_LT_LPAREN] = ACTIONS(4863),
    [anon_sym_GT_LPAREN] = ACTIONS(4863),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5259),
    [sym_word] = ACTIONS(4867),
    [anon_sym_LF] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(727),
  },
  [2103] = {
    [sym_string] = STATE(2306),
    [sym_simple_expansion] = STATE(2306),
    [sym_string_expansion] = STATE(2306),
    [sym_expansion] = STATE(2306),
    [sym_command_substitution] = STATE(2306),
    [sym_process_substitution] = STATE(2306),
    [sym__special_characters] = ACTIONS(5261),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(5261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5261),
  },
  [2104] = {
    [aux_sym_concatenation_repeat1] = STATE(2307),
    [sym__simple_heredoc_body] = ACTIONS(765),
    [sym__heredoc_body_beginning] = ACTIONS(765),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(4869),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_esac] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_EQ_TILDE] = ACTIONS(767),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [2105] = {
    [sym__simple_heredoc_body] = ACTIONS(769),
    [sym__heredoc_body_beginning] = ACTIONS(769),
    [sym_file_descriptor] = ACTIONS(769),
    [sym__concat] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_esac] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_EQ_TILDE] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_AMP_GT] = ACTIONS(771),
    [anon_sym_AMP_GT_GT] = ACTIONS(769),
    [anon_sym_LT_AMP] = ACTIONS(769),
    [anon_sym_GT_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_LT_LT_DASH] = ACTIONS(769),
    [anon_sym_LT_LT_LT] = ACTIONS(769),
    [sym__special_characters] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [2106] = {
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [2107] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(5263),
    [anon_sym_DOLLAR] = ACTIONS(5265),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2108] = {
    [sym__simple_heredoc_body] = ACTIONS(803),
    [sym__heredoc_body_beginning] = ACTIONS(803),
    [sym_file_descriptor] = ACTIONS(803),
    [sym__concat] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_esac] = ACTIONS(805),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [anon_sym_PIPE_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_EQ_TILDE] = ACTIONS(805),
    [anon_sym_EQ_EQ] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_AMP_GT] = ACTIONS(805),
    [anon_sym_AMP_GT_GT] = ACTIONS(803),
    [anon_sym_LT_AMP] = ACTIONS(803),
    [anon_sym_GT_AMP] = ACTIONS(803),
    [anon_sym_LT_LT] = ACTIONS(805),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_LT] = ACTIONS(803),
    [sym__special_characters] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_raw_string] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(805),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(805),
  },
  [2109] = {
    [sym__simple_heredoc_body] = ACTIONS(807),
    [sym__heredoc_body_beginning] = ACTIONS(807),
    [sym_file_descriptor] = ACTIONS(807),
    [sym__concat] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_esac] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [anon_sym_PIPE_AMP] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_EQ_TILDE] = ACTIONS(809),
    [anon_sym_EQ_EQ] = ACTIONS(809),
    [anon_sym_LT] = ACTIONS(809),
    [anon_sym_GT] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(807),
    [anon_sym_AMP_GT] = ACTIONS(809),
    [anon_sym_AMP_GT_GT] = ACTIONS(807),
    [anon_sym_LT_AMP] = ACTIONS(807),
    [anon_sym_GT_AMP] = ACTIONS(807),
    [anon_sym_LT_LT] = ACTIONS(809),
    [anon_sym_LT_LT_DASH] = ACTIONS(807),
    [anon_sym_LT_LT_LT] = ACTIONS(807),
    [sym__special_characters] = ACTIONS(807),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(807),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_LT_LPAREN] = ACTIONS(807),
    [anon_sym_GT_LPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(809),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(809),
  },
  [2110] = {
    [sym__simple_heredoc_body] = ACTIONS(811),
    [sym__heredoc_body_beginning] = ACTIONS(811),
    [sym_file_descriptor] = ACTIONS(811),
    [sym__concat] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_esac] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_EQ_TILDE] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_AMP_GT] = ACTIONS(813),
    [anon_sym_AMP_GT_GT] = ACTIONS(811),
    [anon_sym_LT_AMP] = ACTIONS(811),
    [anon_sym_GT_AMP] = ACTIONS(811),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_LT] = ACTIONS(811),
    [sym__special_characters] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_LT_LPAREN] = ACTIONS(811),
    [anon_sym_GT_LPAREN] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(813),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(813),
  },
  [2111] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(5267),
    [sym_comment] = ACTIONS(53),
  },
  [2112] = {
    [sym_subscript] = STATE(2313),
    [sym_variable_name] = ACTIONS(5269),
    [anon_sym_DOLLAR] = ACTIONS(5271),
    [anon_sym_DASH] = ACTIONS(5271),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5273),
    [anon_sym_STAR] = ACTIONS(5275),
    [anon_sym_AT] = ACTIONS(5275),
    [anon_sym_QMARK] = ACTIONS(5275),
    [anon_sym_0] = ACTIONS(5273),
    [anon_sym__] = ACTIONS(5273),
  },
  [2113] = {
    [sym_concatenation] = STATE(2316),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2316),
    [anon_sym_RBRACE] = ACTIONS(5277),
    [anon_sym_EQ] = ACTIONS(5279),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5283),
    [anon_sym_COLON] = ACTIONS(5279),
    [anon_sym_COLON_QMARK] = ACTIONS(5279),
    [anon_sym_COLON_DASH] = ACTIONS(5279),
    [anon_sym_PERCENT] = ACTIONS(5279),
    [anon_sym_DASH] = ACTIONS(5279),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2114] = {
    [sym_concatenation] = STATE(2319),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2319),
    [anon_sym_RBRACE] = ACTIONS(5285),
    [anon_sym_EQ] = ACTIONS(5287),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5291),
    [anon_sym_COLON] = ACTIONS(5287),
    [anon_sym_COLON_QMARK] = ACTIONS(5287),
    [anon_sym_COLON_DASH] = ACTIONS(5287),
    [anon_sym_PERCENT] = ACTIONS(5287),
    [anon_sym_DASH] = ACTIONS(5287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2115] = {
    [anon_sym_SEMI] = ACTIONS(5293),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5295),
    [anon_sym_SEMI_SEMI] = ACTIONS(5297),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5297),
    [anon_sym_AMP] = ACTIONS(5293),
  },
  [2116] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5293),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5295),
    [anon_sym_SEMI_SEMI] = ACTIONS(5297),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5297),
    [anon_sym_AMP] = ACTIONS(5293),
  },
  [2117] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2322),
    [sym_c_style_for_statement] = STATE(2322),
    [sym_while_statement] = STATE(2322),
    [sym_if_statement] = STATE(2322),
    [sym_case_statement] = STATE(2322),
    [sym_function_definition] = STATE(2322),
    [sym_subshell] = STATE(2322),
    [sym_pipeline] = STATE(2322),
    [sym_list] = STATE(2322),
    [sym_negated_command] = STATE(2322),
    [sym_test_command] = STATE(2322),
    [sym_declaration_command] = STATE(2322),
    [sym_unset_command] = STATE(2322),
    [sym_command] = STATE(2322),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2323),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2118] = {
    [anon_sym_SEMI] = ACTIONS(5299),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5301),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(5295),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5301),
    [anon_sym_AMP] = ACTIONS(5299),
  },
  [2119] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5299),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5301),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(5295),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5301),
    [anon_sym_AMP] = ACTIONS(5299),
  },
  [2120] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2325),
    [sym_c_style_for_statement] = STATE(2325),
    [sym_while_statement] = STATE(2325),
    [sym_if_statement] = STATE(2325),
    [sym_case_statement] = STATE(2325),
    [sym_function_definition] = STATE(2325),
    [sym_subshell] = STATE(2325),
    [sym_pipeline] = STATE(2325),
    [sym_list] = STATE(2325),
    [sym_negated_command] = STATE(2325),
    [sym_test_command] = STATE(2325),
    [sym_declaration_command] = STATE(2325),
    [sym_unset_command] = STATE(2325),
    [sym_command] = STATE(2325),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(2326),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [2121] = {
    [anon_sym_SEMI] = ACTIONS(5303),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5305),
    [anon_sym_SEMI_SEMI] = ACTIONS(5307),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5307),
    [anon_sym_AMP] = ACTIONS(5303),
  },
  [2122] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5303),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5305),
    [anon_sym_SEMI_SEMI] = ACTIONS(5307),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5307),
    [anon_sym_AMP] = ACTIONS(5303),
  },
  [2123] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2329),
    [sym_c_style_for_statement] = STATE(2329),
    [sym_while_statement] = STATE(2329),
    [sym_if_statement] = STATE(2329),
    [sym_case_statement] = STATE(2329),
    [sym_function_definition] = STATE(2329),
    [sym_subshell] = STATE(2329),
    [sym_pipeline] = STATE(2329),
    [sym_list] = STATE(2329),
    [sym_negated_command] = STATE(2329),
    [sym_test_command] = STATE(2329),
    [sym_declaration_command] = STATE(2329),
    [sym_unset_command] = STATE(2329),
    [sym_command] = STATE(2329),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2330),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2124] = {
    [anon_sym_RPAREN] = ACTIONS(5309),
    [sym_comment] = ACTIONS(53),
  },
  [2125] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_esac] = ACTIONS(905),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2126] = {
    [sym_for_statement] = STATE(497),
    [sym_c_style_for_statement] = STATE(497),
    [sym_while_statement] = STATE(497),
    [sym_if_statement] = STATE(497),
    [sym_case_statement] = STATE(497),
    [sym_function_definition] = STATE(497),
    [sym_subshell] = STATE(497),
    [sym_pipeline] = STATE(497),
    [sym_list] = STATE(497),
    [sym_negated_command] = STATE(497),
    [sym_test_command] = STATE(497),
    [sym_declaration_command] = STATE(497),
    [sym_unset_command] = STATE(497),
    [sym_command] = STATE(497),
    [sym_command_name] = STATE(1867),
    [sym_variable_assignment] = STATE(2332),
    [sym_subscript] = STATE(1869),
    [sym_file_redirect] = STATE(1872),
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_string_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [aux_sym_command_repeat1] = STATE(1872),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4245),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(4257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4259),
    [anon_sym_declare] = ACTIONS(4261),
    [anon_sym_typeset] = ACTIONS(4261),
    [anon_sym_export] = ACTIONS(4261),
    [anon_sym_readonly] = ACTIONS(4261),
    [anon_sym_local] = ACTIONS(4261),
    [anon_sym_unset] = ACTIONS(4263),
    [anon_sym_unsetenv] = ACTIONS(4263),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4265),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4281),
  },
  [2127] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_esac] = ACTIONS(5311),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5315),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [sym_raw_string] = ACTIONS(5315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5315),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5315),
    [anon_sym_BQUOTE] = ACTIONS(5315),
    [anon_sym_LT_LPAREN] = ACTIONS(5315),
    [anon_sym_GT_LPAREN] = ACTIONS(5315),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5313),
  },
  [2128] = {
    [sym_for_statement] = STATE(2333),
    [sym_c_style_for_statement] = STATE(2333),
    [sym_while_statement] = STATE(2333),
    [sym_if_statement] = STATE(2333),
    [sym_case_statement] = STATE(2333),
    [sym_function_definition] = STATE(2333),
    [sym_subshell] = STATE(2333),
    [sym_pipeline] = STATE(2333),
    [sym_list] = STATE(2333),
    [sym_negated_command] = STATE(2333),
    [sym_test_command] = STATE(2333),
    [sym_declaration_command] = STATE(2333),
    [sym_unset_command] = STATE(2333),
    [sym_command] = STATE(2333),
    [sym_command_name] = STATE(1867),
    [sym_variable_assignment] = STATE(2334),
    [sym_subscript] = STATE(1869),
    [sym_file_redirect] = STATE(1872),
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_string_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [aux_sym_command_repeat1] = STATE(1872),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4245),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(4257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4259),
    [anon_sym_declare] = ACTIONS(4261),
    [anon_sym_typeset] = ACTIONS(4261),
    [anon_sym_export] = ACTIONS(4261),
    [anon_sym_readonly] = ACTIONS(4261),
    [anon_sym_local] = ACTIONS(4261),
    [anon_sym_unset] = ACTIONS(4263),
    [anon_sym_unsetenv] = ACTIONS(4263),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4265),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4281),
  },
  [2129] = {
    [anon_sym_LT] = ACTIONS(5317),
    [anon_sym_GT] = ACTIONS(5317),
    [anon_sym_GT_GT] = ACTIONS(5319),
    [anon_sym_AMP_GT] = ACTIONS(5317),
    [anon_sym_AMP_GT_GT] = ACTIONS(5319),
    [anon_sym_LT_AMP] = ACTIONS(5319),
    [anon_sym_GT_AMP] = ACTIONS(5319),
    [sym_comment] = ACTIONS(53),
  },
  [2130] = {
    [sym_concatenation] = STATE(2338),
    [sym_string] = STATE(2337),
    [sym_simple_expansion] = STATE(2337),
    [sym_string_expansion] = STATE(2337),
    [sym_expansion] = STATE(2337),
    [sym_command_substitution] = STATE(2337),
    [sym_process_substitution] = STATE(2337),
    [sym__special_characters] = ACTIONS(5321),
    [anon_sym_DQUOTE] = ACTIONS(5323),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(5325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5327),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5329),
    [anon_sym_BQUOTE] = ACTIONS(5331),
    [anon_sym_LT_LPAREN] = ACTIONS(5333),
    [anon_sym_GT_LPAREN] = ACTIONS(5333),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(5325),
    [sym_regex] = ACTIONS(5335),
  },
  [2131] = {
    [sym_concatenation] = STATE(511),
    [sym_string] = STATE(2342),
    [sym_simple_expansion] = STATE(2342),
    [sym_string_expansion] = STATE(2342),
    [sym_expansion] = STATE(2342),
    [sym_command_substitution] = STATE(2342),
    [sym_process_substitution] = STATE(2342),
    [sym__special_characters] = ACTIONS(5337),
    [anon_sym_DQUOTE] = ACTIONS(5339),
    [anon_sym_DOLLAR] = ACTIONS(5341),
    [sym_raw_string] = ACTIONS(5343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5347),
    [anon_sym_BQUOTE] = ACTIONS(5349),
    [anon_sym_LT_LPAREN] = ACTIONS(5351),
    [anon_sym_GT_LPAREN] = ACTIONS(5351),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5343),
  },
  [2132] = {
    [sym_concatenation] = STATE(515),
    [sym_string] = STATE(2348),
    [sym_simple_expansion] = STATE(2348),
    [sym_string_expansion] = STATE(2348),
    [sym_expansion] = STATE(2348),
    [sym_command_substitution] = STATE(2348),
    [sym_process_substitution] = STATE(2348),
    [sym__special_characters] = ACTIONS(5353),
    [anon_sym_DQUOTE] = ACTIONS(5339),
    [anon_sym_DOLLAR] = ACTIONS(5341),
    [sym_raw_string] = ACTIONS(5355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5347),
    [anon_sym_BQUOTE] = ACTIONS(5349),
    [anon_sym_LT_LPAREN] = ACTIONS(5351),
    [anon_sym_GT_LPAREN] = ACTIONS(5351),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5355),
  },
  [2133] = {
    [aux_sym_concatenation_repeat1] = STATE(2104),
    [sym__simple_heredoc_body] = ACTIONS(949),
    [sym__heredoc_body_beginning] = ACTIONS(949),
    [sym_file_descriptor] = ACTIONS(949),
    [sym__concat] = ACTIONS(4869),
    [anon_sym_SEMI] = ACTIONS(951),
    [anon_sym_esac] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(951),
    [anon_sym_SEMI_SEMI] = ACTIONS(949),
    [anon_sym_PIPE_AMP] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(949),
    [anon_sym_EQ_TILDE] = ACTIONS(951),
    [anon_sym_EQ_EQ] = ACTIONS(951),
    [anon_sym_LT] = ACTIONS(951),
    [anon_sym_GT] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(949),
    [anon_sym_AMP_GT] = ACTIONS(951),
    [anon_sym_AMP_GT_GT] = ACTIONS(949),
    [anon_sym_LT_AMP] = ACTIONS(949),
    [anon_sym_GT_AMP] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(951),
    [anon_sym_LT_LT_DASH] = ACTIONS(949),
    [anon_sym_LT_LT_LT] = ACTIONS(949),
    [sym__special_characters] = ACTIONS(949),
    [anon_sym_DQUOTE] = ACTIONS(949),
    [anon_sym_DOLLAR] = ACTIONS(951),
    [sym_raw_string] = ACTIONS(949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(949),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(949),
    [anon_sym_BQUOTE] = ACTIONS(949),
    [anon_sym_LT_LPAREN] = ACTIONS(949),
    [anon_sym_GT_LPAREN] = ACTIONS(949),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(951),
    [anon_sym_LF] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
  },
  [2134] = {
    [aux_sym_concatenation_repeat1] = STATE(2104),
    [sym__simple_heredoc_body] = ACTIONS(953),
    [sym__heredoc_body_beginning] = ACTIONS(953),
    [sym_file_descriptor] = ACTIONS(953),
    [sym__concat] = ACTIONS(4869),
    [anon_sym_SEMI] = ACTIONS(955),
    [anon_sym_esac] = ACTIONS(955),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_SEMI_SEMI] = ACTIONS(953),
    [anon_sym_PIPE_AMP] = ACTIONS(953),
    [anon_sym_AMP_AMP] = ACTIONS(953),
    [anon_sym_PIPE_PIPE] = ACTIONS(953),
    [anon_sym_EQ_TILDE] = ACTIONS(955),
    [anon_sym_EQ_EQ] = ACTIONS(955),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_GT] = ACTIONS(955),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_AMP_GT] = ACTIONS(955),
    [anon_sym_AMP_GT_GT] = ACTIONS(953),
    [anon_sym_LT_AMP] = ACTIONS(953),
    [anon_sym_GT_AMP] = ACTIONS(953),
    [anon_sym_LT_LT] = ACTIONS(955),
    [anon_sym_LT_LT_DASH] = ACTIONS(953),
    [anon_sym_LT_LT_LT] = ACTIONS(953),
    [sym__special_characters] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_DOLLAR] = ACTIONS(955),
    [sym_raw_string] = ACTIONS(953),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(953),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_BQUOTE] = ACTIONS(953),
    [anon_sym_LT_LPAREN] = ACTIONS(953),
    [anon_sym_GT_LPAREN] = ACTIONS(953),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(955),
    [anon_sym_LF] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(955),
  },
  [2135] = {
    [sym_file_redirect] = STATE(2349),
    [sym_heredoc_redirect] = STATE(2349),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(2349),
    [aux_sym_while_statement_repeat1] = STATE(2349),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(4909),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_esac] = ACTIONS(957),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(4913),
    [anon_sym_GT] = ACTIONS(4913),
    [anon_sym_GT_GT] = ACTIONS(4915),
    [anon_sym_AMP_GT] = ACTIONS(4913),
    [anon_sym_AMP_GT_GT] = ACTIONS(4915),
    [anon_sym_LT_AMP] = ACTIONS(4915),
    [anon_sym_GT_AMP] = ACTIONS(4915),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(4917),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [2136] = {
    [sym_file_redirect] = STATE(2350),
    [sym_heredoc_redirect] = STATE(2350),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(2350),
    [sym_concatenation] = STATE(2351),
    [sym_string] = STATE(2134),
    [sym_simple_expansion] = STATE(2134),
    [sym_string_expansion] = STATE(2134),
    [sym_expansion] = STATE(2134),
    [sym_command_substitution] = STATE(2134),
    [sym_process_substitution] = STATE(2134),
    [aux_sym_while_statement_repeat1] = STATE(2350),
    [aux_sym_command_repeat2] = STATE(2351),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(4909),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_esac] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(4911),
    [anon_sym_EQ_EQ] = ACTIONS(4911),
    [anon_sym_LT] = ACTIONS(4913),
    [anon_sym_GT] = ACTIONS(4913),
    [anon_sym_GT_GT] = ACTIONS(4915),
    [anon_sym_AMP_GT] = ACTIONS(4913),
    [anon_sym_AMP_GT_GT] = ACTIONS(4915),
    [anon_sym_LT_AMP] = ACTIONS(4915),
    [anon_sym_GT_AMP] = ACTIONS(4915),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(4917),
    [sym__special_characters] = ACTIONS(4919),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4923),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [2137] = {
    [anon_sym_esac] = ACTIONS(5311),
    [sym__special_characters] = ACTIONS(5315),
    [anon_sym_DQUOTE] = ACTIONS(5315),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [sym_raw_string] = ACTIONS(5315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5315),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5315),
    [anon_sym_BQUOTE] = ACTIONS(5315),
    [anon_sym_LT_LPAREN] = ACTIONS(5315),
    [anon_sym_GT_LPAREN] = ACTIONS(5315),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5313),
  },
  [2138] = {
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_esac] = ACTIONS(5357),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(5359),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2139] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_esac] = ACTIONS(5311),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(5359),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2140] = {
    [sym__terminated_statement] = STATE(2140),
    [sym_for_statement] = STATE(2353),
    [sym_c_style_for_statement] = STATE(2353),
    [sym_while_statement] = STATE(2353),
    [sym_if_statement] = STATE(2353),
    [sym_case_statement] = STATE(2353),
    [sym_function_definition] = STATE(2353),
    [sym_subshell] = STATE(2353),
    [sym_pipeline] = STATE(2353),
    [sym_list] = STATE(2353),
    [sym_negated_command] = STATE(2353),
    [sym_test_command] = STATE(2353),
    [sym_declaration_command] = STATE(2353),
    [sym_unset_command] = STATE(2353),
    [sym_command] = STATE(2353),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(2354),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2140),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(968),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_esac] = ACTIONS(3449),
    [anon_sym_SEMI_SEMI] = ACTIONS(3528),
    [anon_sym_function] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(998),
    [anon_sym_typeset] = ACTIONS(998),
    [anon_sym_export] = ACTIONS(998),
    [anon_sym_readonly] = ACTIONS(998),
    [anon_sym_local] = ACTIONS(998),
    [anon_sym_unset] = ACTIONS(1001),
    [anon_sym_unsetenv] = ACTIONS(1001),
    [anon_sym_LT] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_AMP_GT] = ACTIONS(1004),
    [anon_sym_AMP_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_AMP] = ACTIONS(1007),
    [anon_sym_GT_AMP] = ACTIONS(1007),
    [sym__special_characters] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1013),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1022),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1025),
    [anon_sym_BQUOTE] = ACTIONS(1028),
    [anon_sym_LT_LPAREN] = ACTIONS(1031),
    [anon_sym_GT_LPAREN] = ACTIONS(1031),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1034),
  },
  [2141] = {
    [sym_file_redirect] = STATE(2350),
    [sym_heredoc_redirect] = STATE(2350),
    [sym_heredoc_body] = STATE(516),
    [sym_herestring_redirect] = STATE(2350),
    [sym_concatenation] = STATE(2355),
    [sym_string] = STATE(2134),
    [sym_simple_expansion] = STATE(2134),
    [sym_string_expansion] = STATE(2134),
    [sym_expansion] = STATE(2134),
    [sym_command_substitution] = STATE(2134),
    [sym_process_substitution] = STATE(2134),
    [aux_sym_while_statement_repeat1] = STATE(2350),
    [aux_sym_command_repeat2] = STATE(2355),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(4909),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_esac] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_EQ_TILDE] = ACTIONS(4911),
    [anon_sym_EQ_EQ] = ACTIONS(4911),
    [anon_sym_LT] = ACTIONS(4913),
    [anon_sym_GT] = ACTIONS(4913),
    [anon_sym_GT_GT] = ACTIONS(4915),
    [anon_sym_AMP_GT] = ACTIONS(4913),
    [anon_sym_AMP_GT_GT] = ACTIONS(4915),
    [anon_sym_LT_AMP] = ACTIONS(4915),
    [anon_sym_GT_AMP] = ACTIONS(4915),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(4917),
    [sym__special_characters] = ACTIONS(4919),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4923),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [2142] = {
    [sym__terminated_statement] = STATE(2140),
    [sym_for_statement] = STATE(2357),
    [sym_c_style_for_statement] = STATE(2357),
    [sym_while_statement] = STATE(2357),
    [sym_if_statement] = STATE(2357),
    [sym_case_statement] = STATE(2357),
    [sym_function_definition] = STATE(2357),
    [sym_subshell] = STATE(2357),
    [sym_pipeline] = STATE(2357),
    [sym_list] = STATE(2357),
    [sym_negated_command] = STATE(2357),
    [sym_test_command] = STATE(2357),
    [sym_declaration_command] = STATE(2357),
    [sym_unset_command] = STATE(2357),
    [sym_command] = STATE(2357),
    [sym_command_name] = STATE(1867),
    [sym_variable_assignment] = STATE(2358),
    [sym_subscript] = STATE(1869),
    [sym_file_redirect] = STATE(1872),
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_string_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [aux_sym__statements_repeat1] = STATE(2140),
    [aux_sym_command_repeat1] = STATE(1872),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4245),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5311),
    [anon_sym_SEMI_SEMI] = ACTIONS(5361),
    [anon_sym_function] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(4257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4259),
    [anon_sym_declare] = ACTIONS(4261),
    [anon_sym_typeset] = ACTIONS(4261),
    [anon_sym_export] = ACTIONS(4261),
    [anon_sym_readonly] = ACTIONS(4261),
    [anon_sym_local] = ACTIONS(4261),
    [anon_sym_unset] = ACTIONS(4263),
    [anon_sym_unsetenv] = ACTIONS(4263),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4265),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4281),
  },
  [2143] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_esac] = ACTIONS(5363),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(5365),
    [anon_sym_DQUOTE] = ACTIONS(5367),
    [anon_sym_DOLLAR] = ACTIONS(5365),
    [sym_raw_string] = ACTIONS(5367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5367),
    [anon_sym_BQUOTE] = ACTIONS(5367),
    [anon_sym_LT_LPAREN] = ACTIONS(5367),
    [anon_sym_GT_LPAREN] = ACTIONS(5367),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5365),
  },
  [2144] = {
    [anon_sym_esac] = ACTIONS(5363),
    [sym__special_characters] = ACTIONS(5367),
    [anon_sym_DQUOTE] = ACTIONS(5367),
    [anon_sym_DOLLAR] = ACTIONS(5365),
    [sym_raw_string] = ACTIONS(5367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5367),
    [anon_sym_BQUOTE] = ACTIONS(5367),
    [anon_sym_LT_LPAREN] = ACTIONS(5367),
    [anon_sym_GT_LPAREN] = ACTIONS(5367),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5365),
  },
  [2145] = {
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_esac] = ACTIONS(5369),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(5371),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2146] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_esac] = ACTIONS(5363),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(5371),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2147] = {
    [sym__terminated_statement] = STATE(2140),
    [sym_for_statement] = STATE(2361),
    [sym_c_style_for_statement] = STATE(2361),
    [sym_while_statement] = STATE(2361),
    [sym_if_statement] = STATE(2361),
    [sym_case_statement] = STATE(2361),
    [sym_function_definition] = STATE(2361),
    [sym_subshell] = STATE(2361),
    [sym_pipeline] = STATE(2361),
    [sym_list] = STATE(2361),
    [sym_negated_command] = STATE(2361),
    [sym_test_command] = STATE(2361),
    [sym_declaration_command] = STATE(2361),
    [sym_unset_command] = STATE(2361),
    [sym_command] = STATE(2361),
    [sym_command_name] = STATE(1867),
    [sym_variable_assignment] = STATE(2362),
    [sym_subscript] = STATE(1869),
    [sym_file_redirect] = STATE(1872),
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(1860),
    [sym_simple_expansion] = STATE(1860),
    [sym_string_expansion] = STATE(1860),
    [sym_expansion] = STATE(1860),
    [sym_command_substitution] = STATE(1860),
    [sym_process_substitution] = STATE(1860),
    [aux_sym__statements_repeat1] = STATE(2140),
    [aux_sym_command_repeat1] = STATE(1872),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(4245),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(4247),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_esac] = ACTIONS(5363),
    [anon_sym_SEMI_SEMI] = ACTIONS(5373),
    [anon_sym_function] = ACTIONS(4253),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(4255),
    [anon_sym_LBRACK] = ACTIONS(4257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4259),
    [anon_sym_declare] = ACTIONS(4261),
    [anon_sym_typeset] = ACTIONS(4261),
    [anon_sym_export] = ACTIONS(4261),
    [anon_sym_readonly] = ACTIONS(4261),
    [anon_sym_local] = ACTIONS(4261),
    [anon_sym_unset] = ACTIONS(4263),
    [anon_sym_unsetenv] = ACTIONS(4263),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(4265),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4281),
  },
  [2148] = {
    [sym__terminated_statement] = STATE(2366),
    [sym_for_statement] = STATE(2364),
    [sym_c_style_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_if_statement] = STATE(2364),
    [sym_case_statement] = STATE(2364),
    [sym_function_definition] = STATE(2364),
    [sym_subshell] = STATE(2364),
    [sym_pipeline] = STATE(2364),
    [sym_list] = STATE(2364),
    [sym_negated_command] = STATE(2364),
    [sym_test_command] = STATE(2364),
    [sym_declaration_command] = STATE(2364),
    [sym_unset_command] = STATE(2364),
    [sym_command] = STATE(2364),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(2365),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2366),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5375),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [2149] = {
    [aux_sym_case_item_repeat1] = STATE(1874),
    [anon_sym_PIPE] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(5377),
    [sym_comment] = ACTIONS(53),
  },
  [2150] = {
    [sym__terminated_statement] = STATE(2371),
    [sym_for_statement] = STATE(2369),
    [sym_c_style_for_statement] = STATE(2369),
    [sym_while_statement] = STATE(2369),
    [sym_if_statement] = STATE(2369),
    [sym_case_statement] = STATE(2369),
    [sym_function_definition] = STATE(2369),
    [sym_subshell] = STATE(2369),
    [sym_pipeline] = STATE(2369),
    [sym_list] = STATE(2369),
    [sym_negated_command] = STATE(2369),
    [sym_test_command] = STATE(2369),
    [sym_declaration_command] = STATE(2369),
    [sym_unset_command] = STATE(2369),
    [sym_command] = STATE(2369),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(2370),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2371),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5379),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [2151] = {
    [aux_sym_case_item_repeat1] = STATE(1874),
    [anon_sym_PIPE] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(5381),
    [sym_comment] = ACTIONS(53),
  },
  [2152] = {
    [ts_builtin_sym_end] = ACTIONS(5383),
    [anon_sym_SEMI] = ACTIONS(5385),
    [anon_sym_esac] = ACTIONS(5383),
    [anon_sym_PIPE] = ACTIONS(5385),
    [anon_sym_RPAREN] = ACTIONS(5383),
    [anon_sym_SEMI_SEMI] = ACTIONS(5383),
    [anon_sym_PIPE_AMP] = ACTIONS(5383),
    [anon_sym_AMP_AMP] = ACTIONS(5383),
    [anon_sym_PIPE_PIPE] = ACTIONS(5383),
    [anon_sym_BQUOTE] = ACTIONS(5383),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5383),
    [anon_sym_AMP] = ACTIONS(5385),
  },
  [2153] = {
    [ts_builtin_sym_end] = ACTIONS(5387),
    [anon_sym_SEMI] = ACTIONS(5389),
    [anon_sym_esac] = ACTIONS(5387),
    [anon_sym_PIPE] = ACTIONS(5389),
    [anon_sym_RPAREN] = ACTIONS(5387),
    [anon_sym_SEMI_SEMI] = ACTIONS(5387),
    [anon_sym_PIPE_AMP] = ACTIONS(5387),
    [anon_sym_AMP_AMP] = ACTIONS(5387),
    [anon_sym_PIPE_PIPE] = ACTIONS(5387),
    [anon_sym_BQUOTE] = ACTIONS(5387),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5387),
    [anon_sym_AMP] = ACTIONS(5389),
  },
  [2154] = {
    [sym__concat] = ACTIONS(5069),
    [anon_sym_in] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5069),
  },
  [2155] = {
    [sym__concat] = ACTIONS(5073),
    [anon_sym_in] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5073),
  },
  [2156] = {
    [aux_sym_concatenation_repeat1] = STATE(2156),
    [sym__concat] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2157] = {
    [aux_sym_concatenation_repeat1] = STATE(2157),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(4968),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2158] = {
    [sym__concat] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [anon_sym_RBRACK] = ACTIONS(5069),
    [anon_sym_EQ_TILDE] = ACTIONS(5069),
    [anon_sym_EQ_EQ] = ACTIONS(5069),
    [anon_sym_EQ] = ACTIONS(5071),
    [anon_sym_LT] = ACTIONS(5069),
    [anon_sym_GT] = ACTIONS(5069),
    [anon_sym_BANG_EQ] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5069),
  },
  [2159] = {
    [sym__concat] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [anon_sym_RBRACK] = ACTIONS(5073),
    [anon_sym_EQ_TILDE] = ACTIONS(5073),
    [anon_sym_EQ_EQ] = ACTIONS(5073),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_LT] = ACTIONS(5073),
    [anon_sym_GT] = ACTIONS(5073),
    [anon_sym_BANG_EQ] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5073),
  },
  [2160] = {
    [sym_file_descriptor] = ACTIONS(2876),
    [sym__concat] = ACTIONS(2876),
    [ts_builtin_sym_end] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_esac] = ACTIONS(2876),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_RPAREN] = ACTIONS(2876),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [anon_sym_LT] = ACTIONS(2878),
    [anon_sym_GT] = ACTIONS(2878),
    [anon_sym_GT_GT] = ACTIONS(2876),
    [anon_sym_AMP_GT] = ACTIONS(2878),
    [anon_sym_AMP_GT_GT] = ACTIONS(2876),
    [anon_sym_LT_AMP] = ACTIONS(2876),
    [anon_sym_GT_AMP] = ACTIONS(2876),
    [anon_sym_LT_LT] = ACTIONS(2878),
    [anon_sym_LT_LT_DASH] = ACTIONS(2876),
    [anon_sym_LT_LT_LT] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2878),
  },
  [2161] = {
    [sym_file_descriptor] = ACTIONS(2890),
    [sym__concat] = ACTIONS(2890),
    [ts_builtin_sym_end] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_esac] = ACTIONS(2890),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [anon_sym_PIPE_AMP] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2890),
    [anon_sym_AMP_GT] = ACTIONS(2892),
    [anon_sym_AMP_GT_GT] = ACTIONS(2890),
    [anon_sym_LT_AMP] = ACTIONS(2890),
    [anon_sym_GT_AMP] = ACTIONS(2890),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_LT_LT_DASH] = ACTIONS(2890),
    [anon_sym_LT_LT_LT] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2892),
  },
  [2162] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5391),
    [sym_comment] = ACTIONS(53),
  },
  [2163] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [sym_comment] = ACTIONS(53),
  },
  [2164] = {
    [anon_sym_RBRACE] = ACTIONS(5393),
    [sym_comment] = ACTIONS(53),
  },
  [2165] = {
    [sym_concatenation] = STATE(2377),
    [sym_string] = STATE(2376),
    [sym_simple_expansion] = STATE(2376),
    [sym_string_expansion] = STATE(2376),
    [sym_expansion] = STATE(2376),
    [sym_command_substitution] = STATE(2376),
    [sym_process_substitution] = STATE(2376),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [sym__special_characters] = ACTIONS(5395),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(5397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5397),
  },
  [2166] = {
    [sym_file_descriptor] = ACTIONS(2926),
    [sym__concat] = ACTIONS(2926),
    [ts_builtin_sym_end] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_esac] = ACTIONS(2926),
    [anon_sym_PIPE] = ACTIONS(2928),
    [anon_sym_RPAREN] = ACTIONS(2926),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE_AMP] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_GT] = ACTIONS(2928),
    [anon_sym_GT_GT] = ACTIONS(2926),
    [anon_sym_AMP_GT] = ACTIONS(2928),
    [anon_sym_AMP_GT_GT] = ACTIONS(2926),
    [anon_sym_LT_AMP] = ACTIONS(2926),
    [anon_sym_GT_AMP] = ACTIONS(2926),
    [anon_sym_LT_LT] = ACTIONS(2928),
    [anon_sym_LT_LT_DASH] = ACTIONS(2926),
    [anon_sym_LT_LT_LT] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2928),
  },
  [2167] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(5399),
  },
  [2168] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2169] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(5403),
  },
  [2170] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2171] = {
    [sym_concatenation] = STATE(2382),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2382),
    [anon_sym_RBRACE] = ACTIONS(5405),
    [anon_sym_EQ] = ACTIONS(5407),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5407),
    [anon_sym_COLON_QMARK] = ACTIONS(5407),
    [anon_sym_COLON_DASH] = ACTIONS(5407),
    [anon_sym_PERCENT] = ACTIONS(5407),
    [anon_sym_DASH] = ACTIONS(5407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2172] = {
    [sym_file_descriptor] = ACTIONS(2990),
    [sym__concat] = ACTIONS(2990),
    [ts_builtin_sym_end] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_esac] = ACTIONS(2990),
    [anon_sym_PIPE] = ACTIONS(2992),
    [anon_sym_RPAREN] = ACTIONS(2990),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [anon_sym_PIPE_AMP] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(2990),
    [anon_sym_AMP_GT] = ACTIONS(2992),
    [anon_sym_AMP_GT_GT] = ACTIONS(2990),
    [anon_sym_LT_AMP] = ACTIONS(2990),
    [anon_sym_GT_AMP] = ACTIONS(2990),
    [anon_sym_LT_LT] = ACTIONS(2992),
    [anon_sym_LT_LT_DASH] = ACTIONS(2990),
    [anon_sym_LT_LT_LT] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2992),
  },
  [2173] = {
    [sym_concatenation] = STATE(2383),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2383),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [anon_sym_EQ] = ACTIONS(5411),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5411),
    [anon_sym_COLON_QMARK] = ACTIONS(5411),
    [anon_sym_COLON_DASH] = ACTIONS(5411),
    [anon_sym_PERCENT] = ACTIONS(5411),
    [anon_sym_DASH] = ACTIONS(5411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2174] = {
    [sym_file_descriptor] = ACTIONS(3033),
    [sym__concat] = ACTIONS(3033),
    [ts_builtin_sym_end] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_esac] = ACTIONS(3033),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(3033),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [anon_sym_PIPE_AMP] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_GT_GT] = ACTIONS(3033),
    [anon_sym_AMP_GT] = ACTIONS(3035),
    [anon_sym_AMP_GT_GT] = ACTIONS(3033),
    [anon_sym_LT_AMP] = ACTIONS(3033),
    [anon_sym_GT_AMP] = ACTIONS(3033),
    [anon_sym_LT_LT] = ACTIONS(3035),
    [anon_sym_LT_LT_DASH] = ACTIONS(3033),
    [anon_sym_LT_LT_LT] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3035),
  },
  [2175] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(5415),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2176] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(5415),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2177] = {
    [sym_file_descriptor] = ACTIONS(3071),
    [sym__concat] = ACTIONS(3071),
    [ts_builtin_sym_end] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_esac] = ACTIONS(3071),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [anon_sym_PIPE_AMP] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_GT_GT] = ACTIONS(3071),
    [anon_sym_AMP_GT] = ACTIONS(3073),
    [anon_sym_AMP_GT_GT] = ACTIONS(3071),
    [anon_sym_LT_AMP] = ACTIONS(3071),
    [anon_sym_GT_AMP] = ACTIONS(3071),
    [anon_sym_LT_LT] = ACTIONS(3073),
    [anon_sym_LT_LT_DASH] = ACTIONS(3071),
    [anon_sym_LT_LT_LT] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
  },
  [2178] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(5417),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2179] = {
    [sym__concat] = ACTIONS(5069),
    [anon_sym_PIPE] = ACTIONS(5071),
    [anon_sym_RPAREN] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5069),
    [anon_sym_EQ_TILDE] = ACTIONS(5069),
    [anon_sym_EQ_EQ] = ACTIONS(5069),
    [anon_sym_EQ] = ACTIONS(5071),
    [anon_sym_LT] = ACTIONS(5069),
    [anon_sym_GT] = ACTIONS(5069),
    [anon_sym_BANG_EQ] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5069),
  },
  [2180] = {
    [sym__concat] = ACTIONS(5073),
    [anon_sym_PIPE] = ACTIONS(5075),
    [anon_sym_RPAREN] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5073),
    [anon_sym_EQ_TILDE] = ACTIONS(5073),
    [anon_sym_EQ_EQ] = ACTIONS(5073),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_LT] = ACTIONS(5073),
    [anon_sym_GT] = ACTIONS(5073),
    [anon_sym_BANG_EQ] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5073),
  },
  [2181] = {
    [sym__concat] = ACTIONS(5069),
    [sym_variable_name] = ACTIONS(5069),
    [ts_builtin_sym_end] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_PIPE] = ACTIONS(5071),
    [anon_sym_RPAREN] = ACTIONS(5069),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [anon_sym_PIPE_AMP] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [sym__special_characters] = ACTIONS(5069),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [anon_sym_LT_LPAREN] = ACTIONS(5069),
    [anon_sym_GT_LPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5071),
    [sym_word] = ACTIONS(5071),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5071),
  },
  [2182] = {
    [sym__concat] = ACTIONS(5073),
    [sym_variable_name] = ACTIONS(5073),
    [ts_builtin_sym_end] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_PIPE] = ACTIONS(5075),
    [anon_sym_RPAREN] = ACTIONS(5073),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [anon_sym_PIPE_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [sym__special_characters] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym_raw_string] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5075),
    [sym_word] = ACTIONS(5075),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5075),
  },
  [2183] = {
    [sym__concat] = ACTIONS(5069),
    [ts_builtin_sym_end] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_PIPE] = ACTIONS(5071),
    [anon_sym_RPAREN] = ACTIONS(5069),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [anon_sym_PIPE_AMP] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [sym__special_characters] = ACTIONS(5069),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [anon_sym_LT_LPAREN] = ACTIONS(5069),
    [anon_sym_GT_LPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5071),
    [sym_word] = ACTIONS(5071),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5071),
  },
  [2184] = {
    [sym__concat] = ACTIONS(5073),
    [ts_builtin_sym_end] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_PIPE] = ACTIONS(5075),
    [anon_sym_RPAREN] = ACTIONS(5073),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [anon_sym_PIPE_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [sym__special_characters] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym_raw_string] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5075),
    [sym_word] = ACTIONS(5075),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5075),
  },
  [2185] = {
    [sym_file_descriptor] = ACTIONS(5069),
    [sym__concat] = ACTIONS(5069),
    [sym_variable_name] = ACTIONS(5069),
    [anon_sym_LT] = ACTIONS(5071),
    [anon_sym_GT] = ACTIONS(5071),
    [anon_sym_GT_GT] = ACTIONS(5069),
    [anon_sym_AMP_GT] = ACTIONS(5071),
    [anon_sym_AMP_GT_GT] = ACTIONS(5069),
    [anon_sym_LT_AMP] = ACTIONS(5069),
    [anon_sym_GT_AMP] = ACTIONS(5069),
    [sym__special_characters] = ACTIONS(5069),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [anon_sym_LT_LPAREN] = ACTIONS(5069),
    [anon_sym_GT_LPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5069),
  },
  [2186] = {
    [sym_file_descriptor] = ACTIONS(5073),
    [sym__concat] = ACTIONS(5073),
    [sym_variable_name] = ACTIONS(5073),
    [anon_sym_LT] = ACTIONS(5075),
    [anon_sym_GT] = ACTIONS(5075),
    [anon_sym_GT_GT] = ACTIONS(5073),
    [anon_sym_AMP_GT] = ACTIONS(5075),
    [anon_sym_AMP_GT_GT] = ACTIONS(5073),
    [anon_sym_LT_AMP] = ACTIONS(5073),
    [anon_sym_GT_AMP] = ACTIONS(5073),
    [sym__special_characters] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym_raw_string] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5073),
  },
  [2187] = {
    [sym__concat] = ACTIONS(5069),
    [anon_sym_DQUOTE] = ACTIONS(5071),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym__string_content] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5071),
    [anon_sym_BQUOTE] = ACTIONS(5071),
    [sym_comment] = ACTIONS(265),
  },
  [2188] = {
    [sym__concat] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(5075),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym__string_content] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5075),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5075),
    [anon_sym_BQUOTE] = ACTIONS(5075),
    [sym_comment] = ACTIONS(265),
  },
  [2189] = {
    [sym__concat] = ACTIONS(3788),
    [anon_sym_RBRACE] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
  },
  [2190] = {
    [sym__concat] = ACTIONS(3796),
    [anon_sym_RBRACE] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
  },
  [2191] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [sym_comment] = ACTIONS(53),
  },
  [2192] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5421),
    [sym_comment] = ACTIONS(53),
  },
  [2193] = {
    [anon_sym_RBRACE] = ACTIONS(5421),
    [sym_comment] = ACTIONS(53),
  },
  [2194] = {
    [sym_concatenation] = STATE(2389),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2389),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5425),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5425),
    [anon_sym_COLON_QMARK] = ACTIONS(5425),
    [anon_sym_COLON_DASH] = ACTIONS(5425),
    [anon_sym_PERCENT] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(5425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2195] = {
    [sym__concat] = ACTIONS(3852),
    [anon_sym_RBRACE] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
  },
  [2196] = {
    [sym_concatenation] = STATE(2390),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2390),
    [anon_sym_RBRACE] = ACTIONS(5421),
    [anon_sym_EQ] = ACTIONS(5429),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5429),
    [anon_sym_COLON_QMARK] = ACTIONS(5429),
    [anon_sym_COLON_DASH] = ACTIONS(5429),
    [anon_sym_PERCENT] = ACTIONS(5429),
    [anon_sym_DASH] = ACTIONS(5429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2197] = {
    [sym__concat] = ACTIONS(3893),
    [anon_sym_RBRACE] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
  },
  [2198] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2199] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5421),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2200] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_RBRACE] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
  },
  [2201] = {
    [sym__concat] = ACTIONS(3939),
    [anon_sym_RBRACE] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
  },
  [2202] = {
    [sym__concat] = ACTIONS(4568),
    [anon_sym_RBRACE] = ACTIONS(4568),
    [anon_sym_EQ] = ACTIONS(4570),
    [sym__special_characters] = ACTIONS(4570),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_POUND] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [anon_sym_COLON] = ACTIONS(4570),
    [anon_sym_COLON_QMARK] = ACTIONS(4570),
    [anon_sym_COLON_DASH] = ACTIONS(4570),
    [anon_sym_PERCENT] = ACTIONS(4570),
    [anon_sym_DASH] = ACTIONS(4570),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_LT_LPAREN] = ACTIONS(4568),
    [anon_sym_GT_LPAREN] = ACTIONS(4568),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4570),
  },
  [2203] = {
    [sym__concat] = ACTIONS(4572),
    [anon_sym_RBRACE] = ACTIONS(4572),
    [anon_sym_EQ] = ACTIONS(4574),
    [sym__special_characters] = ACTIONS(4574),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_POUND] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [anon_sym_COLON] = ACTIONS(4574),
    [anon_sym_COLON_QMARK] = ACTIONS(4574),
    [anon_sym_COLON_DASH] = ACTIONS(4574),
    [anon_sym_PERCENT] = ACTIONS(4574),
    [anon_sym_DASH] = ACTIONS(4574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(4572),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4574),
  },
  [2204] = {
    [sym__concat] = ACTIONS(4576),
    [anon_sym_RBRACE] = ACTIONS(4576),
    [anon_sym_EQ] = ACTIONS(4578),
    [sym__special_characters] = ACTIONS(4578),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_POUND] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [anon_sym_COLON] = ACTIONS(4578),
    [anon_sym_COLON_QMARK] = ACTIONS(4578),
    [anon_sym_COLON_DASH] = ACTIONS(4578),
    [anon_sym_PERCENT] = ACTIONS(4578),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_LT_LPAREN] = ACTIONS(4576),
    [anon_sym_GT_LPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4578),
  },
  [2205] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2206] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5437),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2207] = {
    [sym__concat] = ACTIONS(4608),
    [anon_sym_RBRACE] = ACTIONS(4608),
    [anon_sym_EQ] = ACTIONS(4610),
    [sym__special_characters] = ACTIONS(4610),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4608),
    [anon_sym_POUND] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [anon_sym_COLON] = ACTIONS(4610),
    [anon_sym_COLON_QMARK] = ACTIONS(4610),
    [anon_sym_COLON_DASH] = ACTIONS(4610),
    [anon_sym_PERCENT] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4610),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_LT_LPAREN] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(4610),
  },
  [2208] = {
    [aux_sym_concatenation_repeat1] = STATE(2208),
    [sym__concat] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2209] = {
    [aux_sym_concatenation_repeat1] = STATE(2209),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(4968),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2210] = {
    [sym__heredoc_body_middle] = ACTIONS(4568),
    [sym__heredoc_body_end] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
  },
  [2211] = {
    [sym__heredoc_body_middle] = ACTIONS(4572),
    [sym__heredoc_body_end] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
  },
  [2212] = {
    [sym__heredoc_body_middle] = ACTIONS(4576),
    [sym__heredoc_body_end] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
  },
  [2213] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2214] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2215] = {
    [sym__heredoc_body_middle] = ACTIONS(4608),
    [sym__heredoc_body_end] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
  },
  [2216] = {
    [sym__concat] = ACTIONS(4568),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_LT_LPAREN] = ACTIONS(4568),
    [anon_sym_GT_LPAREN] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4568),
  },
  [2217] = {
    [sym__concat] = ACTIONS(4572),
    [anon_sym_RPAREN] = ACTIONS(4572),
    [sym__special_characters] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4572),
  },
  [2218] = {
    [sym__concat] = ACTIONS(4576),
    [anon_sym_RPAREN] = ACTIONS(4576),
    [sym__special_characters] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_LT_LPAREN] = ACTIONS(4576),
    [anon_sym_GT_LPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4576),
  },
  [2219] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2220] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2221] = {
    [sym__concat] = ACTIONS(4608),
    [anon_sym_RPAREN] = ACTIONS(4608),
    [sym__special_characters] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_LT_LPAREN] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4608),
  },
  [2222] = {
    [sym_file_descriptor] = ACTIONS(5069),
    [sym__concat] = ACTIONS(5069),
    [sym_variable_name] = ACTIONS(5069),
    [ts_builtin_sym_end] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_PIPE] = ACTIONS(5071),
    [anon_sym_RPAREN] = ACTIONS(5069),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [anon_sym_PIPE_AMP] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [anon_sym_LT] = ACTIONS(5071),
    [anon_sym_GT] = ACTIONS(5071),
    [anon_sym_GT_GT] = ACTIONS(5069),
    [anon_sym_AMP_GT] = ACTIONS(5071),
    [anon_sym_AMP_GT_GT] = ACTIONS(5069),
    [anon_sym_LT_AMP] = ACTIONS(5069),
    [anon_sym_GT_AMP] = ACTIONS(5069),
    [sym__special_characters] = ACTIONS(5069),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [anon_sym_LT_LPAREN] = ACTIONS(5069),
    [anon_sym_GT_LPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5071),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5071),
  },
  [2223] = {
    [sym_file_descriptor] = ACTIONS(5073),
    [sym__concat] = ACTIONS(5073),
    [sym_variable_name] = ACTIONS(5073),
    [ts_builtin_sym_end] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_PIPE] = ACTIONS(5075),
    [anon_sym_RPAREN] = ACTIONS(5073),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [anon_sym_PIPE_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [anon_sym_LT] = ACTIONS(5075),
    [anon_sym_GT] = ACTIONS(5075),
    [anon_sym_GT_GT] = ACTIONS(5073),
    [anon_sym_AMP_GT] = ACTIONS(5075),
    [anon_sym_AMP_GT_GT] = ACTIONS(5073),
    [anon_sym_LT_AMP] = ACTIONS(5073),
    [anon_sym_GT_AMP] = ACTIONS(5073),
    [sym__special_characters] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym_raw_string] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5075),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5075),
  },
  [2224] = {
    [sym__concat] = ACTIONS(3788),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_EQ_TILDE] = ACTIONS(3788),
    [anon_sym_EQ_EQ] = ACTIONS(3788),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_BANG_EQ] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3788),
  },
  [2225] = {
    [sym__concat] = ACTIONS(3796),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [anon_sym_EQ_TILDE] = ACTIONS(3796),
    [anon_sym_EQ_EQ] = ACTIONS(3796),
    [anon_sym_EQ] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3796),
    [anon_sym_GT] = ACTIONS(3796),
    [anon_sym_BANG_EQ] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3796),
  },
  [2226] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5447),
    [sym_comment] = ACTIONS(53),
  },
  [2227] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5449),
    [sym_comment] = ACTIONS(53),
  },
  [2228] = {
    [anon_sym_RBRACE] = ACTIONS(5449),
    [sym_comment] = ACTIONS(53),
  },
  [2229] = {
    [sym_concatenation] = STATE(2401),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2401),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5453),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5453),
    [anon_sym_COLON_QMARK] = ACTIONS(5453),
    [anon_sym_COLON_DASH] = ACTIONS(5453),
    [anon_sym_PERCENT] = ACTIONS(5453),
    [anon_sym_DASH] = ACTIONS(5453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2230] = {
    [sym__concat] = ACTIONS(3852),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3852),
    [anon_sym_EQ_EQ] = ACTIONS(3852),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3852),
    [anon_sym_GT] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3852),
  },
  [2231] = {
    [sym_concatenation] = STATE(2402),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2402),
    [anon_sym_RBRACE] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(5457),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5457),
    [anon_sym_COLON_QMARK] = ACTIONS(5457),
    [anon_sym_COLON_DASH] = ACTIONS(5457),
    [anon_sym_PERCENT] = ACTIONS(5457),
    [anon_sym_DASH] = ACTIONS(5457),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2232] = {
    [sym__concat] = ACTIONS(3893),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_EQ_TILDE] = ACTIONS(3893),
    [anon_sym_EQ_EQ] = ACTIONS(3893),
    [anon_sym_EQ] = ACTIONS(3895),
    [anon_sym_LT] = ACTIONS(3893),
    [anon_sym_GT] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3893),
  },
  [2233] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5461),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2234] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2235] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_EQ_TILDE] = ACTIONS(3915),
    [anon_sym_EQ_EQ] = ACTIONS(3915),
    [anon_sym_EQ] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_GT] = ACTIONS(3915),
    [anon_sym_BANG_EQ] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3915),
  },
  [2236] = {
    [sym__concat] = ACTIONS(3939),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_EQ_TILDE] = ACTIONS(3939),
    [anon_sym_EQ_EQ] = ACTIONS(3939),
    [anon_sym_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_GT] = ACTIONS(3939),
    [anon_sym_BANG_EQ] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(3939),
  },
  [2237] = {
    [ts_builtin_sym_end] = ACTIONS(5463),
    [anon_sym_SEMI] = ACTIONS(5465),
    [anon_sym_esac] = ACTIONS(5463),
    [anon_sym_PIPE] = ACTIONS(5465),
    [anon_sym_RPAREN] = ACTIONS(5463),
    [anon_sym_SEMI_SEMI] = ACTIONS(5463),
    [anon_sym_PIPE_AMP] = ACTIONS(5463),
    [anon_sym_AMP_AMP] = ACTIONS(5463),
    [anon_sym_PIPE_PIPE] = ACTIONS(5463),
    [anon_sym_BQUOTE] = ACTIONS(5463),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5463),
    [anon_sym_AMP] = ACTIONS(5465),
  },
  [2238] = {
    [sym__concat] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_esac] = ACTIONS(5069),
    [anon_sym_PIPE] = ACTIONS(5071),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [anon_sym_PIPE_AMP] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [anon_sym_EQ_TILDE] = ACTIONS(5069),
    [anon_sym_EQ_EQ] = ACTIONS(5069),
    [anon_sym_EQ] = ACTIONS(5071),
    [anon_sym_LT] = ACTIONS(5069),
    [anon_sym_GT] = ACTIONS(5069),
    [anon_sym_BANG_EQ] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5069),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5071),
  },
  [2239] = {
    [sym__concat] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_esac] = ACTIONS(5073),
    [anon_sym_PIPE] = ACTIONS(5075),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [anon_sym_PIPE_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [anon_sym_EQ_TILDE] = ACTIONS(5073),
    [anon_sym_EQ_EQ] = ACTIONS(5073),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_LT] = ACTIONS(5073),
    [anon_sym_GT] = ACTIONS(5073),
    [anon_sym_BANG_EQ] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5073),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5075),
  },
  [2240] = {
    [sym_do_group] = STATE(2404),
    [sym_compound_statement] = STATE(2404),
    [anon_sym_do] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [sym_comment] = ACTIONS(53),
  },
  [2241] = {
    [sym__concat] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_LT_LPAREN] = ACTIONS(4568),
    [anon_sym_GT_LPAREN] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4570),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
  },
  [2242] = {
    [sym__concat] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [sym__special_characters] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4574),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4572),
  },
  [2243] = {
    [sym__concat] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [sym__special_characters] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_LT_LPAREN] = ACTIONS(4576),
    [anon_sym_GT_LPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4578),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4576),
  },
  [2244] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5467),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2245] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5469),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2246] = {
    [sym__concat] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [sym__special_characters] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_LT_LPAREN] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4610),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4608),
  },
  [2247] = {
    [sym_file_descriptor] = ACTIONS(1071),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_esac] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [2248] = {
    [sym_concatenation] = STATE(2408),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_string_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [aux_sym_for_statement_repeat1] = STATE(2408),
    [anon_sym_RPAREN] = ACTIONS(5471),
    [sym__special_characters] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym_raw_string] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1083),
  },
  [2249] = {
    [aux_sym_concatenation_repeat1] = STATE(2410),
    [sym_file_descriptor] = ACTIONS(1093),
    [sym__concat] = ACTIONS(5473),
    [sym_variable_name] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_esac] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [2250] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(2413),
    [anon_sym_DQUOTE] = ACTIONS(5475),
    [anon_sym_DOLLAR] = ACTIONS(5477),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2251] = {
    [sym_string] = STATE(2415),
    [anon_sym_DQUOTE] = ACTIONS(5189),
    [anon_sym_DOLLAR] = ACTIONS(5479),
    [sym_raw_string] = ACTIONS(5481),
    [anon_sym_POUND] = ACTIONS(5479),
    [anon_sym_DASH] = ACTIONS(5479),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5483),
    [anon_sym_STAR] = ACTIONS(5485),
    [anon_sym_AT] = ACTIONS(5485),
    [anon_sym_QMARK] = ACTIONS(5485),
    [anon_sym_0] = ACTIONS(5483),
    [anon_sym__] = ACTIONS(5483),
  },
  [2252] = {
    [aux_sym_concatenation_repeat1] = STATE(2410),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(5473),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_esac] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [2253] = {
    [sym_subscript] = STATE(2420),
    [sym_variable_name] = ACTIONS(5487),
    [anon_sym_BANG] = ACTIONS(5489),
    [anon_sym_DOLLAR] = ACTIONS(5491),
    [anon_sym_POUND] = ACTIONS(5489),
    [anon_sym_DASH] = ACTIONS(5491),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5493),
    [anon_sym_STAR] = ACTIONS(5495),
    [anon_sym_AT] = ACTIONS(5495),
    [anon_sym_QMARK] = ACTIONS(5495),
    [anon_sym_0] = ACTIONS(5493),
    [anon_sym__] = ACTIONS(5493),
  },
  [2254] = {
    [sym__terminated_statement] = STATE(2423),
    [sym_for_statement] = STATE(2421),
    [sym_c_style_for_statement] = STATE(2421),
    [sym_while_statement] = STATE(2421),
    [sym_if_statement] = STATE(2421),
    [sym_case_statement] = STATE(2421),
    [sym_function_definition] = STATE(2421),
    [sym_subshell] = STATE(2421),
    [sym_pipeline] = STATE(2421),
    [sym_list] = STATE(2421),
    [sym_negated_command] = STATE(2421),
    [sym_test_command] = STATE(2421),
    [sym_declaration_command] = STATE(2421),
    [sym_unset_command] = STATE(2421),
    [sym_command] = STATE(2421),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2422),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(2423),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2255] = {
    [sym__terminated_statement] = STATE(2426),
    [sym_for_statement] = STATE(2424),
    [sym_c_style_for_statement] = STATE(2424),
    [sym_while_statement] = STATE(2424),
    [sym_if_statement] = STATE(2424),
    [sym_case_statement] = STATE(2424),
    [sym_function_definition] = STATE(2424),
    [sym_subshell] = STATE(2424),
    [sym_pipeline] = STATE(2424),
    [sym_list] = STATE(2424),
    [sym_negated_command] = STATE(2424),
    [sym_test_command] = STATE(2424),
    [sym_declaration_command] = STATE(2424),
    [sym_unset_command] = STATE(2424),
    [sym_command] = STATE(2424),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(2425),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2426),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [2256] = {
    [sym__terminated_statement] = STATE(2429),
    [sym_for_statement] = STATE(2427),
    [sym_c_style_for_statement] = STATE(2427),
    [sym_while_statement] = STATE(2427),
    [sym_if_statement] = STATE(2427),
    [sym_case_statement] = STATE(2427),
    [sym_function_definition] = STATE(2427),
    [sym_subshell] = STATE(2427),
    [sym_pipeline] = STATE(2427),
    [sym_list] = STATE(2427),
    [sym_negated_command] = STATE(2427),
    [sym_test_command] = STATE(2427),
    [sym_declaration_command] = STATE(2427),
    [sym_unset_command] = STATE(2427),
    [sym_command] = STATE(2427),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2428),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(2429),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2257] = {
    [sym_file_redirect] = STATE(2430),
    [sym_heredoc_redirect] = STATE(2430),
    [sym_heredoc_body] = STATE(615),
    [sym_herestring_redirect] = STATE(2430),
    [aux_sym_while_statement_repeat1] = STATE(2430),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(4909),
    [anon_sym_SEMI] = ACTIONS(1197),
    [anon_sym_esac] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1197),
    [anon_sym_SEMI_SEMI] = ACTIONS(1195),
    [anon_sym_PIPE_AMP] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(4913),
    [anon_sym_GT] = ACTIONS(4913),
    [anon_sym_GT_GT] = ACTIONS(4915),
    [anon_sym_AMP_GT] = ACTIONS(4913),
    [anon_sym_AMP_GT_GT] = ACTIONS(4915),
    [anon_sym_LT_AMP] = ACTIONS(4915),
    [anon_sym_GT_AMP] = ACTIONS(4915),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(4917),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1197),
  },
  [2258] = {
    [anon_sym_RPAREN] = ACTIONS(5497),
    [sym_comment] = ACTIONS(53),
  },
  [2259] = {
    [sym_file_redirect] = STATE(672),
    [sym_file_descriptor] = ACTIONS(5499),
    [anon_sym_SEMI] = ACTIONS(1289),
    [anon_sym_esac] = ACTIONS(1287),
    [anon_sym_PIPE] = ACTIONS(1289),
    [anon_sym_SEMI_SEMI] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_LT] = ACTIONS(5501),
    [anon_sym_GT] = ACTIONS(5501),
    [anon_sym_GT_GT] = ACTIONS(5503),
    [anon_sym_AMP_GT] = ACTIONS(5501),
    [anon_sym_AMP_GT_GT] = ACTIONS(5503),
    [anon_sym_LT_AMP] = ACTIONS(5503),
    [anon_sym_GT_AMP] = ACTIONS(5503),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1289),
  },
  [2260] = {
    [sym_file_redirect] = STATE(2437),
    [sym_heredoc_redirect] = STATE(2437),
    [sym_herestring_redirect] = STATE(2437),
    [aux_sym_while_statement_repeat1] = STATE(2437),
    [sym_file_descriptor] = ACTIONS(5505),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_esac] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_SEMI_SEMI] = ACTIONS(1405),
    [anon_sym_PIPE_AMP] = ACTIONS(1405),
    [anon_sym_AMP_AMP] = ACTIONS(1405),
    [anon_sym_PIPE_PIPE] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(5507),
    [anon_sym_GT] = ACTIONS(5507),
    [anon_sym_GT_GT] = ACTIONS(5509),
    [anon_sym_AMP_GT] = ACTIONS(5507),
    [anon_sym_AMP_GT_GT] = ACTIONS(5509),
    [anon_sym_LT_AMP] = ACTIONS(5509),
    [anon_sym_GT_AMP] = ACTIONS(5509),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_LT_LT_DASH] = ACTIONS(1415),
    [anon_sym_LT_LT_LT] = ACTIONS(5511),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1405),
    [anon_sym_AMP] = ACTIONS(1407),
  },
  [2261] = {
    [sym_concatenation] = STATE(2438),
    [sym_string] = STATE(2441),
    [sym_array] = STATE(2438),
    [sym_simple_expansion] = STATE(2441),
    [sym_string_expansion] = STATE(2441),
    [sym_expansion] = STATE(2441),
    [sym_command_substitution] = STATE(2441),
    [sym_process_substitution] = STATE(2441),
    [sym__empty_value] = ACTIONS(5513),
    [anon_sym_LPAREN] = ACTIONS(5515),
    [sym__special_characters] = ACTIONS(5517),
    [anon_sym_DQUOTE] = ACTIONS(4831),
    [anon_sym_DOLLAR] = ACTIONS(4833),
    [sym_raw_string] = ACTIONS(5519),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4839),
    [anon_sym_BQUOTE] = ACTIONS(4841),
    [anon_sym_LT_LPAREN] = ACTIONS(4843),
    [anon_sym_GT_LPAREN] = ACTIONS(4843),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5519),
  },
  [2262] = {
    [sym_string] = STATE(2442),
    [sym_simple_expansion] = STATE(2442),
    [sym_string_expansion] = STATE(2442),
    [sym_expansion] = STATE(2442),
    [sym_command_substitution] = STATE(2442),
    [sym_process_substitution] = STATE(2442),
    [sym__special_characters] = ACTIONS(5521),
    [anon_sym_DQUOTE] = ACTIONS(4831),
    [anon_sym_DOLLAR] = ACTIONS(4833),
    [sym_raw_string] = ACTIONS(5521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4839),
    [anon_sym_BQUOTE] = ACTIONS(4841),
    [anon_sym_LT_LPAREN] = ACTIONS(4843),
    [anon_sym_GT_LPAREN] = ACTIONS(4843),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5521),
  },
  [2263] = {
    [aux_sym_concatenation_repeat1] = STATE(2443),
    [sym__concat] = ACTIONS(5209),
    [sym_variable_name] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_esac] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(767),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [2264] = {
    [sym__concat] = ACTIONS(769),
    [sym_variable_name] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_esac] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [sym__special_characters] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(771),
    [sym_word] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [2265] = {
    [anon_sym_DQUOTE] = ACTIONS(5523),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [2266] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(5523),
    [anon_sym_DOLLAR] = ACTIONS(5525),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2267] = {
    [sym__concat] = ACTIONS(803),
    [sym_variable_name] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_esac] = ACTIONS(805),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [anon_sym_PIPE_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [sym__special_characters] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_raw_string] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(805),
    [sym_word] = ACTIONS(805),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(805),
  },
  [2268] = {
    [sym__concat] = ACTIONS(807),
    [sym_variable_name] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_esac] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [anon_sym_PIPE_AMP] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [sym__special_characters] = ACTIONS(807),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(807),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_LT_LPAREN] = ACTIONS(807),
    [anon_sym_GT_LPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(809),
    [sym_word] = ACTIONS(809),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(809),
  },
  [2269] = {
    [sym__concat] = ACTIONS(811),
    [sym_variable_name] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_esac] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [sym__special_characters] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_LT_LPAREN] = ACTIONS(811),
    [anon_sym_GT_LPAREN] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(813),
    [sym_word] = ACTIONS(813),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(813),
  },
  [2270] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(5527),
    [sym_comment] = ACTIONS(53),
  },
  [2271] = {
    [sym_subscript] = STATE(2449),
    [sym_variable_name] = ACTIONS(5529),
    [anon_sym_DOLLAR] = ACTIONS(5531),
    [anon_sym_DASH] = ACTIONS(5531),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5533),
    [anon_sym_STAR] = ACTIONS(5535),
    [anon_sym_AT] = ACTIONS(5535),
    [anon_sym_QMARK] = ACTIONS(5535),
    [anon_sym_0] = ACTIONS(5533),
    [anon_sym__] = ACTIONS(5533),
  },
  [2272] = {
    [sym_concatenation] = STATE(2452),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2452),
    [anon_sym_RBRACE] = ACTIONS(5537),
    [anon_sym_EQ] = ACTIONS(5539),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5541),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5543),
    [anon_sym_COLON] = ACTIONS(5539),
    [anon_sym_COLON_QMARK] = ACTIONS(5539),
    [anon_sym_COLON_DASH] = ACTIONS(5539),
    [anon_sym_PERCENT] = ACTIONS(5539),
    [anon_sym_DASH] = ACTIONS(5539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2273] = {
    [sym_concatenation] = STATE(2455),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2455),
    [anon_sym_RBRACE] = ACTIONS(5545),
    [anon_sym_EQ] = ACTIONS(5547),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5549),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5551),
    [anon_sym_COLON] = ACTIONS(5547),
    [anon_sym_COLON_QMARK] = ACTIONS(5547),
    [anon_sym_COLON_DASH] = ACTIONS(5547),
    [anon_sym_PERCENT] = ACTIONS(5547),
    [anon_sym_DASH] = ACTIONS(5547),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2274] = {
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5555),
    [anon_sym_SEMI_SEMI] = ACTIONS(5557),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5557),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [2275] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5555),
    [anon_sym_SEMI_SEMI] = ACTIONS(5557),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5557),
    [anon_sym_AMP] = ACTIONS(5553),
  },
  [2276] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2458),
    [sym_c_style_for_statement] = STATE(2458),
    [sym_while_statement] = STATE(2458),
    [sym_if_statement] = STATE(2458),
    [sym_case_statement] = STATE(2458),
    [sym_function_definition] = STATE(2458),
    [sym_subshell] = STATE(2458),
    [sym_pipeline] = STATE(2458),
    [sym_list] = STATE(2458),
    [sym_negated_command] = STATE(2458),
    [sym_test_command] = STATE(2458),
    [sym_declaration_command] = STATE(2458),
    [sym_unset_command] = STATE(2458),
    [sym_command] = STATE(2458),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2459),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2277] = {
    [anon_sym_SEMI] = ACTIONS(5559),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5561),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(5555),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5559),
  },
  [2278] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5559),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5561),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(5555),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5559),
  },
  [2279] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2461),
    [sym_c_style_for_statement] = STATE(2461),
    [sym_while_statement] = STATE(2461),
    [sym_if_statement] = STATE(2461),
    [sym_case_statement] = STATE(2461),
    [sym_function_definition] = STATE(2461),
    [sym_subshell] = STATE(2461),
    [sym_pipeline] = STATE(2461),
    [sym_list] = STATE(2461),
    [sym_negated_command] = STATE(2461),
    [sym_test_command] = STATE(2461),
    [sym_declaration_command] = STATE(2461),
    [sym_unset_command] = STATE(2461),
    [sym_command] = STATE(2461),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(2462),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [2280] = {
    [anon_sym_SEMI] = ACTIONS(5563),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5565),
    [anon_sym_SEMI_SEMI] = ACTIONS(5567),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5567),
    [anon_sym_AMP] = ACTIONS(5563),
  },
  [2281] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5563),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5565),
    [anon_sym_SEMI_SEMI] = ACTIONS(5567),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5567),
    [anon_sym_AMP] = ACTIONS(5563),
  },
  [2282] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2465),
    [sym_c_style_for_statement] = STATE(2465),
    [sym_while_statement] = STATE(2465),
    [sym_if_statement] = STATE(2465),
    [sym_case_statement] = STATE(2465),
    [sym_function_definition] = STATE(2465),
    [sym_subshell] = STATE(2465),
    [sym_pipeline] = STATE(2465),
    [sym_list] = STATE(2465),
    [sym_negated_command] = STATE(2465),
    [sym_test_command] = STATE(2465),
    [sym_declaration_command] = STATE(2465),
    [sym_unset_command] = STATE(2465),
    [sym_command] = STATE(2465),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2466),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2283] = {
    [sym_variable_assignment] = STATE(2283),
    [sym_subscript] = STATE(2092),
    [sym_concatenation] = STATE(2283),
    [sym_string] = STATE(2087),
    [sym_simple_expansion] = STATE(2087),
    [sym_string_expansion] = STATE(2087),
    [sym_expansion] = STATE(2087),
    [sym_command_substitution] = STATE(2087),
    [sym_process_substitution] = STATE(2087),
    [aux_sym_declaration_command_repeat1] = STATE(2283),
    [sym_variable_name] = ACTIONS(5569),
    [anon_sym_SEMI] = ACTIONS(1562),
    [anon_sym_esac] = ACTIONS(1562),
    [anon_sym_PIPE] = ACTIONS(1562),
    [anon_sym_SEMI_SEMI] = ACTIONS(1560),
    [anon_sym_PIPE_AMP] = ACTIONS(1560),
    [anon_sym_AMP_AMP] = ACTIONS(1560),
    [anon_sym_PIPE_PIPE] = ACTIONS(1560),
    [sym__special_characters] = ACTIONS(5572),
    [anon_sym_DQUOTE] = ACTIONS(5575),
    [anon_sym_DOLLAR] = ACTIONS(5578),
    [sym_raw_string] = ACTIONS(5581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5587),
    [anon_sym_BQUOTE] = ACTIONS(5590),
    [anon_sym_LT_LPAREN] = ACTIONS(5593),
    [anon_sym_GT_LPAREN] = ACTIONS(5593),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5596),
    [sym_word] = ACTIONS(5599),
    [anon_sym_LF] = ACTIONS(1560),
    [anon_sym_AMP] = ACTIONS(1562),
  },
  [2284] = {
    [sym_string] = STATE(2467),
    [sym_simple_expansion] = STATE(2467),
    [sym_string_expansion] = STATE(2467),
    [sym_expansion] = STATE(2467),
    [sym_command_substitution] = STATE(2467),
    [sym_process_substitution] = STATE(2467),
    [sym__special_characters] = ACTIONS(5602),
    [anon_sym_DQUOTE] = ACTIONS(4851),
    [anon_sym_DOLLAR] = ACTIONS(4853),
    [sym_raw_string] = ACTIONS(5602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4859),
    [anon_sym_BQUOTE] = ACTIONS(4861),
    [anon_sym_LT_LPAREN] = ACTIONS(4863),
    [anon_sym_GT_LPAREN] = ACTIONS(4863),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5602),
  },
  [2285] = {
    [aux_sym_concatenation_repeat1] = STATE(2468),
    [sym__concat] = ACTIONS(5235),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_esac] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(767),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [2286] = {
    [sym__concat] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_esac] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [sym__special_characters] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(771),
    [sym_word] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [2287] = {
    [anon_sym_DQUOTE] = ACTIONS(5604),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [2288] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(5604),
    [anon_sym_DOLLAR] = ACTIONS(5606),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2289] = {
    [sym__concat] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_esac] = ACTIONS(805),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [anon_sym_PIPE_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [sym__special_characters] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_raw_string] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(805),
    [sym_word] = ACTIONS(805),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(805),
  },
  [2290] = {
    [sym__concat] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_esac] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [anon_sym_PIPE_AMP] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [sym__special_characters] = ACTIONS(807),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(807),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_LT_LPAREN] = ACTIONS(807),
    [anon_sym_GT_LPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(809),
    [sym_word] = ACTIONS(809),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(809),
  },
  [2291] = {
    [sym__concat] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_esac] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [sym__special_characters] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_LT_LPAREN] = ACTIONS(811),
    [anon_sym_GT_LPAREN] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(813),
    [sym_word] = ACTIONS(813),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(813),
  },
  [2292] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(5608),
    [sym_comment] = ACTIONS(53),
  },
  [2293] = {
    [sym_subscript] = STATE(2474),
    [sym_variable_name] = ACTIONS(5610),
    [anon_sym_DOLLAR] = ACTIONS(5612),
    [anon_sym_DASH] = ACTIONS(5612),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5614),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_AT] = ACTIONS(5616),
    [anon_sym_QMARK] = ACTIONS(5616),
    [anon_sym_0] = ACTIONS(5614),
    [anon_sym__] = ACTIONS(5614),
  },
  [2294] = {
    [sym_concatenation] = STATE(2477),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2477),
    [anon_sym_RBRACE] = ACTIONS(5618),
    [anon_sym_EQ] = ACTIONS(5620),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5622),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5624),
    [anon_sym_COLON] = ACTIONS(5620),
    [anon_sym_COLON_QMARK] = ACTIONS(5620),
    [anon_sym_COLON_DASH] = ACTIONS(5620),
    [anon_sym_PERCENT] = ACTIONS(5620),
    [anon_sym_DASH] = ACTIONS(5620),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2295] = {
    [sym_concatenation] = STATE(2480),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2480),
    [anon_sym_RBRACE] = ACTIONS(5626),
    [anon_sym_EQ] = ACTIONS(5628),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5630),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5632),
    [anon_sym_COLON] = ACTIONS(5628),
    [anon_sym_COLON_QMARK] = ACTIONS(5628),
    [anon_sym_COLON_DASH] = ACTIONS(5628),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_DASH] = ACTIONS(5628),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2296] = {
    [anon_sym_SEMI] = ACTIONS(5634),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5636),
    [anon_sym_SEMI_SEMI] = ACTIONS(5638),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5638),
    [anon_sym_AMP] = ACTIONS(5634),
  },
  [2297] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5634),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5636),
    [anon_sym_SEMI_SEMI] = ACTIONS(5638),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5638),
    [anon_sym_AMP] = ACTIONS(5634),
  },
  [2298] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2483),
    [sym_c_style_for_statement] = STATE(2483),
    [sym_while_statement] = STATE(2483),
    [sym_if_statement] = STATE(2483),
    [sym_case_statement] = STATE(2483),
    [sym_function_definition] = STATE(2483),
    [sym_subshell] = STATE(2483),
    [sym_pipeline] = STATE(2483),
    [sym_list] = STATE(2483),
    [sym_negated_command] = STATE(2483),
    [sym_test_command] = STATE(2483),
    [sym_declaration_command] = STATE(2483),
    [sym_unset_command] = STATE(2483),
    [sym_command] = STATE(2483),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2484),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2299] = {
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(5636),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5642),
    [anon_sym_AMP] = ACTIONS(5640),
  },
  [2300] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5642),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(5636),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5642),
    [anon_sym_AMP] = ACTIONS(5640),
  },
  [2301] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2486),
    [sym_c_style_for_statement] = STATE(2486),
    [sym_while_statement] = STATE(2486),
    [sym_if_statement] = STATE(2486),
    [sym_case_statement] = STATE(2486),
    [sym_function_definition] = STATE(2486),
    [sym_subshell] = STATE(2486),
    [sym_pipeline] = STATE(2486),
    [sym_list] = STATE(2486),
    [sym_negated_command] = STATE(2486),
    [sym_test_command] = STATE(2486),
    [sym_declaration_command] = STATE(2486),
    [sym_unset_command] = STATE(2486),
    [sym_command] = STATE(2486),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(2487),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [2302] = {
    [anon_sym_SEMI] = ACTIONS(5644),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5646),
    [anon_sym_SEMI_SEMI] = ACTIONS(5648),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5648),
    [anon_sym_AMP] = ACTIONS(5644),
  },
  [2303] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5644),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5646),
    [anon_sym_SEMI_SEMI] = ACTIONS(5648),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5648),
    [anon_sym_AMP] = ACTIONS(5644),
  },
  [2304] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2490),
    [sym_c_style_for_statement] = STATE(2490),
    [sym_while_statement] = STATE(2490),
    [sym_if_statement] = STATE(2490),
    [sym_case_statement] = STATE(2490),
    [sym_function_definition] = STATE(2490),
    [sym_subshell] = STATE(2490),
    [sym_pipeline] = STATE(2490),
    [sym_list] = STATE(2490),
    [sym_negated_command] = STATE(2490),
    [sym_test_command] = STATE(2490),
    [sym_declaration_command] = STATE(2490),
    [sym_unset_command] = STATE(2490),
    [sym_command] = STATE(2490),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2491),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2305] = {
    [sym_concatenation] = STATE(2305),
    [sym_string] = STATE(2097),
    [sym_simple_expansion] = STATE(2097),
    [sym_string_expansion] = STATE(2097),
    [sym_expansion] = STATE(2097),
    [sym_command_substitution] = STATE(2097),
    [sym_process_substitution] = STATE(2097),
    [aux_sym_unset_command_repeat1] = STATE(2305),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_esac] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1642),
    [anon_sym_PIPE_AMP] = ACTIONS(1642),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [sym__special_characters] = ACTIONS(5650),
    [anon_sym_DQUOTE] = ACTIONS(5653),
    [anon_sym_DOLLAR] = ACTIONS(5656),
    [sym_raw_string] = ACTIONS(5659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5665),
    [anon_sym_BQUOTE] = ACTIONS(5668),
    [anon_sym_LT_LPAREN] = ACTIONS(5671),
    [anon_sym_GT_LPAREN] = ACTIONS(5671),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5674),
    [sym_word] = ACTIONS(5677),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [2306] = {
    [sym__simple_heredoc_body] = ACTIONS(1724),
    [sym__heredoc_body_beginning] = ACTIONS(1724),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2307] = {
    [aux_sym_concatenation_repeat1] = STATE(2307),
    [sym__simple_heredoc_body] = ACTIONS(1724),
    [sym__heredoc_body_beginning] = ACTIONS(1724),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(5680),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_EQ_TILDE] = ACTIONS(1726),
    [anon_sym_EQ_EQ] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2308] = {
    [sym__simple_heredoc_body] = ACTIONS(1731),
    [sym__heredoc_body_beginning] = ACTIONS(1731),
    [sym_file_descriptor] = ACTIONS(1731),
    [sym__concat] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_esac] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [anon_sym_PIPE_AMP] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [anon_sym_EQ_TILDE] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1731),
    [anon_sym_AMP_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT_GT] = ACTIONS(1731),
    [anon_sym_LT_AMP] = ACTIONS(1731),
    [anon_sym_GT_AMP] = ACTIONS(1731),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_LT_LT_DASH] = ACTIONS(1731),
    [anon_sym_LT_LT_LT] = ACTIONS(1731),
    [sym__special_characters] = ACTIONS(1731),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1731),
    [anon_sym_GT_LPAREN] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1733),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [2309] = {
    [anon_sym_DQUOTE] = ACTIONS(5683),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [2310] = {
    [sym_concatenation] = STATE(2496),
    [sym_string] = STATE(2495),
    [sym_simple_expansion] = STATE(2495),
    [sym_string_expansion] = STATE(2495),
    [sym_expansion] = STATE(2495),
    [sym_command_substitution] = STATE(2495),
    [sym_process_substitution] = STATE(2495),
    [anon_sym_RBRACE] = ACTIONS(5685),
    [sym__special_characters] = ACTIONS(5687),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(5689),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5689),
  },
  [2311] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(5691),
    [sym_comment] = ACTIONS(53),
  },
  [2312] = {
    [sym_concatenation] = STATE(2500),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2500),
    [anon_sym_RBRACE] = ACTIONS(5693),
    [anon_sym_EQ] = ACTIONS(5695),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5699),
    [anon_sym_COLON] = ACTIONS(5695),
    [anon_sym_COLON_QMARK] = ACTIONS(5695),
    [anon_sym_COLON_DASH] = ACTIONS(5695),
    [anon_sym_PERCENT] = ACTIONS(5695),
    [anon_sym_DASH] = ACTIONS(5695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2313] = {
    [sym_concatenation] = STATE(2502),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2502),
    [anon_sym_RBRACE] = ACTIONS(5685),
    [anon_sym_EQ] = ACTIONS(5701),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5703),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5705),
    [anon_sym_COLON] = ACTIONS(5701),
    [anon_sym_COLON_QMARK] = ACTIONS(5701),
    [anon_sym_COLON_DASH] = ACTIONS(5701),
    [anon_sym_PERCENT] = ACTIONS(5701),
    [anon_sym_DASH] = ACTIONS(5701),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2314] = {
    [sym__simple_heredoc_body] = ACTIONS(1832),
    [sym__heredoc_body_beginning] = ACTIONS(1832),
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_esac] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_EQ_TILDE] = ACTIONS(1834),
    [anon_sym_EQ_EQ] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [anon_sym_LT_LT] = ACTIONS(1834),
    [anon_sym_LT_LT_DASH] = ACTIONS(1832),
    [anon_sym_LT_LT_LT] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [2315] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(5707),
  },
  [2316] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5709),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2317] = {
    [sym__simple_heredoc_body] = ACTIONS(1876),
    [sym__heredoc_body_beginning] = ACTIONS(1876),
    [sym_file_descriptor] = ACTIONS(1876),
    [sym__concat] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [anon_sym_PIPE_AMP] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [anon_sym_EQ_TILDE] = ACTIONS(1878),
    [anon_sym_EQ_EQ] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_GT_GT] = ACTIONS(1876),
    [anon_sym_AMP_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT_GT] = ACTIONS(1876),
    [anon_sym_LT_AMP] = ACTIONS(1876),
    [anon_sym_GT_AMP] = ACTIONS(1876),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [anon_sym_LT_LT_DASH] = ACTIONS(1876),
    [anon_sym_LT_LT_LT] = ACTIONS(1876),
    [sym__special_characters] = ACTIONS(1876),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [anon_sym_LT_LPAREN] = ACTIONS(1876),
    [anon_sym_GT_LPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [2318] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(5711),
  },
  [2319] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5685),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2320] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(5713),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2321] = {
    [sym__simple_heredoc_body] = ACTIONS(1884),
    [sym__heredoc_body_beginning] = ACTIONS(1884),
    [sym_file_descriptor] = ACTIONS(1884),
    [sym__concat] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_esac] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [anon_sym_EQ_TILDE] = ACTIONS(1886),
    [anon_sym_EQ_EQ] = ACTIONS(1886),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_GT] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT] = ACTIONS(1886),
    [anon_sym_AMP_GT_GT] = ACTIONS(1884),
    [anon_sym_LT_AMP] = ACTIONS(1884),
    [anon_sym_GT_AMP] = ACTIONS(1884),
    [anon_sym_LT_LT] = ACTIONS(1886),
    [anon_sym_LT_LT_DASH] = ACTIONS(1884),
    [anon_sym_LT_LT_LT] = ACTIONS(1884),
    [sym__special_characters] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym_raw_string] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(1884),
    [anon_sym_GT_LPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [2322] = {
    [anon_sym_SEMI] = ACTIONS(5715),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5713),
    [anon_sym_SEMI_SEMI] = ACTIONS(5717),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5717),
    [anon_sym_AMP] = ACTIONS(5715),
  },
  [2323] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5715),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5713),
    [anon_sym_SEMI_SEMI] = ACTIONS(5717),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5717),
    [anon_sym_AMP] = ACTIONS(5715),
  },
  [2324] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(5713),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2325] = {
    [anon_sym_SEMI] = ACTIONS(5719),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5721),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(5713),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5721),
    [anon_sym_AMP] = ACTIONS(5719),
  },
  [2326] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5719),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5721),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(5713),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5721),
    [anon_sym_AMP] = ACTIONS(5719),
  },
  [2327] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(5723),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2328] = {
    [sym__simple_heredoc_body] = ACTIONS(1916),
    [sym__heredoc_body_beginning] = ACTIONS(1916),
    [sym_file_descriptor] = ACTIONS(1916),
    [sym__concat] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_esac] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [anon_sym_EQ_TILDE] = ACTIONS(1918),
    [anon_sym_EQ_EQ] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1916),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT_GT] = ACTIONS(1916),
    [anon_sym_LT_AMP] = ACTIONS(1916),
    [anon_sym_GT_AMP] = ACTIONS(1916),
    [anon_sym_LT_LT] = ACTIONS(1918),
    [anon_sym_LT_LT_DASH] = ACTIONS(1916),
    [anon_sym_LT_LT_LT] = ACTIONS(1916),
    [sym__special_characters] = ACTIONS(1916),
    [anon_sym_DQUOTE] = ACTIONS(1916),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1916),
    [anon_sym_GT_LPAREN] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [2329] = {
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5723),
    [anon_sym_SEMI_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5727),
    [anon_sym_AMP] = ACTIONS(5725),
  },
  [2330] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5723),
    [anon_sym_SEMI_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5727),
    [anon_sym_AMP] = ACTIONS(5725),
  },
  [2331] = {
    [sym_compound_statement] = STATE(2511),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [2332] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_esac] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1926),
  },
  [2333] = {
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_esac] = ACTIONS(1928),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [2334] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_esac] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [2335] = {
    [sym_concatenation] = STATE(945),
    [sym_string] = STATE(2513),
    [sym_simple_expansion] = STATE(2513),
    [sym_string_expansion] = STATE(2513),
    [sym_expansion] = STATE(2513),
    [sym_command_substitution] = STATE(2513),
    [sym_process_substitution] = STATE(2513),
    [sym__special_characters] = ACTIONS(5729),
    [anon_sym_DQUOTE] = ACTIONS(5339),
    [anon_sym_DOLLAR] = ACTIONS(5341),
    [sym_raw_string] = ACTIONS(5731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5347),
    [anon_sym_BQUOTE] = ACTIONS(5349),
    [anon_sym_LT_LPAREN] = ACTIONS(5351),
    [anon_sym_GT_LPAREN] = ACTIONS(5351),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5731),
  },
  [2336] = {
    [aux_sym_concatenation_repeat1] = STATE(2104),
    [sym__simple_heredoc_body] = ACTIONS(1960),
    [sym__heredoc_body_beginning] = ACTIONS(1960),
    [sym_file_descriptor] = ACTIONS(1960),
    [sym__concat] = ACTIONS(4869),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_esac] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1962),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [anon_sym_EQ_TILDE] = ACTIONS(1962),
    [anon_sym_EQ_EQ] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1962),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1962),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1962),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [sym__special_characters] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1962),
    [sym_raw_string] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1962),
    [anon_sym_LF] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1962),
  },
  [2337] = {
    [aux_sym_concatenation_repeat1] = STATE(2104),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [sym__concat] = ACTIONS(4869),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_esac] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_EQ_TILDE] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1966),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1966),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [2338] = {
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_esac] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_EQ_TILDE] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1966),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1966),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [2339] = {
    [aux_sym_concatenation_repeat1] = STATE(2515),
    [sym__simple_heredoc_body] = ACTIONS(731),
    [sym__heredoc_body_beginning] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(5733),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [2340] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(2518),
    [anon_sym_DQUOTE] = ACTIONS(5735),
    [anon_sym_DOLLAR] = ACTIONS(5737),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2341] = {
    [sym_string] = STATE(2520),
    [anon_sym_DQUOTE] = ACTIONS(5339),
    [anon_sym_DOLLAR] = ACTIONS(5739),
    [sym_raw_string] = ACTIONS(5741),
    [anon_sym_POUND] = ACTIONS(5739),
    [anon_sym_DASH] = ACTIONS(5739),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5743),
    [anon_sym_STAR] = ACTIONS(5745),
    [anon_sym_AT] = ACTIONS(5745),
    [anon_sym_QMARK] = ACTIONS(5745),
    [anon_sym_0] = ACTIONS(5743),
    [anon_sym__] = ACTIONS(5743),
  },
  [2342] = {
    [aux_sym_concatenation_repeat1] = STATE(2515),
    [sym__simple_heredoc_body] = ACTIONS(749),
    [sym__heredoc_body_beginning] = ACTIONS(749),
    [sym_file_descriptor] = ACTIONS(749),
    [sym__concat] = ACTIONS(5733),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_esac] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_LT_LT_DASH] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [2343] = {
    [sym_subscript] = STATE(2525),
    [sym_variable_name] = ACTIONS(5747),
    [anon_sym_BANG] = ACTIONS(5749),
    [anon_sym_DOLLAR] = ACTIONS(5751),
    [anon_sym_POUND] = ACTIONS(5749),
    [anon_sym_DASH] = ACTIONS(5751),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5753),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_AT] = ACTIONS(5755),
    [anon_sym_QMARK] = ACTIONS(5755),
    [anon_sym_0] = ACTIONS(5753),
    [anon_sym__] = ACTIONS(5753),
  },
  [2344] = {
    [sym__terminated_statement] = STATE(2528),
    [sym_for_statement] = STATE(2526),
    [sym_c_style_for_statement] = STATE(2526),
    [sym_while_statement] = STATE(2526),
    [sym_if_statement] = STATE(2526),
    [sym_case_statement] = STATE(2526),
    [sym_function_definition] = STATE(2526),
    [sym_subshell] = STATE(2526),
    [sym_pipeline] = STATE(2526),
    [sym_list] = STATE(2526),
    [sym_negated_command] = STATE(2526),
    [sym_test_command] = STATE(2526),
    [sym_declaration_command] = STATE(2526),
    [sym_unset_command] = STATE(2526),
    [sym_command] = STATE(2526),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2527),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(2528),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2345] = {
    [sym__terminated_statement] = STATE(2531),
    [sym_for_statement] = STATE(2529),
    [sym_c_style_for_statement] = STATE(2529),
    [sym_while_statement] = STATE(2529),
    [sym_if_statement] = STATE(2529),
    [sym_case_statement] = STATE(2529),
    [sym_function_definition] = STATE(2529),
    [sym_subshell] = STATE(2529),
    [sym_pipeline] = STATE(2529),
    [sym_list] = STATE(2529),
    [sym_negated_command] = STATE(2529),
    [sym_test_command] = STATE(2529),
    [sym_declaration_command] = STATE(2529),
    [sym_unset_command] = STATE(2529),
    [sym_command] = STATE(2529),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(2530),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2531),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [2346] = {
    [sym__terminated_statement] = STATE(2534),
    [sym_for_statement] = STATE(2532),
    [sym_c_style_for_statement] = STATE(2532),
    [sym_while_statement] = STATE(2532),
    [sym_if_statement] = STATE(2532),
    [sym_case_statement] = STATE(2532),
    [sym_function_definition] = STATE(2532),
    [sym_subshell] = STATE(2532),
    [sym_pipeline] = STATE(2532),
    [sym_list] = STATE(2532),
    [sym_negated_command] = STATE(2532),
    [sym_test_command] = STATE(2532),
    [sym_declaration_command] = STATE(2532),
    [sym_unset_command] = STATE(2532),
    [sym_command] = STATE(2532),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2533),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(2534),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2347] = {
    [aux_sym_concatenation_repeat1] = STATE(2515),
    [sym__simple_heredoc_body] = ACTIONS(1972),
    [sym__heredoc_body_beginning] = ACTIONS(1972),
    [sym_file_descriptor] = ACTIONS(1972),
    [sym__concat] = ACTIONS(5733),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_esac] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_PIPE_AMP] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_PIPE_PIPE] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_AMP_GT] = ACTIONS(1974),
    [anon_sym_AMP_GT_GT] = ACTIONS(1972),
    [anon_sym_LT_AMP] = ACTIONS(1972),
    [anon_sym_GT_AMP] = ACTIONS(1972),
    [anon_sym_LT_LT] = ACTIONS(1974),
    [anon_sym_LT_LT_DASH] = ACTIONS(1972),
    [anon_sym_LT_LT_LT] = ACTIONS(1972),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1974),
  },
  [2348] = {
    [aux_sym_concatenation_repeat1] = STATE(2515),
    [sym__simple_heredoc_body] = ACTIONS(1976),
    [sym__heredoc_body_beginning] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(5733),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_esac] = ACTIONS(1976),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [2349] = {
    [sym_file_redirect] = STATE(2349),
    [sym_heredoc_redirect] = STATE(2349),
    [sym_herestring_redirect] = STATE(2349),
    [aux_sym_while_statement_repeat1] = STATE(2349),
    [sym__simple_heredoc_body] = ACTIONS(1984),
    [sym__heredoc_body_beginning] = ACTIONS(1984),
    [sym_file_descriptor] = ACTIONS(5757),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_esac] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(5760),
    [anon_sym_GT] = ACTIONS(5760),
    [anon_sym_GT_GT] = ACTIONS(5763),
    [anon_sym_AMP_GT] = ACTIONS(5760),
    [anon_sym_AMP_GT_GT] = ACTIONS(5763),
    [anon_sym_LT_AMP] = ACTIONS(5763),
    [anon_sym_GT_AMP] = ACTIONS(5763),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_LT_LT_DASH] = ACTIONS(2000),
    [anon_sym_LT_LT_LT] = ACTIONS(5766),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1989),
  },
  [2350] = {
    [sym_file_redirect] = STATE(2349),
    [sym_heredoc_redirect] = STATE(2349),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(2349),
    [aux_sym_while_statement_repeat1] = STATE(2349),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(4909),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_esac] = ACTIONS(1980),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(4913),
    [anon_sym_GT] = ACTIONS(4913),
    [anon_sym_GT_GT] = ACTIONS(4915),
    [anon_sym_AMP_GT] = ACTIONS(4913),
    [anon_sym_AMP_GT_GT] = ACTIONS(4915),
    [anon_sym_LT_AMP] = ACTIONS(4915),
    [anon_sym_GT_AMP] = ACTIONS(4915),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(4917),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [2351] = {
    [sym_concatenation] = STATE(2351),
    [sym_string] = STATE(2134),
    [sym_simple_expansion] = STATE(2134),
    [sym_string_expansion] = STATE(2134),
    [sym_expansion] = STATE(2134),
    [sym_command_substitution] = STATE(2134),
    [sym_process_substitution] = STATE(2134),
    [aux_sym_command_repeat2] = STATE(2351),
    [sym__simple_heredoc_body] = ACTIONS(1964),
    [sym__heredoc_body_beginning] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_esac] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_SEMI_SEMI] = ACTIONS(1964),
    [anon_sym_PIPE_AMP] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_EQ_TILDE] = ACTIONS(5769),
    [anon_sym_EQ_EQ] = ACTIONS(5769),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT_LT_DASH] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(1964),
    [sym__special_characters] = ACTIONS(5772),
    [anon_sym_DQUOTE] = ACTIONS(5775),
    [anon_sym_DOLLAR] = ACTIONS(5778),
    [sym_raw_string] = ACTIONS(5781),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5784),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5787),
    [anon_sym_BQUOTE] = ACTIONS(5790),
    [anon_sym_LT_LPAREN] = ACTIONS(5793),
    [anon_sym_GT_LPAREN] = ACTIONS(5793),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5796),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1966),
  },
  [2352] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_esac] = ACTIONS(5799),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(5801),
    [anon_sym_DQUOTE] = ACTIONS(5803),
    [anon_sym_DOLLAR] = ACTIONS(5801),
    [sym_raw_string] = ACTIONS(5803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5803),
    [anon_sym_BQUOTE] = ACTIONS(5803),
    [anon_sym_LT_LPAREN] = ACTIONS(5803),
    [anon_sym_GT_LPAREN] = ACTIONS(5803),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5801),
  },
  [2353] = {
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(4907),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2354] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(4907),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2355] = {
    [sym_file_redirect] = STATE(2535),
    [sym_heredoc_redirect] = STATE(2535),
    [sym_heredoc_body] = STATE(947),
    [sym_herestring_redirect] = STATE(2535),
    [sym_concatenation] = STATE(2351),
    [sym_string] = STATE(2134),
    [sym_simple_expansion] = STATE(2134),
    [sym_string_expansion] = STATE(2134),
    [sym_expansion] = STATE(2134),
    [sym_command_substitution] = STATE(2134),
    [sym_process_substitution] = STATE(2134),
    [aux_sym_while_statement_repeat1] = STATE(2535),
    [aux_sym_command_repeat2] = STATE(2351),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(4909),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_esac] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_SEMI_SEMI] = ACTIONS(1980),
    [anon_sym_PIPE_AMP] = ACTIONS(1980),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_EQ_TILDE] = ACTIONS(4911),
    [anon_sym_EQ_EQ] = ACTIONS(4911),
    [anon_sym_LT] = ACTIONS(4913),
    [anon_sym_GT] = ACTIONS(4913),
    [anon_sym_GT_GT] = ACTIONS(4915),
    [anon_sym_AMP_GT] = ACTIONS(4913),
    [anon_sym_AMP_GT_GT] = ACTIONS(4915),
    [anon_sym_LT_AMP] = ACTIONS(4915),
    [anon_sym_GT_AMP] = ACTIONS(4915),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(4917),
    [sym__special_characters] = ACTIONS(4919),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [anon_sym_DOLLAR] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(4921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4275),
    [anon_sym_BQUOTE] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(4279),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4923),
    [anon_sym_LF] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1982),
  },
  [2356] = {
    [anon_sym_esac] = ACTIONS(5799),
    [sym__special_characters] = ACTIONS(5803),
    [anon_sym_DQUOTE] = ACTIONS(5803),
    [anon_sym_DOLLAR] = ACTIONS(5801),
    [sym_raw_string] = ACTIONS(5803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5803),
    [anon_sym_BQUOTE] = ACTIONS(5803),
    [anon_sym_LT_LPAREN] = ACTIONS(5803),
    [anon_sym_GT_LPAREN] = ACTIONS(5803),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5801),
  },
  [2357] = {
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_esac] = ACTIONS(5805),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(5807),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2358] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_esac] = ACTIONS(5799),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(5807),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2359] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_esac] = ACTIONS(5809),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(5811),
    [anon_sym_DQUOTE] = ACTIONS(5813),
    [anon_sym_DOLLAR] = ACTIONS(5811),
    [sym_raw_string] = ACTIONS(5813),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5813),
    [anon_sym_BQUOTE] = ACTIONS(5813),
    [anon_sym_LT_LPAREN] = ACTIONS(5813),
    [anon_sym_GT_LPAREN] = ACTIONS(5813),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5811),
  },
  [2360] = {
    [anon_sym_esac] = ACTIONS(5809),
    [sym__special_characters] = ACTIONS(5813),
    [anon_sym_DQUOTE] = ACTIONS(5813),
    [anon_sym_DOLLAR] = ACTIONS(5811),
    [sym_raw_string] = ACTIONS(5813),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5813),
    [anon_sym_BQUOTE] = ACTIONS(5813),
    [anon_sym_LT_LPAREN] = ACTIONS(5813),
    [anon_sym_GT_LPAREN] = ACTIONS(5813),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5811),
  },
  [2361] = {
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_esac] = ACTIONS(5815),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(5817),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2362] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym_esac] = ACTIONS(5809),
    [anon_sym_PIPE] = ACTIONS(4899),
    [anon_sym_SEMI_SEMI] = ACTIONS(5817),
    [anon_sym_PIPE_AMP] = ACTIONS(4903),
    [anon_sym_AMP_AMP] = ACTIONS(4905),
    [anon_sym_PIPE_PIPE] = ACTIONS(4905),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(4907),
    [anon_sym_AMP] = ACTIONS(4895),
  },
  [2363] = {
    [sym__special_characters] = ACTIONS(4821),
    [anon_sym_DQUOTE] = ACTIONS(4821),
    [anon_sym_DOLLAR] = ACTIONS(4823),
    [sym_raw_string] = ACTIONS(4821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4821),
    [anon_sym_BQUOTE] = ACTIONS(4821),
    [anon_sym_LT_LPAREN] = ACTIONS(4821),
    [anon_sym_GT_LPAREN] = ACTIONS(4821),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4821),
  },
  [2364] = {
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(5819),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [2365] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(5819),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [2366] = {
    [sym__terminated_statement] = STATE(2542),
    [sym_for_statement] = STATE(2540),
    [sym_c_style_for_statement] = STATE(2540),
    [sym_while_statement] = STATE(2540),
    [sym_if_statement] = STATE(2540),
    [sym_case_statement] = STATE(2540),
    [sym_function_definition] = STATE(2540),
    [sym_subshell] = STATE(2540),
    [sym_pipeline] = STATE(2540),
    [sym_list] = STATE(2540),
    [sym_negated_command] = STATE(2540),
    [sym_test_command] = STATE(2540),
    [sym_declaration_command] = STATE(2540),
    [sym_unset_command] = STATE(2540),
    [sym_command] = STATE(2540),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(2541),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2542),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5821),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [2367] = {
    [sym__terminated_statement] = STATE(2543),
    [sym_for_statement] = STATE(2540),
    [sym_c_style_for_statement] = STATE(2540),
    [sym_while_statement] = STATE(2540),
    [sym_if_statement] = STATE(2540),
    [sym_case_statement] = STATE(2540),
    [sym_function_definition] = STATE(2540),
    [sym_subshell] = STATE(2540),
    [sym_pipeline] = STATE(2540),
    [sym_list] = STATE(2540),
    [sym_negated_command] = STATE(2540),
    [sym_test_command] = STATE(2540),
    [sym_declaration_command] = STATE(2540),
    [sym_unset_command] = STATE(2540),
    [sym_command] = STATE(2540),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(2541),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2543),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5821),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [2368] = {
    [sym__special_characters] = ACTIONS(4934),
    [anon_sym_DQUOTE] = ACTIONS(4934),
    [anon_sym_DOLLAR] = ACTIONS(4936),
    [sym_raw_string] = ACTIONS(4934),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4934),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4934),
    [anon_sym_BQUOTE] = ACTIONS(4934),
    [anon_sym_LT_LPAREN] = ACTIONS(4934),
    [anon_sym_GT_LPAREN] = ACTIONS(4934),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4934),
  },
  [2369] = {
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(5823),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [2370] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(5823),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [2371] = {
    [sym__terminated_statement] = STATE(2542),
    [sym_for_statement] = STATE(2546),
    [sym_c_style_for_statement] = STATE(2546),
    [sym_while_statement] = STATE(2546),
    [sym_if_statement] = STATE(2546),
    [sym_case_statement] = STATE(2546),
    [sym_function_definition] = STATE(2546),
    [sym_subshell] = STATE(2546),
    [sym_pipeline] = STATE(2546),
    [sym_list] = STATE(2546),
    [sym_negated_command] = STATE(2546),
    [sym_test_command] = STATE(2546),
    [sym_declaration_command] = STATE(2546),
    [sym_unset_command] = STATE(2546),
    [sym_command] = STATE(2546),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(2547),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2542),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5825),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [2372] = {
    [sym__terminated_statement] = STATE(2548),
    [sym_for_statement] = STATE(2546),
    [sym_c_style_for_statement] = STATE(2546),
    [sym_while_statement] = STATE(2546),
    [sym_if_statement] = STATE(2546),
    [sym_case_statement] = STATE(2546),
    [sym_function_definition] = STATE(2546),
    [sym_subshell] = STATE(2546),
    [sym_pipeline] = STATE(2546),
    [sym_list] = STATE(2546),
    [sym_negated_command] = STATE(2546),
    [sym_test_command] = STATE(2546),
    [sym_declaration_command] = STATE(2546),
    [sym_unset_command] = STATE(2546),
    [sym_command] = STATE(2546),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(2547),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2548),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(5825),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [2373] = {
    [sym_file_descriptor] = ACTIONS(3788),
    [sym__concat] = ACTIONS(3788),
    [ts_builtin_sym_end] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_esac] = ACTIONS(3788),
    [anon_sym_PIPE] = ACTIONS(3790),
    [anon_sym_RPAREN] = ACTIONS(3788),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [anon_sym_PIPE_AMP] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3790),
    [anon_sym_GT] = ACTIONS(3790),
    [anon_sym_GT_GT] = ACTIONS(3788),
    [anon_sym_AMP_GT] = ACTIONS(3790),
    [anon_sym_AMP_GT_GT] = ACTIONS(3788),
    [anon_sym_LT_AMP] = ACTIONS(3788),
    [anon_sym_GT_AMP] = ACTIONS(3788),
    [anon_sym_LT_LT] = ACTIONS(3790),
    [anon_sym_LT_LT_DASH] = ACTIONS(3788),
    [anon_sym_LT_LT_LT] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3790),
  },
  [2374] = {
    [sym_file_descriptor] = ACTIONS(3796),
    [sym__concat] = ACTIONS(3796),
    [ts_builtin_sym_end] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_esac] = ACTIONS(3796),
    [anon_sym_PIPE] = ACTIONS(3798),
    [anon_sym_RPAREN] = ACTIONS(3796),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [anon_sym_PIPE_AMP] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_GT] = ACTIONS(3798),
    [anon_sym_GT_GT] = ACTIONS(3796),
    [anon_sym_AMP_GT] = ACTIONS(3798),
    [anon_sym_AMP_GT_GT] = ACTIONS(3796),
    [anon_sym_LT_AMP] = ACTIONS(3796),
    [anon_sym_GT_AMP] = ACTIONS(3796),
    [anon_sym_LT_LT] = ACTIONS(3798),
    [anon_sym_LT_LT_DASH] = ACTIONS(3796),
    [anon_sym_LT_LT_LT] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3798),
  },
  [2375] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5827),
    [sym_comment] = ACTIONS(53),
  },
  [2376] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(5829),
    [sym_comment] = ACTIONS(53),
  },
  [2377] = {
    [anon_sym_RBRACE] = ACTIONS(5829),
    [sym_comment] = ACTIONS(53),
  },
  [2378] = {
    [sym_concatenation] = STATE(2552),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2552),
    [anon_sym_RBRACE] = ACTIONS(5831),
    [anon_sym_EQ] = ACTIONS(5833),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5833),
    [anon_sym_COLON_QMARK] = ACTIONS(5833),
    [anon_sym_COLON_DASH] = ACTIONS(5833),
    [anon_sym_PERCENT] = ACTIONS(5833),
    [anon_sym_DASH] = ACTIONS(5833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2379] = {
    [sym_file_descriptor] = ACTIONS(3852),
    [sym__concat] = ACTIONS(3852),
    [ts_builtin_sym_end] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_esac] = ACTIONS(3852),
    [anon_sym_PIPE] = ACTIONS(3854),
    [anon_sym_RPAREN] = ACTIONS(3852),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [anon_sym_PIPE_AMP] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_GT] = ACTIONS(3854),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_AMP_GT] = ACTIONS(3854),
    [anon_sym_AMP_GT_GT] = ACTIONS(3852),
    [anon_sym_LT_AMP] = ACTIONS(3852),
    [anon_sym_GT_AMP] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3854),
    [anon_sym_LT_LT_DASH] = ACTIONS(3852),
    [anon_sym_LT_LT_LT] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3854),
  },
  [2380] = {
    [sym_concatenation] = STATE(2553),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2553),
    [anon_sym_RBRACE] = ACTIONS(5829),
    [anon_sym_EQ] = ACTIONS(5837),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(5837),
    [anon_sym_COLON_QMARK] = ACTIONS(5837),
    [anon_sym_COLON_DASH] = ACTIONS(5837),
    [anon_sym_PERCENT] = ACTIONS(5837),
    [anon_sym_DASH] = ACTIONS(5837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2381] = {
    [sym_file_descriptor] = ACTIONS(3893),
    [sym__concat] = ACTIONS(3893),
    [ts_builtin_sym_end] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_esac] = ACTIONS(3893),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_RPAREN] = ACTIONS(3893),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [anon_sym_PIPE_AMP] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_GT_GT] = ACTIONS(3893),
    [anon_sym_AMP_GT] = ACTIONS(3895),
    [anon_sym_AMP_GT_GT] = ACTIONS(3893),
    [anon_sym_LT_AMP] = ACTIONS(3893),
    [anon_sym_GT_AMP] = ACTIONS(3893),
    [anon_sym_LT_LT] = ACTIONS(3895),
    [anon_sym_LT_LT_DASH] = ACTIONS(3893),
    [anon_sym_LT_LT_LT] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3895),
  },
  [2382] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5841),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2383] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5829),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2384] = {
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [ts_builtin_sym_end] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3915),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3915),
    [anon_sym_LT_AMP] = ACTIONS(3915),
    [anon_sym_GT_AMP] = ACTIONS(3915),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_LT_LT_DASH] = ACTIONS(3915),
    [anon_sym_LT_LT_LT] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [2385] = {
    [sym_file_descriptor] = ACTIONS(3939),
    [sym__concat] = ACTIONS(3939),
    [ts_builtin_sym_end] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_esac] = ACTIONS(3939),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_RPAREN] = ACTIONS(3939),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [anon_sym_PIPE_AMP] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3939),
    [anon_sym_AMP_GT] = ACTIONS(3941),
    [anon_sym_AMP_GT_GT] = ACTIONS(3939),
    [anon_sym_LT_AMP] = ACTIONS(3939),
    [anon_sym_GT_AMP] = ACTIONS(3939),
    [anon_sym_LT_LT] = ACTIONS(3941),
    [anon_sym_LT_LT_DASH] = ACTIONS(3939),
    [anon_sym_LT_LT_LT] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3941),
  },
  [2386] = {
    [sym__concat] = ACTIONS(4568),
    [anon_sym_RBRACE] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
  },
  [2387] = {
    [sym__concat] = ACTIONS(4572),
    [anon_sym_RBRACE] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
  },
  [2388] = {
    [sym__concat] = ACTIONS(4576),
    [anon_sym_RBRACE] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
  },
  [2389] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5843),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2390] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5845),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2391] = {
    [sym__concat] = ACTIONS(4608),
    [anon_sym_RBRACE] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
  },
  [2392] = {
    [sym__concat] = ACTIONS(5069),
    [anon_sym_RBRACE] = ACTIONS(5069),
    [anon_sym_EQ] = ACTIONS(5071),
    [sym__special_characters] = ACTIONS(5071),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5069),
    [anon_sym_POUND] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [anon_sym_COLON] = ACTIONS(5071),
    [anon_sym_COLON_QMARK] = ACTIONS(5071),
    [anon_sym_COLON_DASH] = ACTIONS(5071),
    [anon_sym_PERCENT] = ACTIONS(5071),
    [anon_sym_DASH] = ACTIONS(5071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [anon_sym_LT_LPAREN] = ACTIONS(5069),
    [anon_sym_GT_LPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(5071),
  },
  [2393] = {
    [sym__concat] = ACTIONS(5073),
    [anon_sym_RBRACE] = ACTIONS(5073),
    [anon_sym_EQ] = ACTIONS(5075),
    [sym__special_characters] = ACTIONS(5075),
    [anon_sym_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym_raw_string] = ACTIONS(5073),
    [anon_sym_POUND] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [anon_sym_COLON] = ACTIONS(5075),
    [anon_sym_COLON_QMARK] = ACTIONS(5075),
    [anon_sym_COLON_DASH] = ACTIONS(5075),
    [anon_sym_PERCENT] = ACTIONS(5075),
    [anon_sym_DASH] = ACTIONS(5075),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(5075),
  },
  [2394] = {
    [sym__heredoc_body_middle] = ACTIONS(5069),
    [sym__heredoc_body_end] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
  },
  [2395] = {
    [sym__heredoc_body_middle] = ACTIONS(5073),
    [sym__heredoc_body_end] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
  },
  [2396] = {
    [sym__concat] = ACTIONS(5069),
    [anon_sym_RPAREN] = ACTIONS(5069),
    [sym__special_characters] = ACTIONS(5069),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [anon_sym_LT_LPAREN] = ACTIONS(5069),
    [anon_sym_GT_LPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5069),
  },
  [2397] = {
    [sym__concat] = ACTIONS(5073),
    [anon_sym_RPAREN] = ACTIONS(5073),
    [sym__special_characters] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym_raw_string] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5073),
  },
  [2398] = {
    [sym__concat] = ACTIONS(4568),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_EQ_TILDE] = ACTIONS(4568),
    [anon_sym_EQ_EQ] = ACTIONS(4568),
    [anon_sym_EQ] = ACTIONS(4570),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_BANG_EQ] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4568),
  },
  [2399] = {
    [sym__concat] = ACTIONS(4572),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [anon_sym_EQ_TILDE] = ACTIONS(4572),
    [anon_sym_EQ_EQ] = ACTIONS(4572),
    [anon_sym_EQ] = ACTIONS(4574),
    [anon_sym_LT] = ACTIONS(4572),
    [anon_sym_GT] = ACTIONS(4572),
    [anon_sym_BANG_EQ] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4572),
  },
  [2400] = {
    [sym__concat] = ACTIONS(4576),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [anon_sym_EQ_TILDE] = ACTIONS(4576),
    [anon_sym_EQ_EQ] = ACTIONS(4576),
    [anon_sym_EQ] = ACTIONS(4578),
    [anon_sym_LT] = ACTIONS(4576),
    [anon_sym_GT] = ACTIONS(4576),
    [anon_sym_BANG_EQ] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4576),
  },
  [2401] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5847),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2402] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5849),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2403] = {
    [sym__concat] = ACTIONS(4608),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [anon_sym_EQ_TILDE] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4608),
    [anon_sym_EQ] = ACTIONS(4610),
    [anon_sym_LT] = ACTIONS(4608),
    [anon_sym_GT] = ACTIONS(4608),
    [anon_sym_BANG_EQ] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(4608),
  },
  [2404] = {
    [ts_builtin_sym_end] = ACTIONS(5851),
    [anon_sym_SEMI] = ACTIONS(5853),
    [anon_sym_esac] = ACTIONS(5851),
    [anon_sym_PIPE] = ACTIONS(5853),
    [anon_sym_RPAREN] = ACTIONS(5851),
    [anon_sym_SEMI_SEMI] = ACTIONS(5851),
    [anon_sym_PIPE_AMP] = ACTIONS(5851),
    [anon_sym_AMP_AMP] = ACTIONS(5851),
    [anon_sym_PIPE_PIPE] = ACTIONS(5851),
    [anon_sym_BQUOTE] = ACTIONS(5851),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5851),
    [anon_sym_AMP] = ACTIONS(5853),
  },
  [2405] = {
    [sym__concat] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [sym__special_characters] = ACTIONS(5069),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [anon_sym_LT_LPAREN] = ACTIONS(5069),
    [anon_sym_GT_LPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5071),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5069),
  },
  [2406] = {
    [sym__concat] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [sym__special_characters] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym_raw_string] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5075),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5073),
  },
  [2407] = {
    [sym_file_descriptor] = ACTIONS(2056),
    [sym_variable_name] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_esac] = ACTIONS(2058),
    [anon_sym_PIPE] = ACTIONS(2058),
    [anon_sym_SEMI_SEMI] = ACTIONS(2056),
    [anon_sym_PIPE_AMP] = ACTIONS(2056),
    [anon_sym_AMP_AMP] = ACTIONS(2056),
    [anon_sym_PIPE_PIPE] = ACTIONS(2056),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_GT] = ACTIONS(2058),
    [anon_sym_GT_GT] = ACTIONS(2056),
    [anon_sym_AMP_GT] = ACTIONS(2058),
    [anon_sym_AMP_GT_GT] = ACTIONS(2056),
    [anon_sym_LT_AMP] = ACTIONS(2056),
    [anon_sym_GT_AMP] = ACTIONS(2056),
    [sym__special_characters] = ACTIONS(2056),
    [anon_sym_DQUOTE] = ACTIONS(2056),
    [anon_sym_DOLLAR] = ACTIONS(2058),
    [sym_raw_string] = ACTIONS(2056),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2056),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2056),
    [anon_sym_BQUOTE] = ACTIONS(2056),
    [anon_sym_LT_LPAREN] = ACTIONS(2056),
    [anon_sym_GT_LPAREN] = ACTIONS(2056),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2058),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2058),
  },
  [2408] = {
    [sym_concatenation] = STATE(977),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_string_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [aux_sym_for_statement_repeat1] = STATE(977),
    [anon_sym_RPAREN] = ACTIONS(5855),
    [sym__special_characters] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym_raw_string] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1083),
  },
  [2409] = {
    [sym_string] = STATE(2560),
    [sym_simple_expansion] = STATE(2560),
    [sym_string_expansion] = STATE(2560),
    [sym_expansion] = STATE(2560),
    [sym_command_substitution] = STATE(2560),
    [sym_process_substitution] = STATE(2560),
    [sym__special_characters] = ACTIONS(5857),
    [anon_sym_DQUOTE] = ACTIONS(5189),
    [anon_sym_DOLLAR] = ACTIONS(5191),
    [sym_raw_string] = ACTIONS(5857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5197),
    [anon_sym_BQUOTE] = ACTIONS(5199),
    [anon_sym_LT_LPAREN] = ACTIONS(5201),
    [anon_sym_GT_LPAREN] = ACTIONS(5201),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5857),
  },
  [2410] = {
    [aux_sym_concatenation_repeat1] = STATE(2561),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(5473),
    [sym_variable_name] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_esac] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [sym__special_characters] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(765),
    [anon_sym_BQUOTE] = ACTIONS(765),
    [anon_sym_LT_LPAREN] = ACTIONS(765),
    [anon_sym_GT_LPAREN] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [2411] = {
    [sym_file_descriptor] = ACTIONS(769),
    [sym__concat] = ACTIONS(769),
    [sym_variable_name] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_esac] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_AMP_GT] = ACTIONS(771),
    [anon_sym_AMP_GT_GT] = ACTIONS(769),
    [anon_sym_LT_AMP] = ACTIONS(769),
    [anon_sym_GT_AMP] = ACTIONS(769),
    [sym__special_characters] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [2412] = {
    [anon_sym_DQUOTE] = ACTIONS(5859),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [2413] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(5859),
    [anon_sym_DOLLAR] = ACTIONS(5861),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2414] = {
    [sym_file_descriptor] = ACTIONS(803),
    [sym__concat] = ACTIONS(803),
    [sym_variable_name] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_esac] = ACTIONS(805),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [anon_sym_PIPE_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_AMP_GT] = ACTIONS(805),
    [anon_sym_AMP_GT_GT] = ACTIONS(803),
    [anon_sym_LT_AMP] = ACTIONS(803),
    [anon_sym_GT_AMP] = ACTIONS(803),
    [sym__special_characters] = ACTIONS(803),
    [anon_sym_DQUOTE] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_raw_string] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(803),
    [anon_sym_BQUOTE] = ACTIONS(803),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(805),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(805),
  },
  [2415] = {
    [sym_file_descriptor] = ACTIONS(807),
    [sym__concat] = ACTIONS(807),
    [sym_variable_name] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_esac] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [anon_sym_PIPE_AMP] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_LT] = ACTIONS(809),
    [anon_sym_GT] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(807),
    [anon_sym_AMP_GT] = ACTIONS(809),
    [anon_sym_AMP_GT_GT] = ACTIONS(807),
    [anon_sym_LT_AMP] = ACTIONS(807),
    [anon_sym_GT_AMP] = ACTIONS(807),
    [sym__special_characters] = ACTIONS(807),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym_raw_string] = ACTIONS(807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(807),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_LT_LPAREN] = ACTIONS(807),
    [anon_sym_GT_LPAREN] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(809),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(809),
  },
  [2416] = {
    [sym_file_descriptor] = ACTIONS(811),
    [sym__concat] = ACTIONS(811),
    [sym_variable_name] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_esac] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_AMP_GT] = ACTIONS(813),
    [anon_sym_AMP_GT_GT] = ACTIONS(811),
    [anon_sym_LT_AMP] = ACTIONS(811),
    [anon_sym_GT_AMP] = ACTIONS(811),
    [sym__special_characters] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(811),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(811),
    [anon_sym_LT_LPAREN] = ACTIONS(811),
    [anon_sym_GT_LPAREN] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(813),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(813),
  },
  [2417] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(5863),
    [sym_comment] = ACTIONS(53),
  },
  [2418] = {
    [sym_subscript] = STATE(2567),
    [sym_variable_name] = ACTIONS(5865),
    [anon_sym_DOLLAR] = ACTIONS(5867),
    [anon_sym_DASH] = ACTIONS(5867),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5869),
    [anon_sym_STAR] = ACTIONS(5871),
    [anon_sym_AT] = ACTIONS(5871),
    [anon_sym_QMARK] = ACTIONS(5871),
    [anon_sym_0] = ACTIONS(5869),
    [anon_sym__] = ACTIONS(5869),
  },
  [2419] = {
    [sym_concatenation] = STATE(2570),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2570),
    [anon_sym_RBRACE] = ACTIONS(5873),
    [anon_sym_EQ] = ACTIONS(5875),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5879),
    [anon_sym_COLON] = ACTIONS(5875),
    [anon_sym_COLON_QMARK] = ACTIONS(5875),
    [anon_sym_COLON_DASH] = ACTIONS(5875),
    [anon_sym_PERCENT] = ACTIONS(5875),
    [anon_sym_DASH] = ACTIONS(5875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2420] = {
    [sym_concatenation] = STATE(2573),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2573),
    [anon_sym_RBRACE] = ACTIONS(5881),
    [anon_sym_EQ] = ACTIONS(5883),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5887),
    [anon_sym_COLON] = ACTIONS(5883),
    [anon_sym_COLON_QMARK] = ACTIONS(5883),
    [anon_sym_COLON_DASH] = ACTIONS(5883),
    [anon_sym_PERCENT] = ACTIONS(5883),
    [anon_sym_DASH] = ACTIONS(5883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2421] = {
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5891),
    [anon_sym_SEMI_SEMI] = ACTIONS(5893),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(5889),
  },
  [2422] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5891),
    [anon_sym_SEMI_SEMI] = ACTIONS(5893),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(5889),
  },
  [2423] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2576),
    [sym_c_style_for_statement] = STATE(2576),
    [sym_while_statement] = STATE(2576),
    [sym_if_statement] = STATE(2576),
    [sym_case_statement] = STATE(2576),
    [sym_function_definition] = STATE(2576),
    [sym_subshell] = STATE(2576),
    [sym_pipeline] = STATE(2576),
    [sym_list] = STATE(2576),
    [sym_negated_command] = STATE(2576),
    [sym_test_command] = STATE(2576),
    [sym_declaration_command] = STATE(2576),
    [sym_unset_command] = STATE(2576),
    [sym_command] = STATE(2576),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2577),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2424] = {
    [anon_sym_SEMI] = ACTIONS(5895),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5897),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(5891),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5897),
    [anon_sym_AMP] = ACTIONS(5895),
  },
  [2425] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5895),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5897),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(5891),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5897),
    [anon_sym_AMP] = ACTIONS(5895),
  },
  [2426] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2579),
    [sym_c_style_for_statement] = STATE(2579),
    [sym_while_statement] = STATE(2579),
    [sym_if_statement] = STATE(2579),
    [sym_case_statement] = STATE(2579),
    [sym_function_definition] = STATE(2579),
    [sym_subshell] = STATE(2579),
    [sym_pipeline] = STATE(2579),
    [sym_list] = STATE(2579),
    [sym_negated_command] = STATE(2579),
    [sym_test_command] = STATE(2579),
    [sym_declaration_command] = STATE(2579),
    [sym_unset_command] = STATE(2579),
    [sym_command] = STATE(2579),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(2580),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [2427] = {
    [anon_sym_SEMI] = ACTIONS(5899),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5901),
    [anon_sym_SEMI_SEMI] = ACTIONS(5903),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5903),
    [anon_sym_AMP] = ACTIONS(5899),
  },
  [2428] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5899),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5901),
    [anon_sym_SEMI_SEMI] = ACTIONS(5903),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5903),
    [anon_sym_AMP] = ACTIONS(5899),
  },
  [2429] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2583),
    [sym_c_style_for_statement] = STATE(2583),
    [sym_while_statement] = STATE(2583),
    [sym_if_statement] = STATE(2583),
    [sym_case_statement] = STATE(2583),
    [sym_function_definition] = STATE(2583),
    [sym_subshell] = STATE(2583),
    [sym_pipeline] = STATE(2583),
    [sym_list] = STATE(2583),
    [sym_negated_command] = STATE(2583),
    [sym_test_command] = STATE(2583),
    [sym_declaration_command] = STATE(2583),
    [sym_unset_command] = STATE(2583),
    [sym_command] = STATE(2583),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2584),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2430] = {
    [sym_file_redirect] = STATE(2349),
    [sym_heredoc_redirect] = STATE(2349),
    [sym_heredoc_body] = STATE(1086),
    [sym_herestring_redirect] = STATE(2349),
    [aux_sym_while_statement_repeat1] = STATE(2349),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(4909),
    [anon_sym_SEMI] = ACTIONS(2331),
    [anon_sym_esac] = ACTIONS(2329),
    [anon_sym_PIPE] = ACTIONS(2331),
    [anon_sym_SEMI_SEMI] = ACTIONS(2329),
    [anon_sym_PIPE_AMP] = ACTIONS(2329),
    [anon_sym_AMP_AMP] = ACTIONS(2329),
    [anon_sym_PIPE_PIPE] = ACTIONS(2329),
    [anon_sym_LT] = ACTIONS(4913),
    [anon_sym_GT] = ACTIONS(4913),
    [anon_sym_GT_GT] = ACTIONS(4915),
    [anon_sym_AMP_GT] = ACTIONS(4913),
    [anon_sym_AMP_GT_GT] = ACTIONS(4915),
    [anon_sym_LT_AMP] = ACTIONS(4915),
    [anon_sym_GT_AMP] = ACTIONS(4915),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(4917),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2329),
    [anon_sym_AMP] = ACTIONS(2331),
  },
  [2431] = {
    [sym_compound_statement] = STATE(2585),
    [anon_sym_LBRACE] = ACTIONS(511),
    [sym_comment] = ACTIONS(53),
  },
  [2432] = {
    [anon_sym_LT] = ACTIONS(5905),
    [anon_sym_GT] = ACTIONS(5905),
    [anon_sym_GT_GT] = ACTIONS(5907),
    [anon_sym_AMP_GT] = ACTIONS(5905),
    [anon_sym_AMP_GT_GT] = ACTIONS(5907),
    [anon_sym_LT_AMP] = ACTIONS(5907),
    [anon_sym_GT_AMP] = ACTIONS(5907),
    [sym_comment] = ACTIONS(53),
  },
  [2433] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(2588),
    [sym_simple_expansion] = STATE(2588),
    [sym_string_expansion] = STATE(2588),
    [sym_expansion] = STATE(2588),
    [sym_command_substitution] = STATE(2588),
    [sym_process_substitution] = STATE(2588),
    [sym__special_characters] = ACTIONS(5909),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(5911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5911),
  },
  [2434] = {
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_GT] = ACTIONS(5915),
    [anon_sym_AMP_GT] = ACTIONS(5913),
    [anon_sym_AMP_GT_GT] = ACTIONS(5915),
    [anon_sym_LT_AMP] = ACTIONS(5915),
    [anon_sym_GT_AMP] = ACTIONS(5915),
    [sym_comment] = ACTIONS(53),
  },
  [2435] = {
    [sym_concatenation] = STATE(1186),
    [sym_string] = STATE(2591),
    [sym_simple_expansion] = STATE(2591),
    [sym_string_expansion] = STATE(2591),
    [sym_expansion] = STATE(2591),
    [sym_command_substitution] = STATE(2591),
    [sym_process_substitution] = STATE(2591),
    [sym__special_characters] = ACTIONS(5917),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(5919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5919),
  },
  [2436] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(2593),
    [sym_simple_expansion] = STATE(2593),
    [sym_string_expansion] = STATE(2593),
    [sym_expansion] = STATE(2593),
    [sym_command_substitution] = STATE(2593),
    [sym_process_substitution] = STATE(2593),
    [sym__special_characters] = ACTIONS(5921),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(5923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5923),
  },
  [2437] = {
    [sym_file_redirect] = STATE(2594),
    [sym_heredoc_redirect] = STATE(2594),
    [sym_herestring_redirect] = STATE(2594),
    [aux_sym_while_statement_repeat1] = STATE(2594),
    [sym_file_descriptor] = ACTIONS(5505),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_esac] = ACTIONS(2632),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(5507),
    [anon_sym_GT] = ACTIONS(5507),
    [anon_sym_GT_GT] = ACTIONS(5509),
    [anon_sym_AMP_GT] = ACTIONS(5507),
    [anon_sym_AMP_GT_GT] = ACTIONS(5509),
    [anon_sym_LT_AMP] = ACTIONS(5509),
    [anon_sym_GT_AMP] = ACTIONS(5509),
    [anon_sym_LT_LT] = ACTIONS(1413),
    [anon_sym_LT_LT_DASH] = ACTIONS(1415),
    [anon_sym_LT_LT_LT] = ACTIONS(5511),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [2438] = {
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_esac] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1073),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [2439] = {
    [sym_concatenation] = STATE(2596),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_string_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [aux_sym_for_statement_repeat1] = STATE(2596),
    [anon_sym_RPAREN] = ACTIONS(5925),
    [sym__special_characters] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym_raw_string] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1083),
  },
  [2440] = {
    [aux_sym_concatenation_repeat1] = STATE(2263),
    [sym__concat] = ACTIONS(5209),
    [sym_variable_name] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_esac] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym__special_characters] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1097),
    [sym_word] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [2441] = {
    [aux_sym_concatenation_repeat1] = STATE(2263),
    [sym__concat] = ACTIONS(5209),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_esac] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [sym__special_characters] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1073),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
  },
  [2442] = {
    [sym__concat] = ACTIONS(1724),
    [sym_variable_name] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1726),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2443] = {
    [aux_sym_concatenation_repeat1] = STATE(2443),
    [sym__concat] = ACTIONS(5927),
    [sym_variable_name] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1726),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2444] = {
    [sym__concat] = ACTIONS(1731),
    [sym_variable_name] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_esac] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [anon_sym_PIPE_AMP] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [sym__special_characters] = ACTIONS(1731),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1731),
    [anon_sym_GT_LPAREN] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1733),
    [sym_word] = ACTIONS(1733),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [2445] = {
    [anon_sym_DQUOTE] = ACTIONS(5930),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [2446] = {
    [sym_concatenation] = STATE(2601),
    [sym_string] = STATE(2600),
    [sym_simple_expansion] = STATE(2600),
    [sym_string_expansion] = STATE(2600),
    [sym_expansion] = STATE(2600),
    [sym_command_substitution] = STATE(2600),
    [sym_process_substitution] = STATE(2600),
    [anon_sym_RBRACE] = ACTIONS(5932),
    [sym__special_characters] = ACTIONS(5934),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(5936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5936),
  },
  [2447] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(5938),
    [sym_comment] = ACTIONS(53),
  },
  [2448] = {
    [sym_concatenation] = STATE(2605),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2605),
    [anon_sym_RBRACE] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5942),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5946),
    [anon_sym_COLON] = ACTIONS(5942),
    [anon_sym_COLON_QMARK] = ACTIONS(5942),
    [anon_sym_COLON_DASH] = ACTIONS(5942),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_DASH] = ACTIONS(5942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2449] = {
    [sym_concatenation] = STATE(2607),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2607),
    [anon_sym_RBRACE] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5948),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5952),
    [anon_sym_COLON] = ACTIONS(5948),
    [anon_sym_COLON_QMARK] = ACTIONS(5948),
    [anon_sym_COLON_DASH] = ACTIONS(5948),
    [anon_sym_PERCENT] = ACTIONS(5948),
    [anon_sym_DASH] = ACTIONS(5948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2450] = {
    [sym__concat] = ACTIONS(1832),
    [sym_variable_name] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_esac] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1834),
    [sym_word] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [2451] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(5954),
  },
  [2452] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5956),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2453] = {
    [sym__concat] = ACTIONS(1876),
    [sym_variable_name] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [anon_sym_PIPE_AMP] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [sym__special_characters] = ACTIONS(1876),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [anon_sym_LT_LPAREN] = ACTIONS(1876),
    [anon_sym_GT_LPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1878),
    [sym_word] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [2454] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(5958),
  },
  [2455] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2456] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(5960),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2457] = {
    [sym__concat] = ACTIONS(1884),
    [sym_variable_name] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_esac] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [sym__special_characters] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym_raw_string] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(1884),
    [anon_sym_GT_LPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1886),
    [sym_word] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [2458] = {
    [anon_sym_SEMI] = ACTIONS(5962),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5960),
    [anon_sym_SEMI_SEMI] = ACTIONS(5964),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5964),
    [anon_sym_AMP] = ACTIONS(5962),
  },
  [2459] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5962),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5960),
    [anon_sym_SEMI_SEMI] = ACTIONS(5964),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5964),
    [anon_sym_AMP] = ACTIONS(5962),
  },
  [2460] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(5960),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2461] = {
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5968),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(5960),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5968),
    [anon_sym_AMP] = ACTIONS(5966),
  },
  [2462] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(5968),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(5960),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5968),
    [anon_sym_AMP] = ACTIONS(5966),
  },
  [2463] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(5970),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2464] = {
    [sym__concat] = ACTIONS(1916),
    [sym_variable_name] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_esac] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [sym__special_characters] = ACTIONS(1916),
    [anon_sym_DQUOTE] = ACTIONS(1916),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1916),
    [anon_sym_GT_LPAREN] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1918),
    [sym_word] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [2465] = {
    [anon_sym_SEMI] = ACTIONS(5972),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5970),
    [anon_sym_SEMI_SEMI] = ACTIONS(5974),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5974),
    [anon_sym_AMP] = ACTIONS(5972),
  },
  [2466] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(5972),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(5970),
    [anon_sym_SEMI_SEMI] = ACTIONS(5974),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(5974),
    [anon_sym_AMP] = ACTIONS(5972),
  },
  [2467] = {
    [sym__concat] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1726),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2468] = {
    [aux_sym_concatenation_repeat1] = STATE(2468),
    [sym__concat] = ACTIONS(5976),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1726),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2469] = {
    [sym__concat] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_esac] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [anon_sym_PIPE_AMP] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [sym__special_characters] = ACTIONS(1731),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1731),
    [anon_sym_GT_LPAREN] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1733),
    [sym_word] = ACTIONS(1733),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [2470] = {
    [anon_sym_DQUOTE] = ACTIONS(5979),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [2471] = {
    [sym_concatenation] = STATE(2620),
    [sym_string] = STATE(2619),
    [sym_simple_expansion] = STATE(2619),
    [sym_string_expansion] = STATE(2619),
    [sym_expansion] = STATE(2619),
    [sym_command_substitution] = STATE(2619),
    [sym_process_substitution] = STATE(2619),
    [anon_sym_RBRACE] = ACTIONS(5981),
    [sym__special_characters] = ACTIONS(5983),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(5985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5985),
  },
  [2472] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(5987),
    [sym_comment] = ACTIONS(53),
  },
  [2473] = {
    [sym_concatenation] = STATE(2624),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2624),
    [anon_sym_RBRACE] = ACTIONS(5989),
    [anon_sym_EQ] = ACTIONS(5991),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(5995),
    [anon_sym_COLON] = ACTIONS(5991),
    [anon_sym_COLON_QMARK] = ACTIONS(5991),
    [anon_sym_COLON_DASH] = ACTIONS(5991),
    [anon_sym_PERCENT] = ACTIONS(5991),
    [anon_sym_DASH] = ACTIONS(5991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2474] = {
    [sym_concatenation] = STATE(2626),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2626),
    [anon_sym_RBRACE] = ACTIONS(5981),
    [anon_sym_EQ] = ACTIONS(5997),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(5999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(6001),
    [anon_sym_COLON] = ACTIONS(5997),
    [anon_sym_COLON_QMARK] = ACTIONS(5997),
    [anon_sym_COLON_DASH] = ACTIONS(5997),
    [anon_sym_PERCENT] = ACTIONS(5997),
    [anon_sym_DASH] = ACTIONS(5997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2475] = {
    [sym__concat] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_esac] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1834),
    [sym_word] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [2476] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6003),
  },
  [2477] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6005),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2478] = {
    [sym__concat] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [anon_sym_PIPE_AMP] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [sym__special_characters] = ACTIONS(1876),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [anon_sym_LT_LPAREN] = ACTIONS(1876),
    [anon_sym_GT_LPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1878),
    [sym_word] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [2479] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6007),
  },
  [2480] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(5981),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2481] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6009),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2482] = {
    [sym__concat] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_esac] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [sym__special_characters] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym_raw_string] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(1884),
    [anon_sym_GT_LPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1886),
    [sym_word] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [2483] = {
    [anon_sym_SEMI] = ACTIONS(6011),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6009),
    [anon_sym_SEMI_SEMI] = ACTIONS(6013),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(6013),
    [anon_sym_AMP] = ACTIONS(6011),
  },
  [2484] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(6011),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6009),
    [anon_sym_SEMI_SEMI] = ACTIONS(6013),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(6013),
    [anon_sym_AMP] = ACTIONS(6011),
  },
  [2485] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(6009),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2486] = {
    [anon_sym_SEMI] = ACTIONS(6015),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(6017),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(6009),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(6017),
    [anon_sym_AMP] = ACTIONS(6015),
  },
  [2487] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(6015),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(6017),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(6009),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(6017),
    [anon_sym_AMP] = ACTIONS(6015),
  },
  [2488] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6019),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2489] = {
    [sym__concat] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_esac] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [sym__special_characters] = ACTIONS(1916),
    [anon_sym_DQUOTE] = ACTIONS(1916),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1916),
    [anon_sym_GT_LPAREN] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1918),
    [sym_word] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [2490] = {
    [anon_sym_SEMI] = ACTIONS(6021),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6019),
    [anon_sym_SEMI_SEMI] = ACTIONS(6023),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(6023),
    [anon_sym_AMP] = ACTIONS(6021),
  },
  [2491] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(6021),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6019),
    [anon_sym_SEMI_SEMI] = ACTIONS(6023),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(6023),
    [anon_sym_AMP] = ACTIONS(6021),
  },
  [2492] = {
    [sym__simple_heredoc_body] = ACTIONS(2876),
    [sym__heredoc_body_beginning] = ACTIONS(2876),
    [sym_file_descriptor] = ACTIONS(2876),
    [sym__concat] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_esac] = ACTIONS(2878),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [anon_sym_EQ_TILDE] = ACTIONS(2878),
    [anon_sym_EQ_EQ] = ACTIONS(2878),
    [anon_sym_LT] = ACTIONS(2878),
    [anon_sym_GT] = ACTIONS(2878),
    [anon_sym_GT_GT] = ACTIONS(2876),
    [anon_sym_AMP_GT] = ACTIONS(2878),
    [anon_sym_AMP_GT_GT] = ACTIONS(2876),
    [anon_sym_LT_AMP] = ACTIONS(2876),
    [anon_sym_GT_AMP] = ACTIONS(2876),
    [anon_sym_LT_LT] = ACTIONS(2878),
    [anon_sym_LT_LT_DASH] = ACTIONS(2876),
    [anon_sym_LT_LT_LT] = ACTIONS(2876),
    [sym__special_characters] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [anon_sym_LT_LPAREN] = ACTIONS(2876),
    [anon_sym_GT_LPAREN] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2878),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2878),
  },
  [2493] = {
    [sym__simple_heredoc_body] = ACTIONS(2890),
    [sym__heredoc_body_beginning] = ACTIONS(2890),
    [sym_file_descriptor] = ACTIONS(2890),
    [sym__concat] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_esac] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [anon_sym_PIPE_AMP] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_EQ_TILDE] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2890),
    [anon_sym_AMP_GT] = ACTIONS(2892),
    [anon_sym_AMP_GT_GT] = ACTIONS(2890),
    [anon_sym_LT_AMP] = ACTIONS(2890),
    [anon_sym_GT_AMP] = ACTIONS(2890),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_LT_LT_DASH] = ACTIONS(2890),
    [anon_sym_LT_LT_LT] = ACTIONS(2890),
    [sym__special_characters] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [anon_sym_LT_LPAREN] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2892),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2892),
  },
  [2494] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6025),
    [sym_comment] = ACTIONS(53),
  },
  [2495] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6027),
    [sym_comment] = ACTIONS(53),
  },
  [2496] = {
    [anon_sym_RBRACE] = ACTIONS(6027),
    [sym_comment] = ACTIONS(53),
  },
  [2497] = {
    [sym_concatenation] = STATE(2639),
    [sym_string] = STATE(2638),
    [sym_simple_expansion] = STATE(2638),
    [sym_string_expansion] = STATE(2638),
    [sym_expansion] = STATE(2638),
    [sym_command_substitution] = STATE(2638),
    [sym_process_substitution] = STATE(2638),
    [anon_sym_RBRACE] = ACTIONS(6027),
    [sym__special_characters] = ACTIONS(6029),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(6031),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6031),
  },
  [2498] = {
    [sym__simple_heredoc_body] = ACTIONS(2926),
    [sym__heredoc_body_beginning] = ACTIONS(2926),
    [sym_file_descriptor] = ACTIONS(2926),
    [sym__concat] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_esac] = ACTIONS(2928),
    [anon_sym_PIPE] = ACTIONS(2928),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE_AMP] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_EQ_TILDE] = ACTIONS(2928),
    [anon_sym_EQ_EQ] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_GT] = ACTIONS(2928),
    [anon_sym_GT_GT] = ACTIONS(2926),
    [anon_sym_AMP_GT] = ACTIONS(2928),
    [anon_sym_AMP_GT_GT] = ACTIONS(2926),
    [anon_sym_LT_AMP] = ACTIONS(2926),
    [anon_sym_GT_AMP] = ACTIONS(2926),
    [anon_sym_LT_LT] = ACTIONS(2928),
    [anon_sym_LT_LT_DASH] = ACTIONS(2926),
    [anon_sym_LT_LT_LT] = ACTIONS(2926),
    [sym__special_characters] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym_raw_string] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [anon_sym_LT_LPAREN] = ACTIONS(2926),
    [anon_sym_GT_LPAREN] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2928),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2928),
  },
  [2499] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6033),
  },
  [2500] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6035),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2501] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6037),
  },
  [2502] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2503] = {
    [sym_concatenation] = STATE(2644),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2644),
    [anon_sym_RBRACE] = ACTIONS(6039),
    [anon_sym_EQ] = ACTIONS(6041),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6041),
    [anon_sym_COLON_QMARK] = ACTIONS(6041),
    [anon_sym_COLON_DASH] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6041),
    [anon_sym_DASH] = ACTIONS(6041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2504] = {
    [sym__simple_heredoc_body] = ACTIONS(2990),
    [sym__heredoc_body_beginning] = ACTIONS(2990),
    [sym_file_descriptor] = ACTIONS(2990),
    [sym__concat] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_esac] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(2992),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [anon_sym_PIPE_AMP] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [anon_sym_EQ_TILDE] = ACTIONS(2992),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(2990),
    [anon_sym_AMP_GT] = ACTIONS(2992),
    [anon_sym_AMP_GT_GT] = ACTIONS(2990),
    [anon_sym_LT_AMP] = ACTIONS(2990),
    [anon_sym_GT_AMP] = ACTIONS(2990),
    [anon_sym_LT_LT] = ACTIONS(2992),
    [anon_sym_LT_LT_DASH] = ACTIONS(2990),
    [anon_sym_LT_LT_LT] = ACTIONS(2990),
    [sym__special_characters] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym_raw_string] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_LT_LPAREN] = ACTIONS(2990),
    [anon_sym_GT_LPAREN] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2992),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2992),
  },
  [2505] = {
    [sym_concatenation] = STATE(2645),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2645),
    [anon_sym_RBRACE] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(6045),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6045),
    [anon_sym_COLON_QMARK] = ACTIONS(6045),
    [anon_sym_COLON_DASH] = ACTIONS(6045),
    [anon_sym_PERCENT] = ACTIONS(6045),
    [anon_sym_DASH] = ACTIONS(6045),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2506] = {
    [sym__simple_heredoc_body] = ACTIONS(3033),
    [sym__heredoc_body_beginning] = ACTIONS(3033),
    [sym_file_descriptor] = ACTIONS(3033),
    [sym__concat] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_esac] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [anon_sym_PIPE_AMP] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [anon_sym_EQ_TILDE] = ACTIONS(3035),
    [anon_sym_EQ_EQ] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_GT_GT] = ACTIONS(3033),
    [anon_sym_AMP_GT] = ACTIONS(3035),
    [anon_sym_AMP_GT_GT] = ACTIONS(3033),
    [anon_sym_LT_AMP] = ACTIONS(3033),
    [anon_sym_GT_AMP] = ACTIONS(3033),
    [anon_sym_LT_LT] = ACTIONS(3035),
    [anon_sym_LT_LT_DASH] = ACTIONS(3033),
    [anon_sym_LT_LT_LT] = ACTIONS(3033),
    [sym__special_characters] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [anon_sym_LT_LPAREN] = ACTIONS(3033),
    [anon_sym_GT_LPAREN] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3035),
  },
  [2507] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6049),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2508] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(6049),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2509] = {
    [sym__simple_heredoc_body] = ACTIONS(3071),
    [sym__heredoc_body_beginning] = ACTIONS(3071),
    [sym_file_descriptor] = ACTIONS(3071),
    [sym__concat] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_esac] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [anon_sym_PIPE_AMP] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_EQ_TILDE] = ACTIONS(3073),
    [anon_sym_EQ_EQ] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_GT_GT] = ACTIONS(3071),
    [anon_sym_AMP_GT] = ACTIONS(3073),
    [anon_sym_AMP_GT_GT] = ACTIONS(3071),
    [anon_sym_LT_AMP] = ACTIONS(3071),
    [anon_sym_GT_AMP] = ACTIONS(3071),
    [anon_sym_LT_LT] = ACTIONS(3073),
    [anon_sym_LT_LT_DASH] = ACTIONS(3071),
    [anon_sym_LT_LT_LT] = ACTIONS(3071),
    [sym__special_characters] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [sym_raw_string] = ACTIONS(3071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_LT_LPAREN] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
  },
  [2510] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6051),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2511] = {
    [sym_file_redirect] = STATE(1363),
    [sym_file_descriptor] = ACTIONS(5499),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_esac] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_SEMI_SEMI] = ACTIONS(2460),
    [anon_sym_PIPE_AMP] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(5501),
    [anon_sym_GT] = ACTIONS(5501),
    [anon_sym_GT_GT] = ACTIONS(5503),
    [anon_sym_AMP_GT] = ACTIONS(5501),
    [anon_sym_AMP_GT_GT] = ACTIONS(5503),
    [anon_sym_LT_AMP] = ACTIONS(5503),
    [anon_sym_GT_AMP] = ACTIONS(5503),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
  },
  [2512] = {
    [aux_sym_concatenation_repeat1] = STATE(2515),
    [sym__simple_heredoc_body] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(5733),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_esac] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2513] = {
    [aux_sym_concatenation_repeat1] = STATE(2515),
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(5733),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_esac] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2514] = {
    [sym_string] = STATE(2648),
    [sym_simple_expansion] = STATE(2648),
    [sym_string_expansion] = STATE(2648),
    [sym_expansion] = STATE(2648),
    [sym_command_substitution] = STATE(2648),
    [sym_process_substitution] = STATE(2648),
    [sym__special_characters] = ACTIONS(6053),
    [anon_sym_DQUOTE] = ACTIONS(5339),
    [anon_sym_DOLLAR] = ACTIONS(5341),
    [sym_raw_string] = ACTIONS(6053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5347),
    [anon_sym_BQUOTE] = ACTIONS(5349),
    [anon_sym_LT_LPAREN] = ACTIONS(5351),
    [anon_sym_GT_LPAREN] = ACTIONS(5351),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6053),
  },
  [2515] = {
    [aux_sym_concatenation_repeat1] = STATE(2649),
    [sym__simple_heredoc_body] = ACTIONS(765),
    [sym__heredoc_body_beginning] = ACTIONS(765),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(5733),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_esac] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [2516] = {
    [sym__simple_heredoc_body] = ACTIONS(769),
    [sym__heredoc_body_beginning] = ACTIONS(769),
    [sym_file_descriptor] = ACTIONS(769),
    [sym__concat] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_esac] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_AMP_GT] = ACTIONS(771),
    [anon_sym_AMP_GT_GT] = ACTIONS(769),
    [anon_sym_LT_AMP] = ACTIONS(769),
    [anon_sym_GT_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_LT_LT_DASH] = ACTIONS(769),
    [anon_sym_LT_LT_LT] = ACTIONS(769),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [2517] = {
    [anon_sym_DQUOTE] = ACTIONS(6055),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [2518] = {
    [sym_simple_expansion] = STATE(141),
    [sym_expansion] = STATE(141),
    [sym_command_substitution] = STATE(141),
    [aux_sym_string_repeat1] = STATE(450),
    [anon_sym_DQUOTE] = ACTIONS(6055),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [sym__string_content] = ACTIONS(257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(265),
  },
  [2519] = {
    [sym__simple_heredoc_body] = ACTIONS(803),
    [sym__heredoc_body_beginning] = ACTIONS(803),
    [sym_file_descriptor] = ACTIONS(803),
    [sym__concat] = ACTIONS(803),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_esac] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_SEMI_SEMI] = ACTIONS(803),
    [anon_sym_PIPE_AMP] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_AMP_GT] = ACTIONS(805),
    [anon_sym_AMP_GT_GT] = ACTIONS(803),
    [anon_sym_LT_AMP] = ACTIONS(803),
    [anon_sym_GT_AMP] = ACTIONS(803),
    [anon_sym_LT_LT] = ACTIONS(805),
    [anon_sym_LT_LT_DASH] = ACTIONS(803),
    [anon_sym_LT_LT_LT] = ACTIONS(803),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(805),
  },
  [2520] = {
    [sym__simple_heredoc_body] = ACTIONS(807),
    [sym__heredoc_body_beginning] = ACTIONS(807),
    [sym_file_descriptor] = ACTIONS(807),
    [sym__concat] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_esac] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_SEMI_SEMI] = ACTIONS(807),
    [anon_sym_PIPE_AMP] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_LT] = ACTIONS(809),
    [anon_sym_GT] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(807),
    [anon_sym_AMP_GT] = ACTIONS(809),
    [anon_sym_AMP_GT_GT] = ACTIONS(807),
    [anon_sym_LT_AMP] = ACTIONS(807),
    [anon_sym_GT_AMP] = ACTIONS(807),
    [anon_sym_LT_LT] = ACTIONS(809),
    [anon_sym_LT_LT_DASH] = ACTIONS(807),
    [anon_sym_LT_LT_LT] = ACTIONS(807),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(807),
    [anon_sym_AMP] = ACTIONS(809),
  },
  [2521] = {
    [sym__simple_heredoc_body] = ACTIONS(811),
    [sym__heredoc_body_beginning] = ACTIONS(811),
    [sym_file_descriptor] = ACTIONS(811),
    [sym__concat] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_esac] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_SEMI_SEMI] = ACTIONS(811),
    [anon_sym_PIPE_AMP] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_AMP_GT] = ACTIONS(813),
    [anon_sym_AMP_GT_GT] = ACTIONS(811),
    [anon_sym_LT_AMP] = ACTIONS(811),
    [anon_sym_GT_AMP] = ACTIONS(811),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_LT] = ACTIONS(811),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_AMP] = ACTIONS(813),
  },
  [2522] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(6059),
    [sym_comment] = ACTIONS(53),
  },
  [2523] = {
    [sym_subscript] = STATE(2655),
    [sym_variable_name] = ACTIONS(6061),
    [anon_sym_DOLLAR] = ACTIONS(6063),
    [anon_sym_DASH] = ACTIONS(6063),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6065),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_AT] = ACTIONS(6067),
    [anon_sym_QMARK] = ACTIONS(6067),
    [anon_sym_0] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6065),
  },
  [2524] = {
    [sym_concatenation] = STATE(2658),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2658),
    [anon_sym_RBRACE] = ACTIONS(6069),
    [anon_sym_EQ] = ACTIONS(6071),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(6075),
    [anon_sym_COLON] = ACTIONS(6071),
    [anon_sym_COLON_QMARK] = ACTIONS(6071),
    [anon_sym_COLON_DASH] = ACTIONS(6071),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2525] = {
    [sym_concatenation] = STATE(2661),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2661),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_EQ] = ACTIONS(6079),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_COLON] = ACTIONS(6079),
    [anon_sym_COLON_QMARK] = ACTIONS(6079),
    [anon_sym_COLON_DASH] = ACTIONS(6079),
    [anon_sym_PERCENT] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2526] = {
    [anon_sym_SEMI] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_SEMI_SEMI] = ACTIONS(6089),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(6089),
    [anon_sym_AMP] = ACTIONS(6085),
  },
  [2527] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_SEMI_SEMI] = ACTIONS(6089),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(6089),
    [anon_sym_AMP] = ACTIONS(6085),
  },
  [2528] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2664),
    [sym_c_style_for_statement] = STATE(2664),
    [sym_while_statement] = STATE(2664),
    [sym_if_statement] = STATE(2664),
    [sym_case_statement] = STATE(2664),
    [sym_function_definition] = STATE(2664),
    [sym_subshell] = STATE(2664),
    [sym_pipeline] = STATE(2664),
    [sym_list] = STATE(2664),
    [sym_negated_command] = STATE(2664),
    [sym_test_command] = STATE(2664),
    [sym_declaration_command] = STATE(2664),
    [sym_unset_command] = STATE(2664),
    [sym_command] = STATE(2664),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2665),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2529] = {
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(6093),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(6087),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6091),
  },
  [2530] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(6091),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(6093),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(6087),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6091),
  },
  [2531] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2667),
    [sym_c_style_for_statement] = STATE(2667),
    [sym_while_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym_case_statement] = STATE(2667),
    [sym_function_definition] = STATE(2667),
    [sym_subshell] = STATE(2667),
    [sym_pipeline] = STATE(2667),
    [sym_list] = STATE(2667),
    [sym_negated_command] = STATE(2667),
    [sym_test_command] = STATE(2667),
    [sym_declaration_command] = STATE(2667),
    [sym_unset_command] = STATE(2667),
    [sym_command] = STATE(2667),
    [sym_command_name] = STATE(165),
    [sym_variable_assignment] = STATE(2668),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(168),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(168),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(289),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_typeset] = ACTIONS(299),
    [anon_sym_export] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_local] = ACTIONS(299),
    [anon_sym_unset] = ACTIONS(301),
    [anon_sym_unsetenv] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(303),
  },
  [2532] = {
    [anon_sym_SEMI] = ACTIONS(6095),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6097),
    [anon_sym_SEMI_SEMI] = ACTIONS(6099),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(6099),
    [anon_sym_AMP] = ACTIONS(6095),
  },
  [2533] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(6095),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6097),
    [anon_sym_SEMI_SEMI] = ACTIONS(6099),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(6099),
    [anon_sym_AMP] = ACTIONS(6095),
  },
  [2534] = {
    [sym__terminated_statement] = STATE(190),
    [sym_for_statement] = STATE(2671),
    [sym_c_style_for_statement] = STATE(2671),
    [sym_while_statement] = STATE(2671),
    [sym_if_statement] = STATE(2671),
    [sym_case_statement] = STATE(2671),
    [sym_function_definition] = STATE(2671),
    [sym_subshell] = STATE(2671),
    [sym_pipeline] = STATE(2671),
    [sym_list] = STATE(2671),
    [sym_negated_command] = STATE(2671),
    [sym_test_command] = STATE(2671),
    [sym_declaration_command] = STATE(2671),
    [sym_unset_command] = STATE(2671),
    [sym_command] = STATE(2671),
    [sym_command_name] = STATE(78),
    [sym_variable_assignment] = STATE(2672),
    [sym_subscript] = STATE(80),
    [sym_file_redirect] = STATE(82),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(75),
    [sym_simple_expansion] = STATE(75),
    [sym_string_expansion] = STATE(75),
    [sym_expansion] = STATE(75),
    [sym_command_substitution] = STATE(75),
    [sym_process_substitution] = STATE(75),
    [aux_sym__statements_repeat1] = STATE(190),
    [aux_sym_command_repeat1] = STATE(82),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(109),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(129),
  },
  [2535] = {
    [sym_file_redirect] = STATE(2349),
    [sym_heredoc_redirect] = STATE(2349),
    [sym_heredoc_body] = STATE(1375),
    [sym_herestring_redirect] = STATE(2349),
    [aux_sym_while_statement_repeat1] = STATE(2349),
    [sym__simple_heredoc_body] = ACTIONS(321),
    [sym__heredoc_body_beginning] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(4909),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_esac] = ACTIONS(3118),
    [anon_sym_PIPE] = ACTIONS(3120),
    [anon_sym_SEMI_SEMI] = ACTIONS(3118),
    [anon_sym_PIPE_AMP] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3118),
    [anon_sym_PIPE_PIPE] = ACTIONS(3118),
    [anon_sym_LT] = ACTIONS(4913),
    [anon_sym_GT] = ACTIONS(4913),
    [anon_sym_GT_GT] = ACTIONS(4915),
    [anon_sym_AMP_GT] = ACTIONS(4913),
    [anon_sym_AMP_GT_GT] = ACTIONS(4915),
    [anon_sym_LT_AMP] = ACTIONS(4915),
    [anon_sym_GT_AMP] = ACTIONS(4915),
    [anon_sym_LT_LT] = ACTIONS(337),
    [anon_sym_LT_LT_DASH] = ACTIONS(339),
    [anon_sym_LT_LT_LT] = ACTIONS(4917),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3120),
  },
  [2536] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_esac] = ACTIONS(6101),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(6103),
    [anon_sym_DQUOTE] = ACTIONS(6105),
    [anon_sym_DOLLAR] = ACTIONS(6103),
    [sym_raw_string] = ACTIONS(6105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6105),
    [anon_sym_BQUOTE] = ACTIONS(6105),
    [anon_sym_LT_LPAREN] = ACTIONS(6105),
    [anon_sym_GT_LPAREN] = ACTIONS(6105),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6103),
  },
  [2537] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_esac] = ACTIONS(6107),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(6109),
    [anon_sym_DQUOTE] = ACTIONS(6111),
    [anon_sym_DOLLAR] = ACTIONS(6109),
    [sym_raw_string] = ACTIONS(6111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6111),
    [anon_sym_BQUOTE] = ACTIONS(6111),
    [anon_sym_LT_LPAREN] = ACTIONS(6111),
    [anon_sym_GT_LPAREN] = ACTIONS(6111),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6109),
  },
  [2538] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(5313),
    [anon_sym_DQUOTE] = ACTIONS(5315),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [sym_raw_string] = ACTIONS(5315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5315),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5315),
    [anon_sym_BQUOTE] = ACTIONS(5315),
    [anon_sym_LT_LPAREN] = ACTIONS(5315),
    [anon_sym_GT_LPAREN] = ACTIONS(5315),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5313),
  },
  [2539] = {
    [sym__special_characters] = ACTIONS(5315),
    [anon_sym_DQUOTE] = ACTIONS(5315),
    [anon_sym_DOLLAR] = ACTIONS(5313),
    [sym_raw_string] = ACTIONS(5315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5315),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5315),
    [anon_sym_BQUOTE] = ACTIONS(5315),
    [anon_sym_LT_LPAREN] = ACTIONS(5315),
    [anon_sym_GT_LPAREN] = ACTIONS(5315),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5315),
  },
  [2540] = {
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(6113),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [2541] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(6113),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [2542] = {
    [sym__terminated_statement] = STATE(2542),
    [sym_for_statement] = STATE(521),
    [sym_c_style_for_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_case_statement] = STATE(521),
    [sym_function_definition] = STATE(521),
    [sym_subshell] = STATE(521),
    [sym_pipeline] = STATE(521),
    [sym_list] = STATE(521),
    [sym_negated_command] = STATE(521),
    [sym_test_command] = STATE(521),
    [sym_declaration_command] = STATE(521),
    [sym_unset_command] = STATE(521),
    [sym_command] = STATE(521),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(522),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2542),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(968),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_SEMI_SEMI] = ACTIONS(3528),
    [anon_sym_function] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(998),
    [anon_sym_typeset] = ACTIONS(998),
    [anon_sym_export] = ACTIONS(998),
    [anon_sym_readonly] = ACTIONS(998),
    [anon_sym_local] = ACTIONS(998),
    [anon_sym_unset] = ACTIONS(1001),
    [anon_sym_unsetenv] = ACTIONS(1001),
    [anon_sym_LT] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_AMP_GT] = ACTIONS(1004),
    [anon_sym_AMP_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_AMP] = ACTIONS(1007),
    [anon_sym_GT_AMP] = ACTIONS(1007),
    [sym__special_characters] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1013),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1022),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1025),
    [anon_sym_BQUOTE] = ACTIONS(1028),
    [anon_sym_LT_LPAREN] = ACTIONS(1031),
    [anon_sym_GT_LPAREN] = ACTIONS(1031),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1034),
  },
  [2543] = {
    [sym__terminated_statement] = STATE(2542),
    [sym_for_statement] = STATE(2675),
    [sym_c_style_for_statement] = STATE(2675),
    [sym_while_statement] = STATE(2675),
    [sym_if_statement] = STATE(2675),
    [sym_case_statement] = STATE(2675),
    [sym_function_definition] = STATE(2675),
    [sym_subshell] = STATE(2675),
    [sym_pipeline] = STATE(2675),
    [sym_list] = STATE(2675),
    [sym_negated_command] = STATE(2675),
    [sym_test_command] = STATE(2675),
    [sym_declaration_command] = STATE(2675),
    [sym_unset_command] = STATE(2675),
    [sym_command] = STATE(2675),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(2676),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2542),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6115),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [2544] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(5365),
    [anon_sym_DQUOTE] = ACTIONS(5367),
    [anon_sym_DOLLAR] = ACTIONS(5365),
    [sym_raw_string] = ACTIONS(5367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5367),
    [anon_sym_BQUOTE] = ACTIONS(5367),
    [anon_sym_LT_LPAREN] = ACTIONS(5367),
    [anon_sym_GT_LPAREN] = ACTIONS(5367),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5365),
  },
  [2545] = {
    [sym__special_characters] = ACTIONS(5367),
    [anon_sym_DQUOTE] = ACTIONS(5367),
    [anon_sym_DOLLAR] = ACTIONS(5365),
    [sym_raw_string] = ACTIONS(5367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5367),
    [anon_sym_BQUOTE] = ACTIONS(5367),
    [anon_sym_LT_LPAREN] = ACTIONS(5367),
    [anon_sym_GT_LPAREN] = ACTIONS(5367),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5367),
  },
  [2546] = {
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(6117),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [2547] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(6117),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [2548] = {
    [sym__terminated_statement] = STATE(2542),
    [sym_for_statement] = STATE(2679),
    [sym_c_style_for_statement] = STATE(2679),
    [sym_while_statement] = STATE(2679),
    [sym_if_statement] = STATE(2679),
    [sym_case_statement] = STATE(2679),
    [sym_function_definition] = STATE(2679),
    [sym_subshell] = STATE(2679),
    [sym_pipeline] = STATE(2679),
    [sym_list] = STATE(2679),
    [sym_negated_command] = STATE(2679),
    [sym_test_command] = STATE(2679),
    [sym_declaration_command] = STATE(2679),
    [sym_unset_command] = STATE(2679),
    [sym_command] = STATE(2679),
    [sym_command_name] = STATE(51),
    [sym_variable_assignment] = STATE(2680),
    [sym_subscript] = STATE(53),
    [sym_file_redirect] = STATE(54),
    [sym_concatenation] = STATE(30),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__statements_repeat1] = STATE(2542),
    [aux_sym_command_repeat1] = STATE(54),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(15),
    [anon_sym_case] = ACTIONS(17),
    [anon_sym_SEMI_SEMI] = ACTIONS(6119),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(79),
    [anon_sym_declare] = ACTIONS(81),
    [anon_sym_typeset] = ACTIONS(81),
    [anon_sym_export] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_local] = ACTIONS(81),
    [anon_sym_unset] = ACTIONS(83),
    [anon_sym_unsetenv] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(35),
    [anon_sym_AMP_GT] = ACTIONS(33),
    [anon_sym_AMP_GT_GT] = ACTIONS(35),
    [anon_sym_LT_AMP] = ACTIONS(35),
    [anon_sym_GT_AMP] = ACTIONS(35),
    [sym__special_characters] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym_raw_string] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(45),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(47),
    [anon_sym_BQUOTE] = ACTIONS(49),
    [anon_sym_LT_LPAREN] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(51),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(89),
  },
  [2549] = {
    [sym_file_descriptor] = ACTIONS(4568),
    [sym__concat] = ACTIONS(4568),
    [ts_builtin_sym_end] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_esac] = ACTIONS(4568),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_LT] = ACTIONS(4570),
    [anon_sym_GT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_AMP_GT] = ACTIONS(4570),
    [anon_sym_AMP_GT_GT] = ACTIONS(4568),
    [anon_sym_LT_AMP] = ACTIONS(4568),
    [anon_sym_GT_AMP] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4570),
    [anon_sym_LT_LT_DASH] = ACTIONS(4568),
    [anon_sym_LT_LT_LT] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4570),
  },
  [2550] = {
    [sym_file_descriptor] = ACTIONS(4572),
    [sym__concat] = ACTIONS(4572),
    [ts_builtin_sym_end] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_esac] = ACTIONS(4572),
    [anon_sym_PIPE] = ACTIONS(4574),
    [anon_sym_RPAREN] = ACTIONS(4572),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [anon_sym_PIPE_AMP] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [anon_sym_LT] = ACTIONS(4574),
    [anon_sym_GT] = ACTIONS(4574),
    [anon_sym_GT_GT] = ACTIONS(4572),
    [anon_sym_AMP_GT] = ACTIONS(4574),
    [anon_sym_AMP_GT_GT] = ACTIONS(4572),
    [anon_sym_LT_AMP] = ACTIONS(4572),
    [anon_sym_GT_AMP] = ACTIONS(4572),
    [anon_sym_LT_LT] = ACTIONS(4574),
    [anon_sym_LT_LT_DASH] = ACTIONS(4572),
    [anon_sym_LT_LT_LT] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4574),
  },
  [2551] = {
    [sym_file_descriptor] = ACTIONS(4576),
    [sym__concat] = ACTIONS(4576),
    [ts_builtin_sym_end] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_esac] = ACTIONS(4576),
    [anon_sym_PIPE] = ACTIONS(4578),
    [anon_sym_RPAREN] = ACTIONS(4576),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [anon_sym_PIPE_AMP] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [anon_sym_LT] = ACTIONS(4578),
    [anon_sym_GT] = ACTIONS(4578),
    [anon_sym_GT_GT] = ACTIONS(4576),
    [anon_sym_AMP_GT] = ACTIONS(4578),
    [anon_sym_AMP_GT_GT] = ACTIONS(4576),
    [anon_sym_LT_AMP] = ACTIONS(4576),
    [anon_sym_GT_AMP] = ACTIONS(4576),
    [anon_sym_LT_LT] = ACTIONS(4578),
    [anon_sym_LT_LT_DASH] = ACTIONS(4576),
    [anon_sym_LT_LT_LT] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4578),
  },
  [2552] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6121),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2553] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6123),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2554] = {
    [sym_file_descriptor] = ACTIONS(4608),
    [sym__concat] = ACTIONS(4608),
    [ts_builtin_sym_end] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_esac] = ACTIONS(4608),
    [anon_sym_PIPE] = ACTIONS(4610),
    [anon_sym_RPAREN] = ACTIONS(4608),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [anon_sym_PIPE_AMP] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [anon_sym_LT] = ACTIONS(4610),
    [anon_sym_GT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_AMP_GT] = ACTIONS(4610),
    [anon_sym_AMP_GT_GT] = ACTIONS(4608),
    [anon_sym_LT_AMP] = ACTIONS(4608),
    [anon_sym_GT_AMP] = ACTIONS(4608),
    [anon_sym_LT_LT] = ACTIONS(4610),
    [anon_sym_LT_LT_DASH] = ACTIONS(4608),
    [anon_sym_LT_LT_LT] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4610),
  },
  [2555] = {
    [sym__concat] = ACTIONS(5069),
    [anon_sym_RBRACE] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
  },
  [2556] = {
    [sym__concat] = ACTIONS(5073),
    [anon_sym_RBRACE] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
  },
  [2557] = {
    [sym__concat] = ACTIONS(5069),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [anon_sym_EQ_TILDE] = ACTIONS(5069),
    [anon_sym_EQ_EQ] = ACTIONS(5069),
    [anon_sym_EQ] = ACTIONS(5071),
    [anon_sym_LT] = ACTIONS(5069),
    [anon_sym_GT] = ACTIONS(5069),
    [anon_sym_BANG_EQ] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5069),
  },
  [2558] = {
    [sym__concat] = ACTIONS(5073),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [anon_sym_EQ_TILDE] = ACTIONS(5073),
    [anon_sym_EQ_EQ] = ACTIONS(5073),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_LT] = ACTIONS(5073),
    [anon_sym_GT] = ACTIONS(5073),
    [anon_sym_BANG_EQ] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [sym_test_operator] = ACTIONS(5073),
  },
  [2559] = {
    [sym_file_descriptor] = ACTIONS(3178),
    [sym_variable_name] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym_esac] = ACTIONS(3180),
    [anon_sym_PIPE] = ACTIONS(3180),
    [anon_sym_SEMI_SEMI] = ACTIONS(3178),
    [anon_sym_PIPE_AMP] = ACTIONS(3178),
    [anon_sym_AMP_AMP] = ACTIONS(3178),
    [anon_sym_PIPE_PIPE] = ACTIONS(3178),
    [anon_sym_LT] = ACTIONS(3180),
    [anon_sym_GT] = ACTIONS(3180),
    [anon_sym_GT_GT] = ACTIONS(3178),
    [anon_sym_AMP_GT] = ACTIONS(3180),
    [anon_sym_AMP_GT_GT] = ACTIONS(3178),
    [anon_sym_LT_AMP] = ACTIONS(3178),
    [anon_sym_GT_AMP] = ACTIONS(3178),
    [sym__special_characters] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_DOLLAR] = ACTIONS(3180),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3178),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3178),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(3178),
    [anon_sym_GT_LPAREN] = ACTIONS(3178),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3180),
    [anon_sym_LF] = ACTIONS(3178),
    [anon_sym_AMP] = ACTIONS(3180),
  },
  [2560] = {
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1724),
    [sym_variable_name] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2561] = {
    [aux_sym_concatenation_repeat1] = STATE(2561),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(6125),
    [sym_variable_name] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [sym__special_characters] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LT_LPAREN] = ACTIONS(1724),
    [anon_sym_GT_LPAREN] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1726),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2562] = {
    [sym_file_descriptor] = ACTIONS(1731),
    [sym__concat] = ACTIONS(1731),
    [sym_variable_name] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_esac] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [anon_sym_PIPE_AMP] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1731),
    [anon_sym_AMP_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT_GT] = ACTIONS(1731),
    [anon_sym_LT_AMP] = ACTIONS(1731),
    [anon_sym_GT_AMP] = ACTIONS(1731),
    [sym__special_characters] = ACTIONS(1731),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1733),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1731),
    [anon_sym_BQUOTE] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1731),
    [anon_sym_GT_LPAREN] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1733),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [2563] = {
    [anon_sym_DQUOTE] = ACTIONS(6128),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [2564] = {
    [sym_concatenation] = STATE(2687),
    [sym_string] = STATE(2686),
    [sym_simple_expansion] = STATE(2686),
    [sym_string_expansion] = STATE(2686),
    [sym_expansion] = STATE(2686),
    [sym_command_substitution] = STATE(2686),
    [sym_process_substitution] = STATE(2686),
    [anon_sym_RBRACE] = ACTIONS(6130),
    [sym__special_characters] = ACTIONS(6132),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(6134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6134),
  },
  [2565] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(6136),
    [sym_comment] = ACTIONS(53),
  },
  [2566] = {
    [sym_concatenation] = STATE(2691),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2691),
    [anon_sym_RBRACE] = ACTIONS(6138),
    [anon_sym_EQ] = ACTIONS(6140),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6140),
    [anon_sym_COLON_QMARK] = ACTIONS(6140),
    [anon_sym_COLON_DASH] = ACTIONS(6140),
    [anon_sym_PERCENT] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2567] = {
    [sym_concatenation] = STATE(2693),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2693),
    [anon_sym_RBRACE] = ACTIONS(6130),
    [anon_sym_EQ] = ACTIONS(6146),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(6150),
    [anon_sym_COLON] = ACTIONS(6146),
    [anon_sym_COLON_QMARK] = ACTIONS(6146),
    [anon_sym_COLON_DASH] = ACTIONS(6146),
    [anon_sym_PERCENT] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6146),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2568] = {
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [sym_variable_name] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_esac] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [sym__special_characters] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym_raw_string] = ACTIONS(1832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1832),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [2569] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6152),
  },
  [2570] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6154),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2571] = {
    [sym_file_descriptor] = ACTIONS(1876),
    [sym__concat] = ACTIONS(1876),
    [sym_variable_name] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [anon_sym_PIPE_AMP] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_GT_GT] = ACTIONS(1876),
    [anon_sym_AMP_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT_GT] = ACTIONS(1876),
    [anon_sym_LT_AMP] = ACTIONS(1876),
    [anon_sym_GT_AMP] = ACTIONS(1876),
    [sym__special_characters] = ACTIONS(1876),
    [anon_sym_DQUOTE] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [sym_raw_string] = ACTIONS(1876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1876),
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [anon_sym_LT_LPAREN] = ACTIONS(1876),
    [anon_sym_GT_LPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [2572] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6156),
  },
  [2573] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6130),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2574] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6158),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2575] = {
    [sym_file_descriptor] = ACTIONS(1884),
    [sym__concat] = ACTIONS(1884),
    [sym_variable_name] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_esac] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_GT] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT] = ACTIONS(1886),
    [anon_sym_AMP_GT_GT] = ACTIONS(1884),
    [anon_sym_LT_AMP] = ACTIONS(1884),
    [anon_sym_GT_AMP] = ACTIONS(1884),
    [sym__special_characters] = ACTIONS(1884),
    [anon_sym_DQUOTE] = ACTIONS(1884),
    [anon_sym_DOLLAR] = ACTIONS(1886),
    [sym_raw_string] = ACTIONS(1884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1884),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(1884),
    [anon_sym_GT_LPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [2576] = {
    [anon_sym_SEMI] = ACTIONS(6160),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6158),
    [anon_sym_SEMI_SEMI] = ACTIONS(6162),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(6162),
    [anon_sym_AMP] = ACTIONS(6160),
  },
  [2577] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(6160),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6158),
    [anon_sym_SEMI_SEMI] = ACTIONS(6162),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(6162),
    [anon_sym_AMP] = ACTIONS(6160),
  },
  [2578] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(6158),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2579] = {
    [anon_sym_SEMI] = ACTIONS(6164),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(6166),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(6158),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(6166),
    [anon_sym_AMP] = ACTIONS(6164),
  },
  [2580] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(6164),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(6166),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(6158),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(6166),
    [anon_sym_AMP] = ACTIONS(6164),
  },
  [2581] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2582] = {
    [sym_file_descriptor] = ACTIONS(1916),
    [sym__concat] = ACTIONS(1916),
    [sym_variable_name] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_esac] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1916),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT_GT] = ACTIONS(1916),
    [anon_sym_LT_AMP] = ACTIONS(1916),
    [anon_sym_GT_AMP] = ACTIONS(1916),
    [sym__special_characters] = ACTIONS(1916),
    [anon_sym_DQUOTE] = ACTIONS(1916),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1916),
    [anon_sym_GT_LPAREN] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [2583] = {
    [anon_sym_SEMI] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_SEMI_SEMI] = ACTIONS(6172),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(6172),
    [anon_sym_AMP] = ACTIONS(6170),
  },
  [2584] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_SEMI_SEMI] = ACTIONS(6172),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(6172),
    [anon_sym_AMP] = ACTIONS(6170),
  },
  [2585] = {
    [sym_file_redirect] = STATE(1541),
    [sym_file_descriptor] = ACTIONS(5499),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_esac] = ACTIONS(3520),
    [anon_sym_PIPE] = ACTIONS(3522),
    [anon_sym_SEMI_SEMI] = ACTIONS(3520),
    [anon_sym_PIPE_AMP] = ACTIONS(3520),
    [anon_sym_AMP_AMP] = ACTIONS(3520),
    [anon_sym_PIPE_PIPE] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(5501),
    [anon_sym_GT] = ACTIONS(5501),
    [anon_sym_GT_GT] = ACTIONS(5503),
    [anon_sym_AMP_GT] = ACTIONS(5501),
    [anon_sym_AMP_GT_GT] = ACTIONS(5503),
    [anon_sym_LT_AMP] = ACTIONS(5503),
    [anon_sym_GT_AMP] = ACTIONS(5503),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3522),
  },
  [2586] = {
    [sym_concatenation] = STATE(1544),
    [sym_string] = STATE(2703),
    [sym_simple_expansion] = STATE(2703),
    [sym_string_expansion] = STATE(2703),
    [sym_expansion] = STATE(2703),
    [sym_command_substitution] = STATE(2703),
    [sym_process_substitution] = STATE(2703),
    [sym__special_characters] = ACTIONS(6174),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(6176),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6176),
  },
  [2587] = {
    [aux_sym_concatenation_repeat1] = STATE(2704),
    [sym__concat] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [2588] = {
    [aux_sym_concatenation_repeat1] = STATE(2704),
    [sym__concat] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_esac] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [2589] = {
    [sym_concatenation] = STATE(1574),
    [sym_string] = STATE(2706),
    [sym_simple_expansion] = STATE(2706),
    [sym_string_expansion] = STATE(2706),
    [sym_expansion] = STATE(2706),
    [sym_command_substitution] = STATE(2706),
    [sym_process_substitution] = STATE(2706),
    [sym__special_characters] = ACTIONS(6178),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(6180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2620),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LT_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_LPAREN] = ACTIONS(2624),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6180),
  },
  [2590] = {
    [aux_sym_concatenation_repeat1] = STATE(2707),
    [sym_file_descriptor] = ACTIONS(731),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_esac] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_LT_LT_LT] = ACTIONS(731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(735),
  },
  [2591] = {
    [aux_sym_concatenation_repeat1] = STATE(2707),
    [sym_file_descriptor] = ACTIONS(749),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_esac] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(749),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(749),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(749),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(749),
    [anon_sym_LT_AMP] = ACTIONS(749),
    [anon_sym_GT_AMP] = ACTIONS(749),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_LT_LT_DASH] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(749),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [2592] = {
    [aux_sym_concatenation_repeat1] = STATE(2707),
    [sym_file_descriptor] = ACTIONS(1972),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_esac] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_PIPE_AMP] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_PIPE_PIPE] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_AMP_GT] = ACTIONS(1974),
    [anon_sym_AMP_GT_GT] = ACTIONS(1972),
    [anon_sym_LT_AMP] = ACTIONS(1972),
    [anon_sym_GT_AMP] = ACTIONS(1972),
    [anon_sym_LT_LT] = ACTIONS(1974),
    [anon_sym_LT_LT_DASH] = ACTIONS(1972),
    [anon_sym_LT_LT_LT] = ACTIONS(1972),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1974),
  },
  [2593] = {
    [aux_sym_concatenation_repeat1] = STATE(2707),
    [sym_file_descriptor] = ACTIONS(1976),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_esac] = ACTIONS(1976),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(1976),
    [anon_sym_AMP_AMP] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP_GT] = ACTIONS(1978),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_LT_LT_DASH] = ACTIONS(1976),
    [anon_sym_LT_LT_LT] = ACTIONS(1976),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1978),
  },
  [2594] = {
    [sym_file_redirect] = STATE(2594),
    [sym_heredoc_redirect] = STATE(2594),
    [sym_herestring_redirect] = STATE(2594),
    [aux_sym_while_statement_repeat1] = STATE(2594),
    [sym_file_descriptor] = ACTIONS(6182),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_esac] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(6185),
    [anon_sym_GT] = ACTIONS(6185),
    [anon_sym_GT_GT] = ACTIONS(6188),
    [anon_sym_AMP_GT] = ACTIONS(6185),
    [anon_sym_AMP_GT_GT] = ACTIONS(6188),
    [anon_sym_LT_AMP] = ACTIONS(6188),
    [anon_sym_GT_AMP] = ACTIONS(6188),
    [anon_sym_LT_LT] = ACTIONS(3625),
    [anon_sym_LT_LT_DASH] = ACTIONS(3628),
    [anon_sym_LT_LT_LT] = ACTIONS(6191),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1989),
  },
  [2595] = {
    [sym_variable_name] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_esac] = ACTIONS(2058),
    [anon_sym_PIPE] = ACTIONS(2058),
    [anon_sym_SEMI_SEMI] = ACTIONS(2056),
    [anon_sym_PIPE_AMP] = ACTIONS(2056),
    [anon_sym_AMP_AMP] = ACTIONS(2056),
    [anon_sym_PIPE_PIPE] = ACTIONS(2056),
    [sym__special_characters] = ACTIONS(2056),
    [anon_sym_DQUOTE] = ACTIONS(2056),
    [anon_sym_DOLLAR] = ACTIONS(2058),
    [sym_raw_string] = ACTIONS(2056),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2056),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2056),
    [anon_sym_BQUOTE] = ACTIONS(2056),
    [anon_sym_LT_LPAREN] = ACTIONS(2056),
    [anon_sym_GT_LPAREN] = ACTIONS(2056),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2058),
    [sym_word] = ACTIONS(2058),
    [anon_sym_LF] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2058),
  },
  [2596] = {
    [sym_concatenation] = STATE(977),
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_string_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [aux_sym_for_statement_repeat1] = STATE(977),
    [anon_sym_RPAREN] = ACTIONS(6194),
    [sym__special_characters] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym_raw_string] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1085),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1091),
    [anon_sym_GT_LPAREN] = ACTIONS(1091),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(1083),
  },
  [2597] = {
    [sym__concat] = ACTIONS(2876),
    [sym_variable_name] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_esac] = ACTIONS(2878),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [sym__special_characters] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [anon_sym_LT_LPAREN] = ACTIONS(2876),
    [anon_sym_GT_LPAREN] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2878),
    [sym_word] = ACTIONS(2878),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2878),
  },
  [2598] = {
    [sym__concat] = ACTIONS(2890),
    [sym_variable_name] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_esac] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [anon_sym_PIPE_AMP] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [sym__special_characters] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [anon_sym_LT_LPAREN] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2892),
    [sym_word] = ACTIONS(2892),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2892),
  },
  [2599] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6196),
    [sym_comment] = ACTIONS(53),
  },
  [2600] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6198),
    [sym_comment] = ACTIONS(53),
  },
  [2601] = {
    [anon_sym_RBRACE] = ACTIONS(6198),
    [sym_comment] = ACTIONS(53),
  },
  [2602] = {
    [sym_concatenation] = STATE(2713),
    [sym_string] = STATE(2712),
    [sym_simple_expansion] = STATE(2712),
    [sym_string_expansion] = STATE(2712),
    [sym_expansion] = STATE(2712),
    [sym_command_substitution] = STATE(2712),
    [sym_process_substitution] = STATE(2712),
    [anon_sym_RBRACE] = ACTIONS(6198),
    [sym__special_characters] = ACTIONS(6200),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(6202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6202),
  },
  [2603] = {
    [sym__concat] = ACTIONS(2926),
    [sym_variable_name] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_esac] = ACTIONS(2928),
    [anon_sym_PIPE] = ACTIONS(2928),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE_AMP] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [sym__special_characters] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym_raw_string] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [anon_sym_LT_LPAREN] = ACTIONS(2926),
    [anon_sym_GT_LPAREN] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2928),
    [sym_word] = ACTIONS(2928),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2928),
  },
  [2604] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6204),
  },
  [2605] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6206),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2606] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6208),
  },
  [2607] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6198),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2608] = {
    [sym_concatenation] = STATE(2718),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2718),
    [anon_sym_RBRACE] = ACTIONS(6210),
    [anon_sym_EQ] = ACTIONS(6212),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6214),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6212),
    [anon_sym_COLON_QMARK] = ACTIONS(6212),
    [anon_sym_COLON_DASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [anon_sym_DASH] = ACTIONS(6212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2609] = {
    [sym__concat] = ACTIONS(2990),
    [sym_variable_name] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_esac] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(2992),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [anon_sym_PIPE_AMP] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [sym__special_characters] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym_raw_string] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_LT_LPAREN] = ACTIONS(2990),
    [anon_sym_GT_LPAREN] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2992),
    [sym_word] = ACTIONS(2992),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2992),
  },
  [2610] = {
    [sym_concatenation] = STATE(2719),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2719),
    [anon_sym_RBRACE] = ACTIONS(6198),
    [anon_sym_EQ] = ACTIONS(6216),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6218),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6216),
    [anon_sym_COLON_QMARK] = ACTIONS(6216),
    [anon_sym_COLON_DASH] = ACTIONS(6216),
    [anon_sym_PERCENT] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6216),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2611] = {
    [sym__concat] = ACTIONS(3033),
    [sym_variable_name] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_esac] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [anon_sym_PIPE_AMP] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [sym__special_characters] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [anon_sym_LT_LPAREN] = ACTIONS(3033),
    [anon_sym_GT_LPAREN] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3035),
    [sym_word] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3035),
  },
  [2612] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6220),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2613] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(6220),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2614] = {
    [sym__concat] = ACTIONS(3071),
    [sym_variable_name] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_esac] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [anon_sym_PIPE_AMP] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [sym__special_characters] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [sym_raw_string] = ACTIONS(3071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_LT_LPAREN] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3073),
    [sym_word] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
  },
  [2615] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6222),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2616] = {
    [sym__concat] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_esac] = ACTIONS(2878),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [sym__special_characters] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [anon_sym_LT_LPAREN] = ACTIONS(2876),
    [anon_sym_GT_LPAREN] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2878),
    [sym_word] = ACTIONS(2878),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2878),
  },
  [2617] = {
    [sym__concat] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_esac] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [anon_sym_PIPE_AMP] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [sym__special_characters] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [anon_sym_LT_LPAREN] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2892),
    [sym_word] = ACTIONS(2892),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2892),
  },
  [2618] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6224),
    [sym_comment] = ACTIONS(53),
  },
  [2619] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6226),
    [sym_comment] = ACTIONS(53),
  },
  [2620] = {
    [anon_sym_RBRACE] = ACTIONS(6226),
    [sym_comment] = ACTIONS(53),
  },
  [2621] = {
    [sym_concatenation] = STATE(2726),
    [sym_string] = STATE(2725),
    [sym_simple_expansion] = STATE(2725),
    [sym_string_expansion] = STATE(2725),
    [sym_expansion] = STATE(2725),
    [sym_command_substitution] = STATE(2725),
    [sym_process_substitution] = STATE(2725),
    [anon_sym_RBRACE] = ACTIONS(6226),
    [sym__special_characters] = ACTIONS(6228),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(6230),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6230),
  },
  [2622] = {
    [sym__concat] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_esac] = ACTIONS(2928),
    [anon_sym_PIPE] = ACTIONS(2928),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE_AMP] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [sym__special_characters] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym_raw_string] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [anon_sym_LT_LPAREN] = ACTIONS(2926),
    [anon_sym_GT_LPAREN] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2928),
    [sym_word] = ACTIONS(2928),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2928),
  },
  [2623] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6232),
  },
  [2624] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6234),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2625] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6236),
  },
  [2626] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6226),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2627] = {
    [sym_concatenation] = STATE(2731),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2731),
    [anon_sym_RBRACE] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6240),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6240),
    [anon_sym_COLON_QMARK] = ACTIONS(6240),
    [anon_sym_COLON_DASH] = ACTIONS(6240),
    [anon_sym_PERCENT] = ACTIONS(6240),
    [anon_sym_DASH] = ACTIONS(6240),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2628] = {
    [sym__concat] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_esac] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(2992),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [anon_sym_PIPE_AMP] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [sym__special_characters] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym_raw_string] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_LT_LPAREN] = ACTIONS(2990),
    [anon_sym_GT_LPAREN] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2992),
    [sym_word] = ACTIONS(2992),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2992),
  },
  [2629] = {
    [sym_concatenation] = STATE(2732),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2732),
    [anon_sym_RBRACE] = ACTIONS(6226),
    [anon_sym_EQ] = ACTIONS(6244),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6246),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6244),
    [anon_sym_COLON_QMARK] = ACTIONS(6244),
    [anon_sym_COLON_DASH] = ACTIONS(6244),
    [anon_sym_PERCENT] = ACTIONS(6244),
    [anon_sym_DASH] = ACTIONS(6244),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2630] = {
    [sym__concat] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_esac] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [anon_sym_PIPE_AMP] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [sym__special_characters] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [anon_sym_LT_LPAREN] = ACTIONS(3033),
    [anon_sym_GT_LPAREN] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3035),
    [sym_word] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3035),
  },
  [2631] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6248),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2632] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(6248),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2633] = {
    [sym__concat] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_esac] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [anon_sym_PIPE_AMP] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [sym__special_characters] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [sym_raw_string] = ACTIONS(3071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_LT_LPAREN] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3073),
    [sym_word] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
  },
  [2634] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2635] = {
    [sym__simple_heredoc_body] = ACTIONS(3788),
    [sym__heredoc_body_beginning] = ACTIONS(3788),
    [sym_file_descriptor] = ACTIONS(3788),
    [sym__concat] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_esac] = ACTIONS(3790),
    [anon_sym_PIPE] = ACTIONS(3790),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [anon_sym_PIPE_AMP] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_EQ_TILDE] = ACTIONS(3790),
    [anon_sym_EQ_EQ] = ACTIONS(3790),
    [anon_sym_LT] = ACTIONS(3790),
    [anon_sym_GT] = ACTIONS(3790),
    [anon_sym_GT_GT] = ACTIONS(3788),
    [anon_sym_AMP_GT] = ACTIONS(3790),
    [anon_sym_AMP_GT_GT] = ACTIONS(3788),
    [anon_sym_LT_AMP] = ACTIONS(3788),
    [anon_sym_GT_AMP] = ACTIONS(3788),
    [anon_sym_LT_LT] = ACTIONS(3790),
    [anon_sym_LT_LT_DASH] = ACTIONS(3788),
    [anon_sym_LT_LT_LT] = ACTIONS(3788),
    [sym__special_characters] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LT_LPAREN] = ACTIONS(3788),
    [anon_sym_GT_LPAREN] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3790),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3790),
  },
  [2636] = {
    [sym__simple_heredoc_body] = ACTIONS(3796),
    [sym__heredoc_body_beginning] = ACTIONS(3796),
    [sym_file_descriptor] = ACTIONS(3796),
    [sym__concat] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_esac] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3798),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [anon_sym_PIPE_AMP] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [anon_sym_EQ_TILDE] = ACTIONS(3798),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_GT] = ACTIONS(3798),
    [anon_sym_GT_GT] = ACTIONS(3796),
    [anon_sym_AMP_GT] = ACTIONS(3798),
    [anon_sym_AMP_GT_GT] = ACTIONS(3796),
    [anon_sym_LT_AMP] = ACTIONS(3796),
    [anon_sym_GT_AMP] = ACTIONS(3796),
    [anon_sym_LT_LT] = ACTIONS(3798),
    [anon_sym_LT_LT_DASH] = ACTIONS(3796),
    [anon_sym_LT_LT_LT] = ACTIONS(3796),
    [sym__special_characters] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym_raw_string] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3796),
    [anon_sym_GT_LPAREN] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3798),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3798),
  },
  [2637] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [sym_comment] = ACTIONS(53),
  },
  [2638] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6254),
    [sym_comment] = ACTIONS(53),
  },
  [2639] = {
    [anon_sym_RBRACE] = ACTIONS(6254),
    [sym_comment] = ACTIONS(53),
  },
  [2640] = {
    [sym_concatenation] = STATE(2738),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2738),
    [anon_sym_RBRACE] = ACTIONS(6256),
    [anon_sym_EQ] = ACTIONS(6258),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6260),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6258),
    [anon_sym_COLON_QMARK] = ACTIONS(6258),
    [anon_sym_COLON_DASH] = ACTIONS(6258),
    [anon_sym_PERCENT] = ACTIONS(6258),
    [anon_sym_DASH] = ACTIONS(6258),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2641] = {
    [sym__simple_heredoc_body] = ACTIONS(3852),
    [sym__heredoc_body_beginning] = ACTIONS(3852),
    [sym_file_descriptor] = ACTIONS(3852),
    [sym__concat] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_esac] = ACTIONS(3854),
    [anon_sym_PIPE] = ACTIONS(3854),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [anon_sym_PIPE_AMP] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_EQ_TILDE] = ACTIONS(3854),
    [anon_sym_EQ_EQ] = ACTIONS(3854),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_GT] = ACTIONS(3854),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_AMP_GT] = ACTIONS(3854),
    [anon_sym_AMP_GT_GT] = ACTIONS(3852),
    [anon_sym_LT_AMP] = ACTIONS(3852),
    [anon_sym_GT_AMP] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3854),
    [anon_sym_LT_LT_DASH] = ACTIONS(3852),
    [anon_sym_LT_LT_LT] = ACTIONS(3852),
    [sym__special_characters] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym_raw_string] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_LT_LPAREN] = ACTIONS(3852),
    [anon_sym_GT_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3854),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3854),
  },
  [2642] = {
    [sym_concatenation] = STATE(2739),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2739),
    [anon_sym_RBRACE] = ACTIONS(6254),
    [anon_sym_EQ] = ACTIONS(6262),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6262),
    [anon_sym_COLON_QMARK] = ACTIONS(6262),
    [anon_sym_COLON_DASH] = ACTIONS(6262),
    [anon_sym_PERCENT] = ACTIONS(6262),
    [anon_sym_DASH] = ACTIONS(6262),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2643] = {
    [sym__simple_heredoc_body] = ACTIONS(3893),
    [sym__heredoc_body_beginning] = ACTIONS(3893),
    [sym_file_descriptor] = ACTIONS(3893),
    [sym__concat] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_esac] = ACTIONS(3895),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [anon_sym_PIPE_AMP] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_EQ_TILDE] = ACTIONS(3895),
    [anon_sym_EQ_EQ] = ACTIONS(3895),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_GT_GT] = ACTIONS(3893),
    [anon_sym_AMP_GT] = ACTIONS(3895),
    [anon_sym_AMP_GT_GT] = ACTIONS(3893),
    [anon_sym_LT_AMP] = ACTIONS(3893),
    [anon_sym_GT_AMP] = ACTIONS(3893),
    [anon_sym_LT_LT] = ACTIONS(3895),
    [anon_sym_LT_LT_DASH] = ACTIONS(3893),
    [anon_sym_LT_LT_LT] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LT_LPAREN] = ACTIONS(3893),
    [anon_sym_GT_LPAREN] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3895),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3895),
  },
  [2644] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6266),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2645] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6254),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2646] = {
    [sym__simple_heredoc_body] = ACTIONS(3915),
    [sym__heredoc_body_beginning] = ACTIONS(3915),
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_EQ_TILDE] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3915),
    [anon_sym_LT_AMP] = ACTIONS(3915),
    [anon_sym_GT_AMP] = ACTIONS(3915),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_LT_LT_DASH] = ACTIONS(3915),
    [anon_sym_LT_LT_LT] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [2647] = {
    [sym__simple_heredoc_body] = ACTIONS(3939),
    [sym__heredoc_body_beginning] = ACTIONS(3939),
    [sym_file_descriptor] = ACTIONS(3939),
    [sym__concat] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_esac] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [anon_sym_PIPE_AMP] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_EQ_TILDE] = ACTIONS(3941),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3939),
    [anon_sym_AMP_GT] = ACTIONS(3941),
    [anon_sym_AMP_GT_GT] = ACTIONS(3939),
    [anon_sym_LT_AMP] = ACTIONS(3939),
    [anon_sym_GT_AMP] = ACTIONS(3939),
    [anon_sym_LT_LT] = ACTIONS(3941),
    [anon_sym_LT_LT_DASH] = ACTIONS(3939),
    [anon_sym_LT_LT_LT] = ACTIONS(3939),
    [sym__special_characters] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [sym_raw_string] = ACTIONS(3939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LT_LPAREN] = ACTIONS(3939),
    [anon_sym_GT_LPAREN] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3941),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3941),
  },
  [2648] = {
    [sym__simple_heredoc_body] = ACTIONS(1724),
    [sym__heredoc_body_beginning] = ACTIONS(1724),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1724),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2649] = {
    [aux_sym_concatenation_repeat1] = STATE(2649),
    [sym__simple_heredoc_body] = ACTIONS(1724),
    [sym__heredoc_body_beginning] = ACTIONS(1724),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(6268),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1724),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2650] = {
    [sym__simple_heredoc_body] = ACTIONS(1731),
    [sym__heredoc_body_beginning] = ACTIONS(1731),
    [sym_file_descriptor] = ACTIONS(1731),
    [sym__concat] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_esac] = ACTIONS(1731),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1731),
    [anon_sym_PIPE_AMP] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1731),
    [anon_sym_PIPE_PIPE] = ACTIONS(1731),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1731),
    [anon_sym_AMP_GT] = ACTIONS(1733),
    [anon_sym_AMP_GT_GT] = ACTIONS(1731),
    [anon_sym_LT_AMP] = ACTIONS(1731),
    [anon_sym_GT_AMP] = ACTIONS(1731),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_LT_LT_DASH] = ACTIONS(1731),
    [anon_sym_LT_LT_LT] = ACTIONS(1731),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1733),
  },
  [2651] = {
    [anon_sym_DQUOTE] = ACTIONS(6271),
    [anon_sym_DOLLAR] = ACTIONS(775),
    [sym__string_content] = ACTIONS(777),
    [anon_sym_POUND] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [sym_comment] = ACTIONS(265),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_0] = ACTIONS(781),
    [anon_sym__] = ACTIONS(781),
  },
  [2652] = {
    [sym_concatenation] = STATE(2745),
    [sym_string] = STATE(2744),
    [sym_simple_expansion] = STATE(2744),
    [sym_string_expansion] = STATE(2744),
    [sym_expansion] = STATE(2744),
    [sym_command_substitution] = STATE(2744),
    [sym_process_substitution] = STATE(2744),
    [anon_sym_RBRACE] = ACTIONS(6273),
    [sym__special_characters] = ACTIONS(6275),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(6277),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6277),
  },
  [2653] = {
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(6279),
    [sym_comment] = ACTIONS(53),
  },
  [2654] = {
    [sym_concatenation] = STATE(2749),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2749),
    [anon_sym_RBRACE] = ACTIONS(6281),
    [anon_sym_EQ] = ACTIONS(6283),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(6287),
    [anon_sym_COLON] = ACTIONS(6283),
    [anon_sym_COLON_QMARK] = ACTIONS(6283),
    [anon_sym_COLON_DASH] = ACTIONS(6283),
    [anon_sym_PERCENT] = ACTIONS(6283),
    [anon_sym_DASH] = ACTIONS(6283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2655] = {
    [sym_concatenation] = STATE(2751),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2751),
    [anon_sym_RBRACE] = ACTIONS(6273),
    [anon_sym_EQ] = ACTIONS(6289),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(6293),
    [anon_sym_COLON] = ACTIONS(6289),
    [anon_sym_COLON_QMARK] = ACTIONS(6289),
    [anon_sym_COLON_DASH] = ACTIONS(6289),
    [anon_sym_PERCENT] = ACTIONS(6289),
    [anon_sym_DASH] = ACTIONS(6289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2656] = {
    [sym__simple_heredoc_body] = ACTIONS(1832),
    [sym__heredoc_body_beginning] = ACTIONS(1832),
    [sym_file_descriptor] = ACTIONS(1832),
    [sym__concat] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_esac] = ACTIONS(1832),
    [anon_sym_PIPE] = ACTIONS(1834),
    [anon_sym_SEMI_SEMI] = ACTIONS(1832),
    [anon_sym_PIPE_AMP] = ACTIONS(1832),
    [anon_sym_AMP_AMP] = ACTIONS(1832),
    [anon_sym_PIPE_PIPE] = ACTIONS(1832),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1832),
    [anon_sym_AMP_GT] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(1832),
    [anon_sym_LT_AMP] = ACTIONS(1832),
    [anon_sym_GT_AMP] = ACTIONS(1832),
    [anon_sym_LT_LT] = ACTIONS(1834),
    [anon_sym_LT_LT_DASH] = ACTIONS(1832),
    [anon_sym_LT_LT_LT] = ACTIONS(1832),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1832),
    [anon_sym_AMP] = ACTIONS(1834),
  },
  [2657] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6295),
  },
  [2658] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6297),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2659] = {
    [sym__simple_heredoc_body] = ACTIONS(1876),
    [sym__heredoc_body_beginning] = ACTIONS(1876),
    [sym_file_descriptor] = ACTIONS(1876),
    [sym__concat] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1876),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1876),
    [anon_sym_PIPE_AMP] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1876),
    [anon_sym_PIPE_PIPE] = ACTIONS(1876),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_GT_GT] = ACTIONS(1876),
    [anon_sym_AMP_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT_GT] = ACTIONS(1876),
    [anon_sym_LT_AMP] = ACTIONS(1876),
    [anon_sym_GT_AMP] = ACTIONS(1876),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [anon_sym_LT_LT_DASH] = ACTIONS(1876),
    [anon_sym_LT_LT_LT] = ACTIONS(1876),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_AMP] = ACTIONS(1878),
  },
  [2660] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6299),
  },
  [2661] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6273),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2662] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6301),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2663] = {
    [sym__simple_heredoc_body] = ACTIONS(1884),
    [sym__heredoc_body_beginning] = ACTIONS(1884),
    [sym_file_descriptor] = ACTIONS(1884),
    [sym__concat] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_esac] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_SEMI_SEMI] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(1884),
    [anon_sym_AMP_AMP] = ACTIONS(1884),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_GT] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1884),
    [anon_sym_AMP_GT] = ACTIONS(1886),
    [anon_sym_AMP_GT_GT] = ACTIONS(1884),
    [anon_sym_LT_AMP] = ACTIONS(1884),
    [anon_sym_GT_AMP] = ACTIONS(1884),
    [anon_sym_LT_LT] = ACTIONS(1886),
    [anon_sym_LT_LT_DASH] = ACTIONS(1884),
    [anon_sym_LT_LT_LT] = ACTIONS(1884),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_AMP] = ACTIONS(1886),
  },
  [2664] = {
    [anon_sym_SEMI] = ACTIONS(6303),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6301),
    [anon_sym_SEMI_SEMI] = ACTIONS(6305),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(6305),
    [anon_sym_AMP] = ACTIONS(6303),
  },
  [2665] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(6303),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6301),
    [anon_sym_SEMI_SEMI] = ACTIONS(6305),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(6305),
    [anon_sym_AMP] = ACTIONS(6303),
  },
  [2666] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(6301),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2667] = {
    [anon_sym_SEMI] = ACTIONS(6307),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(6309),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(6301),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(6309),
    [anon_sym_AMP] = ACTIONS(6307),
  },
  [2668] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(6307),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_SEMI_SEMI] = ACTIONS(6309),
    [anon_sym_PIPE_AMP] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(6301),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(6309),
    [anon_sym_AMP] = ACTIONS(6307),
  },
  [2669] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6311),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2670] = {
    [sym__simple_heredoc_body] = ACTIONS(1916),
    [sym__heredoc_body_beginning] = ACTIONS(1916),
    [sym_file_descriptor] = ACTIONS(1916),
    [sym__concat] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_esac] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1916),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT_GT] = ACTIONS(1916),
    [anon_sym_LT_AMP] = ACTIONS(1916),
    [anon_sym_GT_AMP] = ACTIONS(1916),
    [anon_sym_LT_LT] = ACTIONS(1918),
    [anon_sym_LT_LT_DASH] = ACTIONS(1916),
    [anon_sym_LT_LT_LT] = ACTIONS(1916),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1918),
  },
  [2671] = {
    [anon_sym_SEMI] = ACTIONS(6313),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6311),
    [anon_sym_SEMI_SEMI] = ACTIONS(6315),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(6315),
    [anon_sym_AMP] = ACTIONS(6313),
  },
  [2672] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(6313),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(6311),
    [anon_sym_SEMI_SEMI] = ACTIONS(6315),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(6315),
    [anon_sym_AMP] = ACTIONS(6313),
  },
  [2673] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(5801),
    [anon_sym_DQUOTE] = ACTIONS(5803),
    [anon_sym_DOLLAR] = ACTIONS(5801),
    [sym_raw_string] = ACTIONS(5803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5803),
    [anon_sym_BQUOTE] = ACTIONS(5803),
    [anon_sym_LT_LPAREN] = ACTIONS(5803),
    [anon_sym_GT_LPAREN] = ACTIONS(5803),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5801),
  },
  [2674] = {
    [sym__special_characters] = ACTIONS(5803),
    [anon_sym_DQUOTE] = ACTIONS(5803),
    [anon_sym_DOLLAR] = ACTIONS(5801),
    [sym_raw_string] = ACTIONS(5803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5803),
    [anon_sym_BQUOTE] = ACTIONS(5803),
    [anon_sym_LT_LPAREN] = ACTIONS(5803),
    [anon_sym_GT_LPAREN] = ACTIONS(5803),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5803),
  },
  [2675] = {
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(6317),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [2676] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(6317),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [2677] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(5811),
    [anon_sym_DQUOTE] = ACTIONS(5813),
    [anon_sym_DOLLAR] = ACTIONS(5811),
    [sym_raw_string] = ACTIONS(5813),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5813),
    [anon_sym_BQUOTE] = ACTIONS(5813),
    [anon_sym_LT_LPAREN] = ACTIONS(5813),
    [anon_sym_GT_LPAREN] = ACTIONS(5813),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5811),
  },
  [2678] = {
    [sym__special_characters] = ACTIONS(5813),
    [anon_sym_DQUOTE] = ACTIONS(5813),
    [anon_sym_DOLLAR] = ACTIONS(5811),
    [sym_raw_string] = ACTIONS(5813),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5813),
    [anon_sym_BQUOTE] = ACTIONS(5813),
    [anon_sym_LT_LPAREN] = ACTIONS(5813),
    [anon_sym_GT_LPAREN] = ACTIONS(5813),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5813),
  },
  [2679] = {
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(6319),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [2680] = {
    [sym_file_descriptor] = ACTIONS(349),
    [sym_variable_name] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_SEMI_SEMI] = ACTIONS(6319),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(351),
    [anon_sym_GT_GT] = ACTIONS(349),
    [anon_sym_AMP_GT] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(349),
    [anon_sym_LT_AMP] = ACTIONS(349),
    [anon_sym_GT_AMP] = ACTIONS(349),
    [sym__special_characters] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_DOLLAR] = ACTIONS(351),
    [sym_raw_string] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(349),
    [anon_sym_GT_LPAREN] = ACTIONS(349),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(351),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
  },
  [2681] = {
    [sym_file_descriptor] = ACTIONS(5069),
    [sym__concat] = ACTIONS(5069),
    [ts_builtin_sym_end] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_esac] = ACTIONS(5069),
    [anon_sym_PIPE] = ACTIONS(5071),
    [anon_sym_RPAREN] = ACTIONS(5069),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [anon_sym_PIPE_AMP] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [anon_sym_LT] = ACTIONS(5071),
    [anon_sym_GT] = ACTIONS(5071),
    [anon_sym_GT_GT] = ACTIONS(5069),
    [anon_sym_AMP_GT] = ACTIONS(5071),
    [anon_sym_AMP_GT_GT] = ACTIONS(5069),
    [anon_sym_LT_AMP] = ACTIONS(5069),
    [anon_sym_GT_AMP] = ACTIONS(5069),
    [anon_sym_LT_LT] = ACTIONS(5071),
    [anon_sym_LT_LT_DASH] = ACTIONS(5069),
    [anon_sym_LT_LT_LT] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5071),
  },
  [2682] = {
    [sym_file_descriptor] = ACTIONS(5073),
    [sym__concat] = ACTIONS(5073),
    [ts_builtin_sym_end] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_esac] = ACTIONS(5073),
    [anon_sym_PIPE] = ACTIONS(5075),
    [anon_sym_RPAREN] = ACTIONS(5073),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [anon_sym_PIPE_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [anon_sym_LT] = ACTIONS(5075),
    [anon_sym_GT] = ACTIONS(5075),
    [anon_sym_GT_GT] = ACTIONS(5073),
    [anon_sym_AMP_GT] = ACTIONS(5075),
    [anon_sym_AMP_GT_GT] = ACTIONS(5073),
    [anon_sym_LT_AMP] = ACTIONS(5073),
    [anon_sym_GT_AMP] = ACTIONS(5073),
    [anon_sym_LT_LT] = ACTIONS(5075),
    [anon_sym_LT_LT_DASH] = ACTIONS(5073),
    [anon_sym_LT_LT_LT] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5075),
  },
  [2683] = {
    [sym_file_descriptor] = ACTIONS(2876),
    [sym__concat] = ACTIONS(2876),
    [sym_variable_name] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_esac] = ACTIONS(2878),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [anon_sym_LT] = ACTIONS(2878),
    [anon_sym_GT] = ACTIONS(2878),
    [anon_sym_GT_GT] = ACTIONS(2876),
    [anon_sym_AMP_GT] = ACTIONS(2878),
    [anon_sym_AMP_GT_GT] = ACTIONS(2876),
    [anon_sym_LT_AMP] = ACTIONS(2876),
    [anon_sym_GT_AMP] = ACTIONS(2876),
    [sym__special_characters] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_DOLLAR] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2876),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2876),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [anon_sym_LT_LPAREN] = ACTIONS(2876),
    [anon_sym_GT_LPAREN] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2878),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2878),
  },
  [2684] = {
    [sym_file_descriptor] = ACTIONS(2890),
    [sym__concat] = ACTIONS(2890),
    [sym_variable_name] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_esac] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [anon_sym_PIPE_AMP] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2890),
    [anon_sym_AMP_GT] = ACTIONS(2892),
    [anon_sym_AMP_GT_GT] = ACTIONS(2890),
    [anon_sym_LT_AMP] = ACTIONS(2890),
    [anon_sym_GT_AMP] = ACTIONS(2890),
    [sym__special_characters] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [anon_sym_LT_LPAREN] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2892),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2892),
  },
  [2685] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6321),
    [sym_comment] = ACTIONS(53),
  },
  [2686] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6323),
    [sym_comment] = ACTIONS(53),
  },
  [2687] = {
    [anon_sym_RBRACE] = ACTIONS(6323),
    [sym_comment] = ACTIONS(53),
  },
  [2688] = {
    [sym_concatenation] = STATE(2766),
    [sym_string] = STATE(2765),
    [sym_simple_expansion] = STATE(2765),
    [sym_string_expansion] = STATE(2765),
    [sym_expansion] = STATE(2765),
    [sym_command_substitution] = STATE(2765),
    [sym_process_substitution] = STATE(2765),
    [anon_sym_RBRACE] = ACTIONS(6323),
    [sym__special_characters] = ACTIONS(6325),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(6327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6327),
  },
  [2689] = {
    [sym_file_descriptor] = ACTIONS(2926),
    [sym__concat] = ACTIONS(2926),
    [sym_variable_name] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_esac] = ACTIONS(2928),
    [anon_sym_PIPE] = ACTIONS(2928),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE_AMP] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_GT] = ACTIONS(2928),
    [anon_sym_GT_GT] = ACTIONS(2926),
    [anon_sym_AMP_GT] = ACTIONS(2928),
    [anon_sym_AMP_GT_GT] = ACTIONS(2926),
    [anon_sym_LT_AMP] = ACTIONS(2926),
    [anon_sym_GT_AMP] = ACTIONS(2926),
    [sym__special_characters] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_DOLLAR] = ACTIONS(2928),
    [sym_raw_string] = ACTIONS(2926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2926),
    [anon_sym_BQUOTE] = ACTIONS(2926),
    [anon_sym_LT_LPAREN] = ACTIONS(2926),
    [anon_sym_GT_LPAREN] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2928),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2928),
  },
  [2690] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6329),
  },
  [2691] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6331),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2692] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6333),
  },
  [2693] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6323),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2694] = {
    [sym_concatenation] = STATE(2771),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2771),
    [anon_sym_RBRACE] = ACTIONS(6335),
    [anon_sym_EQ] = ACTIONS(6337),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6337),
    [anon_sym_COLON_QMARK] = ACTIONS(6337),
    [anon_sym_COLON_DASH] = ACTIONS(6337),
    [anon_sym_PERCENT] = ACTIONS(6337),
    [anon_sym_DASH] = ACTIONS(6337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2695] = {
    [sym_file_descriptor] = ACTIONS(2990),
    [sym__concat] = ACTIONS(2990),
    [sym_variable_name] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_esac] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(2992),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [anon_sym_PIPE_AMP] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(2990),
    [anon_sym_AMP_GT] = ACTIONS(2992),
    [anon_sym_AMP_GT_GT] = ACTIONS(2990),
    [anon_sym_LT_AMP] = ACTIONS(2990),
    [anon_sym_GT_AMP] = ACTIONS(2990),
    [sym__special_characters] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [sym_raw_string] = ACTIONS(2990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2990),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2990),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_LT_LPAREN] = ACTIONS(2990),
    [anon_sym_GT_LPAREN] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(2992),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2992),
  },
  [2696] = {
    [sym_concatenation] = STATE(2772),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2772),
    [anon_sym_RBRACE] = ACTIONS(6323),
    [anon_sym_EQ] = ACTIONS(6341),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_COLON_QMARK] = ACTIONS(6341),
    [anon_sym_COLON_DASH] = ACTIONS(6341),
    [anon_sym_PERCENT] = ACTIONS(6341),
    [anon_sym_DASH] = ACTIONS(6341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2697] = {
    [sym_file_descriptor] = ACTIONS(3033),
    [sym__concat] = ACTIONS(3033),
    [sym_variable_name] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_esac] = ACTIONS(3035),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [anon_sym_PIPE_AMP] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_GT_GT] = ACTIONS(3033),
    [anon_sym_AMP_GT] = ACTIONS(3035),
    [anon_sym_AMP_GT_GT] = ACTIONS(3033),
    [anon_sym_LT_AMP] = ACTIONS(3033),
    [anon_sym_GT_AMP] = ACTIONS(3033),
    [sym__special_characters] = ACTIONS(3033),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [sym_raw_string] = ACTIONS(3033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3033),
    [anon_sym_BQUOTE] = ACTIONS(3033),
    [anon_sym_LT_LPAREN] = ACTIONS(3033),
    [anon_sym_GT_LPAREN] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3035),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3035),
  },
  [2698] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6345),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2699] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(6345),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2700] = {
    [sym_file_descriptor] = ACTIONS(3071),
    [sym__concat] = ACTIONS(3071),
    [sym_variable_name] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_esac] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [anon_sym_PIPE_AMP] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_GT_GT] = ACTIONS(3071),
    [anon_sym_AMP_GT] = ACTIONS(3073),
    [anon_sym_AMP_GT_GT] = ACTIONS(3071),
    [anon_sym_LT_AMP] = ACTIONS(3071),
    [anon_sym_GT_AMP] = ACTIONS(3071),
    [sym__special_characters] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [sym_raw_string] = ACTIONS(3071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_LT_LPAREN] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3073),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
  },
  [2701] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6347),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2702] = {
    [aux_sym_concatenation_repeat1] = STATE(2704),
    [sym__concat] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_esac] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2703] = {
    [aux_sym_concatenation_repeat1] = STATE(2704),
    [sym__concat] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_esac] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2704] = {
    [aux_sym_concatenation_repeat1] = STATE(2775),
    [sym__concat] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_esac] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [2705] = {
    [aux_sym_concatenation_repeat1] = STATE(2707),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_esac] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1055),
    [anon_sym_LT_LT_DASH] = ACTIONS(1053),
    [anon_sym_LT_LT_LT] = ACTIONS(1053),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
  },
  [2706] = {
    [aux_sym_concatenation_repeat1] = STATE(2707),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_esac] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2707] = {
    [aux_sym_concatenation_repeat1] = STATE(2776),
    [sym_file_descriptor] = ACTIONS(765),
    [sym__concat] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_esac] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(765),
    [anon_sym_LT_AMP] = ACTIONS(765),
    [anon_sym_GT_AMP] = ACTIONS(765),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_LT_LT_DASH] = ACTIONS(765),
    [anon_sym_LT_LT_LT] = ACTIONS(765),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [2708] = {
    [sym_variable_name] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym_esac] = ACTIONS(3180),
    [anon_sym_PIPE] = ACTIONS(3180),
    [anon_sym_SEMI_SEMI] = ACTIONS(3178),
    [anon_sym_PIPE_AMP] = ACTIONS(3178),
    [anon_sym_AMP_AMP] = ACTIONS(3178),
    [anon_sym_PIPE_PIPE] = ACTIONS(3178),
    [sym__special_characters] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_DOLLAR] = ACTIONS(3180),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3178),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3178),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(3178),
    [anon_sym_GT_LPAREN] = ACTIONS(3178),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3180),
    [sym_word] = ACTIONS(3180),
    [anon_sym_LF] = ACTIONS(3178),
    [anon_sym_AMP] = ACTIONS(3180),
  },
  [2709] = {
    [sym__concat] = ACTIONS(3788),
    [sym_variable_name] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_esac] = ACTIONS(3790),
    [anon_sym_PIPE] = ACTIONS(3790),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [anon_sym_PIPE_AMP] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [sym__special_characters] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LT_LPAREN] = ACTIONS(3788),
    [anon_sym_GT_LPAREN] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3790),
    [sym_word] = ACTIONS(3790),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3790),
  },
  [2710] = {
    [sym__concat] = ACTIONS(3796),
    [sym_variable_name] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_esac] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3798),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [anon_sym_PIPE_AMP] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [sym__special_characters] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym_raw_string] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3796),
    [anon_sym_GT_LPAREN] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3798),
    [sym_word] = ACTIONS(3798),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3798),
  },
  [2711] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6349),
    [sym_comment] = ACTIONS(53),
  },
  [2712] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6351),
    [sym_comment] = ACTIONS(53),
  },
  [2713] = {
    [anon_sym_RBRACE] = ACTIONS(6351),
    [sym_comment] = ACTIONS(53),
  },
  [2714] = {
    [sym_concatenation] = STATE(2780),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2780),
    [anon_sym_RBRACE] = ACTIONS(6353),
    [anon_sym_EQ] = ACTIONS(6355),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6355),
    [anon_sym_COLON_QMARK] = ACTIONS(6355),
    [anon_sym_COLON_DASH] = ACTIONS(6355),
    [anon_sym_PERCENT] = ACTIONS(6355),
    [anon_sym_DASH] = ACTIONS(6355),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2715] = {
    [sym__concat] = ACTIONS(3852),
    [sym_variable_name] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_esac] = ACTIONS(3854),
    [anon_sym_PIPE] = ACTIONS(3854),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [anon_sym_PIPE_AMP] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [sym__special_characters] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym_raw_string] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_LT_LPAREN] = ACTIONS(3852),
    [anon_sym_GT_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3854),
    [sym_word] = ACTIONS(3854),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3854),
  },
  [2716] = {
    [sym_concatenation] = STATE(2781),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2781),
    [anon_sym_RBRACE] = ACTIONS(6351),
    [anon_sym_EQ] = ACTIONS(6359),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6359),
    [anon_sym_COLON_QMARK] = ACTIONS(6359),
    [anon_sym_COLON_DASH] = ACTIONS(6359),
    [anon_sym_PERCENT] = ACTIONS(6359),
    [anon_sym_DASH] = ACTIONS(6359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2717] = {
    [sym__concat] = ACTIONS(3893),
    [sym_variable_name] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_esac] = ACTIONS(3895),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [anon_sym_PIPE_AMP] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LT_LPAREN] = ACTIONS(3893),
    [anon_sym_GT_LPAREN] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3895),
    [sym_word] = ACTIONS(3895),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3895),
  },
  [2718] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6363),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2719] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6351),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2720] = {
    [sym__concat] = ACTIONS(3915),
    [sym_variable_name] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3917),
    [sym_word] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [2721] = {
    [sym__concat] = ACTIONS(3939),
    [sym_variable_name] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_esac] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [anon_sym_PIPE_AMP] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [sym__special_characters] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [sym_raw_string] = ACTIONS(3939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LT_LPAREN] = ACTIONS(3939),
    [anon_sym_GT_LPAREN] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3941),
    [sym_word] = ACTIONS(3941),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3941),
  },
  [2722] = {
    [sym__concat] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_esac] = ACTIONS(3790),
    [anon_sym_PIPE] = ACTIONS(3790),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [anon_sym_PIPE_AMP] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [sym__special_characters] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LT_LPAREN] = ACTIONS(3788),
    [anon_sym_GT_LPAREN] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3790),
    [sym_word] = ACTIONS(3790),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3790),
  },
  [2723] = {
    [sym__concat] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_esac] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3798),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [anon_sym_PIPE_AMP] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [sym__special_characters] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym_raw_string] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3796),
    [anon_sym_GT_LPAREN] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3798),
    [sym_word] = ACTIONS(3798),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3798),
  },
  [2724] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6365),
    [sym_comment] = ACTIONS(53),
  },
  [2725] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6367),
    [sym_comment] = ACTIONS(53),
  },
  [2726] = {
    [anon_sym_RBRACE] = ACTIONS(6367),
    [sym_comment] = ACTIONS(53),
  },
  [2727] = {
    [sym_concatenation] = STATE(2786),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2786),
    [anon_sym_RBRACE] = ACTIONS(6369),
    [anon_sym_EQ] = ACTIONS(6371),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6371),
    [anon_sym_COLON_QMARK] = ACTIONS(6371),
    [anon_sym_COLON_DASH] = ACTIONS(6371),
    [anon_sym_PERCENT] = ACTIONS(6371),
    [anon_sym_DASH] = ACTIONS(6371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2728] = {
    [sym__concat] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_esac] = ACTIONS(3854),
    [anon_sym_PIPE] = ACTIONS(3854),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [anon_sym_PIPE_AMP] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [sym__special_characters] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym_raw_string] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_LT_LPAREN] = ACTIONS(3852),
    [anon_sym_GT_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3854),
    [sym_word] = ACTIONS(3854),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3854),
  },
  [2729] = {
    [sym_concatenation] = STATE(2787),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2787),
    [anon_sym_RBRACE] = ACTIONS(6367),
    [anon_sym_EQ] = ACTIONS(6375),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6375),
    [anon_sym_COLON_QMARK] = ACTIONS(6375),
    [anon_sym_COLON_DASH] = ACTIONS(6375),
    [anon_sym_PERCENT] = ACTIONS(6375),
    [anon_sym_DASH] = ACTIONS(6375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2730] = {
    [sym__concat] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_esac] = ACTIONS(3895),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [anon_sym_PIPE_AMP] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LT_LPAREN] = ACTIONS(3893),
    [anon_sym_GT_LPAREN] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3895),
    [sym_word] = ACTIONS(3895),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3895),
  },
  [2731] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6379),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2732] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6367),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2733] = {
    [sym__concat] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3917),
    [sym_word] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [2734] = {
    [sym__concat] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_esac] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [anon_sym_PIPE_AMP] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [sym__special_characters] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [sym_raw_string] = ACTIONS(3939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LT_LPAREN] = ACTIONS(3939),
    [anon_sym_GT_LPAREN] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3941),
    [sym_word] = ACTIONS(3941),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3941),
  },
  [2735] = {
    [sym__simple_heredoc_body] = ACTIONS(4568),
    [sym__heredoc_body_beginning] = ACTIONS(4568),
    [sym_file_descriptor] = ACTIONS(4568),
    [sym__concat] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_esac] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_EQ_TILDE] = ACTIONS(4570),
    [anon_sym_EQ_EQ] = ACTIONS(4570),
    [anon_sym_LT] = ACTIONS(4570),
    [anon_sym_GT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_AMP_GT] = ACTIONS(4570),
    [anon_sym_AMP_GT_GT] = ACTIONS(4568),
    [anon_sym_LT_AMP] = ACTIONS(4568),
    [anon_sym_GT_AMP] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4570),
    [anon_sym_LT_LT_DASH] = ACTIONS(4568),
    [anon_sym_LT_LT_LT] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_LT_LPAREN] = ACTIONS(4568),
    [anon_sym_GT_LPAREN] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4570),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4570),
  },
  [2736] = {
    [sym__simple_heredoc_body] = ACTIONS(4572),
    [sym__heredoc_body_beginning] = ACTIONS(4572),
    [sym_file_descriptor] = ACTIONS(4572),
    [sym__concat] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_esac] = ACTIONS(4574),
    [anon_sym_PIPE] = ACTIONS(4574),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [anon_sym_PIPE_AMP] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [anon_sym_EQ_TILDE] = ACTIONS(4574),
    [anon_sym_EQ_EQ] = ACTIONS(4574),
    [anon_sym_LT] = ACTIONS(4574),
    [anon_sym_GT] = ACTIONS(4574),
    [anon_sym_GT_GT] = ACTIONS(4572),
    [anon_sym_AMP_GT] = ACTIONS(4574),
    [anon_sym_AMP_GT_GT] = ACTIONS(4572),
    [anon_sym_LT_AMP] = ACTIONS(4572),
    [anon_sym_GT_AMP] = ACTIONS(4572),
    [anon_sym_LT_LT] = ACTIONS(4574),
    [anon_sym_LT_LT_DASH] = ACTIONS(4572),
    [anon_sym_LT_LT_LT] = ACTIONS(4572),
    [sym__special_characters] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4574),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4574),
  },
  [2737] = {
    [sym__simple_heredoc_body] = ACTIONS(4576),
    [sym__heredoc_body_beginning] = ACTIONS(4576),
    [sym_file_descriptor] = ACTIONS(4576),
    [sym__concat] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_esac] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(4578),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [anon_sym_PIPE_AMP] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [anon_sym_EQ_TILDE] = ACTIONS(4578),
    [anon_sym_EQ_EQ] = ACTIONS(4578),
    [anon_sym_LT] = ACTIONS(4578),
    [anon_sym_GT] = ACTIONS(4578),
    [anon_sym_GT_GT] = ACTIONS(4576),
    [anon_sym_AMP_GT] = ACTIONS(4578),
    [anon_sym_AMP_GT_GT] = ACTIONS(4576),
    [anon_sym_LT_AMP] = ACTIONS(4576),
    [anon_sym_GT_AMP] = ACTIONS(4576),
    [anon_sym_LT_LT] = ACTIONS(4578),
    [anon_sym_LT_LT_DASH] = ACTIONS(4576),
    [anon_sym_LT_LT_LT] = ACTIONS(4576),
    [sym__special_characters] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_LT_LPAREN] = ACTIONS(4576),
    [anon_sym_GT_LPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4578),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4578),
  },
  [2738] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6381),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2739] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6383),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2740] = {
    [sym__simple_heredoc_body] = ACTIONS(4608),
    [sym__heredoc_body_beginning] = ACTIONS(4608),
    [sym_file_descriptor] = ACTIONS(4608),
    [sym__concat] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_esac] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4610),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [anon_sym_PIPE_AMP] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT] = ACTIONS(4610),
    [anon_sym_GT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_AMP_GT] = ACTIONS(4610),
    [anon_sym_AMP_GT_GT] = ACTIONS(4608),
    [anon_sym_LT_AMP] = ACTIONS(4608),
    [anon_sym_GT_AMP] = ACTIONS(4608),
    [anon_sym_LT_LT] = ACTIONS(4610),
    [anon_sym_LT_LT_DASH] = ACTIONS(4608),
    [anon_sym_LT_LT_LT] = ACTIONS(4608),
    [sym__special_characters] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_LT_LPAREN] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4610),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4610),
  },
  [2741] = {
    [sym__simple_heredoc_body] = ACTIONS(2876),
    [sym__heredoc_body_beginning] = ACTIONS(2876),
    [sym_file_descriptor] = ACTIONS(2876),
    [sym__concat] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_esac] = ACTIONS(2876),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_SEMI_SEMI] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2876),
    [anon_sym_PIPE_PIPE] = ACTIONS(2876),
    [anon_sym_LT] = ACTIONS(2878),
    [anon_sym_GT] = ACTIONS(2878),
    [anon_sym_GT_GT] = ACTIONS(2876),
    [anon_sym_AMP_GT] = ACTIONS(2878),
    [anon_sym_AMP_GT_GT] = ACTIONS(2876),
    [anon_sym_LT_AMP] = ACTIONS(2876),
    [anon_sym_GT_AMP] = ACTIONS(2876),
    [anon_sym_LT_LT] = ACTIONS(2878),
    [anon_sym_LT_LT_DASH] = ACTIONS(2876),
    [anon_sym_LT_LT_LT] = ACTIONS(2876),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2878),
  },
  [2742] = {
    [sym__simple_heredoc_body] = ACTIONS(2890),
    [sym__heredoc_body_beginning] = ACTIONS(2890),
    [sym_file_descriptor] = ACTIONS(2890),
    [sym__concat] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_esac] = ACTIONS(2890),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_SEMI_SEMI] = ACTIONS(2890),
    [anon_sym_PIPE_AMP] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2890),
    [anon_sym_AMP_GT] = ACTIONS(2892),
    [anon_sym_AMP_GT_GT] = ACTIONS(2890),
    [anon_sym_LT_AMP] = ACTIONS(2890),
    [anon_sym_GT_AMP] = ACTIONS(2890),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_LT_LT_DASH] = ACTIONS(2890),
    [anon_sym_LT_LT_LT] = ACTIONS(2890),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2892),
  },
  [2743] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6385),
    [sym_comment] = ACTIONS(53),
  },
  [2744] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6387),
    [sym_comment] = ACTIONS(53),
  },
  [2745] = {
    [anon_sym_RBRACE] = ACTIONS(6387),
    [sym_comment] = ACTIONS(53),
  },
  [2746] = {
    [sym_concatenation] = STATE(2795),
    [sym_string] = STATE(2794),
    [sym_simple_expansion] = STATE(2794),
    [sym_string_expansion] = STATE(2794),
    [sym_expansion] = STATE(2794),
    [sym_command_substitution] = STATE(2794),
    [sym_process_substitution] = STATE(2794),
    [anon_sym_RBRACE] = ACTIONS(6387),
    [sym__special_characters] = ACTIONS(6389),
    [anon_sym_DQUOTE] = ACTIONS(1802),
    [anon_sym_DOLLAR] = ACTIONS(1804),
    [sym_raw_string] = ACTIONS(6391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1810),
    [anon_sym_BQUOTE] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(1814),
    [anon_sym_GT_LPAREN] = ACTIONS(1814),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6391),
  },
  [2747] = {
    [sym__simple_heredoc_body] = ACTIONS(2926),
    [sym__heredoc_body_beginning] = ACTIONS(2926),
    [sym_file_descriptor] = ACTIONS(2926),
    [sym__concat] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_esac] = ACTIONS(2926),
    [anon_sym_PIPE] = ACTIONS(2928),
    [anon_sym_SEMI_SEMI] = ACTIONS(2926),
    [anon_sym_PIPE_AMP] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_GT] = ACTIONS(2928),
    [anon_sym_GT_GT] = ACTIONS(2926),
    [anon_sym_AMP_GT] = ACTIONS(2928),
    [anon_sym_AMP_GT_GT] = ACTIONS(2926),
    [anon_sym_LT_AMP] = ACTIONS(2926),
    [anon_sym_GT_AMP] = ACTIONS(2926),
    [anon_sym_LT_LT] = ACTIONS(2928),
    [anon_sym_LT_LT_DASH] = ACTIONS(2926),
    [anon_sym_LT_LT_LT] = ACTIONS(2926),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2928),
  },
  [2748] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6393),
  },
  [2749] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6395),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2750] = {
    [sym_comment] = ACTIONS(265),
    [sym_regex_without_right_brace] = ACTIONS(6397),
  },
  [2751] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6387),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2752] = {
    [sym_concatenation] = STATE(2800),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2800),
    [anon_sym_RBRACE] = ACTIONS(6399),
    [anon_sym_EQ] = ACTIONS(6401),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6401),
    [anon_sym_COLON_QMARK] = ACTIONS(6401),
    [anon_sym_COLON_DASH] = ACTIONS(6401),
    [anon_sym_PERCENT] = ACTIONS(6401),
    [anon_sym_DASH] = ACTIONS(6401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2753] = {
    [sym__simple_heredoc_body] = ACTIONS(2990),
    [sym__heredoc_body_beginning] = ACTIONS(2990),
    [sym_file_descriptor] = ACTIONS(2990),
    [sym__concat] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_esac] = ACTIONS(2990),
    [anon_sym_PIPE] = ACTIONS(2992),
    [anon_sym_SEMI_SEMI] = ACTIONS(2990),
    [anon_sym_PIPE_AMP] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(2990),
    [anon_sym_AMP_GT] = ACTIONS(2992),
    [anon_sym_AMP_GT_GT] = ACTIONS(2990),
    [anon_sym_LT_AMP] = ACTIONS(2990),
    [anon_sym_GT_AMP] = ACTIONS(2990),
    [anon_sym_LT_LT] = ACTIONS(2992),
    [anon_sym_LT_LT_DASH] = ACTIONS(2990),
    [anon_sym_LT_LT_LT] = ACTIONS(2990),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2992),
  },
  [2754] = {
    [sym_concatenation] = STATE(2801),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2801),
    [anon_sym_RBRACE] = ACTIONS(6387),
    [anon_sym_EQ] = ACTIONS(6405),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6405),
    [anon_sym_COLON_QMARK] = ACTIONS(6405),
    [anon_sym_COLON_DASH] = ACTIONS(6405),
    [anon_sym_PERCENT] = ACTIONS(6405),
    [anon_sym_DASH] = ACTIONS(6405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2755] = {
    [sym__simple_heredoc_body] = ACTIONS(3033),
    [sym__heredoc_body_beginning] = ACTIONS(3033),
    [sym_file_descriptor] = ACTIONS(3033),
    [sym__concat] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_esac] = ACTIONS(3033),
    [anon_sym_PIPE] = ACTIONS(3035),
    [anon_sym_SEMI_SEMI] = ACTIONS(3033),
    [anon_sym_PIPE_AMP] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_GT_GT] = ACTIONS(3033),
    [anon_sym_AMP_GT] = ACTIONS(3035),
    [anon_sym_AMP_GT_GT] = ACTIONS(3033),
    [anon_sym_LT_AMP] = ACTIONS(3033),
    [anon_sym_GT_AMP] = ACTIONS(3033),
    [anon_sym_LT_LT] = ACTIONS(3035),
    [anon_sym_LT_LT_DASH] = ACTIONS(3033),
    [anon_sym_LT_LT_LT] = ACTIONS(3033),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3035),
  },
  [2756] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6409),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2757] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(6409),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2758] = {
    [sym__simple_heredoc_body] = ACTIONS(3071),
    [sym__heredoc_body_beginning] = ACTIONS(3071),
    [sym_file_descriptor] = ACTIONS(3071),
    [sym__concat] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_esac] = ACTIONS(3071),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_SEMI_SEMI] = ACTIONS(3071),
    [anon_sym_PIPE_AMP] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_GT_GT] = ACTIONS(3071),
    [anon_sym_AMP_GT] = ACTIONS(3073),
    [anon_sym_AMP_GT_GT] = ACTIONS(3071),
    [anon_sym_LT_AMP] = ACTIONS(3071),
    [anon_sym_GT_AMP] = ACTIONS(3071),
    [anon_sym_LT_LT] = ACTIONS(3073),
    [anon_sym_LT_LT_DASH] = ACTIONS(3071),
    [anon_sym_LT_LT_LT] = ACTIONS(3071),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3073),
  },
  [2759] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(6411),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(901),
    [anon_sym_BQUOTE] = ACTIONS(901),
    [anon_sym_LT_LPAREN] = ACTIONS(901),
    [anon_sym_GT_LPAREN] = ACTIONS(901),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(905),
  },
  [2760] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(6103),
    [anon_sym_DQUOTE] = ACTIONS(6105),
    [anon_sym_DOLLAR] = ACTIONS(6103),
    [sym_raw_string] = ACTIONS(6105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6105),
    [anon_sym_BQUOTE] = ACTIONS(6105),
    [anon_sym_LT_LPAREN] = ACTIONS(6105),
    [anon_sym_GT_LPAREN] = ACTIONS(6105),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6103),
  },
  [2761] = {
    [sym_file_descriptor] = ACTIONS(901),
    [sym_variable_name] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_SEMI_SEMI] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeset] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_local] = ACTIONS(905),
    [anon_sym_unset] = ACTIONS(905),
    [anon_sym_unsetenv] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(905),
    [anon_sym_AMP_GT_GT] = ACTIONS(901),
    [anon_sym_LT_AMP] = ACTIONS(901),
    [anon_sym_GT_AMP] = ACTIONS(901),
    [sym__special_characters] = ACTIONS(6109),
    [anon_sym_DQUOTE] = ACTIONS(6111),
    [anon_sym_DOLLAR] = ACTIONS(6109),
    [sym_raw_string] = ACTIONS(6111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6111),
    [anon_sym_BQUOTE] = ACTIONS(6111),
    [anon_sym_LT_LPAREN] = ACTIONS(6111),
    [anon_sym_GT_LPAREN] = ACTIONS(6111),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(6109),
  },
  [2762] = {
    [sym_file_descriptor] = ACTIONS(3788),
    [sym__concat] = ACTIONS(3788),
    [sym_variable_name] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_esac] = ACTIONS(3790),
    [anon_sym_PIPE] = ACTIONS(3790),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [anon_sym_PIPE_AMP] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3790),
    [anon_sym_GT] = ACTIONS(3790),
    [anon_sym_GT_GT] = ACTIONS(3788),
    [anon_sym_AMP_GT] = ACTIONS(3790),
    [anon_sym_AMP_GT_GT] = ACTIONS(3788),
    [anon_sym_LT_AMP] = ACTIONS(3788),
    [anon_sym_GT_AMP] = ACTIONS(3788),
    [sym__special_characters] = ACTIONS(3788),
    [anon_sym_DQUOTE] = ACTIONS(3788),
    [anon_sym_DOLLAR] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3788),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LT_LPAREN] = ACTIONS(3788),
    [anon_sym_GT_LPAREN] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3790),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3790),
  },
  [2763] = {
    [sym_file_descriptor] = ACTIONS(3796),
    [sym__concat] = ACTIONS(3796),
    [sym_variable_name] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_esac] = ACTIONS(3798),
    [anon_sym_PIPE] = ACTIONS(3798),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [anon_sym_PIPE_AMP] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_GT] = ACTIONS(3798),
    [anon_sym_GT_GT] = ACTIONS(3796),
    [anon_sym_AMP_GT] = ACTIONS(3798),
    [anon_sym_AMP_GT_GT] = ACTIONS(3796),
    [anon_sym_LT_AMP] = ACTIONS(3796),
    [anon_sym_GT_AMP] = ACTIONS(3796),
    [sym__special_characters] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3796),
    [anon_sym_DOLLAR] = ACTIONS(3798),
    [sym_raw_string] = ACTIONS(3796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3796),
    [anon_sym_BQUOTE] = ACTIONS(3796),
    [anon_sym_LT_LPAREN] = ACTIONS(3796),
    [anon_sym_GT_LPAREN] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3798),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3798),
  },
  [2764] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6413),
    [sym_comment] = ACTIONS(53),
  },
  [2765] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6415),
    [sym_comment] = ACTIONS(53),
  },
  [2766] = {
    [anon_sym_RBRACE] = ACTIONS(6415),
    [sym_comment] = ACTIONS(53),
  },
  [2767] = {
    [sym_concatenation] = STATE(2807),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2807),
    [anon_sym_RBRACE] = ACTIONS(6417),
    [anon_sym_EQ] = ACTIONS(6419),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6419),
    [anon_sym_COLON_QMARK] = ACTIONS(6419),
    [anon_sym_COLON_DASH] = ACTIONS(6419),
    [anon_sym_PERCENT] = ACTIONS(6419),
    [anon_sym_DASH] = ACTIONS(6419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2768] = {
    [sym_file_descriptor] = ACTIONS(3852),
    [sym__concat] = ACTIONS(3852),
    [sym_variable_name] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_esac] = ACTIONS(3854),
    [anon_sym_PIPE] = ACTIONS(3854),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [anon_sym_PIPE_AMP] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_GT] = ACTIONS(3854),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_AMP_GT] = ACTIONS(3854),
    [anon_sym_AMP_GT_GT] = ACTIONS(3852),
    [anon_sym_LT_AMP] = ACTIONS(3852),
    [anon_sym_GT_AMP] = ACTIONS(3852),
    [sym__special_characters] = ACTIONS(3852),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_DOLLAR] = ACTIONS(3854),
    [sym_raw_string] = ACTIONS(3852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3852),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3852),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_LT_LPAREN] = ACTIONS(3852),
    [anon_sym_GT_LPAREN] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3854),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3854),
  },
  [2769] = {
    [sym_concatenation] = STATE(2808),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2808),
    [anon_sym_RBRACE] = ACTIONS(6415),
    [anon_sym_EQ] = ACTIONS(6423),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6425),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6423),
    [anon_sym_COLON_QMARK] = ACTIONS(6423),
    [anon_sym_COLON_DASH] = ACTIONS(6423),
    [anon_sym_PERCENT] = ACTIONS(6423),
    [anon_sym_DASH] = ACTIONS(6423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2770] = {
    [sym_file_descriptor] = ACTIONS(3893),
    [sym__concat] = ACTIONS(3893),
    [sym_variable_name] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_esac] = ACTIONS(3895),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [anon_sym_PIPE_AMP] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_GT_GT] = ACTIONS(3893),
    [anon_sym_AMP_GT] = ACTIONS(3895),
    [anon_sym_AMP_GT_GT] = ACTIONS(3893),
    [anon_sym_LT_AMP] = ACTIONS(3893),
    [anon_sym_GT_AMP] = ACTIONS(3893),
    [sym__special_characters] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3893),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LT_LPAREN] = ACTIONS(3893),
    [anon_sym_GT_LPAREN] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3895),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3895),
  },
  [2771] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6427),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2772] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6415),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2773] = {
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [sym_variable_name] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3915),
    [anon_sym_LT_AMP] = ACTIONS(3915),
    [anon_sym_GT_AMP] = ACTIONS(3915),
    [sym__special_characters] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [anon_sym_DOLLAR] = ACTIONS(3917),
    [sym_raw_string] = ACTIONS(3915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3915),
    [anon_sym_BQUOTE] = ACTIONS(3915),
    [anon_sym_LT_LPAREN] = ACTIONS(3915),
    [anon_sym_GT_LPAREN] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3917),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [2774] = {
    [sym_file_descriptor] = ACTIONS(3939),
    [sym__concat] = ACTIONS(3939),
    [sym_variable_name] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_esac] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [anon_sym_PIPE_AMP] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3939),
    [anon_sym_AMP_GT] = ACTIONS(3941),
    [anon_sym_AMP_GT_GT] = ACTIONS(3939),
    [anon_sym_LT_AMP] = ACTIONS(3939),
    [anon_sym_GT_AMP] = ACTIONS(3939),
    [sym__special_characters] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_DOLLAR] = ACTIONS(3941),
    [sym_raw_string] = ACTIONS(3939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LT_LPAREN] = ACTIONS(3939),
    [anon_sym_GT_LPAREN] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(3941),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3941),
  },
  [2775] = {
    [aux_sym_concatenation_repeat1] = STATE(2775),
    [sym__concat] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1724),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2776] = {
    [aux_sym_concatenation_repeat1] = STATE(2776),
    [sym_file_descriptor] = ACTIONS(1724),
    [sym__concat] = ACTIONS(4968),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_esac] = ACTIONS(1724),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_SEMI_SEMI] = ACTIONS(1724),
    [anon_sym_PIPE_AMP] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_AMP_GT] = ACTIONS(1726),
    [anon_sym_AMP_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_AMP] = ACTIONS(1724),
    [anon_sym_GT_AMP] = ACTIONS(1724),
    [anon_sym_LT_LT] = ACTIONS(1726),
    [anon_sym_LT_LT_DASH] = ACTIONS(1724),
    [anon_sym_LT_LT_LT] = ACTIONS(1724),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1726),
  },
  [2777] = {
    [sym__concat] = ACTIONS(4568),
    [sym_variable_name] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_esac] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_LT_LPAREN] = ACTIONS(4568),
    [anon_sym_GT_LPAREN] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4570),
    [sym_word] = ACTIONS(4570),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4570),
  },
  [2778] = {
    [sym__concat] = ACTIONS(4572),
    [sym_variable_name] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_esac] = ACTIONS(4574),
    [anon_sym_PIPE] = ACTIONS(4574),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [anon_sym_PIPE_AMP] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [sym__special_characters] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4574),
    [sym_word] = ACTIONS(4574),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4574),
  },
  [2779] = {
    [sym__concat] = ACTIONS(4576),
    [sym_variable_name] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_esac] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(4578),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [anon_sym_PIPE_AMP] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [sym__special_characters] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_LT_LPAREN] = ACTIONS(4576),
    [anon_sym_GT_LPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4578),
    [sym_word] = ACTIONS(4578),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4578),
  },
  [2780] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6429),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2781] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6431),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2782] = {
    [sym__concat] = ACTIONS(4608),
    [sym_variable_name] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_esac] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4610),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [anon_sym_PIPE_AMP] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [sym__special_characters] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_LT_LPAREN] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4610),
    [sym_word] = ACTIONS(4610),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4610),
  },
  [2783] = {
    [sym__concat] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_esac] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_LT_LPAREN] = ACTIONS(4568),
    [anon_sym_GT_LPAREN] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4570),
    [sym_word] = ACTIONS(4570),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4570),
  },
  [2784] = {
    [sym__concat] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_esac] = ACTIONS(4574),
    [anon_sym_PIPE] = ACTIONS(4574),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [anon_sym_PIPE_AMP] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [sym__special_characters] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4574),
    [sym_word] = ACTIONS(4574),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4574),
  },
  [2785] = {
    [sym__concat] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_esac] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(4578),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [anon_sym_PIPE_AMP] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [sym__special_characters] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_LT_LPAREN] = ACTIONS(4576),
    [anon_sym_GT_LPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4578),
    [sym_word] = ACTIONS(4578),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4578),
  },
  [2786] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6433),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2787] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6435),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2788] = {
    [sym__concat] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_esac] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4610),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [anon_sym_PIPE_AMP] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [sym__special_characters] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_LT_LPAREN] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4610),
    [sym_word] = ACTIONS(4610),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4610),
  },
  [2789] = {
    [sym__simple_heredoc_body] = ACTIONS(5069),
    [sym__heredoc_body_beginning] = ACTIONS(5069),
    [sym_file_descriptor] = ACTIONS(5069),
    [sym__concat] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_esac] = ACTIONS(5071),
    [anon_sym_PIPE] = ACTIONS(5071),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [anon_sym_PIPE_AMP] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [anon_sym_EQ_TILDE] = ACTIONS(5071),
    [anon_sym_EQ_EQ] = ACTIONS(5071),
    [anon_sym_LT] = ACTIONS(5071),
    [anon_sym_GT] = ACTIONS(5071),
    [anon_sym_GT_GT] = ACTIONS(5069),
    [anon_sym_AMP_GT] = ACTIONS(5071),
    [anon_sym_AMP_GT_GT] = ACTIONS(5069),
    [anon_sym_LT_AMP] = ACTIONS(5069),
    [anon_sym_GT_AMP] = ACTIONS(5069),
    [anon_sym_LT_LT] = ACTIONS(5071),
    [anon_sym_LT_LT_DASH] = ACTIONS(5069),
    [anon_sym_LT_LT_LT] = ACTIONS(5069),
    [sym__special_characters] = ACTIONS(5069),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [anon_sym_LT_LPAREN] = ACTIONS(5069),
    [anon_sym_GT_LPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5071),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5071),
  },
  [2790] = {
    [sym__simple_heredoc_body] = ACTIONS(5073),
    [sym__heredoc_body_beginning] = ACTIONS(5073),
    [sym_file_descriptor] = ACTIONS(5073),
    [sym__concat] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_esac] = ACTIONS(5075),
    [anon_sym_PIPE] = ACTIONS(5075),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [anon_sym_PIPE_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [anon_sym_EQ_TILDE] = ACTIONS(5075),
    [anon_sym_EQ_EQ] = ACTIONS(5075),
    [anon_sym_LT] = ACTIONS(5075),
    [anon_sym_GT] = ACTIONS(5075),
    [anon_sym_GT_GT] = ACTIONS(5073),
    [anon_sym_AMP_GT] = ACTIONS(5075),
    [anon_sym_AMP_GT_GT] = ACTIONS(5073),
    [anon_sym_LT_AMP] = ACTIONS(5073),
    [anon_sym_GT_AMP] = ACTIONS(5073),
    [anon_sym_LT_LT] = ACTIONS(5075),
    [anon_sym_LT_LT_DASH] = ACTIONS(5073),
    [anon_sym_LT_LT_LT] = ACTIONS(5073),
    [sym__special_characters] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym_raw_string] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5075),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5075),
  },
  [2791] = {
    [sym__simple_heredoc_body] = ACTIONS(3788),
    [sym__heredoc_body_beginning] = ACTIONS(3788),
    [sym_file_descriptor] = ACTIONS(3788),
    [sym__concat] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_esac] = ACTIONS(3788),
    [anon_sym_PIPE] = ACTIONS(3790),
    [anon_sym_SEMI_SEMI] = ACTIONS(3788),
    [anon_sym_PIPE_AMP] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3790),
    [anon_sym_GT] = ACTIONS(3790),
    [anon_sym_GT_GT] = ACTIONS(3788),
    [anon_sym_AMP_GT] = ACTIONS(3790),
    [anon_sym_AMP_GT_GT] = ACTIONS(3788),
    [anon_sym_LT_AMP] = ACTIONS(3788),
    [anon_sym_GT_AMP] = ACTIONS(3788),
    [anon_sym_LT_LT] = ACTIONS(3790),
    [anon_sym_LT_LT_DASH] = ACTIONS(3788),
    [anon_sym_LT_LT_LT] = ACTIONS(3788),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3790),
  },
  [2792] = {
    [sym__simple_heredoc_body] = ACTIONS(3796),
    [sym__heredoc_body_beginning] = ACTIONS(3796),
    [sym_file_descriptor] = ACTIONS(3796),
    [sym__concat] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_esac] = ACTIONS(3796),
    [anon_sym_PIPE] = ACTIONS(3798),
    [anon_sym_SEMI_SEMI] = ACTIONS(3796),
    [anon_sym_PIPE_AMP] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [anon_sym_LT] = ACTIONS(3798),
    [anon_sym_GT] = ACTIONS(3798),
    [anon_sym_GT_GT] = ACTIONS(3796),
    [anon_sym_AMP_GT] = ACTIONS(3798),
    [anon_sym_AMP_GT_GT] = ACTIONS(3796),
    [anon_sym_LT_AMP] = ACTIONS(3796),
    [anon_sym_GT_AMP] = ACTIONS(3796),
    [anon_sym_LT_LT] = ACTIONS(3798),
    [anon_sym_LT_LT_DASH] = ACTIONS(3796),
    [anon_sym_LT_LT_LT] = ACTIONS(3796),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(3798),
  },
  [2793] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6437),
    [sym_comment] = ACTIONS(53),
  },
  [2794] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__concat] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(6439),
    [sym_comment] = ACTIONS(53),
  },
  [2795] = {
    [anon_sym_RBRACE] = ACTIONS(6439),
    [sym_comment] = ACTIONS(53),
  },
  [2796] = {
    [sym_concatenation] = STATE(2817),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2817),
    [anon_sym_RBRACE] = ACTIONS(6441),
    [anon_sym_EQ] = ACTIONS(6443),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6443),
    [anon_sym_COLON_QMARK] = ACTIONS(6443),
    [anon_sym_COLON_DASH] = ACTIONS(6443),
    [anon_sym_PERCENT] = ACTIONS(6443),
    [anon_sym_DASH] = ACTIONS(6443),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2797] = {
    [sym__simple_heredoc_body] = ACTIONS(3852),
    [sym__heredoc_body_beginning] = ACTIONS(3852),
    [sym_file_descriptor] = ACTIONS(3852),
    [sym__concat] = ACTIONS(3852),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_esac] = ACTIONS(3852),
    [anon_sym_PIPE] = ACTIONS(3854),
    [anon_sym_SEMI_SEMI] = ACTIONS(3852),
    [anon_sym_PIPE_AMP] = ACTIONS(3852),
    [anon_sym_AMP_AMP] = ACTIONS(3852),
    [anon_sym_PIPE_PIPE] = ACTIONS(3852),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_GT] = ACTIONS(3854),
    [anon_sym_GT_GT] = ACTIONS(3852),
    [anon_sym_AMP_GT] = ACTIONS(3854),
    [anon_sym_AMP_GT_GT] = ACTIONS(3852),
    [anon_sym_LT_AMP] = ACTIONS(3852),
    [anon_sym_GT_AMP] = ACTIONS(3852),
    [anon_sym_LT_LT] = ACTIONS(3854),
    [anon_sym_LT_LT_DASH] = ACTIONS(3852),
    [anon_sym_LT_LT_LT] = ACTIONS(3852),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3852),
    [anon_sym_AMP] = ACTIONS(3854),
  },
  [2798] = {
    [sym_concatenation] = STATE(2818),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(2818),
    [anon_sym_RBRACE] = ACTIONS(6439),
    [anon_sym_EQ] = ACTIONS(6447),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(6449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(6447),
    [anon_sym_COLON_QMARK] = ACTIONS(6447),
    [anon_sym_COLON_DASH] = ACTIONS(6447),
    [anon_sym_PERCENT] = ACTIONS(6447),
    [anon_sym_DASH] = ACTIONS(6447),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2799] = {
    [sym__simple_heredoc_body] = ACTIONS(3893),
    [sym__heredoc_body_beginning] = ACTIONS(3893),
    [sym_file_descriptor] = ACTIONS(3893),
    [sym__concat] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_esac] = ACTIONS(3893),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_SEMI_SEMI] = ACTIONS(3893),
    [anon_sym_PIPE_AMP] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_GT_GT] = ACTIONS(3893),
    [anon_sym_AMP_GT] = ACTIONS(3895),
    [anon_sym_AMP_GT_GT] = ACTIONS(3893),
    [anon_sym_LT_AMP] = ACTIONS(3893),
    [anon_sym_GT_AMP] = ACTIONS(3893),
    [anon_sym_LT_LT] = ACTIONS(3895),
    [anon_sym_LT_LT_DASH] = ACTIONS(3893),
    [anon_sym_LT_LT_LT] = ACTIONS(3893),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(3895),
  },
  [2800] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6451),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2801] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6439),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2802] = {
    [sym__simple_heredoc_body] = ACTIONS(3915),
    [sym__heredoc_body_beginning] = ACTIONS(3915),
    [sym_file_descriptor] = ACTIONS(3915),
    [sym__concat] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_esac] = ACTIONS(3915),
    [anon_sym_PIPE] = ACTIONS(3917),
    [anon_sym_SEMI_SEMI] = ACTIONS(3915),
    [anon_sym_PIPE_AMP] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3915),
    [anon_sym_LT] = ACTIONS(3917),
    [anon_sym_GT] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_AMP_GT] = ACTIONS(3917),
    [anon_sym_AMP_GT_GT] = ACTIONS(3915),
    [anon_sym_LT_AMP] = ACTIONS(3915),
    [anon_sym_GT_AMP] = ACTIONS(3915),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_LT_LT_DASH] = ACTIONS(3915),
    [anon_sym_LT_LT_LT] = ACTIONS(3915),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [2803] = {
    [sym__simple_heredoc_body] = ACTIONS(3939),
    [sym__heredoc_body_beginning] = ACTIONS(3939),
    [sym_file_descriptor] = ACTIONS(3939),
    [sym__concat] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_esac] = ACTIONS(3939),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_SEMI_SEMI] = ACTIONS(3939),
    [anon_sym_PIPE_AMP] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3939),
    [anon_sym_AMP_GT] = ACTIONS(3941),
    [anon_sym_AMP_GT_GT] = ACTIONS(3939),
    [anon_sym_LT_AMP] = ACTIONS(3939),
    [anon_sym_GT_AMP] = ACTIONS(3939),
    [anon_sym_LT_LT] = ACTIONS(3941),
    [anon_sym_LT_LT_DASH] = ACTIONS(3939),
    [anon_sym_LT_LT_LT] = ACTIONS(3939),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3941),
  },
  [2804] = {
    [sym_file_descriptor] = ACTIONS(4568),
    [sym__concat] = ACTIONS(4568),
    [sym_variable_name] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_esac] = ACTIONS(4570),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_LT] = ACTIONS(4570),
    [anon_sym_GT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_AMP_GT] = ACTIONS(4570),
    [anon_sym_AMP_GT_GT] = ACTIONS(4568),
    [anon_sym_LT_AMP] = ACTIONS(4568),
    [anon_sym_GT_AMP] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [sym_raw_string] = ACTIONS(4568),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4568),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_LT_LPAREN] = ACTIONS(4568),
    [anon_sym_GT_LPAREN] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4570),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4570),
  },
  [2805] = {
    [sym_file_descriptor] = ACTIONS(4572),
    [sym__concat] = ACTIONS(4572),
    [sym_variable_name] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_esac] = ACTIONS(4574),
    [anon_sym_PIPE] = ACTIONS(4574),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [anon_sym_PIPE_AMP] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [anon_sym_LT] = ACTIONS(4574),
    [anon_sym_GT] = ACTIONS(4574),
    [anon_sym_GT_GT] = ACTIONS(4572),
    [anon_sym_AMP_GT] = ACTIONS(4574),
    [anon_sym_AMP_GT_GT] = ACTIONS(4572),
    [anon_sym_LT_AMP] = ACTIONS(4572),
    [anon_sym_GT_AMP] = ACTIONS(4572),
    [sym__special_characters] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4574),
    [sym_raw_string] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4572),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_LT_LPAREN] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4574),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4574),
  },
  [2806] = {
    [sym_file_descriptor] = ACTIONS(4576),
    [sym__concat] = ACTIONS(4576),
    [sym_variable_name] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_esac] = ACTIONS(4578),
    [anon_sym_PIPE] = ACTIONS(4578),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [anon_sym_PIPE_AMP] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [anon_sym_LT] = ACTIONS(4578),
    [anon_sym_GT] = ACTIONS(4578),
    [anon_sym_GT_GT] = ACTIONS(4576),
    [anon_sym_AMP_GT] = ACTIONS(4578),
    [anon_sym_AMP_GT_GT] = ACTIONS(4576),
    [anon_sym_LT_AMP] = ACTIONS(4576),
    [anon_sym_GT_AMP] = ACTIONS(4576),
    [sym__special_characters] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4578),
    [sym_raw_string] = ACTIONS(4576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4576),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_LT_LPAREN] = ACTIONS(4576),
    [anon_sym_GT_LPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4578),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4578),
  },
  [2807] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6453),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2808] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6455),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2809] = {
    [sym_file_descriptor] = ACTIONS(4608),
    [sym__concat] = ACTIONS(4608),
    [sym_variable_name] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_esac] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4610),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [anon_sym_PIPE_AMP] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [anon_sym_LT] = ACTIONS(4610),
    [anon_sym_GT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_AMP_GT] = ACTIONS(4610),
    [anon_sym_AMP_GT_GT] = ACTIONS(4608),
    [anon_sym_LT_AMP] = ACTIONS(4608),
    [anon_sym_GT_AMP] = ACTIONS(4608),
    [sym__special_characters] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4608),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_LT_LPAREN] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(4610),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4610),
  },
  [2810] = {
    [sym__concat] = ACTIONS(5069),
    [sym_variable_name] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_esac] = ACTIONS(5071),
    [anon_sym_PIPE] = ACTIONS(5071),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [anon_sym_PIPE_AMP] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [sym__special_characters] = ACTIONS(5069),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [anon_sym_LT_LPAREN] = ACTIONS(5069),
    [anon_sym_GT_LPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5071),
    [sym_word] = ACTIONS(5071),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5071),
  },
  [2811] = {
    [sym__concat] = ACTIONS(5073),
    [sym_variable_name] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_esac] = ACTIONS(5075),
    [anon_sym_PIPE] = ACTIONS(5075),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [anon_sym_PIPE_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [sym__special_characters] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym_raw_string] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5075),
    [sym_word] = ACTIONS(5075),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5075),
  },
  [2812] = {
    [sym__concat] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_esac] = ACTIONS(5071),
    [anon_sym_PIPE] = ACTIONS(5071),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [anon_sym_PIPE_AMP] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [sym__special_characters] = ACTIONS(5069),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [anon_sym_LT_LPAREN] = ACTIONS(5069),
    [anon_sym_GT_LPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5071),
    [sym_word] = ACTIONS(5071),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5071),
  },
  [2813] = {
    [sym__concat] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_esac] = ACTIONS(5075),
    [anon_sym_PIPE] = ACTIONS(5075),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [anon_sym_PIPE_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [sym__special_characters] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym_raw_string] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5075),
    [sym_word] = ACTIONS(5075),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5075),
  },
  [2814] = {
    [sym__simple_heredoc_body] = ACTIONS(4568),
    [sym__heredoc_body_beginning] = ACTIONS(4568),
    [sym_file_descriptor] = ACTIONS(4568),
    [sym__concat] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_esac] = ACTIONS(4568),
    [anon_sym_PIPE] = ACTIONS(4570),
    [anon_sym_SEMI_SEMI] = ACTIONS(4568),
    [anon_sym_PIPE_AMP] = ACTIONS(4568),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_LT] = ACTIONS(4570),
    [anon_sym_GT] = ACTIONS(4570),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_AMP_GT] = ACTIONS(4570),
    [anon_sym_AMP_GT_GT] = ACTIONS(4568),
    [anon_sym_LT_AMP] = ACTIONS(4568),
    [anon_sym_GT_AMP] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4570),
    [anon_sym_LT_LT_DASH] = ACTIONS(4568),
    [anon_sym_LT_LT_LT] = ACTIONS(4568),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4570),
  },
  [2815] = {
    [sym__simple_heredoc_body] = ACTIONS(4572),
    [sym__heredoc_body_beginning] = ACTIONS(4572),
    [sym_file_descriptor] = ACTIONS(4572),
    [sym__concat] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4574),
    [anon_sym_esac] = ACTIONS(4572),
    [anon_sym_PIPE] = ACTIONS(4574),
    [anon_sym_SEMI_SEMI] = ACTIONS(4572),
    [anon_sym_PIPE_AMP] = ACTIONS(4572),
    [anon_sym_AMP_AMP] = ACTIONS(4572),
    [anon_sym_PIPE_PIPE] = ACTIONS(4572),
    [anon_sym_LT] = ACTIONS(4574),
    [anon_sym_GT] = ACTIONS(4574),
    [anon_sym_GT_GT] = ACTIONS(4572),
    [anon_sym_AMP_GT] = ACTIONS(4574),
    [anon_sym_AMP_GT_GT] = ACTIONS(4572),
    [anon_sym_LT_AMP] = ACTIONS(4572),
    [anon_sym_GT_AMP] = ACTIONS(4572),
    [anon_sym_LT_LT] = ACTIONS(4574),
    [anon_sym_LT_LT_DASH] = ACTIONS(4572),
    [anon_sym_LT_LT_LT] = ACTIONS(4572),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4574),
  },
  [2816] = {
    [sym__simple_heredoc_body] = ACTIONS(4576),
    [sym__heredoc_body_beginning] = ACTIONS(4576),
    [sym_file_descriptor] = ACTIONS(4576),
    [sym__concat] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4578),
    [anon_sym_esac] = ACTIONS(4576),
    [anon_sym_PIPE] = ACTIONS(4578),
    [anon_sym_SEMI_SEMI] = ACTIONS(4576),
    [anon_sym_PIPE_AMP] = ACTIONS(4576),
    [anon_sym_AMP_AMP] = ACTIONS(4576),
    [anon_sym_PIPE_PIPE] = ACTIONS(4576),
    [anon_sym_LT] = ACTIONS(4578),
    [anon_sym_GT] = ACTIONS(4578),
    [anon_sym_GT_GT] = ACTIONS(4576),
    [anon_sym_AMP_GT] = ACTIONS(4578),
    [anon_sym_AMP_GT_GT] = ACTIONS(4576),
    [anon_sym_LT_AMP] = ACTIONS(4576),
    [anon_sym_GT_AMP] = ACTIONS(4576),
    [anon_sym_LT_LT] = ACTIONS(4578),
    [anon_sym_LT_LT_DASH] = ACTIONS(4576),
    [anon_sym_LT_LT_LT] = ACTIONS(4576),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4578),
  },
  [2817] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6457),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2818] = {
    [sym_concatenation] = STATE(911),
    [sym_string] = STATE(460),
    [sym_simple_expansion] = STATE(460),
    [sym_string_expansion] = STATE(460),
    [sym_expansion] = STATE(460),
    [sym_command_substitution] = STATE(460),
    [sym_process_substitution] = STATE(460),
    [aux_sym_expansion_repeat1] = STATE(911),
    [anon_sym_RBRACE] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(1872),
    [sym__special_characters] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COLON_QMARK] = ACTIONS(1872),
    [anon_sym_COLON_DASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(849),
    [anon_sym_GT_LPAREN] = ACTIONS(849),
    [sym_comment] = ACTIONS(265),
    [sym_word] = ACTIONS(851),
  },
  [2819] = {
    [sym__simple_heredoc_body] = ACTIONS(4608),
    [sym__heredoc_body_beginning] = ACTIONS(4608),
    [sym_file_descriptor] = ACTIONS(4608),
    [sym__concat] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_esac] = ACTIONS(4608),
    [anon_sym_PIPE] = ACTIONS(4610),
    [anon_sym_SEMI_SEMI] = ACTIONS(4608),
    [anon_sym_PIPE_AMP] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4608),
    [anon_sym_PIPE_PIPE] = ACTIONS(4608),
    [anon_sym_LT] = ACTIONS(4610),
    [anon_sym_GT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_AMP_GT] = ACTIONS(4610),
    [anon_sym_AMP_GT_GT] = ACTIONS(4608),
    [anon_sym_LT_AMP] = ACTIONS(4608),
    [anon_sym_GT_AMP] = ACTIONS(4608),
    [anon_sym_LT_LT] = ACTIONS(4610),
    [anon_sym_LT_LT_DASH] = ACTIONS(4608),
    [anon_sym_LT_LT_LT] = ACTIONS(4608),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4610),
  },
  [2820] = {
    [sym_file_descriptor] = ACTIONS(5069),
    [sym__concat] = ACTIONS(5069),
    [sym_variable_name] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_esac] = ACTIONS(5071),
    [anon_sym_PIPE] = ACTIONS(5071),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [anon_sym_PIPE_AMP] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [anon_sym_LT] = ACTIONS(5071),
    [anon_sym_GT] = ACTIONS(5071),
    [anon_sym_GT_GT] = ACTIONS(5069),
    [anon_sym_AMP_GT] = ACTIONS(5071),
    [anon_sym_AMP_GT_GT] = ACTIONS(5069),
    [anon_sym_LT_AMP] = ACTIONS(5069),
    [anon_sym_GT_AMP] = ACTIONS(5069),
    [sym__special_characters] = ACTIONS(5069),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5069),
    [anon_sym_LT_LPAREN] = ACTIONS(5069),
    [anon_sym_GT_LPAREN] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5071),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5071),
  },
  [2821] = {
    [sym_file_descriptor] = ACTIONS(5073),
    [sym__concat] = ACTIONS(5073),
    [sym_variable_name] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_esac] = ACTIONS(5075),
    [anon_sym_PIPE] = ACTIONS(5075),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [anon_sym_PIPE_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [anon_sym_LT] = ACTIONS(5075),
    [anon_sym_GT] = ACTIONS(5075),
    [anon_sym_GT_GT] = ACTIONS(5073),
    [anon_sym_AMP_GT] = ACTIONS(5075),
    [anon_sym_AMP_GT_GT] = ACTIONS(5073),
    [anon_sym_LT_AMP] = ACTIONS(5073),
    [anon_sym_GT_AMP] = ACTIONS(5073),
    [sym__special_characters] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(5075),
    [sym_raw_string] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5073),
    [anon_sym_BQUOTE] = ACTIONS(5073),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [sym_word] = ACTIONS(5075),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5075),
  },
  [2822] = {
    [sym__simple_heredoc_body] = ACTIONS(5069),
    [sym__heredoc_body_beginning] = ACTIONS(5069),
    [sym_file_descriptor] = ACTIONS(5069),
    [sym__concat] = ACTIONS(5069),
    [anon_sym_SEMI] = ACTIONS(5071),
    [anon_sym_esac] = ACTIONS(5069),
    [anon_sym_PIPE] = ACTIONS(5071),
    [anon_sym_SEMI_SEMI] = ACTIONS(5069),
    [anon_sym_PIPE_AMP] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_PIPE_PIPE] = ACTIONS(5069),
    [anon_sym_LT] = ACTIONS(5071),
    [anon_sym_GT] = ACTIONS(5071),
    [anon_sym_GT_GT] = ACTIONS(5069),
    [anon_sym_AMP_GT] = ACTIONS(5071),
    [anon_sym_AMP_GT_GT] = ACTIONS(5069),
    [anon_sym_LT_AMP] = ACTIONS(5069),
    [anon_sym_GT_AMP] = ACTIONS(5069),
    [anon_sym_LT_LT] = ACTIONS(5071),
    [anon_sym_LT_LT_DASH] = ACTIONS(5069),
    [anon_sym_LT_LT_LT] = ACTIONS(5069),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5071),
  },
  [2823] = {
    [sym__simple_heredoc_body] = ACTIONS(5073),
    [sym__heredoc_body_beginning] = ACTIONS(5073),
    [sym_file_descriptor] = ACTIONS(5073),
    [sym__concat] = ACTIONS(5073),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_esac] = ACTIONS(5073),
    [anon_sym_PIPE] = ACTIONS(5075),
    [anon_sym_SEMI_SEMI] = ACTIONS(5073),
    [anon_sym_PIPE_AMP] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_PIPE_PIPE] = ACTIONS(5073),
    [anon_sym_LT] = ACTIONS(5075),
    [anon_sym_GT] = ACTIONS(5075),
    [anon_sym_GT_GT] = ACTIONS(5073),
    [anon_sym_AMP_GT] = ACTIONS(5075),
    [anon_sym_AMP_GT_GT] = ACTIONS(5073),
    [anon_sym_LT_AMP] = ACTIONS(5073),
    [anon_sym_GT_AMP] = ACTIONS(5073),
    [anon_sym_LT_LT] = ACTIONS(5075),
    [anon_sym_LT_LT_DASH] = ACTIONS(5073),
    [anon_sym_LT_LT_LT] = ACTIONS(5073),
    [sym_comment] = ACTIONS(53),
    [anon_sym_LF] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5075),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [11] = {.count = 1, .reusable = false}, SHIFT(4),
  [13] = {.count = 1, .reusable = false}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = true}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = false}, SHIFT(11),
  [27] = {.count = 1, .reusable = true}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = false}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = true}, SHIFT(15),
  [37] = {.count = 1, .reusable = false}, SHIFT(16),
  [39] = {.count = 1, .reusable = true}, SHIFT(17),
  [41] = {.count = 1, .reusable = false}, SHIFT(18),
  [43] = {.count = 1, .reusable = true}, SHIFT(19),
  [45] = {.count = 1, .reusable = true}, SHIFT(20),
  [47] = {.count = 1, .reusable = true}, SHIFT(21),
  [49] = {.count = 1, .reusable = true}, SHIFT(22),
  [51] = {.count = 1, .reusable = true}, SHIFT(23),
  [53] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [55] = {.count = 1, .reusable = false}, SHIFT(24),
  [57] = {.count = 1, .reusable = false}, SHIFT(33),
  [59] = {.count = 1, .reusable = true}, SHIFT(33),
  [61] = {.count = 1, .reusable = true}, SHIFT(34),
  [63] = {.count = 1, .reusable = true}, SHIFT(35),
  [65] = {.count = 1, .reusable = true}, SHIFT(36),
  [67] = {.count = 1, .reusable = true}, SHIFT(37),
  [69] = {.count = 1, .reusable = true}, SHIFT(38),
  [71] = {.count = 1, .reusable = false}, SHIFT(39),
  [73] = {.count = 1, .reusable = false}, SHIFT(40),
  [75] = {.count = 1, .reusable = false}, SHIFT(41),
  [77] = {.count = 1, .reusable = false}, SHIFT(42),
  [79] = {.count = 1, .reusable = true}, SHIFT(43),
  [81] = {.count = 1, .reusable = false}, SHIFT(44),
  [83] = {.count = 1, .reusable = false}, SHIFT(45),
  [85] = {.count = 1, .reusable = false}, SHIFT(46),
  [87] = {.count = 1, .reusable = true}, SHIFT(47),
  [89] = {.count = 1, .reusable = false}, SHIFT(48),
  [91] = {.count = 1, .reusable = true}, SHIFT(56),
  [93] = {.count = 1, .reusable = true}, SHIFT(57),
  [95] = {.count = 1, .reusable = false}, SHIFT(58),
  [97] = {.count = 1, .reusable = true}, SHIFT(59),
  [99] = {.count = 1, .reusable = true}, SHIFT(60),
  [101] = {.count = 1, .reusable = true}, SHIFT(61),
  [103] = {.count = 1, .reusable = true}, SHIFT(62),
  [105] = {.count = 1, .reusable = true}, SHIFT(63),
  [107] = {.count = 1, .reusable = true}, SHIFT(65),
  [109] = {.count = 1, .reusable = true}, SHIFT(66),
  [111] = {.count = 1, .reusable = false}, SHIFT(67),
  [113] = {.count = 1, .reusable = false}, SHIFT(68),
  [115] = {.count = 1, .reusable = false}, SHIFT(69),
  [117] = {.count = 1, .reusable = false}, SHIFT(70),
  [119] = {.count = 1, .reusable = true}, SHIFT(71),
  [121] = {.count = 1, .reusable = false}, SHIFT(72),
  [123] = {.count = 1, .reusable = false}, SHIFT(73),
  [125] = {.count = 1, .reusable = false}, SHIFT(74),
  [127] = {.count = 1, .reusable = true}, SHIFT(75),
  [129] = {.count = 1, .reusable = false}, SHIFT(76),
  [131] = {.count = 1, .reusable = true}, SHIFT(83),
  [133] = {.count = 1, .reusable = true}, SHIFT(86),
  [135] = {.count = 1, .reusable = false}, SHIFT(87),
  [137] = {.count = 1, .reusable = true}, SHIFT(88),
  [139] = {.count = 1, .reusable = true}, SHIFT(89),
  [141] = {.count = 1, .reusable = false}, SHIFT(90),
  [143] = {.count = 1, .reusable = true}, SHIFT(91),
  [145] = {.count = 1, .reusable = true}, SHIFT(92),
  [147] = {.count = 1, .reusable = true}, SHIFT(93),
  [149] = {.count = 1, .reusable = true}, SHIFT(94),
  [151] = {.count = 1, .reusable = true}, SHIFT(95),
  [153] = {.count = 1, .reusable = false}, SHIFT(91),
  [155] = {.count = 1, .reusable = true}, SHIFT(87),
  [157] = {.count = 1, .reusable = true}, SHIFT(97),
  [159] = {.count = 1, .reusable = false}, SHIFT(98),
  [161] = {.count = 1, .reusable = true}, SHIFT(99),
  [163] = {.count = 1, .reusable = true}, SHIFT(100),
  [165] = {.count = 1, .reusable = false}, SHIFT(101),
  [167] = {.count = 1, .reusable = true}, SHIFT(102),
  [169] = {.count = 1, .reusable = true}, SHIFT(103),
  [171] = {.count = 1, .reusable = true}, SHIFT(104),
  [173] = {.count = 1, .reusable = true}, SHIFT(105),
  [175] = {.count = 1, .reusable = true}, SHIFT(106),
  [177] = {.count = 1, .reusable = false}, SHIFT(102),
  [179] = {.count = 1, .reusable = true}, SHIFT(98),
  [181] = {.count = 1, .reusable = true}, SHIFT(108),
  [183] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 1),
  [185] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 1),
  [187] = {.count = 1, .reusable = true}, SHIFT(109),
  [189] = {.count = 1, .reusable = true}, SHIFT(110),
  [191] = {.count = 1, .reusable = false}, SHIFT(111),
  [193] = {.count = 1, .reusable = true}, SHIFT(112),
  [195] = {.count = 1, .reusable = true}, SHIFT(113),
  [197] = {.count = 1, .reusable = true}, SHIFT(114),
  [199] = {.count = 1, .reusable = true}, SHIFT(115),
  [201] = {.count = 1, .reusable = true}, SHIFT(116),
  [203] = {.count = 1, .reusable = false}, SHIFT(118),
  [205] = {.count = 1, .reusable = false}, SHIFT(112),
  [207] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 1),
  [209] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 1),
  [211] = {.count = 1, .reusable = true}, SHIFT(119),
  [213] = {.count = 1, .reusable = true}, SHIFT(120),
  [215] = {.count = 1, .reusable = false}, SHIFT(121),
  [217] = {.count = 1, .reusable = true}, SHIFT(122),
  [219] = {.count = 1, .reusable = true}, SHIFT(123),
  [221] = {.count = 1, .reusable = true}, SHIFT(124),
  [223] = {.count = 1, .reusable = true}, SHIFT(125),
  [225] = {.count = 1, .reusable = true}, SHIFT(126),
  [227] = {.count = 1, .reusable = false}, SHIFT(127),
  [229] = {.count = 1, .reusable = false}, SHIFT(122),
  [231] = {.count = 1, .reusable = true}, SHIFT(128),
  [233] = {.count = 1, .reusable = true}, SHIFT(129),
  [235] = {.count = 1, .reusable = false}, SHIFT(130),
  [237] = {.count = 1, .reusable = true}, SHIFT(131),
  [239] = {.count = 1, .reusable = true}, SHIFT(132),
  [241] = {.count = 1, .reusable = true}, SHIFT(133),
  [243] = {.count = 1, .reusable = true}, SHIFT(134),
  [245] = {.count = 1, .reusable = true}, SHIFT(135),
  [247] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [249] = {.count = 1, .reusable = true}, SHIFT(137),
  [251] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [253] = {.count = 1, .reusable = false}, SHIFT(139),
  [255] = {.count = 1, .reusable = false}, SHIFT(140),
  [257] = {.count = 1, .reusable = true}, SHIFT(141),
  [259] = {.count = 1, .reusable = false}, SHIFT(142),
  [261] = {.count = 1, .reusable = false}, SHIFT(143),
  [263] = {.count = 1, .reusable = false}, SHIFT(144),
  [265] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [267] = {.count = 1, .reusable = true}, SHIFT(146),
  [269] = {.count = 1, .reusable = true}, SHIFT(147),
  [271] = {.count = 1, .reusable = false}, SHIFT(148),
  [273] = {.count = 1, .reusable = true}, SHIFT(148),
  [275] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1),
  [277] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1),
  [279] = {.count = 1, .reusable = true}, SHIFT(149),
  [281] = {.count = 1, .reusable = true}, SHIFT(150),
  [283] = {.count = 1, .reusable = true}, SHIFT(151),
  [285] = {.count = 1, .reusable = false}, SHIFT(152),
  [287] = {.count = 1, .reusable = true}, SHIFT(152),
  [289] = {.count = 1, .reusable = false}, SHIFT(156),
  [291] = {.count = 1, .reusable = false}, SHIFT(157),
  [293] = {.count = 1, .reusable = false}, SHIFT(158),
  [295] = {.count = 1, .reusable = false}, SHIFT(159),
  [297] = {.count = 1, .reusable = true}, SHIFT(160),
  [299] = {.count = 1, .reusable = false}, SHIFT(161),
  [301] = {.count = 1, .reusable = false}, SHIFT(162),
  [303] = {.count = 1, .reusable = false}, SHIFT(163),
  [305] = {.count = 1, .reusable = true}, SHIFT(172),
  [307] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [309] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [311] = {.count = 1, .reusable = false}, SHIFT(173),
  [313] = {.count = 1, .reusable = false}, SHIFT(174),
  [315] = {.count = 1, .reusable = true}, SHIFT(173),
  [317] = {.count = 1, .reusable = true}, SHIFT(174),
  [319] = {.count = 1, .reusable = true}, SHIFT(175),
  [321] = {.count = 1, .reusable = true}, SHIFT(176),
  [323] = {.count = 1, .reusable = true}, SHIFT(177),
  [325] = {.count = 1, .reusable = true}, SHIFT(178),
  [327] = {.count = 1, .reusable = true}, REDUCE(sym_command, 1),
  [329] = {.count = 1, .reusable = false}, REDUCE(sym_command, 1),
  [331] = {.count = 1, .reusable = false}, SHIFT(179),
  [333] = {.count = 1, .reusable = false}, SHIFT(180),
  [335] = {.count = 1, .reusable = true}, SHIFT(180),
  [337] = {.count = 1, .reusable = false}, SHIFT(181),
  [339] = {.count = 1, .reusable = true}, SHIFT(181),
  [341] = {.count = 1, .reusable = true}, SHIFT(182),
  [343] = {.count = 1, .reusable = true}, SHIFT(183),
  [345] = {.count = 1, .reusable = true}, SHIFT(184),
  [347] = {.count = 1, .reusable = false}, SHIFT(184),
  [349] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 1),
  [351] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 1),
  [353] = {.count = 1, .reusable = true}, SHIFT(16),
  [355] = {.count = 1, .reusable = true}, SHIFT(193),
  [357] = {.count = 1, .reusable = true}, SHIFT(194),
  [359] = {.count = 1, .reusable = true}, SHIFT(196),
  [361] = {.count = 1, .reusable = true}, SHIFT(197),
  [363] = {.count = 1, .reusable = true}, SHIFT(199),
  [365] = {.count = 1, .reusable = true}, SHIFT(200),
  [367] = {.count = 1, .reusable = true}, SHIFT(201),
  [369] = {.count = 1, .reusable = true}, SHIFT(202),
  [371] = {.count = 1, .reusable = false}, SHIFT(203),
  [373] = {.count = 1, .reusable = true}, SHIFT(204),
  [375] = {.count = 1, .reusable = true}, SHIFT(205),
  [377] = {.count = 1, .reusable = true}, SHIFT(206),
  [379] = {.count = 1, .reusable = true}, SHIFT(207),
  [381] = {.count = 1, .reusable = true}, SHIFT(208),
  [383] = {.count = 1, .reusable = false}, SHIFT(209),
  [385] = {.count = 1, .reusable = true}, SHIFT(209),
  [387] = {.count = 1, .reusable = true}, SHIFT(210),
  [389] = {.count = 1, .reusable = false}, SHIFT(211),
  [391] = {.count = 1, .reusable = true}, SHIFT(212),
  [393] = {.count = 1, .reusable = true}, SHIFT(213),
  [395] = {.count = 1, .reusable = false}, SHIFT(214),
  [397] = {.count = 1, .reusable = true}, SHIFT(215),
  [399] = {.count = 1, .reusable = true}, SHIFT(216),
  [401] = {.count = 1, .reusable = true}, SHIFT(217),
  [403] = {.count = 1, .reusable = true}, SHIFT(218),
  [405] = {.count = 1, .reusable = true}, SHIFT(219),
  [407] = {.count = 1, .reusable = false}, SHIFT(215),
  [409] = {.count = 1, .reusable = true}, SHIFT(211),
  [411] = {.count = 1, .reusable = true}, SHIFT(221),
  [413] = {.count = 1, .reusable = false}, SHIFT(222),
  [415] = {.count = 1, .reusable = true}, SHIFT(222),
  [417] = {.count = 1, .reusable = true}, SHIFT(223),
  [419] = {.count = 1, .reusable = true}, SHIFT(225),
  [421] = {.count = 1, .reusable = true}, SHIFT(228),
  [423] = {.count = 1, .reusable = true}, SHIFT(229),
  [425] = {.count = 1, .reusable = true}, SHIFT(230),
  [427] = {.count = 1, .reusable = false}, SHIFT(232),
  [429] = {.count = 1, .reusable = false}, SHIFT(230),
  [431] = {.count = 1, .reusable = true}, SHIFT(233),
  [433] = {.count = 1, .reusable = true}, SHIFT(234),
  [435] = {.count = 1, .reusable = false}, SHIFT(235),
  [437] = {.count = 1, .reusable = false}, SHIFT(234),
  [439] = {.count = 1, .reusable = true}, SHIFT(237),
  [441] = {.count = 1, .reusable = true}, SHIFT(238),
  [443] = {.count = 1, .reusable = false}, SHIFT(240),
  [445] = {.count = 1, .reusable = false}, SHIFT(241),
  [447] = {.count = 1, .reusable = true}, SHIFT(240),
  [449] = {.count = 1, .reusable = true}, SHIFT(241),
  [451] = {.count = 1, .reusable = true}, SHIFT(242),
  [453] = {.count = 1, .reusable = true}, SHIFT(243),
  [455] = {.count = 1, .reusable = false}, SHIFT(244),
  [457] = {.count = 1, .reusable = false}, SHIFT(245),
  [459] = {.count = 1, .reusable = true}, SHIFT(245),
  [461] = {.count = 1, .reusable = true}, SHIFT(246),
  [463] = {.count = 1, .reusable = true}, SHIFT(247),
  [465] = {.count = 1, .reusable = true}, SHIFT(248),
  [467] = {.count = 1, .reusable = false}, SHIFT(248),
  [469] = {.count = 1, .reusable = true}, SHIFT(46),
  [471] = {.count = 1, .reusable = true}, SHIFT(252),
  [473] = {.count = 1, .reusable = true}, SHIFT(253),
  [475] = {.count = 1, .reusable = true}, SHIFT(254),
  [477] = {.count = 1, .reusable = false}, SHIFT(255),
  [479] = {.count = 1, .reusable = true}, SHIFT(255),
  [481] = {.count = 1, .reusable = false}, SHIFT(257),
  [483] = {.count = 1, .reusable = false}, SHIFT(258),
  [485] = {.count = 1, .reusable = true}, SHIFT(260),
  [487] = {.count = 1, .reusable = true}, SHIFT(261),
  [489] = {.count = 1, .reusable = false}, SHIFT(262),
  [491] = {.count = 1, .reusable = true}, SHIFT(262),
  [493] = {.count = 1, .reusable = true}, SHIFT(263),
  [495] = {.count = 1, .reusable = false}, SHIFT(264),
  [497] = {.count = 1, .reusable = true}, SHIFT(264),
  [499] = {.count = 1, .reusable = true}, SHIFT(265),
  [501] = {.count = 1, .reusable = true}, SHIFT(266),
  [503] = {.count = 1, .reusable = true}, SHIFT(267),
  [505] = {.count = 1, .reusable = false}, SHIFT(268),
  [507] = {.count = 1, .reusable = true}, SHIFT(268),
  [509] = {.count = 1, .reusable = true}, SHIFT(278),
  [511] = {.count = 1, .reusable = true}, SHIFT(279),
  [513] = {.count = 1, .reusable = true}, SHIFT(281),
  [515] = {.count = 1, .reusable = true}, SHIFT(283),
  [517] = {.count = 1, .reusable = true}, SHIFT(286),
  [519] = {.count = 1, .reusable = true}, SHIFT(287),
  [521] = {.count = 1, .reusable = true}, SHIFT(288),
  [523] = {.count = 1, .reusable = false}, SHIFT(290),
  [525] = {.count = 1, .reusable = false}, SHIFT(288),
  [527] = {.count = 1, .reusable = true}, SHIFT(291),
  [529] = {.count = 1, .reusable = true}, SHIFT(292),
  [531] = {.count = 1, .reusable = false}, SHIFT(293),
  [533] = {.count = 1, .reusable = false}, SHIFT(292),
  [535] = {.count = 1, .reusable = true}, SHIFT(295),
  [537] = {.count = 1, .reusable = false}, SHIFT(296),
  [539] = {.count = 1, .reusable = false}, SHIFT(297),
  [541] = {.count = 1, .reusable = true}, SHIFT(298),
  [543] = {.count = 1, .reusable = true}, SHIFT(296),
  [545] = {.count = 1, .reusable = true}, SHIFT(297),
  [547] = {.count = 1, .reusable = true}, SHIFT(299),
  [549] = {.count = 1, .reusable = true}, SHIFT(300),
  [551] = {.count = 1, .reusable = false}, SHIFT(301),
  [553] = {.count = 1, .reusable = false}, SHIFT(302),
  [555] = {.count = 1, .reusable = true}, SHIFT(302),
  [557] = {.count = 1, .reusable = true}, SHIFT(303),
  [559] = {.count = 1, .reusable = true}, SHIFT(304),
  [561] = {.count = 1, .reusable = true}, SHIFT(305),
  [563] = {.count = 1, .reusable = false}, SHIFT(305),
  [565] = {.count = 1, .reusable = true}, SHIFT(74),
  [567] = {.count = 1, .reusable = true}, SHIFT(311),
  [569] = {.count = 1, .reusable = true}, REDUCE(sym_negated_command, 2),
  [571] = {.count = 1, .reusable = false}, REDUCE(sym_negated_command, 2),
  [573] = {.count = 1, .reusable = false}, SHIFT(312),
  [575] = {.count = 1, .reusable = true}, SHIFT(313),
  [577] = {.count = 1, .reusable = true}, SHIFT(314),
  [579] = {.count = 1, .reusable = false}, SHIFT(314),
  [581] = {.count = 1, .reusable = true}, SHIFT(312),
  [583] = {.count = 1, .reusable = true}, SHIFT(317),
  [585] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [587] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [589] = {.count = 1, .reusable = false}, SHIFT(319),
  [591] = {.count = 1, .reusable = false}, SHIFT(320),
  [593] = {.count = 1, .reusable = true}, SHIFT(322),
  [595] = {.count = 1, .reusable = true}, SHIFT(323),
  [597] = {.count = 1, .reusable = false}, SHIFT(324),
  [599] = {.count = 1, .reusable = true}, SHIFT(324),
  [601] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [603] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [605] = {.count = 1, .reusable = true}, SHIFT(325),
  [607] = {.count = 1, .reusable = true}, SHIFT(326),
  [609] = {.count = 1, .reusable = true}, SHIFT(327),
  [611] = {.count = 1, .reusable = false}, SHIFT(328),
  [613] = {.count = 1, .reusable = true}, SHIFT(328),
  [615] = {.count = 1, .reusable = true}, SHIFT(338),
  [617] = {.count = 1, .reusable = true}, SHIFT(339),
  [619] = {.count = 1, .reusable = true}, SHIFT(340),
  [621] = {.count = 1, .reusable = false}, SHIFT(338),
  [623] = {.count = 1, .reusable = true}, SHIFT(343),
  [625] = {.count = 1, .reusable = false}, SHIFT(345),
  [627] = {.count = 1, .reusable = false}, SHIFT(346),
  [629] = {.count = 1, .reusable = true}, SHIFT(348),
  [631] = {.count = 1, .reusable = true}, SHIFT(349),
  [633] = {.count = 1, .reusable = false}, SHIFT(350),
  [635] = {.count = 1, .reusable = true}, SHIFT(350),
  [637] = {.count = 1, .reusable = true}, SHIFT(351),
  [639] = {.count = 1, .reusable = true}, SHIFT(352),
  [641] = {.count = 1, .reusable = true}, SHIFT(353),
  [643] = {.count = 1, .reusable = false}, SHIFT(354),
  [645] = {.count = 1, .reusable = true}, SHIFT(354),
  [647] = {.count = 1, .reusable = true}, SHIFT(364),
  [649] = {.count = 1, .reusable = true}, SHIFT(365),
  [651] = {.count = 1, .reusable = false}, SHIFT(364),
  [653] = {.count = 1, .reusable = true}, SHIFT(366),
  [655] = {.count = 1, .reusable = true}, SHIFT(367),
  [657] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [659] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [661] = {.count = 1, .reusable = false}, SHIFT(369),
  [663] = {.count = 1, .reusable = false}, SHIFT(370),
  [665] = {.count = 1, .reusable = true}, SHIFT(372),
  [667] = {.count = 1, .reusable = true}, SHIFT(373),
  [669] = {.count = 1, .reusable = false}, SHIFT(374),
  [671] = {.count = 1, .reusable = true}, SHIFT(374),
  [673] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [675] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [677] = {.count = 1, .reusable = true}, SHIFT(375),
  [679] = {.count = 1, .reusable = true}, SHIFT(376),
  [681] = {.count = 1, .reusable = true}, SHIFT(377),
  [683] = {.count = 1, .reusable = false}, SHIFT(378),
  [685] = {.count = 1, .reusable = true}, SHIFT(378),
  [687] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 2),
  [689] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 2),
  [691] = {.count = 1, .reusable = false}, SHIFT(388),
  [693] = {.count = 1, .reusable = true}, SHIFT(389),
  [695] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [697] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [699] = {.count = 1, .reusable = false}, SHIFT(391),
  [701] = {.count = 1, .reusable = false}, SHIFT(392),
  [703] = {.count = 1, .reusable = true}, SHIFT(394),
  [705] = {.count = 1, .reusable = true}, SHIFT(395),
  [707] = {.count = 1, .reusable = false}, SHIFT(396),
  [709] = {.count = 1, .reusable = true}, SHIFT(396),
  [711] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [713] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [715] = {.count = 1, .reusable = true}, SHIFT(397),
  [717] = {.count = 1, .reusable = true}, SHIFT(398),
  [719] = {.count = 1, .reusable = true}, SHIFT(399),
  [721] = {.count = 1, .reusable = false}, SHIFT(400),
  [723] = {.count = 1, .reusable = true}, SHIFT(400),
  [725] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 2),
  [727] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 2),
  [729] = {.count = 1, .reusable = false}, SHIFT(410),
  [731] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [733] = {.count = 1, .reusable = true}, SHIFT(411),
  [735] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [737] = {.count = 1, .reusable = false}, SHIFT(413),
  [739] = {.count = 1, .reusable = false}, SHIFT(414),
  [741] = {.count = 1, .reusable = true}, SHIFT(416),
  [743] = {.count = 1, .reusable = true}, SHIFT(417),
  [745] = {.count = 1, .reusable = false}, SHIFT(418),
  [747] = {.count = 1, .reusable = true}, SHIFT(418),
  [749] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2),
  [751] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2),
  [753] = {.count = 1, .reusable = true}, SHIFT(419),
  [755] = {.count = 1, .reusable = true}, SHIFT(420),
  [757] = {.count = 1, .reusable = true}, SHIFT(421),
  [759] = {.count = 1, .reusable = false}, SHIFT(422),
  [761] = {.count = 1, .reusable = true}, SHIFT(422),
  [763] = {.count = 1, .reusable = true}, SHIFT(432),
  [765] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 2),
  [767] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 2),
  [769] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [771] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [773] = {.count = 1, .reusable = false}, SHIFT(434),
  [775] = {.count = 1, .reusable = false}, SHIFT(435),
  [777] = {.count = 1, .reusable = false}, SHIFT(436),
  [779] = {.count = 1, .reusable = true}, SHIFT(435),
  [781] = {.count = 1, .reusable = false}, SHIFT(437),
  [783] = {.count = 1, .reusable = true}, SHIFT(437),
  [785] = {.count = 1, .reusable = true}, SHIFT(438),
  [787] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 1),
  [789] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 1),
  [791] = {.count = 1, .reusable = true}, SHIFT(439),
  [793] = {.count = 1, .reusable = true}, SHIFT(440),
  [795] = {.count = 1, .reusable = true}, SHIFT(441),
  [797] = {.count = 1, .reusable = false}, SHIFT(442),
  [799] = {.count = 1, .reusable = true}, SHIFT(442),
  [801] = {.count = 1, .reusable = false}, SHIFT(449),
  [803] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [805] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [807] = {.count = 1, .reusable = true}, REDUCE(sym_string_expansion, 2),
  [809] = {.count = 1, .reusable = false}, REDUCE(sym_string_expansion, 2),
  [811] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2),
  [813] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2),
  [815] = {.count = 1, .reusable = true}, SHIFT(451),
  [817] = {.count = 1, .reusable = true}, SHIFT(452),
  [819] = {.count = 1, .reusable = true}, SHIFT(453),
  [821] = {.count = 1, .reusable = true}, SHIFT(454),
  [823] = {.count = 1, .reusable = false}, SHIFT(455),
  [825] = {.count = 1, .reusable = true}, SHIFT(455),
  [827] = {.count = 1, .reusable = true}, SHIFT(456),
  [829] = {.count = 1, .reusable = false}, SHIFT(466),
  [831] = {.count = 1, .reusable = false}, SHIFT(457),
  [833] = {.count = 1, .reusable = true}, SHIFT(458),
  [835] = {.count = 1, .reusable = false}, SHIFT(459),
  [837] = {.count = 1, .reusable = true}, SHIFT(460),
  [839] = {.count = 1, .reusable = true}, SHIFT(466),
  [841] = {.count = 1, .reusable = true}, SHIFT(461),
  [843] = {.count = 1, .reusable = true}, SHIFT(462),
  [845] = {.count = 1, .reusable = true}, SHIFT(463),
  [847] = {.count = 1, .reusable = true}, SHIFT(464),
  [849] = {.count = 1, .reusable = true}, SHIFT(465),
  [851] = {.count = 1, .reusable = false}, SHIFT(460),
  [853] = {.count = 1, .reusable = true}, SHIFT(467),
  [855] = {.count = 1, .reusable = false}, SHIFT(469),
  [857] = {.count = 1, .reusable = true}, SHIFT(469),
  [859] = {.count = 1, .reusable = true}, SHIFT(468),
  [861] = {.count = 1, .reusable = false}, SHIFT(470),
  [863] = {.count = 1, .reusable = true}, SHIFT(471),
  [865] = {.count = 1, .reusable = true}, SHIFT(470),
  [867] = {.count = 1, .reusable = true}, SHIFT(475),
  [869] = {.count = 1, .reusable = false}, SHIFT(478),
  [871] = {.count = 1, .reusable = false}, SHIFT(479),
  [873] = {.count = 1, .reusable = true}, SHIFT(480),
  [875] = {.count = 1, .reusable = false}, SHIFT(481),
  [877] = {.count = 1, .reusable = false}, SHIFT(482),
  [879] = {.count = 1, .reusable = true}, SHIFT(481),
  [881] = {.count = 1, .reusable = true}, SHIFT(482),
  [883] = {.count = 1, .reusable = true}, SHIFT(483),
  [885] = {.count = 1, .reusable = true}, SHIFT(484),
  [887] = {.count = 1, .reusable = false}, SHIFT(485),
  [889] = {.count = 1, .reusable = true}, SHIFT(485),
  [891] = {.count = 1, .reusable = true}, SHIFT(486),
  [893] = {.count = 1, .reusable = false}, SHIFT(492),
  [895] = {.count = 1, .reusable = true}, SHIFT(493),
  [897] = {.count = 1, .reusable = true}, SHIFT(492),
  [899] = {.count = 1, .reusable = true}, SHIFT(496),
  [901] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 2),
  [903] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [905] = {.count = 1, .reusable = false}, REDUCE(sym__terminated_statement, 2),
  [907] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 1),
  [909] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 1),
  [911] = {.count = 1, .reusable = true}, SHIFT(504),
  [913] = {.count = 1, .reusable = true}, SHIFT(501),
  [915] = {.count = 1, .reusable = false}, SHIFT(502),
  [917] = {.count = 1, .reusable = true}, SHIFT(503),
  [919] = {.count = 1, .reusable = false}, SHIFT(505),
  [921] = {.count = 1, .reusable = true}, SHIFT(505),
  [923] = {.count = 1, .reusable = false}, SHIFT(506),
  [925] = {.count = 1, .reusable = false}, SHIFT(17),
  [927] = {.count = 1, .reusable = false}, SHIFT(507),
  [929] = {.count = 1, .reusable = false}, SHIFT(20),
  [931] = {.count = 1, .reusable = false}, SHIFT(21),
  [933] = {.count = 1, .reusable = false}, SHIFT(22),
  [935] = {.count = 1, .reusable = false}, SHIFT(23),
  [937] = {.count = 1, .reusable = false}, SHIFT(508),
  [939] = {.count = 1, .reusable = true}, SHIFT(509),
  [941] = {.count = 1, .reusable = true}, SHIFT(510),
  [943] = {.count = 1, .reusable = true}, SHIFT(512),
  [945] = {.count = 1, .reusable = true}, SHIFT(513),
  [947] = {.count = 1, .reusable = true}, SHIFT(514),
  [949] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [951] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [953] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1),
  [955] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1),
  [957] = {.count = 1, .reusable = true}, REDUCE(sym_command, 2),
  [959] = {.count = 1, .reusable = false}, REDUCE(sym_command, 2),
  [961] = {.count = 1, .reusable = false}, SHIFT(520),
  [963] = {.count = 1, .reusable = true}, SHIFT(520),
  [965] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2),
  [968] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(38),
  [971] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(4),
  [974] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(39),
  [977] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(6),
  [980] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(7),
  [983] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(40),
  [986] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(9),
  [989] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(41),
  [992] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(42),
  [995] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(43),
  [998] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(44),
  [1001] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(45),
  [1004] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(15),
  [1007] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(15),
  [1010] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(46),
  [1013] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(17),
  [1016] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(18),
  [1019] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(47),
  [1022] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(20),
  [1025] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(21),
  [1028] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(22),
  [1031] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(23),
  [1034] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(48),
  [1037] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [1040] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(83),
  [1043] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(15),
  [1046] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(15),
  [1049] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2),
  [1051] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2),
  [1053] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [1055] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [1057] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3),
  [1059] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3),
  [1061] = {.count = 1, .reusable = true}, SHIFT(524),
  [1063] = {.count = 1, .reusable = true}, SHIFT(525),
  [1065] = {.count = 1, .reusable = true}, SHIFT(527),
  [1067] = {.count = 1, .reusable = true}, SHIFT(528),
  [1069] = {.count = 1, .reusable = true}, SHIFT(529),
  [1071] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3),
  [1073] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3),
  [1075] = {.count = 1, .reusable = true}, SHIFT(530),
  [1077] = {.count = 1, .reusable = true}, SHIFT(531),
  [1079] = {.count = 1, .reusable = true}, SHIFT(532),
  [1081] = {.count = 1, .reusable = false}, SHIFT(533),
  [1083] = {.count = 1, .reusable = true}, SHIFT(534),
  [1085] = {.count = 1, .reusable = true}, SHIFT(535),
  [1087] = {.count = 1, .reusable = true}, SHIFT(536),
  [1089] = {.count = 1, .reusable = true}, SHIFT(537),
  [1091] = {.count = 1, .reusable = true}, SHIFT(538),
  [1093] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1095] = {.count = 1, .reusable = true}, SHIFT(540),
  [1097] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1099] = {.count = 1, .reusable = false}, SHIFT(542),
  [1101] = {.count = 1, .reusable = false}, SHIFT(543),
  [1103] = {.count = 1, .reusable = true}, SHIFT(545),
  [1105] = {.count = 1, .reusable = true}, SHIFT(546),
  [1107] = {.count = 1, .reusable = false}, SHIFT(547),
  [1109] = {.count = 1, .reusable = true}, SHIFT(547),
  [1111] = {.count = 1, .reusable = true}, SHIFT(548),
  [1113] = {.count = 1, .reusable = true}, SHIFT(549),
  [1115] = {.count = 1, .reusable = true}, SHIFT(550),
  [1117] = {.count = 1, .reusable = false}, SHIFT(551),
  [1119] = {.count = 1, .reusable = true}, SHIFT(551),
  [1121] = {.count = 1, .reusable = false}, SHIFT(561),
  [1123] = {.count = 1, .reusable = true}, SHIFT(561),
  [1125] = {.count = 1, .reusable = true}, SHIFT(565),
  [1127] = {.count = 1, .reusable = false}, SHIFT(567),
  [1129] = {.count = 1, .reusable = false}, SHIFT(568),
  [1131] = {.count = 1, .reusable = true}, SHIFT(570),
  [1133] = {.count = 1, .reusable = true}, SHIFT(571),
  [1135] = {.count = 1, .reusable = false}, SHIFT(572),
  [1137] = {.count = 1, .reusable = true}, SHIFT(572),
  [1139] = {.count = 1, .reusable = true}, SHIFT(573),
  [1141] = {.count = 1, .reusable = true}, SHIFT(574),
  [1143] = {.count = 1, .reusable = true}, SHIFT(575),
  [1145] = {.count = 1, .reusable = false}, SHIFT(576),
  [1147] = {.count = 1, .reusable = true}, SHIFT(576),
  [1149] = {.count = 1, .reusable = false}, SHIFT(586),
  [1151] = {.count = 1, .reusable = true}, SHIFT(586),
  [1153] = {.count = 1, .reusable = true}, SHIFT(587),
  [1155] = {.count = 1, .reusable = true}, SHIFT(588),
  [1157] = {.count = 1, .reusable = false}, SHIFT(587),
  [1159] = {.count = 1, .reusable = true}, SHIFT(589),
  [1161] = {.count = 1, .reusable = true}, SHIFT(590),
  [1163] = {.count = 1, .reusable = false}, SHIFT(591),
  [1165] = {.count = 1, .reusable = true}, SHIFT(592),
  [1167] = {.count = 1, .reusable = true}, SHIFT(593),
  [1169] = {.count = 1, .reusable = true}, SHIFT(594),
  [1171] = {.count = 1, .reusable = true}, SHIFT(595),
  [1173] = {.count = 1, .reusable = true}, SHIFT(596),
  [1175] = {.count = 1, .reusable = true}, SHIFT(598),
  [1177] = {.count = 1, .reusable = true}, SHIFT(600),
  [1179] = {.count = 1, .reusable = true}, SHIFT(601),
  [1181] = {.count = 1, .reusable = true}, SHIFT(603),
  [1183] = {.count = 1, .reusable = true}, SHIFT(605),
  [1185] = {.count = 1, .reusable = true}, SHIFT(606),
  [1187] = {.count = 1, .reusable = false}, SHIFT(608),
  [1189] = {.count = 1, .reusable = false}, SHIFT(610),
  [1191] = {.count = 1, .reusable = true}, SHIFT(612),
  [1193] = {.count = 1, .reusable = false}, SHIFT(613),
  [1195] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [1197] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [1199] = {.count = 1, .reusable = false}, SHIFT(619),
  [1201] = {.count = 1, .reusable = true}, SHIFT(619),
  [1203] = {.count = 1, .reusable = false}, SHIFT(620),
  [1205] = {.count = 1, .reusable = false}, SHIFT(621),
  [1207] = {.count = 1, .reusable = true}, SHIFT(622),
  [1209] = {.count = 1, .reusable = true}, SHIFT(623),
  [1211] = {.count = 1, .reusable = true}, SHIFT(624),
  [1213] = {.count = 1, .reusable = true}, SHIFT(625),
  [1215] = {.count = 1, .reusable = false}, SHIFT(630),
  [1217] = {.count = 1, .reusable = false}, SHIFT(631),
  [1219] = {.count = 1, .reusable = false}, SHIFT(632),
  [1221] = {.count = 1, .reusable = true}, SHIFT(636),
  [1223] = {.count = 1, .reusable = false}, SHIFT(637),
  [1225] = {.count = 1, .reusable = true}, SHIFT(637),
  [1227] = {.count = 1, .reusable = true}, SHIFT(638),
  [1229] = {.count = 1, .reusable = false}, SHIFT(640),
  [1231] = {.count = 1, .reusable = false}, SHIFT(641),
  [1233] = {.count = 1, .reusable = false}, SHIFT(642),
  [1235] = {.count = 1, .reusable = true}, SHIFT(642),
  [1237] = {.count = 1, .reusable = true}, SHIFT(643),
  [1239] = {.count = 1, .reusable = true}, SHIFT(644),
  [1241] = {.count = 1, .reusable = true}, SHIFT(645),
  [1243] = {.count = 1, .reusable = true}, SHIFT(646),
  [1245] = {.count = 1, .reusable = false}, SHIFT(647),
  [1247] = {.count = 1, .reusable = true}, SHIFT(647),
  [1249] = {.count = 1, .reusable = true}, SHIFT(648),
  [1251] = {.count = 1, .reusable = false}, SHIFT(650),
  [1253] = {.count = 1, .reusable = true}, SHIFT(650),
  [1255] = {.count = 1, .reusable = true}, SHIFT(649),
  [1257] = {.count = 1, .reusable = true}, SHIFT(651),
  [1259] = {.count = 1, .reusable = false}, SHIFT(653),
  [1261] = {.count = 1, .reusable = true}, SHIFT(653),
  [1263] = {.count = 1, .reusable = true}, SHIFT(652),
  [1265] = {.count = 1, .reusable = false}, SHIFT(654),
  [1267] = {.count = 1, .reusable = true}, SHIFT(655),
  [1269] = {.count = 1, .reusable = true}, SHIFT(654),
  [1271] = {.count = 1, .reusable = false}, SHIFT(658),
  [1273] = {.count = 1, .reusable = true}, SHIFT(658),
  [1275] = {.count = 1, .reusable = false}, SHIFT(661),
  [1277] = {.count = 1, .reusable = true}, SHIFT(662),
  [1279] = {.count = 1, .reusable = true}, SHIFT(661),
  [1281] = {.count = 1, .reusable = true}, SHIFT(665),
  [1283] = {.count = 1, .reusable = true}, SHIFT(666),
  [1285] = {.count = 1, .reusable = true}, SHIFT(670),
  [1287] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1289] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1291] = {.count = 1, .reusable = false}, SHIFT(671),
  [1293] = {.count = 1, .reusable = true}, SHIFT(671),
  [1295] = {.count = 1, .reusable = true}, SHIFT(673),
  [1297] = {.count = 1, .reusable = true}, SHIFT(674),
  [1299] = {.count = 1, .reusable = true}, SHIFT(676),
  [1301] = {.count = 1, .reusable = true}, SHIFT(678),
  [1303] = {.count = 1, .reusable = true}, SHIFT(679),
  [1305] = {.count = 1, .reusable = false}, SHIFT(681),
  [1307] = {.count = 1, .reusable = false}, SHIFT(683),
  [1309] = {.count = 1, .reusable = true}, SHIFT(685),
  [1311] = {.count = 1, .reusable = true}, SHIFT(686),
  [1313] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3),
  [1315] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3),
  [1317] = {.count = 1, .reusable = false}, SHIFT(689),
  [1319] = {.count = 1, .reusable = true}, SHIFT(689),
  [1321] = {.count = 1, .reusable = false}, SHIFT(690),
  [1323] = {.count = 1, .reusable = false}, SHIFT(691),
  [1325] = {.count = 1, .reusable = true}, SHIFT(692),
  [1327] = {.count = 1, .reusable = true}, SHIFT(693),
  [1329] = {.count = 1, .reusable = true}, SHIFT(694),
  [1331] = {.count = 1, .reusable = true}, SHIFT(695),
  [1333] = {.count = 1, .reusable = false}, SHIFT(699),
  [1335] = {.count = 1, .reusable = true}, SHIFT(699),
  [1337] = {.count = 1, .reusable = true}, SHIFT(701),
  [1339] = {.count = 1, .reusable = true}, SHIFT(702),
  [1341] = {.count = 1, .reusable = true}, SHIFT(703),
  [1343] = {.count = 1, .reusable = true}, SHIFT(704),
  [1345] = {.count = 1, .reusable = true}, SHIFT(707),
  [1347] = {.count = 1, .reusable = true}, SHIFT(708),
  [1349] = {.count = 1, .reusable = true}, SHIFT(709),
  [1351] = {.count = 1, .reusable = false}, SHIFT(708),
  [1353] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [1355] = {.count = 1, .reusable = true}, SHIFT(710),
  [1357] = {.count = 1, .reusable = false}, SHIFT(712),
  [1359] = {.count = 1, .reusable = false}, SHIFT(713),
  [1361] = {.count = 1, .reusable = true}, SHIFT(714),
  [1363] = {.count = 1, .reusable = true}, SHIFT(715),
  [1365] = {.count = 1, .reusable = true}, SHIFT(716),
  [1367] = {.count = 1, .reusable = false}, SHIFT(717),
  [1369] = {.count = 1, .reusable = true}, SHIFT(717),
  [1371] = {.count = 1, .reusable = true}, SHIFT(718),
  [1373] = {.count = 1, .reusable = false}, SHIFT(720),
  [1375] = {.count = 1, .reusable = true}, SHIFT(720),
  [1377] = {.count = 1, .reusable = true}, SHIFT(719),
  [1379] = {.count = 1, .reusable = true}, SHIFT(721),
  [1381] = {.count = 1, .reusable = false}, SHIFT(723),
  [1383] = {.count = 1, .reusable = true}, SHIFT(723),
  [1385] = {.count = 1, .reusable = true}, SHIFT(722),
  [1387] = {.count = 1, .reusable = false}, SHIFT(724),
  [1389] = {.count = 1, .reusable = true}, SHIFT(725),
  [1391] = {.count = 1, .reusable = true}, SHIFT(724),
  [1393] = {.count = 1, .reusable = false}, SHIFT(728),
  [1395] = {.count = 1, .reusable = true}, SHIFT(728),
  [1397] = {.count = 1, .reusable = false}, SHIFT(731),
  [1399] = {.count = 1, .reusable = true}, SHIFT(732),
  [1401] = {.count = 1, .reusable = true}, SHIFT(731),
  [1403] = {.count = 1, .reusable = true}, SHIFT(736),
  [1405] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 3),
  [1407] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 3),
  [1409] = {.count = 1, .reusable = false}, SHIFT(737),
  [1411] = {.count = 1, .reusable = true}, SHIFT(737),
  [1413] = {.count = 1, .reusable = false}, SHIFT(738),
  [1415] = {.count = 1, .reusable = true}, SHIFT(738),
  [1417] = {.count = 1, .reusable = true}, SHIFT(739),
  [1419] = {.count = 1, .reusable = false}, SHIFT(86),
  [1421] = {.count = 1, .reusable = false}, SHIFT(88),
  [1423] = {.count = 1, .reusable = false}, SHIFT(89),
  [1425] = {.count = 1, .reusable = false}, SHIFT(92),
  [1427] = {.count = 1, .reusable = false}, SHIFT(93),
  [1429] = {.count = 1, .reusable = false}, SHIFT(94),
  [1431] = {.count = 1, .reusable = false}, SHIFT(95),
  [1433] = {.count = 1, .reusable = false}, SHIFT(741),
  [1435] = {.count = 1, .reusable = true}, SHIFT(742),
  [1437] = {.count = 1, .reusable = true}, SHIFT(743),
  [1439] = {.count = 1, .reusable = false}, SHIFT(745),
  [1441] = {.count = 1, .reusable = false}, SHIFT(746),
  [1443] = {.count = 1, .reusable = true}, SHIFT(747),
  [1445] = {.count = 1, .reusable = true}, SHIFT(748),
  [1447] = {.count = 1, .reusable = true}, SHIFT(749),
  [1449] = {.count = 1, .reusable = false}, SHIFT(750),
  [1451] = {.count = 1, .reusable = true}, SHIFT(750),
  [1453] = {.count = 1, .reusable = true}, SHIFT(751),
  [1455] = {.count = 1, .reusable = false}, SHIFT(753),
  [1457] = {.count = 1, .reusable = true}, SHIFT(753),
  [1459] = {.count = 1, .reusable = true}, SHIFT(752),
  [1461] = {.count = 1, .reusable = true}, SHIFT(754),
  [1463] = {.count = 1, .reusable = false}, SHIFT(756),
  [1465] = {.count = 1, .reusable = true}, SHIFT(756),
  [1467] = {.count = 1, .reusable = true}, SHIFT(755),
  [1469] = {.count = 1, .reusable = false}, SHIFT(757),
  [1471] = {.count = 1, .reusable = true}, SHIFT(758),
  [1473] = {.count = 1, .reusable = true}, SHIFT(757),
  [1475] = {.count = 1, .reusable = false}, SHIFT(761),
  [1477] = {.count = 1, .reusable = true}, SHIFT(761),
  [1479] = {.count = 1, .reusable = false}, SHIFT(764),
  [1481] = {.count = 1, .reusable = true}, SHIFT(765),
  [1483] = {.count = 1, .reusable = true}, SHIFT(764),
  [1485] = {.count = 1, .reusable = false}, SHIFT(97),
  [1487] = {.count = 1, .reusable = false}, SHIFT(99),
  [1489] = {.count = 1, .reusable = false}, SHIFT(100),
  [1491] = {.count = 1, .reusable = false}, SHIFT(103),
  [1493] = {.count = 1, .reusable = false}, SHIFT(104),
  [1495] = {.count = 1, .reusable = false}, SHIFT(105),
  [1497] = {.count = 1, .reusable = false}, SHIFT(106),
  [1499] = {.count = 1, .reusable = false}, SHIFT(769),
  [1501] = {.count = 1, .reusable = true}, SHIFT(770),
  [1503] = {.count = 1, .reusable = true}, SHIFT(771),
  [1505] = {.count = 1, .reusable = true}, SHIFT(772),
  [1507] = {.count = 1, .reusable = true}, SHIFT(773),
  [1509] = {.count = 1, .reusable = true}, SHIFT(774),
  [1511] = {.count = 1, .reusable = false}, SHIFT(776),
  [1513] = {.count = 1, .reusable = false}, SHIFT(777),
  [1515] = {.count = 1, .reusable = true}, SHIFT(778),
  [1517] = {.count = 1, .reusable = true}, SHIFT(779),
  [1519] = {.count = 1, .reusable = true}, SHIFT(780),
  [1521] = {.count = 1, .reusable = false}, SHIFT(781),
  [1523] = {.count = 1, .reusable = true}, SHIFT(781),
  [1525] = {.count = 1, .reusable = true}, SHIFT(782),
  [1527] = {.count = 1, .reusable = false}, SHIFT(784),
  [1529] = {.count = 1, .reusable = true}, SHIFT(784),
  [1531] = {.count = 1, .reusable = true}, SHIFT(783),
  [1533] = {.count = 1, .reusable = true}, SHIFT(785),
  [1535] = {.count = 1, .reusable = false}, SHIFT(787),
  [1537] = {.count = 1, .reusable = true}, SHIFT(787),
  [1539] = {.count = 1, .reusable = true}, SHIFT(786),
  [1541] = {.count = 1, .reusable = false}, SHIFT(788),
  [1543] = {.count = 1, .reusable = true}, SHIFT(789),
  [1545] = {.count = 1, .reusable = true}, SHIFT(788),
  [1547] = {.count = 1, .reusable = false}, SHIFT(792),
  [1549] = {.count = 1, .reusable = true}, SHIFT(792),
  [1551] = {.count = 1, .reusable = false}, SHIFT(795),
  [1553] = {.count = 1, .reusable = true}, SHIFT(796),
  [1555] = {.count = 1, .reusable = true}, SHIFT(795),
  [1557] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(108),
  [1560] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1562] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1564] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(109),
  [1567] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(110),
  [1570] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(111),
  [1573] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(112),
  [1576] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(113),
  [1579] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(114),
  [1582] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(115),
  [1585] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(116),
  [1588] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(388),
  [1591] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(112),
  [1594] = {.count = 1, .reusable = true}, SHIFT(799),
  [1596] = {.count = 1, .reusable = false}, SHIFT(801),
  [1598] = {.count = 1, .reusable = false}, SHIFT(802),
  [1600] = {.count = 1, .reusable = true}, SHIFT(803),
  [1602] = {.count = 1, .reusable = true}, SHIFT(804),
  [1604] = {.count = 1, .reusable = true}, SHIFT(805),
  [1606] = {.count = 1, .reusable = false}, SHIFT(806),
  [1608] = {.count = 1, .reusable = true}, SHIFT(806),
  [1610] = {.count = 1, .reusable = true}, SHIFT(807),
  [1612] = {.count = 1, .reusable = false}, SHIFT(809),
  [1614] = {.count = 1, .reusable = true}, SHIFT(809),
  [1616] = {.count = 1, .reusable = true}, SHIFT(808),
  [1618] = {.count = 1, .reusable = true}, SHIFT(810),
  [1620] = {.count = 1, .reusable = false}, SHIFT(812),
  [1622] = {.count = 1, .reusable = true}, SHIFT(812),
  [1624] = {.count = 1, .reusable = true}, SHIFT(811),
  [1626] = {.count = 1, .reusable = false}, SHIFT(813),
  [1628] = {.count = 1, .reusable = true}, SHIFT(814),
  [1630] = {.count = 1, .reusable = true}, SHIFT(813),
  [1632] = {.count = 1, .reusable = false}, SHIFT(817),
  [1634] = {.count = 1, .reusable = true}, SHIFT(817),
  [1636] = {.count = 1, .reusable = false}, SHIFT(820),
  [1638] = {.count = 1, .reusable = true}, SHIFT(821),
  [1640] = {.count = 1, .reusable = true}, SHIFT(820),
  [1642] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1644] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1646] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(119),
  [1649] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(120),
  [1652] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(121),
  [1655] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(122),
  [1658] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(123),
  [1661] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(124),
  [1664] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(125),
  [1667] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(126),
  [1670] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(410),
  [1673] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(122),
  [1676] = {.count = 1, .reusable = true}, SHIFT(824),
  [1678] = {.count = 1, .reusable = false}, SHIFT(826),
  [1680] = {.count = 1, .reusable = false}, SHIFT(827),
  [1682] = {.count = 1, .reusable = true}, SHIFT(828),
  [1684] = {.count = 1, .reusable = true}, SHIFT(829),
  [1686] = {.count = 1, .reusable = true}, SHIFT(830),
  [1688] = {.count = 1, .reusable = false}, SHIFT(831),
  [1690] = {.count = 1, .reusable = true}, SHIFT(831),
  [1692] = {.count = 1, .reusable = true}, SHIFT(832),
  [1694] = {.count = 1, .reusable = false}, SHIFT(834),
  [1696] = {.count = 1, .reusable = true}, SHIFT(834),
  [1698] = {.count = 1, .reusable = true}, SHIFT(833),
  [1700] = {.count = 1, .reusable = true}, SHIFT(835),
  [1702] = {.count = 1, .reusable = false}, SHIFT(837),
  [1704] = {.count = 1, .reusable = true}, SHIFT(837),
  [1706] = {.count = 1, .reusable = true}, SHIFT(836),
  [1708] = {.count = 1, .reusable = false}, SHIFT(838),
  [1710] = {.count = 1, .reusable = true}, SHIFT(839),
  [1712] = {.count = 1, .reusable = true}, SHIFT(838),
  [1714] = {.count = 1, .reusable = false}, SHIFT(842),
  [1716] = {.count = 1, .reusable = true}, SHIFT(842),
  [1718] = {.count = 1, .reusable = false}, SHIFT(845),
  [1720] = {.count = 1, .reusable = true}, SHIFT(846),
  [1722] = {.count = 1, .reusable = true}, SHIFT(845),
  [1724] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1726] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1728] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(137),
  [1731] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1733] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1735] = {.count = 1, .reusable = true}, SHIFT(849),
  [1737] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1739] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1741] = {.count = 1, .reusable = true}, SHIFT(850),
  [1743] = {.count = 1, .reusable = true}, SHIFT(851),
  [1745] = {.count = 1, .reusable = true}, SHIFT(852),
  [1747] = {.count = 1, .reusable = false}, SHIFT(853),
  [1749] = {.count = 1, .reusable = true}, SHIFT(853),
  [1751] = {.count = 1, .reusable = true}, SHIFT(854),
  [1753] = {.count = 1, .reusable = false}, SHIFT(856),
  [1755] = {.count = 1, .reusable = true}, SHIFT(856),
  [1757] = {.count = 1, .reusable = true}, SHIFT(855),
  [1759] = {.count = 1, .reusable = true}, SHIFT(857),
  [1761] = {.count = 1, .reusable = false}, SHIFT(859),
  [1763] = {.count = 1, .reusable = true}, SHIFT(859),
  [1765] = {.count = 1, .reusable = true}, SHIFT(858),
  [1767] = {.count = 1, .reusable = false}, SHIFT(860),
  [1769] = {.count = 1, .reusable = true}, SHIFT(861),
  [1771] = {.count = 1, .reusable = true}, SHIFT(860),
  [1773] = {.count = 1, .reusable = false}, SHIFT(864),
  [1775] = {.count = 1, .reusable = true}, SHIFT(864),
  [1777] = {.count = 1, .reusable = false}, SHIFT(867),
  [1779] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(868),
  [1782] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(141),
  [1785] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(142),
  [1788] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(143),
  [1791] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(144),
  [1794] = {.count = 1, .reusable = true}, SHIFT(869),
  [1796] = {.count = 1, .reusable = true}, SHIFT(870),
  [1798] = {.count = 1, .reusable = true}, SHIFT(872),
  [1800] = {.count = 1, .reusable = false}, SHIFT(873),
  [1802] = {.count = 1, .reusable = true}, SHIFT(874),
  [1804] = {.count = 1, .reusable = false}, SHIFT(875),
  [1806] = {.count = 1, .reusable = true}, SHIFT(876),
  [1808] = {.count = 1, .reusable = true}, SHIFT(877),
  [1810] = {.count = 1, .reusable = true}, SHIFT(878),
  [1812] = {.count = 1, .reusable = true}, SHIFT(879),
  [1814] = {.count = 1, .reusable = true}, SHIFT(880),
  [1816] = {.count = 1, .reusable = true}, SHIFT(882),
  [1818] = {.count = 1, .reusable = true}, SHIFT(883),
  [1820] = {.count = 1, .reusable = false}, SHIFT(885),
  [1822] = {.count = 1, .reusable = true}, SHIFT(885),
  [1824] = {.count = 1, .reusable = true}, SHIFT(884),
  [1826] = {.count = 1, .reusable = false}, SHIFT(887),
  [1828] = {.count = 1, .reusable = true}, SHIFT(887),
  [1830] = {.count = 1, .reusable = true}, SHIFT(886),
  [1832] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [1834] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [1836] = {.count = 1, .reusable = true}, SHIFT(888),
  [1838] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1840] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1842] = {.count = 1, .reusable = false}, SHIFT(890),
  [1844] = {.count = 1, .reusable = false}, SHIFT(891),
  [1846] = {.count = 1, .reusable = true}, SHIFT(893),
  [1848] = {.count = 1, .reusable = true}, SHIFT(894),
  [1850] = {.count = 1, .reusable = false}, SHIFT(895),
  [1852] = {.count = 1, .reusable = true}, SHIFT(895),
  [1854] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1856] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1858] = {.count = 1, .reusable = true}, SHIFT(896),
  [1860] = {.count = 1, .reusable = true}, SHIFT(897),
  [1862] = {.count = 1, .reusable = true}, SHIFT(898),
  [1864] = {.count = 1, .reusable = false}, SHIFT(899),
  [1866] = {.count = 1, .reusable = true}, SHIFT(899),
  [1868] = {.count = 1, .reusable = true}, SHIFT(900),
  [1870] = {.count = 1, .reusable = true}, SHIFT(910),
  [1872] = {.count = 1, .reusable = false}, SHIFT(911),
  [1874] = {.count = 1, .reusable = true}, SHIFT(911),
  [1876] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3),
  [1878] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3),
  [1880] = {.count = 1, .reusable = true}, SHIFT(912),
  [1882] = {.count = 1, .reusable = true}, SHIFT(913),
  [1884] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 3),
  [1886] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 3),
  [1888] = {.count = 1, .reusable = false}, SHIFT(914),
  [1890] = {.count = 1, .reusable = true}, SHIFT(914),
  [1892] = {.count = 1, .reusable = true}, SHIFT(916),
  [1894] = {.count = 1, .reusable = true}, SHIFT(918),
  [1896] = {.count = 1, .reusable = true}, SHIFT(919),
  [1898] = {.count = 1, .reusable = false}, SHIFT(923),
  [1900] = {.count = 1, .reusable = true}, SHIFT(923),
  [1902] = {.count = 1, .reusable = true}, SHIFT(924),
  [1904] = {.count = 1, .reusable = true}, SHIFT(925),
  [1906] = {.count = 1, .reusable = true}, SHIFT(926),
  [1908] = {.count = 1, .reusable = true}, SHIFT(927),
  [1910] = {.count = 1, .reusable = false}, SHIFT(930),
  [1912] = {.count = 1, .reusable = true}, SHIFT(930),
  [1914] = {.count = 1, .reusable = true}, SHIFT(932),
  [1916] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 3),
  [1918] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 3),
  [1920] = {.count = 1, .reusable = false}, SHIFT(933),
  [1922] = {.count = 1, .reusable = true}, SHIFT(933),
  [1924] = {.count = 1, .reusable = true}, REDUCE(sym_pipeline, 3),
  [1926] = {.count = 1, .reusable = false}, REDUCE(sym_pipeline, 3),
  [1928] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [1930] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [1932] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [1934] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [1936] = {.count = 1, .reusable = true}, SHIFT(935),
  [1938] = {.count = 1, .reusable = false}, SHIFT(936),
  [1940] = {.count = 1, .reusable = true}, SHIFT(936),
  [1942] = {.count = 1, .reusable = true}, SHIFT(937),
  [1944] = {.count = 1, .reusable = true}, SHIFT(938),
  [1946] = {.count = 1, .reusable = true}, SHIFT(939),
  [1948] = {.count = 1, .reusable = false}, SHIFT(940),
  [1950] = {.count = 1, .reusable = true}, SHIFT(940),
  [1952] = {.count = 1, .reusable = true}, SHIFT(942),
  [1954] = {.count = 1, .reusable = true}, SHIFT(941),
  [1956] = {.count = 1, .reusable = true}, SHIFT(943),
  [1958] = {.count = 1, .reusable = true}, SHIFT(944),
  [1960] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [1962] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [1964] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2),
  [1966] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1968] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_redirect, 2),
  [1970] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_redirect, 2),
  [1972] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [1974] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [1976] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2),
  [1978] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2),
  [1980] = {.count = 1, .reusable = true}, REDUCE(sym_command, 3),
  [1982] = {.count = 1, .reusable = false}, REDUCE(sym_command, 3),
  [1984] = {.count = 1, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [1986] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(178),
  [1989] = {.count = 1, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [1991] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(180),
  [1994] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(180),
  [1997] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(181),
  [2000] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(181),
  [2003] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(182),
  [2006] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(179),
  [2009] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(183),
  [2012] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(17),
  [2015] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(18),
  [2018] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(184),
  [2021] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(20),
  [2024] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(21),
  [2027] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(22),
  [2030] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(23),
  [2033] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(184),
  [2036] = {.count = 1, .reusable = true}, REDUCE(sym_program, 3),
  [2038] = {.count = 1, .reusable = false}, SHIFT(948),
  [2040] = {.count = 1, .reusable = true}, SHIFT(948),
  [2042] = {.count = 1, .reusable = true}, SHIFT(950),
  [2044] = {.count = 1, .reusable = false}, SHIFT(710),
  [2046] = {.count = 1, .reusable = true}, SHIFT(951),
  [2048] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [2050] = {.count = 1, .reusable = true}, SHIFT(953),
  [2052] = {.count = 1, .reusable = true}, SHIFT(954),
  [2054] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2056] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2058] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2060] = {.count = 1, .reusable = true}, SHIFT(955),
  [2062] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2064] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2066] = {.count = 1, .reusable = false}, SHIFT(957),
  [2068] = {.count = 1, .reusable = false}, SHIFT(958),
  [2070] = {.count = 1, .reusable = true}, SHIFT(960),
  [2072] = {.count = 1, .reusable = true}, SHIFT(961),
  [2074] = {.count = 1, .reusable = false}, SHIFT(962),
  [2076] = {.count = 1, .reusable = true}, SHIFT(962),
  [2078] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2080] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2082] = {.count = 1, .reusable = true}, SHIFT(963),
  [2084] = {.count = 1, .reusable = true}, SHIFT(964),
  [2086] = {.count = 1, .reusable = true}, SHIFT(965),
  [2088] = {.count = 1, .reusable = false}, SHIFT(966),
  [2090] = {.count = 1, .reusable = true}, SHIFT(966),
  [2092] = {.count = 1, .reusable = true}, SHIFT(976),
  [2094] = {.count = 1, .reusable = true}, SHIFT(978),
  [2096] = {.count = 1, .reusable = false}, SHIFT(980),
  [2098] = {.count = 1, .reusable = false}, SHIFT(981),
  [2100] = {.count = 1, .reusable = true}, SHIFT(982),
  [2102] = {.count = 1, .reusable = true}, SHIFT(983),
  [2104] = {.count = 1, .reusable = true}, SHIFT(984),
  [2106] = {.count = 1, .reusable = false}, SHIFT(985),
  [2108] = {.count = 1, .reusable = true}, SHIFT(985),
  [2110] = {.count = 1, .reusable = true}, SHIFT(986),
  [2112] = {.count = 1, .reusable = false}, SHIFT(988),
  [2114] = {.count = 1, .reusable = true}, SHIFT(988),
  [2116] = {.count = 1, .reusable = true}, SHIFT(987),
  [2118] = {.count = 1, .reusable = true}, SHIFT(989),
  [2120] = {.count = 1, .reusable = false}, SHIFT(991),
  [2122] = {.count = 1, .reusable = true}, SHIFT(991),
  [2124] = {.count = 1, .reusable = true}, SHIFT(990),
  [2126] = {.count = 1, .reusable = false}, SHIFT(992),
  [2128] = {.count = 1, .reusable = true}, SHIFT(993),
  [2130] = {.count = 1, .reusable = true}, SHIFT(992),
  [2132] = {.count = 1, .reusable = false}, SHIFT(996),
  [2134] = {.count = 1, .reusable = true}, SHIFT(996),
  [2136] = {.count = 1, .reusable = false}, SHIFT(999),
  [2138] = {.count = 1, .reusable = true}, SHIFT(1000),
  [2140] = {.count = 1, .reusable = true}, SHIFT(999),
  [2142] = {.count = 1, .reusable = true}, SHIFT(1003),
  [2144] = {.count = 1, .reusable = true}, SHIFT(1004),
  [2146] = {.count = 1, .reusable = false}, SHIFT(1005),
  [2148] = {.count = 1, .reusable = true}, SHIFT(1006),
  [2150] = {.count = 1, .reusable = true}, SHIFT(1007),
  [2152] = {.count = 1, .reusable = false}, SHIFT(1008),
  [2154] = {.count = 1, .reusable = true}, SHIFT(1009),
  [2156] = {.count = 1, .reusable = true}, SHIFT(1010),
  [2158] = {.count = 1, .reusable = true}, SHIFT(1011),
  [2160] = {.count = 1, .reusable = true}, SHIFT(1012),
  [2162] = {.count = 1, .reusable = true}, SHIFT(1013),
  [2164] = {.count = 1, .reusable = false}, SHIFT(1009),
  [2166] = {.count = 1, .reusable = true}, SHIFT(1005),
  [2168] = {.count = 1, .reusable = false}, SHIFT(1015),
  [2170] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2172] = {.count = 1, .reusable = true}, SHIFT(1016),
  [2174] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [2176] = {.count = 1, .reusable = true}, SHIFT(1017),
  [2178] = {.count = 1, .reusable = false}, SHIFT(1019),
  [2180] = {.count = 1, .reusable = false}, SHIFT(1020),
  [2182] = {.count = 1, .reusable = true}, SHIFT(1021),
  [2184] = {.count = 1, .reusable = true}, SHIFT(1022),
  [2186] = {.count = 1, .reusable = true}, SHIFT(1023),
  [2188] = {.count = 1, .reusable = false}, SHIFT(1024),
  [2190] = {.count = 1, .reusable = true}, SHIFT(1024),
  [2192] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2194] = {.count = 1, .reusable = false}, SHIFT(1027),
  [2196] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2198] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2200] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2202] = {.count = 1, .reusable = false}, SHIFT(1030),
  [2204] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2206] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2208] = {.count = 1, .reusable = false}, SHIFT(1031),
  [2210] = {.count = 1, .reusable = true}, SHIFT(1032),
  [2212] = {.count = 1, .reusable = true}, SHIFT(1031),
  [2214] = {.count = 1, .reusable = false}, SHIFT(1035),
  [2216] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2218] = {.count = 1, .reusable = false}, SHIFT(1038),
  [2220] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2222] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2224] = {.count = 1, .reusable = false}, SHIFT(210),
  [2226] = {.count = 1, .reusable = false}, SHIFT(212),
  [2228] = {.count = 1, .reusable = false}, SHIFT(213),
  [2230] = {.count = 1, .reusable = false}, SHIFT(216),
  [2232] = {.count = 1, .reusable = false}, SHIFT(217),
  [2234] = {.count = 1, .reusable = false}, SHIFT(218),
  [2236] = {.count = 1, .reusable = false}, SHIFT(219),
  [2238] = {.count = 1, .reusable = false}, SHIFT(1044),
  [2240] = {.count = 1, .reusable = true}, SHIFT(1045),
  [2242] = {.count = 1, .reusable = false}, SHIFT(1047),
  [2244] = {.count = 1, .reusable = false}, SHIFT(1048),
  [2246] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2248] = {.count = 1, .reusable = true}, SHIFT(1051),
  [2250] = {.count = 1, .reusable = false}, SHIFT(1052),
  [2252] = {.count = 1, .reusable = true}, SHIFT(1052),
  [2254] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2256] = {.count = 1, .reusable = true}, SHIFT(1054),
  [2258] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2260] = {.count = 1, .reusable = false}, SHIFT(1056),
  [2262] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2264] = {.count = 1, .reusable = false}, SHIFT(1066),
  [2266] = {.count = 1, .reusable = true}, SHIFT(1066),
  [2268] = {.count = 1, .reusable = false}, SHIFT(592),
  [2270] = {.count = 1, .reusable = false}, SHIFT(1068),
  [2272] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 4),
  [2274] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 4),
  [2276] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2278] = {.count = 1, .reusable = true}, SHIFT(1073),
  [2280] = {.count = 1, .reusable = false}, SHIFT(1074),
  [2282] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2284] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2286] = {.count = 1, .reusable = false}, SHIFT(1076),
  [2288] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2290] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2292] = {.count = 1, .reusable = true}, SHIFT(1079),
  [2294] = {.count = 1, .reusable = true}, SHIFT(1080),
  [2296] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(228),
  [2299] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(229),
  [2302] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(230),
  [2305] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(608),
  [2308] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(230),
  [2311] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(233),
  [2314] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(234),
  [2317] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(610),
  [2320] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(234),
  [2323] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 2),
  [2325] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 2),
  [2327] = {.count = 1, .reusable = false}, SHIFT(1084),
  [2329] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 4),
  [2331] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 4),
  [2333] = {.count = 1, .reusable = true}, SHIFT(1087),
  [2335] = {.count = 1, .reusable = true}, SHIFT(1088),
  [2337] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(243),
  [2340] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(245),
  [2343] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(245),
  [2346] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(246),
  [2349] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(244),
  [2352] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(247),
  [2355] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(248),
  [2358] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(248),
  [2361] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [2363] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [2365] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 1),
  [2367] = {.count = 1, .reusable = true}, SHIFT(1093),
  [2369] = {.count = 1, .reusable = false}, SHIFT(1093),
  [2371] = {.count = 1, .reusable = true}, SHIFT(631),
  [2373] = {.count = 1, .reusable = true}, SHIFT(632),
  [2375] = {.count = 1, .reusable = false}, SHIFT(1098),
  [2377] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2379] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2381] = {.count = 1, .reusable = false}, SHIFT(1100),
  [2383] = {.count = 1, .reusable = false}, SHIFT(1104),
  [2385] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2387] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(253),
  [2390] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2392] = {.count = 1, .reusable = false}, SHIFT(1106),
  [2394] = {.count = 1, .reusable = false}, SHIFT(1109),
  [2396] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2398] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2400] = {.count = 1, .reusable = false}, SHIFT(1111),
  [2402] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2404] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2406] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2408] = {.count = 1, .reusable = false}, SHIFT(1117),
  [2410] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2412] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2414] = {.count = 1, .reusable = false}, SHIFT(1119),
  [2416] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2418] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2420] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2422] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2424] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2426] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2428] = {.count = 1, .reusable = false}, SHIFT(1124),
  [2430] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2432] = {.count = 1, .reusable = false}, SHIFT(1125),
  [2434] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2436] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2438] = {.count = 1, .reusable = false}, SHIFT(1127),
  [2440] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2442] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [2444] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [2446] = {.count = 1, .reusable = false}, SHIFT(1129),
  [2448] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2450] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2452] = {.count = 1, .reusable = false}, SHIFT(1132),
  [2454] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2456] = {.count = 1, .reusable = true}, SHIFT(1133),
  [2458] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2460] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 4),
  [2462] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 4),
  [2464] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2466] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2468] = {.count = 1, .reusable = false}, SHIFT(1140),
  [2470] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2472] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2474] = {.count = 1, .reusable = false}, SHIFT(1142),
  [2476] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2478] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2480] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2482] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2484] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(286),
  [2487] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(287),
  [2490] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(288),
  [2493] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(681),
  [2496] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(288),
  [2499] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(291),
  [2502] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(292),
  [2505] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(683),
  [2508] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(292),
  [2511] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 4),
  [2513] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 4),
  [2515] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2517] = {.count = 1, .reusable = true}, SHIFT(1151),
  [2519] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(300),
  [2522] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(302),
  [2525] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(302),
  [2528] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(303),
  [2531] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(301),
  [2534] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(304),
  [2537] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(305),
  [2540] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(305),
  [2543] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2547] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2549] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2551] = {.count = 1, .reusable = false}, SHIFT(313),
  [2553] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(317),
  [2556] = {.count = 1, .reusable = false}, SHIFT(1158),
  [2558] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2560] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2562] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2564] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2566] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2568] = {.count = 1, .reusable = false}, SHIFT(1166),
  [2570] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2572] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2574] = {.count = 1, .reusable = false}, SHIFT(1168),
  [2576] = {.count = 1, .reusable = true}, SHIFT(1168),
  [2578] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2580] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2582] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2584] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2586] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2588] = {.count = 1, .reusable = false}, SHIFT(1173),
  [2590] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2592] = {.count = 1, .reusable = false}, SHIFT(1174),
  [2594] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2596] = {.count = 1, .reusable = true}, SHIFT(1175),
  [2598] = {.count = 1, .reusable = false}, SHIFT(1176),
  [2600] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2602] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2604] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2606] = {.count = 1, .reusable = false}, SHIFT(1177),
  [2608] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2610] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2612] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2614] = {.count = 1, .reusable = false}, SHIFT(1180),
  [2616] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2618] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2620] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2622] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2624] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2626] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2628] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2630] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2632] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 4),
  [2634] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 4),
  [2636] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(343),
  [2639] = {.count = 1, .reusable = false}, SHIFT(1192),
  [2641] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2643] = {.count = 1, .reusable = false}, SHIFT(1194),
  [2645] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2647] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2649] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2651] = {.count = 1, .reusable = false}, SHIFT(1200),
  [2653] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2655] = {.count = 1, .reusable = true}, SHIFT(1199),
  [2657] = {.count = 1, .reusable = false}, SHIFT(1202),
  [2659] = {.count = 1, .reusable = true}, SHIFT(1202),
  [2661] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2663] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2665] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2667] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2669] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2671] = {.count = 1, .reusable = false}, SHIFT(1207),
  [2673] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2675] = {.count = 1, .reusable = false}, SHIFT(1208),
  [2677] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2679] = {.count = 1, .reusable = true}, SHIFT(1209),
  [2681] = {.count = 1, .reusable = false}, SHIFT(1210),
  [2683] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2685] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2687] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(367),
  [2690] = {.count = 1, .reusable = false}, SHIFT(1213),
  [2692] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2694] = {.count = 1, .reusable = false}, SHIFT(1215),
  [2696] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2698] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2700] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2702] = {.count = 1, .reusable = false}, SHIFT(1221),
  [2704] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2706] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2708] = {.count = 1, .reusable = false}, SHIFT(1223),
  [2710] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2712] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2714] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2716] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2718] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2720] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2722] = {.count = 1, .reusable = false}, SHIFT(1228),
  [2724] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2726] = {.count = 1, .reusable = false}, SHIFT(1229),
  [2728] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2730] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2732] = {.count = 1, .reusable = false}, SHIFT(1231),
  [2734] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2736] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(389),
  [2739] = {.count = 1, .reusable = false}, SHIFT(1232),
  [2741] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2743] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2745] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2747] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2749] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2751] = {.count = 1, .reusable = false}, SHIFT(1240),
  [2753] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2755] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2757] = {.count = 1, .reusable = false}, SHIFT(1242),
  [2759] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2761] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2763] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2765] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2767] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2769] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2771] = {.count = 1, .reusable = false}, SHIFT(1247),
  [2773] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2775] = {.count = 1, .reusable = false}, SHIFT(1248),
  [2777] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2779] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2781] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2783] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2785] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(411),
  [2788] = {.count = 1, .reusable = false}, SHIFT(1251),
  [2790] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2792] = {.count = 1, .reusable = false}, SHIFT(1253),
  [2794] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2796] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2798] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2800] = {.count = 1, .reusable = false}, SHIFT(1259),
  [2802] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2804] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2806] = {.count = 1, .reusable = false}, SHIFT(1261),
  [2808] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2810] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2812] = {.count = 1, .reusable = true}, SHIFT(1262),
  [2814] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2816] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2818] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2820] = {.count = 1, .reusable = false}, SHIFT(1266),
  [2822] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2824] = {.count = 1, .reusable = false}, SHIFT(1267),
  [2826] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2828] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2830] = {.count = 1, .reusable = false}, SHIFT(1269),
  [2832] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2834] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 3),
  [2836] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 3),
  [2838] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2840] = {.count = 1, .reusable = false}, SHIFT(1271),
  [2842] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2844] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2846] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2848] = {.count = 1, .reusable = false}, SHIFT(1277),
  [2850] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2852] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2854] = {.count = 1, .reusable = false}, SHIFT(1279),
  [2856] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2858] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2860] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2862] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2864] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2866] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2868] = {.count = 1, .reusable = false}, SHIFT(1284),
  [2870] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2872] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2874] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2876] = {.count = 1, .reusable = true}, REDUCE(sym_string, 4),
  [2878] = {.count = 1, .reusable = false}, REDUCE(sym_string, 4),
  [2880] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2882] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2884] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2886] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2888] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2890] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4),
  [2892] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4),
  [2894] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2896] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2898] = {.count = 1, .reusable = false}, SHIFT(1294),
  [2900] = {.count = 1, .reusable = false}, SHIFT(1295),
  [2902] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2904] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2906] = {.count = 1, .reusable = false}, SHIFT(1299),
  [2908] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2910] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2912] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2914] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2916] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2918] = {.count = 1, .reusable = false}, SHIFT(1304),
  [2920] = {.count = 1, .reusable = true}, SHIFT(1304),
  [2922] = {.count = 1, .reusable = false}, SHIFT(1314),
  [2924] = {.count = 1, .reusable = true}, SHIFT(1315),
  [2926] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2928] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2930] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2932] = {.count = 1, .reusable = true}, SHIFT(1318),
  [2934] = {.count = 1, .reusable = true}, SHIFT(1319),
  [2936] = {.count = 1, .reusable = true}, SHIFT(1320),
  [2938] = {.count = 1, .reusable = false}, SHIFT(1322),
  [2940] = {.count = 1, .reusable = false}, SHIFT(1323),
  [2942] = {.count = 1, .reusable = true}, SHIFT(1324),
  [2944] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2946] = {.count = 1, .reusable = true}, SHIFT(1326),
  [2948] = {.count = 1, .reusable = false}, SHIFT(1327),
  [2950] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2952] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2954] = {.count = 1, .reusable = false}, SHIFT(1330),
  [2956] = {.count = 1, .reusable = true}, SHIFT(1330),
  [2958] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2960] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2962] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2964] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2966] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2968] = {.count = 1, .reusable = true}, SHIFT(1334),
  [2970] = {.count = 1, .reusable = false}, SHIFT(1335),
  [2972] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2974] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2976] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2978] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2980] = {.count = 1, .reusable = false}, SHIFT(1340),
  [2982] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2984] = {.count = 1, .reusable = false}, SHIFT(1343),
  [2986] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2988] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2990] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [2992] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [2994] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2),
  [2996] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(911),
  [2999] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(457),
  [3002] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(458),
  [3005] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(459),
  [3008] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(460),
  [3011] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(911),
  [3014] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(461),
  [3017] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(463),
  [3020] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(464),
  [3023] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(465),
  [3026] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(460),
  [3029] = {.count = 1, .reusable = false}, SHIFT(1347),
  [3031] = {.count = 1, .reusable = true}, SHIFT(1347),
  [3033] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 4),
  [3035] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 4),
  [3037] = {.count = 1, .reusable = true}, SHIFT(1348),
  [3039] = {.count = 1, .reusable = true}, SHIFT(1350),
  [3041] = {.count = 1, .reusable = true}, SHIFT(1351),
  [3043] = {.count = 1, .reusable = false}, SHIFT(1352),
  [3045] = {.count = 1, .reusable = true}, SHIFT(1352),
  [3047] = {.count = 1, .reusable = true}, SHIFT(1353),
  [3049] = {.count = 1, .reusable = false}, SHIFT(1354),
  [3051] = {.count = 1, .reusable = true}, SHIFT(1354),
  [3053] = {.count = 1, .reusable = true}, SHIFT(1355),
  [3055] = {.count = 1, .reusable = true}, SHIFT(1358),
  [3057] = {.count = 1, .reusable = true}, SHIFT(1359),
  [3059] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(484),
  [3062] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(485),
  [3065] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(485),
  [3068] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(486),
  [3071] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 4),
  [3073] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 4),
  [3075] = {.count = 1, .reusable = true}, SHIFT(1362),
  [3077] = {.count = 1, .reusable = true}, SHIFT(1364),
  [3079] = {.count = 1, .reusable = true}, SHIFT(1365),
  [3081] = {.count = 1, .reusable = true}, SHIFT(1366),
  [3083] = {.count = 1, .reusable = false}, SHIFT(1367),
  [3085] = {.count = 1, .reusable = true}, SHIFT(1367),
  [3087] = {.count = 1, .reusable = true}, SHIFT(1368),
  [3089] = {.count = 1, .reusable = false}, SHIFT(1370),
  [3091] = {.count = 1, .reusable = true}, SHIFT(1370),
  [3093] = {.count = 1, .reusable = true}, SHIFT(1369),
  [3095] = {.count = 1, .reusable = true}, SHIFT(1371),
  [3097] = {.count = 1, .reusable = false}, SHIFT(1373),
  [3099] = {.count = 1, .reusable = true}, SHIFT(1373),
  [3101] = {.count = 1, .reusable = true}, SHIFT(1372),
  [3103] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [3105] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [3107] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(942),
  [3110] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [3112] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(502),
  [3115] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(503),
  [3118] = {.count = 1, .reusable = true}, REDUCE(sym_command, 4),
  [3120] = {.count = 1, .reusable = false}, REDUCE(sym_command, 4),
  [3122] = {.count = 1, .reusable = true}, SHIFT(1376),
  [3124] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [3126] = {.count = 1, .reusable = true}, SHIFT(1377),
  [3128] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [3130] = {.count = 1, .reusable = true}, SHIFT(1378),
  [3132] = {.count = 1, .reusable = false}, SHIFT(1380),
  [3134] = {.count = 1, .reusable = false}, SHIFT(1381),
  [3136] = {.count = 1, .reusable = true}, SHIFT(1382),
  [3138] = {.count = 1, .reusable = true}, SHIFT(1383),
  [3140] = {.count = 1, .reusable = true}, SHIFT(1384),
  [3142] = {.count = 1, .reusable = false}, SHIFT(1385),
  [3144] = {.count = 1, .reusable = true}, SHIFT(1385),
  [3146] = {.count = 1, .reusable = true}, SHIFT(1386),
  [3148] = {.count = 1, .reusable = false}, SHIFT(1388),
  [3150] = {.count = 1, .reusable = true}, SHIFT(1388),
  [3152] = {.count = 1, .reusable = true}, SHIFT(1387),
  [3154] = {.count = 1, .reusable = true}, SHIFT(1389),
  [3156] = {.count = 1, .reusable = false}, SHIFT(1391),
  [3158] = {.count = 1, .reusable = true}, SHIFT(1391),
  [3160] = {.count = 1, .reusable = true}, SHIFT(1390),
  [3162] = {.count = 1, .reusable = false}, SHIFT(1392),
  [3164] = {.count = 1, .reusable = true}, SHIFT(1393),
  [3166] = {.count = 1, .reusable = true}, SHIFT(1392),
  [3168] = {.count = 1, .reusable = false}, SHIFT(1396),
  [3170] = {.count = 1, .reusable = true}, SHIFT(1396),
  [3172] = {.count = 1, .reusable = false}, SHIFT(1399),
  [3174] = {.count = 1, .reusable = true}, SHIFT(1400),
  [3176] = {.count = 1, .reusable = true}, SHIFT(1399),
  [3178] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3180] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3182] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3184] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(531),
  [3187] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(532),
  [3190] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(533),
  [3193] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(534),
  [3196] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(535),
  [3199] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(536),
  [3202] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(537),
  [3205] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(538),
  [3208] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(540),
  [3211] = {.count = 1, .reusable = false}, SHIFT(1403),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1404),
  [3215] = {.count = 1, .reusable = false}, SHIFT(1405),
  [3217] = {.count = 1, .reusable = true}, SHIFT(1406),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1408),
  [3221] = {.count = 1, .reusable = true}, SHIFT(1409),
  [3223] = {.count = 1, .reusable = false}, SHIFT(1411),
  [3225] = {.count = 1, .reusable = true}, SHIFT(1411),
  [3227] = {.count = 1, .reusable = true}, SHIFT(1410),
  [3229] = {.count = 1, .reusable = false}, SHIFT(1413),
  [3231] = {.count = 1, .reusable = true}, SHIFT(1413),
  [3233] = {.count = 1, .reusable = true}, SHIFT(1412),
  [3235] = {.count = 1, .reusable = true}, SHIFT(1414),
  [3237] = {.count = 1, .reusable = true}, SHIFT(1415),
  [3239] = {.count = 1, .reusable = true}, SHIFT(1416),
  [3241] = {.count = 1, .reusable = true}, SHIFT(1417),
  [3243] = {.count = 1, .reusable = false}, SHIFT(1418),
  [3245] = {.count = 1, .reusable = true}, SHIFT(1418),
  [3247] = {.count = 1, .reusable = false}, SHIFT(1419),
  [3249] = {.count = 1, .reusable = true}, SHIFT(1419),
  [3251] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3253] = {.count = 1, .reusable = false}, SHIFT(1421),
  [3255] = {.count = 1, .reusable = true}, SHIFT(1421),
  [3257] = {.count = 1, .reusable = true}, SHIFT(1422),
  [3259] = {.count = 1, .reusable = true}, SHIFT(1423),
  [3261] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3263] = {.count = 1, .reusable = false}, SHIFT(1429),
  [3265] = {.count = 1, .reusable = false}, SHIFT(1430),
  [3267] = {.count = 1, .reusable = true}, SHIFT(1432),
  [3269] = {.count = 1, .reusable = true}, SHIFT(1433),
  [3271] = {.count = 1, .reusable = false}, SHIFT(1434),
  [3273] = {.count = 1, .reusable = true}, SHIFT(1434),
  [3275] = {.count = 1, .reusable = true}, SHIFT(1435),
  [3277] = {.count = 1, .reusable = true}, SHIFT(1436),
  [3279] = {.count = 1, .reusable = true}, SHIFT(1437),
  [3281] = {.count = 1, .reusable = false}, SHIFT(1438),
  [3283] = {.count = 1, .reusable = true}, SHIFT(1438),
  [3285] = {.count = 1, .reusable = true}, SHIFT(1448),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1449),
  [3289] = {.count = 1, .reusable = true}, SHIFT(1450),
  [3291] = {.count = 1, .reusable = false}, SHIFT(1449),
  [3293] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(565),
  [3296] = {.count = 1, .reusable = false}, SHIFT(1452),
  [3298] = {.count = 1, .reusable = true}, SHIFT(1453),
  [3300] = {.count = 1, .reusable = false}, SHIFT(1454),
  [3302] = {.count = 1, .reusable = true}, SHIFT(1455),
  [3304] = {.count = 1, .reusable = true}, SHIFT(1457),
  [3306] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3308] = {.count = 1, .reusable = false}, SHIFT(1460),
  [3310] = {.count = 1, .reusable = true}, SHIFT(1460),
  [3312] = {.count = 1, .reusable = true}, SHIFT(1459),
  [3314] = {.count = 1, .reusable = false}, SHIFT(1462),
  [3316] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3318] = {.count = 1, .reusable = true}, SHIFT(1461),
  [3320] = {.count = 1, .reusable = true}, SHIFT(1463),
  [3322] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3324] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3326] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3328] = {.count = 1, .reusable = false}, SHIFT(1467),
  [3330] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3332] = {.count = 1, .reusable = false}, SHIFT(1468),
  [3334] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3336] = {.count = 1, .reusable = true}, SHIFT(1469),
  [3338] = {.count = 1, .reusable = false}, SHIFT(1470),
  [3340] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3342] = {.count = 1, .reusable = false}, SHIFT(1471),
  [3344] = {.count = 1, .reusable = true}, SHIFT(1471),
  [3346] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3348] = {.count = 1, .reusable = false}, SHIFT(1474),
  [3350] = {.count = 1, .reusable = false}, SHIFT(1475),
  [3352] = {.count = 1, .reusable = true}, SHIFT(1476),
  [3354] = {.count = 1, .reusable = true}, SHIFT(1477),
  [3356] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3358] = {.count = 1, .reusable = false}, SHIFT(1479),
  [3360] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3362] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3364] = {.count = 1, .reusable = false}, SHIFT(1482),
  [3366] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3368] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3370] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3372] = {.count = 1, .reusable = false}, SHIFT(1485),
  [3374] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3376] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3378] = {.count = 1, .reusable = false}, SHIFT(1486),
  [3380] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3382] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3384] = {.count = 1, .reusable = false}, SHIFT(1490),
  [3386] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3388] = {.count = 1, .reusable = false}, SHIFT(1493),
  [3390] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3392] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3394] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3396] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(589),
  [3399] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(590),
  [3402] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(591),
  [3405] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(592),
  [3408] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(593),
  [3411] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(594),
  [3414] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(595),
  [3417] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(596),
  [3420] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(592),
  [3423] = {.count = 1, .reusable = false}, SHIFT(1498),
  [3425] = {.count = 1, .reusable = false}, SHIFT(1501),
  [3427] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3429] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3433] = {.count = 1, .reusable = false}, SHIFT(1504),
  [3435] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3437] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3439] = {.count = 1, .reusable = true}, SHIFT(1506),
  [3441] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3443] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3445] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 3),
  [3447] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 3),
  [3449] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2),
  [3451] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [3453] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [3455] = {.count = 1, .reusable = true}, SHIFT(1511),
  [3457] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 2),
  [3459] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3461] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3463] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3465] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3467] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(631),
  [3470] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [3472] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [3474] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3476] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3478] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3480] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3482] = {.count = 1, .reusable = false}, SHIFT(1521),
  [3484] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5),
  [3486] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5),
  [3488] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3490] = {.count = 1, .reusable = false}, SHIFT(1525),
  [3492] = {.count = 1, .reusable = true}, SHIFT(1528),
  [3494] = {.count = 1, .reusable = true}, SHIFT(1529),
  [3496] = {.count = 1, .reusable = false}, SHIFT(1530),
  [3498] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3500] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3502] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3504] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3506] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3508] = {.count = 1, .reusable = false}, SHIFT(1537),
  [3510] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3512] = {.count = 1, .reusable = false}, SHIFT(1538),
  [3514] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3516] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3518] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3520] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [3522] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [3524] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [3526] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [3528] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [3530] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3532] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3534] = {.count = 1, .reusable = false}, SHIFT(1548),
  [3536] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3538] = {.count = 1, .reusable = true}, SHIFT(1549),
  [3540] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3542] = {.count = 1, .reusable = false}, SHIFT(1551),
  [3544] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3546] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3548] = {.count = 1, .reusable = true}, SHIFT(1553),
  [3550] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3552] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3554] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 5),
  [3556] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 5),
  [3558] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3560] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3562] = {.count = 1, .reusable = true}, SHIFT(1560),
  [3564] = {.count = 1, .reusable = false}, SHIFT(1561),
  [3566] = {.count = 1, .reusable = true}, SHIFT(1562),
  [3568] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3570] = {.count = 1, .reusable = true}, SHIFT(1565),
  [3572] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3574] = {.count = 1, .reusable = true}, SHIFT(1567),
  [3576] = {.count = 1, .reusable = false}, SHIFT(1568),
  [3578] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3580] = {.count = 1, .reusable = false}, SHIFT(1569),
  [3582] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3584] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3586] = {.count = 1, .reusable = true}, SHIFT(1571),
  [3588] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3590] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3592] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3594] = {.count = 1, .reusable = false}, SHIFT(1577),
  [3596] = {.count = 1, .reusable = false}, SHIFT(1578),
  [3598] = {.count = 1, .reusable = true}, SHIFT(1580),
  [3600] = {.count = 1, .reusable = true}, SHIFT(1581),
  [3602] = {.count = 1, .reusable = false}, SHIFT(1582),
  [3604] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3606] = {.count = 1, .reusable = true}, SHIFT(1583),
  [3608] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3610] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3612] = {.count = 1, .reusable = false}, SHIFT(1586),
  [3614] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3616] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(736),
  [3619] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(737),
  [3622] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(737),
  [3625] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(738),
  [3628] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(738),
  [3631] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(739),
  [3634] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3636] = {.count = 1, .reusable = true}, SHIFT(1597),
  [3638] = {.count = 1, .reusable = false}, SHIFT(1598),
  [3640] = {.count = 1, .reusable = true}, SHIFT(1599),
  [3642] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3644] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3646] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3648] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3650] = {.count = 1, .reusable = false}, SHIFT(1605),
  [3652] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3654] = {.count = 1, .reusable = false}, SHIFT(1606),
  [3656] = {.count = 1, .reusable = true}, SHIFT(1606),
  [3658] = {.count = 1, .reusable = true}, SHIFT(1607),
  [3660] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3662] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3664] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3666] = {.count = 1, .reusable = true}, SHIFT(1611),
  [3668] = {.count = 1, .reusable = false}, SHIFT(1612),
  [3670] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3672] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3674] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3676] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3678] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3680] = {.count = 1, .reusable = false}, SHIFT(1619),
  [3682] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3684] = {.count = 1, .reusable = false}, SHIFT(1620),
  [3686] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3688] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3690] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3692] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3694] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3696] = {.count = 1, .reusable = false}, SHIFT(1625),
  [3698] = {.count = 1, .reusable = true}, SHIFT(1626),
  [3700] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3702] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3704] = {.count = 1, .reusable = true}, SHIFT(1630),
  [3706] = {.count = 1, .reusable = true}, SHIFT(1631),
  [3708] = {.count = 1, .reusable = false}, SHIFT(1632),
  [3710] = {.count = 1, .reusable = true}, SHIFT(1632),
  [3712] = {.count = 1, .reusable = false}, SHIFT(1633),
  [3714] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3716] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3718] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3720] = {.count = 1, .reusable = true}, SHIFT(1636),
  [3722] = {.count = 1, .reusable = true}, SHIFT(1637),
  [3724] = {.count = 1, .reusable = false}, SHIFT(1638),
  [3726] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3728] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3730] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3732] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3734] = {.count = 1, .reusable = true}, SHIFT(1644),
  [3736] = {.count = 1, .reusable = false}, SHIFT(1645),
  [3738] = {.count = 1, .reusable = true}, SHIFT(1645),
  [3740] = {.count = 1, .reusable = false}, SHIFT(1646),
  [3742] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3744] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3746] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3748] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3750] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3752] = {.count = 1, .reusable = false}, SHIFT(1651),
  [3754] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3756] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3758] = {.count = 1, .reusable = true}, SHIFT(1655),
  [3760] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3762] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3764] = {.count = 1, .reusable = false}, SHIFT(1658),
  [3766] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3768] = {.count = 1, .reusable = false}, SHIFT(1659),
  [3770] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3772] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3774] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3776] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3778] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [3780] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3782] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3784] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [3786] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3788] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [3790] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [3792] = {.count = 1, .reusable = false}, SHIFT(1667),
  [3794] = {.count = 1, .reusable = false}, SHIFT(1668),
  [3796] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5),
  [3798] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5),
  [3800] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3802] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3804] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3806] = {.count = 1, .reusable = false}, SHIFT(1672),
  [3808] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3810] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3812] = {.count = 1, .reusable = false}, SHIFT(1675),
  [3814] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3816] = {.count = 1, .reusable = true}, SHIFT(1674),
  [3818] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3820] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3822] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3824] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3826] = {.count = 1, .reusable = false}, SHIFT(1679),
  [3828] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3830] = {.count = 1, .reusable = true}, SHIFT(1679),
  [3832] = {.count = 1, .reusable = false}, SHIFT(1683),
  [3834] = {.count = 1, .reusable = true}, SHIFT(1683),
  [3836] = {.count = 1, .reusable = false}, SHIFT(1686),
  [3838] = {.count = 1, .reusable = true}, SHIFT(1687),
  [3840] = {.count = 1, .reusable = true}, SHIFT(1686),
  [3842] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3844] = {.count = 1, .reusable = true}, SHIFT(1691),
  [3846] = {.count = 1, .reusable = true}, SHIFT(1692),
  [3848] = {.count = 1, .reusable = false}, SHIFT(1693),
  [3850] = {.count = 1, .reusable = true}, SHIFT(1693),
  [3852] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [3854] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [3856] = {.count = 1, .reusable = false}, SHIFT(1694),
  [3858] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3860] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(888),
  [3863] = {.count = 1, .reusable = false}, SHIFT(1695),
  [3865] = {.count = 1, .reusable = true}, SHIFT(1696),
  [3867] = {.count = 1, .reusable = false}, SHIFT(1697),
  [3869] = {.count = 1, .reusable = true}, SHIFT(1698),
  [3871] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3873] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3875] = {.count = 1, .reusable = false}, SHIFT(1703),
  [3877] = {.count = 1, .reusable = true}, SHIFT(1703),
  [3879] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3881] = {.count = 1, .reusable = false}, SHIFT(1705),
  [3883] = {.count = 1, .reusable = true}, SHIFT(1705),
  [3885] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3887] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3889] = {.count = 1, .reusable = true}, SHIFT(1707),
  [3891] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3893] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [3895] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [3897] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3899] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3901] = {.count = 1, .reusable = false}, SHIFT(1711),
  [3903] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3905] = {.count = 1, .reusable = false}, SHIFT(1712),
  [3907] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3909] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3911] = {.count = 1, .reusable = false}, SHIFT(1714),
  [3913] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3915] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 5),
  [3917] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 5),
  [3919] = {.count = 1, .reusable = false}, SHIFT(1716),
  [3921] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3923] = {.count = 1, .reusable = true}, SHIFT(1717),
  [3925] = {.count = 1, .reusable = true}, SHIFT(1718),
  [3927] = {.count = 1, .reusable = false}, SHIFT(1719),
  [3929] = {.count = 1, .reusable = true}, SHIFT(1719),
  [3931] = {.count = 1, .reusable = true}, SHIFT(1720),
  [3933] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3935] = {.count = 1, .reusable = true}, SHIFT(1722),
  [3937] = {.count = 1, .reusable = true}, SHIFT(1723),
  [3939] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 5),
  [3941] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 5),
  [3943] = {.count = 1, .reusable = true}, SHIFT(1726),
  [3945] = {.count = 1, .reusable = false}, SHIFT(1727),
  [3947] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3949] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3951] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3953] = {.count = 1, .reusable = false}, SHIFT(1733),
  [3955] = {.count = 1, .reusable = true}, SHIFT(1733),
  [3957] = {.count = 1, .reusable = true}, SHIFT(1732),
  [3959] = {.count = 1, .reusable = false}, SHIFT(1735),
  [3961] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3963] = {.count = 1, .reusable = true}, SHIFT(1734),
  [3965] = {.count = 1, .reusable = true}, SHIFT(1736),
  [3967] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3969] = {.count = 1, .reusable = true}, SHIFT(1738),
  [3971] = {.count = 1, .reusable = true}, REDUCE(sym_command, 5),
  [3973] = {.count = 1, .reusable = false}, REDUCE(sym_command, 5),
  [3975] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [3977] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [3979] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(955),
  [3982] = {.count = 1, .reusable = false}, SHIFT(1739),
  [3984] = {.count = 1, .reusable = true}, SHIFT(1740),
  [3986] = {.count = 1, .reusable = false}, SHIFT(1741),
  [3988] = {.count = 1, .reusable = true}, SHIFT(1742),
  [3990] = {.count = 1, .reusable = true}, SHIFT(1744),
  [3992] = {.count = 1, .reusable = true}, SHIFT(1745),
  [3994] = {.count = 1, .reusable = false}, SHIFT(1747),
  [3996] = {.count = 1, .reusable = true}, SHIFT(1747),
  [3998] = {.count = 1, .reusable = true}, SHIFT(1746),
  [4000] = {.count = 1, .reusable = false}, SHIFT(1749),
  [4002] = {.count = 1, .reusable = true}, SHIFT(1749),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1748),
  [4006] = {.count = 1, .reusable = true}, SHIFT(1750),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1751),
  [4010] = {.count = 1, .reusable = true}, SHIFT(1752),
  [4012] = {.count = 1, .reusable = true}, SHIFT(1753),
  [4014] = {.count = 1, .reusable = false}, SHIFT(1754),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1754),
  [4018] = {.count = 1, .reusable = false}, SHIFT(1755),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1755),
  [4022] = {.count = 1, .reusable = true}, SHIFT(1756),
  [4024] = {.count = 1, .reusable = false}, SHIFT(1757),
  [4026] = {.count = 1, .reusable = true}, SHIFT(1757),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1758),
  [4030] = {.count = 1, .reusable = true}, SHIFT(1759),
  [4032] = {.count = 1, .reusable = false}, SHIFT(1760),
  [4034] = {.count = 1, .reusable = true}, SHIFT(1761),
  [4036] = {.count = 1, .reusable = true}, SHIFT(1763),
  [4038] = {.count = 1, .reusable = true}, SHIFT(1764),
  [4040] = {.count = 1, .reusable = true}, SHIFT(1765),
  [4042] = {.count = 1, .reusable = true}, SHIFT(1766),
  [4044] = {.count = 1, .reusable = false}, SHIFT(1767),
  [4046] = {.count = 1, .reusable = true}, SHIFT(1767),
  [4048] = {.count = 1, .reusable = false}, SHIFT(1768),
  [4050] = {.count = 1, .reusable = true}, SHIFT(1768),
  [4052] = {.count = 1, .reusable = true}, SHIFT(1769),
  [4054] = {.count = 1, .reusable = true}, SHIFT(1770),
  [4056] = {.count = 1, .reusable = true}, SHIFT(1772),
  [4058] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 6),
  [4060] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 6),
  [4062] = {.count = 1, .reusable = true}, SHIFT(1774),
  [4064] = {.count = 1, .reusable = true}, SHIFT(1775),
  [4066] = {.count = 1, .reusable = false}, SHIFT(1777),
  [4068] = {.count = 1, .reusable = false}, SHIFT(1778),
  [4070] = {.count = 1, .reusable = true}, SHIFT(1779),
  [4072] = {.count = 1, .reusable = true}, SHIFT(1780),
  [4074] = {.count = 1, .reusable = true}, SHIFT(1781),
  [4076] = {.count = 1, .reusable = false}, SHIFT(1782),
  [4078] = {.count = 1, .reusable = true}, SHIFT(1782),
  [4080] = {.count = 1, .reusable = true}, SHIFT(1783),
  [4082] = {.count = 1, .reusable = false}, SHIFT(1785),
  [4084] = {.count = 1, .reusable = true}, SHIFT(1785),
  [4086] = {.count = 1, .reusable = true}, SHIFT(1784),
  [4088] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4090] = {.count = 1, .reusable = false}, SHIFT(1788),
  [4092] = {.count = 1, .reusable = true}, SHIFT(1788),
  [4094] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4096] = {.count = 1, .reusable = false}, SHIFT(1789),
  [4098] = {.count = 1, .reusable = true}, SHIFT(1790),
  [4100] = {.count = 1, .reusable = true}, SHIFT(1789),
  [4102] = {.count = 1, .reusable = false}, SHIFT(1793),
  [4104] = {.count = 1, .reusable = true}, SHIFT(1793),
  [4106] = {.count = 1, .reusable = false}, SHIFT(1796),
  [4108] = {.count = 1, .reusable = true}, SHIFT(1797),
  [4110] = {.count = 1, .reusable = true}, SHIFT(1796),
  [4112] = {.count = 1, .reusable = true}, SHIFT(1800),
  [4114] = {.count = 1, .reusable = false}, SHIFT(1004),
  [4116] = {.count = 1, .reusable = false}, SHIFT(1006),
  [4118] = {.count = 1, .reusable = false}, SHIFT(1007),
  [4120] = {.count = 1, .reusable = false}, SHIFT(1010),
  [4122] = {.count = 1, .reusable = false}, SHIFT(1011),
  [4124] = {.count = 1, .reusable = false}, SHIFT(1012),
  [4126] = {.count = 1, .reusable = false}, SHIFT(1013),
  [4128] = {.count = 1, .reusable = false}, SHIFT(1802),
  [4130] = {.count = 1, .reusable = true}, SHIFT(1803),
  [4132] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4134] = {.count = 1, .reusable = true}, SHIFT(1805),
  [4136] = {.count = 1, .reusable = false}, SHIFT(1806),
  [4138] = {.count = 1, .reusable = true}, SHIFT(1807),
  [4140] = {.count = 1, .reusable = true}, SHIFT(1809),
  [4142] = {.count = 1, .reusable = true}, SHIFT(1810),
  [4144] = {.count = 1, .reusable = true}, SHIFT(1811),
  [4146] = {.count = 1, .reusable = true}, SHIFT(1812),
  [4148] = {.count = 1, .reusable = false}, SHIFT(1813),
  [4150] = {.count = 1, .reusable = true}, SHIFT(1813),
  [4152] = {.count = 1, .reusable = false}, SHIFT(1814),
  [4154] = {.count = 1, .reusable = true}, SHIFT(1814),
  [4156] = {.count = 1, .reusable = true}, SHIFT(1815),
  [4158] = {.count = 1, .reusable = true}, SHIFT(1816),
  [4160] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1045),
  [4163] = {.count = 1, .reusable = false}, SHIFT(1818),
  [4165] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4167] = {.count = 1, .reusable = false}, SHIFT(1820),
  [4169] = {.count = 1, .reusable = true}, SHIFT(1821),
  [4171] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4173] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4175] = {.count = 1, .reusable = false}, SHIFT(1826),
  [4177] = {.count = 1, .reusable = true}, SHIFT(1826),
  [4179] = {.count = 1, .reusable = true}, SHIFT(1825),
  [4181] = {.count = 1, .reusable = false}, SHIFT(1828),
  [4183] = {.count = 1, .reusable = true}, SHIFT(1828),
  [4185] = {.count = 1, .reusable = true}, SHIFT(1827),
  [4187] = {.count = 1, .reusable = true}, SHIFT(1829),
  [4189] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4191] = {.count = 1, .reusable = true}, SHIFT(1831),
  [4193] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4195] = {.count = 1, .reusable = false}, SHIFT(1833),
  [4197] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4199] = {.count = 1, .reusable = false}, SHIFT(1834),
  [4201] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4203] = {.count = 1, .reusable = true}, SHIFT(1835),
  [4205] = {.count = 1, .reusable = false}, SHIFT(1836),
  [4207] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4209] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [4211] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [4213] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4215] = {.count = 1, .reusable = true}, SHIFT(1838),
  [4217] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4219] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4221] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1075),
  [4224] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1076),
  [4227] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1076),
  [4230] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1077),
  [4233] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 3),
  [4235] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [4237] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [4239] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4241] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4243] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4245] = {.count = 1, .reusable = true}, SHIFT(1848),
  [4247] = {.count = 1, .reusable = false}, SHIFT(1849),
  [4249] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [4251] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4253] = {.count = 1, .reusable = false}, SHIFT(1851),
  [4255] = {.count = 1, .reusable = false}, SHIFT(1852),
  [4257] = {.count = 1, .reusable = false}, SHIFT(1853),
  [4259] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4261] = {.count = 1, .reusable = false}, SHIFT(1855),
  [4263] = {.count = 1, .reusable = false}, SHIFT(1856),
  [4265] = {.count = 1, .reusable = false}, SHIFT(1857),
  [4267] = {.count = 1, .reusable = true}, SHIFT(1858),
  [4269] = {.count = 1, .reusable = false}, SHIFT(1859),
  [4271] = {.count = 1, .reusable = true}, SHIFT(1860),
  [4273] = {.count = 1, .reusable = true}, SHIFT(1861),
  [4275] = {.count = 1, .reusable = true}, SHIFT(1862),
  [4277] = {.count = 1, .reusable = true}, SHIFT(1863),
  [4279] = {.count = 1, .reusable = true}, SHIFT(1864),
  [4281] = {.count = 1, .reusable = false}, SHIFT(1865),
  [4283] = {.count = 1, .reusable = true}, SHIFT(1873),
  [4285] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2),
  [4287] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4289] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4291] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [4293] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [4295] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4297] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1882),
  [4300] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(100),
  [4303] = {.count = 2, .reusable = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(101),
  [4306] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1883),
  [4309] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(103),
  [4312] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(104),
  [4315] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(105),
  [4318] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(106),
  [4321] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6),
  [4323] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6),
  [4325] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4327] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4329] = {.count = 1, .reusable = true}, SHIFT(1889),
  [4331] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4333] = {.count = 1, .reusable = false}, SHIFT(1891),
  [4335] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4337] = {.count = 1, .reusable = false}, SHIFT(1892),
  [4339] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4341] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4343] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 6),
  [4345] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 6),
  [4347] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4349] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4351] = {.count = 1, .reusable = true}, SHIFT(1898),
  [4353] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4355] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1141),
  [4358] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1142),
  [4361] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1142),
  [4364] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1143),
  [4367] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4369] = {.count = 1, .reusable = true}, SHIFT(1902),
  [4371] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4373] = {.count = 1, .reusable = false}, SHIFT(1904),
  [4375] = {.count = 1, .reusable = true}, SHIFT(1904),
  [4377] = {.count = 1, .reusable = false}, SHIFT(1905),
  [4379] = {.count = 1, .reusable = true}, SHIFT(1905),
  [4381] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4383] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4385] = {.count = 1, .reusable = false}, SHIFT(1909),
  [4387] = {.count = 1, .reusable = false}, SHIFT(1910),
  [4389] = {.count = 1, .reusable = true}, SHIFT(1911),
  [4391] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4393] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4395] = {.count = 1, .reusable = false}, SHIFT(1914),
  [4397] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4399] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4401] = {.count = 1, .reusable = false}, SHIFT(1917),
  [4403] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4405] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4407] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4409] = {.count = 1, .reusable = false}, SHIFT(1920),
  [4411] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4413] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4415] = {.count = 1, .reusable = false}, SHIFT(1921),
  [4417] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4419] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4421] = {.count = 1, .reusable = false}, SHIFT(1925),
  [4423] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4425] = {.count = 1, .reusable = false}, SHIFT(1928),
  [4427] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4429] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4431] = {.count = 1, .reusable = true}, SHIFT(1932),
  [4433] = {.count = 1, .reusable = true}, SHIFT(1933),
  [4435] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4437] = {.count = 1, .reusable = false}, SHIFT(1935),
  [4439] = {.count = 1, .reusable = true}, SHIFT(1935),
  [4441] = {.count = 1, .reusable = false}, SHIFT(1936),
  [4443] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4445] = {.count = 1, .reusable = true}, SHIFT(1937),
  [4447] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4449] = {.count = 1, .reusable = true}, SHIFT(1939),
  [4451] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4453] = {.count = 1, .reusable = false}, SHIFT(1941),
  [4455] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4457] = {.count = 1, .reusable = false}, SHIFT(1942),
  [4459] = {.count = 1, .reusable = true}, SHIFT(1942),
  [4461] = {.count = 1, .reusable = true}, SHIFT(1943),
  [4463] = {.count = 1, .reusable = true}, SHIFT(1944),
  [4465] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4467] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4469] = {.count = 1, .reusable = false}, SHIFT(1947),
  [4471] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4473] = {.count = 1, .reusable = false}, SHIFT(1948),
  [4475] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4477] = {.count = 1, .reusable = true}, SHIFT(1949),
  [4479] = {.count = 1, .reusable = true}, SHIFT(1950),
  [4481] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4483] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4485] = {.count = 1, .reusable = false}, SHIFT(1953),
  [4487] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4489] = {.count = 1, .reusable = false}, SHIFT(1954),
  [4491] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4493] = {.count = 1, .reusable = true}, SHIFT(1955),
  [4495] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4497] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4499] = {.count = 1, .reusable = true}, SHIFT(1958),
  [4501] = {.count = 1, .reusable = false}, SHIFT(1959),
  [4503] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4505] = {.count = 1, .reusable = false}, SHIFT(1960),
  [4507] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4509] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4511] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4513] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [4515] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4517] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [4519] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1291),
  [4522] = {.count = 1, .reusable = false}, SHIFT(1964),
  [4524] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4526] = {.count = 1, .reusable = false}, SHIFT(1966),
  [4528] = {.count = 1, .reusable = true}, SHIFT(1967),
  [4530] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4532] = {.count = 1, .reusable = true}, SHIFT(1970),
  [4534] = {.count = 1, .reusable = false}, SHIFT(1972),
  [4536] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4538] = {.count = 1, .reusable = true}, SHIFT(1971),
  [4540] = {.count = 1, .reusable = false}, SHIFT(1974),
  [4542] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4544] = {.count = 1, .reusable = true}, SHIFT(1973),
  [4546] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4548] = {.count = 1, .reusable = true}, SHIFT(1976),
  [4550] = {.count = 1, .reusable = true}, SHIFT(1977),
  [4552] = {.count = 1, .reusable = true}, SHIFT(1978),
  [4554] = {.count = 1, .reusable = false}, SHIFT(1979),
  [4556] = {.count = 1, .reusable = true}, SHIFT(1979),
  [4558] = {.count = 1, .reusable = false}, SHIFT(1980),
  [4560] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4562] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4564] = {.count = 1, .reusable = false}, SHIFT(1982),
  [4566] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4568] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [4570] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [4572] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6),
  [4574] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6),
  [4576] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [4578] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [4580] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4582] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4584] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4586] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4588] = {.count = 1, .reusable = false}, SHIFT(1987),
  [4590] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4592] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4594] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4596] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4598] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4600] = {.count = 1, .reusable = false}, SHIFT(1994),
  [4602] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4604] = {.count = 1, .reusable = false}, SHIFT(1995),
  [4606] = {.count = 1, .reusable = true}, SHIFT(1995),
  [4608] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [4610] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [4612] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4614] = {.count = 1, .reusable = true}, SHIFT(1997),
  [4616] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4618] = {.count = 1, .reusable = true}, SHIFT(1999),
  [4620] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4622] = {.count = 1, .reusable = true}, SHIFT(2002),
  [4624] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1353),
  [4627] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1354),
  [4630] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1354),
  [4633] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(1355),
  [4636] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4638] = {.count = 1, .reusable = true}, SHIFT(2005),
  [4640] = {.count = 1, .reusable = false}, SHIFT(2006),
  [4642] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4644] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4646] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4648] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4650] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4652] = {.count = 1, .reusable = false}, SHIFT(2013),
  [4654] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4656] = {.count = 1, .reusable = false}, SHIFT(2014),
  [4658] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4660] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4662] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4664] = {.count = 1, .reusable = false}, SHIFT(2017),
  [4666] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4668] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4670] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4672] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4674] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4676] = {.count = 1, .reusable = false}, SHIFT(2024),
  [4678] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4680] = {.count = 1, .reusable = false}, SHIFT(2025),
  [4682] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4684] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4686] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4688] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4690] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4692] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4694] = {.count = 1, .reusable = false}, SHIFT(2031),
  [4696] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4698] = {.count = 1, .reusable = false}, SHIFT(2032),
  [4700] = {.count = 1, .reusable = true}, SHIFT(2032),
  [4702] = {.count = 1, .reusable = true}, SHIFT(2033),
  [4704] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 7),
  [4706] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 7),
  [4708] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4710] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1427),
  [4713] = {.count = 1, .reusable = false}, SHIFT(2035),
  [4715] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4717] = {.count = 1, .reusable = false}, SHIFT(2037),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2038),
  [4721] = {.count = 1, .reusable = true}, SHIFT(2040),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4725] = {.count = 1, .reusable = false}, SHIFT(2043),
  [4727] = {.count = 1, .reusable = true}, SHIFT(2043),
  [4729] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4731] = {.count = 1, .reusable = false}, SHIFT(2045),
  [4733] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4735] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4737] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4739] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4741] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4743] = {.count = 1, .reusable = true}, SHIFT(2049),
  [4745] = {.count = 1, .reusable = false}, SHIFT(2050),
  [4747] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4749] = {.count = 1, .reusable = false}, SHIFT(2051),
  [4751] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4753] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4755] = {.count = 1, .reusable = false}, SHIFT(2053),
  [4757] = {.count = 1, .reusable = true}, SHIFT(2053),
  [4759] = {.count = 1, .reusable = true}, SHIFT(2055),
  [4761] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4763] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4765] = {.count = 1, .reusable = true}, SHIFT(2058),
  [4767] = {.count = 1, .reusable = false}, SHIFT(2059),
  [4769] = {.count = 1, .reusable = true}, SHIFT(2059),
  [4771] = {.count = 1, .reusable = false}, SHIFT(2060),
  [4773] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4775] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4777] = {.count = 1, .reusable = true}, SHIFT(2062),
  [4779] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4781] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4783] = {.count = 1, .reusable = false}, SHIFT(2065),
  [4785] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4787] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4789] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4791] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4793] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4795] = {.count = 1, .reusable = false}, SHIFT(2072),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4799] = {.count = 1, .reusable = false}, SHIFT(2073),
  [4801] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4803] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4805] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4807] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4),
  [4809] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [4811] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [4813] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 2),
  [4815] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2),
  [4817] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4819] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [4821] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [4823] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [4825] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4827] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4829] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4831] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4833] = {.count = 1, .reusable = false}, SHIFT(2086),
  [4835] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4837] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4839] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4841] = {.count = 1, .reusable = true}, SHIFT(2090),
  [4843] = {.count = 1, .reusable = true}, SHIFT(2091),
  [4845] = {.count = 1, .reusable = false}, SHIFT(2093),
  [4847] = {.count = 1, .reusable = false}, SHIFT(2087),
  [4849] = {.count = 1, .reusable = true}, SHIFT(2094),
  [4851] = {.count = 1, .reusable = true}, SHIFT(2095),
  [4853] = {.count = 1, .reusable = false}, SHIFT(2096),
  [4855] = {.count = 1, .reusable = true}, SHIFT(2097),
  [4857] = {.count = 1, .reusable = true}, SHIFT(2098),
  [4859] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4861] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4863] = {.count = 1, .reusable = true}, SHIFT(2101),
  [4865] = {.count = 1, .reusable = false}, SHIFT(2102),
  [4867] = {.count = 1, .reusable = false}, SHIFT(2097),
  [4869] = {.count = 1, .reusable = true}, SHIFT(2103),
  [4871] = {.count = 1, .reusable = false}, SHIFT(2105),
  [4873] = {.count = 1, .reusable = false}, SHIFT(2106),
  [4875] = {.count = 1, .reusable = true}, SHIFT(2108),
  [4877] = {.count = 1, .reusable = true}, SHIFT(2109),
  [4879] = {.count = 1, .reusable = false}, SHIFT(2110),
  [4881] = {.count = 1, .reusable = true}, SHIFT(2110),
  [4883] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4885] = {.count = 1, .reusable = true}, SHIFT(2112),
  [4887] = {.count = 1, .reusable = true}, SHIFT(2113),
  [4889] = {.count = 1, .reusable = false}, SHIFT(2114),
  [4891] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4893] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4895] = {.count = 1, .reusable = false}, SHIFT(2125),
  [4897] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [4899] = {.count = 1, .reusable = false}, SHIFT(2126),
  [4901] = {.count = 1, .reusable = true}, SHIFT(2127),
  [4903] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4905] = {.count = 1, .reusable = true}, SHIFT(2128),
  [4907] = {.count = 1, .reusable = true}, SHIFT(2125),
  [4909] = {.count = 1, .reusable = true}, SHIFT(2129),
  [4911] = {.count = 1, .reusable = false}, SHIFT(2130),
  [4913] = {.count = 1, .reusable = false}, SHIFT(2131),
  [4915] = {.count = 1, .reusable = true}, SHIFT(2131),
  [4917] = {.count = 1, .reusable = true}, SHIFT(2132),
  [4919] = {.count = 1, .reusable = true}, SHIFT(2133),
  [4921] = {.count = 1, .reusable = true}, SHIFT(2134),
  [4923] = {.count = 1, .reusable = false}, SHIFT(2134),
  [4925] = {.count = 1, .reusable = true}, SHIFT(2137),
  [4927] = {.count = 1, .reusable = true}, SHIFT(1857),
  [4929] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(1515),
  [4932] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3),
  [4934] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3),
  [4936] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3),
  [4938] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3),
  [4940] = {.count = 1, .reusable = true}, SHIFT(2143),
  [4942] = {.count = 1, .reusable = true}, SHIFT(2144),
  [4944] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [4946] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [4948] = {.count = 1, .reusable = true}, SHIFT(2148),
  [4950] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4952] = {.count = 1, .reusable = true}, SHIFT(2152),
  [4954] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7),
  [4956] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7),
  [4958] = {.count = 1, .reusable = true}, SHIFT(2153),
  [4960] = {.count = 1, .reusable = true}, SHIFT(2154),
  [4962] = {.count = 1, .reusable = true}, SHIFT(2155),
  [4964] = {.count = 1, .reusable = true}, SHIFT(2158),
  [4966] = {.count = 1, .reusable = true}, SHIFT(2159),
  [4968] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1575),
  [4971] = {.count = 1, .reusable = false}, SHIFT(2160),
  [4973] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4975] = {.count = 1, .reusable = false}, SHIFT(2162),
  [4977] = {.count = 1, .reusable = true}, SHIFT(2163),
  [4979] = {.count = 1, .reusable = true}, SHIFT(2165),
  [4981] = {.count = 1, .reusable = true}, SHIFT(2166),
  [4983] = {.count = 1, .reusable = false}, SHIFT(2168),
  [4985] = {.count = 1, .reusable = true}, SHIFT(2168),
  [4987] = {.count = 1, .reusable = true}, SHIFT(2167),
  [4989] = {.count = 1, .reusable = false}, SHIFT(2170),
  [4991] = {.count = 1, .reusable = true}, SHIFT(2170),
  [4993] = {.count = 1, .reusable = true}, SHIFT(2169),
  [4995] = {.count = 1, .reusable = true}, SHIFT(2171),
  [4997] = {.count = 1, .reusable = true}, SHIFT(2172),
  [4999] = {.count = 1, .reusable = true}, SHIFT(2173),
  [5001] = {.count = 1, .reusable = true}, SHIFT(2174),
  [5003] = {.count = 1, .reusable = false}, SHIFT(2175),
  [5005] = {.count = 1, .reusable = true}, SHIFT(2175),
  [5007] = {.count = 1, .reusable = false}, SHIFT(2176),
  [5009] = {.count = 1, .reusable = true}, SHIFT(2176),
  [5011] = {.count = 1, .reusable = true}, SHIFT(2177),
  [5013] = {.count = 1, .reusable = false}, SHIFT(2178),
  [5015] = {.count = 1, .reusable = true}, SHIFT(2178),
  [5017] = {.count = 1, .reusable = true}, SHIFT(2179),
  [5019] = {.count = 1, .reusable = true}, SHIFT(2180),
  [5021] = {.count = 1, .reusable = true}, SHIFT(2181),
  [5023] = {.count = 1, .reusable = true}, SHIFT(2182),
  [5025] = {.count = 1, .reusable = true}, SHIFT(2183),
  [5027] = {.count = 1, .reusable = true}, SHIFT(2184),
  [5029] = {.count = 1, .reusable = true}, SHIFT(2185),
  [5031] = {.count = 1, .reusable = true}, SHIFT(2186),
  [5033] = {.count = 1, .reusable = true}, SHIFT(2187),
  [5035] = {.count = 1, .reusable = true}, SHIFT(2188),
  [5037] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [5039] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [5041] = {.count = 1, .reusable = true}, SHIFT(2189),
  [5043] = {.count = 1, .reusable = true}, SHIFT(2190),
  [5045] = {.count = 1, .reusable = false}, SHIFT(2191),
  [5047] = {.count = 1, .reusable = true}, SHIFT(2192),
  [5049] = {.count = 1, .reusable = true}, SHIFT(2194),
  [5051] = {.count = 1, .reusable = true}, SHIFT(2195),
  [5053] = {.count = 1, .reusable = true}, SHIFT(2196),
  [5055] = {.count = 1, .reusable = true}, SHIFT(2197),
  [5057] = {.count = 1, .reusable = false}, SHIFT(2198),
  [5059] = {.count = 1, .reusable = true}, SHIFT(2198),
  [5061] = {.count = 1, .reusable = false}, SHIFT(2199),
  [5063] = {.count = 1, .reusable = true}, SHIFT(2199),
  [5065] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5067] = {.count = 1, .reusable = true}, SHIFT(2201),
  [5069] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [5071] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [5073] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7),
  [5075] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7),
  [5077] = {.count = 1, .reusable = true}, SHIFT(2202),
  [5079] = {.count = 1, .reusable = true}, SHIFT(2203),
  [5081] = {.count = 1, .reusable = true}, SHIFT(2204),
  [5083] = {.count = 1, .reusable = false}, SHIFT(2205),
  [5085] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5087] = {.count = 1, .reusable = false}, SHIFT(2206),
  [5089] = {.count = 1, .reusable = true}, SHIFT(2206),
  [5091] = {.count = 1, .reusable = true}, SHIFT(2207),
  [5093] = {.count = 1, .reusable = true}, SHIFT(2210),
  [5095] = {.count = 1, .reusable = true}, SHIFT(2211),
  [5097] = {.count = 1, .reusable = true}, SHIFT(2212),
  [5099] = {.count = 1, .reusable = false}, SHIFT(2213),
  [5101] = {.count = 1, .reusable = true}, SHIFT(2213),
  [5103] = {.count = 1, .reusable = false}, SHIFT(2214),
  [5105] = {.count = 1, .reusable = true}, SHIFT(2214),
  [5107] = {.count = 1, .reusable = true}, SHIFT(2215),
  [5109] = {.count = 1, .reusable = true}, SHIFT(2216),
  [5111] = {.count = 1, .reusable = true}, SHIFT(2217),
  [5113] = {.count = 1, .reusable = true}, SHIFT(2218),
  [5115] = {.count = 1, .reusable = false}, SHIFT(2219),
  [5117] = {.count = 1, .reusable = true}, SHIFT(2219),
  [5119] = {.count = 1, .reusable = false}, SHIFT(2220),
  [5121] = {.count = 1, .reusable = true}, SHIFT(2220),
  [5123] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5125] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5127] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5129] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5131] = {.count = 1, .reusable = true}, SHIFT(2225),
  [5133] = {.count = 1, .reusable = false}, SHIFT(2226),
  [5135] = {.count = 1, .reusable = true}, SHIFT(2227),
  [5137] = {.count = 1, .reusable = true}, SHIFT(2229),
  [5139] = {.count = 1, .reusable = true}, SHIFT(2230),
  [5141] = {.count = 1, .reusable = true}, SHIFT(2231),
  [5143] = {.count = 1, .reusable = true}, SHIFT(2232),
  [5145] = {.count = 1, .reusable = false}, SHIFT(2233),
  [5147] = {.count = 1, .reusable = true}, SHIFT(2233),
  [5149] = {.count = 1, .reusable = false}, SHIFT(2234),
  [5151] = {.count = 1, .reusable = true}, SHIFT(2234),
  [5153] = {.count = 1, .reusable = true}, SHIFT(2235),
  [5155] = {.count = 1, .reusable = true}, SHIFT(2236),
  [5157] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 8),
  [5159] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 8),
  [5161] = {.count = 1, .reusable = true}, SHIFT(2238),
  [5163] = {.count = 1, .reusable = true}, SHIFT(2239),
  [5165] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5167] = {.count = 1, .reusable = true}, SHIFT(2241),
  [5169] = {.count = 1, .reusable = true}, SHIFT(2242),
  [5171] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5173] = {.count = 1, .reusable = false}, SHIFT(2244),
  [5175] = {.count = 1, .reusable = true}, SHIFT(2244),
  [5177] = {.count = 1, .reusable = false}, SHIFT(2245),
  [5179] = {.count = 1, .reusable = true}, SHIFT(2245),
  [5181] = {.count = 1, .reusable = true}, SHIFT(2246),
  [5183] = {.count = 1, .reusable = true}, SHIFT(2247),
  [5185] = {.count = 1, .reusable = true}, SHIFT(2248),
  [5187] = {.count = 1, .reusable = true}, SHIFT(2249),
  [5189] = {.count = 1, .reusable = true}, SHIFT(2250),
  [5191] = {.count = 1, .reusable = false}, SHIFT(2251),
  [5193] = {.count = 1, .reusable = true}, SHIFT(2252),
  [5195] = {.count = 1, .reusable = true}, SHIFT(2253),
  [5197] = {.count = 1, .reusable = true}, SHIFT(2254),
  [5199] = {.count = 1, .reusable = true}, SHIFT(2255),
  [5201] = {.count = 1, .reusable = true}, SHIFT(2256),
  [5203] = {.count = 1, .reusable = true}, SHIFT(2258),
  [5205] = {.count = 1, .reusable = true}, SHIFT(2260),
  [5207] = {.count = 1, .reusable = true}, SHIFT(2261),
  [5209] = {.count = 1, .reusable = true}, SHIFT(2262),
  [5211] = {.count = 1, .reusable = false}, SHIFT(2264),
  [5213] = {.count = 1, .reusable = false}, SHIFT(2265),
  [5215] = {.count = 1, .reusable = true}, SHIFT(2267),
  [5217] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5219] = {.count = 1, .reusable = false}, SHIFT(2269),
  [5221] = {.count = 1, .reusable = true}, SHIFT(2269),
  [5223] = {.count = 1, .reusable = true}, SHIFT(2270),
  [5225] = {.count = 1, .reusable = true}, SHIFT(2271),
  [5227] = {.count = 1, .reusable = true}, SHIFT(2272),
  [5229] = {.count = 1, .reusable = false}, SHIFT(2273),
  [5231] = {.count = 1, .reusable = true}, SHIFT(2273),
  [5233] = {.count = 1, .reusable = false}, SHIFT(2283),
  [5235] = {.count = 1, .reusable = true}, SHIFT(2284),
  [5237] = {.count = 1, .reusable = false}, SHIFT(2286),
  [5239] = {.count = 1, .reusable = false}, SHIFT(2287),
  [5241] = {.count = 1, .reusable = true}, SHIFT(2289),
  [5243] = {.count = 1, .reusable = true}, SHIFT(2290),
  [5245] = {.count = 1, .reusable = false}, SHIFT(2291),
  [5247] = {.count = 1, .reusable = true}, SHIFT(2291),
  [5249] = {.count = 1, .reusable = true}, SHIFT(2292),
  [5251] = {.count = 1, .reusable = true}, SHIFT(2293),
  [5253] = {.count = 1, .reusable = true}, SHIFT(2294),
  [5255] = {.count = 1, .reusable = false}, SHIFT(2295),
  [5257] = {.count = 1, .reusable = true}, SHIFT(2295),
  [5259] = {.count = 1, .reusable = false}, SHIFT(2305),
  [5261] = {.count = 1, .reusable = true}, SHIFT(2306),
  [5263] = {.count = 1, .reusable = false}, SHIFT(2308),
  [5265] = {.count = 1, .reusable = false}, SHIFT(2309),
  [5267] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5269] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5271] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5273] = {.count = 1, .reusable = false}, SHIFT(2313),
  [5275] = {.count = 1, .reusable = true}, SHIFT(2313),
  [5277] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5279] = {.count = 1, .reusable = false}, SHIFT(2316),
  [5281] = {.count = 1, .reusable = true}, SHIFT(2316),
  [5283] = {.count = 1, .reusable = true}, SHIFT(2315),
  [5285] = {.count = 1, .reusable = true}, SHIFT(2317),
  [5287] = {.count = 1, .reusable = false}, SHIFT(2319),
  [5289] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5291] = {.count = 1, .reusable = true}, SHIFT(2318),
  [5293] = {.count = 1, .reusable = false}, SHIFT(2320),
  [5295] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5297] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5299] = {.count = 1, .reusable = false}, SHIFT(2324),
  [5301] = {.count = 1, .reusable = true}, SHIFT(2324),
  [5303] = {.count = 1, .reusable = false}, SHIFT(2327),
  [5305] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5307] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5309] = {.count = 1, .reusable = true}, SHIFT(2331),
  [5311] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [5313] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5315] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [5317] = {.count = 1, .reusable = false}, SHIFT(2335),
  [5319] = {.count = 1, .reusable = true}, SHIFT(2335),
  [5321] = {.count = 1, .reusable = false}, SHIFT(2336),
  [5323] = {.count = 1, .reusable = false}, SHIFT(1858),
  [5325] = {.count = 1, .reusable = false}, SHIFT(2337),
  [5327] = {.count = 1, .reusable = false}, SHIFT(1861),
  [5329] = {.count = 1, .reusable = false}, SHIFT(1862),
  [5331] = {.count = 1, .reusable = false}, SHIFT(1863),
  [5333] = {.count = 1, .reusable = false}, SHIFT(1864),
  [5335] = {.count = 1, .reusable = false}, SHIFT(2338),
  [5337] = {.count = 1, .reusable = true}, SHIFT(2339),
  [5339] = {.count = 1, .reusable = true}, SHIFT(2340),
  [5341] = {.count = 1, .reusable = false}, SHIFT(2341),
  [5343] = {.count = 1, .reusable = true}, SHIFT(2342),
  [5345] = {.count = 1, .reusable = true}, SHIFT(2343),
  [5347] = {.count = 1, .reusable = true}, SHIFT(2344),
  [5349] = {.count = 1, .reusable = true}, SHIFT(2345),
  [5351] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5353] = {.count = 1, .reusable = true}, SHIFT(2347),
  [5355] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5357] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [5359] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5361] = {.count = 1, .reusable = true}, SHIFT(2356),
  [5363] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4),
  [5365] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4),
  [5367] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4),
  [5369] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4),
  [5371] = {.count = 1, .reusable = true}, SHIFT(2359),
  [5373] = {.count = 1, .reusable = true}, SHIFT(2360),
  [5375] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5377] = {.count = 1, .reusable = true}, SHIFT(2367),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2368),
  [5381] = {.count = 1, .reusable = true}, SHIFT(2372),
  [5383] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [5385] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [5387] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8),
  [5389] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8),
  [5391] = {.count = 1, .reusable = true}, SHIFT(2373),
  [5393] = {.count = 1, .reusable = true}, SHIFT(2374),
  [5395] = {.count = 1, .reusable = false}, SHIFT(2375),
  [5397] = {.count = 1, .reusable = true}, SHIFT(2376),
  [5399] = {.count = 1, .reusable = true}, SHIFT(2378),
  [5401] = {.count = 1, .reusable = true}, SHIFT(2379),
  [5403] = {.count = 1, .reusable = true}, SHIFT(2380),
  [5405] = {.count = 1, .reusable = true}, SHIFT(2381),
  [5407] = {.count = 1, .reusable = false}, SHIFT(2382),
  [5409] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5411] = {.count = 1, .reusable = false}, SHIFT(2383),
  [5413] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5415] = {.count = 1, .reusable = true}, SHIFT(2384),
  [5417] = {.count = 1, .reusable = true}, SHIFT(2385),
  [5419] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5421] = {.count = 1, .reusable = true}, SHIFT(2387),
  [5423] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5425] = {.count = 1, .reusable = false}, SHIFT(2389),
  [5427] = {.count = 1, .reusable = true}, SHIFT(2389),
  [5429] = {.count = 1, .reusable = false}, SHIFT(2390),
  [5431] = {.count = 1, .reusable = true}, SHIFT(2390),
  [5433] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5435] = {.count = 1, .reusable = true}, SHIFT(2392),
  [5437] = {.count = 1, .reusable = true}, SHIFT(2393),
  [5439] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5441] = {.count = 1, .reusable = true}, SHIFT(2395),
  [5443] = {.count = 1, .reusable = true}, SHIFT(2396),
  [5445] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5447] = {.count = 1, .reusable = true}, SHIFT(2398),
  [5449] = {.count = 1, .reusable = true}, SHIFT(2399),
  [5451] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5453] = {.count = 1, .reusable = false}, SHIFT(2401),
  [5455] = {.count = 1, .reusable = true}, SHIFT(2401),
  [5457] = {.count = 1, .reusable = false}, SHIFT(2402),
  [5459] = {.count = 1, .reusable = true}, SHIFT(2402),
  [5461] = {.count = 1, .reusable = true}, SHIFT(2403),
  [5463] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 9),
  [5465] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 9),
  [5467] = {.count = 1, .reusable = true}, SHIFT(2405),
  [5469] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5471] = {.count = 1, .reusable = true}, SHIFT(2407),
  [5473] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5475] = {.count = 1, .reusable = false}, SHIFT(2411),
  [5477] = {.count = 1, .reusable = false}, SHIFT(2412),
  [5479] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5481] = {.count = 1, .reusable = true}, SHIFT(2415),
  [5483] = {.count = 1, .reusable = false}, SHIFT(2416),
  [5485] = {.count = 1, .reusable = true}, SHIFT(2416),
  [5487] = {.count = 1, .reusable = true}, SHIFT(2417),
  [5489] = {.count = 1, .reusable = true}, SHIFT(2418),
  [5491] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5493] = {.count = 1, .reusable = false}, SHIFT(2420),
  [5495] = {.count = 1, .reusable = true}, SHIFT(2420),
  [5497] = {.count = 1, .reusable = true}, SHIFT(2431),
  [5499] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5501] = {.count = 1, .reusable = false}, SHIFT(2433),
  [5503] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5505] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5507] = {.count = 1, .reusable = false}, SHIFT(2435),
  [5509] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5511] = {.count = 1, .reusable = true}, SHIFT(2436),
  [5513] = {.count = 1, .reusable = true}, SHIFT(2438),
  [5515] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5517] = {.count = 1, .reusable = true}, SHIFT(2440),
  [5519] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5521] = {.count = 1, .reusable = true}, SHIFT(2442),
  [5523] = {.count = 1, .reusable = false}, SHIFT(2444),
  [5525] = {.count = 1, .reusable = false}, SHIFT(2445),
  [5527] = {.count = 1, .reusable = true}, SHIFT(2446),
  [5529] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5531] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5533] = {.count = 1, .reusable = false}, SHIFT(2449),
  [5535] = {.count = 1, .reusable = true}, SHIFT(2449),
  [5537] = {.count = 1, .reusable = true}, SHIFT(2450),
  [5539] = {.count = 1, .reusable = false}, SHIFT(2452),
  [5541] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5543] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5545] = {.count = 1, .reusable = true}, SHIFT(2453),
  [5547] = {.count = 1, .reusable = false}, SHIFT(2455),
  [5549] = {.count = 1, .reusable = true}, SHIFT(2455),
  [5551] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5553] = {.count = 1, .reusable = false}, SHIFT(2456),
  [5555] = {.count = 1, .reusable = true}, SHIFT(2457),
  [5557] = {.count = 1, .reusable = true}, SHIFT(2456),
  [5559] = {.count = 1, .reusable = false}, SHIFT(2460),
  [5561] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5563] = {.count = 1, .reusable = false}, SHIFT(2463),
  [5565] = {.count = 1, .reusable = true}, SHIFT(2464),
  [5567] = {.count = 1, .reusable = true}, SHIFT(2463),
  [5569] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2083),
  [5572] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2084),
  [5575] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2085),
  [5578] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2086),
  [5581] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2087),
  [5584] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2088),
  [5587] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2089),
  [5590] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2090),
  [5593] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2091),
  [5596] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2283),
  [5599] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2087),
  [5602] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5604] = {.count = 1, .reusable = false}, SHIFT(2469),
  [5606] = {.count = 1, .reusable = false}, SHIFT(2470),
  [5608] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5610] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5612] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5614] = {.count = 1, .reusable = false}, SHIFT(2474),
  [5616] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5618] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5620] = {.count = 1, .reusable = false}, SHIFT(2477),
  [5622] = {.count = 1, .reusable = true}, SHIFT(2477),
  [5624] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5626] = {.count = 1, .reusable = true}, SHIFT(2478),
  [5628] = {.count = 1, .reusable = false}, SHIFT(2480),
  [5630] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5632] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5634] = {.count = 1, .reusable = false}, SHIFT(2481),
  [5636] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5638] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5640] = {.count = 1, .reusable = false}, SHIFT(2485),
  [5642] = {.count = 1, .reusable = true}, SHIFT(2485),
  [5644] = {.count = 1, .reusable = false}, SHIFT(2488),
  [5646] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5648] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5650] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2094),
  [5653] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2095),
  [5656] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2096),
  [5659] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2097),
  [5662] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2098),
  [5665] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2099),
  [5668] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2100),
  [5671] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2101),
  [5674] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2305),
  [5677] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2097),
  [5680] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2103),
  [5683] = {.count = 1, .reusable = false}, SHIFT(2492),
  [5685] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5687] = {.count = 1, .reusable = false}, SHIFT(2494),
  [5689] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5691] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5693] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5695] = {.count = 1, .reusable = false}, SHIFT(2500),
  [5697] = {.count = 1, .reusable = true}, SHIFT(2500),
  [5699] = {.count = 1, .reusable = true}, SHIFT(2499),
  [5701] = {.count = 1, .reusable = false}, SHIFT(2502),
  [5703] = {.count = 1, .reusable = true}, SHIFT(2502),
  [5705] = {.count = 1, .reusable = true}, SHIFT(2501),
  [5707] = {.count = 1, .reusable = true}, SHIFT(2503),
  [5709] = {.count = 1, .reusable = true}, SHIFT(2504),
  [5711] = {.count = 1, .reusable = true}, SHIFT(2505),
  [5713] = {.count = 1, .reusable = true}, SHIFT(2506),
  [5715] = {.count = 1, .reusable = false}, SHIFT(2507),
  [5717] = {.count = 1, .reusable = true}, SHIFT(2507),
  [5719] = {.count = 1, .reusable = false}, SHIFT(2508),
  [5721] = {.count = 1, .reusable = true}, SHIFT(2508),
  [5723] = {.count = 1, .reusable = true}, SHIFT(2509),
  [5725] = {.count = 1, .reusable = false}, SHIFT(2510),
  [5727] = {.count = 1, .reusable = true}, SHIFT(2510),
  [5729] = {.count = 1, .reusable = true}, SHIFT(2512),
  [5731] = {.count = 1, .reusable = true}, SHIFT(2513),
  [5733] = {.count = 1, .reusable = true}, SHIFT(2514),
  [5735] = {.count = 1, .reusable = false}, SHIFT(2516),
  [5737] = {.count = 1, .reusable = false}, SHIFT(2517),
  [5739] = {.count = 1, .reusable = true}, SHIFT(2519),
  [5741] = {.count = 1, .reusable = true}, SHIFT(2520),
  [5743] = {.count = 1, .reusable = false}, SHIFT(2521),
  [5745] = {.count = 1, .reusable = true}, SHIFT(2521),
  [5747] = {.count = 1, .reusable = true}, SHIFT(2522),
  [5749] = {.count = 1, .reusable = true}, SHIFT(2523),
  [5751] = {.count = 1, .reusable = true}, SHIFT(2524),
  [5753] = {.count = 1, .reusable = false}, SHIFT(2525),
  [5755] = {.count = 1, .reusable = true}, SHIFT(2525),
  [5757] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2129),
  [5760] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2131),
  [5763] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2131),
  [5766] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2132),
  [5769] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2130),
  [5772] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2133),
  [5775] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1858),
  [5778] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1859),
  [5781] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2134),
  [5784] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1861),
  [5787] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1862),
  [5790] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1863),
  [5793] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1864),
  [5796] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2134),
  [5799] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [5801] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [5803] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [5805] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [5807] = {.count = 1, .reusable = true}, SHIFT(2536),
  [5809] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5),
  [5811] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5),
  [5813] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5),
  [5815] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 5),
  [5817] = {.count = 1, .reusable = true}, SHIFT(2537),
  [5819] = {.count = 1, .reusable = true}, SHIFT(2538),
  [5821] = {.count = 1, .reusable = true}, SHIFT(2539),
  [5823] = {.count = 1, .reusable = true}, SHIFT(2544),
  [5825] = {.count = 1, .reusable = true}, SHIFT(2545),
  [5827] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5829] = {.count = 1, .reusable = true}, SHIFT(2550),
  [5831] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5833] = {.count = 1, .reusable = false}, SHIFT(2552),
  [5835] = {.count = 1, .reusable = true}, SHIFT(2552),
  [5837] = {.count = 1, .reusable = false}, SHIFT(2553),
  [5839] = {.count = 1, .reusable = true}, SHIFT(2553),
  [5841] = {.count = 1, .reusable = true}, SHIFT(2554),
  [5843] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5845] = {.count = 1, .reusable = true}, SHIFT(2556),
  [5847] = {.count = 1, .reusable = true}, SHIFT(2557),
  [5849] = {.count = 1, .reusable = true}, SHIFT(2558),
  [5851] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 10),
  [5853] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 10),
  [5855] = {.count = 1, .reusable = true}, SHIFT(2559),
  [5857] = {.count = 1, .reusable = true}, SHIFT(2560),
  [5859] = {.count = 1, .reusable = false}, SHIFT(2562),
  [5861] = {.count = 1, .reusable = false}, SHIFT(2563),
  [5863] = {.count = 1, .reusable = true}, SHIFT(2564),
  [5865] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5867] = {.count = 1, .reusable = true}, SHIFT(2566),
  [5869] = {.count = 1, .reusable = false}, SHIFT(2567),
  [5871] = {.count = 1, .reusable = true}, SHIFT(2567),
  [5873] = {.count = 1, .reusable = true}, SHIFT(2568),
  [5875] = {.count = 1, .reusable = false}, SHIFT(2570),
  [5877] = {.count = 1, .reusable = true}, SHIFT(2570),
  [5879] = {.count = 1, .reusable = true}, SHIFT(2569),
  [5881] = {.count = 1, .reusable = true}, SHIFT(2571),
  [5883] = {.count = 1, .reusable = false}, SHIFT(2573),
  [5885] = {.count = 1, .reusable = true}, SHIFT(2573),
  [5887] = {.count = 1, .reusable = true}, SHIFT(2572),
  [5889] = {.count = 1, .reusable = false}, SHIFT(2574),
  [5891] = {.count = 1, .reusable = true}, SHIFT(2575),
  [5893] = {.count = 1, .reusable = true}, SHIFT(2574),
  [5895] = {.count = 1, .reusable = false}, SHIFT(2578),
  [5897] = {.count = 1, .reusable = true}, SHIFT(2578),
  [5899] = {.count = 1, .reusable = false}, SHIFT(2581),
  [5901] = {.count = 1, .reusable = true}, SHIFT(2582),
  [5903] = {.count = 1, .reusable = true}, SHIFT(2581),
  [5905] = {.count = 1, .reusable = false}, SHIFT(2586),
  [5907] = {.count = 1, .reusable = true}, SHIFT(2586),
  [5909] = {.count = 1, .reusable = true}, SHIFT(2587),
  [5911] = {.count = 1, .reusable = true}, SHIFT(2588),
  [5913] = {.count = 1, .reusable = false}, SHIFT(2589),
  [5915] = {.count = 1, .reusable = true}, SHIFT(2589),
  [5917] = {.count = 1, .reusable = true}, SHIFT(2590),
  [5919] = {.count = 1, .reusable = true}, SHIFT(2591),
  [5921] = {.count = 1, .reusable = true}, SHIFT(2592),
  [5923] = {.count = 1, .reusable = true}, SHIFT(2593),
  [5925] = {.count = 1, .reusable = true}, SHIFT(2595),
  [5927] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2262),
  [5930] = {.count = 1, .reusable = false}, SHIFT(2597),
  [5932] = {.count = 1, .reusable = true}, SHIFT(2598),
  [5934] = {.count = 1, .reusable = false}, SHIFT(2599),
  [5936] = {.count = 1, .reusable = true}, SHIFT(2600),
  [5938] = {.count = 1, .reusable = true}, SHIFT(2602),
  [5940] = {.count = 1, .reusable = true}, SHIFT(2603),
  [5942] = {.count = 1, .reusable = false}, SHIFT(2605),
  [5944] = {.count = 1, .reusable = true}, SHIFT(2605),
  [5946] = {.count = 1, .reusable = true}, SHIFT(2604),
  [5948] = {.count = 1, .reusable = false}, SHIFT(2607),
  [5950] = {.count = 1, .reusable = true}, SHIFT(2607),
  [5952] = {.count = 1, .reusable = true}, SHIFT(2606),
  [5954] = {.count = 1, .reusable = true}, SHIFT(2608),
  [5956] = {.count = 1, .reusable = true}, SHIFT(2609),
  [5958] = {.count = 1, .reusable = true}, SHIFT(2610),
  [5960] = {.count = 1, .reusable = true}, SHIFT(2611),
  [5962] = {.count = 1, .reusable = false}, SHIFT(2612),
  [5964] = {.count = 1, .reusable = true}, SHIFT(2612),
  [5966] = {.count = 1, .reusable = false}, SHIFT(2613),
  [5968] = {.count = 1, .reusable = true}, SHIFT(2613),
  [5970] = {.count = 1, .reusable = true}, SHIFT(2614),
  [5972] = {.count = 1, .reusable = false}, SHIFT(2615),
  [5974] = {.count = 1, .reusable = true}, SHIFT(2615),
  [5976] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2284),
  [5979] = {.count = 1, .reusable = false}, SHIFT(2616),
  [5981] = {.count = 1, .reusable = true}, SHIFT(2617),
  [5983] = {.count = 1, .reusable = false}, SHIFT(2618),
  [5985] = {.count = 1, .reusable = true}, SHIFT(2619),
  [5987] = {.count = 1, .reusable = true}, SHIFT(2621),
  [5989] = {.count = 1, .reusable = true}, SHIFT(2622),
  [5991] = {.count = 1, .reusable = false}, SHIFT(2624),
  [5993] = {.count = 1, .reusable = true}, SHIFT(2624),
  [5995] = {.count = 1, .reusable = true}, SHIFT(2623),
  [5997] = {.count = 1, .reusable = false}, SHIFT(2626),
  [5999] = {.count = 1, .reusable = true}, SHIFT(2626),
  [6001] = {.count = 1, .reusable = true}, SHIFT(2625),
  [6003] = {.count = 1, .reusable = true}, SHIFT(2627),
  [6005] = {.count = 1, .reusable = true}, SHIFT(2628),
  [6007] = {.count = 1, .reusable = true}, SHIFT(2629),
  [6009] = {.count = 1, .reusable = true}, SHIFT(2630),
  [6011] = {.count = 1, .reusable = false}, SHIFT(2631),
  [6013] = {.count = 1, .reusable = true}, SHIFT(2631),
  [6015] = {.count = 1, .reusable = false}, SHIFT(2632),
  [6017] = {.count = 1, .reusable = true}, SHIFT(2632),
  [6019] = {.count = 1, .reusable = true}, SHIFT(2633),
  [6021] = {.count = 1, .reusable = false}, SHIFT(2634),
  [6023] = {.count = 1, .reusable = true}, SHIFT(2634),
  [6025] = {.count = 1, .reusable = true}, SHIFT(2635),
  [6027] = {.count = 1, .reusable = true}, SHIFT(2636),
  [6029] = {.count = 1, .reusable = false}, SHIFT(2637),
  [6031] = {.count = 1, .reusable = true}, SHIFT(2638),
  [6033] = {.count = 1, .reusable = true}, SHIFT(2640),
  [6035] = {.count = 1, .reusable = true}, SHIFT(2641),
  [6037] = {.count = 1, .reusable = true}, SHIFT(2642),
  [6039] = {.count = 1, .reusable = true}, SHIFT(2643),
  [6041] = {.count = 1, .reusable = false}, SHIFT(2644),
  [6043] = {.count = 1, .reusable = true}, SHIFT(2644),
  [6045] = {.count = 1, .reusable = false}, SHIFT(2645),
  [6047] = {.count = 1, .reusable = true}, SHIFT(2645),
  [6049] = {.count = 1, .reusable = true}, SHIFT(2646),
  [6051] = {.count = 1, .reusable = true}, SHIFT(2647),
  [6053] = {.count = 1, .reusable = true}, SHIFT(2648),
  [6055] = {.count = 1, .reusable = false}, SHIFT(2650),
  [6057] = {.count = 1, .reusable = false}, SHIFT(2651),
  [6059] = {.count = 1, .reusable = true}, SHIFT(2652),
  [6061] = {.count = 1, .reusable = true}, SHIFT(2653),
  [6063] = {.count = 1, .reusable = true}, SHIFT(2654),
  [6065] = {.count = 1, .reusable = false}, SHIFT(2655),
  [6067] = {.count = 1, .reusable = true}, SHIFT(2655),
  [6069] = {.count = 1, .reusable = true}, SHIFT(2656),
  [6071] = {.count = 1, .reusable = false}, SHIFT(2658),
  [6073] = {.count = 1, .reusable = true}, SHIFT(2658),
  [6075] = {.count = 1, .reusable = true}, SHIFT(2657),
  [6077] = {.count = 1, .reusable = true}, SHIFT(2659),
  [6079] = {.count = 1, .reusable = false}, SHIFT(2661),
  [6081] = {.count = 1, .reusable = true}, SHIFT(2661),
  [6083] = {.count = 1, .reusable = true}, SHIFT(2660),
  [6085] = {.count = 1, .reusable = false}, SHIFT(2662),
  [6087] = {.count = 1, .reusable = true}, SHIFT(2663),
  [6089] = {.count = 1, .reusable = true}, SHIFT(2662),
  [6091] = {.count = 1, .reusable = false}, SHIFT(2666),
  [6093] = {.count = 1, .reusable = true}, SHIFT(2666),
  [6095] = {.count = 1, .reusable = false}, SHIFT(2669),
  [6097] = {.count = 1, .reusable = true}, SHIFT(2670),
  [6099] = {.count = 1, .reusable = true}, SHIFT(2669),
  [6101] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 6, .alias_sequence_id = 1),
  [6103] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 6, .alias_sequence_id = 1),
  [6105] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 6, .alias_sequence_id = 1),
  [6107] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 6),
  [6109] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 6),
  [6111] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 6),
  [6113] = {.count = 1, .reusable = true}, SHIFT(2673),
  [6115] = {.count = 1, .reusable = true}, SHIFT(2674),
  [6117] = {.count = 1, .reusable = true}, SHIFT(2677),
  [6119] = {.count = 1, .reusable = true}, SHIFT(2678),
  [6121] = {.count = 1, .reusable = true}, SHIFT(2681),
  [6123] = {.count = 1, .reusable = true}, SHIFT(2682),
  [6125] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2409),
  [6128] = {.count = 1, .reusable = false}, SHIFT(2683),
  [6130] = {.count = 1, .reusable = true}, SHIFT(2684),
  [6132] = {.count = 1, .reusable = false}, SHIFT(2685),
  [6134] = {.count = 1, .reusable = true}, SHIFT(2686),
  [6136] = {.count = 1, .reusable = true}, SHIFT(2688),
  [6138] = {.count = 1, .reusable = true}, SHIFT(2689),
  [6140] = {.count = 1, .reusable = false}, SHIFT(2691),
  [6142] = {.count = 1, .reusable = true}, SHIFT(2691),
  [6144] = {.count = 1, .reusable = true}, SHIFT(2690),
  [6146] = {.count = 1, .reusable = false}, SHIFT(2693),
  [6148] = {.count = 1, .reusable = true}, SHIFT(2693),
  [6150] = {.count = 1, .reusable = true}, SHIFT(2692),
  [6152] = {.count = 1, .reusable = true}, SHIFT(2694),
  [6154] = {.count = 1, .reusable = true}, SHIFT(2695),
  [6156] = {.count = 1, .reusable = true}, SHIFT(2696),
  [6158] = {.count = 1, .reusable = true}, SHIFT(2697),
  [6160] = {.count = 1, .reusable = false}, SHIFT(2698),
  [6162] = {.count = 1, .reusable = true}, SHIFT(2698),
  [6164] = {.count = 1, .reusable = false}, SHIFT(2699),
  [6166] = {.count = 1, .reusable = true}, SHIFT(2699),
  [6168] = {.count = 1, .reusable = true}, SHIFT(2700),
  [6170] = {.count = 1, .reusable = false}, SHIFT(2701),
  [6172] = {.count = 1, .reusable = true}, SHIFT(2701),
  [6174] = {.count = 1, .reusable = true}, SHIFT(2702),
  [6176] = {.count = 1, .reusable = true}, SHIFT(2703),
  [6178] = {.count = 1, .reusable = true}, SHIFT(2705),
  [6180] = {.count = 1, .reusable = true}, SHIFT(2706),
  [6182] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2434),
  [6185] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2435),
  [6188] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2435),
  [6191] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(2436),
  [6194] = {.count = 1, .reusable = true}, SHIFT(2708),
  [6196] = {.count = 1, .reusable = true}, SHIFT(2709),
  [6198] = {.count = 1, .reusable = true}, SHIFT(2710),
  [6200] = {.count = 1, .reusable = false}, SHIFT(2711),
  [6202] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6204] = {.count = 1, .reusable = true}, SHIFT(2714),
  [6206] = {.count = 1, .reusable = true}, SHIFT(2715),
  [6208] = {.count = 1, .reusable = true}, SHIFT(2716),
  [6210] = {.count = 1, .reusable = true}, SHIFT(2717),
  [6212] = {.count = 1, .reusable = false}, SHIFT(2718),
  [6214] = {.count = 1, .reusable = true}, SHIFT(2718),
  [6216] = {.count = 1, .reusable = false}, SHIFT(2719),
  [6218] = {.count = 1, .reusable = true}, SHIFT(2719),
  [6220] = {.count = 1, .reusable = true}, SHIFT(2720),
  [6222] = {.count = 1, .reusable = true}, SHIFT(2721),
  [6224] = {.count = 1, .reusable = true}, SHIFT(2722),
  [6226] = {.count = 1, .reusable = true}, SHIFT(2723),
  [6228] = {.count = 1, .reusable = false}, SHIFT(2724),
  [6230] = {.count = 1, .reusable = true}, SHIFT(2725),
  [6232] = {.count = 1, .reusable = true}, SHIFT(2727),
  [6234] = {.count = 1, .reusable = true}, SHIFT(2728),
  [6236] = {.count = 1, .reusable = true}, SHIFT(2729),
  [6238] = {.count = 1, .reusable = true}, SHIFT(2730),
  [6240] = {.count = 1, .reusable = false}, SHIFT(2731),
  [6242] = {.count = 1, .reusable = true}, SHIFT(2731),
  [6244] = {.count = 1, .reusable = false}, SHIFT(2732),
  [6246] = {.count = 1, .reusable = true}, SHIFT(2732),
  [6248] = {.count = 1, .reusable = true}, SHIFT(2733),
  [6250] = {.count = 1, .reusable = true}, SHIFT(2734),
  [6252] = {.count = 1, .reusable = true}, SHIFT(2735),
  [6254] = {.count = 1, .reusable = true}, SHIFT(2736),
  [6256] = {.count = 1, .reusable = true}, SHIFT(2737),
  [6258] = {.count = 1, .reusable = false}, SHIFT(2738),
  [6260] = {.count = 1, .reusable = true}, SHIFT(2738),
  [6262] = {.count = 1, .reusable = false}, SHIFT(2739),
  [6264] = {.count = 1, .reusable = true}, SHIFT(2739),
  [6266] = {.count = 1, .reusable = true}, SHIFT(2740),
  [6268] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2514),
  [6271] = {.count = 1, .reusable = false}, SHIFT(2741),
  [6273] = {.count = 1, .reusable = true}, SHIFT(2742),
  [6275] = {.count = 1, .reusable = false}, SHIFT(2743),
  [6277] = {.count = 1, .reusable = true}, SHIFT(2744),
  [6279] = {.count = 1, .reusable = true}, SHIFT(2746),
  [6281] = {.count = 1, .reusable = true}, SHIFT(2747),
  [6283] = {.count = 1, .reusable = false}, SHIFT(2749),
  [6285] = {.count = 1, .reusable = true}, SHIFT(2749),
  [6287] = {.count = 1, .reusable = true}, SHIFT(2748),
  [6289] = {.count = 1, .reusable = false}, SHIFT(2751),
  [6291] = {.count = 1, .reusable = true}, SHIFT(2751),
  [6293] = {.count = 1, .reusable = true}, SHIFT(2750),
  [6295] = {.count = 1, .reusable = true}, SHIFT(2752),
  [6297] = {.count = 1, .reusable = true}, SHIFT(2753),
  [6299] = {.count = 1, .reusable = true}, SHIFT(2754),
  [6301] = {.count = 1, .reusable = true}, SHIFT(2755),
  [6303] = {.count = 1, .reusable = false}, SHIFT(2756),
  [6305] = {.count = 1, .reusable = true}, SHIFT(2756),
  [6307] = {.count = 1, .reusable = false}, SHIFT(2757),
  [6309] = {.count = 1, .reusable = true}, SHIFT(2757),
  [6311] = {.count = 1, .reusable = true}, SHIFT(2758),
  [6313] = {.count = 1, .reusable = false}, SHIFT(2759),
  [6315] = {.count = 1, .reusable = true}, SHIFT(2759),
  [6317] = {.count = 1, .reusable = true}, SHIFT(2760),
  [6319] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6321] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6323] = {.count = 1, .reusable = true}, SHIFT(2763),
  [6325] = {.count = 1, .reusable = false}, SHIFT(2764),
  [6327] = {.count = 1, .reusable = true}, SHIFT(2765),
  [6329] = {.count = 1, .reusable = true}, SHIFT(2767),
  [6331] = {.count = 1, .reusable = true}, SHIFT(2768),
  [6333] = {.count = 1, .reusable = true}, SHIFT(2769),
  [6335] = {.count = 1, .reusable = true}, SHIFT(2770),
  [6337] = {.count = 1, .reusable = false}, SHIFT(2771),
  [6339] = {.count = 1, .reusable = true}, SHIFT(2771),
  [6341] = {.count = 1, .reusable = false}, SHIFT(2772),
  [6343] = {.count = 1, .reusable = true}, SHIFT(2772),
  [6345] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6347] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6349] = {.count = 1, .reusable = true}, SHIFT(2777),
  [6351] = {.count = 1, .reusable = true}, SHIFT(2778),
  [6353] = {.count = 1, .reusable = true}, SHIFT(2779),
  [6355] = {.count = 1, .reusable = false}, SHIFT(2780),
  [6357] = {.count = 1, .reusable = true}, SHIFT(2780),
  [6359] = {.count = 1, .reusable = false}, SHIFT(2781),
  [6361] = {.count = 1, .reusable = true}, SHIFT(2781),
  [6363] = {.count = 1, .reusable = true}, SHIFT(2782),
  [6365] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6367] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6369] = {.count = 1, .reusable = true}, SHIFT(2785),
  [6371] = {.count = 1, .reusable = false}, SHIFT(2786),
  [6373] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6375] = {.count = 1, .reusable = false}, SHIFT(2787),
  [6377] = {.count = 1, .reusable = true}, SHIFT(2787),
  [6379] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6381] = {.count = 1, .reusable = true}, SHIFT(2789),
  [6383] = {.count = 1, .reusable = true}, SHIFT(2790),
  [6385] = {.count = 1, .reusable = true}, SHIFT(2791),
  [6387] = {.count = 1, .reusable = true}, SHIFT(2792),
  [6389] = {.count = 1, .reusable = false}, SHIFT(2793),
  [6391] = {.count = 1, .reusable = true}, SHIFT(2794),
  [6393] = {.count = 1, .reusable = true}, SHIFT(2796),
  [6395] = {.count = 1, .reusable = true}, SHIFT(2797),
  [6397] = {.count = 1, .reusable = true}, SHIFT(2798),
  [6399] = {.count = 1, .reusable = true}, SHIFT(2799),
  [6401] = {.count = 1, .reusable = false}, SHIFT(2800),
  [6403] = {.count = 1, .reusable = true}, SHIFT(2800),
  [6405] = {.count = 1, .reusable = false}, SHIFT(2801),
  [6407] = {.count = 1, .reusable = true}, SHIFT(2801),
  [6409] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6411] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6413] = {.count = 1, .reusable = true}, SHIFT(2804),
  [6415] = {.count = 1, .reusable = true}, SHIFT(2805),
  [6417] = {.count = 1, .reusable = true}, SHIFT(2806),
  [6419] = {.count = 1, .reusable = false}, SHIFT(2807),
  [6421] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6423] = {.count = 1, .reusable = false}, SHIFT(2808),
  [6425] = {.count = 1, .reusable = true}, SHIFT(2808),
  [6427] = {.count = 1, .reusable = true}, SHIFT(2809),
  [6429] = {.count = 1, .reusable = true}, SHIFT(2810),
  [6431] = {.count = 1, .reusable = true}, SHIFT(2811),
  [6433] = {.count = 1, .reusable = true}, SHIFT(2812),
  [6435] = {.count = 1, .reusable = true}, SHIFT(2813),
  [6437] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6439] = {.count = 1, .reusable = true}, SHIFT(2815),
  [6441] = {.count = 1, .reusable = true}, SHIFT(2816),
  [6443] = {.count = 1, .reusable = false}, SHIFT(2817),
  [6445] = {.count = 1, .reusable = true}, SHIFT(2817),
  [6447] = {.count = 1, .reusable = false}, SHIFT(2818),
  [6449] = {.count = 1, .reusable = true}, SHIFT(2818),
  [6451] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6453] = {.count = 1, .reusable = true}, SHIFT(2820),
  [6455] = {.count = 1, .reusable = true}, SHIFT(2821),
  [6457] = {.count = 1, .reusable = true}, SHIFT(2822),
  [6459] = {.count = 1, .reusable = true}, SHIFT(2823),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_word,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
